// VehHsvdPage message handlers
// VehHsvdPage.cpp : implementation file
//

#include "stdafx.h"
#include "entreeV5.h"
#include "HsvdPage.h"

// CHsvdPage dialog

IMPLEMENT_DYNAMIC(CHsvdPage, CPropertyPage)
CHsvdPage::CHsvdPage() : CPropertyPage(CHsvdPage::IDD), m_pBioHsvdData(0), m_pVehHsvdData(0)
{
	m_cbRetainData	= false;
	m_nTotalCamNo	= 0;
	m_nCurCamNo		= 0;
	m_cVersion		= ' ',

	m_edTstRef		= _T("");
	m_edVscFactor	= _T("");
	m_edViewDesc	= _T("");
	m_edComment		= _T("");
}

CHsvdPage::~CHsvdPage()
{

}

void CHsvdPage::ClearAll()
{
	UpdateData ();
	m_listCamNo.ResetContent();
		
	m_cbRetainData	= false;
	m_nTotalCamNo	= 0;
	m_nCurCamNo		= 0;
	m_cVersion		= ' ',

	m_edTstRef		= _T("");
	m_edVscFactor	= _T("");
	m_edViewDesc	= _T("");
	m_edComment		= _T("");
	UpdateData (FALSE);
}	// ClearAll

void CHsvdPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
		
	DDX_Control(pDX, IDC_CAMNO_LIST, m_listCamNo);
	DDX_Check(pDX, IDC_RETAINDATA, m_cbRetainData);
	DDX_Control(pDX, IDC_NEXT_CAMNO, m_btnNextCamNo);
	DDX_Control(pDX, IDC_DELETE_CAMNO, m_btnDeleteCamNo);
	
	DDX_Control(pDX, IDC_VEHTEST_TSTREF, m_edTstRef);
	DDX_Control(pDX, IDC_CAMERANO, m_edCameraNo);
	DDX_Control(pDX, IDC_EDIT_VSCFACTOR, m_edVscFactor);
	DDX_Control(pDX, IDC_EDIT_DESC, m_edViewDesc);
	DDX_Control(pDX, IDC_EDIT_COMMENT, m_edComment);
}


BEGIN_MESSAGE_MAP(CHsvdPage, CPropertyPage)

	ON_BN_CLICKED(IDC_NEXT_CAMNO, OnNextRecord)
	ON_BN_CLICKED(IDC_DELETE_CAMNO, OnDeleteCamNo)

	ON_LBN_SELCHANGE(IDC_CAMNO_LIST, OnSelchangeCamNolist)
	ON_WM_HELPINFO()
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTW, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTA, 0, 0xFFFF, OnToolTipNotify )

END_MESSAGE_MAP()


// CHsvdPage message handlers
void CHsvdPage::OnNextRecord()
{
	if( ::GetKeyState( VK_RETURN ) < 0 ) { return; }

	// If at end, increase # of curves
	if( m_nCurCamNo == m_nTotalCamNo ) 
	{
		if( m_nCurCamNo != 0 )
		{
			LoadHsvdData();
		}

		m_nTotalCamNo++; 
		m_nCurCamNo++;
		InitializeNext();
	} 
	else if( m_nCurCamNo != 0 ) 
	{
		if( !LoadHsvdData() )
		{
			MessageBox( "Error: see CHsvdPage::OnNextcurveButton()" );
			return;
		}

		m_nCurCamNo++;
	}

	DisplayHsvdData();

	SetBusinessRules();

}	// OnNextRecord

void CHsvdPage::OnDeleteCamNo()
{
	if( ::GetKeyState( VK_RETURN ) < 0 ) { return; }

	if( m_nCurCamNo == 0 ) { return; }  // Can not delete zeroth curve.

	m_nTotalCamNo--;

	switch (m_cVersion)
	{
	case 'B':
		m_pBioHsvdData->m_camno.RemoveAt(m_nCurCamNo);
		m_pBioHsvdData->m_vscfactor.RemoveAt(m_nCurCamNo);
		m_pBioHsvdData->m_desc.RemoveAt(m_nCurCamNo);
		m_pBioHsvdData->m_comment.RemoveAt(m_nCurCamNo); 
	break;
	case 'C':
		m_pComHsvdData->m_camno.RemoveAt(m_nCurCamNo);
		m_pComHsvdData->m_vscfactor.RemoveAt(m_nCurCamNo);
		m_pComHsvdData->m_desc.RemoveAt(m_nCurCamNo);
		m_pComHsvdData->m_comment.RemoveAt(m_nCurCamNo); 
	break;
	case 'S':
		m_pSwgHsvdData->m_camno.RemoveAt(m_nCurCamNo);
		m_pSwgHsvdData->m_vscfactor.RemoveAt(m_nCurCamNo);
		m_pSwgHsvdData->m_desc.RemoveAt(m_nCurCamNo);
		m_pSwgHsvdData->m_comment.RemoveAt(m_nCurCamNo); 
	break;
	case 'V':
		m_pVehHsvdData->m_camno.RemoveAt(m_nCurCamNo);
		m_pVehHsvdData->m_vscfactor.RemoveAt(m_nCurCamNo);
		m_pVehHsvdData->m_desc.RemoveAt(m_nCurCamNo);
		m_pVehHsvdData->m_comment.RemoveAt(m_nCurCamNo); 
	break;
	default: return;
	}
	m_nCurCamNo--;	// Goto previous curve 

	// If m_nCurCamNo == 0 now, and there are remaining curves,
	// set curve 1 as active ( m_icurno = 1 )
	if(	( m_nCurCamNo == 0 ) && ( m_nTotalCamNo > 0 ) )
	{
		m_nCurCamNo = 1;
	}
		
	DisplayHsvdData();  // display previous set, if existing
}	// OnDeleteCamNo

BOOL CHsvdPage::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	
	EnableToolTips(TRUE);
	
	return TRUE;  

}	// OnInitDialog

void CHsvdPage::OnSelchangeCamNolist()
{
	int nCurve = m_listCamNo.GetCurSel();  // Zero based

	if( m_nCurCamNo != 0 ) 
	{
		// Load current info (not zeroth curve)
		// Data not valid, dont change curves.
		if( !LoadHsvdData() )
		{
			// Select current curve, zero based.
			m_listCamNo.SetCurSel( max( 0, m_nCurCamNo - 1 ) );  
			return;
		}
	}

	m_nCurCamNo = nCurve + 1;	// Goto current curve 

	DisplayHsvdData();	// Display next set, if existing

//	ValidatePage();			// ?
//	SetBusinessRules();		// ?
}	// OnSelchangeCamNolist

BOOL CHsvdPage::OnHelpInfo(HELPINFO* pHelpInfo)
{
//	WinHelp( HighSpeedVideo );??
	
	return TRUE;
}	// OnHelpInfo

BOOL CHsvdPage::OnToolTipNotify(UINT id, NMHDR * pNMHDR, LRESULT * pResult)
{
	TOOLTIPTEXTA* pTTTA = (TOOLTIPTEXTA*)pNMHDR;
	TOOLTIPTEXTW* pTTTW = (TOOLTIPTEXTW*)pNMHDR;
	CString strTipText = "";
	UINT nID = pNMHDR->idFrom;
	if (pNMHDR->code == TTN_NEEDTEXTA && (pTTTA->uFlags & TTF_IDISHWND) ||
		pNMHDR->code == TTN_NEEDTEXTW && (pTTTW->uFlags & TTF_IDISHWND))
	{
		// idFrom is actually the HWND of the tool
		nID = ::GetDlgCtrlID((HWND)nID);
	}

	if (nID != 0) // will be zero on a separator
	{
		strTipText.Format("Control ID = %d", nID);
		switch (nID)
		{
		case IDC_CAMNO_LIST:
			strTipText = "Camera number list";
			break;
		case IDC_RETAINDATA:
			strTipText = "Retain data for the record of next number";
			break;
		case IDC_NEXT_CAMNO:
			strTipText = "Move to the next camera"; // "% Integer (0->999)";
			break;
		case IDC_DELETE_CAMNO:
			strTipText = "Delete the current record";
			break;
		case IDC_VEHTEST_TSTREF:
			strTipText = "string (maximum 10 characters)";
			break;
		case IDC_EDIT_VSCFACTOR:
			strTipText = "Millisecond (real)";
			break;
		case IDC_EDIT_DESC:
			strTipText = "string (maximum 70 characters)";
			break;
		case IDC_EDIT_COMMENT:
			strTipText = "string (maximum 70 characters)";
			break;
		default:
			strTipText = "";
		}
	}

	if (pNMHDR->code == TTN_NEEDTEXTA)
		lstrcpyn(pTTTA->szText, strTipText, sizeof(pTTTA->szText));
	else
		::MultiByteToWideChar( CP_ACP , 0, strTipText, -1, pTTTW->szText, sizeof(pTTTW->szText) );
	*pResult = 0;

	return TRUE;    // message was handled
}	// OnToolTipNotify

BOOL CHsvdPage::OnSetActive() 
{
	switch (m_cVersion)
	{
	case 'B': m_nTotalCamNo = max( m_pBioHsvdData->m_camno.GetSize()-1 , 0 ); break;
	case 'C': m_nTotalCamNo = max( m_pComHsvdData->m_camno.GetSize()-1 , 0 ); break;
	case 'S': m_nTotalCamNo = max( m_pSwgHsvdData->m_camno.GetSize()-1 , 0 ); break;
	case 'V': m_nTotalCamNo = max( m_pVehHsvdData->m_camno.GetSize()-1 , 0 ); break;
	default: return CPropertyPage::OnSetActive(); ;
	}
	SetBusinessRules();
	DisplayHsvdData();
	ValidatePage();
	
	return CPropertyPage::OnSetActive();
}

BOOL CHsvdPage::OnKillActive() 
{
	if(!ValidateThisPage()) { return false; }
	return CPropertyPage::OnKillActive();
}

const bool CHsvdPage::ValidateThisPage()
{
	if(!ValidatePage()) { return false; }

	LoadHsvdData();
	int nOldCurIndx = m_nCurCamNo;
	for( int i=1; i<=m_nTotalCamNo; i++ )
	{
		m_nCurCamNo = i;
		DisplayHsvdData();
		if( !ValidatePage() )  { return false; }
	}
	m_nCurCamNo = nOldCurIndx;
	DisplayHsvdData();
	return true;
}	// ValidateThisPage

/// functions:
void CHsvdPage::UpdateListbox()
{
	if( m_listCamNo.GetCount() != m_nTotalCamNo )
	{
		m_listCamNo.ResetContent();
		char crvbuf [10];
		for( int loop = 1; loop <= m_nTotalCamNo; loop++ )
		{
			// If buffer is not there already.
			itoa( loop, crvbuf, 10 );
			if( m_listCamNo.FindString( -1, crvbuf ) == LB_ERR )  
			{
				m_listCamNo.AddString( crvbuf );
			}
		}
	}

	// select current curve, zero based.
	m_listCamNo.SetCurSel( max( 0, m_nCurCamNo - 1 ) );  
}	// UpdateListbox

void CHsvdPage::InitializeNext()
{
//	m_pHsvdData->m_tstref = "";
	CString temp = "";
	UpdateData();
	if( m_cbRetainData )
	{
		switch (m_cVersion)
		{					
		case 'B':
			temp = m_pBioHsvdData->m_camno[m_nCurCamNo -1];
			m_pBioHsvdData->m_camno.SetAtGrow(m_nCurCamNo, temp);
			temp = m_pBioHsvdData->m_camerano[m_nCurCamNo -1];
			m_pBioHsvdData->m_camerano.SetAtGrow(m_nCurCamNo, temp);
			temp = m_pBioHsvdData->m_vscfactor[m_nCurCamNo -1];
			m_pBioHsvdData->m_vscfactor.SetAtGrow(m_nCurCamNo, temp);
			temp = m_pBioHsvdData->m_desc[m_nCurCamNo -1];
			m_pBioHsvdData->m_desc.SetAtGrow(m_nCurCamNo, temp);
			temp = m_pBioHsvdData->m_comment[m_nCurCamNo -1];
			m_pBioHsvdData->m_comment.SetAtGrow(m_nCurCamNo, temp);
			break;
		case 'C':
			temp = m_pComHsvdData->m_camno[m_nCurCamNo -1];
			m_pComHsvdData->m_camno.SetAtGrow(m_nCurCamNo, temp);
			temp = m_pComHsvdData->m_camerano[m_nCurCamNo -1];
			m_pComHsvdData->m_camerano.SetAtGrow(m_nCurCamNo, temp);
			temp = m_pComHsvdData->m_vscfactor[m_nCurCamNo -1];
			m_pComHsvdData->m_vscfactor.SetAtGrow(m_nCurCamNo, temp);
			temp = m_pComHsvdData->m_desc[m_nCurCamNo -1];
			m_pComHsvdData->m_desc.SetAtGrow(m_nCurCamNo, temp);
			temp = m_pComHsvdData->m_comment[m_nCurCamNo -1];
			m_pComHsvdData->m_comment.SetAtGrow(m_nCurCamNo, temp);
			break;
		case 'S':
			temp = m_pSwgHsvdData->m_camno[m_nCurCamNo -1];
			m_pSwgHsvdData->m_camno.SetAtGrow(m_nCurCamNo, temp);
			temp = m_pSwgHsvdData->m_camerano[m_nCurCamNo -1];
			m_pSwgHsvdData->m_camerano.SetAtGrow(m_nCurCamNo, temp);
			temp = m_pSwgHsvdData->m_vscfactor[m_nCurCamNo -1];
			m_pSwgHsvdData->m_vscfactor.SetAtGrow(m_nCurCamNo, temp);
			temp = m_pSwgHsvdData->m_desc[m_nCurCamNo -1];
			m_pSwgHsvdData->m_desc.SetAtGrow(m_nCurCamNo, temp);
			temp = m_pSwgHsvdData->m_comment[m_nCurCamNo -1];
			m_pSwgHsvdData->m_comment.SetAtGrow(m_nCurCamNo, temp);
			break;
		case 'V':
			temp = m_pVehHsvdData->m_camno[m_nCurCamNo -1];
			m_pVehHsvdData->m_camno.SetAtGrow(m_nCurCamNo, temp);
			temp = m_pVehHsvdData->m_camerano[m_nCurCamNo -1];
			m_pVehHsvdData->m_camerano.SetAtGrow(m_nCurCamNo, temp);
			temp = m_pVehHsvdData->m_vscfactor[m_nCurCamNo -1];
			m_pVehHsvdData->m_vscfactor.SetAtGrow(m_nCurCamNo, temp);
			temp = m_pVehHsvdData->m_desc[m_nCurCamNo -1];
			m_pVehHsvdData->m_desc.SetAtGrow(m_nCurCamNo, temp);
			temp = m_pVehHsvdData->m_comment[m_nCurCamNo -1];
			m_pVehHsvdData->m_comment.SetAtGrow(m_nCurCamNo, temp);
			break;
		default: return;
		}
	}
	else
	{
		switch (m_cVersion)
		{
		case 'B': 
			m_pBioHsvdData->m_camno.SetAtGrow(m_nCurCamNo, "" );
			m_pBioHsvdData->m_camerano.SetAtGrow(m_nCurCamNo,"" );
			m_pBioHsvdData->m_vscfactor.SetAtGrow(m_nCurCamNo,"" );
			m_pBioHsvdData->m_desc.SetAtGrow(m_nCurCamNo,"" );
			m_pBioHsvdData->m_comment.SetAtGrow(m_nCurCamNo,"" );
			break;
		case 'C': 
			m_pComHsvdData->m_camno.SetAtGrow(m_nCurCamNo, "" );
			m_pComHsvdData->m_camerano.SetAtGrow(m_nCurCamNo,"" );
			m_pComHsvdData->m_vscfactor.SetAtGrow(m_nCurCamNo,"" );
			m_pComHsvdData->m_desc.SetAtGrow(m_nCurCamNo,"" );
			m_pComHsvdData->m_comment.SetAtGrow(m_nCurCamNo,"" );
			break;
		case 'S': 
			m_pSwgHsvdData->m_camno.SetAtGrow(m_nCurCamNo, "" );
			m_pSwgHsvdData->m_camerano.SetAtGrow(m_nCurCamNo,"" );
			m_pSwgHsvdData->m_vscfactor.SetAtGrow(m_nCurCamNo,"" );
			m_pSwgHsvdData->m_desc.SetAtGrow(m_nCurCamNo,"" );
			m_pSwgHsvdData->m_comment.SetAtGrow(m_nCurCamNo,"" );
			break;
		case 'V':
			m_pVehHsvdData->m_camno.SetAtGrow(m_nCurCamNo, "" );
			m_pVehHsvdData->m_camerano.SetAtGrow(m_nCurCamNo,"" );
			m_pVehHsvdData->m_vscfactor.SetAtGrow(m_nCurCamNo,"" );
			m_pVehHsvdData->m_desc.SetAtGrow(m_nCurCamNo,"" );
			m_pVehHsvdData->m_comment.SetAtGrow(m_nCurCamNo,"" );
			break;
		default: return;
		}
	}
	UpdateData(false);
}	// InitializeNext

void CHsvdPage::DisplayHsvdData()
{
	if( m_hWnd == NULL ) { return; }

	UpdateListbox();
	
	UpdateData();

	switch (m_cVersion)
	{
	case 'B': 
		m_edTstRef		= m_pBioHsvdData->m_tstref;
		m_edCameraNo	= m_pBioHsvdData->m_camerano[m_nCurCamNo];
		m_edVscFactor	= m_pBioHsvdData->m_vscfactor[m_nCurCamNo];
		m_edViewDesc	= m_pBioHsvdData->m_desc[m_nCurCamNo];
		m_edComment		= m_pBioHsvdData->m_comment[m_nCurCamNo];
	break;
	case 'C': 
		m_edTstRef		= m_pComHsvdData->m_tstref;
		m_edCameraNo	= m_pComHsvdData->m_camerano[m_nCurCamNo];
		m_edVscFactor	= m_pComHsvdData->m_vscfactor[m_nCurCamNo];
		m_edViewDesc	= m_pComHsvdData->m_desc[m_nCurCamNo];
		m_edComment		= m_pComHsvdData->m_comment[m_nCurCamNo];
	break;
	case 'S': 
		m_edTstRef		= m_pSwgHsvdData->m_tstref;
		m_edCameraNo	= m_pSwgHsvdData->m_camerano[m_nCurCamNo];
		m_edVscFactor	= m_pSwgHsvdData->m_vscfactor[m_nCurCamNo];
		m_edViewDesc	= m_pSwgHsvdData->m_desc[m_nCurCamNo];
		m_edComment		= m_pSwgHsvdData->m_comment[m_nCurCamNo];
	break;
	case 'V': 
		m_edTstRef		= m_pVehHsvdData->m_tstref;
		m_edCameraNo	= m_pVehHsvdData->m_camerano[m_nCurCamNo];
		m_edVscFactor	= m_pVehHsvdData->m_vscfactor[m_nCurCamNo];
		m_edViewDesc	= m_pVehHsvdData->m_desc[m_nCurCamNo];
		m_edComment		= m_pVehHsvdData->m_comment[m_nCurCamNo];
	break;
	default: return;
	}
	// if ncodes.mdb is available for
//	CCodeValidation( m_edTstRef, "","" );
//	CCodeValidation( m_edCameraNo, "","" );
//	CCodeValidation( m_edVscFactor, "","" );
//	CCodeValidation( m_edViewDesc, "","" );
//	CCodeValidation( m_edComment, "","" );

	UpdateData( FALSE );

}	// DisplayHsvdData

BOOL CHsvdPage::LoadHsvdData()
{
	if( m_hWnd == NULL ) { return TRUE; }	//only return FALSE if data invalid

	char szTemp[4];
	itoa(m_nCurCamNo, szTemp, 10);
	UpdateData();
	switch (m_cVersion)
	{
	case 'B':
		m_pBioHsvdData->m_camno[m_nCurCamNo] = szTemp;
		m_pBioHsvdData->m_tstref = m_edTstRef.GetTextAsString();
		m_pBioHsvdData->m_camerano[m_nCurCamNo] = m_edCameraNo.GetTextAsString();
		m_pBioHsvdData->m_vscfactor[m_nCurCamNo] = m_edVscFactor.GetTextAsString();
		m_pBioHsvdData->m_desc[m_nCurCamNo] = m_edViewDesc.GetTextAsString();
		m_pBioHsvdData->m_comment[m_nCurCamNo] = m_edComment.GetTextAsString();
	break;
	case 'C':
		m_pComHsvdData->m_camno[m_nCurCamNo] = szTemp;
		m_pComHsvdData->m_tstref = m_edTstRef.GetTextAsString();
		m_pComHsvdData->m_camerano[m_nCurCamNo] = m_edCameraNo.GetTextAsString();
		m_pComHsvdData->m_vscfactor[m_nCurCamNo] = m_edVscFactor.GetTextAsString();
		m_pComHsvdData->m_desc[m_nCurCamNo] = m_edViewDesc.GetTextAsString();
		m_pComHsvdData->m_comment[m_nCurCamNo] = m_edComment.GetTextAsString();
	break;
	case 'S':
		m_pSwgHsvdData->m_camno[m_nCurCamNo] = szTemp;
		m_pSwgHsvdData->m_tstref = m_edTstRef.GetTextAsString();
		m_pSwgHsvdData->m_camerano[m_nCurCamNo] = m_edCameraNo.GetTextAsString();
		m_pSwgHsvdData->m_vscfactor[m_nCurCamNo] = m_edVscFactor.GetTextAsString();
		m_pSwgHsvdData->m_desc[m_nCurCamNo] = m_edViewDesc.GetTextAsString();
		m_pSwgHsvdData->m_comment[m_nCurCamNo] = m_edComment.GetTextAsString();
	break;
	case 'V':
		m_pVehHsvdData->m_camno[m_nCurCamNo] = szTemp;
		m_pVehHsvdData->m_tstref = m_edTstRef.GetTextAsString();
		m_pVehHsvdData->m_camerano[m_nCurCamNo] = m_edCameraNo.GetTextAsString();
		m_pVehHsvdData->m_vscfactor[m_nCurCamNo] = m_edVscFactor.GetTextAsString();
		m_pVehHsvdData->m_desc[m_nCurCamNo] = m_edViewDesc.GetTextAsString();
		m_pVehHsvdData->m_comment[m_nCurCamNo] = m_edComment.GetTextAsString();
	break;
	default: return false;
	}

	UpdateData(false);

	return TRUE;
}	// LoadHsvdData

bool CHsvdPage::InsertHsvdData()
{
	if( m_hWnd == NULL ) { return TRUE; }  // Return FALSE if data invalid
	
	UpdateData();
	char camno[16]; itoa(m_nCurCamNo, camno, 10);

	switch (m_cVersion)
	{
	case 'B':
		m_pBioHsvdData->m_tstref = m_edTstRef.GetTextAsString();	
		m_pBioHsvdData->m_camno.InsertAt( m_nCurCamNo, camno );
		m_pBioHsvdData->m_camerano.InsertAt( m_nCurCamNo, m_edCameraNo.GetTextAsString() );
		m_pBioHsvdData->m_vscfactor.InsertAt( m_nCurCamNo, m_edVscFactor.GetTextAsString() );
		m_pBioHsvdData->m_desc.InsertAt( m_nCurCamNo, m_edViewDesc.GetTextAsString() );
		m_pBioHsvdData->m_comment.InsertAt( m_nCurCamNo, m_edComment.GetTextAsString() );
	break;
	case 'C':
		m_pComHsvdData->m_tstref = m_edTstRef.GetTextAsString();	
		m_pComHsvdData->m_camno.InsertAt( m_nCurCamNo, camno );
		m_pComHsvdData->m_camerano.InsertAt( m_nCurCamNo, m_edCameraNo.GetTextAsString() );
		m_pComHsvdData->m_vscfactor.InsertAt( m_nCurCamNo, m_edVscFactor.GetTextAsString() );
		m_pComHsvdData->m_desc.InsertAt( m_nCurCamNo, m_edViewDesc.GetTextAsString() );
		m_pComHsvdData->m_comment.InsertAt( m_nCurCamNo, m_edComment.GetTextAsString() );
	break;
	case 'S':
		m_pSwgHsvdData->m_tstref = m_edTstRef.GetTextAsString();	
		m_pSwgHsvdData->m_camno.InsertAt( m_nCurCamNo, camno );
		m_pSwgHsvdData->m_camerano.InsertAt( m_nCurCamNo, m_edCameraNo.GetTextAsString() );
		m_pSwgHsvdData->m_vscfactor.InsertAt( m_nCurCamNo, m_edVscFactor.GetTextAsString() );
		m_pSwgHsvdData->m_desc.InsertAt( m_nCurCamNo, m_edViewDesc.GetTextAsString() );
		m_pSwgHsvdData->m_comment.InsertAt( m_nCurCamNo, m_edComment.GetTextAsString() );
	break;
	case 'V':
		m_pVehHsvdData->m_tstref = m_edTstRef.GetTextAsString();	
		m_pVehHsvdData->m_camno.InsertAt( m_nCurCamNo, camno );
		m_pVehHsvdData->m_camerano.InsertAt( m_nCurCamNo, m_edCameraNo.GetTextAsString() );
		m_pVehHsvdData->m_vscfactor.InsertAt( m_nCurCamNo, m_edVscFactor.GetTextAsString() );
		m_pVehHsvdData->m_desc.InsertAt( m_nCurCamNo, m_edViewDesc.GetTextAsString() );
		m_pVehHsvdData->m_comment.InsertAt( m_nCurCamNo, m_edComment.GetTextAsString() );
	break;
	default: return false;
	}

	UpdateData( false );
	return true;
}	// InsertHsvdData

const bool CHsvdPage::ValidatePage( void )
{
	const int nTotal = 4;
	bool bRetArray[nTotal];

	bRetArray[0] = m_edCameraNo.GetValidate();
	bRetArray[1] = m_edVscFactor.GetValidate();
	bRetArray[2] = m_edViewDesc.GetValidate();
	bRetArray[3] = m_edComment.GetValidate();

	for( int i = 0; i < nTotal; i++ )
	{
		if( !bRetArray[i] ) { return false; }
	}

	return true;
}	// ValidatePage

void CHsvdPage::SetBusinessRules( void )
{
	m_edCameraNo.SetDouble( 1, 999, true );
	m_edVscFactor.SetDouble( 0, 10000, true );
	m_edViewDesc.SetString( 0, 70, true );
	m_edComment.SetString( 0, 70, true );
}	// SetBusinessRules
