#pragma once
#include "EditEx.h"
#include "BioData.h"
#include "CompData.h"
#include "SwgData.h"
#include "VehData.h"
// CHsvdPage dialog

class CHsvdPage : public CPropertyPage
{
	DECLARE_DYNAMIC(CHsvdPage)

public:
	CHsvdPage();
	virtual ~CHsvdPage();

	void ClearAll();
	
	void UpdateListbox();
	void InitializeNext();
	
	void DisplayHsvdData();
	BOOL LoadHsvdData();
	bool InsertHsvdData();

	const bool ValidateThisPage();
	const bool ValidatePage();
	void SetBusinessRules();

	int			m_nTotalCamNo;
	int			m_nCurCamNo;
	CBioData*	m_pBioHsvdData;
	CCompData*	m_pComHsvdData;
	CSWGData*	m_pSwgHsvdData;
	CVehData*	m_pVehHsvdData;

	char		m_cVersion; // 'B', 'C', 'S', 'V'

// Dialog Data
	enum { IDD = IDD_HSVD_PAGE };
	
	CListBox	m_listCamNo;
	BOOL		m_cbRetainData;
	CButton		m_btnNextCamNo;
	CButton		m_btnDeleteCamNo;
	
	CNEdit		m_edTstRef;
	CNEdit		m_edCameraNo;
	CNEdit		m_edVscFactor;
	CNEdit		m_edViewDesc;
	CNEdit		m_edComment;

	public: // virtual overwrite
	virtual BOOL OnSetActive();
	virtual BOOL OnKillActive();

	
protected:
	// virtual overwrite
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	afx_msg void OnNextRecord();
	afx_msg void OnDeleteCamNo();

	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeCamNolist();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	afx_msg BOOL OnToolTipNotify(UINT, NMHDR *, LRESULT *);

	DECLARE_MESSAGE_MAP()
};
