// VehIntrPage.cpp : implementation file
//

#include "stdafx.h"
#include "entreeV5.h"
#include "VehIntrPage.h"
#include "search.h"
#include "CodeValidation.h"

extern CString search_code;

IMPLEMENT_DYNAMIC(CVehIntrPage, CPropertyPage)
CVehIntrPage::CVehIntrPage() : CPropertyPage(CVehIntrPage::IDD)
{
	m_cbRetainData	= false;
	m_nTotalNo		= 0;
	m_nCurNo		= 0;

//	m_edTstNo		= _T("");
	m_edVehNo		= _T("");
	m_edTstRef		= _T("");
//	m_edIntrPt		= _T("");
	m_edIntrPtNo	= _T("");
	m_edIntrPtLoc		= _T("");
	m_nrt_edBix		= _T("");
	m_nrt_edBiy		= _T("");
	m_nrt_edBiz		= _T("");
	m_nrt_edAix		= _T("");
	m_nrt_edAiy		= _T("");
	m_nrt_edAiz		= _T("");
}

CVehIntrPage::~CVehIntrPage()
{

}

void CVehIntrPage::ClearAll()
{
	UpdateData ();
	m_ListNo.ResetContent();
		
	m_cbRetainData	= false;
	m_nTotalNo	= 0;
	m_nCurNo		= 0;

//	m_edTstNo		= _T("");
	m_edVehNo		= _T("");
	m_edTstRef		= _T("");
//	m_edIntrPt		= _T("");
	m_edIntrPtNo	= _T("");
	m_edIntrPtLoc		= _T("");
	m_nrt_edBix		= _T("");
	m_nrt_edBiy		= _T("");
	m_nrt_edBiz		= _T("");
	m_nrt_edAix		= _T("");
	m_nrt_edAiy		= _T("");
	m_nrt_edAiz		= _T("");

	UpdateData (FALSE);

}	// ClearAll

void CVehIntrPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
			
	DDX_Control(pDX, IDC_NTRNO_LIST, m_ListNo);
	DDX_Check(pDX, IDC_RETAIN_NTR, m_cbRetainData);
	DDX_Control(pDX, IDC_NEXT_NTRNO, m_btnNextNo);
	DDX_Control(pDX, IDC_DELETE_NTRNO, m_btnDeleteNo);

//	DDX_Control(pDX, IDC_VEHTEST_VERNO, m_edTstNo);
	DDX_Control(pDX, IDC_NTR_VEHNO, m_edVehNo);
	DDX_Control(pDX, IDC_VEHTEST_TSTREF, m_edTstRef);
//	DDX_Control(pDX, IDC_VEH_NRT_POINT, m_edIntrPt);
	DDX_Control(pDX, IDC_VEH_NRT_POINTNO, m_edIntrPtNo);
	DDX_Control(pDX, IDC_VEH_NRT_POINT_LOC, m_edIntrPtLoc);
	DDX_Control(pDX, IDC_VEH_NRT_BIX, m_nrt_edBix);
	DDX_Control(pDX, IDC_VEH_NRT_BIY, m_nrt_edBiy);
	DDX_Control(pDX, IDC_VEH_NRT_BIZ, m_nrt_edBiz);
	DDX_Control(pDX, IDC_VEH_NRT_AIX, m_nrt_edAix);
	DDX_Control(pDX, IDC_VEH_NRT_AIY, m_nrt_edAiy);
	DDX_Control(pDX, IDC_VEH_NRT_AIZ, m_nrt_edAiz);

}	// DoDataExchange


BEGIN_MESSAGE_MAP(CVehIntrPage, CPropertyPage)

	ON_BN_CLICKED(IDC_NEXT_NTRNO, OnNextRecord)
	ON_BN_CLICKED(IDC_DELETE_NTRNO, OnDeleteNtrNo)
	ON_LBN_SELCHANGE(IDC_NTRNO_LIST, OnSelchangeNtrNolist)

	ON_BN_CLICKED(IDC_IP_SERACH, OnIpSearch)

	ON_WM_HELPINFO()
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTW, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTA, 0, 0xFFFF, OnToolTipNotify )

END_MESSAGE_MAP()


// CVehIntrPage message handlers

void CVehIntrPage::OnIpSearch()
{
//	AfxMessageBox("Reference table is not available yet.");

	if( ::GetKeyState( VK_RETURN ) < 0 ) { return; }

	UpdateData( TRUE );  //First save data

//	CSearch search( NULL, "VEHIP", "INTRUSIONDB" );
	CString sqlStmt = "SELECT VEHIP, VEHIPD, VEHIP_COMMENT ";
	sqlStmt += "FROM NHTSADB_VEHIP WHERE REFERENCE LIKE '%INTRUSIONDB%'";
	CSearch search( NULL, "VEHIP", "INTRUSIONDB", sqlStmt );
	if( search.DoModal() == IDOK )
	{
		m_sVehIp = search_code;
		m_sVehIp.Trim();
		DecodeVehIp(m_edIntrPtNo, m_edIntrPtLoc);
		m_edIntrPtNo.SetValidateColor();
		m_edIntrPtLoc.SetValidateColor();
	}
	UpdateData(FALSE);

}	// OnIpSearch

void CVehIntrPage::DecodeVehIp(CNEdit& edNo, CNEdit& edLoc)
{
	CString sNo(""), sLoc("");
	bool bIsDigit = true;
	for (int i=0; i<m_sVehIp.GetLength(); i++)
	{
		if (bIsDigit&&isdigit(m_sVehIp[i])) { sNo += m_sVehIp[i]; }
		else { bIsDigit = false; sLoc += m_sVehIp[i]; }
	}

	edNo = sNo;
	edLoc = sLoc;
}	// DecodeVehIp

void CVehIntrPage::OnNextRecord()
{
	if( ::GetKeyState( VK_RETURN ) < 0 ) { return; }

	// If at end, increase # of curves
	if( m_nCurNo == m_nTotalNo ) 
	{
		if( m_nCurNo != 0 )
		{
			LoadIntrusionData();
		}

		m_nTotalNo++; 
		m_nCurNo++;
		InitializeNext();
	} 
	else if( m_nCurNo != 0 ) 
	{
		if( !LoadIntrusionData() )
		{
			MessageBox( "Error: see CVehIntrPage::OnNextcurveButton()" );
			return;
		}

		m_nCurNo++;
	}

	DisplayIntrusionData();

	SetBusinessRules();

}	// OnNextRecord

void CVehIntrPage::OnDeleteNtrNo()
{
	if( ::GetKeyState( VK_RETURN ) < 0 ) { return; }

	if( m_nCurNo == 0 ) { return; }  // Can not delete zeroth curve.

	m_nTotalNo--;
	CIntrusionData* pIntr = &m_pVehData->m_IntrusionData;
	pIntr->m_nrt_no.RemoveAt(m_nCurNo);
	pIntr->m_nrt_vehno.RemoveAt(m_nCurNo);
//	pIntr->m_nrt_point.RemoveAt(m_nCurNo);
	pIntr->m_nrt_pointno.RemoveAt(m_nCurNo);
	pIntr->m_nrt_pointloc.RemoveAt(m_nCurNo);
	pIntr->m_nrt_bix.RemoveAt(m_nCurNo);
	pIntr->m_nrt_biy.RemoveAt(m_nCurNo);
	pIntr->m_nrt_biz.RemoveAt(m_nCurNo);
	pIntr->m_nrt_aix.RemoveAt(m_nCurNo);
	pIntr->m_nrt_aiy.RemoveAt(m_nCurNo);
	pIntr->m_nrt_aiz.RemoveAt(m_nCurNo);

	m_nCurNo--;	// Goto previous curve 

	// If m_nCurNo == 0 now, and there are remaining curves,
	// set curve 1 as active ( m_icurno = 1 )
	if(	( m_nCurNo == 0 ) && ( m_nTotalNo > 0 ) )
	{
		m_nCurNo = 1;
	}
		
	DisplayIntrusionData();  // display previous set, if existing
}	// OnDeleteCamNo

BOOL CVehIntrPage::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	
	EnableToolTips(TRUE);
	
	return TRUE;  

}	// OnInitDialog

void CVehIntrPage::OnSelchangeNtrNolist()
{
	int nCurve = m_ListNo.GetCurSel();  // Zero based

	if( m_nCurNo != 0 ) 
	{
		// Load current info (not zeroth curve)
		// Data not valid, dont change curves.
		if( !LoadIntrusionData() )
		{
			// Select current curve, zero based.
			m_ListNo.SetCurSel( max( 0, m_nCurNo - 1 ) );  
			return;
		}
	}

	m_nCurNo = nCurve + 1;	// Goto current curve 

	DisplayIntrusionData();	// Display next set, if existing

//	ValidatePage();			// ?
//	SetBusinessRules();		// ?
}	// OnSelchangeCamNolist

BOOL CVehIntrPage::OnHelpInfo(HELPINFO* pHelpInfo)
{
//	WinHelp( Intrusion );??
	
	return TRUE;
}	// OnHelpInfo

BOOL CVehIntrPage::OnToolTipNotify(UINT id, NMHDR * pNMHDR, LRESULT * pResult)
{
	TOOLTIPTEXTA* pTTTA = (TOOLTIPTEXTA*)pNMHDR;
	TOOLTIPTEXTW* pTTTW = (TOOLTIPTEXTW*)pNMHDR;
	CString strTipText = "";
	UINT nID = pNMHDR->idFrom;
	if (pNMHDR->code == TTN_NEEDTEXTA && (pTTTA->uFlags & TTF_IDISHWND) ||
		pNMHDR->code == TTN_NEEDTEXTW && (pTTTW->uFlags & TTF_IDISHWND))
	{
		// idFrom is actually the HWND of the tool
		nID = ::GetDlgCtrlID((HWND)nID);
	}

	if (nID != 0) // will be zero on a separator
	{
		strTipText.Format("Control ID = %d", nID);
		switch (nID)
		{
		case IDC_NTRNO_LIST:
			strTipText = "Intrusion number list";
			break;
		case IDC_RETAINDATA:
			strTipText = "Retain data for the record of next number";
			break;
		case IDC_NEXT_NTRNO:
			strTipText = "Move to the next intrusion"; // "% Integer (0->999)";
			break;
		case IDC_DELETE_NTRNO:
			strTipText = "Delete the current record";
			break;
		case IDC_VEHTEST_TSTREF:
			strTipText = "string (maximum 10 characters)";
			break;
		case IDC_VEHTEST_VERNO:
			strTipText = "string (5 character with 'V' at the beginning)";
			break;
		case IDC_NTR_VEHNO:
			strTipText = "0, 1 or 2";
			break;
		case IDC_VEH_NRT_POINTNO:
			strTipText = "determined by intrusion point";
			break;
		case IDC_VEH_NRT_POINT_LOC:
			strTipText = "determined by intrusion point";
			break;
		case IDC_VEH_NRT_BIX:
			strTipText = "integer";
			break;
		case IDC_VEH_NRT_BIY:
			strTipText = "integer";
			break;
		case IDC_VEH_NRT_BIZ:
			strTipText = "integer";
			break;
		case IDC_VEH_NRT_AIX:
			strTipText = "integer";
			break;
		case IDC_VEH_NRT_AIY:
			strTipText = "integer";
			break;
		case IDC_VEH_NRT_AIZ:
			strTipText = "integer";
			break;
		default:
			strTipText = "";
		}
	}

	if (pNMHDR->code == TTN_NEEDTEXTA)
		lstrcpyn(pTTTA->szText, strTipText, sizeof(pTTTA->szText));
	else
		::MultiByteToWideChar( CP_ACP , 0, strTipText, -1, pTTTW->szText, sizeof(pTTTW->szText) );
	*pResult = 0;

	return TRUE;    // message was handled
}	// OnToolTipNotify

BOOL CVehIntrPage::OnSetActive() 
{
	m_pVehData->m_IntrusionData.m_tstref = m_pVehData->m_tstref;
	m_nTotalNo = max( m_pVehData->m_IntrusionData.m_nrt_no.GetSize()-1, 0 );

	SetBusinessRules();
	DisplayIntrusionData();
	ValidatePage();
	
	return CPropertyPage::OnSetActive();
}

BOOL CVehIntrPage::OnKillActive() 
{
	if (!ValidateThisPage()) { return false; }
	return CPropertyPage::OnKillActive();
}

const bool CVehIntrPage::ValidateThisPage()
{
	if(!ValidatePage()) { return false; }

	LoadIntrusionData();
	int nOldCurIndx = m_nCurNo;
	for( int i=1; i<=m_nTotalNo; i++ )
	{
		m_nCurNo = i;
		DisplayIntrusionData();
		if( !ValidatePage() )  { return false; }
	}
	m_nCurNo = nOldCurIndx;
	DisplayIntrusionData();
	return true;
}	// ValidateThisPage

/// functions:
void CVehIntrPage::UpdateListbox()
{
	if( m_ListNo.GetCount() != m_nTotalNo )
	{
		m_ListNo.ResetContent();
		char crvbuf [10];
		for( int loop = 1; loop <= m_nTotalNo; loop++ )
		{
			// If buffer is not there already.
			itoa( loop, crvbuf, 10 );
			if( m_ListNo.FindString( -1, crvbuf ) == LB_ERR )  
			{
				m_ListNo.AddString( crvbuf );
			}
		}
	}

	// select current curve, zero based.
	m_ListNo.SetCurSel( max( 0, m_nCurNo - 1 ) );  
}	// UpdateListbox

void CVehIntrPage::InitializeNext()
{
	CIntrusionData* pIntr = &m_pVehData->m_IntrusionData;
	int n = pIntr->m_nrt_no.GetSize();
	//	pIntr->m_tstref = "";
	UpdateData();
	if( m_cbRetainData )
	{
		CString temp = pIntr->m_nrt_no[m_nCurNo -1];
		pIntr->m_nrt_no.SetAtGrow(m_nCurNo, temp);
		temp = pIntr->m_nrt_vehno[m_nCurNo -1];
		pIntr->m_nrt_vehno.SetAtGrow(m_nCurNo, temp);
//		temp = pIntr->m_nrt_point[m_nCurNo -1];
//		pIntr->m_nrt_point.SetAtGrow(m_nCurNo, temp);
		temp = pIntr->m_nrt_pointno[m_nCurNo -1];
		pIntr->m_nrt_pointno.SetAtGrow(m_nCurNo, temp);
		temp = pIntr->m_nrt_pointloc[m_nCurNo -1];
		pIntr->m_nrt_pointloc.SetAtGrow(m_nCurNo, temp);
		temp = pIntr->m_nrt_bix[m_nCurNo -1];
		pIntr->m_nrt_bix.SetAtGrow(m_nCurNo, temp);
		temp = pIntr->m_nrt_biy[m_nCurNo -1];
		pIntr->m_nrt_biy.SetAtGrow(m_nCurNo, temp);
		temp = pIntr->m_nrt_biz[m_nCurNo -1];
		pIntr->m_nrt_biz.SetAtGrow(m_nCurNo, temp);
		temp = pIntr->m_nrt_aix[m_nCurNo -1];
		pIntr->m_nrt_aix.SetAtGrow(m_nCurNo, temp);
		temp = pIntr->m_nrt_aiy[m_nCurNo -1];
		pIntr->m_nrt_aiy.SetAtGrow(m_nCurNo, temp);
		temp = pIntr->m_nrt_aiz[m_nCurNo -1];
		pIntr->m_nrt_aiz.SetAtGrow(m_nCurNo, temp);
	}
	else
	{
		pIntr->m_nrt_no.SetAtGrow(m_nCurNo, "");
		pIntr->m_nrt_vehno.SetAtGrow(m_nCurNo, "1");
//		pIntr->m_nrt_point.SetAtGrow(m_nCurNo, "");
		pIntr->m_nrt_pointno.SetAtGrow(m_nCurNo, "");
		pIntr->m_nrt_pointloc.SetAtGrow(m_nCurNo, "");
		pIntr->m_nrt_bix.SetAtGrow(m_nCurNo, "");
		pIntr->m_nrt_biy.SetAtGrow(m_nCurNo, "");
		pIntr->m_nrt_biz.SetAtGrow(m_nCurNo, "");
		pIntr->m_nrt_aix.SetAtGrow(m_nCurNo, "");
		pIntr->m_nrt_aiy.SetAtGrow(m_nCurNo, "");
		pIntr->m_nrt_aiz.SetAtGrow(m_nCurNo, "");
	}
	UpdateData(false);
}	// InitializeNext

void CVehIntrPage::DisplayIntrusionData()
{
	if( m_hWnd == NULL ) { return; }

	UpdateListbox();
	
	UpdateData();
	CIntrusionData* pIntr = &m_pVehData->m_IntrusionData;

//	m_edTstNo		= pIntr->m_verno;
	m_edVehNo		= pIntr->m_nrt_vehno[m_nCurNo];
	m_edTstRef		= pIntr->m_tstref;
//	m_edIntrPt		= pIntr->m_nrt_point[m_nCurNo];
	m_edIntrPtNo	= pIntr->m_nrt_pointno[m_nCurNo];
	m_edIntrPtLoc	= pIntr->m_nrt_pointloc[m_nCurNo];
	m_nrt_edBix		= pIntr->m_nrt_bix[m_nCurNo];
	m_nrt_edBiy		= pIntr->m_nrt_biy[m_nCurNo];
	m_nrt_edBiz		= pIntr->m_nrt_biz[m_nCurNo];
	m_nrt_edAix		= pIntr->m_nrt_aix[m_nCurNo];
	m_nrt_edAiy		= pIntr->m_nrt_aiy[m_nCurNo];
	m_nrt_edAiz		= pIntr->m_nrt_aiz[m_nCurNo];

	// if ncodes.mdb is available for CNEdit
	CString sPtNo = m_edIntrPtNo.GetTextAsString().Trim();
	CString sPtLoc = m_edIntrPtLoc.GetTextAsString().Trim();
	CString sIP = sPtNo + sPtLoc;
	bool bPass;

	m_edIntrPtNo.SetWindowText(sIP);
	CCodeValidation( m_edIntrPtNo, "VEHIP", "INTRUSIONDB", bPass );
	m_edIntrPtNo.SetWindowText(sPtNo);
	m_edIntrPtNo.SetValidate(bPass);

	m_edIntrPtLoc.SetWindowText(sIP);
	CCodeValidation( m_edIntrPtLoc, "VEHIP", "INTRUSIONDB", bPass );
	m_edIntrPtLoc.SetWindowText(sPtLoc);
	m_edIntrPtLoc.SetValidate(bPass);

	UpdateData( FALSE );

}	// DisplayHsvdData

BOOL CVehIntrPage::LoadIntrusionData()
{
	if( m_hWnd == NULL ) { return TRUE; }	//only return FALSE if data invalid

	char szTemp[4];
	itoa(m_nCurNo, szTemp, 10);

	UpdateData();
	CIntrusionData* pIntr			= &m_pVehData->m_IntrusionData;
	int n = pIntr->m_nrt_no.GetSize();
	pIntr->m_nrt_no[m_nCurNo]		= szTemp;
	pIntr->m_nrt_vehno[m_nCurNo]	= m_edVehNo.GetTextAsString();
	pIntr->m_tstref					= m_edTstRef.GetTextAsString();
//	pIntr->m_nrt_point[m_nCurNo]	= m_edIntrPt.GetTextAsString();
	pIntr->m_nrt_pointno[m_nCurNo]	= m_edIntrPtNo.GetTextAsString();
	pIntr->m_nrt_pointloc[m_nCurNo]	= m_edIntrPtLoc.GetTextAsString();
	pIntr->m_nrt_bix[m_nCurNo]		= m_nrt_edBix.GetTextAsString();
	pIntr->m_nrt_biy[m_nCurNo]		= m_nrt_edBiy.GetTextAsString();
	pIntr->m_nrt_biz[m_nCurNo]		= m_nrt_edBiz.GetTextAsString();
	pIntr->m_nrt_aix[m_nCurNo]		= m_nrt_edAix.GetTextAsString();
	pIntr->m_nrt_aiy[m_nCurNo]		= m_nrt_edAiy.GetTextAsString();
	pIntr->m_nrt_aiz[m_nCurNo]		= m_nrt_edAiz.GetTextAsString();
	UpdateData(false);

	m_pVehData->m_tstref = pIntr->m_tstref;
	return TRUE;
}	// LoadIntrusionData

bool CVehIntrPage::InsertIntrusionData()
{
	if( m_hWnd == NULL ) { return TRUE; }  // Return FALSE if data invalid
	
	UpdateData();
	char nrtno[16]; itoa(m_nCurNo, nrtno, 10);

	CIntrusionData* pIntr = &m_pVehData->m_IntrusionData;
	pIntr->m_nrt_no.InsertAt( m_nCurNo, nrtno );
//	pIntr->m_verno = m_edTstNo.GetTextAsString();
	pIntr->m_nrt_vehno.InsertAt( m_nCurNo, m_edVehNo.GetTextAsString() );
	pIntr->m_tstref = m_edTstRef.GetTextAsString();
//	pIntr->m_nrt_point.InsertAt( m_nCurNo, m_edIntrPt.GetTextAsString() );
	pIntr->m_nrt_pointno.InsertAt( m_nCurNo, m_edIntrPtNo.GetTextAsString() );
	pIntr->m_nrt_pointloc.InsertAt( m_nCurNo, m_edIntrPtLoc.GetTextAsString() );
	pIntr->m_nrt_bix.InsertAt( m_nCurNo, m_nrt_edBix.GetTextAsString() );
	pIntr->m_nrt_biy.InsertAt( m_nCurNo, m_nrt_edBiy.GetTextAsString() );
	pIntr->m_nrt_biz.InsertAt( m_nCurNo, m_nrt_edBiz.GetTextAsString() );
	pIntr->m_nrt_aix.InsertAt( m_nCurNo, m_nrt_edAix.GetTextAsString() );
	pIntr->m_nrt_aiy.InsertAt( m_nCurNo, m_nrt_edAiy.GetTextAsString() );
	pIntr->m_nrt_aiz.InsertAt( m_nCurNo, m_nrt_edAiz.GetTextAsString() );

	UpdateData( false );
	return true;
}	// InsertIntrusionData

const bool CVehIntrPage::ValidatePage( void )
{
	const int nTotal = 9;
	bool bRetArray[nTotal];
	int i = 0;
	bRetArray[i++] = m_edVehNo.GetValidate();
	bRetArray[i++] = m_edIntrPtNo.GetValidate();
	bRetArray[i++] = m_edIntrPtLoc.GetValidate();
	bRetArray[i++] = m_nrt_edBix.GetValidate();
	bRetArray[i++] = m_nrt_edBiy.GetValidate();
	bRetArray[i++] = m_nrt_edBiz.GetValidate();
	bRetArray[i++] = m_nrt_edAix.GetValidate();
	bRetArray[i++] = m_nrt_edAiy.GetValidate();
	bRetArray[i++] = m_nrt_edAiz.GetValidate();

	for( int i = 0; i < nTotal; i++ )
	{
		if( !bRetArray[i] ) { return false; }
	}

	return true;
}	// ValidatePage

void CVehIntrPage::SetBusinessRules( void )
{
	m_edVehNo.SetDouble( 0, 2, true );
//	m_edIntrPtNo.SetDouble( 0, 1000, true );
//	m_edIntrPtLoc.SetString( 0, 2, true );
	m_nrt_edBix.SetDouble( -10000, 10000, true );
	m_nrt_edBiy.SetDouble( -10000, 10000, true );
	m_nrt_edBiz.SetDouble( -10000, 10000, true );
	m_nrt_edAix.SetDouble( -10000, 10000, true );
	m_nrt_edAiy.SetDouble( -10000, 10000, true );
	m_nrt_edAiz.SetDouble( -10000, 10000, true );

}	// SetBusinessRules
