#pragma once
#include "EditEx.h"
#include "VehData.h"

// CVehIntrPage dialog

class CVehIntrPage : public CPropertyPage
{
	DECLARE_DYNAMIC(CVehIntrPage)

public:
	CVehIntrPage();
	
	virtual ~CVehIntrPage();

	void ClearAll();

	void UpdateListbox();
	void InitializeNext();
	
	void DisplayIntrusionData();
	BOOL LoadIntrusionData();
	bool InsertIntrusionData();

	void DecodeVehIp(CNEdit& edNo, CNEdit& edLoc);
	const bool ValidateThisPage();
	const bool ValidatePage();
	void SetBusinessRules();

	int			m_nTotalNo;
	int			m_nCurNo;
	CString		m_sVehIp;
	CVehData*	m_pVehData;

// Dialog Data
	enum { IDD = IDD_VEH_NTR_PAGE };

	CListBox	m_ListNo;
	BOOL		m_cbRetainData;
	CButton		m_btnNextNo;
	CButton		m_btnDeleteNo;
	
//	CNEdit		m_edTstNo;
	CNEdit		m_edVehNo;
	CNEdit		m_edTstRef;
//	CNEdit		m_edIntrPt;
	CNEdit		m_edIntrPtNo;
	CNEdit		m_edIntrPtLoc;
	CNEdit		m_nrt_edBix;
	CNEdit		m_nrt_edBiy;
	CNEdit		m_nrt_edBiz;
	CNEdit		m_nrt_edAix;
	CNEdit		m_nrt_edAiy;
	CNEdit		m_nrt_edAiz;

	public: // virtual overwrite
	virtual BOOL OnSetActive();
	virtual BOOL OnKillActive();

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();

	afx_msg void OnNextRecord();
	afx_msg void OnDeleteNtrNo();
	afx_msg void OnSelchangeNtrNolist();
	afx_msg void OnIpSearch();

	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	afx_msg BOOL OnToolTipNotify(UINT, NMHDR *, LRESULT *);

	DECLARE_MESSAGE_MAP()
};
