// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: BioAnthPage.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description:  Member functions of CBioAnthPage.
//               They relate to the loading and display of 
//               data on this page.
//  Date		Who			Description
//	2000    Y. Wong Adding data range control, recode all edit boxs
//					and correct other errors.
// -----------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "BioAnthPage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBioAnthPage property page

IMPLEMENT_DYNCREATE(CBioAnthPage, CPropertyPage)

CBioAnthPage::CBioAnthPage() : CPropertyPage(CBioAnthPage::IDD)
{
	//{{AFX_DATA_INIT(CBioAnthPage)
	m_editanklcr = "";
	m_editwrstcr = "";
	m_editanklht = "";
	m_editbicpcr = "";
	m_editbuttcr = "";
	m_editbuttdp = "";
	m_editcalfcr = "";
	m_editchstbd = "";
	m_editchstcr = "";
	m_editchstdp = "";
	m_editelbwcr = "";
	m_editfarmcr = "";
	m_editfarmhd = "";
	m_editfootbd = "";
	m_editfootln = "";
	m_edithdtroc = "";
	m_editheadbd = "";
	m_editheadch = "";
	m_editheadln = "";
	m_edithipbd = "";
	m_editinscye = "";
	m_editkneecr = "";
	m_editkneeht = "";
	m_editltghcr = "";
	m_editneckcr = "";
	m_editscyecr = "";
	m_editseatht = "";
	m_editshldbd = "";
	m_editshldel = "";
	m_editshldht = "";
	m_editstatur = "";
	m_editthghcr = "";
	m_edittiblht = "";
	m_editvrtsym = "";
	m_editwastbd = "";
	m_editwastcr = "";
	m_editwastdp = "";
	m_editwastht = "";
	//}}AFX_DATA_INIT
}

CBioAnthPage::~CBioAnthPage()
{
}

void CBioAnthPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBioAnthPage)
	DDX_Control(pDX, IDC_BIOANTHANKLCR, m_editanklcr);
	DDX_Control(pDX, IDC_BIOANTHWRSTCR, m_editwrstcr);
	DDX_Control(pDX, IDC_BIOANTHANKLHT, m_editanklht);
	DDX_Control(pDX, IDC_BIOANTHBICPCR, m_editbicpcr);
	DDX_Control(pDX, IDC_BIOANTHBUTTCR, m_editbuttcr);
	DDX_Control(pDX, IDC_BIOANTHBUTTDP, m_editbuttdp);
	DDX_Control(pDX, IDC_BIOANTHCALFCR, m_editcalfcr);
	DDX_Control(pDX, IDC_BIOANTHCHSTBD, m_editchstbd);
	DDX_Control(pDX, IDC_BIOANTHCHSTCR, m_editchstcr);
	DDX_Control(pDX, IDC_BIOANTHCHSTDP, m_editchstdp);
	DDX_Control(pDX, IDC_BIOANTHELBWCR, m_editelbwcr);
	DDX_Control(pDX, IDC_BIOANTHFARMCR, m_editfarmcr);
	DDX_Control(pDX, IDC_BIOANTHFARMHD, m_editfarmhd);
	DDX_Control(pDX, IDC_BIOANTHFOOTBD, m_editfootbd);
	DDX_Control(pDX, IDC_BIOANTHFOOTLN, m_editfootln);
	DDX_Control(pDX, IDC_BIOANTHHDTROC, m_edithdtroc);
	DDX_Control(pDX, IDC_BIOANTHHEADBD, m_editheadbd);
	DDX_Control(pDX, IDC_BIOANTHHEADCH, m_editheadch);
	DDX_Control(pDX, IDC_BIOANTHHEADLN, m_editheadln);
	DDX_Control(pDX, IDC_BIOANTHHIPBD, m_edithipbd);
	DDX_Control(pDX, IDC_BIOANTHINSCYE, m_editinscye);
	DDX_Control(pDX, IDC_BIOANTHKNEECR, m_editkneecr);
	DDX_Control(pDX, IDC_BIOANTHKNEEHT, m_editkneeht);
	DDX_Control(pDX, IDC_BIOANTHLTGHCR, m_editltghcr);
	DDX_Control(pDX, IDC_BIOANTHNECKCR, m_editneckcr);
	DDX_Control(pDX, IDC_BIOANTHSCYECR, m_editscyecr);
	DDX_Control(pDX, IDC_BIOANTHSEATHT, m_editseatht);
	DDX_Control(pDX, IDC_BIOANTHSHLDBD, m_editshldbd);
	DDX_Control(pDX, IDC_BIOANTHSHLDEL, m_editshldel);
	DDX_Control(pDX, IDC_BIOANTHSHLDHT, m_editshldht);
	DDX_Control(pDX, IDC_BIOANTHSTATUR, m_editstatur);
	DDX_Control(pDX, IDC_BIOANTHTHGHCR, m_editthghcr);
	DDX_Control(pDX, IDC_BIOANTHTIBLHT, m_edittiblht);
	DDX_Control(pDX, IDC_BIOANTHVRTSYM, m_editvrtsym);
	DDX_Control(pDX, IDC_BIOANTHWASTBD, m_editwastbd);
	DDX_Control(pDX, IDC_BIOANTHWASTCR, m_editwastcr);
	DDX_Control(pDX, IDC_BIOANTHWASTDP, m_editwastdp);
	DDX_Control(pDX, IDC_BIOANTHWASTHT, m_editwastht);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBioAnthPage, CPropertyPage)
	//{{AFX_MSG_MAP(CBioAnthPage)
	ON_WM_HELPINFO()
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTW, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTA, 0, 0xFFFF, OnToolTipNotify )
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBioAnthPage message handlers

/******************************************************************************

	Name:		

	Action:		

	Params:		void

	Returns:	BOOL

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
BOOL CBioAnthPage::OnKillActive( void ) 
{
	if( ValidateAnthPage() == true )
	{
		LoadBioAnthData();

		return CPropertyPage::OnKillActive();
	}
	else
	{
		// Error are found on AnthPage.
		return FALSE;
	}
}

/******************************************************************************

	Name:		

	Action:		

	Params:		void

	Returns:	BOOL

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
BOOL CBioAnthPage::OnSetActive( void ) 
{
	EnableControls();

	SetBusinessRules();

	DisplayBioAnthData();

	ValidateAnthPage();
	
	return CPropertyPage::OnSetActive();
}

/******************************************************************************

	Name:		

	Action:		

	Params:		void

	Returns:	BOOL

	Notes:	

	Dates:		

******************************************************************************/
BOOL CBioAnthPage::OnInitDialog( void ) 
{
	CPropertyPage::OnInitDialog();
	
	EnableToolTips();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		

******************************************************************************/
BOOL CBioAnthPage::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{

	TOOLTIPTEXTA* pTTTA = (TOOLTIPTEXTA*)pNMHDR;
	TOOLTIPTEXTW* pTTTW = (TOOLTIPTEXTW*)pNMHDR;
	CString strTipText = "";
	UINT nID = pNMHDR->idFrom;
	if (pNMHDR->code == TTN_NEEDTEXTA && (pTTTA->uFlags & TTF_IDISHWND) ||
		pNMHDR->code == TTN_NEEDTEXTW && (pTTTW->uFlags & TTF_IDISHWND))
	{
		// idFrom is actually the HWND of the tool
		nID = ::GetDlgCtrlID((HWND)nID);
	}

	if (nID != 0) // will be zero on a separator
	{
		strTipText.Format("Control ID = %d", nID);
		switch (nID)
			{
			case IDC_BIOANTHTSTNO:
				strTipText = "";
				break;
			case IDC_BIOANTHWRSTCR:
				strTipText = "Millimeters (0 -> 999)";
				break;
			default:
				strTipText = "Millimeters (0 -> 9999)";
			}
	}

	if (pNMHDR->code == TTN_NEEDTEXTA)
		lstrcpyn(pTTTA->szText, strTipText, sizeof(pTTTA->szText));
	else
		::MultiByteToWideChar( CP_ACP , 0, strTipText, -1, pTTTW->szText, sizeof(pTTTW->szText) );
	*pResult = 0;

	return TRUE;    // message was handled
}

/******************************************************************************

	Name:		LoadBioAnthData

	Action:		Put data from screen into m_pBioData

	Params:		void

	Returns:	BOOL

	Notes:	

	Dates:		

******************************************************************************/
BOOL CBioAnthPage::LoadBioAnthData( void )
{
	if (m_hWnd==NULL) return TRUE; // only return FALSE if data invalid
	// put data into m_pBioData
	if (!UpdateData(TRUE)) return FALSE;

	m_pBioData->m_anklcr = m_editanklcr.GetTextAsString();
	m_pBioData->m_anklht = m_editanklht.GetTextAsString();
	m_pBioData->m_bicpcr = m_editbicpcr.GetTextAsString();
	m_pBioData->m_buttcr = m_editbuttcr.GetTextAsString();
	m_pBioData->m_buttdp = m_editbuttdp.GetTextAsString();
	m_pBioData->m_calfcr = m_editcalfcr.GetTextAsString();
	m_pBioData->m_chstbd = m_editchstbd.GetTextAsString();
	m_pBioData->m_chstcr = m_editchstcr.GetTextAsString();
	m_pBioData->m_chstdp = m_editchstdp.GetTextAsString();
	m_pBioData->m_elbwcr = m_editelbwcr.GetTextAsString();
	m_pBioData->m_farmcr = m_editfarmcr.GetTextAsString();
	m_pBioData->m_farmhd = m_editfarmhd.GetTextAsString();
	m_pBioData->m_footbd = m_editfootbd.GetTextAsString();
	m_pBioData->m_footln = m_editfootln.GetTextAsString();
	m_pBioData->m_hdtroc = m_edithdtroc.GetTextAsString();
	m_pBioData->m_headbd = m_editheadbd.GetTextAsString();
	m_pBioData->m_headch = m_editheadch.GetTextAsString();
	m_pBioData->m_headln = m_editheadln.GetTextAsString();
	m_pBioData->m_hipbd = m_edithipbd.GetTextAsString();
	m_pBioData->m_inscye = m_editinscye.GetTextAsString();
	m_pBioData->m_kneecr = m_editkneecr.GetTextAsString();
	m_pBioData->m_kneeht = m_editkneeht.GetTextAsString();
	m_pBioData->m_ltghcr = m_editltghcr.GetTextAsString();
	m_pBioData->m_neckcr = m_editneckcr.GetTextAsString();
	m_pBioData->m_scyecr = m_editscyecr.GetTextAsString();
	m_pBioData->m_seatht = m_editseatht.GetTextAsString();
	m_pBioData->m_shldbd = m_editshldbd.GetTextAsString();
	m_pBioData->m_shldel = m_editshldel.GetTextAsString();
	m_pBioData->m_shldht = m_editshldht.GetTextAsString();
	m_pBioData->m_statur = m_editstatur.GetTextAsString();
	m_pBioData->m_thghcr = m_editthghcr.GetTextAsString();
	m_pBioData->m_tiblht = m_edittiblht.GetTextAsString();
	m_pBioData->m_vrtsym = m_editvrtsym.GetTextAsString();
	m_pBioData->m_wastbd = m_editwastbd.GetTextAsString();
	m_pBioData->m_wastcr = m_editwastcr.GetTextAsString();
	m_pBioData->m_wastdp = m_editwastdp.GetTextAsString();
	m_pBioData->m_wastht = m_editwastht.GetTextAsString();
	m_pBioData->m_wrstcr = m_editwrstcr.GetTextAsString();

	return TRUE;
}

/******************************************************************************

	Name:		DisplayBioAnthData()

	Action:		Get Data from pBioData and display it.	

	Params:		void

	Returns:	void

	Notes:	

	Dates:		

******************************************************************************/
void CBioAnthPage::DisplayBioAnthData( void )
{
	UpdateData();
	m_editanklcr = m_pBioData->m_anklcr ;
	m_editanklht = m_pBioData->m_anklht ;
	m_editbicpcr = m_pBioData->m_bicpcr ;
	m_editbuttcr = m_pBioData->m_buttcr ;
	m_editbuttdp = m_pBioData->m_buttdp ;
	m_editcalfcr = m_pBioData->m_calfcr ;
	m_editchstbd = m_pBioData->m_chstbd ;
	m_editchstcr = m_pBioData->m_chstcr ;
	m_editchstdp = m_pBioData->m_chstdp ;
	m_editelbwcr = m_pBioData->m_elbwcr ;
	m_editfarmcr = m_pBioData->m_farmcr ;
	m_editfarmhd = m_pBioData->m_farmhd ;
	m_editfootbd = m_pBioData->m_footbd ;
	m_editfootln = m_pBioData->m_footln ;
	m_edithdtroc = m_pBioData->m_hdtroc ;
	m_editheadbd = m_pBioData->m_headbd ;
	m_editheadch = m_pBioData->m_headch ;
	m_editheadln = m_pBioData->m_headln ;
	m_edithipbd = m_pBioData->m_hipbd ;
	m_editinscye = m_pBioData->m_inscye ;
	m_editkneecr = m_pBioData->m_kneecr ;
	m_editkneeht = m_pBioData->m_kneeht ;
	m_editltghcr = m_pBioData->m_ltghcr ;
	m_editneckcr = m_pBioData->m_neckcr ;
	m_editscyecr = m_pBioData->m_scyecr ;
	m_editseatht = m_pBioData->m_seatht ;
	m_editshldbd = m_pBioData->m_shldbd ;
	m_editshldel = m_pBioData->m_shldel ;
	m_editshldht = m_pBioData->m_shldht ;
	m_editstatur = m_pBioData->m_statur ;
	m_editthghcr = m_pBioData->m_thghcr ;
	m_edittiblht = m_pBioData->m_tiblht ;
	m_editvrtsym = m_pBioData->m_vrtsym ;
	m_editwastbd = m_pBioData->m_wastbd ;
	m_editwastcr = m_pBioData->m_wastcr ;
	m_editwastdp = m_pBioData->m_wastdp ;
	m_editwastht = m_pBioData->m_wastht ;
	m_editwrstcr = m_pBioData->m_wrstcr ;

	UpdateData(FALSE);

}

/******************************************************************************

	Name:		OnHelpInfo

	Action:		

	Params:		HELPINFO* pHelpInfo

	Returns:	BOOL

	Notes:	

	Dates:		

******************************************************************************/
BOOL CBioAnthPage::OnHelpInfo( HELPINFO* pHelpInfo ) 
{
	WinHelp(Anthropometric_Information);
	
	return TRUE;
}

/******************************************************************************

	Name:		ValidateAnthPage

	Action:		

	Params:		void

	Returns:	bool

	Notes:	

	Dates:		

******************************************************************************/
bool CBioAnthPage::ValidateAnthPage( void )
{
	bool bRetArray[38];

	bRetArray[0] = m_editanklcr.GetValidate();
	bRetArray[1] = m_editanklht.GetValidate();
	bRetArray[2] = m_editbicpcr.GetValidate();
	bRetArray[3] = m_editbuttcr.GetValidate();
	bRetArray[4] = m_editbuttdp.GetValidate();
	bRetArray[5] = m_editcalfcr.GetValidate();
	bRetArray[6] = m_editchstbd.GetValidate();
	bRetArray[7] = m_editchstcr.GetValidate();
	bRetArray[8] = m_editchstdp.GetValidate();
	bRetArray[9] = m_editelbwcr.GetValidate();
	bRetArray[10] = m_editfarmcr.GetValidate();
	bRetArray[11] = m_editfarmhd.GetValidate();
	bRetArray[12] = m_editfootbd.GetValidate();
	bRetArray[13] = m_editfootln.GetValidate();
	bRetArray[14] = m_edithdtroc.GetValidate();
	bRetArray[15] = m_editheadbd.GetValidate();
	bRetArray[16] = m_editheadch.GetValidate();
	bRetArray[17] = m_editheadln.GetValidate();
	bRetArray[18] = m_edithipbd.GetValidate();
	bRetArray[19] = m_editinscye.GetValidate();
	bRetArray[20] = m_editkneecr.GetValidate();
	bRetArray[21] = m_editkneeht.GetValidate();
	bRetArray[22] = m_editltghcr.GetValidate();
	bRetArray[23] = m_editneckcr.GetValidate();
	bRetArray[24] = m_editscyecr.GetValidate();
	bRetArray[25] = m_editseatht.GetValidate();
	bRetArray[26] = m_editshldbd.GetValidate();
	bRetArray[27] = m_editshldel.GetValidate();
	bRetArray[28] = m_editshldht.GetValidate();
	bRetArray[29] = m_editstatur.GetValidate();
	bRetArray[30] = m_editthghcr.GetValidate();
	bRetArray[31] = m_edittiblht.GetValidate();
	bRetArray[32] = m_editvrtsym.GetValidate();
	bRetArray[33] = m_editwastbd.GetValidate();
	bRetArray[34] = m_editwastcr.GetValidate();
	bRetArray[35] = m_editwastdp.GetValidate();
	bRetArray[36] = m_editwastht.GetValidate();
	bRetArray[37] = m_editwrstcr.GetValidate();
	
	for(int i=0; i<38; i++) { if (!bRetArray[i]) return false; }
	return true;
}

void CBioAnthPage::SetBusinessRules( void )
{
	m_editanklcr.SetDouble( 0, 9999 );	// type 1: set strin
	m_editanklht.SetDouble( 0, 9999 );
	m_editbicpcr.SetDouble( 0, 9999 );
	m_editbuttcr.SetDouble( 0, 9999 );
	m_editbuttdp.SetDouble( 0, 9999 );
	m_editcalfcr.SetDouble( 0, 9999 );
	m_editchstbd.SetDouble( 0, 9999 );
	m_editchstcr.SetDouble( 0, 9999 );
	m_editchstdp.SetDouble( 0, 9999 );
	m_editelbwcr.SetDouble( 0, 9999 );
	m_editfarmcr.SetDouble( 0, 9999 );
	m_editfarmhd.SetDouble( 0, 9999 );
	m_editfootbd.SetDouble( 0, 9999 );
	m_editfootln.SetDouble( 0, 9999 );
	m_edithdtroc.SetDouble( 0, 9999 );
	m_editheadbd.SetDouble( 0, 9999 );
	m_editheadch.SetDouble( 0, 9999 );
	m_editheadln.SetDouble( 0, 9999 );
	m_edithipbd.SetDouble( 0, 9999 );
	m_editinscye.SetDouble( 0, 9999 );
	m_editkneecr.SetDouble( 0, 9999 );
	m_editkneeht.SetDouble( 0, 9999 );
	m_editltghcr.SetDouble( 0, 9999 );
	m_editneckcr.SetDouble( 0, 9999 );
	m_editscyecr.SetDouble( 0, 9999 );
	m_editseatht.SetDouble( 0, 9999 );
	m_editshldbd.SetDouble( 0, 9999 );
	m_editshldel.SetDouble( 0, 9999 );
	m_editshldht.SetDouble( 0, 9999 );
	m_editstatur.SetDouble( 0, 9999 );
	m_editthghcr.SetDouble( 0, 9999 );
	m_edittiblht.SetDouble( 0, 9999 );
	m_editvrtsym.SetDouble( 0, 9999 );
	m_editwastbd.SetDouble( 0, 9999 );
	m_editwastcr.SetDouble( 0, 9999 );
	m_editwastdp.SetDouble( 0, 9999 );
	m_editwastht.SetDouble( 0, 9999 );
	m_editwrstcr.SetDouble( 0, 999 );
}	// SetBusinessRules


void CBioAnthPage::EnableControls()
{
	bool bStatue = true;
	if ( (m_pBioData->m_occtyp == "") || ( (m_pBioData->m_occtyp != "AN") &&
	   (m_pBioData->m_occtyp != "CD") && (m_pBioData->m_occtyp != "HU") ) ) 
	{
		bStatue = false;
	}

	m_editanklcr.EnableWindow(bStatue);
	m_editwrstcr.EnableWindow(bStatue);
	m_editanklht.EnableWindow(bStatue);
	m_editbicpcr.EnableWindow(bStatue);
	m_editbuttcr.EnableWindow(bStatue);

	m_editbuttdp.EnableWindow(bStatue);
	m_editcalfcr.EnableWindow(bStatue);
	m_editchstbd.EnableWindow(bStatue);
	m_editchstcr.EnableWindow(bStatue);
	m_editchstdp.EnableWindow(bStatue);

	m_editelbwcr.EnableWindow(bStatue);
	m_editfarmcr.EnableWindow(bStatue);
	m_editfarmhd.EnableWindow(bStatue);
	m_editfootbd.EnableWindow(bStatue);
	m_editfootln.EnableWindow(bStatue);

	m_edithdtroc.EnableWindow(bStatue);
	m_editheadbd.EnableWindow(bStatue);
	m_editheadch.EnableWindow(bStatue);
	m_editheadln.EnableWindow(bStatue);
	m_edithipbd.EnableWindow(bStatue);

	m_editinscye.EnableWindow(bStatue);
	m_editkneecr.EnableWindow(bStatue);
	m_editkneeht.EnableWindow(bStatue);
	m_editltghcr.EnableWindow(bStatue);
	m_editneckcr.EnableWindow(bStatue);

	m_editscyecr.EnableWindow(bStatue);
	m_editseatht.EnableWindow(bStatue);
	m_editshldbd.EnableWindow(bStatue);
	m_editshldel.EnableWindow(bStatue);
	m_editshldht.EnableWindow(bStatue);

	m_editstatur.EnableWindow(bStatue);
	m_editthghcr.EnableWindow(bStatue);
	m_edittiblht.EnableWindow(bStatue);
	m_editvrtsym.EnableWindow(bStatue);
	m_editwastbd.EnableWindow(bStatue);

	m_editwastcr.EnableWindow(bStatue);
	m_editwastdp.EnableWindow(bStatue);
	m_editwastht.EnableWindow(bStatue);
	

	//else   // enable.
	//{
	//	m_editanklcr.EnableWindow(true);
	//	m_editwrstcr.EnableWindow(true);
	//	m_editanklht.EnableWindow(true);
	//	m_editbicpcr.EnableWindow(true);
	//	m_editbuttcr.EnableWindow(true);

	//	m_editbuttdp.EnableWindow(true);
	//	m_editcalfcr.EnableWindow(true);
	//	m_editchstbd.EnableWindow(true);
	//	m_editchstcr.EnableWindow(true);
	//	m_editchstdp.EnableWindow(true);

	//	m_editelbwcr.EnableWindow(true);
	//	m_editfarmcr.EnableWindow(true);
	//	m_editfarmhd.EnableWindow(true);
	//	m_editfootbd.EnableWindow(true);
	//	m_editfootln.EnableWindow(true);

	//	m_edithdtroc.EnableWindow(true);
	//	m_editheadbd.EnableWindow(true);
	//	m_editheadch.EnableWindow(true);
	//	m_editheadln.EnableWindow(true);
	//	m_edithipbd.EnableWindow(true);

	//	m_editinscye.EnableWindow(true);
	//	m_editkneecr.EnableWindow(true);
	//	m_editkneeht.EnableWindow(true);
	//	m_editltghcr.EnableWindow(true);
	//	m_editneckcr.EnableWindow(true);

	//	m_editscyecr.EnableWindow(true);
	//	m_editseatht.EnableWindow(true);
	//	m_editshldbd.EnableWindow(true);
	//	m_editshldel.EnableWindow(true);
	//	m_editshldht.EnableWindow(true);

	//	m_editstatur.EnableWindow(true);
	//	m_editthghcr.EnableWindow(true);
	//	m_edittiblht.EnableWindow(true);
	//	m_editvrtsym.EnableWindow(true);
	//	m_editwastbd.EnableWindow(true);

	//	m_editwastcr.EnableWindow(true);
	//	m_editwastdp.EnableWindow(true);
	//	m_editwastht.EnableWindow(true);
	//}
}	// EnableControls
