// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: BioCBandPage.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description:  Member functions of CBioCBandPage.
//               They relate to the loading and display of 
//               data on this page.
//
//  Modification History:
//  Date		Who			Description
//	2000    Y. Wong Adding business rules, recode all edit boxs
//					and correct other errors.
// ----------------------------------------- 

#include "stdafx.h"
#include "entreeV5.h"
#include "BioCBandPage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBioCBandPage property page

IMPLEMENT_DYNCREATE(CBioCBandPage, CPropertyPage)

CBioCBandPage::CBioCBandPage() : CPropertyPage(CBioCBandPage::IDD)
{
	//{{AFX_DATA_INIT(CBioCBandPage)
	m_editantloc = _T("");
	m_editchbcom = _T("");
	m_editposloc = _T("");
	m_retaindata = FALSE;
	m_editbanlen = _T("");
	m_editchsbrd = _T("");
	m_editchsdpt = _T("");
	m_editgagstr = _T("");
	m_editdisstr = _T("");
	m_editdisspn = _T("");
	m_edittotgag = _T("");
	m_editgagspn = _T("");
	//}}AFX_DATA_INIT

	m_curband=0;
}

CBioCBandPage::~CBioCBandPage()
{
}

void CBioCBandPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBioCBandPage)
	DDX_Control(pDX, IDC_CBANDLIST, m_cbandlist);
	DDX_Control(pDX, IDC_NEXTSET_BUTTON, m_nextsetbutton);
	DDX_Control(pDX, IDC_DELETE_BUTTON, m_deletebutton);

	DDX_Control(pDX, IDC_BIOCBANDANTLOC, m_editantloc);
//	DDV_MaxChars(pDX, m_antloc, 2);
	DDX_Control(pDX, IDC_BIOCBANDCHBCOM, m_editchbcom);
//	DDV_MaxChars(pDX, m_chbcom, 70);
	DDX_Control(pDX, IDC_BIOCBANDPOSLOC, m_editposloc);
//	DDV_MaxChars(pDX, m_posloc, 2);
	DDX_Check(pDX, IDC_RETAINDATA, m_retaindata);
	DDX_Control(pDX, IDC_BIOCBANDBANLEN, m_editbanlen);
//	DDV_MinMaxDWord(pDX, m_banlen, 0, 999);
	DDX_Control(pDX, IDC_BIOCBANDCHSBRD, m_editchsbrd);
//	DDV_MinMaxDWord(pDX, m_chsbrd, 0, 999);
	DDX_Control(pDX, IDC_BIOCBANDCHSDPT, m_editchsdpt);
//	DDV_MinMaxDWord(pDX, m_chsdpt, 0, 999);
	DDX_Control(pDX, IDC_BIOCBANDGAGSTR, m_editgagstr);
//	DDV_MinMaxDWord(pDX, m_gagstr, 1, 200);
	DDX_Control(pDX, IDC_BIOCBANDDISSTR, m_editdisstr);
//	DDV_MinMaxDWord(pDX, m_disstr, 0, 99);
	DDX_Control(pDX, IDC_BIOCBANDDISSPN, m_editdisspn);
//	DDV_MinMaxDWord(pDX, m_disspn, 0, 99);
	DDX_Control(pDX, IDC_BIOCBANDTOTGAG, m_edittotgag);
//	DDV_MinMaxDWord(pDX, m_totgag, 1, 40);
	DDX_Control(pDX, IDC_BIOCBANDGAGSPN, m_editgagspn);
//	DDV_MinMaxDWord(pDX, m_gagspn, 1, 200);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBioCBandPage, CPropertyPage)
	//{{AFX_MSG_MAP(CBioCBandPage)
	ON_BN_CLICKED(IDC_DELETE_BUTTON, OnDeleteButton)
	ON_BN_CLICKED(IDC_NEXTSET_BUTTON, OnNextsetButton)
	ON_LBN_SELCHANGE(IDC_CBANDLIST, OnSelchangeCbandlist)
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTW, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTA, 0, 0xFFFF, OnToolTipNotify )
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBioCBandPage message handlers

BOOL CBioCBandPage::OnKillActive() 
{
	if( ValidateBandPage() == true )
	{
		LoadBioCBandData();
		
        int nOldCurIndx = m_curband;
		for (m_curband=1; m_curband<m_pBioData->m_bandno+1; m_curband++)
		{
			DisplayBioCBandData();
			if (!ValidateBandPage()) { return false; }
		}
		m_curband = nOldCurIndx;

		DisplayBioCBandData();

		return CPropertyPage::OnKillActive();
	}
	else
	{
		// Error are found on AnthPage.
		return FALSE;
	}
}

BOOL CBioCBandPage::OnSetActive() 
{
	SetBusinessRules();

	DisplayBioCBandData();

	ValidateBandPage();
	
	return CPropertyPage::OnSetActive();
}

BOOL CBioCBandPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	EnableToolTips();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CBioCBandPage::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
	TOOLTIPTEXTA* pTTTA = (TOOLTIPTEXTA*)pNMHDR;
	TOOLTIPTEXTW* pTTTW = (TOOLTIPTEXTW*)pNMHDR;
	CString strTipText = "";
	UINT nID = pNMHDR->idFrom;
	if (pNMHDR->code == TTN_NEEDTEXTA && (pTTTA->uFlags & TTF_IDISHWND) ||
		pNMHDR->code == TTN_NEEDTEXTW && (pTTTW->uFlags & TTF_IDISHWND))
	{
		// idFrom is actually the HWND of the tool
		nID = ::GetDlgCtrlID((HWND)nID);
	}

	if (nID != 0) // will be zero on a separator
	{
		strTipText.Format("Control ID = %d", nID);
		switch (nID)
			{
			case IDC_BIOCBANDCHSDPT:
				strTipText = "Millimeters (0->999)";
				break;
			case IDC_BIOCBANDCHSBRD:
				strTipText = "Millimeters (0->999)";
				break;
			case IDC_BIOCBANDDISSTR:
				strTipText = "Millimeters (0->99)";
				break;
			case IDC_BIOCBANDDISSPN:
				strTipText = "Millimeters (0->99)";
				break;
			case IDC_BIOCBANDBANLEN:
				strTipText = "Millimeters (0->1800)";
				break;
			case IDC_BIOCBANDANTLOC:
				strTipText = "1->10";
				break;
			case IDC_BIOCBANDPOSLOC:
				strTipText = "1->10";
				break;
			case IDC_BIOCBANDTOTGAG:
				strTipText = "0->1000";
				break;
			case IDC_DELETE_BUTTON:
				strTipText = "Delete chest band info set";
				break;
			case IDC_NEXTSET_BUTTON:
				strTipText = "Go to or add next chest band info set";
				break;
			default:
				strTipText = "";
			}
	}

	if (pNMHDR->code == TTN_NEEDTEXTA)
		lstrcpyn(pTTTA->szText, strTipText, sizeof(pTTTA->szText));
	else
		::MultiByteToWideChar( CP_ACP , 0, strTipText, -1, pTTTW->szText, sizeof(pTTTW->szText) );
	*pResult = 0;

	return TRUE;    // message was handled
}

// This function gets data from the entry screen and puts it into m_pBioData
// It is called from OnKillActive, ExportData, and record changed.
BOOL CBioCBandPage::LoadBioCBandData()
{
	// put data into m_pBioData
	if (m_hWnd==NULL) return TRUE; //only return FALSE if data invalid
	if (!UpdateData(TRUE)) return FALSE;
		
	m_pBioData->m_antloc[m_curband] = m_editantloc.GetTextAsString();
	m_pBioData->m_bandno = max(m_pBioData->m_bandno, m_curband);
	m_pBioData->m_banlen[m_curband] = m_editbanlen.GetTextAsString();
	m_pBioData->m_chbcom[m_curband] = m_editchbcom.GetTextAsString();
	m_pBioData->m_chsbrd[m_curband] = m_editchsbrd.GetTextAsString();
	m_pBioData->m_chsdpt[m_curband] = m_editchsdpt.GetTextAsString();
	m_pBioData->m_disspn[m_curband] = m_editdisspn.GetTextAsString();
	m_pBioData->m_disstr[m_curband] = m_editdisstr.GetTextAsString();
	m_pBioData->m_gagspn[m_curband] = m_editgagspn.GetTextAsString();
	m_pBioData->m_gagstr[m_curband] = m_editgagstr.GetTextAsString();
	m_pBioData->m_posloc[m_curband] = m_editposloc.GetTextAsString();
	m_pBioData->m_totgag[m_curband] = m_edittotgag.GetTextAsString();

	return TRUE;
	
}

// wong code in 03/02/00
bool CBioCBandPage::InsertBioCBandData()
{
	if (m_hWnd==NULL) return TRUE;  // only return FALSE if data invalid
	
	UpdateData();
 
//	m_pBioData->m_ais.InsertAt( m_curinj, m_ais);
	m_pBioData->m_antloc.InsertAt( m_curband, m_editantloc.GetTextAsString() );
	m_pBioData->m_bandno = max(m_pBioData->m_bandno, m_curband);
	m_pBioData->m_banlen.InsertAt( m_curband, m_editbanlen.GetTextAsString() );
	m_pBioData->m_chbcom.InsertAt( m_curband, m_editchbcom.GetTextAsString() );
	m_pBioData->m_chsbrd.InsertAt( m_curband, m_editchsbrd.GetTextAsString() );
	m_pBioData->m_chsdpt.InsertAt( m_curband, m_editchsdpt.GetTextAsString() );
	m_pBioData->m_disspn.InsertAt( m_curband, m_editdisspn.GetTextAsString() );
	m_pBioData->m_disstr.InsertAt( m_curband, m_editdisstr.GetTextAsString() );
	m_pBioData->m_gagspn.InsertAt( m_curband, m_editgagspn.GetTextAsString() );
	m_pBioData->m_gagstr.InsertAt( m_curband, m_editgagstr.GetTextAsString() );
	m_pBioData->m_posloc.InsertAt( m_curband, m_editposloc.GetTextAsString() );
	m_pBioData->m_totgag.InsertAt( m_curband, m_edittotgag.GetTextAsString() );

	UpdateData(false);

	return true;
}	// InsertBioCBandData

//get data from m_pBioData and display it
void CBioCBandPage::DisplayBioCBandData()
{
	if (m_hWnd==NULL) return;

	UpdateCurveListbox();

	UpdateData();
	m_editantloc = m_pBioData->m_antloc[m_curband];
	m_editbanlen = m_pBioData->m_banlen[m_curband];
	m_editchbcom = m_pBioData->m_chbcom[m_curband];
	m_editposloc = m_pBioData->m_posloc[m_curband];
	m_editchsbrd = m_pBioData->m_chsbrd[m_curband];
	m_editchsdpt = m_pBioData->m_chsdpt[m_curband];
	m_editdisspn = m_pBioData->m_disspn[m_curband];
	m_editdisstr = m_pBioData->m_disstr[m_curband];
	m_editgagspn = m_pBioData->m_gagspn[m_curband];
	m_editgagstr = m_pBioData->m_gagstr[m_curband];
	m_edittotgag = m_pBioData->m_totgag[m_curband];

	UpdateData(FALSE);

}

void CBioCBandPage::OnDeleteButton() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	if (m_curband==0)  { return;  }

	m_pBioData->m_bandno--;

	m_pBioData->m_antloc.RemoveAt(m_curband);  
	m_pBioData->m_banlen.RemoveAt(m_curband);  
	m_pBioData->m_chbcom.RemoveAt(m_curband);
	m_pBioData->m_chsbrd.RemoveAt(m_curband);
	m_pBioData->m_chsdpt.RemoveAt(m_curband);
	m_pBioData->m_disspn.RemoveAt(m_curband);
	m_pBioData->m_disstr.RemoveAt(m_curband);
	m_pBioData->m_gagspn.RemoveAt(m_curband);
	m_pBioData->m_gagstr.RemoveAt(m_curband);
	m_pBioData->m_posloc.RemoveAt(m_curband);
	m_pBioData->m_totgag.RemoveAt(m_curband);

	m_curband--;             //goto previous cband

	//if m_curband == 0 now, and there are remaining curves, set curve 1 as active (m_curset=1)
	if (m_curband==0 && m_pBioData->m_bandno >0)
	{
		m_curband = 1;
	}
		
	DisplayBioCBandData();  //display previous set, if existing
	
}


void CBioCBandPage::OnNextsetButton() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }
	if (m_curband== MAXCBANDS) return;  // Don't go past max bands.

	if (m_curband==m_pBioData->m_bandno) //if at end, increase # of curves
	{
		if (m_curband!=0) { LoadBioCBandData(); }
		m_pBioData->m_bandno++; 
		m_curband++;
		InitializeNextCBand();
	} 
	else if (m_curband != 0) 
	{
		if(!LoadBioCBandData())
		{
			MessageBox("Error: see CBioCBandPage::OnNextcurveButton()");
			return;
		}
		m_curband++;
	}

	DisplayBioCBandData();
	ValidateBandPage();	
}

// New CBand set, expand arrays in m_pBioData to hold info
void CBioCBandPage::InitializeNextCBand()
{

	// *******************************************
	//These temp variables are used because the reference that [] returns is invalid when SetAtGrow
	// happens, because SetAtGrow (sometimes) moves the array to a different location in memory.   
	// If you try to use that reference directly, you will get an access violation.
	// For Example:  m_pBioData->m_injcom.SetAtGrow (m_curinj,m_pBioData->injcom[m_curinj-1]); //BAD!!!!
	CString strtemp; 
//	DWORD dwtemp;
	// *******************************************

	if (m_retaindata)
	{
		strtemp = m_pBioData->m_antloc[m_curband-1];
		m_pBioData->m_antloc.SetAtGrow(m_curband,strtemp);

		strtemp = m_pBioData->m_banlen[m_curband -1];
		m_pBioData->m_banlen.SetAtGrow(m_curband,strtemp);

		strtemp = m_pBioData->m_chbcom[m_curband-1];
		m_pBioData->m_chbcom.SetAtGrow(m_curband,strtemp);

		strtemp = m_pBioData->m_chsbrd[m_curband -1];
		m_pBioData->m_chsbrd.SetAtGrow(m_curband,strtemp);

		strtemp = m_pBioData->m_chsdpt[m_curband -1];
		m_pBioData->m_chsdpt.SetAtGrow(m_curband,strtemp);

		strtemp = m_pBioData->m_disspn[m_curband -1];
		m_pBioData->m_disspn.SetAtGrow(m_curband,strtemp);

		strtemp = m_pBioData->m_disstr[m_curband -1];
		m_pBioData->m_disstr.SetAtGrow(m_curband,strtemp);

		strtemp = m_pBioData->m_gagspn[m_curband -1];
		m_pBioData->m_gagspn.SetAtGrow(m_curband,strtemp);

		strtemp = m_pBioData->m_gagstr[m_curband -1];
		m_pBioData->m_gagstr.SetAtGrow(m_curband,strtemp);

		strtemp = m_pBioData->m_posloc[m_curband -1];
		m_pBioData->m_posloc.SetAtGrow(m_curband,strtemp);

		strtemp = m_pBioData->m_totgag[m_curband -1];
		m_pBioData->m_totgag.SetAtGrow(m_curband,strtemp);

	}
	else
	{
		m_pBioData->m_antloc.SetAtGrow(m_curband,"");
		m_pBioData->m_banlen.SetAtGrow(m_curband,"");
		m_pBioData->m_chbcom.SetAtGrow(m_curband,"");
		m_pBioData->m_chsbrd.SetAtGrow(m_curband,"");
		m_pBioData->m_chsdpt.SetAtGrow(m_curband,"");
		m_pBioData->m_disspn.SetAtGrow(m_curband,"");
		m_pBioData->m_disstr.SetAtGrow(m_curband,"");
		m_pBioData->m_gagspn.SetAtGrow(m_curband,"");
		m_pBioData->m_gagstr.SetAtGrow(m_curband,"");
		m_pBioData->m_posloc.SetAtGrow(m_curband,"");
		m_pBioData->m_totgag.SetAtGrow(m_curband,"");
		
	}
}

void CBioCBandPage::OnSelchangeCbandlist() 
{
	int nCurve = m_cbandlist.GetCurSel ();  //zero based

	if (m_curband != 0) 
	{
		BOOL success = LoadBioCBandData();     //load current info (not zeroth curve)
		if (!success) //Data not valid, dont change curves.
		{
			m_cbandlist.SetCurSel (max(0,m_curband-1));  // select current curve, zero based.
			return;
		}
	}

	m_curband= nCurve+1;             //goto current curve 

	DisplayBioCBandData();  //display next set, if existing	
	ValidateBandPage();
}

void CBioCBandPage::UpdateCurveListbox()
{
	if (m_cbandlist.GetCount()!=m_pBioData->m_bandno)
	{
		m_cbandlist.ResetContent();
		char crvbuf [10];
		for (int loop=1;loop <= m_pBioData->m_bandno;loop++)
		{
			itoa(loop,crvbuf,10);
			if (m_cbandlist.FindString (-1,crvbuf)==LB_ERR)  //if buf isnt there already.
			{
				m_cbandlist.AddString(crvbuf);
			}
		}
	}

	m_cbandlist.SetCurSel (max(0,m_curband-1));  // select current curve, zero based.
	
}

BOOL CBioCBandPage::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	WinHelp(Chest_Band_Occupant_Information);
	
	return TRUE;
}

//
bool CBioCBandPage::ValidateBandPage( void )
{
	bool bRetArray[11];
	bRetArray[0] = m_editantloc.GetValidate();
	bRetArray[1] = m_editchbcom.GetValidate();
	bRetArray[2] = m_editposloc.GetValidate();
	bRetArray[3] = m_editbanlen.GetValidate();
	bRetArray[4] = m_editchsbrd.GetValidate();

	bRetArray[5] = m_editchsdpt.GetValidate();
	bRetArray[6] = m_editgagstr.GetValidate();
	bRetArray[7] = m_editdisstr.GetValidate();
	bRetArray[8] = m_editdisspn.GetValidate();
	bRetArray[9] = m_edittotgag.GetValidate();

	bRetArray[10] = m_editgagspn.GetValidate();
	
	for(int i=0; i<11; i++) { if (!bRetArray[i]) return false; }
	return true;
}	// ValidateAnthPage

void CBioCBandPage::SetBusinessRules( void )
{
	m_editantloc.SetDouble( 0, 10 );	// type 1: set string
	m_editchbcom.SetString( 0, 70 );
	m_editposloc.SetDouble( 0, 10 );

	m_editbanlen.SetDouble( 0, 1800 );	// type 0: set number
	m_editchsbrd.SetDouble( 0, 999 );

	m_editchsdpt.SetDouble( 0, 999 );
	m_editgagstr.SetDouble( 0, 200 );
	m_editdisstr.SetDouble( 0, 99 );
	m_editdisspn.SetDouble( 0, 99 );
	m_edittotgag.SetDouble( 0, 1000 );

	m_editgagspn.SetDouble( 0, 200 );

}	// SetBusinessRules
