#if !defined(AFX_CBANDPAGE_H__815D5A65_6DA8_11D2_9495_0008C7AA9033__INCLUDED_)
#define AFX_CBANDPAGE_H__815D5A65_6DA8_11D2_9495_0008C7AA9033__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CBandPage.h : header file
//
#include "EditEx.h"
/////////////////////////////////////////////////////////////////////////////
// CBioCBandPage dialog

class CBioCBandPage : public CPropertyPage
{
	DECLARE_DYNCREATE(CBioCBandPage)

// Construction
public:
	CBioCBandPage();
	~CBioCBandPage();

	void	UpdateCurveListbox();
	void	InitializeNextCBand();
	void	DisplayBioCBandData();
	BOOL	LoadBioCBandData();

	bool	SetBoxColor( CNEdit& ctrlEdit, COLORREF clrText,
				COLORREF clrBackgroundError, COLORREF clrBackgroundCorrect );	
	bool	SetStringColor( CNEdit& ctrlEdit, COLORREF clrText,
				COLORREF clrBackgroundError, COLORREF clrBackgroundCorrect );
	void	SetNumber( CNEdit& ctrlEdit, const int nMin, const int nMax, bool bBlank=true);
	bool	InsertBioCBandData();
	bool	ValidateBandPage( void );
	void	SetBusinessRules( void );

	int			m_curband;
	CBioData*	m_pBioData;


// Dialog Data
	//{{AFX_DATA(CBioCBandPage)
	enum { IDD = IDD_BIOMECH_CBAND_PAGE };
	CListBox	m_cbandlist;
	CButton	m_nextsetbutton;
	CButton	m_deletebutton;

	CNEdit	m_editantloc;
	CNEdit	m_editchbcom;
	CNEdit	m_editposloc;
	BOOL	m_retaindata;
	CNEdit	m_editbanlen;
	CNEdit	m_editchsbrd;
	CNEdit	m_editchsdpt;
	CNEdit	m_editgagstr;
	CNEdit	m_editdisstr;
	CNEdit	m_editdisspn;
	CNEdit	m_edittotgag;
	CNEdit	m_editgagspn;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CBioCBandPage)
	public:
	virtual BOOL OnKillActive();
	virtual BOOL OnSetActive();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CBioCBandPage)
	virtual BOOL OnInitDialog();
	afx_msg void OnDeleteButton();
	afx_msg void OnNextsetButton();
	afx_msg void OnSelchangeCbandlist();
	afx_msg BOOL OnToolTipNotify(UINT, NMHDR *, LRESULT *);
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CBANDPAGE_H__815D5A65_6DA8_11D2_9495_0008C7AA9033__INCLUDED_)
