// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: BioData.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description:  BioData constructors and member functions to
//               process, import and export data.
//
//  Modification History:
//  Date		Who			Description
//	2000    Y. Wong Adding business rules, recode all edit boxs
//					and correct other errors.
// -----------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "BioData.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CBioData::CBioData()
{
	// Initialize BioData
	m_verno		= "B5";
	m_title		= "";
	m_tstobj	= "";
	m_tstdat	= "";
	m_tstprf	= "";
	m_conno		= "";
	m_tstref	= "";
	m_tstcfn	= "";
	m_temp		= "";
	m_rectyp	= "";
	m_link		= "";
	m_clsspd	= "";
	m_impang	= "";
	m_totcrv	= 0;
	m_occtyp	= ""; // "CD";
	m_tstcom	= "";
	//Dummy Occupant Info Data
	m_doccloc	= "";
	m_doccsex	= "";
	m_dseposn	= "";
	m_hic		= "";
	m_t1		= "";
	m_t2		= "";
	m_clip3m	= "";
	m_lfem		= "";
	m_rfem		= "";
	m_csi		= "";
	m_lbelt		= "";
	m_sbelt		= "";
	m_tti		= "";
	m_pelvg		= "";
	m_cti		= "";
	m_vc		= "";
	m_cmax		= "";
	m_nij		= "";
	m_mthcal	= "";
	m_dumsiz	= "";
	m_dumman	= "";
	m_dummod	= "";
	m_dumdsc	= "";
	m_dcompwt	= "";
	m_doccom	= "";
	//Bio Specimen Occupant Info Data
	m_boccloc	= "";
	m_boccsex	= ""; 
	m_bseposn	= "";
	m_occage	= "";
	m_occwt		= "";
	m_frctrb	= "";
	m_rbfrct	= "";
	m_occref	= "";
	m_notest	= "";
	m_dtedth	= "";
	m_csedth	= "";
	m_cadapp	= "";
	m_bedcon	= "";
	m_cadan		= "";
	m_aorpre	= "";
	m_cerpre	= "";
	m_pulpre	= "";
	m_boccom	= "";
	m_bmc		= "";
	m_bmcloc	= "";
	m_bmcunits	= "";
	m_bmcmethod = "";
	m_bcompwt	= "";
	m_bmccom	= "";
	//Bio Anthropometric Info Data
	m_statur	= "";
	m_shldht	= "";
	m_vrtsym	= "";
	m_wastht	= "";
	m_shldbd	= "";
	m_chstbd	= "";
	m_wastbd	= "";
	m_hipbd		= "";
	m_shldel	= "";
	m_farmhd	= "";
	m_tiblht	= "";
	m_anklht	= "";
	m_footbd	= "";
	m_footln	= "";
	m_hdtroc	= "";
	m_seatht	= "";
	m_kneeht	= "";
	m_headln	= "";
	m_headbd	= "";
	m_headch	= "";
	m_bicpcr	= "";
	m_elbwcr	= "";
	m_farmcr	= "";
	m_wrstcr	= "";
	m_thghcr	= "";
	m_ltghcr	= "";
	m_kneecr	= "";
	m_calfcr	= "";
	m_anklcr	= "";
	m_neckcr	= "";
	m_scyecr	= "";
	m_chstcr	= "";
	m_wastcr	= "";
	m_buttcr	= "";
	m_chstdp	= "";
	m_wastdp	= "";
	m_buttdp	= "";
	m_inscye	= "";
    //Bio Rib Info Data
	m_ribno = 0;
	m_ribloc.SetAtGrow(0,""); m_ribloc.SetAtGrow(1,"");
	m_ribin.SetAtGrow(0,""); m_ribin.SetAtGrow(1,"");
	m_nadis.SetAtGrow(0,""); m_nadis.SetAtGrow(1,"");
	m_splen.SetAtGrow(0,""); m_splen.SetAtGrow(1,"");
	m_defl.SetAtGrow(0,""); m_defl.SetAtGrow(1,"");
	m_load.SetAtGrow(0,""); m_load.SetAtGrow(1,"");
	m_brkld.SetAtGrow(0,""); m_brkld.SetAtGrow(1,"");
	m_armar.SetAtGrow(0,""); m_armar.SetAtGrow(1,"");
	m_rarea.SetAtGrow(0,""); m_rarea.SetAtGrow(1,"");
	//Bio Occupant Injury Information
	m_injno = 0;
	m_bodyrg.SetAtGrow(0,""); m_bodyrg.SetAtGrow(1,"");
	m_aspect.SetAtGrow(0,""); m_aspect.SetAtGrow(1,"");
	m_lesion.SetAtGrow(0,""); m_lesion.SetAtGrow(1,"");
	m_sysorg.SetAtGrow(0,""); m_sysorg.SetAtGrow(1,"");
	m_ais.SetAtGrow(0,""); m_ais.SetAtGrow(1,"");
	m_ais90.SetAtGrow(0,""); m_ais90.SetAtGrow(1,"");
	m_injcom.SetAtGrow(0,""); m_injcom.SetAtGrow(1,"");
	//Bio Occupant Restraints Information
	m_rstno = 0;
	m_rsttyp.SetAtGrow(0,""); m_rsttyp.SetAtGrow(1,"");
	m_rstmnt.SetAtGrow(0,""); m_rstmnt.SetAtGrow(1,"");
	m_deploy.SetAtGrow(0,""); m_deploy.SetAtGrow(1,"");
	m_rstcom.SetAtGrow(0,""); m_rstcom.SetAtGrow(1,"");
	//Bio ChestBand Occupant Information
	m_bandno = 0;
	m_chsdpt.SetAtGrow(0,""); m_chsdpt.SetAtGrow(1,"");
	m_chsbrd.SetAtGrow(0,""); m_chsbrd.SetAtGrow(1,"");
	m_banlen.SetAtGrow(0,""); m_banlen.SetAtGrow(1,"");
	m_antloc.SetAtGrow(0,""); m_antloc.SetAtGrow(1,"");
	m_posloc.SetAtGrow(0,""); m_posloc.SetAtGrow(1,"");
	m_gagstr.SetAtGrow(0,""); m_gagstr.SetAtGrow(1,"");
	m_disstr.SetAtGrow(0,""); m_disstr.SetAtGrow(1,"");
	m_gagspn.SetAtGrow(0,""); m_gagspn.SetAtGrow(1,"");
	m_disspn.SetAtGrow(0,""); m_disspn.SetAtGrow(1,"");
	m_totgag.SetAtGrow(0,""); m_totgag.SetAtGrow(1,"");
	m_chbcom.SetAtGrow(0,""); m_chbcom.SetAtGrow(1,"");
	//Bio Chest Band Gauge Information
	m_gaugesets = 0;
	m_Gauge_bandno.SetAtGrow(0,""); m_Gauge_bandno.SetAtGrow(1,"");
	m_gageno.SetAtGrow(0,""); m_gageno.SetAtGrow(1,"");
	m_gagdis.SetAtGrow(0,""); m_gagdis.SetAtGrow(1,"");
	m_Gauge_curno.SetAtGrow(0,""); m_Gauge_curno.SetAtGrow(1,"");
	m_gagcom.SetAtGrow(0,""); m_gagcom.SetAtGrow(1,"");
	//Bio Instrumentation Information
	m_curno = 0;
	m_sentyp.SetAtGrow(0,"");	m_sentyp.SetAtGrow(1,"");
	m_senloc.SetAtGrow(0,"");	m_senloc.SetAtGrow(1,"");
	m_senatt.SetAtGrow(0,"");	m_senatt.SetAtGrow(1,"");
	m_axis.SetAtGrow(0,"");		m_axis.SetAtGrow(1,"");
	m_xunits.SetAtGrow(0,"SEC"); m_xunits.SetAtGrow(1,"SEC");
	m_yunits.SetAtGrow(0,"");	m_yunits.SetAtGrow(1,"");
	m_prefil.SetAtGrow(0,"");	m_prefil.SetAtGrow(1,"");
	m_insman.SetAtGrow(0,"");	m_insman.SetAtGrow(1,"");
	m_caldat.SetAtGrow(0,"");	m_caldat.SetAtGrow(1,"");
	m_insrat.SetAtGrow(0,"");	m_insrat.SetAtGrow(1,"");
	m_chlmax.SetAtGrow(0,"");	m_chlmax.SetAtGrow(1,"");
	m_inivel.SetAtGrow(0,"");	m_inivel.SetAtGrow(1,"");
	m_nfp.SetAtGrow(0,"");		m_nfp.SetAtGrow(1,"");
	m_nlp.SetAtGrow(0,"");		m_nlp.SetAtGrow(1,"");
	m_delt.SetAtGrow(0,"");		m_delt.SetAtGrow(1,"");
	m_dastat.SetAtGrow(0,"AM"); m_dastat.SetAtGrow(1,"AM");
	m_chstat.SetAtGrow(0,"P");	m_chstat.SetAtGrow(1,"P");
	m_inscom.SetAtGrow(0,"");	m_inscom.SetAtGrow(1,"");

}	// CBioData::CBioData()

CBioData::~CBioData()
{

}

bool CBioData::ValidateTestData()
{
	if ( (m_verno == "B5") && (m_title == "") && (m_tstobj == "") && (m_tstdat == "") && 
		 (m_tstprf == "") && (m_conno	 == "") && (m_tstref == "") && (m_tstcfn == "") && 
		 (m_temp == "") && (m_rectyp == "") && (m_link == "") && (m_clsspd == "") && (m_impang == "") && 
		 (m_totcrv == 0) && ((m_occtyp == "CD")||(m_occtyp == "")) && (m_tstcom == "") ) { return false; }

	return true;
}	// ValidateTestdata

// validate Dummy occupant data
bool CBioData::ValidateDoccData()
{
	//Dummy Occupant Info Data
	if ( (m_doccloc == "") && (m_doccsex == "") && (m_dseposn == "") && (m_hic == "") &&
		 (m_t1 == "") && (m_t2 == "") && (m_clip3m == "") && (m_lfem == "") && (m_rfem == "") &&
		 (m_csi == "") && (m_lbelt == "") && (m_sbelt == "") && (m_tti == "") && (m_pelvg == "") &&
		 (m_cti == "") && (m_vc == "") && (m_cmax == "") && (m_nij == "") && (m_mthcal == "") &&
		 (m_dumsiz == "") && (m_dumman == "") && (m_dummod == "") && (m_dumdsc == "") &&
		 (m_dcompwt == "") && (m_doccom == "") ) { return false; }
	else if ( (m_occtyp == "AN") || (m_occtyp == "CD") || (m_occtyp == "HU") || (m_occtyp == "") ) { return false; }

	return true;
	
}	// ValidateDoccData

// validate Specimen Occupant Info Data
bool CBioData::ValidateSoccData()
{
	if ( (m_boccloc	== "") && (m_boccsex== "") && (m_bseposn== "") && (m_occage	== "") &&
	     (m_occwt	== "") && (m_frctrb	== "") && (m_rbfrct	== "") && (m_occref	== "") &&
		 (m_notest	== "") && (m_dtedth	== "") && (m_csedth	== "") && (m_cadapp	== "") &&
		 (m_bedcon	== "") && (m_cadan	== "") && (m_aorpre	== "") && (m_cerpre	== "") &&
		 (m_pulpre	== "") && (m_boccom	== "") && (m_bmc	== "") && (m_bmcloc	== "") &&
		 (m_bmcunits== "") && (m_bmcmethod == "") && (m_bcompwt	== "") && (m_bmccom	== "") )
		 { return false; }
	else if ( (m_occtyp=="") || ( (m_occtyp!="AN")&&(m_occtyp!="CD")&&(m_occtyp != "HU") ) ){ return false; }

	return true;
}	// ValidateSoccData

// validate Anthropometric Info Data
bool CBioData::ValidateAnthData()
{
	if ( (m_statur	== "") && (m_shldht	== "") && (m_vrtsym	== "") && (m_wastht	== "") &&
		 (m_shldbd	== "") && (m_chstbd	== "") && (m_wastbd	== "") && (m_hipbd	== "") &&
		 (m_shldel	== "") && (m_farmhd	== "") && (m_tiblht	== "") && (m_anklht	== "") &&
		 (m_footbd	== "") && (m_footln	== "") && (m_hdtroc	== "") && (m_seatht	== "") &&
		 (m_kneeht	== "") && (m_headln	== "") && (m_headbd	== "") && (m_headch	== "") &&
		 (m_bicpcr	== "") && (m_elbwcr	== "") && (m_farmcr	== "") && (m_wrstcr	== "") &&
		 (m_thghcr	== "") && (m_ltghcr	== "") && (m_kneecr	== "") && (m_calfcr	== "") &&
		 (m_anklcr	== "") && (m_neckcr	== "") && (m_scyecr	== "") && (m_chstcr	== "") &&
		 (m_wastcr	== "") && (m_buttcr	== "") && (m_chstdp	== "") && (m_wastdp	== "") &&
		 (m_buttdp	== "") && (m_inscye	== "") )
		{ return false; }

	return true;
} // ValidateAnthData

// validate Rib Info Data
bool CBioData::ValidateRibData()
{
	if (m_ribno > 0) { return true; }
	return false;

}	// ValidateRibData

// validate Occupant Injury Information
bool CBioData::ValidateInjData()
{
	if (m_injno > 0) { return true; }
	return false;
}	// ValidateInjData

// validate Occupant Restraints Information
bool CBioData::ValidateRestData()
{
	if (m_rstno > 0) { return true; }
	return false;
}	// ValidateRestData

// validate ChestBand Occupant Information
bool CBioData::ValidateBandData()
{
	if (m_bandno > 0) { return true; }
	return false;
} // ValidateBandData

// validate Chest Band Gauge Information
bool CBioData::ValidateGageData()
{
	if (m_gaugesets > 0) { return true; }
	return false;
} // ValidateGageData

// validate Instrumentation Information
bool CBioData::ValidateInstData()
{
	if (m_curno > 0) { return true; }
	return false;
}	// ValidateInstData

//******************
// ExportEV5 
// This function creates a .ev5 file and writes the data in BioData out to it. 
// *****************
BOOL CBioData::ExportEV5(CString & strfile_out)
{
    CStdioFile myFile;
	CFileException fileException;

	
	myFile.Open( strfile_out, CFile::modeCreate | CFile::modeReadWrite | CFile::typeText,
		&fileException );
	if (!myFile.m_pStream)  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_out, fileException.m_cause );
		MessageBox(NULL,msg,"Error",MB_OK);
		return FALSE;
	}
	
	CTime now = CTime::GetCurrentTime ();
	myFile.WriteString ("# Source: Entree for Windows v5\n");
	CString strToday;
	strToday.Format("# Date: <%d/%d/%d>\n", now.GetMonth(), now.GetDay(), now.GetYear() );
	myFile.WriteString (strToday);
	myFile.WriteString ("----- EV5 -----\n");
	
	// The order of the Write... calls should not be changed unless the ev5 file spec. changes
	WriteBioTest (myFile);
	WriteBioDum (myFile);
	WriteBioOcc (myFile);
	WriteBioRest (myFile);
	WriteBioAnth (myFile);
	WriteBioRib (myFile);
	WriteBioInj (myFile);
	WriteBioInst (myFile);
	WriteBioCBand (myFile);
	WriteBioGauge (myFile);
	
	myFile.WriteString ("----- END -----\n");

	myFile.Close ();
	
	return TRUE;
}	// ExportEV5

// Writes data out to the file.  The order IS important and shouldn't be changed
// unless the ev5 file spec changes.
void CBioData::WriteBioAnth(CStdioFile & myFile)
{
	if (!ValidateAnthData()) { return; }

	myFile.WriteString("----- ANTHROPOMETRY -----\n");
	
	myFile.WriteString (OutString(m_statur));
	myFile.WriteString (OutString(m_shldht));
	myFile.WriteString (OutString(m_vrtsym));
	myFile.WriteString (OutString(m_wastht));
	
	myFile.WriteString (OutString(m_shldbd));
	myFile.WriteString (OutString(m_chstbd));
	myFile.WriteString (OutString(m_wastbd));
	myFile.WriteString (OutString(m_hipbd));
	myFile.WriteString (OutString(m_shldel));	// 10
	
	myFile.WriteString (OutString(m_farmhd));
	myFile.WriteString (OutString(m_tiblht));
	myFile.WriteString (OutString(m_anklht));
	myFile.WriteString (OutString(m_footbd));
	myFile.WriteString (OutString(m_footln));
	
	myFile.WriteString (OutString(m_hdtroc));
	myFile.WriteString (OutString(m_seatht));
	myFile.WriteString (OutString(m_kneeht));
	myFile.WriteString (OutString(m_headln));
	myFile.WriteString (OutString(m_headbd));	// 20
	
	myFile.WriteString (OutString(m_headch));
	myFile.WriteString (OutString(m_bicpcr));
	myFile.WriteString (OutString(m_elbwcr));
	myFile.WriteString (OutString(m_farmcr));
	myFile.WriteString (OutString(m_wrstcr));
	
	myFile.WriteString (OutString(m_thghcr));
	myFile.WriteString (OutString(m_ltghcr));
	myFile.WriteString (OutString(m_kneecr));
	myFile.WriteString (OutString(m_calfcr));
	myFile.WriteString (OutString(m_anklcr));	// 30
	
	myFile.WriteString (OutString(m_neckcr));
	myFile.WriteString (OutString(m_scyecr));
	myFile.WriteString (OutString(m_chstcr));
	myFile.WriteString (OutString(m_wastcr));
	myFile.WriteString (OutString(m_buttcr));	//35
	
	myFile.WriteString (OutString(m_chstdp));
	myFile.WriteString (OutString(m_wastdp));
	myFile.WriteString (OutString(m_buttdp));
	myFile.WriteString (m_inscye + '\n'); 	
}	// WriteBioAnth

// Writes data out to the file.  The order IS important and shouldn't be changed
// unless the ev5 file spec changes.
void CBioData::WriteBioCBand(CStdioFile & myFile)
{
	if (!ValidateBandData()) { return; }

	myFile.WriteString("----- CHEST BAND -----\n");

	for ( int loop=1; loop<=m_bandno; loop++)  
	{
		myFile.WriteString(OutString(loop));
		myFile.WriteString(OutString(m_chsdpt[loop]));
		myFile.WriteString(OutString(m_chsbrd[loop]));
		myFile.WriteString(OutString(m_banlen[loop]));

		myFile.WriteString(OutString(m_antloc[loop]));
		myFile.WriteString(OutString(m_posloc[loop]));
		myFile.WriteString(OutString(m_gagstr[loop]));
		myFile.WriteString(OutString(m_disstr[loop]));
		myFile.WriteString(OutString(m_gagspn[loop]));

		myFile.WriteString(OutString(m_disspn[loop]));
		myFile.WriteString(OutString(m_totgag[loop]));
		myFile.WriteString(m_chbcom[loop] + '\n');	
	}
}	// WriteBioCBand

// Writes data out to the file.  The order IS important and shouldn't be changed
// unless the ev5 file spec changes.
void CBioData::WriteBioDum(CStdioFile & myFile)
{
	if (!ValidateDoccData()) { return; }

	myFile.WriteString("----- DUMMY OCCUPANT -----\n");
	
	myFile.WriteString(OutString(m_doccloc));
	//myFile.WriteString(OutString(m_occtyp));
	myFile.WriteString(OutString(m_doccsex));
	myFile.WriteString(OutString(m_dseposn));
	
	myFile.WriteString(OutString(m_hic));
	myFile.WriteString(OutString(m_t1));
	myFile.WriteString(OutString(m_t2));
	myFile.WriteString(OutString(m_clip3m));
	myFile.WriteString(OutString(m_lfem));
	
	myFile.WriteString(OutString(m_rfem));
	myFile.WriteString(OutString(m_csi));
	myFile.WriteString(OutString(m_lbelt));
	myFile.WriteString(OutString(m_sbelt));
	myFile.WriteString(OutString(m_tti));
	
	myFile.WriteString(OutString(m_pelvg));

	myFile.WriteString(OutString(m_cti));
	myFile.WriteString(OutString(m_vc));
	myFile.WriteString(OutString(m_cmax));
	myFile.WriteString(OutString(m_nij));

	myFile.WriteString(OutString(m_mthcal));
	myFile.WriteString(OutString(m_dumsiz));
	myFile.WriteString(OutString(m_dumman));
	myFile.WriteString(OutString(m_dummod));
	
	myFile.WriteString(OutString(m_dumdsc));
	myFile.WriteString(OutString(m_dcompwt));
	myFile.WriteString(m_doccom	+ '\n');	
}	// WriteBioDum

// Writes data out to the file.  The order IS important and shouldn't be changed
// unless the ev5 file spec changes.
void CBioData::WriteBioGauge(CStdioFile & myFile)
{
	if (!ValidateGageData()) { return; }
	myFile.WriteString("----- CHEST BAND GAUGE -----\n");

	for ( int loop=1; loop<=m_gaugesets; loop++)  
	{

		myFile.WriteString(OutString(m_Gauge_bandno[loop]));
		myFile.WriteString(OutString(m_gageno[loop]));
		myFile.WriteString(OutString(m_gagdis[loop]));
		myFile.WriteString(OutString(m_Gauge_curno[loop]));

		myFile.WriteString(m_gagcom[loop] + '\n');	
	}

}

// Writes data out to the file.  The order IS important and shouldn't be changed
// unless the ev5 file spec changes.
void CBioData::WriteBioInj(CStdioFile & myFile)
{
	if (!ValidateInjData()) { return; }

	myFile.WriteString("----- OCCUPANT INJURY -----\n");

	for ( int loop=1; loop<=m_injno; loop++)  
	{
		myFile.WriteString (OutString(loop));
		myFile.WriteString (OutString(m_bodyrg[loop]));
		myFile.WriteString (OutString(m_aspect[loop]));
		myFile.WriteString (OutString(m_lesion[loop]));

		myFile.WriteString (OutString(m_sysorg[loop]));
		myFile.WriteString (OutString(m_ais[loop]));
		myFile.WriteString (OutString(m_ais90[loop]));//,1));
		myFile.WriteString (m_injcom[loop] + '\n');	
	}
}

// Writes data out to the file.  The order IS important and shouldn't be changed
// unless the ev5 file spec changes.
void CBioData::WriteBioInst(CStdioFile & myFile)
{
	if (!ValidateInstData()) { return; }

	myFile.WriteString("----- INSTRUMENTATION -----\n");

	for ( int loop=1; loop<=m_curno; loop++)  
	{
		myFile.WriteString (OutString(loop));
		myFile.WriteString (OutString(m_sentyp[loop]));
		myFile.WriteString (OutString(m_senloc[loop]));
		myFile.WriteString (OutString(m_senatt[loop]));

		myFile.WriteString (OutString(m_axis[loop]));
		myFile.WriteString (OutString(m_xunits[loop]));
		myFile.WriteString (OutString(m_yunits[loop]));
		myFile.WriteString (OutString(m_prefil[loop]));
		myFile.WriteString (OutString(m_insman[loop]));
		myFile.WriteString (OutString(m_caldat[loop]));	//10 

		myFile.WriteString (OutString(m_insrat[loop]));
		myFile.WriteString (OutString(m_chlmax[loop]));
		myFile.WriteString (OutString(m_inivel[loop]));
		myFile.WriteString (OutString(m_nfp[loop]));
		myFile.WriteString (OutString(m_nlp[loop]));

		myFile.WriteString (OutString(m_delt[loop]));
		myFile.WriteString (OutString(m_dastat[loop]));
		myFile.WriteString (OutString(m_chstat[loop]));
		myFile.WriteString (m_inscom[loop] + '\n');	
	}
}	// WriteBioInst

// Writes data out to the file.  The order IS important and shouldn't be changed
// unless the ev5 file spec changes.
void CBioData::WriteBioTest(CStdioFile & myFile)
{
	if (!ValidateTestData()) { return; }

	myFile.WriteString("----- TEST -----\n");					

	myFile.WriteString(OutString("B5")); // myFile.WriteString(OutString(m_verno));
	myFile.WriteString(OutString(m_title));	
	myFile.WriteString(OutString(m_tstobj));
	m_tstdat.MakeUpper();
	myFile.WriteString(OutString(m_tstdat));

	myFile.WriteString(OutString(m_tstprf));	
	myFile.WriteString(OutString(m_conno));	
	myFile.WriteString(OutString(m_tstref));		
	myFile.WriteString(OutString(m_tstcfn));
	myFile.WriteString(OutString(m_temp));		// 10

	myFile.WriteString(OutString(m_rectyp));
	myFile.WriteString(OutString(m_link));	
	myFile.WriteString(OutString(m_clsspd));	
	myFile.WriteString(OutString(m_impang));
	myFile.WriteString(OutString(m_totcrv));
	myFile.WriteString(OutString(m_occtyp));
			
	myFile.WriteString(m_tstcom + '\n');	
}

// Writes data out to the file.  The order IS important and shouldn't be changed
// unless the ev5 file spec changes.
void CBioData::WriteBioOcc(CStdioFile & myFile)
{
	if (!ValidateSoccData()) { return; }

	myFile.WriteString("----- BIO OCCUPANT -----\n");
	
	myFile.WriteString(OutString(m_boccloc));
	myFile.WriteString(OutString(m_boccsex));
	myFile.WriteString(OutString(m_bseposn));
	myFile.WriteString(OutString(m_occage));
	myFile.WriteString(OutString(m_occwt));

	myFile.WriteString(OutString(m_bcompwt));
	myFile.WriteString(OutString(m_frctrb));
	myFile.WriteString(OutString(m_rbfrct));
	myFile.WriteString(OutString(m_occref));
	myFile.WriteString(OutString(m_notest));

	myFile.WriteString(OutString(m_dtedth));
	myFile.WriteString(OutString(m_csedth));
	myFile.WriteString(OutString(m_cadapp));
	myFile.WriteString(OutString(m_bedcon));
	myFile.WriteString(OutString(m_cadan));

	myFile.WriteString(OutString(m_aorpre));
	myFile.WriteString(OutString(m_cerpre));
	myFile.WriteString(OutString(m_pulpre));
	myFile.WriteString(OutString(m_bmc));
	myFile.WriteString(OutString(m_bmcloc));

	myFile.WriteString(OutString(m_bmcunits));
	myFile.WriteString(OutString(m_bmcmethod));	
	myFile.WriteString(OutString(m_bmccom));
	myFile.WriteString (m_boccom + '\n');	

}

// Writes data out to the file.  The order IS important and shouldn't be changed
// unless the ev5 file spec changes.
void CBioData::WriteBioRest(CStdioFile & myFile)
{
	if (!ValidateRestData()) { return; }

	myFile.WriteString ("----- RESTRAINT -----\n");

	for ( int loop=1; loop<=m_rstno; loop++)  
	{
		myFile.WriteString (OutString(loop));
		myFile.WriteString (OutString(m_rsttyp[loop]));
		myFile.WriteString (OutString(m_rstmnt[loop]));
		myFile.WriteString (OutString(m_deploy[loop]));
		myFile.WriteString (m_rstcom[loop] + '\n')	;
	}
}

// Writes data out to the file.  The order IS important and shouldn't be changed
// unless the ev5 file spec changes.
void CBioData::WriteBioRib(CStdioFile & myFile)
{
	if (!ValidateRibData()) { return; }

	myFile.WriteString ("----- RIB -----\n");
	for (int loop=1; loop<=m_ribno; loop++)
	{
		myFile.WriteString (OutString(loop));
		myFile.WriteString (OutString(m_ribloc[loop]));
		myFile.WriteString (OutString(m_ribin[loop]));
		myFile.WriteString (OutString(m_nadis[loop]));
		myFile.WriteString (OutString(m_splen[loop])) ;
		myFile.WriteString (OutString(m_defl[loop])) ;
		myFile.WriteString (OutString(m_load[loop])) ;
		myFile.WriteString (OutString(m_brkld[loop]));
		myFile.WriteString (OutString(m_armar[loop])) ;
		myFile.WriteString (m_rarea[loop]); //Last String in BioRib, dont use OutString to
		//append |, instead append \n.
		myFile.WriteString ("\n");
	}	
}	// WriteBioRib

// format a string to be outputted to a ev5 file.
CString CBioData::OutString(CString str)
{
	if (str=="")
	{
		str=" |";
	}
	else
	{
		str+= "|";
	}
	
	return str;
}

// overloaded OutString.
// format a string to be outputted to a ev5 file.
CString CBioData::OutString(int nStr)
{
	char temp [100];
	itoa(nStr,temp,10);
	CString str = temp;
	if (str=="")
	{
		str=" |";
	}
	else
	{
		str+= "|";
	}
	
	return str;
}

// overloaded OutString.
// format a string to be outputted to a ev5 file.
CString CBioData::OutString(DWORD dwStr)
{
	char temp [100];
	itoa(dwStr,temp,10);
	CString str = temp;
	if (str=="")
	{
		str=" |";
	}
	else
	{
		str+= "|";
	}
	
	return str;
}

// overloaded OutString.
// format a string to be outputted to a ev5 file.
CString CBioData::OutString(double dblStr, short precision)
{
	char temp [100];
	
	switch (precision)
	{
	case 1:
		{
			sprintf(temp, "%.1f", dblStr);
			break;
		}
	case 2:
	default:
		{
			sprintf(temp,"%.2f",dblStr);
			break;
		}
	}
	
	CString str = temp;
	if (str=="")
	{
		str=" |";
	}
	else
	{
		str+= "|";
	}
	
	return str;
}	// 

// **************************
// Create a Report (.evr) from the current BioData
//
// **************************
BOOL CBioData::ExportEVR(CString & strfile_out)
{
	CStdioFile myFile;
	CFileException fileException;

	myFile.Open( strfile_out, CFile::modeCreate | CFile::modeReadWrite | CFile::typeText,
		&fileException );
	if (!myFile.m_pStream)  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_out, fileException.m_cause );
		MessageBox(NULL,msg,"Error",MB_OK);
		return FALSE;
	}
	
	CTime now = CTime::GetCurrentTime ();
	myFile.WriteString ("# Source: Entree for Windows v5\n");
	CString strToday;
	strToday.Format("# Date: <%d/%d/%d>\n", now.GetMonth(), now.GetDay(), now.GetYear() );
	myFile.WriteString (strToday);
	myFile.WriteString ("----- EV5 REPORT FILE -----\n");

	WriteBioMechTestReport (myFile);
	WriteBioDumReport (myFile);
	WriteBioOccReport (myFile);
	WriteBioRibReport (myFile);
	WriteBioRestReport (myFile);

	WriteBioAnthReport (myFile);	
	WriteBioInjReport (myFile);
	WriteBioInstReport (myFile);	
	WriteBioCBandReport (myFile);	
	WriteBioGaugeReport (myFile);
	

	myFile.WriteString ("----- END -----\n");

	myFile.Close ();

	return TRUE;
}

/******************************************************************************
	Name:		WriteBioAnthReport
	Action:		Write the BioAnth part of a report (.evr) file
	Params:		CStdioFile & myFile
	Returns:	void
	Notes:	
	Dates:		Modify - Al Wilhelm - 3/6/2000
******************************************************************************/
void CBioData::WriteBioAnthReport( CStdioFile & myFile )
{
	if (!ValidateAnthData()) { return; }

	myFile.WriteString("----- ANTHROPOMETRY -----\n");

	myFile.WriteString ("Stature:	" + m_statur + "\n");
	myFile.WriteString ("Shoulder Height:	" + m_shldht + "\n");
	myFile.WriteString ("Vertex to Symphysion:	" + m_vrtsym + "\n");
	myFile.WriteString ("Waist Height:	" + m_wastht + "\n");
	myFile.WriteString ("Shoulder Breadth:	" + m_shldbd + "\n");	
	myFile.WriteString ("Chest Breadth:	" + m_chstbd + "\n");
	myFile.WriteString ("Waist Breadth:	" + m_wastbd + "\n");
	myFile.WriteString ("Hip Breadth:	" + m_hipbd + "\n");
	myFile.WriteString ("Shoulder to Elbow:	" + m_shldel + "\n");
	myFile.WriteString ("Forearm - Hand Length:	" + m_farmhd + "\n");
	myFile.WriteString ("Tibiale Height:	" + m_tiblht + "\n");
	myFile.WriteString ("Ankle Height:	" + m_anklht + "\n");
	myFile.WriteString ("Foot Breadth:	" + m_footbd + "\n");
	myFile.WriteString ("Foot Length:	" + m_footln + "\n");
	myFile.WriteString ("Head to Trochanterion Distance:	" + m_hdtroc + "\n");
	myFile.WriteString ("Seated Height:	" + m_seatht + "\n");
	myFile.WriteString ("Knee Height, Seated:	" + m_kneeht + "\n");
	myFile.WriteString ("Head Length:	" + m_headln + "\n");
	myFile.WriteString ("Head Breadth:	" + m_headbd + "\n");
	myFile.WriteString ("Head Height:	" + m_headch + "\n");
	myFile.WriteString ("Bicep Circumference:	" + m_bicpcr + "\n");
	myFile.WriteString ("Elbow Circumference:	" + m_elbwcr + "\n");
	myFile.WriteString ("Forearm Circumference:	" + m_farmcr + "\n");
	myFile.WriteString ("Wrist Circumference:	" + m_wrstcr + "\n");
	myFile.WriteString ("Thigh Circumference:	" + m_thghcr + "\n");	
	myFile.WriteString ("Lower Thigh Circumference:	" + m_ltghcr + "\n");
	myFile.WriteString ("Knee Circumference:	" + m_kneecr + "\n");
	myFile.WriteString ("Calf Circumference:	" + m_calfcr + "\n");
	myFile.WriteString ("Ankle Circumference:	" + m_anklcr + "\n");
	myFile.WriteString ("Neck Circumference:	" + m_neckcr + "\n");
	myFile.WriteString ("Scye Circumference:	" + m_scyecr + "\n");
	myFile.WriteString ("Chest Circumference:	" + m_chstcr + "\n");
	myFile.WriteString ("Waist Circumference:	" + m_wastcr + "\n");
	myFile.WriteString ("Buttock Circumference:	" + m_buttcr + "\n");
	myFile.WriteString ("Chest Depth:	" + m_chstdp + "\n");
	myFile.WriteString ("Waist Depth:	" + m_wastdp + "\n");
	myFile.WriteString ("Buttock Depth:	" + m_buttdp + "\n");
	myFile.WriteString ("Interscye Distance:	" + m_inscye + "\n"); 
}

//Write the BioCBand part of a report (.evr) file
void CBioData::WriteBioCBandReport(CStdioFile & myFile)
{
	if (!ValidateBandData()) { return; }

	myFile.WriteString("----- CHEST BAND -----\n");

	for ( int loop=1; loop<=m_bandno; loop++)  
	{
		if (m_bandno>1)
		{
			char temp [100];
			CString strTemp;
			itoa (loop,temp,10);
			strTemp=temp;
			myFile.WriteString ("Record "+strTemp+":\n");
		}

		myFile.WriteString("Chest Depth:	" + m_chsdpt[loop] + "\n");
		myFile.WriteString("Chest Breadth:	" + m_chsbrd[loop] + "\n");
		myFile.WriteString("Band Length:	" + m_banlen[loop] + "\n");		
		myFile.WriteString("Anterior Vertical Location:	"+m_antloc[loop]+"\n");
		myFile.WriteString("Posterior Vertical Location:	"+m_posloc[loop]+"\n");

		myFile.WriteString("Curve Number, Gauge Relative to Sternum:	" + m_gagstr[loop] + "\n");
		myFile.WriteString("Distance Referenced to the Sternum:	" + m_disstr[loop] + "\n");
		myFile.WriteString("Curve Number, Gauge Relative to Spine:	" + m_gagspn[loop] + "\n");
		myFile.WriteString("Distance Referenced to the Spine:	" + m_disspn[loop] + "\n");
		myFile.WriteString("Total Number of Gauges:	" + m_totgag[loop] + "\n");
		
		myFile.WriteString("Chest Band Comments:	"+m_chbcom[loop] + "\n");	
		
	}
}

//Write the BioDum part of a report (.evr) file
void CBioData::WriteBioDumReport(CStdioFile & myFile)
{
	if (!ValidateDoccData()) { return; }

	myFile.WriteString("----- DUMMY OCCUPANT -----\n");

	myFile.WriteString("Occupant Location:	"+m_doccloc+"\n");
	myFile.WriteString("Occupant Sex:	"+m_doccsex+"\n");
	myFile.WriteString("Seat Position:	"+m_dseposn+"\n");
	myFile.WriteString("Head Injury Criterion:	" + m_hic + "\n");
	myFile.WriteString("Lower Boundary of HIC Time Interval:	" + m_t1 + "\n");

	myFile.WriteString("Upper Boundary of HIC Time Interval:	" + m_t2 + "\n");
	myFile.WriteString("Thorax Region Peak Acceleration:	" + m_clip3m + "\n");
	myFile.WriteString("Left Femur Peak Load:	" + m_lfem + "\n");	// 10
	myFile.WriteString("Right Femur Peak Load:	" + m_rfem + "\n");
	myFile.WriteString("Chest Severity Index:	" + m_csi + "\n");

	myFile.WriteString("Lap Belt Peak Load:	" + m_lbelt + "\n");
	myFile.WriteString("Shoulder Belt Peak Load:	" + m_sbelt + "\n");
	myFile.WriteString("Thoracic Trauma Index:	" + m_tti + "\n");
	myFile.WriteString("Pelvic G's:	" + m_pelvg + "\n");
	myFile.WriteString("Combined Thoracic Criterion:	" + m_cti + "\n");
	
	myFile.WriteString("Viscous Criterion:	" + m_vc + "\n");
	myFile.WriteString("Chest Deflection:	" + m_cmax + "\n");
	myFile.WriteString("Neck Injury Criterion:	" + m_nij + "\n");
	myFile.WriteString("Calibration Method:	"+m_mthcal+"\n");
	myFile.WriteString("Dummy Size:	"+m_dumsiz+"\n");

	myFile.WriteString("Dummy Manufacturer:	"+m_dumman+"\n");
	myFile.WriteString("Dummy Modification:	"+m_dummod+"\n");
	myFile.WriteString("Dummy Description:	"+m_dumdsc+"\n");
	myFile.WriteString("Component Weight:	" + m_dcompwt + "\n");
	myFile.WriteString("Occupant Comments:	"+m_doccom	+ "\n");	

}

//Write the BioGauge part of a report (.evr) file
void CBioData::WriteBioGaugeReport(CStdioFile & myFile)
{
	if (!ValidateGageData()) { return; }
	myFile.WriteString("----- CHEST BAND GAUGE -----\n");

	for ( int loop=1; loop<=m_gaugesets; loop++)  
	{
		if (m_gaugesets>1)
		{
			char temp [100];
			CString strTemp;
			itoa (loop,temp,10);
			strTemp=temp;
			myFile.WriteString ("Record "+strTemp+":\n");
		}

		myFile.WriteString("Chest Band Number:	" + m_Gauge_bandno[loop] + "\n");
		myFile.WriteString("Gauge Number:	" + m_gageno[loop] + "\n");
		myFile.WriteString("Gauge Distance:	" + m_gagdis[loop] + "\n");
		myFile.WriteString("Curve Number of Specific Gauge:	" + m_Gauge_curno[loop] + "\n");
		myFile.WriteString("Gauge Comments:	" + m_gagcom[loop] + "\n");			
	}
}

//Write the Bioinj part of a report (.evr) file
void CBioData::WriteBioInjReport(CStdioFile & myFile)
{
	if (!ValidateInjData()) { return; }
	myFile.WriteString("----- OCCUPANT INJURY -----\n");

	for ( int loop=1; loop<=m_injno; loop++)  
	{
		if (m_injno>1)
		{
			char temp [100];
			CString strTemp;
			itoa (loop,temp,10);
			strTemp=temp;
			myFile.WriteString ("Record "+strTemp+":\n");
		}

		myFile.WriteString ("Body Region:	"+m_bodyrg[loop]+"\n");
		myFile.WriteString ("Body Aspect:	"+m_aspect[loop]+"\n");
		myFile.WriteString ("Injury:	"+m_lesion[loop]+"\n");
		myFile.WriteString ("Injured Organ:	"+m_sysorg[loop]+"\n");
		myFile.WriteString ("Abbreviated Injury Scale:	"+m_ais[loop]+"\n");

		myFile.WriteString ("AIS 90:	" + m_ais90[loop] + "\n");
		myFile.WriteString ("Injury Comments:	"+m_injcom[loop] + "\n");			
	}

}

//Write the BioInst part of a report (.evr) file
void CBioData::WriteBioInstReport(CStdioFile & myFile)
{
	if (!ValidateInstData()) { return; }
	myFile.WriteString("----- INSTRUMENTATION -----\n");

	for ( int loop=1; loop<=m_curno; loop++)  
	{
		if (m_curno>1)
		{
			char temp [100];
			CString strTemp;
			itoa (loop,temp,10);
			strTemp=temp;
			myFile.WriteString ("Record "+strTemp+":\n");
		}
		
		myFile.WriteString ("Sensor Type:	"+m_sentyp[loop]+"\n");
		myFile.WriteString ("Sensor Location:	"+m_senloc[loop]+"\n");
		myFile.WriteString ("Sensor Attachment:	"+m_senatt[loop]+"\n");
		myFile.WriteString ("Axis:	"+m_axis[loop]+"\n");
		myFile.WriteString ("X Units:	"+m_xunits[loop]+"\n");

		myFile.WriteString ("Y Units:	"+m_yunits[loop]+"\n");
		myFile.WriteString ("Prefilter Frequency:	" + m_prefil[loop] + "\n");
		myFile.WriteString ("Instrument Manufacturer:	"+m_insman[loop]+"\n");
		myFile.WriteString ("Calibration Date:	"+m_caldat[loop]+"\n");	
		myFile.WriteString ("Instrument Rating:	" + m_insrat[loop] + "\n");

		myFile.WriteString ("Channel Maximum Rating:	" + m_chlmax[loop] + "\n");
		myFile.WriteString ("Initial Velocity:	" + m_inivel[loop] + "\n");
		myFile.WriteString ("Number of First Point:	" + m_nfp[loop] + "\n");
		myFile.WriteString ("Number of Last Point:	" + m_nlp[loop] + "\n");
		myFile.WriteString ("Time Increment:	" + m_delt[loop] + "\n");

		myFile.WriteString ("Data Status:	"+m_dastat[loop]+"\n");
		myFile.WriteString ("Channel Status:	"+m_chstat[loop]+"\n");
		myFile.WriteString ("Instrument Comments:	"+m_inscom[loop] + "\n");	
	}
}	// WriteBioInstReport

//Write the BioMechTest part of a report (.evr) file
void CBioData::WriteBioMechTestReport(CStdioFile & myFile)
{
	if (!ValidateTestData()) { return; }

	char temp [100];
	CString strTemp;

	myFile.WriteString("----- TEST -----\n");					

	myFile.WriteString("Version Number:	"+m_verno+"\n");
	myFile.WriteString("Title:	"+m_title+"\n");	
	myFile.WriteString("Test Objectives:	"+m_tstobj+"\n");
	m_tstdat.MakeUpper();
	myFile.WriteString("Test Date:	"+m_tstdat+"\n");
	myFile.WriteString("Test Performer:	"+m_tstprf+"\n");
	
	myFile.WriteString("Contract Number:	"+m_conno+"\n");	
	myFile.WriteString("Test Reference Number:	"+m_tstref+"\n");		
	myFile.WriteString("Test Configuration:	"+m_tstcfn+"\n");
	myFile.WriteString("Ambient Temperature:	" + m_temp + "\n");	
	myFile.WriteString("Type of Recorder:	"+m_rectyp+"\n");

	myFile.WriteString("Data Link to Recorder:	"+m_link+"\n");	
	myFile.WriteString("Closing Speed:	" + m_clsspd + "\n");
	myFile.WriteString("Impact Angle:	" + m_impang + "\n");
	itoa(m_totcrv, temp,10);
	strTemp=temp;
	myFile.WriteString("Total Number of Curves:	" + strTemp + "\n");
	myFile.WriteString("Occupant Type:	"+m_occtyp+"\n");
			
	myFile.WriteString("Test Comments:	"+m_tstcom + "\n");	
}

//Write the BioOcc part of a report (.evr) file
void CBioData::WriteBioOccReport(CStdioFile & myFile)
{
	if (!ValidateSoccData()) { return; }

	myFile.WriteString("----- BIO OCCUPANT -----\n");
	
	myFile.WriteString("Occupant Location:	"+m_boccloc+"\n");
	myFile.WriteString("Occupant Sex:	"+m_boccsex+"\n"); 
	myFile.WriteString("Seat Position:	"+m_bseposn+"\n");
	myFile.WriteString("Occupant Age:	" + m_occage + "\n");
	myFile.WriteString("Occupant Weight:	" + m_occwt + "\n");

	myFile.WriteString("Component Weight:	" + m_bcompwt + "\n");	
	myFile.WriteString("Number of Fractured Ribs:	" + m_frctrb + "\n");
	myFile.WriteString("Number of Rib Fractures:	" + m_rbfrct + "\n");
	myFile.WriteString("Occupant Reference Number:	"+m_occref+"\n");
	myFile.WriteString("Number of Tests:	" + m_notest + "\n");

	myFile.WriteString("Cadaver Date of Death:	"+m_dtedth+"\n");
	myFile.WriteString("Cadaver Cause of Death:	"+m_csedth+"\n");
	myFile.WriteString("Cadaver Appearance:	"+m_cadapp+"\n");
	myFile.WriteString("Length of Bed Confinement:	" + m_bedcon + "\n");
	myFile.WriteString("Cadaver Anomaly:	"+m_cadan+"\n");

	myFile.WriteString("Cardiovascular Pressurization:	"+m_aorpre+"\n");
	myFile.WriteString("Head Pressurization:	"+m_cerpre+"\n");
	myFile.WriteString("Pulmonary Pressurization:	"+m_pulpre+"\n");
	myFile.WriteString("Bone Mineral Content:	" + m_bmc + "\n");
	myFile.WriteString("Location of BMC Measurement:	"+m_bmcloc+"\n");

	myFile.WriteString("BMC Units:	"+m_bmcunits+"\n");
	myFile.WriteString("BMC Measurement Method:	"+m_bmcmethod+"\n");	
	myFile.WriteString ("BMC Comments:	"+m_bmccom + "\n");	
	myFile.WriteString("Occupant Comments:	"+m_boccom+"\n");
}

//Write the BioRest part of a report (.evr) file
void CBioData::WriteBioRestReport(CStdioFile & myFile)
{
	if (!ValidateRestData()) { return; }

	myFile.WriteString ("----- RESTRAINT -----\n");

	for ( int loop=1; loop<=m_rstno; loop++)  
	{
		if (m_rstno>1)
		{
			char temp [100];
			CString strTemp;
			itoa (loop,temp,10);
			strTemp=temp;
			myFile.WriteString ("Record "+strTemp+":\n");
		}

		myFile.WriteString ("Restraint Type:	"+m_rsttyp[loop]+"\n");
		myFile.WriteString ("Restraint Mount:	"+m_rstmnt[loop]+"\n");
		myFile.WriteString ("Inflator/Belt Deployment:	"+m_deploy[loop]+"\n");
		myFile.WriteString ("Restraint Comments:	"+m_rstcom[loop] + "\n")	;
	}
}

//Write the BioRib part of a report (.evr) file
void CBioData::WriteBioRibReport(CStdioFile & myFile)
{
	if (!ValidateRibData()) { return; }

	myFile.WriteString ("----- RIB -----\n");

	for (int loop=1; loop<=m_ribno; loop++)
	{
		if (m_ribno>1)
		{
			char temp [100];
			CString strTemp;
			itoa (loop,temp,10);
			strTemp=temp;
			myFile.WriteString ("Record "+strTemp+":\n");
		}

		myFile.WriteString ("Rib Location:	"+m_ribloc[loop]+"\n");
		myFile.WriteString ("Rib Moment of Inertia:	" + m_ribin[loop] + "\n");
		myFile.WriteString ("Neutral Axis Distance:	" + m_nadis[loop] + "\n");
		myFile.WriteString ("Span Length:	" + m_splen[loop] + "\n") ;
		myFile.WriteString ("Deflection:	" + m_defl[loop] + "\n") ;

		myFile.WriteString ("Load:	" + m_load[loop] + "\n") ;
		myFile.WriteString ("Break Load:	" + m_brkld[loop] + "\n");
		myFile.WriteString ("Area of Bone Marrow:	" + m_armar[loop] + "\n") ;
		myFile.WriteString ("Cross Sectional Area:	"+m_rarea[loop] + "\n");
	}
}

// Open an EV5 file to read in the data.
BOOL CBioData::ImportEV5(CString & strfile_in)
{
	CStdioFile myFile;
	CFileException fileException;

	myFile.Open( strfile_in, CFile::modeRead | CFile::typeText,
		&fileException );
	if (!myFile.m_pStream)  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_in, fileException.m_cause );
		MessageBox(NULL,msg,"Error",MB_OK);
		return FALSE;
	}

	return LoadBioEV5Data(myFile);

}

// Open an EV4 file to read in the data.
BOOL CBioData::ImportEV4(CString & strfile_in)
{
	CStdioFile myFile;
	CFileException fileException;

	myFile.Open( strfile_in, CFile::modeRead | CFile::typeText,
		&fileException );
	if (!myFile.m_pStream)  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_in, fileException.m_cause );
		MessageBox(NULL,msg,"Error",MB_OK);
		return FALSE;
	}

	return LoadBioEV4Data(myFile);	
}	// ImportEV4

// put data from ev5 file in BioData data members
BOOL CBioData::LoadBioEV5Data(CStdioFile & myFile)
{
	CString strLine;

	ExtractTestData(myFile, EV5);   // test data section is omnipresent

	ExtractRibData (myFile); // finds Rib section intelligently
	
	ExtractRestData(myFile,EV5);  // finds rest section intelligently. 
	
	ExtractOccData(myFile);  // finds Occ section intelligently. 
	
	ExtractInstData (myFile, EV5);  // finds inst section intelligently. 

	ExtractInjData (myFile, EV5);  // finds inj section intelligently. 

	ExtractGaugeData (myFile, EV5);  // finds gauge section intelligently. 

	ExtractDumData (myFile);  // finds dum section intelligently. 

	ExtractCBandData (myFile, EV5);  // finds CBand section intelligently. 

	ExtractAnthData (myFile, EV5);  // finds anth section intelligently. 

	return TRUE;
}	// LoadBioEV5Data

// ----------------
// CBioData::ExtractTestData(CStdioFile&, int)  
// Looks for a TEST section in a Bio EV file.  If found, extracts the
// data and puts it into members of CBioData.
// ----------------
void CBioData::ExtractTestData(CStdioFile & myFile, int nVersion)
{
	CString strLine;
	myFile.SeekToBegin ();  // back to beginning

	// find ----- TEST -----
	int nRes = -1;
	while (myFile.ReadString (strLine))
	{
		nRes = strLine.Find("----- TEST -----");
		if (nRes != -1) break;
	}

	if (nRes == -1) return;  // TEST section not found
    // now read line after ----- TEST -----
	
	myFile.ReadString (strLine);	
	if ((strLine.GetLength ()) <1) return;  // don't process empty string

	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}

	int loc1 = strLine.Find ('|',0);

	if (loc1==-1)  return;  // | not found in line after ----- TEST -----,
					        // must be another section, so return.
	
	//15 pipes.EV5     15pipes EV4 (pipes = fields-1)
	int nPipes = CountPipes(strLine);
	if (nVersion==EV5)
	{
		if (nPipes!=15)
		{
			char buf [10];
			itoa (nPipes,buf,10);
			CString strPipes = buf;
			CString strErr = "This EV5 file has "+strPipes +" | characters in the TEST section, should have 15.";
			MessageBox(NULL, strErr, "Error",MB_OK);
			return;
			
		}
		
	}
	else if (nVersion==EV4)
	{
		if (nPipes!=15)
		{
			char buf [10];
			itoa (nPipes,buf,10);
			CString strPipes = buf;
			CString strErr = "This EV4 file has "+strPipes +"| characters in the TEST section, should have 15.";
			MessageBox(NULL, strErr, "Error",MB_OK);
			return;
		}
		
	}
	
	if (nVersion==EV4)  //only skip one if EV4.  EV5 has no tstno.
	{
		m_verno = GetTextBetweenPipes(strLine,1,2);
		m_title	= GetTextBetweenPipes(strLine,2,3);
		m_tstobj= GetTextBetweenPipes(strLine,3,4);
		m_tstdat= GetTextBetweenPipes(strLine,4,5);
		m_tstprf= GetTextBetweenPipes(strLine,5,6);
		m_conno	= GetTextBetweenPipes(strLine,6,7);
		m_tstref= GetTextBetweenPipes(strLine,7,8);
		m_tstcfn= GetTextBetweenPipes(strLine,8,9);
		m_temp	= GetTextBetweenPipes(strLine,9,10);
		m_rectyp= GetTextBetweenPipes(strLine,10,11);
		m_link	= GetTextBetweenPipes(strLine,11,12);
		m_clsspd= GetTextBetweenPipes(strLine,12,13);
		m_impang= GetTextBetweenPipes(strLine,13,14);
		m_totcrv= atoi(GetTextBetweenPipes(strLine,14,15));
		m_occtyp= ""; //EV4 test doesn't have occtyp. It's in Dummy or bio-occupant section.
		m_tstcom= GetTextBetweenPipes(strLine,15,16); 

	}
	else //EV5
	{
		m_verno = GetTextBetweenPipes(strLine,0,1);
		m_title	= GetTextBetweenPipes(strLine,1,2);
		m_tstobj= GetTextBetweenPipes(strLine,2,3);
		m_tstdat= GetTextBetweenPipes(strLine,3,4);
		m_tstprf= GetTextBetweenPipes(strLine,4,5);
		m_conno	= GetTextBetweenPipes(strLine,5,6);
		m_tstref= GetTextBetweenPipes(strLine,6,7);
		m_tstcfn= GetTextBetweenPipes(strLine,7,8);
		m_temp	= GetTextBetweenPipes(strLine,8,9);
		m_rectyp= GetTextBetweenPipes(strLine,9,10);
		m_link	= GetTextBetweenPipes(strLine,10,11);
		m_clsspd= GetTextBetweenPipes(strLine,11,12);
		m_impang= GetTextBetweenPipes(strLine,12,13);
		m_totcrv= atoi(GetTextBetweenPipes(strLine,13,14));
		m_occtyp= GetTextBetweenPipes(strLine,14,15); 
		m_tstcom= GetTextBetweenPipes(strLine,15,16); 
	}
}	// ExtractTestData

// -------------------
// void CBioData::ExtractRibData() 
// This function finds and separates the Rib Data in an ev5 file
// if any, and fills in BioData with those values
// -------------------
void CBioData::ExtractRibData(CStdioFile & myFile)
{
	CString strLine;
	myFile.SeekToBegin ();  // back to beginning

	// find ----- RIB -----
	int nRes = -1;
	while (myFile.ReadString (strLine))
	{
		nRes = strLine.Find("----- RIB -----");
		if (nRes != -1) break;
	}

	if (nRes==-1) 
	{
		m_ribno=0;
		return; // RIB not found.
	}

    // now read line after ----- RIB -----
	myFile.ReadString (strLine);	

	if ((strLine.GetLength ()) <1) 
	{
		m_ribno=0;	
		return;  // don't process empty string
	}

	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}

	int loc1 = strLine.Find ('|',0);

	if (loc1==-1) 
	{
		m_ribno = 0;
		return;      // | not found in line after ----- RIB -----,
				     // must be another section, so return.
	}
			
	int loop =1;
	while ((strLine.Left(6) !="----- "))  // not at another header.
	{
		//9 pipes.EV5     
		int nPipes = CountPipes(strLine);
		if (nPipes!= 9)
		{
			char buf [10];
			itoa (nPipes,buf,10);
			CString strPipes = buf;
			CString strErr = "This EV5 file has "+strPipes +" | characters in the RIB section, should have 9.";
			MessageBox(NULL, strErr, "Error",MB_OK);
			m_ribno = 0;
			return;			
		}

		m_ribno= atoi(GetTextBetweenPipes(strLine,0,1));
		m_ribloc.SetAtGrow(loop, GetTextBetweenPipes(strLine,1,2));
		m_ribin.SetAtGrow(loop, GetTextBetweenPipes(strLine,2,3));
		m_nadis.SetAtGrow(loop, GetTextBetweenPipes(strLine,3,4));
		m_splen.SetAtGrow(loop, GetTextBetweenPipes(strLine,4,5));
		m_defl.SetAtGrow(loop, GetTextBetweenPipes(strLine,5,6));
		m_load.SetAtGrow(loop, GetTextBetweenPipes(strLine,6,7));
		m_brkld.SetAtGrow(loop, GetTextBetweenPipes(strLine,7,8));
		m_armar.SetAtGrow(loop, GetTextBetweenPipes(strLine,8,9));
		m_rarea.SetAtGrow (loop, GetTextBetweenPipes(strLine,9,10));
		
		// now increment loop and read next string.
		loop++;
		myFile.ReadString (strLine);	

		while (strLine[0]=='#')  //comment line, so read another.
		{
			myFile.ReadString (strLine);	
		}
	}
}	// ExtractRibData

// -------------------
// CBioData::ExtractRestData(CStdioFile&, int)  
// This function finds and separates the Rest Data in an ev5 file
// if any, and fills in BioData with those values
// -------------------
void CBioData::ExtractRestData(CStdioFile & myFile, int nVersion)
{
	CString strLine;
	myFile.SeekToBegin ();  // back to beginning

	// find ----- RESTRAINT -----
	int nRes = -1;
	while (myFile.ReadString (strLine))
	{
		nRes = strLine.Find("----- RESTRAINT -----");
		if (nRes != -1) break;
	}

	if (nRes==-1) 
	{
		m_rstno=0;
		return; // REST not found.
	}
    // now read line after ----- RESTRAINT -----
	myFile.ReadString (strLine);	

	if ((strLine.GetLength ()) <1) 
	{
		m_rstno=0;	
		return;  // don't process empty string
	}
	
	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}
	
	int loc1 = strLine.Find ('|',0);

	if (loc1==-1) 
	{
		m_rstno = 0;
		return;      // | not found in line after ----- REST -----,
				     // must be another section, so return.
	}

	int loop =1;
	while ((strLine.Left(6) !="----- "))  // not at another header.
	{
		//4 pipes.EV5 and 5 EV4
		int nPipes = CountPipes(strLine);
		if (nVersion==EV4)
		{
			if (nPipes!= 5)
			{
				char buf [10];
				itoa (nPipes,buf,10);
				CString strPipes = buf;
				CString strErr = "This EV4 file has "+strPipes +" | characters in the REST section, should have 5.";
				MessageBox(NULL, strErr, "Error",MB_OK);
				m_rstno = 0;
				return;
			}
		}
		else if (nVersion==EV5)
		{
			if (nPipes!= 4)
			{
				char buf [10];
				itoa (nPipes,buf,10);
				CString strPipes = buf;
				CString strErr = "This EV5 file has "+strPipes +" | characters in the REST section, should have 4.";
				MessageBox(NULL, strErr, "Error",MB_OK);
				m_rstno = 0;
				return;
			}
		}

		if (nVersion==EV4) //Skip tstno if EV4
		{
			m_rstno= atoi(GetTextBetweenPipes(strLine,1,2));
			m_rsttyp.SetAtGrow (loop, GetTextBetweenPipes(strLine,2,3));
			m_rstmnt.SetAtGrow (loop, GetTextBetweenPipes(strLine,3,4));
			m_deploy.SetAtGrow (loop, GetTextBetweenPipes(strLine,4,5));
			m_rstcom.SetAtGrow (loop, GetTextBetweenPipes(strLine,5,6));

		}
		else if (nVersion==EV5) // nothing to skip EV5
		{
			m_rstno= atoi(GetTextBetweenPipes(strLine,0,1));
			m_rsttyp.SetAtGrow (loop, GetTextBetweenPipes(strLine,1,2));
			m_rstmnt.SetAtGrow (loop, GetTextBetweenPipes(strLine,2,3));
			m_deploy.SetAtGrow (loop, GetTextBetweenPipes(strLine,3,4));
			m_rstcom.SetAtGrow (loop, GetTextBetweenPipes(strLine,4,5));
		}
		
		// now increment loop and read next string.
		loop++;
		myFile.ReadString (strLine);	
	
		while (strLine[0]=='#')  //comment line, so read another.
		{
			myFile.ReadString (strLine);	
		}
	}
}	// ExtractRestData

// ExtractOccData()  *******************************************
// This function finds and separates the Occ Data in an ev5 file
// if any, and fills in BioData with those values
void CBioData::ExtractOccData(CStdioFile & myFile)
{
	CString strLine;
	myFile.SeekToBegin ();  // back to beginning

	// find ----- BIO OCCUPANT -----
	int nRes=-1;
	while (myFile.ReadString (strLine))
	{
		nRes = strLine.Find("----- BIO OCCUPANT -----");
		if (nRes != -1) break;
	}

	if (nRes==-1) 
	{
		return; // BIO OCC not found.
	}

    // now read line after ----- BIO OCCUPANT -----
	myFile.ReadString (strLine);	

	if ((strLine.GetLength ()) <1) 
	{
		return;  // don't process empty string
	}

	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}

	int loc1 = strLine.Find ('|',0);
	if (loc1==-1) 
	{
		return;      // | not found in line after ----- BIO OCCUPANT -----,
				     // must be another section, so return.
	}

	//23 pipes.EV5
	int nPipes = CountPipes(strLine);
	if (nPipes!= 23)
	{
		char buf [10];
		itoa (nPipes,buf,10);
		CString strPipes = buf;
		CString strErr = "This EV5 file has "+strPipes +" | characters in the BIO OCCUPANT section, should have 23.";
		MessageBox(NULL, strErr, "Error",MB_OK);
		return;
	}
		
	m_boccloc	= GetTextBetweenPipes(strLine,0,1);
	m_boccsex	= GetTextBetweenPipes(strLine,1,2);
	m_bseposn	= GetTextBetweenPipes(strLine,2,3);
	m_occage	= GetTextBetweenPipes(strLine,3,4);
	m_occwt		= GetTextBetweenPipes(strLine,4,5);

	m_bcompwt	= GetTextBetweenPipes(strLine,5,6);
	m_frctrb	= GetTextBetweenPipes(strLine,6,7);
	m_rbfrct	= GetTextBetweenPipes(strLine,7,8);
	m_occref	= GetTextBetweenPipes(strLine,8,9);
	m_notest	= GetTextBetweenPipes(strLine,9,10);

	m_dtedth	= GetTextBetweenPipes(strLine,10,11);
	m_csedth	= GetTextBetweenPipes(strLine,11,12);
	m_cadapp	= GetTextBetweenPipes(strLine,12,13);
	m_bedcon	= GetTextBetweenPipes(strLine,13,14);
	m_cadan		= GetTextBetweenPipes(strLine,14,15);

	m_aorpre	= GetTextBetweenPipes(strLine,15,16);
	m_cerpre	= GetTextBetweenPipes(strLine,16,17);
	m_pulpre	= GetTextBetweenPipes(strLine,17,18);
	m_bmc		= GetTextBetweenPipes(strLine,18,19);
	m_bmcloc	= GetTextBetweenPipes(strLine,19,20);

	m_bmcunits	= GetTextBetweenPipes(strLine,20,21);
	m_bmcmethod = GetTextBetweenPipes(strLine,21,22);	
	m_bmccom	= GetTextBetweenPipes(strLine,22,23);
	m_boccom	= GetTextBetweenPipes(strLine,23,24);

}

// ExtractInstData()  *******************************************
// This function finds and separates the Inst Data in an ev* file
// if any, and fills in BioData with those values
void CBioData::ExtractInstData(CStdioFile & myFile, int nVersion)
{
	CString strLine;
	myFile.SeekToBegin ();  // back to beginning

	// find ----- INSTRUMENTATION -----
	int nRes = -1;
	while (myFile.ReadString (strLine))
	{
		nRes = strLine.Find("----- INSTRUMENTATION -----");
		if (nRes != -1) break;
	}

	if (nRes==-1) 
	{
		m_totcrv = 0;
		return; // INST not found.
	}

    // now read line after ----- INSTRUMENTATION -----
	myFile.ReadString (strLine);	

	if ((strLine.GetLength ()) <1) 
	{
		m_totcrv = 0;
		return;  // don't process empty string
	}
	
	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}
	int loc1 = strLine.Find ('|',0);

	if (loc1==-1) 
	{
		m_totcrv = 0;
		return;      // | not found in line after ----- INSTRUMENTATION -----,
				     // must be another section, so return.
	}
	
	int loop =1;
	while ((strLine.Left(6) !="----- "))  // not at another header.
	{
		//18 pipes.EV5 and 18 EV4
		int nPipes = CountPipes(strLine);
		if (nVersion == EV5)
		{
			if (nPipes!= 18)
			{
				char buf [10];
				itoa (nPipes,buf,10);
				CString strPipes = buf;
				CString strErr = "This EV5 file has "+strPipes +" | characters in the INST section, should have 18.";
				MessageBox(NULL, strErr, "Error",MB_OK);
				m_totcrv = 0;
				return;
			}
		}
		else if (nVersion == EV4)
		{
			if (nPipes!= 18)
			{
				char buf [10];
				itoa (nPipes,buf,10);
				CString strPipes = buf;
				CString strErr = "This EV4 file has "+strPipes +" | characters in the INST section, should have 18.";
				MessageBox(NULL, strErr, "Error",MB_OK);
				m_totcrv = 0;
				return;
			}
		}

		if (nVersion==EV4) //skip tstno for EV4
		{
			m_curno = atoi(GetTextBetweenPipes(strLine,1,2));
			m_sentyp.SetAtGrow(loop, GetTextBetweenPipes(strLine,2,3));
			m_senloc.SetAtGrow(loop, GetTextBetweenPipes(strLine,3,4));
			m_senatt.SetAtGrow(loop, GetTextBetweenPipes(strLine,4,5));
			m_axis.SetAtGrow(loop, GetTextBetweenPipes(strLine,5,6));
		//	m_xunits.SetAtGrow(loop, GetTextBetweenPipes(strLine,6,7));
			m_xunits.SetAtGrow(loop, _T("SEC"));
			m_yunits.SetAtGrow(loop, GetTextBetweenPipes(strLine,6,7));
			m_prefil.SetAtGrow(loop, GetTextBetweenPipes(strLine,7,8));
			m_insman.SetAtGrow(loop, GetTextBetweenPipes(strLine,8,9));
			m_caldat.SetAtGrow(loop, GetTextBetweenPipes(strLine,9,10));
			m_insrat.SetAtGrow(loop, GetTextBetweenPipes(strLine,10,11));
			m_chlmax.SetAtGrow(loop, GetTextBetweenPipes(strLine,11,12));
			m_inivel.SetAtGrow(loop, GetTextBetweenPipes(strLine,12,13));
			m_nfp.SetAtGrow(loop, GetTextBetweenPipes(strLine,13,14));
			m_nlp.SetAtGrow(loop, GetTextBetweenPipes(strLine,14,15));
			m_delt.SetAtGrow(loop, GetTextBetweenPipes(strLine,15,16));
			m_dastat.SetAtGrow(loop, GetTextBetweenPipes(strLine,16,17));
			m_chstat.SetAtGrow(loop, GetTextBetweenPipes(strLine,17,18));
			m_inscom.SetAtGrow (loop, GetTextBetweenPipes(strLine,18,19));
		}
		else if (nVersion==EV5)  //EV5 has no tstno
		{
			m_curno = atoi(GetTextBetweenPipes(strLine,0,1));
			m_sentyp.SetAtGrow(loop, GetTextBetweenPipes(strLine,1,2));
			m_senloc.SetAtGrow(loop, GetTextBetweenPipes(strLine,2,3));
			m_senatt.SetAtGrow(loop, GetTextBetweenPipes(strLine,3,4));
			m_axis.SetAtGrow(loop, GetTextBetweenPipes(strLine,4,5));
			m_xunits.SetAtGrow(loop, GetTextBetweenPipes(strLine,5,6));
			m_yunits.SetAtGrow(loop, GetTextBetweenPipes(strLine,6,7));
			m_prefil.SetAtGrow(loop, GetTextBetweenPipes(strLine,7,8));
			m_insman.SetAtGrow(loop, GetTextBetweenPipes(strLine,8,9));
			m_caldat.SetAtGrow(loop, GetTextBetweenPipes(strLine,9,10));
			m_insrat.SetAtGrow(loop, GetTextBetweenPipes(strLine,10,11));
			m_chlmax.SetAtGrow(loop, GetTextBetweenPipes(strLine,11,12));
			m_inivel.SetAtGrow(loop, GetTextBetweenPipes(strLine,12,13));
			m_nfp.SetAtGrow(loop, GetTextBetweenPipes(strLine,13,14));
			m_nlp.SetAtGrow(loop, GetTextBetweenPipes(strLine,14,15));
			m_delt.SetAtGrow(loop, GetTextBetweenPipes(strLine,15,16));
			m_dastat.SetAtGrow(loop, GetTextBetweenPipes(strLine,16,17));
			m_chstat.SetAtGrow(loop, GetTextBetweenPipes(strLine,17,18));
			m_inscom.SetAtGrow (loop, GetTextBetweenPipes(strLine,18,19));
		}

		// now increment loop and read next string.
		loop++;
		myFile.ReadString (strLine);

		while (strLine[0]=='#')  //comment line, so read another.
		{
			myFile.ReadString (strLine);	
		}

	}
	
	m_totcrv = loop-1;  // total curve infos read from file.

}

// ExtractInjData()  *******************************************
// This function finds and separates the Inj Data in an ev5 file
// if any, and fills in BioData with those values
void CBioData::ExtractInjData(CStdioFile & myFile, int nVersion)
{
	CString strLine;
	myFile.SeekToBegin ();  // back to beginning

	// find ----- OCCUPANT INJURY ----- or ----- OCCI
	int nRes = -1;
	int nRes2 = -1;
	while (myFile.ReadString (strLine))
	{
		nRes = strLine.Find("----- OCCUPANT INJURY -----");
		nRes2 = strLine.Find("----- OCCI");

		if ((nRes != -1) || (nRes2!=-1)) break;
	}

	if (nRes==-1) 
	{
		return; // Inj not found.
	}

    // now read line after ----- OCCUPANT INJURY -----
	myFile.ReadString (strLine);	

	if ((strLine.GetLength ()) <1) 
	{
		m_injno=0;	
		return;  // don't process empty string
	}

	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}

	int loc1 = strLine.Find ('|',0);
	
	if (loc1==-1) 
	{
		m_injno = 0;
		return;      // | not found in line after ----- OCCUPANT INJURY -----,
		// must be another section, so return.
	}
	
	int loop =1;
	while ((strLine.Left(6) !="----- "))  // not at another header.
	{
		//7 pipes.EV5 and 7 EV4
		int nPipes = CountPipes(strLine);
		if (nVersion == EV5)
		{
			if (nPipes!= 7)
			{
				char buf [10];
				itoa (nPipes,buf,10);
				CString strPipes = buf;
				CString strErr = "This EV5 file has "+strPipes +" | characters in the OCCUPANT INJURY section, should have 7.";
				MessageBox(NULL, strErr, "Error",MB_OK);
				m_injno=0;
				return;
			}
		}
		else if (nVersion == EV4)
		{
			if (nPipes!= 7)
			{
				char buf [10];
				itoa (nPipes,buf,10);
				CString strPipes = buf;
				CString strErr = "This EV4 file has "+strPipes +" | characters in the OCCUPANT INJURY section, should have 7.";
				MessageBox(NULL, strErr, "Error",MB_OK);
				m_injno=0;
				return;
			}
		}
		
		if (nVersion == EV4)  
		{
			m_injno= atoi(GetTextBetweenPipes(strLine,1,2));
			m_bodyrg.SetAtGrow (loop, GetTextBetweenPipes(strLine,2,3));
			m_aspect.SetAtGrow (loop, GetTextBetweenPipes(strLine,3,4));
			m_lesion.SetAtGrow (loop, GetTextBetweenPipes(strLine,4,5));
			m_sysorg.SetAtGrow (loop, GetTextBetweenPipes(strLine,5,6));
			m_ais.SetAtGrow (loop, GetTextBetweenPipes(strLine,6,7));
			m_ais90.SetAtGrow (loop, 0); // only EV5 has ais90
			m_injcom.SetAtGrow (loop, GetTextBetweenPipes(strLine,7,8));
			
		}
		else if (nVersion==EV5)  //Skip tstno, get injno
		{
			m_injno= atoi(GetTextBetweenPipes(strLine,0,1));
			m_bodyrg.SetAtGrow (loop, GetTextBetweenPipes(strLine,1,2));
			m_aspect.SetAtGrow (loop, GetTextBetweenPipes(strLine,2,3));
			m_lesion.SetAtGrow (loop, GetTextBetweenPipes(strLine,3,4));
			m_sysorg.SetAtGrow (loop, GetTextBetweenPipes(strLine,4,5));
			m_ais.SetAtGrow (loop, GetTextBetweenPipes(strLine,5,6));
			m_ais90.SetAtGrow (loop, GetTextBetweenPipes(strLine,6,7)); // only EV5 has ais90
			m_injcom.SetAtGrow (loop, GetTextBetweenPipes(strLine,7,8));
			
		}
		// now increment loop and read next string.
		loop++;
		myFile.ReadString (strLine);	
		
		while (strLine[0]=='#')  //comment line, so read another.
		{
			myFile.ReadString (strLine);	
		}
	}
	
	if (nVersion==EV4) // no injno counter
	{
		m_injno= loop-1;
	}
}

// ------------
// void CBioData::ExtractGaugeData(CStdioFile&, int)  
// This function finds and separates the Gauge Data in an ev5 file
// if any, and fills in BioData with those values
// ------------
void CBioData::ExtractGaugeData(CStdioFile & myFile, int nVersion)
{
	CString strLine;
	myFile.SeekToBegin ();  // back to beginning

	// find ----- CHEST BAND GAUGE ----- or ----- GAUGE
	int nRes = -1;
	int nRes2 =-1;
	while (myFile.ReadString (strLine))
	{
		nRes = strLine.Find("----- CHEST BAND GAUGE -----");
		nRes2= strLine.Find("----- GAUGE");
		if ((nRes != -1) || (nRes2!=-1)) break;
	}

	if (nRes==-1) 
	{
		m_gaugesets=0;
		return; // Gauge not found.
	}

    // now read line after ----- CHEST BAND GAUGE -----
	myFile.ReadString (strLine);	

	if ((strLine.GetLength ()) <1) 
	{
		m_gaugesets = 0;	
		return;  // don't process empty string
	}

	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}

	int loc1 = strLine.Find ('|',0);

	if (loc1==-1) 
	{
		m_gaugesets = 0;
		return;      // | not found in line after ----- CHEST BAND GAUGE -----,
				     // must be another section, so return.
	}

	int loop =1;
	while ((strLine.Left(6) !="----- "))  // not at another header.
	{
		
		//4 pipes.EV5 and 5 EV4
		int nPipes = CountPipes(strLine);
		if (nVersion==EV4)
		{
			if (nPipes!= 5)
			{
				char buf [10];
				itoa (nPipes,buf,10);
				CString strPipes = buf;
				CString strErr = "This EV4 file has "+strPipes +" | characters in the CHEST BAND GAUGE section, should have 5.";
				MessageBox(NULL, strErr, "Error",MB_OK);
				m_gaugesets = 0;
				return;
			}
		}
		else if (nVersion==EV5)
		{
			if (nPipes!= 4)
			{
				char buf [10];
				itoa (nPipes,buf,10);
				CString strPipes = buf;
				CString strErr = "This EV5 file has "+strPipes +" | characters in the CHEST BAND GAUGE section, should have 4.";
				MessageBox(NULL, strErr, "Error",MB_OK);
				m_gaugesets = 0;
				return;
			}
		}

		if (nVersion==EV4) //EV4 has tstno so skip it.
		{
			m_Gauge_bandno.SetAtGrow (loop, GetTextBetweenPipes(strLine,1,2));
			m_gageno.SetAtGrow (loop, GetTextBetweenPipes(strLine,2,3));
			m_gagdis.SetAtGrow (loop, GetTextBetweenPipes(strLine,3,4)); 
			m_Gauge_curno.SetAtGrow (loop, GetTextBetweenPipes(strLine,4,5)); 
			m_gagcom.SetAtGrow (loop, GetTextBetweenPipes(strLine,5,6));  

		}
		else if (nVersion==EV5) //EV5 has no tstno so don't skip
		{
			m_Gauge_bandno.SetAtGrow (loop, GetTextBetweenPipes(strLine,0,1));
			m_gageno.SetAtGrow (loop, GetTextBetweenPipes(strLine,1,2));
			m_gagdis.SetAtGrow (loop, GetTextBetweenPipes(strLine,2,3)); 
			m_Gauge_curno.SetAtGrow (loop, GetTextBetweenPipes(strLine,3,4)); 
			m_gagcom.SetAtGrow (loop, GetTextBetweenPipes(strLine,4,5));  
		}

		// now increment loop and read next string.
		loop++;
		myFile.ReadString (strLine);	
		
		while (strLine[0]=='#')  //comment line, so read another.
		{
			myFile.ReadString (strLine);	
		}
	}
	m_gaugesets=loop-1;
}

// -------------
// ExtractDumData()
// This function finds and separates the Dum Data in an ev5 file
// if any, and fills in BioData with those values
// -------------
void CBioData::ExtractDumData(CStdioFile & myFile)
{
	CString strLine;
	myFile.SeekToBegin ();  // back to beginning

	// find ----- DUMMY 
	int nRes = -1;
	while (myFile.ReadString (strLine))
	{
		nRes = strLine.Find("----- DUMMY");
		if (nRes != -1) break;
	}

	if (nRes==-1) 
	{
		return; // Dummy not found.
	}

    // now read line after ----- DUMMY
	myFile.ReadString (strLine);	

	if ((strLine.GetLength ()) <1) 
	{
		return;  // don't process empty string
	}
	
	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}

	int loc1 = strLine.Find ('|',0);

	if (loc1==-1) 
	{
		return;      // | not found in line after ----- DUMMY OCCUPANT -----,
				     // must be another section, so return.
	}

	//24 pipes.EV5
	int nPipes = CountPipes(strLine);
	if (nPipes!= 24)
	{
		char buf [10];
		itoa (nPipes,buf,10);
		CString strPipes = buf;
		CString strErr = "This EV5 file has "+strPipes +" | characters in the DUMMY OCCUPANT section, should have 24.";
		MessageBox(NULL, strErr, "Error",MB_OK);
		return;
	}
	
	// *****
	// doccloc|doccsex|...   EV5
	// *****

	m_doccloc	= GetTextBetweenPipes(strLine,0,1);
	m_doccsex	= GetTextBetweenPipes(strLine,1,2);
	m_dseposn	= GetTextBetweenPipes(strLine,2,3);
	m_hic		= GetTextBetweenPipes(strLine,3,4);
	m_t1		= GetTextBetweenPipes(strLine,4,5);
	m_t2		= GetTextBetweenPipes(strLine,5,6);
	m_clip3m	= GetTextBetweenPipes(strLine,6,7);
	m_lfem		= GetTextBetweenPipes(strLine,7,8);
	m_rfem		= GetTextBetweenPipes(strLine,8,9);
	m_csi		= GetTextBetweenPipes(strLine,9,10);
	m_lbelt		= GetTextBetweenPipes(strLine,10,11);
	m_sbelt		= GetTextBetweenPipes(strLine,11,12);
	m_tti		= GetTextBetweenPipes(strLine,12,13);
	m_pelvg		= GetTextBetweenPipes(strLine,13,14);
	m_cti		= GetTextBetweenPipes(strLine,14,15);
	m_vc		= GetTextBetweenPipes(strLine,15,16);
	m_cmax		= GetTextBetweenPipes(strLine,16,17);
	m_nij		= GetTextBetweenPipes(strLine,17,18);
	m_mthcal	= GetTextBetweenPipes(strLine,18,19);
	m_dumsiz	= GetTextBetweenPipes(strLine,19,20);
	m_dumman	= GetTextBetweenPipes(strLine,20,21);
	m_dummod	= GetTextBetweenPipes(strLine,21,22);
	m_dumdsc	= GetTextBetweenPipes(strLine,22,23);
	m_dcompwt	= GetTextBetweenPipes(strLine,23,24);
	m_doccom	= GetTextBetweenPipes(strLine,24,25);
}

// ExtractCBandData()  *******************************************
// This function finds and separates the CBand Data in an ev5 file
// if any, and fills in BioData with those values
void CBioData::ExtractCBandData(CStdioFile & myFile, int nVersion)
{
	CString strLine;
	myFile.SeekToBegin ();  // back to beginning

	// find ----- CHEST BAND -----
	int nRes=-1;
	while (myFile.ReadString (strLine))
	{
		nRes = strLine.Find("----- CHEST BAND -----");
		if (nRes != -1) break;
	}

	if (nRes==-1) 
	{
		m_bandno=0;
		return; // CHEST BAND not found.
	}

    // now read line after ----- CHEST BAND -----
	myFile.ReadString (strLine);	

	if ((strLine.GetLength ()) <1) 
	{
		m_bandno=0;	
		return;  // don't process empty string
	}

	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}

	int loc1 = strLine.Find ('|',0);

	if (loc1==-1) 
	{
		m_bandno = 0;
		return;      // | not found in line after ----- CHEST BAND -----,
				     // must be another section, so return.
	}

	int loop =1;
	while ((strLine.Left(6) !="----- ") && (loop<=MAXCBANDS))  // not at another header.
	{
		//11 pipes.EV5 and 12 EV4
		int nPipes = CountPipes(strLine);
		if (nVersion==EV4)
		{
			if (nPipes!= 12)
			{
				char buf [10];
				itoa (nPipes,buf,10);
				CString strPipes = buf;
				CString strErr = "This EV4 file has "+strPipes +" | characters in the CHEST BAND section, should have 12.";
				MessageBox(NULL, strErr, "Error",MB_OK);
				m_bandno = 0;
				return;
			}
		}
		else if (nVersion==EV5)
		{
			if (nPipes!= 11)
			{
				char buf [10];
				itoa (nPipes,buf,10);
				CString strPipes = buf;
				CString strErr = "This EV5 file has "+strPipes +" | characters in the CHEST BAND section, should have 11.";
				MessageBox(NULL, strErr, "Error",MB_OK);
				m_bandno = 0;
				return;
			}
		}

		if (nVersion==EV4)  //EV4 has tstno so skip it
		{
			m_bandno= atoi(GetTextBetweenPipes(strLine,1,2));
			m_chsdpt.SetAtGrow (loop, GetTextBetweenPipes(strLine,2,3));
			m_chsbrd.SetAtGrow (loop, GetTextBetweenPipes(strLine,3,4));
			m_banlen.SetAtGrow (loop, GetTextBetweenPipes(strLine,4,5));
			m_antloc.SetAtGrow (loop, GetTextBetweenPipes(strLine,5,6));
			m_posloc.SetAtGrow (loop, GetTextBetweenPipes(strLine,6,7));
			m_gagstr.SetAtGrow (loop, GetTextBetweenPipes(strLine,7,8));
			m_disstr.SetAtGrow (loop, GetTextBetweenPipes(strLine,8,9));
			m_gagspn.SetAtGrow (loop, GetTextBetweenPipes(strLine,9,10));
			m_disspn.SetAtGrow (loop, GetTextBetweenPipes(strLine,10,11));
			m_totgag.SetAtGrow (loop, GetTextBetweenPipes(strLine,11,12));
			m_chbcom.SetAtGrow (loop, GetTextBetweenPipes(strLine,12,13));
		}
		else if (nVersion==EV5)  // no tstno, dont skip.
		{
			m_bandno= atoi(GetTextBetweenPipes(strLine,0,1));
			m_chsdpt.SetAtGrow (loop, GetTextBetweenPipes(strLine,1,2));
			m_chsbrd.SetAtGrow (loop, GetTextBetweenPipes(strLine,2,3));
			m_banlen.SetAtGrow (loop, GetTextBetweenPipes(strLine,3,4));
			m_antloc.SetAtGrow (loop, GetTextBetweenPipes(strLine,4,5));
			m_posloc.SetAtGrow (loop, GetTextBetweenPipes(strLine,5,6));
			m_gagstr.SetAtGrow (loop, GetTextBetweenPipes(strLine,6,7));
			m_disstr.SetAtGrow (loop, GetTextBetweenPipes(strLine,7,8));
			m_gagspn.SetAtGrow (loop, GetTextBetweenPipes(strLine,8,9));
			m_disspn.SetAtGrow (loop, GetTextBetweenPipes(strLine,9,10));
			m_totgag.SetAtGrow (loop, GetTextBetweenPipes(strLine,10,11));
			m_chbcom.SetAtGrow (loop, GetTextBetweenPipes(strLine,11,12));
		}

		// now increment loop and read next string.
		loop++;
		myFile.ReadString (strLine);	

		while (strLine[0]=='#')  //comment line, so read another.
		{
			myFile.ReadString (strLine);	
		}
	}
}	// ExtractCBandData

/******************************************************************************

	Name:		ExtractAnthData
	Action:		This function finds and separates the Anth Data in an ev5 file
				if any, and fills in BioData with those values
	Params:		CStdioFile & myFile, int nVersion
	Returns:	void
	Notes:	
	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
void CBioData::ExtractAnthData( CStdioFile & myFile, int nVersion )
{
	CString strLine;
	myFile.SeekToBegin ();  // back to beginning

	// find ----- ANTHROPOMETRY -----
	int nRes=-1;
	while (myFile.ReadString (strLine))
	{
		nRes = strLine.Find("----- ANTHROPOMETRY -----");
		if (nRes != -1) break;
	}

	if (nRes==-1) 
	{
		return; // ANTHROPOMETRY not found.
	}

    // now read line after ----- ANTHROPOMETRY -----
	myFile.ReadString (strLine);	

	if ((strLine.GetLength ()) <1) 
	{
		return;  // don't process empty string
	}

	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}

	int loc1 = strLine.Find ('|',0);

	if (loc1==-1) 
	{
		return;      // | not found in line after ----- ANTHROPOMETRY -----,
				     // must be another section, so return.
	}

	//37 pipes.EV5 and 38 EV4
	int nPipes = CountPipes(strLine);
	if (nVersion==EV4)
	{
		if (nPipes!= 38)
		{
			char buf [10];
			itoa (nPipes,buf,10);
			CString strPipes = buf;
			CString strErr = "This EV4 file has "+strPipes +" | characters in the ANTHROPOMETRY section, should have 38.";
			MessageBox(NULL, strErr, "Error",MB_OK);
			return;
		}
	}
	else if (nVersion==EV5)
	{
		if (nPipes!= 37)
		{
			char buf [10];
			itoa (nPipes,buf,10);
			CString strPipes = buf;
			CString strErr = "This EV5 file has "+strPipes +" | characters in the ANTHROPOMETRY section, should have 37.";
			MessageBox(NULL, strErr, "Error",MB_OK);
			return;
		}
	}
	
	if (nVersion==EV4) //EV4, skip tstno
	{
		m_statur = GetTextBetweenPipes(strLine,1,2);
		m_shldht = GetTextBetweenPipes(strLine,2,3);
		m_vrtsym = GetTextBetweenPipes(strLine,3,4);
		m_wastht = GetTextBetweenPipes(strLine,4,5);
		m_shldbd = GetTextBetweenPipes(strLine,5,6);
		m_chstbd = GetTextBetweenPipes(strLine,6,7);
		m_wastbd = GetTextBetweenPipes(strLine,7,8);
		m_hipbd  = GetTextBetweenPipes(strLine,8,9);
		m_shldel = GetTextBetweenPipes(strLine,9,10);
		m_farmhd = GetTextBetweenPipes(strLine,10,11);
		m_tiblht = GetTextBetweenPipes(strLine,11,12);
		m_anklht = GetTextBetweenPipes(strLine,12,13);
		m_footbd = GetTextBetweenPipes(strLine,13,14);
		m_footln = GetTextBetweenPipes(strLine,14,15);
		m_hdtroc = GetTextBetweenPipes(strLine,15,16);
		m_seatht = GetTextBetweenPipes(strLine,16,17);
		m_kneeht = GetTextBetweenPipes(strLine,17,18);
		m_headln = GetTextBetweenPipes(strLine,18,19);
		m_headbd = GetTextBetweenPipes(strLine,19,20);
		m_headch = GetTextBetweenPipes(strLine,20,21);
		m_bicpcr = GetTextBetweenPipes(strLine,21,22);
		m_elbwcr = GetTextBetweenPipes(strLine,22,23);
		m_farmcr = GetTextBetweenPipes(strLine,23,24);
		m_wrstcr = GetTextBetweenPipes(strLine,24,25);
		m_thghcr = GetTextBetweenPipes(strLine,25,26);
		m_ltghcr = GetTextBetweenPipes(strLine,26,27);
		m_kneecr = GetTextBetweenPipes(strLine,27,28);
		m_calfcr = GetTextBetweenPipes(strLine,28,29);
		m_anklcr = GetTextBetweenPipes(strLine,29,30);
		m_neckcr = GetTextBetweenPipes(strLine,30,31);
		m_scyecr = GetTextBetweenPipes(strLine,31,32);
		m_chstcr = GetTextBetweenPipes(strLine,32,33);
		m_wastcr = GetTextBetweenPipes(strLine,33,34);
		m_buttcr = GetTextBetweenPipes(strLine,34,35);
		m_chstdp = GetTextBetweenPipes(strLine,35,36);
		m_wastdp = GetTextBetweenPipes(strLine,36,37);
		m_buttdp = GetTextBetweenPipes(strLine,37,38);
		m_inscye = GetTextBetweenPipes(strLine,38,39);
	}
	else if (nVersion==EV5)
	{
		m_statur = GetTextBetweenPipes(strLine,0,1);
		m_shldht = GetTextBetweenPipes(strLine,1,2);
		m_vrtsym = GetTextBetweenPipes(strLine,2,3);
		m_wastht = GetTextBetweenPipes(strLine,3,4);
		m_shldbd = GetTextBetweenPipes(strLine,4,5);
		m_chstbd = GetTextBetweenPipes(strLine,5,6);
		m_wastbd = GetTextBetweenPipes(strLine,6,7);
		m_hipbd  = GetTextBetweenPipes(strLine,7,8);
		m_shldel = GetTextBetweenPipes(strLine,8,9);
		m_farmhd = GetTextBetweenPipes(strLine,9,10);
		m_tiblht = GetTextBetweenPipes(strLine,10,11);
		m_anklht = GetTextBetweenPipes(strLine,11,12);
		m_footbd = GetTextBetweenPipes(strLine,12,13);
		m_footln = GetTextBetweenPipes(strLine,13,14);
		m_hdtroc = GetTextBetweenPipes(strLine,14,15);
		m_seatht = GetTextBetweenPipes(strLine,15,16);
		m_kneeht = GetTextBetweenPipes(strLine,16,17);
		m_headln = GetTextBetweenPipes(strLine,17,18);
		m_headbd = GetTextBetweenPipes(strLine,18,19);
		m_headch = GetTextBetweenPipes(strLine,19,20);
		m_bicpcr = GetTextBetweenPipes(strLine,20,21);
		m_elbwcr = GetTextBetweenPipes(strLine,21,22);
		m_farmcr = GetTextBetweenPipes(strLine,22,23);
		m_wrstcr = GetTextBetweenPipes(strLine,23,24);
		m_thghcr = GetTextBetweenPipes(strLine,24,25);
		m_ltghcr = GetTextBetweenPipes(strLine,25,26);
		m_kneecr = GetTextBetweenPipes(strLine,26,27);
		m_calfcr = GetTextBetweenPipes(strLine,27,28);
		m_anklcr = GetTextBetweenPipes(strLine,28,29);
		m_neckcr = GetTextBetweenPipes(strLine,29,30);
		m_scyecr = GetTextBetweenPipes(strLine,30,31);
		m_chstcr = GetTextBetweenPipes(strLine,31,32);
		m_wastcr = GetTextBetweenPipes(strLine,32,33);
		m_buttcr = GetTextBetweenPipes(strLine,33,34);
		m_chstdp = GetTextBetweenPipes(strLine,34,35);
		m_wastdp = GetTextBetweenPipes(strLine,35,36);
		m_buttdp = GetTextBetweenPipes(strLine,36,37);
		m_inscye = GetTextBetweenPipes(strLine,37,38);
	}
}


// put data from ev4 file in BioData data members
BOOL CBioData::LoadBioEV4Data(CStdioFile & myFile)
{		
	ExtractTestData(myFile, EV4);   // test data section is omnipresent

	ExtractRestData(myFile, EV4);  // finds rest section intelligently.
	
	ExtractInstData(myFile, EV4);  // finds inst section intelligently. 

	ExtractInjData(myFile, EV4);  // finds inj section intelligently. 

	ExtractGaugeData (myFile, EV4);  // finds gauge section intelligently.

	if (IsEV4BioOcc(myFile, "----- BIO OCCUPANT -----"))  //decide whether it's dum or bocc.  Also fill in occtyp.
	{
		ExtractOccDataFromEV4(myFile);  // finds Occ section intelligently. 
		ExtractRibDataFromBOcc(myFile); // gets rib info out of BOCC section (EV4)		
	}
	else if (IsEV4BioOcc(myFile, "----- DUMMY OCCUPANT -----"))
	{
		ExtractDumDataFromEV4(myFile);  // finds dum section intelligently. 
	}
	
	ExtractCBandData(myFile, EV4);  // finds CBand section intelligently. same in EV4 and EV5

	ExtractAnthData(myFile, EV4);  // finds anth section intelligently. same in EV4 and EV5
	
	return TRUE;
}

// EV4 Files store rib info in the Bio Occ section, so 
// extract it here.
void CBioData::ExtractRibDataFromBOcc(CStdioFile & myFile)
{
	CString strLine;
	myFile.SeekToBegin ();  // back to beginning

	// find ----- BIO OCCUPANT -----
	int nRes=-1;
	while (myFile.ReadString (strLine))
	{
		nRes = strLine.Find("----- BIO OCCUPANT -----");
		if (nRes != -1) break;
	}
	
	if (nRes==-1)  { return; }  // BIO OCCUPANT not found. 

    // now read line after ----- BIO OCCUPANT -----
	myFile.ReadString (strLine);	

	if ((strLine.GetLength ()) <1)  { return;  } // don't process empty string	

	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}

	int loc1 = strLine.Find ('|',0);

	if (loc1==-1) 
	{
		return;      // | not found in line after ----- BIO OCCUPANT -----,
				     // must be another section, so return.
	}

	// Dont check number of pipes as usual.  The Bio Occ section will be checked elsewhere.
	//	1  Skip the first 19 entries.
	for (int loop=0; loop<4; loop++)  // read the four possible ribs out of the .ev4
	{
		// new update: // 05/23/01
		m_ribno = loop+1;
		int i = 9*loop;
		int j = 19;
		int k = 20;
		
		m_ribloc.SetAtGrow (m_ribno, GetTextBetweenPipes(strLine,j+i,k+i));
		m_ribin.SetAtGrow (m_ribno, GetTextBetweenPipes(strLine,++j+i,++k+i));
		m_nadis.SetAtGrow (m_ribno, GetTextBetweenPipes(strLine,++j+i,++k+i));
		m_splen.SetAtGrow (m_ribno, GetTextBetweenPipes(strLine,++j+i,++k+i));
		m_defl.SetAtGrow (m_ribno, GetTextBetweenPipes(strLine,++j+i,++k+i));
		m_load.SetAtGrow (m_ribno, GetTextBetweenPipes(strLine,++j+i,++k+i));
		m_brkld.SetAtGrow (m_ribno, GetTextBetweenPipes(strLine,++j+i,++k+i));
		m_armar.SetAtGrow (m_ribno, GetTextBetweenPipes(strLine,++j+i,++k+i));
		m_rarea.SetAtGrow (m_ribno, GetTextBetweenPipes(strLine,++j+i,++k+i));
	}
}	// ExtractRibDataFromBOcc

// -------------
// void CBioData::ExtractOccData(CStdioFile&)  
// This function finds and separates the Occ Data in an ev4 file
// if any, and fills in BioData with those values
// -------------
void CBioData::ExtractOccDataFromEV4(CStdioFile &myFile)
{
	CString strLine;
	myFile.SeekToBegin ();  // back to beginning

	// find ----- BIO OCCUPANT -----
	int nRes = -1;
	while (myFile.ReadString (strLine))
	{
		nRes = strLine.Find("----- BIO OCCUPANT -----");
		if (nRes != -1) break;
	}

	if (nRes==-1)  { return;  } // BOcc not found.

    // now read line after ----- BIO OCCUPANT -----
	myFile.ReadString (strLine);	

	if ((strLine.GetLength ()) <1)  { return;  }	// don't process empty string

	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}

	int loc1 = strLine.Find ('|',0);

	if (loc1==-1) 
	{
		return; // | not found in line after ----- BIO OCCUPANT -----, must be another section, so return.
	}

	//57 pipes EV4
	int nPipes = CountPipes(strLine);
//	if (nPipes!= 57)	// original
	if (nPipes!= 55)
	{
		char buf [10];
		itoa (nPipes,buf,10);
		CString strPipes = buf;
		CString strErr = "This EV4 file has "+strPipes +" | characters in the BIO OCCUPANT section, should have 57.";
		MessageBox(NULL, strErr, "Error",MB_OK);
		return;
	}

	m_boccloc = GetTextBetweenPipes(strLine,1,2);
	m_occtyp = GetTextBetweenPipes(strLine,2,3);	
	m_occage = GetTextBetweenPipes(strLine,3,4); 
	m_boccsex = GetTextBetweenPipes(strLine,4,5);

	m_occwt = GetTextBetweenPipes(strLine,5,6);
	m_bseposn = GetTextBetweenPipes(strLine,6,7);
	m_frctrb = GetTextBetweenPipes(strLine,7,8);
	m_rbfrct = GetTextBetweenPipes(strLine,8,9);	// 10
//skip one
	m_notest = GetTextBetweenPipes(strLine,10,11);
	m_dtedth = GetTextBetweenPipes(strLine,11,12);
	m_csedth = GetTextBetweenPipes(strLine,12,13);
	m_cadapp = GetTextBetweenPipes(strLine,13,14);
	m_bedcon = GetTextBetweenPipes(strLine,14,15);	// 15

	m_cadan = GetTextBetweenPipes(strLine,15,16);
	m_aorpre = GetTextBetweenPipes(strLine,16,17);
	m_cerpre = GetTextBetweenPipes(strLine,17,18);
	m_pulpre = GetTextBetweenPipes(strLine,18,19);
													// 20		
	//skip rib info, get occcom.
	m_boccom = GetTextBetweenPipes(strLine,55,56);
	
}	// ExtractOccDataFromEV4

// Read an EV4 file and look for data in Dummy Occupant and 
// Bio Occupant.  If nothing found in Dummy, it is Bio.  Maybe bio is empty too,
// but dont deal with that here. sSection = "----- BIO OCCUPANT -----" or "----- DUMMY OCCUPANT -----"
BOOL CBioData::IsEV4BioOcc(CStdioFile & myFile, const CString sSection)
{
	CString strLine;
	myFile.SeekToBegin ();  // back to beginning
	
	int nRes = -1;
	while (myFile.ReadString (strLine)) // find ----- BIO OCCUPANT -----
	{
		nRes = strLine.Find(sSection); // ("----- BIO OCCUPANT -----"); 
		if (nRes != -1) break;
	}
	 
	if (nRes==-1)  { return FALSE; }

	myFile.ReadString(strLine);  // read next line (BOcc Section)
	strLine.TrimLeft();
	if (strLine.GetLength()==0) { return false; }
	// see if the next line is info-data line:
	if ( strLine.Find("|")==-1 )  { return false; }

	return TRUE;
}	// IsEV4BioOcc
/***
// Read an EV4 file and look for data in Dummy Occupant and 
// Bio Occupant.  If nothing found in Dummy, it is Bio.  Maybe bio is empty too,
// but dont deal with that here.
BOOL CBioData::IsEV4BioOcc(CStdioFile & myFile)
{
	// find ----- DUMMY OCCUPANT -----
	while (myFile.ReadString (strLine))
	{
		int nRes = strLine.Find("----- DUMMY OCCUPANT -----");
		if (nRes != -1) break;
	}

    // now read line after ----- DUMMY OCCUPANT -----
	myFile.ReadString (strLine);	

	int nRes = strLine.Find("----- BIO OCCUPANT -----");  
	if (nRes==-1) 
	{
		bBOcc=FALSE;   // Dum Section found, so read occtyp out of Dum Section
		if ((strLine.GetLength ()) <1) 
		{
			return bBOcc;  // don't process empty string
		}
		
		int loc1 = strLine.Find ('|',0);
		
		//	m_tstno = atoi(strLine.Mid(0, loc1 - 0)); // dont use tstno
		
		int loc2 = strLine.Find ('|',loc1+1);
		
		//m_doccloc = strLine.Mid(loc1+1, loc2 -(loc1+1));
		
		loc1 = loc2;
		loc2 = strLine.Find ('|',loc1+1);
		m_occtyp = strLine.Mid(loc1+1, loc2 -(loc1+1));
		

	}
	else
	{
		bBOcc=TRUE; //read occtyp out of BOcc section.
		myFile.ReadString(strLine);  // read next line (BOcc Section)
		if ((strLine.GetLength ()) <1)
		{
			return bBOcc; // don't process empty string
		}

		int loc1 = strLine.Find ('|',0);
		
		//	m_tstno = atoi(strLine.Mid(0, loc1 - 0)); // dont use tstno
		
		int loc2 = strLine.Find ('|',loc1+1);
		
		//m_boccloc = strLine.Mid(loc1+1, loc2 -(loc1+1));
		
		loc1 = loc2;
		loc2 = strLine.Find ('|',loc1+1);
		m_occtyp = strLine.Mid (loc1 +1, loc2 - (loc1+1));
	}

	return bBOcc;
}
***/
// ------------------------------------
// BOOL ImportGR1(CString&)
// Description:  Opens GR1 file. Sets BioData member vars with
//               Data found there, using the offsets defined in
//               BioGR1.h
// ------------------------------------
BOOL CBioData::ImportGR1(CString & strfile_in)
{
	CStdioFile myFile;
	CFileException fileException;

	myFile.Open( strfile_in, CFile::modeRead | CFile::typeText,
		&fileException );
	if (!myFile.m_pStream)  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_in, fileException.m_cause );
		MessageBox(NULL,msg,"Error",MB_OK);
		return FALSE;
	}

	CString strLine;
	myFile.ReadString (strLine);

	if ((strLine.GetLength ()) <1) return FALSE;  // don't process empty string

	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}

	int nLen = strLine.GetLength ();
	if (nLen != m_GR1.m_totallen)
	{
		MessageBox(NULL,strfile_in+" is not in proper GR1 format.","ERROR", MB_OK);
		return FALSE;
	}
	// load member variables
	m_title = strLine.Mid(m_GR1.m_titleoff ,m_GR1.m_titlelen );
	m_tstobj = strLine.Mid(m_GR1.m_tstobjoff ,m_GR1.m_tstobjlen );
	m_tstdat = strLine.Mid(m_GR1.m_tstdatoff ,m_GR1.m_tstdatlen );
	m_tstprf = strLine.Mid(m_GR1.m_tstprfoff ,m_GR1.m_tstprflen );
	m_conno = strLine.Mid(m_GR1.m_connooff ,m_GR1.m_connolen );
	m_tstref = strLine.Mid(m_GR1.m_tstrefoff ,m_GR1.m_tstreflen );
	m_tstcfn = strLine.Mid(m_GR1.m_tstcfnoff ,m_GR1.m_tstcfnlen );
	m_temp = strLine.Mid(m_GR1.m_tempoff ,m_GR1.m_templen ); // atoi(strLine.Mid(m_GR1.m_tempoff ,m_GR1.m_templen ));
	m_rectyp = strLine.Mid(m_GR1.m_rectypoff ,m_GR1.m_rectyplen );
	m_link = strLine.Mid(m_GR1.m_linkoff ,m_GR1.m_linklen );
	m_clsspd = strLine.Mid(m_GR1.m_clsspdoff ,m_GR1.m_clsspdlen ); //(float) atof(strLine.Mid(m_GR1.m_clsspdoff ,m_GR1.m_clsspdlen ));
	m_impang = strLine.Mid(m_GR1.m_impangoff ,m_GR1.m_impanglen ); // atoi(strLine.Mid(m_GR1.m_impangoff ,m_GR1.m_impanglen ));
	//m_totcrv = atoi(strLine.Mid(m_GR1.m_totcrvoff ,m_GR1.m_totcrvlen ));  GR5 controlled.
	m_tstcom = strLine.Mid(m_GR1.m_tstcomoff ,m_GR1.m_tstcomlen );

	return TRUE;

}

// ------------------------------------
// BOOL ImportGR5(CString&)
// Description:  Opens GR5 file. Sets BioData member vars with
//               Data found there, using the offsets defined in
//               BioGR5.h
// ------------------------------------
BOOL CBioData::ImportGR5(CString & strfile_in)
{
	CStdioFile myFile;
	CFileException fileException;
	
	myFile.Open( strfile_in, CFile::modeRead | CFile::typeText,
		&fileException );
	if (!myFile.m_pStream)  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_in, fileException.m_cause );
		MessageBox(NULL,msg,"Error",MB_OK);
		return FALSE;
	}

	CString strLine;
	
	while(myFile.ReadString (strLine))
	{
		if ((strLine.GetLength ()) <1) return FALSE;  // don't process empty string

		while (strLine[0]=='#')  //comment line, so read another.
		{	
//			continue;
			myFile.ReadString (strLine);	
		}

		int nLen = strLine.GetLength ();
		if (nLen != m_GR5.m_totallen)
		{
			MessageBox(NULL,strfile_in+" is not in proper GR5 format.","ERROR", MB_OK);
			return FALSE;
		}
		
		// load member variables  
		
		m_curno = atoi(strLine.Mid(m_GR5.m_curnooff ,m_GR5.m_curnolen ));
				
		m_sentyp.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_sentypoff ,m_GR5.m_sentyplen ));
				
		m_senloc.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_senlocoff ,m_GR5.m_senloclen ));
				
		m_senatt.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_senattoff ,m_GR5.m_senattlen ));
				
		m_axis.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_axisoff ,m_GR5.m_axislen ));
				
		m_xunits.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_unitsoff ,m_GR5.m_unitslen ));

		m_yunits.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_unitsoff ,m_GR5.m_unitslen ));
		
		m_prefil.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_prefiloff ,m_GR5.m_prefillen )); // atoi(strLine.Mid(m_GR5.m_prefiloff ,m_GR5.m_prefillen )));
				
		m_insman.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_insmanoff ,m_GR5.m_insmanlen ));
				
		m_caldat.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_caldatoff ,m_GR5.m_caldatlen ));
				
		m_insrat.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_insratoff ,m_GR5.m_insratlen )); // atoi(strLine.Mid(m_GR5.m_insratoff ,m_GR5.m_insratlen )));
				
		m_chlmax.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_chlmaxoff ,m_GR5.m_chlmaxlen )); //atoi(strLine.Mid(m_GR5.m_chlmaxoff ,m_GR5.m_chlmaxlen )));
				
		m_inivel.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_iniveloff ,m_GR5.m_inivellen )); //(float) atof(strLine.Mid(m_GR5.m_iniveloff ,m_GR5.m_inivellen )));
		
		m_nfp.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_nfpoff ,m_GR5.m_nfplen )); // atoi(strLine.Mid(m_GR5.m_nfpoff ,m_GR5.m_nfplen )));
				
		m_nlp.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_nlpoff ,m_GR5.m_nlplen )); // atoi(strLine.Mid(m_GR5.m_nlpoff ,m_GR5.m_nlplen )));
				
		m_delt.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_deltoff ,m_GR5.m_deltlen )); // atoi(strLine.Mid(m_GR5.m_deltoff ,m_GR5.m_deltlen )));
				
		m_dastat.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_dastatoff ,m_GR5.m_dastatlen ));

		m_chstat.SetAtGrow (m_curno, ""); //chstat isn't in GR5, so fill in data to avoid access violations
				
		m_inscom.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_inscomoff ,m_GR5.m_inscomlen ));
		
	}
	m_totcrv = m_curno;
	return TRUE;

}

// ------------------------------------
// BOOL ImportGR6(CString&)
// Description:  Opens GR6 file. Sets BioData member vars with
//               Data found there, using the offsets defined in
//               BioGR6.h
// ------------------------------------
BOOL CBioData::ImportGR6(CString & strfile_in)
{
	CStdioFile myFile;
	CFileException fileException;
	
	myFile.Open( strfile_in, CFile::modeRead | CFile::typeText,
		&fileException );
	if (!myFile.m_pStream)  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_in, fileException.m_cause );
		MessageBox(NULL,msg,"Error",MB_OK);
		return FALSE;
	}
	
	CString strLine;
	myFile.ReadString (strLine);

	if ((strLine.GetLength ()) <1) return FALSE;  // don't process empty string

	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}

	int nLen = strLine.GetLength ();
	if (nLen != m_GR6.m_totallen)
	{
		MessageBox(NULL,strfile_in+" is not in proper GR6 format.","ERROR", MB_OK);
		return FALSE;
	}
	// figure out Bio or Dum.  load appropriate screen.
	m_occtyp = strLine.Mid(m_GR6.m_occtypoff ,m_GR6.m_occtyplen );
		
	if ((m_occtyp  == "AN") || (m_occtyp == "CD")) // BIOLOGICAL OCCUPANT
	{
		m_boccloc = strLine.Mid(m_GR6.m_occlocoff ,m_GR6.m_occloclen );
		m_boccsex = strLine.Mid(m_GR6.m_occsexoff ,m_GR6.m_occsexlen );
		m_bseposn = strLine.Mid(m_GR6.m_seposnoff ,m_GR6.m_seposnlen );
		m_occage = strLine.Mid(m_GR6.m_occageoff ,m_GR6.m_occagelen ); // atoi(strLine.Mid(m_GR6.m_occageoff ,m_GR6.m_occagelen ));
		m_occwt = strLine.Mid(m_GR6.m_occwtoff ,m_GR6.m_occwtlen ); // atoi(strLine.Mid(m_GR6.m_occwtoff ,m_GR6.m_occwtlen ));
		m_frctrb = strLine.Mid(m_GR6.m_frctrboff ,m_GR6.m_frctrblen ); // atoi(strLine.Mid(m_GR6.m_frctrboff ,m_GR6.m_frctrblen ));
		m_rbfrct = strLine.Mid(m_GR6.m_rbfrctoff ,m_GR6.m_rbfrctlen ); // atoi(strLine.Mid(m_GR6.m_rbfrctoff ,m_GR6.m_rbfrctlen ));
		m_occref = strLine.Mid(m_GR6.m_cadrefoff ,m_GR6.m_cadreflen );
		m_notest = strLine.Mid(m_GR6.m_notestoff ,m_GR6.m_notestlen ); // atoi(strLine.Mid(m_GR6.m_notestoff ,m_GR6.m_notestlen ));
		m_dtedth = strLine.Mid(m_GR6.m_dtedthoff ,m_GR6.m_dtedthlen );
		m_csedth = strLine.Mid(m_GR6.m_csedthoff ,m_GR6.m_csedthlen );
		m_cadapp = strLine.Mid(m_GR6.m_cadappoff ,m_GR6.m_cadapplen );
		m_bedcon = strLine.Mid(m_GR6.m_bedconoff ,m_GR6.m_bedconlen ); // atoi(strLine.Mid(m_GR6.m_bedconoff ,m_GR6.m_bedconlen ));
		m_cadan = strLine.Mid(m_GR6.m_cadanoff ,m_GR6.m_cadanlen );
		m_aorpre = strLine.Mid(m_GR6.m_aorpreoff ,m_GR6.m_aorprelen );
		m_cerpre = strLine.Mid(m_GR6.m_cerpreoff ,m_GR6.m_cerprelen );
		m_pulpre = strLine.Mid(m_GR6.m_pulpreoff ,m_GR6.m_pulprelen );
		m_boccom = strLine.Mid(m_GR6.m_occcomoff ,m_GR6.m_occcomlen );
		
		//RIBS too.
		m_ribno = 4 ;
		
		m_ribloc.SetAtGrow(1,strLine.Mid(m_GR6.m_rib1off ,m_GR6.m_rib1len ));
		m_ribloc.SetAtGrow(2,strLine.Mid(m_GR6.m_rib2off ,m_GR6.m_rib2len ));
		m_ribloc.SetAtGrow(3,strLine.Mid(m_GR6.m_rib3off ,m_GR6.m_rib3len ));
		m_ribloc.SetAtGrow(4,strLine.Mid(m_GR6.m_rib4off ,m_GR6.m_rib4len ));
		
		m_ribin.SetAtGrow (1, strLine.Mid(m_GR6.m_ribin1off, m_GR6.m_ribin1len)); // atoi(strLine.Mid(m_GR6.m_ribin1off, m_GR6.m_ribin1len)));
		m_ribin.SetAtGrow (2, strLine.Mid(m_GR6.m_ribin2off, m_GR6.m_ribin2len)); // atoi(strLine.Mid(m_GR6.m_ribin2off, m_GR6.m_ribin2len)));
		m_ribin.SetAtGrow (3, strLine.Mid(m_GR6.m_ribin3off, m_GR6.m_ribin3len)); // atoi(strLine.Mid(m_GR6.m_ribin3off, m_GR6.m_ribin3len)));
		m_ribin.SetAtGrow (4, strLine.Mid(m_GR6.m_ribin4off, m_GR6.m_ribin4len)); // atoi(strLine.Mid(m_GR6.m_ribin4off, m_GR6.m_ribin4len)));		
		
		m_nadis.SetAtGrow (1, strLine.Mid(m_GR6.m_nadis1off, m_GR6.m_nadis1len)); // atoi(strLine.Mid(m_GR6.m_nadis1off, m_GR6.m_nadis1len)));
		m_nadis.SetAtGrow (2, strLine.Mid(m_GR6.m_nadis2off, m_GR6.m_nadis2len)); // atoi(strLine.Mid(m_GR6.m_nadis2off, m_GR6.m_nadis2len)));
		m_nadis.SetAtGrow (3, strLine.Mid(m_GR6.m_nadis3off, m_GR6.m_nadis3len)); // atoi(strLine.Mid(m_GR6.m_nadis3off, m_GR6.m_nadis3len)));
		m_nadis.SetAtGrow (4, strLine.Mid(m_GR6.m_nadis4off, m_GR6.m_nadis4len)); // atoi(strLine.Mid(m_GR6.m_nadis4off, m_GR6.m_nadis4len)));

		m_splen.SetAtGrow (1, strLine.Mid(m_GR6.m_splen1off, m_GR6.m_splen1len)); // atoi(strLine.Mid(m_GR6.m_splen1off, m_GR6.m_splen1len)));
		m_splen.SetAtGrow (2, strLine.Mid(m_GR6.m_splen2off, m_GR6.m_splen2len)); // atoi(strLine.Mid(m_GR6.m_splen2off, m_GR6.m_splen2len)));
		m_splen.SetAtGrow (3, strLine.Mid(m_GR6.m_splen3off, m_GR6.m_splen3len)); // atoi(strLine.Mid(m_GR6.m_splen3off, m_GR6.m_splen3len)));
		m_splen.SetAtGrow (4, strLine.Mid(m_GR6.m_splen4off, m_GR6.m_splen4len)); // atoi(strLine.Mid(m_GR6.m_splen4off, m_GR6.m_splen4len)));

		m_defl.SetAtGrow (1, strLine.Mid(m_GR6.m_defl1off, m_GR6.m_defl1len)); // atoi(strLine.Mid(m_GR6.m_defl1off, m_GR6.m_defl1len)));
		m_defl.SetAtGrow (2, strLine.Mid(m_GR6.m_defl2off, m_GR6.m_defl2len)); // atoi(strLine.Mid(m_GR6.m_defl2off, m_GR6.m_defl2len)));
		m_defl.SetAtGrow (3, strLine.Mid(m_GR6.m_defl3off, m_GR6.m_defl3len)); // atoi(strLine.Mid(m_GR6.m_defl3off, m_GR6.m_defl3len)));
		m_defl.SetAtGrow (4, strLine.Mid(m_GR6.m_defl4off, m_GR6.m_defl4len)); // atoi(strLine.Mid(m_GR6.m_defl4off, m_GR6.m_defl4len)));

		m_load.SetAtGrow (1, strLine.Mid(m_GR6.m_load1off, m_GR6.m_load1len)); // atoi(strLine.Mid(m_GR6.m_load1off, m_GR6.m_load1len)));
		m_load.SetAtGrow (2, strLine.Mid(m_GR6.m_load2off, m_GR6.m_load2len)); // atoi(strLine.Mid(m_GR6.m_load2off, m_GR6.m_load2len)));
		m_load.SetAtGrow (3, strLine.Mid(m_GR6.m_load3off, m_GR6.m_load3len)); // atoi(strLine.Mid(m_GR6.m_load3off, m_GR6.m_load3len)));
		m_load.SetAtGrow (4, strLine.Mid(m_GR6.m_load4off, m_GR6.m_load4len)); // atoi(strLine.Mid(m_GR6.m_load4off, m_GR6.m_load4len)));

		m_brkld.SetAtGrow (1, strLine.Mid(m_GR6.m_brkld1off, m_GR6.m_brkld1len)); // atoi(strLine.Mid(m_GR6.m_brkld1off, m_GR6.m_brkld1len)));
		m_brkld.SetAtGrow (2, strLine.Mid(m_GR6.m_brkld2off, m_GR6.m_brkld2len)); // atoi(strLine.Mid(m_GR6.m_brkld2off, m_GR6.m_brkld2len)));
		m_brkld.SetAtGrow (3, strLine.Mid(m_GR6.m_brkld3off, m_GR6.m_brkld3len)); // atoi(strLine.Mid(m_GR6.m_brkld3off, m_GR6.m_brkld3len)));
		m_brkld.SetAtGrow (4, strLine.Mid(m_GR6.m_brkld4off, m_GR6.m_brkld4len)); // atoi(strLine.Mid(m_GR6.m_brkld4off, m_GR6.m_brkld4len)));

		m_armar.SetAtGrow (1, strLine.Mid(m_GR6.m_armar1off, m_GR6.m_armar1len)); // atoi(strLine.Mid(m_GR6.m_armar1off, m_GR6.m_armar1len)));
		m_armar.SetAtGrow (2, strLine.Mid(m_GR6.m_armar2off, m_GR6.m_armar2len)); // atoi(strLine.Mid(m_GR6.m_armar2off, m_GR6.m_armar2len)));
		m_armar.SetAtGrow (3, strLine.Mid(m_GR6.m_armar3off, m_GR6.m_armar3len)); // atoi(strLine.Mid(m_GR6.m_armar3off, m_GR6.m_armar3len)));
		m_armar.SetAtGrow (4, strLine.Mid(m_GR6.m_armar4off, m_GR6.m_armar4len)); // atoi(strLine.Mid(m_GR6.m_armar4off, m_GR6.m_armar4len)));

		m_rarea.SetAtGrow (1, strLine.Mid(m_GR6.m_rarea1off, m_GR6.m_rarea1len)); // atoi(strLine.Mid(m_GR6.m_rarea1off, m_GR6.m_rarea1len)));
		m_rarea.SetAtGrow (2, strLine.Mid(m_GR6.m_rarea2off, m_GR6.m_rarea2len)); // atoi(strLine.Mid(m_GR6.m_rarea2off, m_GR6.m_rarea2len)));
		m_rarea.SetAtGrow (3, strLine.Mid(m_GR6.m_rarea3off, m_GR6.m_rarea3len)); // atoi(strLine.Mid(m_GR6.m_rarea3off, m_GR6.m_rarea3len)));
		m_rarea.SetAtGrow (4, strLine.Mid(m_GR6.m_rarea4off, m_GR6.m_rarea4len)); // atoi(strLine.Mid(m_GR6.m_rarea4off, m_GR6.m_rarea4len)));
				
	}
	else  // DUMMY OCCUPANT
	{
		m_doccloc = strLine.Mid(m_GR6.m_occlocoff ,m_GR6.m_occloclen );
		m_doccsex = strLine.Mid(m_GR6.m_occsexoff ,m_GR6.m_occsexlen );
		m_dseposn = strLine.Mid(m_GR6.m_seposnoff ,m_GR6.m_seposnlen );
		m_hic = strLine.Mid(m_GR6.m_hicoff, m_GR6.m_hiclen );
		m_t1 = strLine.Mid(m_GR6.m_t1off, m_GR6.m_t1len );
		m_t2 =  strLine.Mid(m_GR6.m_t2off, m_GR6.m_t2len );
	
		m_mthcal =  strLine.Mid(m_GR6.m_mthcaloff, m_GR6.m_mthcallen );
		m_dumsiz =  strLine.Mid(m_GR6.m_dumsizoff, m_GR6.m_dumsizlen );
		m_dumman = strLine.Mid(m_GR6.m_dummanoff, m_GR6.m_dummanlen );
		m_dummod = strLine.Mid(m_GR6.m_dummodoff, m_GR6.m_dummodlen );
		m_dumdsc = strLine.Mid(m_GR6.m_dumdscoff, m_GR6.m_dumdsclen );
		m_dcompwt = strLine.Mid(m_GR6.m_occwtoff, m_GR6.m_occwtlen ); // atoi(strLine.Mid(m_GR6.m_occwtoff, m_GR6.m_occwtlen ));
		m_doccom = strLine.Mid(m_GR6.m_occcomoff, m_GR6.m_occcomlen );
		
	}
		
	return TRUE;
}

// ------------------------------------
// BOOL ImportGR7(CString&)
// Description:  Opens GR7 file. Sets BioData member vars with
//               Data found there, using the offsets defined in
//               BioGR7.h
// ------------------------------------

BOOL CBioData::ImportGR7(CString & strfile_in)
{
	CStdioFile myFile;
	CFileException fileException;
	
	myFile.Open( strfile_in, CFile::modeRead | CFile::typeText,
		&fileException );
	if (!myFile.m_pStream)  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_in, fileException.m_cause );
		MessageBox(NULL,msg,"Error",MB_OK);
		return FALSE;
	}
	
	CString strLine;
	myFile.ReadString (strLine);

	if ((strLine.GetLength ()) <1) return FALSE;  // don't process empty string

	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}

	int nLen = strLine.GetLength ();
	if (nLen != m_GR7.m_totallen)
	{
		MessageBox(NULL,strfile_in+" is not in proper GR7 format.","ERROR", MB_OK);
		return FALSE;
	}
	// load member variables
	m_statur = strLine.Mid(m_GR7.m_staturoff ,m_GR7.m_staturlen ); // atoi(strLine.Mid(m_GR7.m_staturoff ,m_GR7.m_staturlen ));
	m_shldht = strLine.Mid(m_GR7.m_shldhtoff ,m_GR7.m_shldhtlen ); // atoi(strLine.Mid(m_GR7.m_shldhtoff ,m_GR7.m_shldhtlen ));
	m_vrtsym = strLine.Mid(m_GR7.m_vrtsymoff ,m_GR7.m_vrtsymlen ); // atoi(strLine.Mid(m_GR7.m_vrtsymoff ,m_GR7.m_vrtsymlen ));
	m_wastht = strLine.Mid(m_GR7.m_wasthtoff ,m_GR7.m_wasthtlen ); // atoi(strLine.Mid(m_GR7.m_wasthtoff ,m_GR7.m_wasthtlen ));
	m_shldbd = strLine.Mid(m_GR7.m_shldbdoff ,m_GR7.m_shldbdlen ); // atoi(strLine.Mid(m_GR7.m_shldbdoff ,m_GR7.m_shldbdlen ));
	m_chstbd = strLine.Mid(m_GR7.m_chstbdoff ,m_GR7.m_chstbdlen ); // atoi(strLine.Mid(m_GR7.m_chstbdoff ,m_GR7.m_chstbdlen ));
	m_wastbd = strLine.Mid(m_GR7.m_wastbdoff ,m_GR7.m_wastbdlen ); // atoi(strLine.Mid(m_GR7.m_wastbdoff ,m_GR7.m_wastbdlen ));
	m_hipbd  = strLine.Mid(m_GR7.m_hipbdoff ,m_GR7.m_hipbdlen ); // atoi(strLine.Mid(m_GR7.m_hipbdoff ,m_GR7.m_hipbdlen ));
	m_shldel = strLine.Mid(m_GR7.m_shldeloff ,m_GR7.m_shldellen ); // atoi(strLine.Mid(m_GR7.m_shldeloff ,m_GR7.m_shldellen ));
	m_farmhd = strLine.Mid(m_GR7.m_farmhdoff ,m_GR7.m_farmhdlen ); // atoi(strLine.Mid(m_GR7.m_farmhdoff ,m_GR7.m_farmhdlen ));
	m_tiblht = strLine.Mid(m_GR7.m_tiblhtoff ,m_GR7.m_tiblhtlen ); // atoi(strLine.Mid(m_GR7.m_tiblhtoff ,m_GR7.m_tiblhtlen ));
	m_anklht = strLine.Mid(m_GR7.m_anklhtoff, m_GR7.m_anklhtlen ); // atoi(strLine.Mid(m_GR7.m_anklhtoff, m_GR7.m_anklhtlen ));
	m_footbd = strLine.Mid(m_GR7.m_footbdoff, m_GR7.m_footbdlen ); // atoi(strLine.Mid(m_GR7.m_footbdoff, m_GR7.m_footbdlen ));
	m_footln = strLine.Mid(m_GR7.m_footlnoff, m_GR7.m_footlnlen ); // atoi(strLine.Mid(m_GR7.m_footlnoff, m_GR7.m_footlnlen ));
	m_hdtroc = strLine.Mid(m_GR7.m_hdtrocoff, m_GR7.m_hdtroclen ); // atoi(strLine.Mid(m_GR7.m_hdtrocoff, m_GR7.m_hdtroclen ));
	m_seatht = strLine.Mid(m_GR7.m_seathtoff, m_GR7.m_seathtlen ); // atoi(strLine.Mid(m_GR7.m_seathtoff, m_GR7.m_seathtlen ));
	m_kneeht = strLine.Mid(m_GR7.m_kneehtoff, m_GR7.m_kneehtlen ); // atoi(strLine.Mid(m_GR7.m_kneehtoff, m_GR7.m_kneehtlen ));
	m_headln = strLine.Mid(m_GR7.m_headlnoff, m_GR7.m_headlnlen ); // atoi(strLine.Mid(m_GR7.m_headlnoff, m_GR7.m_headlnlen ));
	m_headbd = strLine.Mid(m_GR7.m_headbdoff, m_GR7.m_headbdlen ); // atoi(strLine.Mid(m_GR7.m_headbdoff, m_GR7.m_headbdlen ));
	m_headch = strLine.Mid(m_GR7.m_headchoff, m_GR7.m_headchlen ); // atoi(strLine.Mid(m_GR7.m_headchoff, m_GR7.m_headchlen ));
	m_bicpcr = strLine.Mid(m_GR7.m_bicpcroff, m_GR7.m_bicpcrlen ); // atoi(strLine.Mid(m_GR7.m_bicpcroff, m_GR7.m_bicpcrlen ));
	m_elbwcr = strLine.Mid(m_GR7.m_elbwcroff, m_GR7.m_elbwcrlen ); // atoi(strLine.Mid(m_GR7.m_elbwcroff, m_GR7.m_elbwcrlen ));
	m_farmcr = strLine.Mid(m_GR7.m_farmcroff, m_GR7.m_farmcrlen ); // atoi(strLine.Mid(m_GR7.m_farmcroff, m_GR7.m_farmcrlen ));
	m_wrstcr = strLine.Mid(m_GR7.m_wrstcroff, m_GR7.m_wrstcrlen ); // atoi(strLine.Mid(m_GR7.m_wrstcroff, m_GR7.m_wrstcrlen ));
	m_thghcr = strLine.Mid(m_GR7.m_thghcroff, m_GR7.m_thghcrlen ); // atoi(strLine.Mid(m_GR7.m_thghcroff, m_GR7.m_thghcrlen ));
	m_ltghcr = strLine.Mid(m_GR7.m_lthgcroff, m_GR7.m_lthgcrlen ); // atoi(strLine.Mid(m_GR7.m_lthgcroff, m_GR7.m_lthgcrlen ));
	m_kneecr = strLine.Mid(m_GR7.m_kneecroff, m_GR7.m_kneecrlen ); // atoi(strLine.Mid(m_GR7.m_kneecroff, m_GR7.m_kneecrlen ));
	m_calfcr = strLine.Mid(m_GR7.m_calfcroff, m_GR7.m_calfcrlen ); // atoi(strLine.Mid(m_GR7.m_calfcroff, m_GR7.m_calfcrlen ));
	m_anklcr = strLine.Mid(m_GR7.m_anklcroff, m_GR7.m_anklcrlen ); // atoi(strLine.Mid(m_GR7.m_anklcroff, m_GR7.m_anklcrlen ));
	m_neckcr = strLine.Mid(m_GR7.m_neckcroff, m_GR7.m_neckcrlen ); // atoi(strLine.Mid(m_GR7.m_neckcroff, m_GR7.m_neckcrlen ));
	m_scyecr = strLine.Mid(m_GR7.m_scyecroff, m_GR7.m_scyecrlen ); // atoi(strLine.Mid(m_GR7.m_scyecroff, m_GR7.m_scyecrlen ));
	m_chstcr = strLine.Mid(m_GR7.m_chstcroff, m_GR7.m_chstcrlen ); // atoi(strLine.Mid(m_GR7.m_chstcroff, m_GR7.m_chstcrlen ));
	m_wastcr = strLine.Mid(m_GR7.m_wastcroff, m_GR7.m_wastcrlen ); // atoi(strLine.Mid(m_GR7.m_wastcroff, m_GR7.m_wastcrlen ));
	m_buttcr = strLine.Mid(m_GR7.m_buttcroff, m_GR7.m_buttcrlen ); // atoi(strLine.Mid(m_GR7.m_buttcroff, m_GR7.m_buttcrlen ));
	m_chstdp = strLine.Mid(m_GR7.m_chstdpoff, m_GR7.m_chstdplen ); // atoi(strLine.Mid(m_GR7.m_chstdpoff, m_GR7.m_chstdplen ));
	m_wastdp = strLine.Mid(m_GR7.m_wastdpoff, m_GR7.m_wastdplen ); // atoi(strLine.Mid(m_GR7.m_wastdpoff, m_GR7.m_wastdplen ));
	m_buttdp = strLine.Mid(m_GR7.m_buttdpoff, m_GR7.m_buttdplen ); // atoi(strLine.Mid(m_GR7.m_buttdpoff, m_GR7.m_buttdplen ));
	m_inscye = strLine.Mid(m_GR7.m_insyceoff, m_GR7.m_insycelen ); // atoi(strLine.Mid(m_GR7.m_insyceoff, m_GR7.m_insycelen ));

	return TRUE;

}

// ------------------------------------
// short ImportGR8(CString&)
// Description:  Opens GR8 file. Sets BioData member vars with
//               Data found there, using the offsets defined in
//               BioGR8.h
// ------------------------------------
short CBioData::ImportGR8(CString & strfile_in)
{
	CStdioFile myFile;
	CFileException fileException;
	
	myFile.Open( strfile_in, CFile::modeRead | CFile::typeText,
		&fileException );
	if (!myFile.m_pStream)  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_in, fileException.m_cause );
		MessageBox(NULL,msg,"Error",MB_OK);
		return FALSE;
	}

	CString strLine;
	short loop = 1;

	while(myFile.ReadString (strLine))
	{
		if ((strLine.GetLength ()) <1) return 0;  // don't process empty string

		while (strLine[0]=='#')  //comment line, so read another.
		{
			myFile.ReadString (strLine);	
		}

		int nLen = strLine.GetLength ();
		if (nLen != m_GR8.m_totallen)
		{
			MessageBox(NULL,strfile_in+" is not in proper GR8 format.","ERROR", MB_OK);
			return 0;
		}
		
		// load member variables  
		
		m_bodyrg.SetAtGrow(loop, strLine.Mid(m_GR8.m_bodyrgoff, m_GR8.m_bodyrglen ));
		m_aspect.SetAtGrow(loop, strLine.Mid(m_GR8.m_aspectoff, m_GR8.m_aspectlen ));
		m_lesion.SetAtGrow(loop, strLine.Mid(m_GR8.m_lesionoff, m_GR8.m_lesionlen ));
		m_sysorg.SetAtGrow(loop, strLine.Mid(m_GR8.m_sysorgoff, m_GR8.m_sysorglen ));
		m_ais.SetAtGrow(loop, strLine.Mid(m_GR8.m_aisoff, m_GR8.m_aislen ));
		// ais90 not in GR8, so set a default value.
		m_ais90.SetAtGrow(loop,"");
		m_injcom.SetAtGrow(loop, strLine.Mid(m_GR8.m_injtxtoff, m_GR8.m_injtxtlen ));
		
		loop++;
	}

	return --loop;

}

const CString CBioData::IntString(PCSTR sStr)
{
	CString str(sStr); 
	str.TrimLeft(); str.TrimRight();
	if (str=="") { return ""; }

	if ( (!isdigit(str[0])) && (str[0]!='-') ) { return ""; }
	int nLen = str.GetLength();
	for (int i=1; i<nLen; i++)
	{
		if (!isdigit(str[0])) { return ""; }
	}
	if (str[--nLen]=='.') { str = str.Left(nLen); }
	return str;
}	// IntString


const CString CBioData::NumberString(PCSTR sStr)
{
	CString str(sStr); 
	str.TrimLeft(); str.TrimRight();
	if (str=="") { return ""; }

	int dotIndex = 0;

	if ( ((str[0]<48)||(str[0]>57)) && (str[0]!='-') ) { return ""; }
	int nLen = str.GetLength();
	for (int i=1; i<nLen; i++)
	{
		if (str[i]==46) 
		{
			if (dotIndex==0) { dotIndex++; }
			else return "";
		}
		else if (str[i]=='E' || str[i]=='e')	// scientific notation
		{
			if ( (str[++i]!='+') && (str[i]!='-') ) { return ""; }
		}
		else if ( (str[i]<48)||(str[i]>57) ) { return ""; }
	}

	if (str[--nLen]=='.') { str = str.Left(nLen); }
	return str;
}	// NumberString

// ------------------------------------
// short ImportGRY(CString&)
// Description:  Opens GRY file. Sets BioData member vars with
//               Data found there, using the offsets defined in
//               BioGRY.h
// ------------------------------------
short CBioData::ImportGRY(CString & strfile_in)
{
	CStdioFile myFile;
	CFileException fileException;
	
	myFile.Open( strfile_in, CFile::modeRead | CFile::typeText,
		&fileException );
	if (!myFile.m_pStream)  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_in, fileException.m_cause );
		MessageBox(NULL,msg,"Error",MB_OK);
		return FALSE;
	}

	CString strLine;
	short loop = 1;

	while(myFile.ReadString (strLine))
	{	
		if ((strLine.GetLength ()) <1) return 0;  // don't process empty string

		while (strLine[0]=='#')  //comment line, so read another.
		{
			myFile.ReadString (strLine);	
		}

		int nLen = strLine.GetLength ();
		if (nLen==12) { strLine += " "; }	// wong for freer formats
		else if (nLen==11) { strLine += "  "; }
		if (nLen != m_GRY.m_totallen)
		{
			MessageBox(NULL,strfile_in+" is not in proper GRY format.","ERROR", MB_OK);
			return 0;
		}
		
		// load member variables  

		CString sBandno = IntString(strLine.Mid(m_GRY.m_bandnooff, m_GRY.m_bandnolen ));
		CString sGagno	= IntString(strLine.Mid(m_GRY.m_gagnooff, m_GRY.m_gagnolen ));
		CString sGagdis = NumberString(strLine.Mid(m_GRY.m_gagdisoff, m_GRY.m_gagdislen ));
		CString sCurno	= IntString(strLine.Mid(m_GRY.m_curnooff, m_GRY.m_curnolen ));

		m_Gauge_bandno.SetAtGrow(loop, sBandno);
		m_gageno.SetAtGrow(loop, sGagno);
		m_gagdis.SetAtGrow(loop, sGagdis);
		m_Gauge_curno.SetAtGrow(loop, sCurno);

		// gagcom isnt in GRY, so set a default to avoid access violations
		m_gagcom.SetAtGrow(loop, "");

		loop++;
	}
	

	return --loop;
}

// ------------------------------------
// short ImportGRZ(CString&)
// Description:  Opens GRZ file. Sets BioData member vars with
//               Data found there, using the offsets defined in
//               BioGRZ.h
// ------------------------------------
short CBioData::ImportGRZ(CString & strfile_in)
{
	CStdioFile myFile;
	CFileException fileException;
	
	myFile.Open( strfile_in, CFile::modeRead | CFile::typeText,
		&fileException );
	if (!myFile.m_pStream)  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_in, fileException.m_cause );
		MessageBox(NULL,msg,"Error",MB_OK);
		return FALSE;
	}

	CString strLine;
	short loop = 1;

	while((myFile.ReadString (strLine)) && (loop<= MAXCBANDS))
	{
		while (strLine[0]=='#')  //comment line, so read another.
		{
			myFile.ReadString (strLine);	
		}

		int nLen = strLine.GetLength ();
		if (nLen != m_GRZ.m_totallen)
		{
			MessageBox(NULL,strfile_in+" is not in proper GRZ format.","ERROR", MB_OK);
			return 0;
		}
		
		// load member variables  
	
		m_chsdpt.SetAtGrow(loop, strLine.Mid(m_GRZ.m_chsdptoff, m_GRZ.m_chsdptlen )); // atoi(strLine.Mid(m_GRZ.m_chsdptoff, m_GRZ.m_chsdptlen )));
		m_chsbrd.SetAtGrow(loop, strLine.Mid(m_GRZ.m_chsbrdoff, m_GRZ.m_chsbrdlen )); // atoi(strLine.Mid(m_GRZ.m_chsbrdoff, m_GRZ.m_chsbrdlen )));
		m_banlen.SetAtGrow(loop, strLine.Mid(m_GRZ.m_banlenoff, m_GRZ.m_banlenlen )); // atoi(strLine.Mid(m_GRZ.m_banlenoff, m_GRZ.m_banlenlen )));
		m_antloc.SetAtGrow(loop, strLine.Mid(m_GRZ.m_antlocoff, m_GRZ.m_antloclen ));
		m_posloc.SetAtGrow(loop, strLine.Mid(m_GRZ.m_poslocoff, m_GRZ.m_posloclen ));
		m_gagstr.SetAtGrow(loop, strLine.Mid(m_GRZ.m_gagstroff, m_GRZ.m_gagstrlen )); // atoi(strLine.Mid(m_GRZ.m_gagstroff, m_GRZ.m_gagstrlen )));
		m_disstr.SetAtGrow(loop, strLine.Mid(m_GRZ.m_disstroff, m_GRZ.m_disstrlen )); // atoi(strLine.Mid(m_GRZ.m_disstroff, m_GRZ.m_disstrlen )));
		m_gagspn.SetAtGrow(loop, strLine.Mid(m_GRZ.m_gagspnoff, m_GRZ.m_gagspnlen )); // atoi(strLine.Mid(m_GRZ.m_gagspnoff, m_GRZ.m_gagspnlen )));
		m_disspn.SetAtGrow(loop, strLine.Mid(m_GRZ.m_disspnoff, m_GRZ.m_disspnlen )); // atoi(strLine.Mid(m_GRZ.m_disspnoff, m_GRZ.m_disspnlen )));
		m_totgag.SetAtGrow(loop, strLine.Mid(m_GRZ.m_totgagoff, m_GRZ.m_totgaglen )); // atoi(strLine.Mid(m_GRZ.m_totgagoff, m_GRZ.m_totgaglen )));
		// chbcom isnt in GRZ, so set to default
		m_chbcom.SetAtGrow(loop, "");
		
		loop++;
	}

	return --loop;
}

// ------------
// ExtractDumData() 
// This function finds and separates the Dum Data in an ev* file
// if any, and fills in BioData with those values
// ------------
void CBioData::ExtractDumDataFromEV4(CStdioFile& myFile)
{
	CString strLine;
	myFile.SeekToBegin ();  // back to beginning

	// find ----- DUMMY OCCUPANT -----
	int nRes = -1;
	while (myFile.ReadString (strLine))
	{
		nRes = strLine.Find("----- DUMMY OCCUPANT -----");
		if (nRes != -1) break;
	}

	if (nRes==-1) 
	{
		return; // Dummy not found.
	}

	// now read line after ----- DUMMY OCCUPANT -----
	myFile.ReadString (strLine);	

	if ((strLine.GetLength ()) <1) 
	{
		return;  // don't process empty string
	}
	
	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}

	int loc1 = strLine.Find ('|',0);

	if (loc1==-1) 
	{
		return;      // | not found in line after ----- DUMMY OCCUPANT -----,
				     // must be another section, so return.
	}
	//21 pipes EV4
	int nPipes = CountPipes(strLine);
	
	if (nPipes!= 21)
	{
		char buf [10];
		itoa (nPipes,buf,10);
		CString strPipes = buf;
		CString strErr = "This EV4 file has "+strPipes +" | characters in the DUMMY OCCUPANT section, should have 21.";
		MessageBox(NULL, strErr, "Error",MB_OK);
		return;
	}

	m_doccloc = GetTextBetweenPipes(strLine,1,2);
	m_occtyp = GetTextBetweenPipes(strLine,2,3);
	m_doccsex = GetTextBetweenPipes(strLine,3,4);
	m_mthcal = GetTextBetweenPipes(strLine,4,5);
	m_dumsiz = GetTextBetweenPipes(strLine,5,6);
	m_dumman = GetTextBetweenPipes(strLine,6,7);
	m_dummod = GetTextBetweenPipes(strLine,7,8);
	m_dumdsc = GetTextBetweenPipes(strLine,8,9);
	m_dseposn = GetTextBetweenPipes(strLine,9,10);
	m_hic = GetTextBetweenPipes(strLine,10,11);
	m_t1 = GetTextBetweenPipes(strLine,11,12);
	m_t2 = GetTextBetweenPipes(strLine,12,13);
	m_clip3m = GetTextBetweenPipes(strLine,13,14);
	m_lfem = GetTextBetweenPipes(strLine,14,15);
	m_rfem = GetTextBetweenPipes(strLine,15,16);
	m_csi = GetTextBetweenPipes(strLine,16,17);
	m_lbelt = GetTextBetweenPipes(strLine,17,18);
	m_sbelt = GetTextBetweenPipes(strLine,18,19);
	m_tti = GetTextBetweenPipes(strLine,19,20);
	m_pelvg = GetTextBetweenPipes(strLine,20,21);
	m_doccom = GetTextBetweenPipes(strLine,21,22);

}
