// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: BioDumPage.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description:  Member functions of CBioDumPage.
//               They relate to the loading and display of 
//               data on this page.
//  Date		Who			Description
//	2000    Y. Wong Adding business rules (range requirement), recode all edit boxs
//					and correct other errors.
//	06/2003 Y. Wong chnage tool tip control
// -----------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "BioDumPage.h"
#include "search.h"
#include "CodeValidation.h"

#ifdef _DEBUG
//#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CString search_code;

/////////////////////////////////////////////////////////////////////////////
// CBioDumPage property page

IMPLEMENT_DYNCREATE(CBioDumPage, CPropertyPage)

CBioDumPage::CBioDumPage() : CPropertyPage(CBioDumPage::IDD)
{
	//{{AFX_DATA_INIT(CBioDumPage)
	m_editdoccloc = _T("");
	m_editdoccom = _T("");
	m_editdoccsex = _T("");
	m_editdumdsc = _T("");
	m_editdumman = _T("");
	m_editdummod = _T("");
	m_editdumsiz = _T("");
	m_editmthcal = _T("");
	m_editdseposn = _T("");
	m_editlfem = _T("");
	m_editrfem = _T("");
	m_editbelt = _T("");
	m_editsbelt = _T("");
	m_editdcompwt = _T("");
	m_editvc = _T("");
	m_editcmax = _T("");
	m_editnij = _T("");
	m_editcti = _T("");
	m_edithic = _T("");
	m_editt1 = _T("");
	m_editt2 = _T("");
	m_editclip3m = _T("");
	m_edittti = _T("");
	m_editcsi = _T("");
	m_editpelvg = _T("");
	//}}AFX_DATA_INIT
}

CBioDumPage::~CBioDumPage()
{
}

void CBioDumPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBioDumPage)
	DDX_Control(pDX, IDC_MTHCAL_SEARCH, m_mthcalsearch);
	DDX_Control(pDX, IDC_DUMSIZ_SEARCH, m_dumsizsearch);
	DDX_Control(pDX, IDC_DSEPOSN_SEARCH, m_dseposnsearch);
	DDX_Control(pDX, IDC_DOCCSEX_SEARCH, m_doccsexsearch);
	DDX_Control(pDX, IDC_DOCCLOC_SEARCH, m_docclocsearch);
	DDX_Control(pDX, IDC_BIODUMDOCCLOC, m_editdoccloc);
	DDX_Control(pDX, IDC_BIODUMDOCCOM, m_editdoccom);
	DDX_Control(pDX, IDC_BIODUMDOCCSEX, m_editdoccsex);
	DDX_Control(pDX, IDC_BIODUMDUMDSC, m_editdumdsc);
	DDX_Control(pDX, IDC_BIODUMDUMMAN, m_editdumman);
	DDX_Control(pDX, IDC_BIODUMDUMMOD, m_editdummod);
	DDX_Control(pDX, IDC_BIODUMDUMSIZ, m_editdumsiz);
	DDX_Control(pDX, IDC_BIODUMMTHCAL, m_editmthcal);
	DDX_Control(pDX, IDC_BIODUMDSEPOSN, m_editdseposn);
	DDX_Control(pDX, IDC_BIODUMLFEM, m_editlfem);
	DDX_Control(pDX, IDC_BIODUMRFEM, m_editrfem);
	DDX_Control(pDX, IDC_BIODUMLBELT, m_editbelt);
	DDX_Control(pDX, IDC_BIODUMSBELT, m_editsbelt);
	DDX_Control(pDX, IDC_BIODUMDCOMPWT, m_editdcompwt);
	DDX_Control(pDX, IDC_BIODUMVC, m_editvc);
	DDX_Control(pDX, IDC_BIODUMCMAX, m_editcmax);
	DDX_Control(pDX, IDC_BIODUMNIJ, m_editnij);
	DDX_Control(pDX, IDC_BIODUMCTI, m_editcti);
	DDX_Control(pDX, IDC_BIODUMHIC, m_edithic);
	DDX_Control(pDX, IDC_BIODUMT1, m_editt1);
	DDX_Control(pDX, IDC_BIODUMT2, m_editt2);
	DDX_Control(pDX, IDC_BIODUMCLIP3M, m_editclip3m);
	DDX_Control(pDX, IDC_BIODUMTTI, m_edittti);
	DDX_Control(pDX, IDC_BIODUMCSI, m_editcsi);
	DDX_Control(pDX, IDC_BIODUMPELVG, m_editpelvg);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBioDumPage, CPropertyPage)
	//{{AFX_MSG_MAP(CBioDumPage)
	ON_BN_CLICKED(IDC_DOCCLOC_SEARCH, OnDocclocSearch)
	ON_BN_CLICKED(IDC_DOCCSEX_SEARCH, OnDoccsexSearch)
	ON_BN_CLICKED(IDC_DSEPOSN_SEARCH, OnDseposnSearch)
	ON_BN_CLICKED(IDC_MTHCAL_SEARCH, OnMthcalSearch)
	ON_BN_CLICKED(IDC_DUMSIZ_SEARCH, OnDumsizSearch)
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTW, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTA, 0, 0xFFFF, OnToolTipNotify )
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBioDumPage message handlers

// CBioDumPage message handlers

BOOL CBioDumPage::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
	TOOLTIPTEXTA* pTTTA = (TOOLTIPTEXTA*)pNMHDR;
	TOOLTIPTEXTW* pTTTW = (TOOLTIPTEXTW*)pNMHDR;
	CString strTipText;
	UINT nID = pNMHDR->idFrom;
	if (pNMHDR->code == TTN_NEEDTEXTA && (pTTTA->uFlags & TTF_IDISHWND) ||
		pNMHDR->code == TTN_NEEDTEXTW && (pTTTW->uFlags & TTF_IDISHWND))
	{
		// idFrom is actually the HWND of the tool
		nID = ::GetDlgCtrlID((HWND)nID);
	}

	if (nID != 0) // will be zero on a separator
	{
		strTipText.Format("Control ID = %d", nID);
		switch (nID)
			{
			case IDC_BIODUMHIC:
				strTipText = "0->9999";
				break;
			case IDC_BIODUMCLIP3M:
				strTipText = "Acceleration (g, 0.0->99999.9)";
				break;
			case IDC_BIODUMLFEM:
				strTipText = "Newtons (-99999->0)";
				break;
			case IDC_BIODUMRFEM:
				strTipText = "Newtons (-99999->0)";
				break;
			case IDC_BIODUMCSI:
				strTipText = "0->9999";
				break;
			case IDC_BIODUMLBELT:
				strTipText = "Newtons (0->99999)";
				break;
			case IDC_BIODUMSBELT:
				strTipText = "Newtons (0->99999)";
				break;
			case IDC_BIODUMT1:
				strTipText = "Milliseconds (0.0->999999.9)";
				break;
			case IDC_BIODUMT2:
				strTipText = "Milliseconds (0.0->999999.9)";
				break;
			case IDC_BIODUMPELVG:
				strTipText = "Acceleration (g, 0.0->99999.9)";
				break;
			case IDC_BIODUMDCOMPWT:
				strTipText = "0.0->999";
				break;
			case IDC_BIODUMVC:
				strTipText = "m/s (00.00->99.99)";
				break;
			case IDC_BIODUMCMAX:
				strTipText = "0->9999";
				break;
			case IDC_BIODUMTTI:
				strTipText = "00000.00->99999.99";
				break;
			default: strTipText = "";
			}
	}

	if (pNMHDR->code == TTN_NEEDTEXTA)
		lstrcpyn(pTTTA->szText, strTipText, sizeof(pTTTA->szText));
	else
		::MultiByteToWideChar( CP_ACP , 0, strTipText, -1, pTTTW->szText, sizeof(pTTTW->szText) );
	*pResult = 0;

	return TRUE;    // message was handled

}

BOOL CBioDumPage::OnKillActive() 
{	
	if( ValidateDumPage() == true )
	{
		LoadBioDumData();

		return CPropertyPage::OnKillActive();
	}
	else
	{
		// Error are found on AnthPage.
		return FALSE;
	}
}

BOOL CBioDumPage::OnSetActive() 
{
	EnableControls();

	SetBusinessRules();

	DisplayBioDumData();

	ValidateDumPage();
	
	return CPropertyPage::OnSetActive();
}

BOOL CBioDumPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	EnableToolTips(TRUE);   // enable tool tips for view
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

// -------------------
// CBioDumPage::EnableControls()
// If Dummy occupant, this page's controls are activated.  Otherwise,
// they are disabled. Note: there is no occupant type for B4.
// -------------------
void CBioDumPage::EnableControls()
{
	HWND temphwnd;

	if ( ((m_pBioData->m_occtyp == "") ||
		 (m_pBioData->m_occtyp == "AN") ||
	     (m_pBioData->m_occtyp == "CD") ||
		 (m_pBioData->m_occtyp == "HU")) /*&& (m_pBioData->m_verno != "B4")*/ )//not dummy, disable
	{
		m_mthcalsearch.EnableWindow (FALSE);
		m_dumsizsearch.EnableWindow(FALSE);
		m_dseposnsearch.EnableWindow (FALSE);
		m_doccsexsearch.EnableWindow (FALSE);
		m_docclocsearch.EnableWindow (FALSE);

		temphwnd = ::GetDlgItem(m_hWnd,IDC_BIODUMLFEM);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMRFEM);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMLBELT);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd,IDC_BIODUMSBELT);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMDUMMAN);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMDUMMOD);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMDUMDSC);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMDOCCOM);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMDCOMPWT);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMVC);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMCMAX);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMNIJ);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMCTI);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMHIC);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMT1);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMT2);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMCLIP3M);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMTTI);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMCSI);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMPELVG);
		::EnableWindow (temphwnd, FALSE);

	}
	else  // otherwise, enable
	{
		m_mthcalsearch.EnableWindow (TRUE);
		m_dumsizsearch.EnableWindow(TRUE);
		m_dseposnsearch.EnableWindow (TRUE);
		m_doccsexsearch.EnableWindow (TRUE);
		m_docclocsearch.EnableWindow (TRUE);

		temphwnd = ::GetDlgItem(m_hWnd,IDC_BIODUMLFEM);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMRFEM);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMLBELT);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd,IDC_BIODUMSBELT);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMDUMMAN);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMDUMMOD);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMDUMDSC);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMDOCCOM);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMDCOMPWT);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMVC);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMCMAX);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMNIJ);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMCTI);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMHIC);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMT1);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMT2);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMCLIP3M);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMTTI);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMCSI);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIODUMPELVG);
		::EnableWindow (temphwnd, TRUE);
	}
}

void CBioDumPage::OnDocclocSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }
	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"DOCCLOC","BIODB");
	if (search.DoModal ()==IDOK)
	{
		m_editdoccloc = search_code;
		m_editdoccloc.SetValidateColor();
	}
	UpdateData(FALSE);
}

void CBioDumPage::OnDoccsexSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

//	CSearch search(NULL,"OCCSEX","BIODB");
	CSearch search(NULL,"DOCCSEX","BIODB");
	if (search.DoModal ()==IDOK)
	{
		m_editdoccsex = search_code;
		m_editdoccsex.SetValidateColor();
	}
	UpdateData(FALSE);
}

void CBioDumPage::OnDseposnSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"DSEPOSN","BIODB");
	if (search.DoModal ()==IDOK)
	{
		m_editdseposn = search_code;
		m_editdseposn.SetValidateColor();
	}
	UpdateData(FALSE);
}

void CBioDumPage::OnMthcalSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"MTHCAL","BIODB");
	if (search.DoModal ()==IDOK)
	{
		m_editmthcal = search_code;
		m_editmthcal.SetValidateColor();
	}
	UpdateData(FALSE);
}

void CBioDumPage::OnDumsizSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"DUMSIZ","BIODB");
	if (search.DoModal ()==IDOK)
	{
		m_editdumsiz = search_code;
		m_editdumsiz.SetValidateColor();
	}
	UpdateData(FALSE);
}

//  This function gets the data from the entry fields and puts it into 
//  m_pBioData.  It is called in OnKillActive, ExportData, record changed.
BOOL CBioDumPage::LoadBioDumData()
{
	if (m_hWnd==NULL) return TRUE; //only return FALSE if data invalid
	
	if (!UpdateData(TRUE)) return FALSE;
	m_pBioData->m_clip3m = m_editclip3m.GetTextAsString();
	m_pBioData->m_cmax = m_editcmax.GetTextAsString();
	m_pBioData->m_csi = m_editcsi.GetTextAsString();
	m_pBioData->m_cti = m_editcti.GetTextAsString();
	m_pBioData->m_dcompwt = m_editdcompwt.GetTextAsString();
	m_pBioData->m_doccloc = m_editdoccloc.GetTextAsString();
	m_pBioData->m_doccom = m_editdoccom.GetTextAsString();
	m_pBioData->m_doccsex = m_editdoccsex.GetTextAsString();
	m_pBioData->m_dumdsc = m_editdumdsc.GetTextAsString();
	m_pBioData->m_dumman = m_editdumman.GetTextAsString();
	m_pBioData->m_dummod = m_editdummod.GetTextAsString();
	m_pBioData->m_dumsiz = m_editdumsiz.GetTextAsString();
	m_pBioData->m_hic = m_edithic.GetTextAsString();
	m_pBioData->m_lbelt = m_editbelt.GetTextAsString();
	m_pBioData->m_lfem = m_editlfem.GetTextAsString();
	m_pBioData->m_mthcal = m_editmthcal.GetTextAsString();
	m_pBioData->m_nij = m_editnij.GetTextAsString();
	m_pBioData->m_pelvg = m_editpelvg.GetTextAsString();
	m_pBioData->m_rfem = m_editrfem.GetTextAsString();
	m_pBioData->m_sbelt = m_editsbelt.GetTextAsString();
	m_pBioData->m_t1 = m_editt1.GetTextAsString();
	m_pBioData->m_t2 = m_editt2.GetTextAsString();
	m_pBioData->m_tti = m_edittti.GetTextAsString();
	m_pBioData->m_vc = m_editvc.GetTextAsString();
	m_pBioData->m_dseposn = m_editdseposn.GetTextAsString();
	
	return TRUE;
}

//Get dummy data from m_pBioData and display it.
void CBioDumPage::DisplayBioDumData()
{
	m_editclip3m	= m_pBioData->m_clip3m;
	m_editcmax		= m_pBioData->m_cmax;	
	m_editcsi		= m_pBioData->m_csi;
	m_editcti		= m_pBioData->m_cti;
	m_editdcompwt	= m_pBioData->m_dcompwt;

	m_editdoccloc	= m_pBioData->m_doccloc;
	m_editdoccom	= m_pBioData->m_doccom;
	m_editdoccsex	= m_pBioData->m_doccsex;
	m_editdumdsc	= m_pBioData->m_dumdsc;
    m_editdumman	= m_pBioData->m_dumman;

	m_editdummod	= m_pBioData->m_dummod;
	m_editdumsiz	= m_pBioData->m_dumsiz;
	m_edithic		= m_pBioData->m_hic;
	m_editbelt		= m_pBioData->m_lbelt;
	m_editlfem		= m_pBioData->m_lfem;

	m_editmthcal	= m_pBioData->m_mthcal;
	m_editnij		= m_pBioData->m_nij;
	m_editpelvg		= m_pBioData->m_pelvg;
	m_editrfem		= m_pBioData->m_rfem;
	m_editsbelt		= m_pBioData->m_sbelt;

	m_editt1		=  m_pBioData->m_t1;
	m_editt2		=  m_pBioData->m_t2;
	m_edittti		=  m_pBioData->m_tti;
	m_editvc		= m_pBioData->m_vc;	
	m_editdseposn	= m_pBioData->m_dseposn;

	CCodeValidation( m_editdoccloc, "DOCCLOC","BIODB" );
	CCodeValidation( m_editdoccsex, "DOCCSEX","BIODB" );
	CCodeValidation( m_editdseposn, "DSEPOSN","BIODB" );
	CCodeValidation( m_editmthcal, "MTHCAL","BIODB" );
	CCodeValidation( m_editdumsiz, "DUMSIZ","BIODB" );

	UpdateData(FALSE);

}

BOOL CBioDumPage::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	WinHelp(Dummy_Occupant);
	
	return TRUE;
}
//
bool CBioDumPage::ValidateDumPage( )
{
	const int nTotal = 23;
	bool bRetArray[nTotal];

	bRetArray[0] = m_editdoccom.GetValidate();
	bRetArray[1] = m_editdumdsc.GetValidate();
	bRetArray[2] = m_editdumman.GetValidate();
	bRetArray[3] = m_editdummod.GetValidate();
	bRetArray[4] = m_editlfem.GetValidate();

	bRetArray[5] = m_editrfem.GetValidate();
	bRetArray[6] = m_editbelt.GetValidate();
	bRetArray[7] = m_editsbelt.GetValidate();
	bRetArray[8] = m_editvc.GetValidate();
	bRetArray[9] = m_editdcompwt.GetValidate();

	bRetArray[10] = m_editcmax.GetValidate();
	bRetArray[11] = m_edithic.GetValidate();
	bRetArray[12] = m_editt1.GetValidate();
	bRetArray[13] = m_editt2.GetValidate();
	bRetArray[14] = m_editclip3m.GetValidate();

	bRetArray[15] = m_edittti.GetValidate();
	bRetArray[16] = m_editcsi.GetValidate();
	bRetArray[17] = m_editpelvg.GetValidate();
	
	bRetArray[18] = m_editdoccloc.GetValidate();
	bRetArray[19] = m_editdoccsex.GetValidate();
	bRetArray[20] = m_editdseposn.GetValidate();
	bRetArray[21] = m_editmthcal.GetValidate();
	bRetArray[22] = m_editdumsiz.GetValidate();

	for(int i=0; i<nTotal; i++) { if (!bRetArray[i]) return false; }
	return true;
}	// ValidateAnthPage

void CBioDumPage::SetBusinessRules( void )
{
	m_editdoccom.SetString( 0, 70 );
	m_editdumdsc.SetString( 0, 70 );
	m_editdumman.SetString( 0, 70 );
	m_editdummod.SetString( 0, 70 );
	m_editlfem.SetDouble( -99999, 0 );

	m_editrfem.SetDouble( -99999, 0 );
	m_editbelt.SetDouble( 0, 99999 );
	m_editsbelt.SetDouble( 0, 99999 );
	m_editdcompwt.SetDouble( 0.0f, 9999.99f );	// wong added 03/14/00
	m_editvc.SetDouble( 0.0f, 99.99f );

	m_editcmax.SetDouble( 0, 9999);
	m_edithic.SetDouble( 0, 9999);
	m_editt1.SetDouble( 0.0, 999999.9);
	m_editt2.SetDouble( 0.0, 999999.9);
	m_editclip3m.SetDouble( 0., 99999.9);

	m_edittti.SetDouble( 0., 99999.9);
	m_editcsi.SetDouble( 0, 9999);
	m_editpelvg.SetDouble( 0., 99999.9);

}	// SetBusinessRules