// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: BioGR7.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description: CBioGR7 constructor.  All this class does is
//              hold the offsets and lengths used for parsing data out of
//              a GR7 file.
// -----------------------------------------
#include "stdafx.h"
#include "entreeV5.h"
#include "BioGR7.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CBioGR7::CBioGR7()
{
	 m_vehnooff = 1;
	 m_vehnolen = 1;

	 m_occlocoff = 2;
	 m_occloclen = 2;

	 m_staturoff = 4;
	 m_staturlen = 5;

	 m_shldhtoff = 9;
	 m_shldhtlen = 5;

	 m_vrtsymoff = 14;
	 m_vrtsymlen = 5;

	 m_wasthtoff = 19;
	 m_wasthtlen = 5;

	 m_shldbdoff = 24;
	 m_shldbdlen = 5;

	 m_chstbdoff = 29;
	 m_chstbdlen = 5;

	 m_wastbdoff = 34;
	 m_wastbdlen = 5;

	 m_hipbdoff = 39;
	 m_hipbdlen = 5;

	 m_shldeloff = 44;
	 m_shldellen = 5;

	 m_farmhdoff = 49;
	 m_farmhdlen = 5;

	 m_tiblhtoff = 54;
	 m_tiblhtlen = 5;

	 m_anklhtoff = 59;
	 m_anklhtlen = 5;

	 m_footbdoff = 64;
	 m_footbdlen = 5;

	 m_footlnoff = 69;
	 m_footlnlen = 5;

	 m_hdtrocoff = 74; 
	 m_hdtroclen = 5;

	 m_seathtoff = 79;
	 m_seathtlen = 5;

	 m_kneehtoff = 84;
	 m_kneehtlen = 5;

	 m_headlnoff = 89;
	 m_headlnlen = 5;

	 m_headbdoff = 94;
	 m_headbdlen = 5;

	 m_headchoff = 99;
	 m_headchlen = 5;

	 m_bicpcroff = 104;
	 m_bicpcrlen = 5;

	 m_elbwcroff = 109;
	 m_elbwcrlen = 5;

	 m_farmcroff = 114;
	 m_farmcrlen = 5;

	 m_wrstcroff = 119;
	 m_wrstcrlen = 5;

	 m_thghcroff = 124;
	 m_thghcrlen = 5;

	 m_lthgcroff = 129;
	 m_lthgcrlen = 5;

	 m_kneecroff = 134;
	 m_kneecrlen = 5;

	 m_calfcroff = 139;
	 m_calfcrlen = 5;

	 m_anklcroff = 144;
	 m_anklcrlen = 5;

	 m_neckcroff = 149;
	 m_neckcrlen = 5;

	 m_scyecroff = 154;
	 m_scyecrlen = 5;

	 m_chstcroff = 159;
	 m_chstcrlen = 5;

	 m_wastcroff = 164;
	 m_wastcrlen = 5;

	 m_buttcroff = 169;
	 m_buttcrlen = 5;

	 m_chstdpoff = 174;
	 m_chstdplen = 5;

	 m_wastdpoff = 179;
	 m_wastdplen = 5;

	 m_buttdpoff = 184;
	 m_buttdplen = 5;

	 m_insyceoff = 189;
	 m_insycelen = 5;

	 m_totallen = 194;

}

CBioGR7::~CBioGR7()
{

}
