// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: BioGR8.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description: CBioGR8 constructor.  All this class does is
//              hold the offsets and lengths used for parsing data out of
//              a GR8 file.
// -----------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "BioGR8.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CBioGR8::CBioGR8()
{
	 m_vehnooff = 1;
	 m_vehnolen = 1;

	 m_occlocoff = 2;
	 m_occloclen = 2;

	 m_bodyrgoff = 4;
	 m_bodyrglen = 1;

	 m_aspectoff = 5;
	 m_aspectlen = 1;

	 m_lesionoff = 6;
	 m_lesionlen = 1;

	 m_sysorgoff = 7;
	 m_sysorglen = 1;

	 m_aisoff = 8;
	 m_aislen = 1;

	 m_injtxtoff = 9;
	 m_injtxtlen = 70;

	 m_totallen = 79;


}

CBioGR8::~CBioGR8()
{

}
