// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: BioGRZ.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description: CBioGRZ constructor.  All this class does is
//              hold the offsets and lengths used for parsing data out of
//              a GRZ file.
// -----------------------------------------
#include "stdafx.h"
#include "entreeV5.h"
#include "BioGRZ.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CBioGRZ::CBioGRZ()
{
	 m_bandnooff = 1;
	 m_bandnolen = 2;

	 m_chsdptoff = 3;
	 m_chsdptlen = 5;

	 m_chsbrdoff = 8;
	 m_chsbrdlen = 5;

	 m_banlenoff = 13;
	 m_banlenlen = 5;

	 m_antlocoff = 18;
	 m_antloclen = 4;

	 m_poslocoff = 22;
	 m_posloclen = 4;

	 m_gagstroff = 26;
	 m_gagstrlen = 3;

	 m_disstroff = 29;
	 m_disstrlen = 5; 

	 m_gagspnoff = 34;
	 m_gagspnlen = 3;

	 m_disspnoff = 37;
	 m_disspnlen = 5;

	 m_totgagoff = 42;
	 m_totgaglen = 2;

	 m_totallen = 44;

}

CBioGRZ::~CBioGRZ()
{

}
