// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: BioInjPage.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description:  Member functions of CBioInjPage.
//               They relate to the loading and display of 
//               data on this page.
//
//  Modification History:
//  Date		Who			Description
//	2000    Y. Wong Adding business rules, recode all edit boxs
//					and correct other errors.
// -----------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "BioInjPage.h"
#include "search.h"
#include "CodeValidation.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CString search_code;

/////////////////////////////////////////////////////////////////////////////
// CBioInjPage property page

IMPLEMENT_DYNCREATE(CBioInjPage, CPropertyPage)

CBioInjPage::CBioInjPage() : CPropertyPage(CBioInjPage::IDD)
{
	//{{AFX_DATA_INIT(CBioInjPage)
	m_editais = _T("");
	m_editaspect = _T("");
	m_editbodyrg = _T("");
	m_editinjcom = _T("");
	m_editlesion = _T("");
	m_editsysorg = _T("");
	m_retaindata = FALSE;
	m_editais90 = _T("");
	//}}AFX_DATA_INIT

	m_curinj= 0;     // Default to first inj.
}

CBioInjPage::~CBioInjPage()
{
}

void CBioInjPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBioInjPage)
	DDX_Control(pDX, IDC_INJLIST, m_injlist);
	DDX_Control(pDX, IDC_NEXTSET_BUTTON, m_nextsetbutton);
	DDX_Control(pDX, IDC_DELETE_BUTTON, m_deletebutton);
	DDX_Control(pDX, IDC_BIOINJAIS, m_editais);
	DDX_Control(pDX, IDC_BIOINJASPECT, m_editaspect);
	DDX_Control(pDX, IDC_BIOINJBODYRG, m_editbodyrg);
	DDX_Control(pDX, IDC_BIOINJINJCOM, m_editinjcom);
//	DDV_MaxChars(pDX, m_injcom, 70);
	DDX_Control(pDX, IDC_BIOINJLESION, m_editlesion);
	DDX_Control(pDX, IDC_BIOINJSYSORG, m_editsysorg);
	DDX_Check(pDX, IDC_RETAINDATA, m_retaindata);
	DDX_Control(pDX, IDC_BIOINJAIS90, m_editais90);
//	DDV_MinMaxDouble(pDX, m_ais90, 0., 999999.9);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBioInjPage, CPropertyPage)
	//{{AFX_MSG_MAP(CBioInjPage)
	ON_BN_CLICKED(IDC_LESION_SEARCH, OnLesionSearch)
	ON_BN_CLICKED(IDC_SYSORG_SEARCH, OnSysorgSearch)
	ON_BN_CLICKED(IDC_BODYRG_SEARCH, OnBodyrgSearch)
	ON_BN_CLICKED(IDC_ASPECT_SEARCH, OnAspectSearch)
	ON_BN_CLICKED(IDC_AIS_SEARCH, OnAisSearch)
	ON_BN_CLICKED(IDC_NEXTSET_BUTTON, OnNextsetButton)
	ON_BN_CLICKED(IDC_DELETE_BUTTON, OnDeleteButton)
	ON_LBN_SELCHANGE(IDC_INJLIST, OnSelchangeInjlist)
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTW, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTA, 0, 0xFFFF, OnToolTipNotify )
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBioInjPage message handlers

BOOL CBioInjPage::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{	
	TOOLTIPTEXTA* pTTTA = (TOOLTIPTEXTA*)pNMHDR;
	TOOLTIPTEXTW* pTTTW = (TOOLTIPTEXTW*)pNMHDR;
	CString strTipText = "";
	UINT nID = pNMHDR->idFrom;
	if (pNMHDR->code == TTN_NEEDTEXTA && (pTTTA->uFlags & TTF_IDISHWND) ||
		pNMHDR->code == TTN_NEEDTEXTW && (pTTTW->uFlags & TTF_IDISHWND))
	{
		// idFrom is actually the HWND of the tool
		nID = ::GetDlgCtrlID((HWND)nID);
	}

	if (nID != 0) // will be zero on a separator
	{
		strTipText.Format("Control ID = %d", nID);
		switch (nID)
			{
			case IDC_NEXTSET_BUTTON:
				strTipText = "Go to or add next injury info set";
				break;
			case IDC_DELETE_BUTTON:
				strTipText = "Delete Injury info set";
				break;
			case IDC_BIOINJAIS90:
				strTipText = "0.0 -> 999999.9";
				break;
			default:
				strTipText = "";
			}
	}

	if (pNMHDR->code == TTN_NEEDTEXTA)
		lstrcpyn(pTTTA->szText, strTipText, sizeof(pTTTA->szText));
	else
		::MultiByteToWideChar( CP_ACP , 0, strTipText, -1, pTTTW->szText, sizeof(pTTTW->szText) );
	*pResult = 0;

	return TRUE;    // message was handled
}

void CBioInjPage::OnLesionSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"LESION","BIODB");
	if (search.DoModal ()==IDOK)
	{
		m_editlesion = search_code;
		m_editlesion.SetValidateColor();
	}
	UpdateData(FALSE);	
}

void CBioInjPage::OnSysorgSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"SYSORG","BIODB");
	if (search.DoModal ()==IDOK)
	{
		m_editsysorg = search_code;
		m_editsysorg.SetValidateColor();
	}
	UpdateData(FALSE);	
}

void CBioInjPage::OnBodyrgSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"BODYRG","BIODB");
	if (search.DoModal ()==IDOK)
	{
		m_editbodyrg = search_code;
		m_editbodyrg.SetValidateColor();
	}
	UpdateData(FALSE);	
}

void CBioInjPage::OnAspectSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"ASPECT","BIODB");
	if (search.DoModal ()==IDOK)
	{
		m_editaspect = search_code;
		m_editaspect.SetValidateColor();
	}
	UpdateData(FALSE);	
}

void CBioInjPage::OnAisSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"AIS","BIODB");
	if (search.DoModal ()==IDOK)
	{
		m_editais = search_code;
		m_editais.SetValidateColor();
	}
	UpdateData(FALSE);	
}

BOOL CBioInjPage::OnKillActive() 
{
	if( ValidateInjPage() == true )
	{
		LoadBioInjData();

		int nOldCurIndx = m_curinj;
		for (m_curinj=1; m_curinj<m_pBioData->m_injno+1; m_curinj++)
		{
			DisplayBioInjData();
			if (!ValidateInjPage()) { return false; }
		}
		m_curinj = nOldCurIndx;

		DisplayBioInjData();

		return CPropertyPage::OnKillActive();
	}
	else
	{
		// Error are found on AnthPage.
		return FALSE;
	}
}

BOOL CBioInjPage::OnSetActive() 
{
	EnableControls();

	m_curinj = max(m_pBioData->m_injno , 0) ; //initialize total curves.

	SetBusinessRules();

	DisplayBioInjData();

	ValidateInjPage();
	
	return CPropertyPage::OnSetActive();
}

BOOL CBioInjPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	EnableToolTips();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

// get data from m_pBioData and display it
void CBioInjPage::DisplayBioInjData()
{
	if (m_hWnd==NULL) return;

	UpdateCurveListbox();

	UpdateData();	// wong added in 03/01/00
	m_editais = m_pBioData->m_ais[m_curinj];

	m_editais90 = m_pBioData->m_ais90 [m_curinj];

	m_editaspect = m_pBioData->m_aspect[m_curinj];
	m_editbodyrg = m_pBioData->m_bodyrg[m_curinj];
	m_editinjcom = m_pBioData->m_injcom[m_curinj];
	m_editlesion = m_pBioData->m_lesion[m_curinj];
	m_editsysorg = m_pBioData->m_sysorg[m_curinj];

	CCodeValidation( m_editlesion, "LESION","BIODB" );
	CCodeValidation( m_editsysorg, "SYSORG","BIODB" );
	CCodeValidation( m_editbodyrg, "BODYRG","BIODB" );
	CCodeValidation( m_editaspect, "ASPECT","BIODB" );
	CCodeValidation( m_editais, "AIS","BIODB" );

	UpdateData(FALSE);
}

// This function gets data from the entry screen and puts it into m_pBioData
// It is called from OnKillActive, ExportData, and record changed.
BOOL CBioInjPage::LoadBioInjData()
{
	// put data into m_pBioData
	if (m_hWnd==NULL) return TRUE;  // only return FALSE if data invalid

	UpdateData();
	
	m_pBioData->m_injno = max(m_pBioData->m_injno, m_curinj); 

	m_pBioData->m_ais[m_curinj]		= m_editais.GetTextAsString();
	m_pBioData->m_ais90[m_curinj]	= m_editais90.GetTextAsString();
	m_pBioData->m_aspect[m_curinj]	= m_editaspect.GetTextAsString();
	m_pBioData->m_bodyrg[m_curinj]	= m_editbodyrg.GetTextAsString();
	m_pBioData->m_injcom[m_curinj]	= m_editinjcom.GetTextAsString();
	m_pBioData->m_lesion[m_curinj]	= m_editlesion.GetTextAsString();
	m_pBioData->m_sysorg[m_curinj]	= m_editsysorg.GetTextAsString();
	UpdateData(false);

	return TRUE;	
}

// wong code in 03/02/00
bool CBioInjPage::InsertBioInjData()
{
	if (m_hWnd==NULL) return TRUE;  // only return FALSE if data invalid
	
	UpdateData();
 
	m_pBioData->m_ais.InsertAt( m_curinj, m_editais.GetTextAsString());
	m_pBioData->m_ais90.InsertAt( m_curinj, m_editais90.GetTextAsString() );
	m_pBioData->m_aspect.InsertAt( m_curinj, m_editaspect.GetTextAsString() );
	m_pBioData->m_bodyrg.InsertAt( m_curinj, m_editbodyrg.GetTextAsString() );
	m_pBioData->m_injcom.InsertAt( m_curinj, m_editinjcom.GetTextAsString() );
	m_pBioData->m_lesion.InsertAt( m_curinj, m_editlesion.GetTextAsString() );
	m_pBioData->m_sysorg.InsertAt( m_curinj, m_editsysorg.GetTextAsString() );
	UpdateData(false);

	return true;
}	// InsertBioInjData

void CBioInjPage::OnNextsetButton() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	if (m_curinj==m_pBioData->m_injno) //if at end, increase # of curves
	{
		if (m_curinj!=0) { LoadBioInjData(); }
		m_pBioData->m_injno++; 
		m_curinj++;
		InitializeNextInj();
	} 
	else if (m_curinj != 0) 
	{
		if(!LoadBioInjData())
		{
			MessageBox("Error: see CBioInjPage::OnNextcurveButton()");
			return;
		}
		m_curinj++;
	}

	DisplayBioInjData();
	ValidateInjPage();

/**
	bool newinj=false;

	if (m_curinj>=m_pBioData->m_injno) 
	{
		newinj=true;
	}   

	if (m_curinj != 0) 
	{
//		if (!LoadBioInjData())     //load current info (not zeroth curve) // wong note: 03/01/00
		if (!InsertBioInjData())	// wong note: should insert not just load
		{
			return;
		}
	}
	
	m_curinj++;            //goto next inj 
	m_pBioData->m_injno++; //increment total injs.

	if (newinj) InitializeNextInj();

	DisplayBioInjData();  //display next set, if existing
	ValidateInjPage();
**/
}

void CBioInjPage::OnDeleteButton() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	if (m_curinj==0) { return;  }

	m_pBioData->m_injno--;

	m_pBioData->m_ais.RemoveAt(m_curinj);
	m_pBioData->m_ais90.RemoveAt(m_curinj);
	m_pBioData->m_aspect.RemoveAt(m_curinj);
	m_pBioData->m_bodyrg.RemoveAt(m_curinj);
	m_pBioData->m_injcom.RemoveAt(m_curinj);
	m_pBioData->m_lesion.RemoveAt(m_curinj);
	m_pBioData->m_sysorg.RemoveAt(m_curinj);
	

	m_curinj--;             //goto previous inj

	//if m_curset == 0 now, and there are remaining curves, set curve 1 as active (m_curset=1)
	if (m_curinj==0 && m_pBioData->m_injno>0)
	{
		m_curinj = 1;
	}
		
	DisplayBioInjData();  //display previous set, if existing		
}

// New Inj Set, so expand arrays in m_pBioData to hold info.
void CBioInjPage::InitializeNextInj()
{

	// *******************************************
	//These temp variables are used because the reference that [] returns is invalid when SetAtGrow
	// happens, because SetAtGrow (sometimes) moves the array to a different location in memory.   
	// If you try to use that reference directly, you will get an access violation.
	// For Example:  m_pBioData->m_injcom.SetAtGrow (m_curinj,m_pBioData->injcom[m_curinj-1]); //BAD!!!!
	CString strtemp; 
	CString dbltemp;    
	// *******************************************

	if (m_retaindata)
	{
		strtemp = m_pBioData->m_ais[m_curinj -1];
		m_pBioData->m_ais.SetAtGrow(m_curinj, strtemp);

		dbltemp = m_pBioData->m_ais90[m_curinj -1];
		m_pBioData->m_ais90.SetAtGrow(m_curinj, dbltemp);
		
		strtemp = m_pBioData->m_aspect[m_curinj -1];
		m_pBioData->m_aspect.SetAtGrow(m_curinj, strtemp);

		strtemp = m_pBioData->m_bodyrg[m_curinj -1];
		m_pBioData->m_bodyrg.SetAtGrow(m_curinj, strtemp);

		strtemp = m_pBioData->m_injcom[m_curinj -1];
		m_pBioData->m_injcom.SetAtGrow(m_curinj, strtemp);

		strtemp = m_pBioData->m_lesion[m_curinj -1];
		m_pBioData->m_lesion.SetAtGrow(m_curinj, strtemp);

		strtemp = m_pBioData->m_sysorg[m_curinj -1];
		m_pBioData->m_sysorg.SetAtGrow(m_curinj, strtemp);

	}
	else
	{

		m_pBioData->m_ais.SetAtGrow(m_curinj, "");
		m_pBioData->m_ais90.SetAtGrow(m_curinj, "");
		m_pBioData->m_aspect.SetAtGrow(m_curinj, "");
		m_pBioData->m_bodyrg.SetAtGrow(m_curinj, "");
		m_pBioData->m_injcom.SetAtGrow(m_curinj, "");
		m_pBioData->m_lesion.SetAtGrow(m_curinj, "");
		m_pBioData->m_sysorg.SetAtGrow(m_curinj, "");

	}

}

// user clicked the curves listbox, so change to that curve
void CBioInjPage::OnSelchangeInjlist() 
{
	int nCurve = m_injlist.GetCurSel ();  //zero based
	if ( (nCurve<0)&&(nCurve>m_pBioData->m_injno) ) { return; }

	if (m_curinj != 0) 
	{
		BOOL success = LoadBioInjData();     //load current info (not zeroth curve)
		if (!success) //Data not valid, dont change curves.
		{
			m_injlist.SetCurSel (max(0,m_curinj-1));  // select current curve, zero based.
			MessageBox("Tracing Injlist");	// wong
			return;
		}
	}

	m_curinj= nCurve+1;             //goto current curve 

	DisplayBioInjData();  //display next set, if existing	
	ValidateInjPage( );	
}

void CBioInjPage::UpdateCurveListbox()
{
	if (m_injlist.GetCount ()!=m_pBioData->m_injno)
	{
		m_injlist.ResetContent();
		char crvbuf [10];
		for (int loop=1;loop <= m_pBioData->m_injno;loop++)
		{
			itoa(loop,crvbuf,10);
			if (m_injlist.FindString (-1,crvbuf)==LB_ERR)  //if buf isnt there already.
			{
				m_injlist.AddString(crvbuf);
			}
		}
	}

	m_injlist.SetCurSel (max(0,m_curinj-1));  // select current curve, zero based.
	
}

BOOL CBioInjPage::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	WinHelp(Occupant_Injury_Information);
	
	return TRUE;
}

// new  added
//
bool CBioInjPage::ValidateInjPage( )
{
	const int nTotal = 7;
	bool bRetArray[nTotal];

	bRetArray[0] = m_editinjcom.GetValidate(); 
	bRetArray[1] = m_editais90.GetValidate();
	
	bRetArray[2] = m_editlesion.GetValidate();
	bRetArray[3] = m_editsysorg.GetValidate();
	bRetArray[4] = m_editbodyrg.GetValidate();
	bRetArray[5] = m_editaspect.GetValidate();
	bRetArray[6] = m_editais.GetValidate();

	for(int i=0; i<nTotal; i++) { if (!bRetArray[i]) return false; }
	return true;
}	// ValidateAnthPage

void CBioInjPage::SetBusinessRules( )
{
	m_editinjcom.SetString( 0, 70 );	// type 1: set string
	m_editais90.SetDouble( 0., 999999.9 );

}	// SetBusinessRules

void CBioInjPage::EnableControls()
{
	HWND temphwnd;
	if ( (m_pBioData->m_occtyp == "") || ( (m_pBioData->m_occtyp != "AN") && 
	   (m_pBioData->m_occtyp != "CD") /*&& (m_pBioData->m_occtyp != "HU")*/ ) ) 
	{

		m_nextsetbutton.EnableWindow(false);
		m_deletebutton.EnableWindow(false);
		m_editais.EnableWindow(false);
		m_editaspect.EnableWindow(false);
		m_editbodyrg.EnableWindow(false);
		m_editinjcom.EnableWindow(false);
		m_editlesion.EnableWindow(false);
		m_editsysorg.EnableWindow(false);
		m_editais90.EnableWindow(false);

		temphwnd = ::GetDlgItem( m_hWnd, IDC_INJLIST );
		::EnableWindow ( temphwnd, false );
		temphwnd = ::GetDlgItem( m_hWnd, IDC_RETAINDATA );
		::EnableWindow ( temphwnd, false );

		temphwnd = ::GetDlgItem( m_hWnd, IDC_LESION_SEARCH );	
		::EnableWindow ( temphwnd, false );
		temphwnd = ::GetDlgItem( m_hWnd, IDC_SYSORG_SEARCH );	
		::EnableWindow ( temphwnd, false );
		temphwnd = ::GetDlgItem( m_hWnd, IDC_BODYRG_SEARCH );	
		::EnableWindow ( temphwnd, false );
		temphwnd = ::GetDlgItem( m_hWnd, IDC_ASPECT_SEARCH );	
		::EnableWindow ( temphwnd, false );
		temphwnd = ::GetDlgItem( m_hWnd, IDC_AIS_SEARCH );		
		::EnableWindow ( temphwnd, false );
		temphwnd = ::GetDlgItem( m_hWnd, IDC_NEXTSET_BUTTON );	
		::EnableWindow ( temphwnd, false );
		temphwnd = ::GetDlgItem( m_hWnd, IDC_DELETE_BUTTON );	
		::EnableWindow ( temphwnd, false );
		temphwnd = ::GetDlgItem( m_hWnd, IDC_INJLIST );

	}
	else   // enable.
	{
		m_nextsetbutton.EnableWindow(true);
		m_deletebutton.EnableWindow(true);
		m_editais.EnableWindow(true);
		m_editaspect.EnableWindow(true);
		m_editbodyrg.EnableWindow(true);
		m_editinjcom.EnableWindow(true);
		m_editlesion.EnableWindow(true);
		m_editsysorg.EnableWindow(true);
		m_editais90.EnableWindow(true);

		temphwnd = ::GetDlgItem( m_hWnd, IDC_INJLIST );
		::EnableWindow ( temphwnd, true );
		temphwnd = ::GetDlgItem( m_hWnd, IDC_RETAINDATA );
		::EnableWindow ( temphwnd, true );

		temphwnd = ::GetDlgItem( m_hWnd, IDC_LESION_SEARCH );	
		::EnableWindow ( temphwnd, true );
		temphwnd = ::GetDlgItem( m_hWnd, IDC_SYSORG_SEARCH );	
		::EnableWindow ( temphwnd, true );
		temphwnd = ::GetDlgItem( m_hWnd, IDC_BODYRG_SEARCH );	
		::EnableWindow ( temphwnd, true );
		temphwnd = ::GetDlgItem( m_hWnd, IDC_ASPECT_SEARCH );	
		::EnableWindow ( temphwnd, true );
		temphwnd = ::GetDlgItem( m_hWnd, IDC_AIS_SEARCH );		
		::EnableWindow ( temphwnd, true );
		temphwnd = ::GetDlgItem( m_hWnd, IDC_NEXTSET_BUTTON );	
		::EnableWindow ( temphwnd, true );
		temphwnd = ::GetDlgItem( m_hWnd, IDC_DELETE_BUTTON );	
		::EnableWindow ( temphwnd, true );
	}
}	// EnableControls
