// -----------------------------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: BioInstPage.cpp
//
// Author: Dan Robbins
// Date Created: October, 1998
// Update: Yeun Wong, 02 - 06, 2000
//
// Description:  Member functions of CBioInstPage.
//               They relate to the loading and display of 
//               data on this page.
//
//  Modification History:
//  Date		Who			Description
//	2000    Y. Wong Adding business rules, recode all edit boxs
//					and control logic
//					and correct other errors.
// -----------------------------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "BioInstPage.h"
#include "search.h"
#include "CodeValidation.h"

#ifdef _DEBUG
//#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CString search_code;

/////////////////////////////////////////////////////////////////////////////
// CBioInstPage property page

IMPLEMENT_DYNCREATE(CBioInstPage, CPropertyPage)

CBioInstPage::CBioInstPage() : CPropertyPage(CBioInstPage::IDD)
{
	//{{AFX_DATA_INIT(CBioInstPage)
	m_editaxis = _T("");
	m_editchstat = _T("");
	m_editdastat = _T("");
	m_editinscom = _T("");
	m_editinsman = _T("");
	m_editsenatt = _T("");
	m_editsenloc = _T("");
	m_editsentyp = _T("");
	m_editxunits = _T("");
	m_edityunits = _T("");
	m_retaindata = FALSE;
	m_editinsrat = _T("");
	m_editchlmax = _T("");
	m_editinivel = _T("");
	m_editnfp = _T("");
	m_editnlp = _T("");
	m_editdelt = _T("");
	m_editprefil = _T("");
	//}}AFX_DATA_INIT

	m_icurno= 0;     // Default to first curve.
}

CBioInstPage::~CBioInstPage()
{
}

void CBioInstPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBioInstPage)
	DDX_Control(pDX, IDC_BIOINSTDAT, m_editinstdate);
	DDX_Control(pDX, IDC_CURVELIST, m_curvelist);
	DDX_Control(pDX, IDC_AXIS_SEARCH, m_axissearch);
	DDX_Control(pDX, IDC_SENATT_SEARCH, m_senattsearch);
	DDX_Control(pDX, IDC_SENTYP_SEARCH, m_sentypsearch);
	DDX_Control(pDX, IDC_XUNITS_SEARCH, m_xunitssearch);
	DDX_Control(pDX, IDC_NEXTCURVE_BUTTON, m_nextcurve);
	DDX_Control(pDX, IDC_DELETE_BUTTON, m_deletebutton);
	DDX_Control(pDX, IDC_BIOINST_CALDAT, m_caldatctrl);
	DDX_Control(pDX, IDC_BIOINST_AXIS, m_editaxis);
	DDX_Control(pDX, IDC_BIOINST_CHSTAT, m_editchstat);
	DDX_Control(pDX, IDC_BIOINST_DASTAT, m_editdastat);
	DDX_Control(pDX, IDC_BIOINST_INSCOM, m_editinscom);
	DDX_Control(pDX, IDC_BIOINST_INSMAN, m_editinsman);
	DDX_Control(pDX, IDC_BIOINST_SENATT, m_editsenatt);
	DDX_Control(pDX, IDC_BIOINST_SENLOC, m_editsenloc);
	DDX_Control(pDX, IDC_BIOINST_SENTYP, m_editsentyp);
	DDX_Control(pDX, IDC_BIOINST_XUNITS, m_editxunits);
	DDX_Control(pDX, IDC_BIOINST_YUNITS, m_edityunits);
	DDX_Check(pDX, IDC_RETAINDATA, m_retaindata);
	DDX_Control(pDX, IDC_BIOINST_INSRAT, m_editinsrat);
	DDX_Control(pDX, IDC_BIOINST_CHLMAX, m_editchlmax);
	DDX_Control(pDX, IDC_BIOINST_INIVEL, m_editinivel);
	DDX_Control(pDX, IDC_BIOINST_NFP, m_editnfp);
	DDX_Control(pDX, IDC_BIOINST_NLP, m_editnlp);
	DDX_Control(pDX, IDC_BIOINST_DELT, m_editdelt);
	DDX_Control(pDX, IDC_BIOINST_PREFIL, m_editprefil);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBioInstPage, CPropertyPage)
	//{{AFX_MSG_MAP(CBioInstPage)
	ON_BN_CLICKED(IDC_NEXTCURVE_BUTTON, OnNextcurveButton)
	ON_BN_CLICKED(IDC_DELETE_BUTTON, OnDeleteButton)
	ON_BN_CLICKED(IDC_SENTYP_SEARCH, OnSentypSearch)
	ON_BN_CLICKED(IDC_SENLOC_SEARCH, OnSenlocSearch)
	ON_BN_CLICKED(IDC_SENATT_SEARCH, OnSenattSearch)
	ON_BN_CLICKED(IDC_AXIS_SEARCH, OnAxisSearch)
	ON_BN_CLICKED(IDC_XUNITS_SEARCH, OnXunitsSearch)
	ON_BN_CLICKED(IDC_YUNITS_SEARCH, OnYunitsSearch)
	ON_BN_CLICKED(IDC_DASTAT_SEARCH, OnDastatSearch)
	ON_BN_CLICKED(IDC_CHSTAT_SEARCH, OnChstatSearch)
	ON_LBN_SELCHANGE(IDC_CURVELIST, OnSelchangeCurvelist)
	ON_WM_HELPINFO()
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTW, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTA, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY(DTN_DATETIMECHANGE, IDC_BIOINST_CALDAT, OnDatetimechangeBioinstCaldat)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBioInstPage message handlers

BOOL CBioInstPage::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
	TOOLTIPTEXTA* pTTTA = (TOOLTIPTEXTA*)pNMHDR;
	TOOLTIPTEXTW* pTTTW = (TOOLTIPTEXTW*)pNMHDR;
	CString strTipText = "";
	UINT nID = pNMHDR->idFrom;
	if (pNMHDR->code == TTN_NEEDTEXTA && (pTTTA->uFlags & TTF_IDISHWND) ||
		pNMHDR->code == TTN_NEEDTEXTW && (pTTTW->uFlags & TTF_IDISHWND))
	{
		// idFrom is actually the HWND of the tool
		nID = ::GetDlgCtrlID((HWND)nID);
	}

	if (nID != 0) // will be zero on a separator
	{
		strTipText.Format("Control ID = %d", nID);
		switch (nID)
			{
			case IDC_NEXTCURVE_BUTTON:
				strTipText = "Go to (or add) the next curve";
				break;
			case IDC_DELETE_BUTTON:
				strTipText = "Delete curve";
				break;
			case IDC_BIOINST_PREFIL:
				strTipText = "Hz (0->99999)";
				break;
			case IDC_BIOINST_DELT:
				strTipText = "Microseconds (0->99999)";
				break;
			case IDC_BIOINST_CHLMAX:
				strTipText = "% (Integer 0->999)";
				break;
			case IDC_BIOINST_INIVEL:
				strTipText = "Kilometers/Hour (-200.00->99999.00)";
				break;
			case IDC_BIOINST_INSRAT:
				strTipText = "-999999->999999";
				break;
			case IDC_BIOINST_NFP:
				strTipText = "-999999->999999";
				break;
			case IDC_BIOINST_NLP:
				strTipText = "-999999->999999";
				break;
			case IDC_BIOINSTDAT:
				strTipText = "Date (dd/MMM/yyyy)";
				break;
			default:
				strTipText = "";
			}
	}

	if (pNMHDR->code == TTN_NEEDTEXTA)
		lstrcpyn(pTTTA->szText, strTipText, sizeof(pTTTA->szText));
	else
		::MultiByteToWideChar( CP_ACP , 0, strTipText, -1, pTTTW->szText, sizeof(pTTTW->szText) );
	*pResult = 0;

	return TRUE;    // message was handled
}

BOOL CBioInstPage::OnKillActive() 
{
	if( ValidateInstPage() == true )
	{
		LoadBioInstData();
        int nOldCurIndx = m_icurno;
		for (m_icurno=1; m_icurno<m_totalcurves+1; m_icurno++)
		{
			DisplayBioInstData();
			if (!ValidateInstPage()) { return false; }
		}
		m_icurno = nOldCurIndx;

		DisplayBioInstData();

		return CPropertyPage::OnKillActive();
	}
	else { return FALSE; }
}

BOOL CBioInstPage::OnSetActive() 
{
	m_totalcurves=max(m_pBioData->m_totcrv , 0) ; //initialize total curves.

	SetBusinessRules();

	DisplayBioInstData();

	ValidateInstPage();
	
	return CPropertyPage::OnSetActive();
}

BOOL CBioInstPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	EnableToolTips();
	m_caldatctrl.SetFormat("dd'/'MMM'/'yyy");

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CBioInstPage::OnNextcurveButton() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	if (m_icurno==m_totalcurves) //if at end, increase # of curves
	{
		if (m_icurno!=0) { LoadBioInstData(); }
		m_totalcurves++; 
		m_icurno++;		
		InitializeNextCurve();
	} 
	else if (m_icurno != 0) 
	{
		if(!LoadBioInstData())
		{
			MessageBox("Error: see CBioInstPage::OnNextcurveButton()");
			return;
		}
		m_icurno++; 
	}

	DisplayBioInstData();  //display next set, if existing
	ValidateInstPage();
}	// OnNextcurveButton


void CBioInstPage::OnDeleteButton() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }
	if (m_icurno==0)  { return;  }

	m_totalcurves--;
	
	m_pBioData->m_axis.RemoveAt(m_icurno);
	m_pBioData->m_chlmax.RemoveAt(m_icurno);
	m_pBioData->m_chstat.RemoveAt(m_icurno);
	m_pBioData->m_dastat.RemoveAt(m_icurno);
	m_pBioData->m_delt.RemoveAt(m_icurno);
	m_pBioData->m_inivel.RemoveAt(m_icurno);
	m_pBioData->m_inscom.RemoveAt(m_icurno);
	m_pBioData->m_insman.RemoveAt(m_icurno);
	m_pBioData->m_insrat.RemoveAt(m_icurno);
	m_pBioData->m_nfp.RemoveAt(m_icurno);
	m_pBioData->m_nlp.RemoveAt(m_icurno);
	m_pBioData->m_prefil.RemoveAt(m_icurno);
	m_pBioData->m_senatt.RemoveAt(m_icurno);
	m_pBioData->m_sentyp.RemoveAt(m_icurno);
	m_pBioData->m_senloc.RemoveAt(m_icurno);
	m_pBioData->m_xunits.RemoveAt(m_icurno);
	m_pBioData->m_yunits.RemoveAt(m_icurno);

	m_icurno--;             //goto previous curve 
		
	//if m_icurno == 0 now, and there are remaining curves, set curve 1 as active (m_icurno=1)
	if (m_icurno==0 && m_totalcurves>0) { m_icurno = 1; }

	DisplayBioInstData();  //display previous set, if existing
	
}	// OnDeleteButton

void CBioInstPage::OnSentypSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	if ( m_edityunits.GetTextAsString()==("") )
	{
		MessageBox("Please enter 'Y Units' prior to searching 'Sensor type'.");
		return;	
	}
//	else if ( m_editsenloc.GetTextAsString()=="" )
//	{
//		MessageBox("Please enter 'Sensor location' prior to searching 'Sensor type'.");
//		return; 
//	} // wong added in 02/22/00

	UpdateData(TRUE);  //First save data

		// Pass the whole SQL Select statement because choices are narrowed based on yunits
	CSearch search(NULL,"SENTYP","",
 		"SELECT SENTYP,SENTYPD,SENTYP_COMMENT FROM SENTYPCODE WHERE UNITS LIKE '%"+
		ReplaceQuoteWithQuestionMark(m_edityunits.GetTextAsString())+"%'OR UNITS LIKE '%ALL%' ORDER BY SENTYP");

	if (search.DoModal ()==IDOK)
	{
		m_editsentyp = search_code;
		m_editsentyp.SetValidateColor();
	}
	UpdateData(FALSE);
}

void CBioInstPage::OnSenlocSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"SENLOC","BIODB");
	if (search.DoModal ()==IDOK)
	{
		if (search_code=="")	// wong added in 02/23/00
		{
			m_editsenatt = "";
			m_editsentyp = "";
			m_editaxis	 = "";
		}
		else if (search_code!=m_editsenloc.GetTextAsString())  //if you change the senloc, reset the senatt.
		{
			m_editsenatt="";
		}
		m_editsenloc = search_code;
		m_editsenloc.SetValidateColor();
		CString temp;
		m_edityunits.GetWindowText(temp);
		if ((search_code!="")&&(temp!="")){ EnableSearch();	}
		else { DisableSearch();	}
	}
	UpdateData(FALSE);

}	// OnSenlocSearch

void CBioInstPage::OnSenattSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	if ( m_edityunits.GetTextAsString()==("") )
	{
		MessageBox("Please enter 'Y Units' prior to searching 'Sensor attachment'.");
		return;	
	}
	else if ( m_editsenloc.GetTextAsString()=="" )
	{
		MessageBox("Please enter 'Sensor location' prior to searching 'Sensor attachment'.");
		return; 
	} // wong added in 02/22/00

	UpdateData(TRUE);  //First save data

	// Pass the whole SQL Select statement because choices are narrowed based on senloc and yunits
	CSearch search(NULL,"SENATT","",
 		"SELECT SENATT,SENATTD,SENATT_COMMENT FROM SENATTCODE WHERE SENLOC LIKE '%"+
		m_editsenloc.GetTextAsString()+"%' AND UNITS LIKE '%"+ReplaceQuoteWithQuestionMark(m_edityunits.GetTextAsString())+"%' ORDER BY SENATT");

	if (search.DoModal ()==IDOK)
	{
		m_editsenatt = search_code;
		////// test stored procedure:
//		search.runStoredProc("WhichRegion", m_editsenatt.GetTextAsString());
		m_editsenatt.SetValidateColor();
	}
	UpdateData(FALSE);
	
}

void CBioInstPage::OnAxisSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	if ( m_edityunits.GetTextAsString()==("") )
	{
		MessageBox("Please enter 'Y Units' prior to searching 'Axis'.");
		return;	
	}
	else if ( m_editsenloc.GetTextAsString()=="" )
	{
		MessageBox("Please enter 'Sensor location' prior to searching 'Axis'.");
		return; 
	} // wong added in 02/22/00

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"AXIS","BIODB");
	if (search.DoModal ()==IDOK)
	{
		m_editaxis = search_code;
		m_editaxis.SetValidateColor();
	}
	UpdateData(FALSE);
}

void CBioInstPage::OnXunitsSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"UNITS","BIODB");
	if (search.DoModal ()==IDOK)
	{
		m_editxunits = search_code;
		m_editxunits.SetValidateColor();
		
		COLORREF colorGreyBack = RGB( 192, 192, 192 );		
		COLORREF colorBlackText = RGB( 0, 0, 0 );
		if (search_code!="SEC") 
		{ 
			m_editdelt = "0";
			m_editdelt.SetColor(colorBlackText, colorGreyBack);
			m_editdelt.EnableWindow(false);
		}
		else 
		{ 
			m_editdelt.EnableWindow();
			COLORREF colorYellowBack = RGB( 255, 255, 0 );
			COLORREF colorWhiteBack = RGB( 255, 255, 255 );
			m_editdelt = m_pBioData->m_delt[m_icurno];			
			if (m_editdelt.GetValidate()) { m_editdelt.SetColor(colorBlackText, colorWhiteBack); }
			else { m_editdelt.SetColor(colorBlackText, colorYellowBack); }
		}
	}
	UpdateData(FALSE);
}

void CBioInstPage::OnYunitsSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

//	CSearch search(NULL,"UNITS","BIODB");
	CSearch search(NULL,"UNITS","",
 	"SELECT UNITS,UNITSD,UNITS_COMMENT FROM NHTSADB_UNITS WHERE MEASUR = 'MET'");

	if (search.DoModal ()==IDOK)
	{
		if (search_code=="")
		{
			m_editsenatt = "";
			m_editsentyp = "";
			m_editaxis	 = "";
		}
		else if (search_code!=m_edityunits.GetTextAsString())  // if you change the yunits, reset the senatt.
		{
			m_editsenatt = "";
			m_editsentyp = "";
		}
		m_edityunits = search_code;
		m_edityunits.SetValidateColor();
		CString temp;
		m_editsenloc.GetWindowText(temp);
		if ((search_code!="")&&(temp!="")){ EnableSearch();	}
		else { DisableSearch();	}
	}
	UpdateData(FALSE);

	DetermineSenatt();
}	// OnYunitsSearch

void CBioInstPage::DetermineSenatt() 
{
	if ( m_edityunits.GetTextAsString()=="" ) { return; }

	CSearch search(NULL,"SENATT","",
 		"SELECT SENATT,SENLOC,SENATTD,SENATT_COMMENT FROM SENATTCODE1 WHERE UNITS LIKE '%"+
		ReplaceQuoteWithQuestionMark(m_edityunits.GetTextAsString())+"%' ORDER BY SENATT", true);

//	CSearch search(NULL,"SENATT","",
// 		"SELECT SENATT,SENLOC,SENATTD,SENATT_COMMENT FROM SENATTCODE1 WHERE UNITS LIKE '%"+
//		ReplaceQuoteWithQuestionMark(m_edityunits.GetTextAsString())+"%' AND SENLOC LIKE '%"+m_editsenloc.GetTextAsString()+"%'  ORDER BY SENATT", true);

	//CSearch search(NULL,"SENATT","",
 //		"SELECT SENATT FROM SENATTCODE1 WHERE SENLOC LIKE '%"+
	//	m_editsenloc.GetTextAsString()+"%' AND UNITS LIKE '%"+ReplaceQuoteWithQuestionMark(m_edityunits.GetTextAsString())+"%' ORDER BY SENATT");
	//if (search.getColArray0()->GetSize()==0) 
	//{ 
	//	UpdateData(FALSE);
	//	return; 
	//}

	search.SetColumnNames("SENATT", "SENLOC", "SENATTD", "SENATT_COMMENT");

	if (search.DoModal ()==IDOK)
	{
		UpdateData(TRUE);
		if ((search.GetSecondCode()==""))
		{ 
			m_edityunits = "";
			m_editsenloc = "";
			DisableSearch(); 
			UpdateData(FALSE);
			return;	
		} 
		m_editsenloc = search.GetSecondCode();
		m_editsenloc.SetValidateColor();
		m_editsenatt = search_code;;
		m_editsenatt.SetValidateColor();
		CString temp;
		m_edityunits.GetWindowText(temp);
		EnableSearch();
		UpdateData(FALSE);
	}
	
}	// DetermineSenatt

void CBioInstPage::OnDastatSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"DASTAT","BIODB");
	if (search.DoModal ()==IDOK)
	{
		m_editdastat = search_code;
		m_editdastat.SetValidateColor();
	}
	UpdateData(FALSE);
}

void CBioInstPage::OnChstatSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"CHSTAT","BIODB");
	if (search.DoModal ()==IDOK)
	{
		m_editchstat = search_code;
		m_editchstat.SetValidateColor();
	}
	UpdateData(FALSE);
}

// This function gets data from the entry screen and puts it into m_pBioData
// It is called from OnKillActive, ExportData, and record changed.
bool CBioInstPage::LoadBioInstData()
{
	//put data into m_pBioData

	if (m_hWnd==NULL) return TRUE;  //only return FALSE if data invalid
	if (!UpdateData()) return FALSE;

	m_pBioData->m_axis[m_icurno]	= m_editaxis.GetTextAsString();
	m_pBioData->m_chlmax[m_icurno]	= m_editchlmax.GetTextAsString();
	m_pBioData->m_chstat[m_icurno]	= m_editchstat.GetTextAsString();
	m_pBioData->m_dastat[m_icurno]	= m_editdastat.GetTextAsString();
	m_pBioData->m_delt[m_icurno]	= m_editdelt.GetTextAsString();
//	if (m_pBioData->m_xunits[m_icurno]!="SEC")  { m_pBioData->m_delt[m_icurno] = "0"; }
//	else { m_pBioData->m_delt[m_icurno] = m_editdelt.GetTextAsString(); }

	m_pBioData->m_inivel[m_icurno]	= m_editinivel.GetTextAsString();
	m_pBioData->m_inscom[m_icurno]	= m_editinscom.GetTextAsString();
	m_pBioData->m_insman[m_icurno]	= m_editinsman.GetTextAsString();
	m_pBioData->m_insrat[m_icurno]	= m_editinsrat.GetTextAsString();
	m_pBioData->m_nfp[m_icurno]		= m_editnfp.GetTextAsString();

	m_pBioData->m_nlp[m_icurno]		= m_editnlp.GetTextAsString();
	m_pBioData->m_prefil[m_icurno]	= m_editprefil.GetTextAsString();
	m_pBioData->m_senatt[m_icurno]	= m_editsenatt.GetTextAsString();
	m_pBioData->m_sentyp[m_icurno]	= m_editsentyp.GetTextAsString();
	m_pBioData->m_senloc[m_icurno]	= m_editsenloc.GetTextAsString();

	m_pBioData->m_xunits[m_icurno]	= m_editxunits.GetTextAsString();
	m_pBioData->m_yunits[m_icurno]	= m_edityunits.GetTextAsString();

	CString caldate;
	GetDlgItemText(IDC_BIOINSTDAT/*IDC_BIOINST_CALDAT*/,caldate);
	m_pBioData->m_caldat[m_icurno]	= caldate;

	m_pBioData->m_totcrv			= m_totalcurves;
	m_pBioData->m_curno				= m_totalcurves;

	return true;
}

// wong code in 03/02/00
bool CBioInstPage::InsertBioInstData()
{
	if (m_hWnd==NULL) return TRUE;  // only return FALSE if data invalid
	
	UpdateData();

	m_pBioData->m_axis.InsertAt( m_icurno, m_editaxis.GetTextAsString() );
	m_pBioData->m_chlmax.InsertAt( m_icurno, m_editchlmax.GetTextAsString() );
	m_pBioData->m_chstat.InsertAt( m_icurno, m_editchstat.GetTextAsString() );
	m_pBioData->m_dastat.InsertAt( m_icurno, m_editdastat.GetTextAsString() );
	m_pBioData->m_delt.InsertAt( m_icurno, m_editdelt.GetTextAsString() );
	m_pBioData->m_inivel.InsertAt( m_icurno, m_editinivel.GetTextAsString() );
	m_pBioData->m_inscom.InsertAt( m_icurno, m_editinscom.GetTextAsString() );
	m_pBioData->m_insman.InsertAt( m_icurno, m_editinsman.GetTextAsString() );
	m_pBioData->m_insrat.InsertAt( m_icurno, m_editinsrat.GetTextAsString() );
	m_pBioData->m_nfp.InsertAt( m_icurno, m_editnfp.GetTextAsString() );
	m_pBioData->m_nlp.InsertAt( m_icurno, m_editnlp.GetTextAsString() );
	m_pBioData->m_prefil.InsertAt( m_icurno, m_editprefil.GetTextAsString() );
	m_pBioData->m_senatt.InsertAt( m_icurno, m_editsenatt.GetTextAsString() );
	m_pBioData->m_sentyp.InsertAt( m_icurno, m_editsentyp.GetTextAsString() );
	m_pBioData->m_senloc.InsertAt( m_icurno, m_editsenloc.GetTextAsString() );
	m_pBioData->m_xunits.InsertAt( m_icurno, m_editxunits.GetTextAsString() );
	m_pBioData->m_yunits.InsertAt( m_icurno, m_edityunits.GetTextAsString() );

	CString caldate;
	GetDlgItemText(IDC_BIOINST_CALDAT,caldate);
	m_pBioData->m_caldat.InsertAt( m_icurno, caldate );

	m_pBioData->m_totcrv = m_totalcurves;
	m_pBioData->m_curno = m_totalcurves;
	UpdateData(false);

	return true;
}	// InsertBioInstData

//Get Data from m_pBioData and Display it.
void CBioInstPage::DisplayBioInstData()
{
	UpdateCurveListbox();

	UpdateData();
	m_caldatctrl.SetTime(&(StringToTime(m_pBioData->m_caldat[m_icurno])));
	m_pBioData->m_caldat[m_icurno].MakeUpper();

	m_editinstdate	= m_pBioData->m_caldat[m_icurno];
	m_editaxis		= m_pBioData->m_axis[m_icurno];
	m_editchlmax	= m_pBioData->m_chlmax[m_icurno];
	m_editchstat	= m_pBioData->m_chstat[m_icurno];
	m_editdastat	= m_pBioData->m_dastat[m_icurno];
	
	m_editdelt		= m_pBioData->m_delt[m_icurno];
	m_editinivel	=  m_pBioData->m_inivel [m_icurno];
	m_editinscom	= m_pBioData->m_inscom[m_icurno];
	m_editinsman	= m_pBioData->m_insman[m_icurno];
	m_editinsrat	= m_pBioData->m_insrat[m_icurno];

	m_editnfp		= m_pBioData->m_nfp[m_icurno];
	m_editnlp		= m_pBioData->m_nlp[m_icurno];
	m_editprefil	= m_pBioData->m_prefil[m_icurno];
	m_editsenatt	= m_pBioData->m_senatt[m_icurno];
	m_editsentyp	= m_pBioData->m_sentyp[m_icurno];

	m_editsenloc	= m_pBioData->m_senloc[m_icurno];
	m_editxunits	= m_pBioData->m_xunits[m_icurno];
	m_edityunits	= m_pBioData->m_yunits[m_icurno];

	if (m_editdelt.GetValidate()) { m_editdelt.SetColor(RGB( 0, 0, 0 ), RGB( 255, 255, 255 )); }
	CCodeValidation( m_editsentyp, "SENTYP","BIODB" );
	CCodeValidation( m_editsenloc, "SENLOC","BIODB" );
	CCodeValidation( m_editsenatt, "SENATT","BIODB" );
	CCodeValidation( m_editaxis, "AXIS","BIODB" );
	CCodeValidation( m_editxunits, "UNITS","BIODB" );
	CCodeValidation( m_edityunits, "UNITS","BIODB" );
	CCodeValidation( m_editdastat, "DASTAT","BIODB" );
	CCodeValidation( m_editchstat, "CHSTAT","BIODB" );

	if (m_pBioData->m_xunits[m_icurno]!="SEC")
	{ 
		m_pBioData->m_delt[m_icurno] = "0";
		m_editdelt.SetValidateColor(); 
	}

	UpdateData(FALSE);

	if ( (m_pBioData->m_yunits[m_icurno]=="") || (m_pBioData->m_senloc[m_icurno]=="") ||
		 (!m_edityunits.GetValidate()) || (!m_editsenloc.GetValidate()) ) 
	{ 
		DisableSearch();
	}
	else { EnableSearch(); }

	if (m_pBioData->m_xunits[m_icurno]=="SEC") { m_editdelt.EnableWindow(); }
	else { m_editdelt.EnableWindow(false); }
	
}	// DisplayBioInstData

void CBioInstPage::EnableSearch()
{
	m_sentypsearch.EnableWindow();
//	m_senattsearch.EnableWindow();
	m_axissearch.EnableWindow();
	m_xunitssearch.EnableWindow();
}	// EnableSearch

void CBioInstPage::DisableSearch()
{
	m_sentypsearch.EnableWindow(false);
//	m_senattsearch.EnableWindow(false);
	m_axissearch.EnableWindow(false);
	m_xunitssearch.EnableWindow(false);
}	// EnableSearch

//New curve, so expand arrays in m_pBioData to hold info
void CBioInstPage::InitializeNextCurve()
{
	// *******************************************
	//These temp variables are used because the reference that [] returns is invalid when SetAtGrow
	// happens, because SetAtGrow (sometimes) moves the array to a different location in memory.   
	// If you try to use that reference directly, you will get an access violation.
	// For Example:  m_pBioData->m_inscom.SetAtGrow (m_icurno,m_pBioData->inscom[m_icurno-1]); //BAD!!!! 
	// *******************************************

	if (m_retaindata)
	{
		int curno = m_icurno - 1;
		CString temp = m_pBioData->m_axis[curno];
		m_pBioData->m_axis.SetAtGrow(m_icurno, temp);
		temp = m_pBioData->m_chlmax[curno];
		m_pBioData->m_chlmax.SetAtGrow(m_icurno, temp);
		temp = m_pBioData->m_chstat[curno];
		m_pBioData->m_chstat.SetAtGrow(m_icurno, temp);
		temp = m_pBioData->m_dastat[curno];
		m_pBioData->m_dastat.SetAtGrow(m_icurno, temp);
		temp = m_pBioData->m_delt[curno];
		m_pBioData->m_delt.SetAtGrow(m_icurno, temp);

		temp = m_pBioData->m_inivel[curno];
		m_pBioData->m_inivel.SetAtGrow(m_icurno, temp);
		temp = m_pBioData->m_inscom[curno];
		m_pBioData->m_inscom.SetAtGrow(m_icurno, temp);
		temp = m_pBioData->m_insman[curno];
		m_pBioData->m_insman.SetAtGrow(m_icurno, temp);
		temp = m_pBioData->m_insrat[curno];
		m_pBioData->m_insrat.SetAtGrow(m_icurno, temp);
		temp = m_pBioData->m_nfp[curno];
		m_pBioData->m_nfp.SetAtGrow(m_icurno, temp);

		temp = m_pBioData->m_nlp[curno];
		m_pBioData->m_nlp.SetAtGrow(m_icurno, temp);
		temp = m_pBioData->m_prefil[curno];
		m_pBioData->m_prefil.SetAtGrow(m_icurno, temp);
		temp = m_pBioData->m_senatt[curno];
		m_pBioData->m_senatt.SetAtGrow(m_icurno, temp);
		temp = m_pBioData->m_senloc[curno];
		m_pBioData->m_senloc.SetAtGrow(m_icurno, temp);
		temp = m_pBioData->m_sentyp[curno];
		m_pBioData->m_sentyp.SetAtGrow(m_icurno, temp);

		temp = m_pBioData->m_xunits[curno];
		m_pBioData->m_xunits.SetAtGrow(m_icurno, temp);
		temp = m_pBioData->m_yunits[curno];
		m_pBioData->m_yunits.SetAtGrow(m_icurno, temp);
		temp = m_pBioData->m_caldat[curno];
		m_pBioData->m_caldat.SetAtGrow (m_icurno, temp);
	}
	else
	{
		m_pBioData->m_axis.SetAtGrow(m_icurno,"");
		m_pBioData->m_chlmax.SetAtGrow(m_icurno,"");
		m_pBioData->m_chstat.SetAtGrow(m_icurno,"P");
		m_pBioData->m_dastat.SetAtGrow(m_icurno,"AM");
		m_pBioData->m_delt.SetAtGrow(m_icurno,"");
		m_pBioData->m_inivel.SetAtGrow(m_icurno,"");
		m_pBioData->m_inscom.SetAtGrow(m_icurno,"");
		m_pBioData->m_insman.SetAtGrow(m_icurno,"");
		m_pBioData->m_insrat.SetAtGrow(m_icurno,"");
		m_pBioData->m_nfp.SetAtGrow(m_icurno,"");
		m_pBioData->m_nlp.SetAtGrow(m_icurno,"");
		m_pBioData->m_prefil.SetAtGrow(m_icurno,"");
		m_pBioData->m_senatt.SetAtGrow(m_icurno,"");
		m_pBioData->m_senloc.SetAtGrow (m_icurno,"");
		m_pBioData->m_sentyp.SetAtGrow(m_icurno,"");
		m_pBioData->m_xunits.SetAtGrow(m_icurno,"SEC");
		m_pBioData->m_yunits.SetAtGrow(m_icurno,"");
		m_pBioData->m_caldat.SetAtGrow(m_icurno,"");
		
		//  The caldat field is grown above.  Here, just set the control to today.
		CTime now;
		now= CTime::GetCurrentTime ();
		m_caldatctrl.SetTime(&now);
	}
}

// This function takes any ' out of a string and replaces it with a ?
// DAO doesn't do a LIKE with a single quote inside the string. Example:
// WHERE UNITS LIKE '*G'S*'  will not work because of the quote between G and S.
// By the way, ? is any single character wild card.
CString CBioInstPage::ReplaceQuoteWithQuestionMark(CString& str)
{
	int nIndex = str.FindOneOf("'");
	while (nIndex>-1)
	{
		str.SetAt (nIndex,'?');
		nIndex = str.FindOneOf("'");
	}
	
	nIndex = str.FindOneOf("?");	// Wong update it to fit the SQL, 06/07/00
	while (nIndex>-1)
	{
		str.SetAt (nIndex,'\'');
		str.Insert( nIndex+1, "'" );
		nIndex = str.FindOneOf("?");
	}

	return str;
}

void CBioInstPage::UpdateCurveListbox()
{
	if (m_curvelist.GetCount ()!=m_totalcurves)
	{
		m_curvelist.ResetContent();
		char crvbuf [10];
		for (int loop=1;loop <= m_totalcurves;loop++)
		{
			itoa(loop,crvbuf,10);
			if (m_curvelist.FindString (-1,crvbuf)==LB_ERR)  //if buf isnt there already.
			{
				m_curvelist.AddString(crvbuf);
			}
		}
	}

	m_curvelist.SetCurSel (max(0,m_icurno-1));  // select current curve, zero based.
	
}

// user clicked the curves listbox, so change to that curve
void CBioInstPage::OnSelchangeCurvelist() 
{
	int nCurve = m_curvelist.GetCurSel ();  //zero based

	if (m_icurno != 0) 
	{
		BOOL success = LoadBioInstData();     //load current info (not zeroth curve)
		if (!success) //Data not valid, dont change curves.
		{
			m_curvelist.SetCurSel (max(0,m_icurno-1));  // select current curve, zero based.
			return;
		}
	}

	m_icurno= nCurve+1;             //goto current curve 

	DisplayBioInstData();  //display next set, if existing	
	ValidateInstPage();	// new added 03/14/00
}

BOOL CBioInstPage::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	WinHelp(Instrumentation_Information);
	
	return TRUE;
}

//
bool CBioInstPage::ValidateInstPage( void )
{	
	const int nTotal = 19;
	bool bRetArray[nTotal];

	bRetArray[0] = m_editinscom.GetValidate();
	bRetArray[1] = m_editinsman.GetValidate();
	bRetArray[2] = m_editinsrat.GetValidate();
	bRetArray[3] = m_editchlmax.GetValidate();
	bRetArray[4] = m_editinivel.GetValidate();

	bRetArray[5] = m_editnfp.GetValidate();
	bRetArray[6] = m_editnlp.GetValidate();

//	if (m_editxunits.GetTextAsString()=="SEC") { bRetArray[7] = m_editdelt.GetValidate(); }
//	else if (m_editdelt.GetTextAsString()=="0") { bRetArray[7] = true; }
//	else { bRetArray[7] = false; }
	bRetArray[7] = m_editdelt.GetValidate();
	bRetArray[8] = m_editprefil.GetValidate();
	bRetArray[9] = m_editinstdate.GetValidate();

	bRetArray[10] = m_editchlmax.GetValidate();	
	bRetArray[11] = m_editsentyp.GetValidate();
	bRetArray[12] = m_editsenloc.GetValidate();
	bRetArray[13] = m_editsenatt.GetValidate();
	bRetArray[14] = m_editaxis.GetValidate();

	bRetArray[15] = m_editxunits.GetValidate();
	bRetArray[16] = m_edityunits.GetValidate();
	bRetArray[17] = m_editdastat.GetValidate();
	bRetArray[18] = m_editchstat.GetValidate();

	for(int i=0; i<nTotal; i++) { if (!bRetArray[i]) return false; }
	return true;
}	// ValidateAnthPage

void CBioInstPage::SetBusinessRules( void )
{
	m_editinscom.SetString( 0, 70 );
	m_editinsman.SetString( 0, 70 );
	m_editinsrat.SetDouble( -999999, 999999 );
	m_editchlmax.SetDouble( 0, 100 );
	m_editinivel.SetDouble( -200, 99999 );

	m_editnfp.SetDouble( -999999, 999999 );
	m_editnlp.SetDouble( -999999, 999999 );
	m_editdelt.SetDouble( 0, 99999 );
	m_editprefil.SetDouble( 0, 99999 );
	m_editinstdate.SetDate();
	m_editchlmax.SetDouble( 0, 999 );
}	// SetBusinessRules

void CBioInstPage::OnDatetimechangeBioinstCaldat(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CString sDate;
    GetDlgItemText(IDC_BIOINST_CALDAT, sDate);

	sDate.MakeUpper();
	m_editinstdate =  m_pBioData->m_caldat[m_icurno] = sDate;
	
	*pResult = 0;
}

