#if !defined(AFX_BIOINSTPAGE_H__04C36506_7325_11D2_9496_0008C7AA9033__INCLUDED_)
#define AFX_BIOINSTPAGE_H__04C36506_7325_11D2_9496_0008C7AA9033__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// BioInstPage.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CBioInstPage dialog

class CBioInstPage : public CPropertyPage
{
	DECLARE_DYNCREATE(CBioInstPage)

// Construction
public:
	CBioInstPage();
	~CBioInstPage();

	void	UpdateCurveListbox();
	CString ReplaceQuoteWithQuestionMark(CString&);
	void	InitializeNextCurve();
	void	DisplayBioInstData();
	bool	LoadBioInstData();
	bool	InsertBioInstData();
	bool	ValidateInstPage();
	void	SetBusinessRules();
	void	DetermineSenatt();

	int			m_icurno;
	int			m_totalcurves;
	CBioData*	m_pBioData;

private:
	void	EnableSearch();
	void	DisableSearch();

public:
// Dialog Data
	//{{AFX_DATA(CBioInstPage)
	enum { IDD = IDD_BIOMECH_INST_PAGE };
	CNEdit	m_editinstdate;
	CListBox	m_curvelist;
	CButton	m_axissearch;
	CButton	m_senattsearch;
	CButton	m_sentypsearch;
	CButton	m_xunitssearch;
	CButton	m_nextcurve;
	CButton	m_deletebutton;
	CDateTimeCtrl	m_caldatctrl;
	CNEdit	m_editaxis;
	CNEdit	m_editchstat;
	CNEdit	m_editdastat;
	CNEdit	m_editinscom;
	CNEdit	m_editinsman;
	CNEdit	m_editsenatt;
	CNEdit	m_editsenloc;
	CNEdit	m_editsentyp;
	CNEdit	m_editxunits;
	CNEdit	m_edityunits;
	BOOL	m_retaindata;
	CNEdit	m_editinsrat;
	CNEdit	m_editchlmax;
	CNEdit	m_editinivel;
	CNEdit	m_editnfp;
	CNEdit	m_editnlp;
	CNEdit	m_editdelt;
	CNEdit	m_editprefil;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CBioInstPage)
	public:
	virtual BOOL OnKillActive();
	virtual BOOL OnSetActive();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CBioInstPage)
	virtual BOOL OnInitDialog();
	afx_msg BOOL OnToolTipNotify(UINT, NMHDR *, LRESULT *);
	afx_msg void OnNextcurveButton();
	afx_msg void OnDeleteButton();
	afx_msg void OnSentypSearch();
	afx_msg void OnSenlocSearch();
	afx_msg void OnSenattSearch();
	afx_msg void OnAxisSearch();
	afx_msg void OnXunitsSearch();
	afx_msg void OnYunitsSearch();
	afx_msg void OnDastatSearch();
	afx_msg void OnChstatSearch();
	afx_msg void OnSelchangeCurvelist();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	afx_msg void OnDatetimechangeBioinstCaldat(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BIOINSTPAGE_H__04C36506_7325_11D2_9496_0008C7AA9033__INCLUDED_)
