// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: BioMechPropertySheet.cpp
//
// Author: Dan Robbins
//
// Date Created: October 1998
//
// Description:  CBioMechPropertySheet is the container for all
//               the Bio...Pages.  The member functions here
//               process menu selections.
//
//  Date		Who			Description
// -----------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "entreeV5Dlg.h"
#include "BioMechPropertySheet.h"

#include <winspool.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBioMechPropertySheet

IMPLEMENT_DYNAMIC(CBioMechPropertySheet, CPropertySheet)

CBioMechPropertySheet::CBioMechPropertySheet(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(nIDCaption, pParentWnd, iSelectPage),
	_bClearAll( false )
{
	m_BioMechTestPage.m_pBioData	= &m_BioData;  // the data is available inside other info dlgs
	m_BioRestPage.m_pBioData		= &m_BioData;
	m_BioAnthPage.m_pBioData		= &m_BioData;
	m_BioInjPage.m_pBioData			= &m_BioData;
	m_BioCBandPage.m_pBioData		= &m_BioData;
	m_BioDumPage.m_pBioData			= &m_BioData;
	m_BioOccPage.m_pBioData			= &m_BioData;
	m_BioInstPage.m_pBioData		= &m_BioData;
	m_BioGaugePage.m_pBioData		= &m_BioData;
	m_BioRibPage.m_pBioData			= &m_BioData;
	m_HsvdPage.m_pBioHsvdData		= &m_BioData;
	m_HsvdPage.m_cVersion = 'B';

	AddPage (&m_BioMechTestPage);
	AddPage (&m_BioRestPage);
	AddPage (&m_BioAnthPage);
	AddPage (&m_BioInjPage);
	AddPage (&m_BioCBandPage);
	AddPage (&m_BioDumPage);
	AddPage (&m_BioOccPage);
	AddPage (&m_BioInstPage);
	AddPage (&m_BioGaugePage);
	AddPage (&m_BioRibPage);
	AddPage (&m_HsvdPage);

	m_pParent = (CChooseDB *) pParentWnd;
}

CBioMechPropertySheet::CBioMechPropertySheet(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage),
	_bClearAll( false )
{
	m_BioMechTestPage.m_pBioData=&m_BioData;  // the data is available inside other info dlgs
	m_BioRestPage.m_pBioData=&m_BioData;
	m_BioAnthPage.m_pBioData=&m_BioData;
	m_BioInjPage.m_pBioData=&m_BioData;
	m_BioCBandPage.m_pBioData=&m_BioData;
	m_BioDumPage.m_pBioData=&m_BioData;
	m_BioOccPage.m_pBioData=&m_BioData;
	m_BioInstPage.m_pBioData=&m_BioData;
	m_BioGaugePage.m_pBioData=&m_BioData;
	m_BioRibPage.m_pBioData=&m_BioData;
	m_HsvdPage.m_pBioHsvdData=&m_BioData;
	m_HsvdPage.m_cVersion = 'B';

	AddPage (&m_BioMechTestPage);
	AddPage (&m_BioRestPage);
	AddPage (&m_BioAnthPage);
	AddPage (&m_BioInjPage);
	AddPage (&m_BioCBandPage);
	AddPage (&m_BioDumPage);
	AddPage (&m_BioOccPage);
	AddPage (&m_BioInstPage);
	AddPage (&m_BioGaugePage);
	AddPage (&m_BioRibPage);
	AddPage (&m_HsvdPage);
	
	m_pParent = (CChooseDB *) pParentWnd;

}

CBioMechPropertySheet::~CBioMechPropertySheet()
{
}


BEGIN_MESSAGE_MAP(CBioMechPropertySheet, CPropertySheet)
	//{{AFX_MSG_MAP(CBioMechPropertySheet)
	ON_COMMAND(ID_COMPONENTDB, OnComponentdb)
	ON_COMMAND(ID_SWGDB, OnSwgdb)
	ON_COMMAND(ID_VEHICLEDB, OnVehicledb)
	ON_COMMAND(ID_CLEARALL, OnClearall)
	ON_COMMAND(ID_EXPORT_TEST, OnExportTest)
	ON_COMMAND(ID_IMPORT_TEST, OnImportTest)
	ON_COMMAND(ID_FILE_LOAD_HSVD, OnImportHsvdData)
	ON_COMMAND(ID_FILE_SAVE_HSVD, OnExportHsvdData)
	ON_COMMAND(ID_FILE_SAVE_HSVD_REPORT, OnExportHsvdReport)
	ON_COMMAND(ID_FILE_PRINT, OnFilePrint)
	ON_COMMAND(ID_EXIT, OnExit)
	ON_COMMAND(ID_EXPORT_REPORT, OnExportReport)
	ON_WM_CLOSE()
	ON_COMMAND(ID_HELP_INDEX, OnHelpIndex)
	ON_COMMAND(ID_HELP_ABOUT, OnHelpAbout)
	ON_COMMAND(ID_HELP, OnHelpFinder)
	ON_WM_INITMENUPOPUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBioMechPropertySheet message handlers

BOOL CBioMechPropertySheet::OnInitDialog() 
{
	BOOL bResult = CPropertySheet::OnInitDialog();
	
    //Load Menu
	CMenu MyMenu;
	CMenu* pMenu=&MyMenu;
	pMenu->LoadMenu(IDR_PROPSHEET_MENU);
	
	// resize, buttons get cut off if you dont, because of menu.
    CRect rect;
	GetWindowRect(&rect);
    
	SetMenu(pMenu);
	

    MyMenu.CheckMenuItem (ID_BIOMECHDB, MF_CHECKED);
	MyMenu.Detach ();  // MyMenu wont be deleted after this function.

	SetWindowPos(&wndTop, rect.left,rect.top, rect.Width() +15, rect.Height()+20, SWP_NOZORDER);

//	CRect helprect((rect.Width()/2)-30  , rect.bottom *81/100,(rect.Width()/2)+30, rect.bottom *86/100);
//	m_pHelpbutton->Create ("Help", WS_CHILD|WS_VISIBLE, helprect, this, ID_HELP);
	
	CenterWindow();

	HICON hICN = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	SetIcon(hICN,FALSE);
	
	return bResult;
}

void CBioMechPropertySheet::OnComponentdb() 
{
	if (MessageBox("Exit Biomechanics Data Screens?",NULL,MB_YESNO)==IDYES)
	{
		CPropertySheet::OnClose();
		m_pParent->OnComponentButton ();	
	}	
}	// OnComponentdb

void CBioMechPropertySheet::OnSwgdb() 
{
	if (MessageBox("Exit Biomechanics Data Screens?",NULL,MB_YESNO)==IDYES)
	{
		CPropertySheet::OnClose();
		m_pParent->OnSwgButton ();	
	}	
}	// OnSwgdb

void CBioMechPropertySheet::OnVehicledb() 
{
	if (MessageBox("Exit Biomechanics Data Screens?",NULL,MB_YESNO)==IDYES)
	{
		CPropertySheet::OnClose();
		m_pParent->OnVehicleButton ();	
	}	
}

// This function is long.  Clear all edit boxes.  Clear all data from all
// arrays in m_BioData.  Then, reinitialize both with defaults.
void CBioMechPropertySheet::OnClearall( void ) 
{
	if( AfxMessageBox( "Really clear all entries?", MB_YESNO )== IDNO )
	{
		this->_bClearAll = false;
		return; // was returning FALSE;
	}
	
	//Clear all BioData ********************************
	m_BioData.m_title	= "";
	m_BioData.m_tstobj	= "";
	m_BioData.m_tstdat	= "";
	m_BioData.m_tstprf	= "";
	m_BioData.m_conno	= "";
	m_BioData.m_tstref	= "";
	m_BioData.m_tstcfn	= "";
	m_BioData.m_temp	= "";
	m_BioData.m_rectyp	= "";
	m_BioData.m_link	= "";
	m_BioData.m_clsspd	= "";
	m_BioData.m_impang	= "";
	m_BioData.m_totcrv	= 0;
	m_BioData.m_occtyp	= "CD";
	m_BioData.m_tstcom	= "";
	m_BioData.m_doccloc = "";
	m_BioData.m_doccsex = "";
	m_BioData.m_dseposn = "";
	m_BioData.m_hic		=  "";
	m_BioData.m_t1		=  "";
	m_BioData.m_t2		=  "";
	m_BioData.m_clip3m	=  "";
	m_BioData.m_lfem	=  "";
	m_BioData.m_rfem	=  "";
	m_BioData.m_csi		=  "";
	m_BioData.m_lbelt	=  "";
	m_BioData.m_sbelt	=  "";
	m_BioData.m_tti		=  "";
	m_BioData.m_pelvg	=  "";
	m_BioData.m_cti		=  "";
	m_BioData.m_vc		=  "";
	m_BioData.m_cmax	=  "";
	m_BioData.m_nij		=  "";
	m_BioData.m_mthcal	= "";
	m_BioData.m_dumsiz	= "";
	m_BioData.m_dumman	= "";
	m_BioData.m_dummod	= "";
	m_BioData.m_dumdsc	= "";
	m_BioData.m_dcompwt = "";
	m_BioData.m_doccom	= "";
	m_BioData.m_boccloc = "";
	m_BioData.m_boccsex = ""; 
	m_BioData.m_bseposn = "";
	m_BioData.m_occage	= "";
	m_BioData.m_occwt	= "";
	m_BioData.m_frctrb	= "";
	m_BioData.m_rbfrct	= "";
	m_BioData.m_occref	= "";
	m_BioData.m_notest	= "";
	m_BioData.m_dtedth	= "";
	m_BioData.m_csedth	= "";
	m_BioData.m_cadapp	= "";
	m_BioData.m_bedcon	= "";
	m_BioData.m_cadan	= "";
	m_BioData.m_aorpre	= "";
	m_BioData.m_cerpre	= "";
	m_BioData.m_pulpre	= "";
	m_BioData.m_boccom	= "";
	m_BioData.m_bmc		= "";
	m_BioData.m_bmcloc	= "";
	m_BioData.m_bmcunits = "";
	m_BioData.m_bmcmethod = "";
	m_BioData.m_bcompwt = "";
	m_BioData.m_bmccom	= "";

	// ANTHROPOMETRY -- BEGIN
	m_BioData.m_statur = "";
	m_BioData.m_shldht = "";
	m_BioData.m_vrtsym = "";
	m_BioData.m_wastht = "";
	m_BioData.m_shldbd = "";
	m_BioData.m_chstbd = "";
	m_BioData.m_wastbd = "";
	m_BioData.m_hipbd  = "";
	m_BioData.m_shldel = "";
	m_BioData.m_farmhd = "";
	m_BioData.m_tiblht = "";
	m_BioData.m_anklht = "";
	m_BioData.m_footbd = "";
	m_BioData.m_footln = "";
	m_BioData.m_hdtroc = "";
	m_BioData.m_seatht = "";
	m_BioData.m_kneeht = "";
	m_BioData.m_headln = "";
	m_BioData.m_headbd = "";
	m_BioData.m_headch = "";
	m_BioData.m_bicpcr = "";
	m_BioData.m_elbwcr = "";
	m_BioData.m_farmcr = "";
	m_BioData.m_wrstcr = "";
	m_BioData.m_thghcr = "";
	m_BioData.m_ltghcr = "";
	m_BioData.m_kneecr = "";
	m_BioData.m_calfcr = "";
	m_BioData.m_anklcr = "";
	m_BioData.m_neckcr = "";
	m_BioData.m_scyecr = "";
	m_BioData.m_chstcr = "";
	m_BioData.m_wastcr = "";
	m_BioData.m_buttcr = "";
	m_BioData.m_chstdp = "";
	m_BioData.m_wastdp = "";
	m_BioData.m_buttdp = "";
	m_BioData.m_inscye = "";
	// ANTHROPOMETRY -- END

    m_BioData.m_ribno = 0;
	m_BioData.m_ribloc.RemoveAll();
	m_BioData.m_ribin.RemoveAll();
	m_BioData.m_nadis.RemoveAll();
	m_BioData.m_splen.RemoveAll();
	m_BioData.m_defl.RemoveAll();
	m_BioData.m_load.RemoveAll();
	m_BioData.m_brkld.RemoveAll();
	m_BioData.m_armar.RemoveAll();
	m_BioData.m_rarea.RemoveAll();
	m_BioData.m_injno = 0;
	m_BioData.m_bodyrg.RemoveAll();
	m_BioData.m_aspect.RemoveAll();
	m_BioData.m_lesion.RemoveAll();
	m_BioData.m_sysorg.RemoveAll();
	m_BioData.m_ais.RemoveAll();
	m_BioData.m_ais90.RemoveAll();
	m_BioData.m_injcom.RemoveAll();
	m_BioData.m_rstno=0;
	m_BioData.m_rsttyp.RemoveAll();
	m_BioData.m_rstmnt.RemoveAll();
	m_BioData.m_deploy.RemoveAll();
	m_BioData.m_rstcom.RemoveAll();
	m_BioData.m_bandno=0;
	m_BioData.m_chsdpt.RemoveAll();
	m_BioData.m_chsbrd.RemoveAll();
	m_BioData.m_banlen.RemoveAll();
	m_BioData.m_antloc.RemoveAll();
	m_BioData.m_posloc.RemoveAll();
	m_BioData.m_gagstr.RemoveAll();
	m_BioData.m_disstr.RemoveAll();
	m_BioData.m_gagspn.RemoveAll();
	m_BioData.m_disspn.RemoveAll();
	m_BioData.m_totgag.RemoveAll();
	m_BioData.m_chbcom.RemoveAll();
	m_BioData.m_gaugesets=0;
	m_BioData.m_Gauge_bandno.RemoveAll();
	m_BioData.m_gageno.RemoveAll();
	m_BioData.m_gagdis.RemoveAll();
	m_BioData.m_Gauge_curno.RemoveAll();
	m_BioData.m_gagcom.RemoveAll();
	m_BioData.m_curno=0;
	m_BioData.m_sentyp.RemoveAll();
	m_BioData.m_senloc.RemoveAll();
	m_BioData.m_senatt.RemoveAll();
	m_BioData.m_axis.RemoveAll();
	m_BioData.m_xunits.RemoveAll();
	m_BioData.m_yunits.RemoveAll();
	m_BioData.m_prefil.RemoveAll();
	m_BioData.m_insman.RemoveAll();
	m_BioData.m_caldat.RemoveAll();
	m_BioData.m_insrat.RemoveAll();
	m_BioData.m_chlmax.RemoveAll();
	m_BioData.m_inivel.RemoveAll();
	m_BioData.m_nfp.RemoveAll();
	m_BioData.m_nlp.RemoveAll();
	m_BioData.m_delt.RemoveAll();
	m_BioData.m_dastat.RemoveAll();
	m_BioData.m_chstat.RemoveAll();
	m_BioData.m_inscom.RemoveAll();
	// Reinitialize BioData Arrays  ********************
	m_BioData.m_ribloc.SetAtGrow(0,"");m_BioData.m_ribloc.SetAtGrow(1,"");
	m_BioData.m_ribin.SetAtGrow(0,"");m_BioData.m_ribin.SetAtGrow(1,"");
	m_BioData.m_nadis.SetAtGrow(0,"");m_BioData.m_nadis.SetAtGrow(1,"");
	m_BioData.m_splen.SetAtGrow(0,"");m_BioData.m_splen.SetAtGrow(1,"");
	m_BioData.m_defl.SetAtGrow(0,"");m_BioData.m_defl.SetAtGrow(1,"");
	m_BioData.m_load.SetAtGrow(0,"");m_BioData.m_load.SetAtGrow(1,"");
	m_BioData.m_brkld.SetAtGrow(0,"");m_BioData.m_brkld.SetAtGrow(1,"");
	m_BioData.m_armar.SetAtGrow(0,"");m_BioData.m_armar.SetAtGrow(1,"");
	m_BioData.m_rarea.SetAtGrow(0,"");m_BioData.m_rarea.SetAtGrow(1,"");
	m_BioData.m_bodyrg.SetAtGrow(0,"");m_BioData.m_bodyrg.SetAtGrow(1,"");
	m_BioData.m_aspect.SetAtGrow(0,"");m_BioData.m_aspect.SetAtGrow(1,"");
	m_BioData.m_lesion.SetAtGrow(0,"");m_BioData.m_lesion.SetAtGrow(1,"");
	m_BioData.m_sysorg.SetAtGrow(0,"");m_BioData.m_sysorg.SetAtGrow(1,"");
	m_BioData.m_ais.SetAtGrow(0,"");m_BioData.m_ais.SetAtGrow(1,"");
	m_BioData.m_ais90.SetAtGrow(0,"");m_BioData.m_ais90.SetAtGrow(1,0);
	m_BioData.m_injcom.SetAtGrow(0,"");m_BioData.m_injcom.SetAtGrow(1,"");
	m_BioData.m_rsttyp.SetAtGrow(0,"");m_BioData.m_rsttyp.SetAtGrow(1,"");
	m_BioData.m_rstmnt.SetAtGrow(0,"");m_BioData.m_rstmnt.SetAtGrow(1,"");
	m_BioData.m_deploy.SetAtGrow(0,"");m_BioData.m_deploy.SetAtGrow(1,"");
	m_BioData.m_rstcom.SetAtGrow(0,"");m_BioData.m_rstcom.SetAtGrow(1,"");
	m_BioData.m_chsdpt.SetAtGrow(0,"");m_BioData.m_chsdpt.SetAtGrow(1,"");
	m_BioData.m_chsbrd.SetAtGrow(0,"");m_BioData.m_chsbrd.SetAtGrow(1,"");
	m_BioData.m_banlen.SetAtGrow(0,"");m_BioData.m_banlen.SetAtGrow(1,"");
	m_BioData.m_antloc.SetAtGrow(0,"");m_BioData.m_antloc.SetAtGrow(1,"");
	m_BioData.m_posloc.SetAtGrow(0,"");m_BioData.m_posloc.SetAtGrow(1,"");
	m_BioData.m_gagstr.SetAtGrow(0,"");m_BioData.m_gagstr.SetAtGrow(1,"");
	m_BioData.m_disstr.SetAtGrow(0,"");m_BioData.m_disstr.SetAtGrow(1,"");
	m_BioData.m_gagspn.SetAtGrow(0,"");m_BioData.m_gagspn.SetAtGrow(1,"");
	m_BioData.m_disspn.SetAtGrow(0,"");m_BioData.m_disspn.SetAtGrow(1,"");
	m_BioData.m_totgag.SetAtGrow(0,"");m_BioData.m_totgag.SetAtGrow(1,"");
	m_BioData.m_chbcom.SetAtGrow(0,"");m_BioData.m_chbcom.SetAtGrow(1,"");
	m_BioData.m_Gauge_bandno.SetAtGrow(0,"");m_BioData.m_Gauge_bandno.SetAtGrow(1,"");
	m_BioData.m_gageno.SetAtGrow(0,"");m_BioData.m_gageno.SetAtGrow(1,"");
	m_BioData.m_gagdis.SetAtGrow(0,"");m_BioData.m_gagdis.SetAtGrow(1,"");
	m_BioData.m_Gauge_curno.SetAtGrow(0,"");m_BioData.m_Gauge_curno.SetAtGrow(1,"");
	m_BioData.m_gagcom.SetAtGrow(0,"");m_BioData.m_gagcom.SetAtGrow(1,"");
	m_BioData.m_sentyp.SetAtGrow(0,"");m_BioData.m_sentyp.SetAtGrow(1,"");
	m_BioData.m_senloc.SetAtGrow(0,"");m_BioData.m_senloc.SetAtGrow(1,"");
	m_BioData.m_senatt.SetAtGrow(0,"");m_BioData.m_senatt.SetAtGrow(1,"");
	m_BioData.m_axis.SetAtGrow(0,"");m_BioData.m_axis.SetAtGrow(1,"");
	m_BioData.m_xunits.SetAtGrow(0,"");m_BioData.m_xunits.SetAtGrow(1,"");
	m_BioData.m_yunits.SetAtGrow(0,"");m_BioData.m_yunits.SetAtGrow(1,"");
	m_BioData.m_prefil.SetAtGrow(0,"");m_BioData.m_prefil.SetAtGrow(1,"");
	m_BioData.m_insman.SetAtGrow(0,"");m_BioData.m_insman.SetAtGrow(1,"");
	m_BioData.m_caldat.SetAtGrow(0,"");m_BioData.m_caldat.SetAtGrow(1,"");
	m_BioData.m_insrat.SetAtGrow(0,"");m_BioData.m_insrat.SetAtGrow(1,"");
	m_BioData.m_chlmax.SetAtGrow(0,"");m_BioData.m_chlmax.SetAtGrow(1,"");
	m_BioData.m_inivel.SetAtGrow(0,"");m_BioData.m_inivel.SetAtGrow(1,"");
	m_BioData.m_nfp.SetAtGrow(0,"");m_BioData.m_nfp.SetAtGrow(1,"");
	m_BioData.m_nlp.SetAtGrow(0,"");m_BioData.m_nlp.SetAtGrow(1,"");
	m_BioData.m_delt.SetAtGrow(0,"");m_BioData.m_delt.SetAtGrow(1,"");
	m_BioData.m_dastat.SetAtGrow(0,"AM");m_BioData.m_dastat.SetAtGrow(1,"AM");
	m_BioData.m_chstat.SetAtGrow(0,"P");m_BioData.m_chstat.SetAtGrow(1,"P");
	m_BioData.m_inscom.SetAtGrow(0,"");m_BioData.m_inscom.SetAtGrow(1,"");

	// TestPage ****************
	m_BioMechTestPage.m_editclsspd	= _T("");
	m_BioMechTestPage.m_editconno	= _T("");
	m_BioMechTestPage.m_editimpang	= _T("");
	m_BioMechTestPage.m_editlink	= _T("");
	m_BioMechTestPage.m_edittotcrv	= _T("0");
	m_BioMechTestPage.m_editrectyp	= _T("");
	m_BioMechTestPage.m_edittemp	= _T("");
	m_BioMechTestPage.m_edittitle	= _T("");
	m_BioMechTestPage.m_edittstcfn	= _T("");
	m_BioMechTestPage.m_edittstcom	= _T("");
	m_BioMechTestPage.m_edittstobj	= _T("");
	m_BioMechTestPage.m_edittstprf	= _T("");
	m_BioMechTestPage.m_edittstref	= _T("");
	m_BioMechTestPage.m_editverno	= _T("B5");
	// RestPage ****************
	m_BioRestPage.m_editdeploy = _T("");
	m_BioRestPage.m_editrstcom = _T("");
	m_BioRestPage.m_editrstmnt = _T("");
	m_BioRestPage.m_editrstno = _T("0");
	m_BioRestPage.m_editrsttyp = _T("");
	m_BioRestPage.m_currest = 0;
	// AnthPage ***************
	m_BioAnthPage.m_editanklcr = "";
	m_BioAnthPage.m_editanklht = "";
	m_BioAnthPage.m_editbicpcr = "";
	m_BioAnthPage.m_editbuttcr = "";
	m_BioAnthPage.m_editbuttdp = "";
	m_BioAnthPage.m_editcalfcr = "";
	m_BioAnthPage.m_editchstbd = "";
	m_BioAnthPage.m_editchstcr = "";
	m_BioAnthPage.m_editchstdp = "";
	m_BioAnthPage.m_editelbwcr = "";
	m_BioAnthPage.m_editfarmcr = "";
	m_BioAnthPage.m_editfarmhd = "";
	m_BioAnthPage.m_editfootbd = "";
	m_BioAnthPage.m_editfootln = "";
	m_BioAnthPage.m_edithdtroc = "";
	m_BioAnthPage.m_editheadbd = "";
	m_BioAnthPage.m_editheadch = "";
	m_BioAnthPage.m_editheadln = "";
	m_BioAnthPage.m_editinscye = "";
	m_BioAnthPage.m_editkneecr = "";
	m_BioAnthPage.m_editkneeht = "";
	m_BioAnthPage.m_editltghcr = "";
	m_BioAnthPage.m_editneckcr = "";
	m_BioAnthPage.m_editscyecr = "";
	m_BioAnthPage.m_editseatht = "";
	m_BioAnthPage.m_editshldbd = "";
	m_BioAnthPage.m_editshldel = "";
	m_BioAnthPage.m_editshldht = "";
	m_BioAnthPage.m_editstatur = "";
	m_BioAnthPage.m_editthghcr = "";
	m_BioAnthPage.m_edittiblht = "";
	m_BioAnthPage.m_editvrtsym = "";
	m_BioAnthPage.m_editwastbd = "";
	m_BioAnthPage.m_editwastcr = "";
	m_BioAnthPage.m_editwastdp = "";
	m_BioAnthPage.m_editwastht = "";
	m_BioAnthPage.m_editwrstcr = "";
	m_BioAnthPage.m_edithipbd  = "";
	//InjPage **************
	m_BioInjPage.m_editais		= _T("");
	m_BioInjPage.m_editais90	= _T("");
	m_BioInjPage.m_editaspect	= _T("");
	m_BioInjPage.m_editbodyrg	= _T("");
	m_BioInjPage.m_editinjcom	= _T("");
	m_BioInjPage.m_editlesion	= _T("");
	m_BioInjPage.m_editsysorg	= _T("");
	m_BioInjPage.m_curinj		= 0;
	//CBandPage ***************
	m_BioCBandPage.m_curband = 0;
	m_BioCBandPage.m_editantloc = _T("");
	m_BioCBandPage.m_editbanlen = _T("");
	m_BioCBandPage.m_editchbcom = _T("");
	m_BioCBandPage.m_editchsbrd = _T("");
	m_BioCBandPage.m_editchsdpt = _T("");
	m_BioCBandPage.m_editdisspn = _T("");
	m_BioCBandPage.m_editdisstr = _T("");
	m_BioCBandPage.m_editgagspn = _T("");
	m_BioCBandPage.m_editgagstr = _T("");
	m_BioCBandPage.m_editposloc = _T("");
	m_BioCBandPage.m_edittotgag = _T("");
	// DumPage**************
	m_BioDumPage.m_editclip3m	= _T("");
	m_BioDumPage.m_editcmax		= _T("");
	m_BioDumPage.m_editcsi		= _T("");
	m_BioDumPage.m_editcti		= _T("");
	m_BioDumPage.m_editdcompwt	= _T("");
	m_BioDumPage.m_editdoccloc	= _T("");
	m_BioDumPage.m_editdoccom	= _T("");
	m_BioDumPage.m_editdoccsex	= _T("");
	m_BioDumPage.m_editdumdsc	= _T("");
	m_BioDumPage.m_editdumman	= _T("");
	m_BioDumPage.m_editdummod	= _T("");
	m_BioDumPage.m_editdumsiz	= _T("");
	m_BioDumPage.m_edithic		= _T("");
	m_BioDumPage.m_editbelt		= _T("");
	m_BioDumPage.m_editlfem		= _T("");
	m_BioDumPage.m_editmthcal	= _T("");
	m_BioDumPage.m_editnij		= _T("");
	m_BioDumPage.m_editpelvg	= _T("");
	m_BioDumPage.m_editrfem		= _T("");
	m_BioDumPage.m_editsbelt	= _T("");
	m_BioDumPage.m_editt1		= _T("");
	m_BioDumPage.m_editt2		= _T("");
	m_BioDumPage.m_edittti		= _T("");
	m_BioDumPage.m_editvc		= _T("");
	m_BioDumPage.m_editdseposn	= _T("");
	//OccPage**************
	m_BioOccPage.m_editaorpre	= _T("");
	m_BioOccPage.m_editbcompwt	= _T("");
	m_BioOccPage.m_editbedcon	= _T("");
	m_BioOccPage.m_editbmc		= _T("");
	m_BioOccPage.m_editbmccom	= _T("");
	m_BioOccPage.m_editbmcloc	= _T("");
	m_BioOccPage.m_editbmcmethod = _T("");
	m_BioOccPage.m_editbmcunits = _T("");
	m_BioOccPage.m_editcadan	= _T("");
	m_BioOccPage.m_editcadapp	= _T("");
	m_BioOccPage.m_editcerpre	= _T("");
	m_BioOccPage.m_editcsedth	= _T("");
	m_BioOccPage.m_editfrctrb	= _T("");
	m_BioOccPage.m_editnotest	= _T("");
	m_BioOccPage.m_editoccage	= _T("");
	m_BioOccPage.m_editocccom	= _T("");
	m_BioOccPage.m_editoccloc	= _T("");
	m_BioOccPage.m_editoccref	= _T("");
	m_BioOccPage.m_editoccsex	= _T("");
	m_BioOccPage.m_editoccwt	= _T("");
	m_BioOccPage.m_editpulpre	= _T("");
	m_BioOccPage.m_editrbfrct	= _T("");
	m_BioOccPage.m_editseposn	= _T("");
	//InstPage**************
	m_BioInstPage.m_editaxis	= _T("");
	m_BioInstPage.m_editchlmax	= _T("");
	m_BioInstPage.m_editchstat	= _T("P");
	m_BioInstPage.m_editdastat	= _T("AM");
	m_BioInstPage.m_editdelt	= _T("");
	m_BioInstPage.m_editinivel	= _T("");
	m_BioInstPage.m_editinscom	= _T("");
	m_BioInstPage.m_editinsman	= _T("");
	m_BioInstPage.m_editinsrat	= _T("");
	m_BioInstPage.m_editnfp		= _T("");
	m_BioInstPage.m_editnlp		= _T("");
	m_BioInstPage.m_editprefil	= _T("");
	m_BioInstPage.m_editsenatt	= _T("");
	m_BioInstPage.m_editsenloc	= _T("");
	m_BioInstPage.m_editsentyp	= _T("");
	m_BioInstPage.m_editxunits	= _T("SEC");
	m_BioInstPage.m_edityunits	= _T("");
	m_BioInstPage.m_icurno		= 0;     // Default to first curve.
	m_BioInstPage.m_totalcurves	=0; //initialize total curves.
	//GaugePage**************
	m_BioGaugePage.m_editbandno		= _T("");
	m_BioGaugePage.m_editcurno		= _T("");
	m_BioGaugePage.m_editgagcom		= _T("");
	m_BioGaugePage.m_editgagdis		= _T("");
	m_BioGaugePage.m_editgageno		= _T("");
	m_BioGaugePage.m_curset			= 0;
	m_BioGaugePage.m_settot			= 0;
	
	//RibPage *************
	m_BioRibPage.m_editarmar	= _T("");
	m_BioRibPage.m_editbrkld	= _T("");
	m_BioRibPage.m_editdefl		= _T("");
	m_BioRibPage.m_editload		= _T("");
	m_BioRibPage.m_editnadis	= _T("");
	m_BioRibPage.m_editrarea	= _T("");
	m_BioRibPage.m_editribin	= _T("");
	m_BioRibPage.m_editribloc	= _T("");
	m_BioRibPage.m_editsplen	= _T("");
	m_BioRibPage.m_currib		= 0;

	if (m_BioMechTestPage.m_hWnd!=NULL) m_BioMechTestPage.UpdateData(FALSE);
	if (m_BioInstPage.m_hWnd!=NULL)
	{
		m_BioInstPage.m_curvelist.ResetContent();
		m_BioInstPage.UpdateData(FALSE);
	}
	
	if (m_BioRestPage.m_hWnd!=NULL)
	{
		m_BioRestPage.m_restlist.ResetContent ();
		m_BioRestPage.UpdateData (FALSE);
	
	}

	if (m_BioAnthPage.m_hWnd!=NULL) m_BioAnthPage.UpdateData(FALSE);

	if (m_BioInjPage.m_hWnd!=NULL) 
	{
		m_BioInjPage.m_injlist.ResetContent ();
		m_BioInjPage.UpdateData(FALSE);
	}

	if (m_BioCBandPage.m_hWnd!=NULL)
	{
		m_BioCBandPage.m_cbandlist.ResetContent();
		m_BioCBandPage.UpdateData(FALSE);
	}

	if (m_BioDumPage.m_hWnd!=NULL) m_BioDumPage.UpdateData(FALSE);
	if (m_BioOccPage.m_hWnd!=NULL) m_BioOccPage.UpdateData(FALSE);
	
	if (m_BioGaugePage.m_hWnd!=NULL) 
	{
		m_BioGaugePage.m_gaugelist.ResetContent();
		m_BioGaugePage.UpdateData(FALSE);
	}
	
	if (m_BioRibPage.m_hWnd!=NULL) 
	{
		m_BioRibPage.m_riblist.ResetContent();
		m_BioRibPage.UpdateData(FALSE);
	}
	
	m_BioData.ClearHsvddata();
	if (m_HsvdPage.m_hWnd!=NULL) { m_HsvdPage.ClearAll(); }	// for high speed video

	this->_bClearAll = true;

	return;		// was returning TRUE
}

// Load data from all pages into BioData.  If success,
// let the user export an EV5 file containing this data.
void CBioMechPropertySheet::OnExportTest() 
{
	// Get latest data from pages - if already loaded, no big deal.
	if (!m_BioMechTestPage.LoadBioTestData ()) return;
	if (!m_BioInstPage.LoadBioInstData ()) return;
	if (!m_BioRestPage.LoadBioRestData ()) return;
	if (!m_BioAnthPage.LoadBioAnthData ()) return;
	if (!m_BioInjPage.LoadBioInjData ()) return;
	if (!m_BioCBandPage.LoadBioCBandData ()) return;
	if (!m_BioDumPage.LoadBioDumData ()) return;
	if (!m_BioOccPage.LoadBioOccData ()) return;
	if (!m_BioGaugePage.LoadBioGaugeData()) return ;
	if (!m_BioRibPage.LoadBioRibData ()) return;

	if ( !(m_BioData.ValidateDoccData() || m_BioData.ValidateSoccData()) ) 
	{ 
		AfxMessageBox("Both bio-dummy and bio-occupant tables are empty.\nIt is illegal. No file output.");
		return; 
	}

	CFileDialog export(FALSE);
	export.m_ofn.lpstrTitle ="Export File";
	export.m_ofn.lpstrFilter = "EV5 File (*.ev5)\0*.ev5\0";

	if(export.DoModal()==IDOK)
	{
		//export here
		CString strfile_out = export.GetPathName ();
		if (export.GetFileExt ()!="ev5")
		{
			strfile_out +=".ev5";
		}
		m_BioData.ExportEV5 (strfile_out);

		// export high-speed video report
		if( m_BioData.m_camno.GetSize()<2 ) { return; }

		if ( !m_HsvdPage.ValidateThisPage() ) 
		{ 
			AfxMessageBox("Illegal data found. No file output.");
			return; 
		}

		strfile_out.TrimRight();
		CString HsvdFile = strfile_out.Left(strfile_out.GetLength()-4) + ".hs5";
		m_BioData.ExportHsvd( HsvdFile );
	}
	
}	// OnExportTest

// Let the user choose a file to import, and then try to load it.
void CBioMechPropertySheet::OnImportTest() 
{
	CFileDialog import(TRUE);
	import.m_ofn.lpstrTitle ="Open Test";
	import.m_ofn.lpstrFilter =
	 "EV5 Tests (*.ev5)\0*.ev5\0EV4 Tests (*.ev4)\0*.ev4\0EV3 Test Data (*.gr1)\0*.gr1\0EV3 Instrumentation Data (*.gr5)\0*.gr5\0EV3 Occupant Data (*.gr6)\0*.gr6\0EV3 Anthropometry Data (*.gr7)\0*.gr7\0EV3 Occupant Injury Data (*.gr8)\0*.gr8\0EV3 Gauge Data (*.gry)\0*.gry\0EV3 Chest Band Data (*.grz)\0*.grz\0";

	if (import.DoModal ()==IDOK)
	{
	
		//import here
		CString strfile_in = import.GetPathName () ;
		CString strext = import.GetFileExt ();
		strext.MakeLower ();

		if (strext == "ev5") 
		{
			OnClearall();
			if( this->_bClearAll == false )
			{
				//	exit if user doesn't want to 
				//	replace current data with imported data.
				return;
			}

			BOOL success = m_BioData.ImportEV5(strfile_in);
			if (success) 
			{
				
				m_BioMechTestPage.OnSetActive ();  //m_hWnd always exists
				if (m_BioAnthPage.m_hWnd) m_BioAnthPage.OnSetActive();

				m_BioCBandPage.m_curband = m_BioData.m_bandno;  //goto last set.
				if (m_BioCBandPage.m_hWnd) m_BioCBandPage.OnSetActive();
				
				if (m_BioDumPage.m_hWnd) m_BioDumPage.OnSetActive();

				m_BioGaugePage.m_curset = m_BioData.m_gaugesets;  //goto last set.
				if (m_BioGaugePage.m_hWnd) m_BioGaugePage.OnSetActive();

				m_BioInjPage.m_curinj = m_BioData.m_injno;  //goto last set.
				if (m_BioInjPage.m_hWnd) m_BioInjPage.OnSetActive();

				m_BioInstPage.m_icurno = m_BioData.m_totcrv;  //goto last set.
				if (m_BioInstPage.m_hWnd) m_BioInstPage.OnSetActive();

				if (m_BioOccPage.m_hWnd) m_BioOccPage.OnSetActive();

				m_BioRestPage.m_currest = m_BioData.m_rstno;  //goto last set.
				if (m_BioRestPage.m_hWnd) m_BioRestPage.OnSetActive();

				m_BioRibPage.m_currib = m_BioData.m_ribno;  //goto last set.
				if (m_BioRibPage.m_hWnd) m_BioRibPage.OnSetActive();
				
				// import High Speed Video data
				strfile_in.TrimRight();

				CString HsvdFile = strfile_in.Left(strfile_in.GetLength()-4) + ".hs5";
				ImportHsvdData(HsvdFile, false);
			}
		}
		else if (strext=="ev4")
		{
			OnClearall();
			if( this->_bClearAll == false ) 
			{
				//	exit if user doesn't want to replace
				//	current data with imported data.
				return;
			}
						

			BOOL success = m_BioData.ImportEV4(strfile_in);
			if (success) 
			{
				m_BioMechTestPage.OnSetActive ();  //m_hWnd always exists
				if (m_BioAnthPage.m_hWnd) m_BioAnthPage.OnSetActive();

				m_BioCBandPage.m_curband = m_BioData.m_bandno;  //goto last set.
				if (m_BioCBandPage.m_hWnd) m_BioCBandPage.OnSetActive();
				
				if (m_BioDumPage.m_hWnd) m_BioDumPage.OnSetActive();

				m_BioGaugePage.m_curset = m_BioData.m_gaugesets;  //goto last set.
				if (m_BioGaugePage.m_hWnd) m_BioGaugePage.OnSetActive();

				m_BioInjPage.m_curinj = m_BioData.m_injno;  //goto last set.
				if (m_BioInjPage.m_hWnd) m_BioInjPage.OnSetActive();

				m_BioInstPage.m_icurno = m_BioData.m_totcrv;  //goto last set.
				if (m_BioInstPage.m_hWnd) m_BioInstPage.OnSetActive();

				if (m_BioOccPage.m_hWnd) m_BioOccPage.OnSetActive();

				m_BioRestPage.m_currest = m_BioData.m_rstno;  //goto last set.
				if (m_BioRestPage.m_hWnd) m_BioRestPage.OnSetActive();

				m_BioRibPage.m_currib = m_BioData.m_ribno;  //goto last set.
				if (m_BioRibPage.m_hWnd) m_BioRibPage.OnSetActive();
				
			}
			
		}
		else if (strext=="gr1")
		{
			BOOL success= m_BioData.ImportGR1(strfile_in);
			if (success) 
			{
				m_BioMechTestPage.OnSetActive ();  //m_hWnd always exists
				if (m_BioAnthPage.m_hWnd) m_BioAnthPage.OnSetActive();
				if (m_BioCBandPage.m_hWnd) m_BioCBandPage.OnSetActive();
				if (m_BioDumPage.m_hWnd) m_BioDumPage.OnSetActive();
				if (m_BioGaugePage.m_hWnd) m_BioGaugePage.OnSetActive();
				if (m_BioInjPage.m_hWnd) m_BioInjPage.OnSetActive();
				if (m_BioInstPage.m_hWnd) m_BioInstPage.OnSetActive();
				if (m_BioOccPage.m_hWnd) m_BioOccPage.OnSetActive();
				if (m_BioRestPage.m_hWnd) m_BioRestPage.OnSetActive();
				if (m_BioRibPage.m_hWnd) m_BioRibPage.OnSetActive();
			}
			
		}
		else if (strext=="gr5")
		{
			BOOL success= m_BioData.ImportGR5(strfile_in);
			if (success) 
			{
				m_BioMechTestPage.OnSetActive ();  //m_hWnd always exists
				m_BioInstPage.m_icurno = m_BioData.m_totcrv;  //goto last set.

				if (m_BioAnthPage.m_hWnd) m_BioAnthPage.OnSetActive();
				if (m_BioCBandPage.m_hWnd) m_BioCBandPage.OnSetActive();
				if (m_BioDumPage.m_hWnd) m_BioDumPage.OnSetActive();
				if (m_BioGaugePage.m_hWnd) m_BioGaugePage.OnSetActive();
				if (m_BioInjPage.m_hWnd) m_BioInjPage.OnSetActive();
				if (m_BioInstPage.m_hWnd) m_BioInstPage.OnSetActive();
				if (m_BioOccPage.m_hWnd) m_BioOccPage.OnSetActive();
				if (m_BioRestPage.m_hWnd) m_BioRestPage.OnSetActive();
				if (m_BioRibPage.m_hWnd) m_BioRibPage.OnSetActive();
			}
			
		}
		else if (strext=="gr6")
		{
			BOOL success= m_BioData.ImportGR6(strfile_in);
			if (success) 
			{
				m_BioMechTestPage.OnSetActive ();  //m_hWnd always exists
				if (m_BioAnthPage.m_hWnd) m_BioAnthPage.OnSetActive();
				if (m_BioCBandPage.m_hWnd) m_BioCBandPage.OnSetActive();
				if (m_BioDumPage.m_hWnd) m_BioDumPage.OnSetActive();
				if (m_BioGaugePage.m_hWnd) m_BioGaugePage.OnSetActive();
				if (m_BioInjPage.m_hWnd) m_BioInjPage.OnSetActive();
				if (m_BioInstPage.m_hWnd) m_BioInstPage.OnSetActive();
				if (m_BioOccPage.m_hWnd) m_BioOccPage.OnSetActive();
				if (m_BioRestPage.m_hWnd) m_BioRestPage.OnSetActive();
				if (m_BioRibPage.m_hWnd) m_BioRibPage.OnSetActive();
			}
			
		}
		else if (strext=="gr7")
		{
			BOOL success= m_BioData.ImportGR7(strfile_in);
			if (success) 
			{
				m_BioMechTestPage.OnSetActive ();  //m_hWnd always exists
				if (m_BioAnthPage.m_hWnd) m_BioAnthPage.OnSetActive();
				if (m_BioCBandPage.m_hWnd) m_BioCBandPage.OnSetActive();
				if (m_BioDumPage.m_hWnd) m_BioDumPage.OnSetActive();
				if (m_BioGaugePage.m_hWnd) m_BioGaugePage.OnSetActive();
				if (m_BioInjPage.m_hWnd) m_BioInjPage.OnSetActive();
				if (m_BioInstPage.m_hWnd) m_BioInstPage.OnSetActive();
				if (m_BioOccPage.m_hWnd) m_BioOccPage.OnSetActive();
				if (m_BioRestPage.m_hWnd) m_BioRestPage.OnSetActive();
				if (m_BioRibPage.m_hWnd) m_BioRibPage.OnSetActive();
			}
			
		}
		else if (strext=="gr8")
		{
			short nSets = m_BioData.ImportGR8(strfile_in);
			if (nSets) 
			{
				m_BioData.m_injno = nSets;

				m_BioInjPage.m_curinj = m_BioData.m_injno;  //goto last set.
			
				m_BioMechTestPage.OnSetActive ();  //m_hWnd always exists
				if (m_BioAnthPage.m_hWnd) m_BioAnthPage.OnSetActive();
				if (m_BioCBandPage.m_hWnd) m_BioCBandPage.OnSetActive();
				if (m_BioDumPage.m_hWnd) m_BioDumPage.OnSetActive();
				if (m_BioGaugePage.m_hWnd) m_BioGaugePage.OnSetActive();
				if (m_BioInjPage.m_hWnd) m_BioInjPage.OnSetActive();
				if (m_BioInstPage.m_hWnd) m_BioInstPage.OnSetActive();
				if (m_BioOccPage.m_hWnd) m_BioOccPage.OnSetActive();
				if (m_BioRestPage.m_hWnd) m_BioRestPage.OnSetActive();
				if (m_BioRibPage.m_hWnd) m_BioRibPage.OnSetActive();
			}
			
		}
		else if (strext=="gry")
		{
			short nSets = m_BioData.ImportGRY(strfile_in);
			if (nSets) 
			{
				m_BioData.m_gaugesets = nSets;
				m_BioGaugePage.m_curset = m_BioData.m_gaugesets;  //goto last set.

				m_BioMechTestPage.OnSetActive ();  //m_hWnd always exists
				if (m_BioAnthPage.m_hWnd) m_BioAnthPage.OnSetActive();
				if (m_BioCBandPage.m_hWnd) m_BioCBandPage.OnSetActive();
				if (m_BioDumPage.m_hWnd) m_BioDumPage.OnSetActive();
				if (m_BioGaugePage.m_hWnd) m_BioGaugePage.OnSetActive();
				if (m_BioInjPage.m_hWnd) m_BioInjPage.OnSetActive();
				if (m_BioInstPage.m_hWnd) m_BioInstPage.OnSetActive();
				if (m_BioOccPage.m_hWnd) m_BioOccPage.OnSetActive();
				if (m_BioRestPage.m_hWnd) m_BioRestPage.OnSetActive();
				if (m_BioRibPage.m_hWnd) m_BioRibPage.OnSetActive();
			}
			
		}
		else if (strext=="grz")
		{
			short nSets = m_BioData.ImportGRZ(strfile_in);
			if (nSets) 
			{
				m_BioData.m_bandno = nSets;
				m_BioCBandPage.m_curband = m_BioData.m_bandno;  //goto last set.

				m_BioMechTestPage.OnSetActive ();  //m_hWnd always exists
				if (m_BioAnthPage.m_hWnd) m_BioAnthPage.OnSetActive();
				if (m_BioCBandPage.m_hWnd) m_BioCBandPage.OnSetActive();
				if (m_BioDumPage.m_hWnd) m_BioDumPage.OnSetActive();
				if (m_BioGaugePage.m_hWnd) m_BioGaugePage.OnSetActive();
				if (m_BioInjPage.m_hWnd) m_BioInjPage.OnSetActive();
				if (m_BioInstPage.m_hWnd) m_BioInstPage.OnSetActive();
				if (m_BioOccPage.m_hWnd) m_BioOccPage.OnSetActive();
				if (m_BioRestPage.m_hWnd) m_BioRestPage.OnSetActive();
				if (m_BioRibPage.m_hWnd) m_BioRibPage.OnSetActive();
			}	
		}	
	}	
}	// OnImportTest

void CBioMechPropertySheet::OnExit() 
{
	OnClose();	
}


//  *************************
//  Ask user which file to print.  Then ask which printer to print with.
//  Then do an annoying line by line print loop.  There must be a better 
//  way to do this.  See ch15 from Programming Windows 95 by Petzold.
//  *************************
void CBioMechPropertySheet::OnFilePrint() 
{

	CString strfile_out= GetPrintFileName();
	if (strfile_out=="") return;  // no file chosen, cancel.

	CString device = GetPrinterDeviceName();
	if (device == "") return; // no printer chosen, cancel.

	CStdioFile myFile;
	CFileException fileException;

	myFile.Open( strfile_out, CFile::shareDenyNone | CFile::modeRead | CFile::typeText,
		&fileException );
	if (!myFile.m_pStream)  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_out, fileException.m_cause );
		MessageBox(msg);
		return;
	}

	
	static DOCINFO di={sizeof(DOCINFO), strfile_out,NULL};

	HDC hdcPrn = CreateDC("WINSPOOL", device, NULL, NULL);

	// size of page and chars and lines per page.
	TEXTMETRIC tm;
	GetTextMetrics(hdcPrn, &tm);
	int yChar, nline = 0;
	yChar = tm.tmHeight +tm.tmExternalLeading;
	int iCharsPerLine = GetDeviceCaps(hdcPrn, HORZRES) /tm.tmAveCharWidth ;
	int iLinesPerPage = GetDeviceCaps(hdcPrn, VERTRES) / yChar;
	
	StartDoc (hdcPrn, &di);
	StartPage (hdcPrn);
	
	CString strbuf;
	char* pBuf = new char[iCharsPerLine + 1];
	// readstrings from file.  
	while (myFile.ReadString(pBuf, iCharsPerLine)) //reads max of iCharsPerLine chars.
	{
		if (nline == iLinesPerPage)  //new page
		{
			nline = 0;
			EndPage(hdcPrn);
			StartPage(hdcPrn);
		}
		// WARNING! TextOut doesn't handle Tabs well, so there are no tabs in .ev5 or .evr.
		strbuf = pBuf;
		TextOut(hdcPrn,0,yChar*nline, strbuf, strbuf.GetLength ());
		nline++;
		
	}

	EndPage(hdcPrn);
	EndDoc(hdcPrn);
	DeleteDC(hdcPrn);
	delete [] pBuf;
	myFile.Close ();
	return;

}

CString CBioMechPropertySheet::GetPrintFileName()
{
	// Get Print File Name  **********
	CFileDialog printfile(TRUE);
	CString strfile_out;
	printfile.m_ofn.lpstrTitle ="Choose File To Print";
	printfile.m_ofn.lpstrFilter = "EV5 File (*.ev5)\0*.ev5\0EV5 Report File (*.evr)\0*.evr\0";

	if (printfile.DoModal()==IDOK)
	{
		strfile_out = printfile.GetPathName ();
	}
	else
	{
		strfile_out = "";
	}
	return strfile_out;

}

CString CBioMechPropertySheet::GetPrinterDeviceName()
{
	CString device;
	// Choose Printer to use ************
	CPrintDialog printmachine(FALSE);
	
	if (printmachine.DoModal ()==IDOK)
	{
		device = printmachine.GetDeviceName();
		GlobalFree(printmachine.m_pd.hDevMode );
		GlobalFree(printmachine.m_pd.hDevNames );
	}
	else
	{
		GlobalFree(printmachine.m_pd.hDevMode );
		GlobalFree(printmachine.m_pd.hDevNames );
		device = "";
	}
	return device;

}

// Try to load all data into m_BioData.  If success,
// let the user export this data into a report (EVR) file.
void CBioMechPropertySheet::OnExportReport() 
{
	// Get latest data from pages - if already loaded, no big deal.
	if (!m_BioMechTestPage.LoadBioTestData ()) return;
	if (!m_BioDumPage.LoadBioDumData ()) return;
	if (!m_BioOccPage.LoadBioOccData ()) return;
	if (!m_BioRibPage.LoadBioRibData ()) return;
	if (!m_BioRestPage.LoadBioRestData ()) return;

	if (!m_BioAnthPage.LoadBioAnthData ()) return;
	if (!m_BioInjPage.LoadBioInjData ()) return;
	if (!m_BioInstPage.LoadBioInstData ()) return;
	if (!m_BioCBandPage.LoadBioCBandData ()) return;	
	if (!m_BioGaugePage.LoadBioGaugeData ()) return;

	if ( !(m_BioData.ValidateDoccData() || m_BioData.ValidateSoccData()) ) 
	{ 
		AfxMessageBox("Both bio-dummy and bio-occupant tables are empty.\nIt is illegal. No Report output.");
		return; 
	}
	
	// File export dialog common control
	CFileDialog export(FALSE);
	export.m_ofn.lpstrTitle ="Export Report";
	export.m_ofn.lpstrFilter = "EV5 Report (*.evr)\0*.evr\0";

	if (export.DoModal()==IDOK)
	{
		//export here
		CString strfile_out = export.GetPathName ();
		if (export.GetFileExt ()!="evr")
		{
			strfile_out +=".evr";
		}
		m_BioData.ExportEVR (strfile_out);

		// Export high speed video report
		if( m_BioData.m_camno.GetSize()<2 ) { return; }

		if ( !m_HsvdPage.ValidateThisPage() ) 
		{ 
			AfxMessageBox("Illegal data found. No file output.");
			return; 
		}

		strfile_out.TrimRight();
		CString HsvdFile = strfile_out.Left(strfile_out.GetLength()-4) + ".hsr";
		m_BioData.ExportHsvdReport( HsvdFile );
	}		
}	// OnExportReport

void CBioMechPropertySheet::OnClose() 
{
	if (MessageBox("Really exit Entree?", "Warning", MB_YESNO)==IDYES)
	{
		m_pParent->DoneChoose();	

	}
}

void CBioMechPropertySheet::OnHelpIndex() 
{
	OnHelpFinder();	
}

void CBioMechPropertySheet::OnHelpAbout() 
{
	CAboutDlg about;
	about.DoModal ();
}

void CBioMechPropertySheet::OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu) 
{
	CPropertySheet::OnInitMenuPopup(pPopupMenu, nIndex, bSysMenu);

//	if(		( m_BioMechTestPage.ValidateTestPage() == true ) 
//		&&	( m_BioDumPage.ValidateDumPage() == true )
//		&&	( m_BioOccPage.ValidateOccPage() == true )
//		&&	( m_BioRibPage.ValidateRibPage() == true )
//		&&	( m_BioRestPage.ValidateRestPage() == true )
//		&&	( m_BioAnthPage.ValidateAnthPage() == true )
//		&&	( m_BioInjPage.ValidateInjPage() == true )
//		&&	( m_BioInstPage.ValidateInstPage() == true )
//		&&	( m_BioCBandPage.ValidateBandPage() == true )
//		&&	( m_BioGaugePage.ValidateGaugePage() == true ) )

	if(		( m_BioMechTestPage.ValidateTestPage() == true ) 
		&&	( m_BioInstPage.ValidateInstPage() == true ) )
	{
		pPopupMenu->EnableMenuItem( ID_EXPORT_TEST, MF_ENABLED );		
	}
	else
	{
		pPopupMenu->EnableMenuItem( ID_EXPORT_TEST, MF_GRAYED );
	}
	
	// for intrusion point
	pPopupMenu->EnableMenuItem( ID_FILE_LOAD_INTRUSION, MF_GRAYED );
	pPopupMenu->EnableMenuItem( ID_FILE_SAVE_INTRUSION, MF_GRAYED );
	pPopupMenu->EnableMenuItem( ID_FILE_SAVE_INTRUSION_REPORT, MF_GRAYED );
}

////////////// for high-speed video files only
void CBioMechPropertySheet::OnImportHsvdData()
{
	CFileDialog import(TRUE);
	import.m_ofn.lpstrTitle ="Open High-Speed Video File";
	import.m_ofn.lpstrFilter = "EV5 HSVD (*.hs5)\0*.hs5\0";
//	 "EV5 Tests (*.ev5)\0*.ev5\0EV4 Tests (*.ev4)\0*.ev4\0EV3 Test Data (*.gr1)\0*.gr1\0EV3 Vehicle Data (*.gr2)\0*.gr2\0EV3 Barrier Data (*.gr3)\0*.gr3\0EV3 Occupant Data (*.gr4)\0*.gr4\0EV3 Instrumentation Data (*.gr5)\0*.gr5\0";
	 
	if (import.DoModal ()==IDCANCEL) { return; }
	CString strfile_in = import.GetPathName () ;
	ImportHsvdData(strfile_in);
}	// OnImportHsvdData

void CBioMechPropertySheet::OnExportHsvdData()
{
	ExportHsvdData();
}	// OnExportHsvdData

void CBioMechPropertySheet::ImportHsvdData(CString& strfile_in, bool bErrMsgResponse) // = true
{
	if( !m_BioData.ImportHsvd(strfile_in, bErrMsgResponse) ) { return; }
	m_HsvdPage.m_nCurCamNo = m_HsvdPage.m_nTotalCamNo = m_BioData.m_camno.GetSize() - 1;	// the 0th item is empty.
	m_BioMechTestPage.OnSetActive ();  //m_hWnd always exists
	if (m_HsvdPage.m_hWnd) m_HsvdPage.OnSetActive();

}	// ImportHsvdData

void CBioMechPropertySheet::ExportHsvdData()
{
	if( m_BioData.m_camno.GetSize()<2 ) { return; }
//	m_HsvdPage.LoadHsvdData();
	
	if ( !m_HsvdPage.ValidateThisPage() ) 
	{ 
		AfxMessageBox("Illegal data found. No file output.");
		return; 
	}

	//File Export Dialog Common Control
	CFileDialog export(FALSE);
	export.m_ofn.lpstrTitle ="Export File";
	export.m_ofn.lpstrFilter = "EV5 HSVD (*.hs5)\0*.hs5\0";

	if( export.DoModal() == IDCANCEL ) { return; }
	
	//export here
	CString strfile_out = export.GetPathName();
	if( export.GetFileExt() != "hs5" )
	{
		strfile_out += ".hs5";
	}

	m_BioData.ExportHsvd( strfile_out );

}	// ExportHsvdData

void CBioMechPropertySheet::OnExportHsvdReport()
{
	ExportHsvdReport();
}	// OnExportHsvdReport


void CBioMechPropertySheet::ExportHsvdReport()
{
	if( m_BioData.m_camno.GetSize()==0 ) { return; }
		
	if ( !m_HsvdPage.ValidateThisPage() ) 
	{ 
		AfxMessageBox("Illegal data found. No file output.");
		return; 
	}

	//File Export Dialog Common Control
	CFileDialog export(FALSE);
	export.m_ofn.lpstrTitle ="Report File";
	export.m_ofn.lpstrFilter = "EV5 HSVD (*.hsr)\0*.hsr\0";

	if( export.DoModal() == IDCANCEL ) { return; }
	
	//export here
	CString strfile_out = export.GetPathName();
	if( export.GetFileExt() != "hsr" )
	{
		strfile_out += ".hsr";
	}

	m_BioData.ExportHsvdReport( strfile_out );

}	// ExportHsvdReport