#if !defined(AFX_BIOMECHPROPERTYSHEET_H__96CE047F_5893_11D2_9493_0008C7AA9033__INCLUDED_)
#define AFX_BIOMECHPROPERTYSHEET_H__96CE047F_5893_11D2_9493_0008C7AA9033__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ChooseDB.h"
#include "BioMechTestPage.h"
#include "BioRestPage.h"
#include "BioAnthPage.h"
#include "BioInjPage.h"
#include "BioCBandPage.h"
#include "BioDumPage.h"
#include "BioOccPage.h"
#include "BioInstPage.h"
#include "BioGaugePage.h"
#include "BioRibPage.h"
#include "HsvdPage.h"
// BioMechPropertySheet.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CBioMechPropertySheet

class CBioMechPropertySheet : public CPropertySheet
{
	DECLARE_DYNAMIC(CBioMechPropertySheet)

// Construction
public:
	CBioMechPropertySheet(UINT nIDCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);
	CBioMechPropertySheet(LPCTSTR pszCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);

// Attributes
public:
	CBioMechTestPage m_BioMechTestPage;
	CBioRestPage     m_BioRestPage;
	CBioAnthPage     m_BioAnthPage;
	CBioInjPage      m_BioInjPage;
	CBioCBandPage    m_BioCBandPage;
	CBioDumPage      m_BioDumPage;
	CBioOccPage      m_BioOccPage;
	CBioInstPage     m_BioInstPage;
	CBioGaugePage    m_BioGaugePage;
	CBioRibPage      m_BioRibPage;
	CHsvdPage		 m_HsvdPage;

	CBioData         m_BioData;
	CChooseDB*		 m_pParent;

// Operations
public:

	CString GetPrinterDeviceName();
	CString GetPrintFileName();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBioMechPropertySheet)
	public:
	virtual BOOL OnInitDialog();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBioMechPropertySheet();

	// Generated message map functions
protected:
	//{{AFX_MSG(CBioMechPropertySheet)
	afx_msg void OnComponentdb();
	afx_msg void OnSwgdb();
	afx_msg void OnVehicledb();
	afx_msg void OnClearall();
	afx_msg void OnExportTest();
	afx_msg void OnImportTest();
	afx_msg void OnImportHsvdData();
	afx_msg void OnExportHsvdData();
	afx_msg void OnExportHsvdReport();
	afx_msg void OnFilePrint();
	afx_msg void OnExit();
	afx_msg void OnExportReport();
	afx_msg void OnClose();
	afx_msg void OnHelpIndex();
	afx_msg void OnHelpAbout();
	afx_msg void OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	bool	_bClearAll;
	void	ImportHsvdData(CString& strfile_in, bool bErrMsgResponse=true);
	void	ExportHsvdData();
	void	ExportHsvdReport();
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BIOMECHPROPERTYSHEET_H__96CE047F_5893_11D2_9493_0008C7AA9033__INCLUDED_)
