// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: BioMechTestPage.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description:  Member functions of CBioMechTestPage.
//               They relate to the loading and display of 
//               data on this page.
//
//  Date		Who			Description
//	2000    Y. Wong Adding business rules, recode all edit boxs
//					and correct other errors.
// -----------------------------------------


#include <math.h>

#include "stdafx.h"
#include "entreeV5.h"
#include "BioMechTestPage.h"
#include "search.h"
#include "CodeValidation.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CString search_code;

/////////////////////////////////////////////////////////////////////////////
// CBioMechTestPage property page

IMPLEMENT_DYNCREATE(CBioMechTestPage, CPropertyPage)

CBioMechTestPage::CBioMechTestPage() : CPropertyPage(CBioMechTestPage::IDD)
{
	//{{AFX_DATA_INIT(CBioMechTestPage)
	m_editconno		= _T("");
	m_editlink		= _T("");
	m_editrectyp	= _T("");
	m_edittitle		= _T("");
	m_edittstcfn	= _T("");
	m_edittstcom	= _T("");
	m_edittstobj	= _T("");
	m_edittstprf	= _T("");
	m_edittstref	= _T("");
	m_editverno		= _T("B5");

	m_edittemp		= _T("");
	m_editimpang	= _T("");
	m_editclsspd	= _T("");
	m_edittotcrv	= _T("0");
	m_editocctyp	= _T("");
	//}}AFX_DATA_INIT
}

CBioMechTestPage::~CBioMechTestPage()
{
}

void CBioMechTestPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBioMechTestPage)
	DDX_Control(pDX, IDC_BIOTESTDAT, m_edittestdate);
	DDX_Control(pDX, IDC_BIOTESTTSTDAT, m_tstdatctrl);
	DDX_Control(pDX, IDC_BIOTESTCONNO, m_editconno);
	DDX_Control(pDX, IDC_BIOTESTLINK, m_editlink);
	DDX_Control(pDX, IDC_BIOTESTRECTYP, m_editrectyp);
	DDX_Control(pDX, IDC_BIOTESTTITLE, m_edittitle);
	DDX_Control(pDX, IDC_BIOTESTTSTCFN, m_edittstcfn);
	DDX_Control(pDX, IDC_BIOTESTTSTCOM, m_edittstcom);
	DDX_Control(pDX, IDC_BIOTESTTSTOBJ, m_edittstobj);
	DDX_Control(pDX, IDC_BIOTESTTSTPRF, m_edittstprf);
	DDX_Control(pDX, IDC_BIOTESTTSTREF, m_edittstref);
	DDX_Control(pDX, IDC_BIOTESTVERNO, m_editverno);
	DDX_Control(pDX, IDC_BIOTESTTEMP, m_edittemp);
	DDX_Control(pDX, IDC_BIOTESTIMPANG, m_editimpang);
	DDX_Control(pDX, IDC_BIOTESTCLSSPD, m_editclsspd);
	DDX_Control(pDX, IDC_BIOTESTOTCRV, m_edittotcrv);
	DDX_Control(pDX, IDC_BIOTESTOCCTYP, m_editocctyp);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBioMechTestPage, CPropertyPage)
	//{{AFX_MSG_MAP(CBioMechTestPage)
	ON_BN_CLICKED(IDC_TSTPRF_SEARCH, OnTstprfSearch)
	ON_BN_CLICKED(IDC_TSTCFN_SEARCH, OnTstcfnSearch)
	ON_BN_CLICKED(IDC_RECTYP_SEARCH, OnRectypSearch)
	ON_BN_CLICKED(IDC_LINK_SEARCH, OnLinkSearch)
	ON_BN_CLICKED(IDC_OCCTYP_SEARCH, OnOcctypSearch)
	ON_WM_HELPINFO()
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTW, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTA, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY(DTN_DATETIMECHANGE, IDC_BIOTESTTSTDAT, OnDatetimechangeBiotesttstdat)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBioMechTestPage message handlers

BOOL CBioMechTestPage::OnKillActive() 
{
	if( ValidateTestPage() == true )
	{
		LoadBioTestData();

		return CPropertyPage::OnKillActive();
	}
	else
	{
		// Error are found on AnthPage.
		return FALSE;
	}
}

BOOL CBioMechTestPage::OnSetActive() 
{
//	EnableControls();
		
//	m_totalcurves=max(m_pBioData->m_injno , 0) ; //initialize total curves.

	SetBusinessRules();

	DisplayBioTestData();

	ValidateTestPage();
	
	return CPropertyPage::OnSetActive();
}

BOOL CBioMechTestPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	CancelToClose();
	EnableToolTips();	
	
	m_tstdatctrl.SetFormat("dd'/'MMM'/'yyy");
	
//	SetBusinessRules();	//**
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CBioMechTestPage::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
	TOOLTIPTEXTA* pTTTA = (TOOLTIPTEXTA*)pNMHDR;
	TOOLTIPTEXTW* pTTTW = (TOOLTIPTEXTW*)pNMHDR;
	CString strTipText = "";
	UINT nID = pNMHDR->idFrom;
	if (pNMHDR->code == TTN_NEEDTEXTA && (pTTTA->uFlags & TTF_IDISHWND) ||
		pNMHDR->code == TTN_NEEDTEXTW && (pTTTW->uFlags & TTF_IDISHWND))
	{
		// idFrom is actually the HWND of the tool
		nID = ::GetDlgCtrlID((HWND)nID);
	}

	if (nID != 0) // will be zero on a separator
	{
		strTipText.Format("Control ID = %d", nID);
		switch (nID)
			{
			case IDC_BIOTESTCLSSPD:
				strTipText = "Kilometers/Hour (-200.00->200.00)";
				break;
			case IDC_BIOTESTIMPANG:
				strTipText = "Degrees (Integer)0->359";
				break;
			case IDC_BIOTESTTEMP:
				strTipText = "Degrees Celsius (-99->99)";
				break;
			case IDC_BIOTESTDAT:
				strTipText = "Date (dd/MMM/yyyy)";
				break;
			default:
				strTipText = "";
			}
	}

	if (pNMHDR->code == TTN_NEEDTEXTA)
		lstrcpyn(pTTTA->szText, strTipText, sizeof(pTTTA->szText));
	else
		::MultiByteToWideChar( CP_ACP , 0, strTipText, -1, pTTTW->szText, sizeof(pTTTW->szText) );
	*pResult = 0;

	return TRUE;    // message was handled
}

void CBioMechTestPage::OnOcctypSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"OCCTYP","BIODB");
	if (search.DoModal ()==IDOK)
	{
		m_editocctyp = search_code;
		m_editocctyp.SetValidateColor();
	}
	UpdateData(FALSE);	
}

void CBioMechTestPage::OnTstprfSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);

	CSearch search(NULL,"TSTPRF","BIODB");
	if (search.DoModal ()==IDOK)
	{
		m_edittstprf = search_code;	
		m_edittstprf.SetValidateColor();
	}
	UpdateData(FALSE);
}

void CBioMechTestPage::OnTstcfnSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"TSTCFN","BIODB");
	if (search.DoModal ()==IDOK)
	{
		m_edittstcfn = search_code;
		m_edittstcfn.SetValidateColor();
	}
	UpdateData(FALSE);	
}

void CBioMechTestPage::OnRectypSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"RECTYP","BIODB");
	if (search.DoModal ()==IDOK)
	{
		m_editrectyp = search_code;
		m_editrectyp.SetValidateColor();
	}
	UpdateData(FALSE);
}

void CBioMechTestPage::OnLinkSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"LINK","BIODB");
	if (search.DoModal ()==IDOK)
	{
		m_editlink = search_code;
		m_editlink.SetValidateColor();
	}
	UpdateData(FALSE);	
}

// This function gets data from the entry screen and puts it into m_pBioData
// It is called from OnKillActive, ExportData, and record changed.
BOOL CBioMechTestPage::LoadBioTestData()
{	
	m_pBioData->m_occtyp = m_editocctyp.GetTextAsString();
	m_pBioData->m_clsspd = m_editclsspd.GetTextAsString();
	m_pBioData->m_conno = m_editconno.GetTextAsString();
	m_pBioData->m_impang = m_editimpang.GetTextAsString();
	m_pBioData->m_link = m_editlink.GetTextAsString();
	m_pBioData->m_rectyp = m_editrectyp.GetTextAsString();
	m_pBioData->m_temp = m_edittemp.GetTextAsString();
	m_pBioData->m_title = m_edittitle.GetTextAsString();
	m_pBioData->m_tstcfn = m_edittstcfn.GetTextAsString();
	m_pBioData->m_tstcom = m_edittstcom.GetTextAsString();
	m_pBioData->m_tstobj = m_edittstobj.GetTextAsString();
	m_pBioData->m_tstprf = m_edittstprf.GetTextAsString();
	m_pBioData->m_tstref = m_edittstref.GetTextAsString();
	m_pBioData->m_verno = m_editverno.GetTextAsString();

	CString testdate;
    GetDlgItemText(IDC_BIOTESTDAT, testdate);
	m_pBioData->m_tstdat = testdate;
	m_edittestdate = testdate;

	m_pBioData->m_totcrv= atoi(m_edittotcrv.GetTextAsString());

	return TRUE;

}

// Get Data out of m_pBioData, and put it into members of BioTestPage,
// and then UpdateData(FALSE).
void CBioMechTestPage::DisplayBioTestData()
{
	UpdateData();
	m_editocctyp = m_pBioData->m_occtyp;
	m_editclsspd = m_pBioData->m_clsspd ;
	m_editconno = m_pBioData->m_conno ;
	m_editimpang = m_pBioData->m_impang ;
	m_editlink = m_pBioData->m_link ;
	m_editrectyp = m_pBioData->m_rectyp ;
	m_edittemp = m_pBioData->m_temp ;
	m_edittitle = m_pBioData->m_title ;
	m_edittstcfn = m_pBioData->m_tstcfn ;
	m_edittstcom = m_pBioData->m_tstcom ;
	m_edittstobj = m_pBioData->m_tstobj ;
	m_edittstprf = m_pBioData->m_tstprf ;
	m_edittstref = m_pBioData->m_tstref ;
	m_editverno = m_pBioData->m_verno ;

	m_tstdatctrl.SetTime(&(StringToTime(m_pBioData->m_tstdat)));
	m_pBioData->m_tstdat.MakeUpper();
	m_edittestdate = m_pBioData->m_tstdat;

	char szTemp[16]; itoa(m_pBioData->m_totcrv, szTemp, 10);
	m_edittotcrv = szTemp;

	CCodeValidation( m_edittstprf, "TSTPRF","BIODB" );
	CCodeValidation( m_edittstcfn, "TSTCFN","BIODB");
	CCodeValidation( m_editrectyp, "RECTYP","BIODB");
	CCodeValidation( m_editlink, "LINK","BIODB");
	CCodeValidation( m_editocctyp, "OCCTYP","BIODB");

	UpdateData(FALSE);

}

BOOL CBioMechTestPage::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	WinHelp(General_Information_Tab);
	
	return TRUE;
}

//
bool CBioMechTestPage::ValidateTestPage( void )
{
	const int nTotal = 15;
	bool bRetArray[nTotal];

	bRetArray[0] = m_editconno.GetValidate();
	bRetArray[1] = m_edittitle.GetValidate();
	bRetArray[2] = m_edittstcom.GetValidate();
	bRetArray[3] = m_edittstobj.GetValidate();
	bRetArray[4] = m_editverno.GetValidate();
	bRetArray[5] = m_edittemp.GetValidate();
	bRetArray[6] = m_editimpang.GetValidate();
	bRetArray[7] = m_editclsspd.GetValidate();
	bRetArray[8] = m_edittstref.GetValidate();
//	bRetArray[8] = m_edittotcrv.GetValidate();	// read only
	bRetArray[9] = m_edittestdate.GetValidate();
	
	bRetArray[10] = m_edittstprf.GetValidate();
	bRetArray[11] = m_edittstcfn.GetValidate();
	bRetArray[12] = m_editrectyp.GetValidate();
	bRetArray[13] = m_editlink.GetValidate();
	bRetArray[14] = m_editocctyp.GetValidate();

	for(int i=0; i<nTotal; i++) { if (!bRetArray[i]) return false; }
	return true;
}	// ValidateAnthPage

void CBioMechTestPage::SetBusinessRules( void )
{
	m_editconno.SetString(0, 17);
	m_edittitle.SetString( 0, 70 );
	m_edittstcom.SetString( 0, 70 );
	m_edittstobj.SetString( 0, 70 );
	m_editverno.SetString( 0, 2 );
	m_edittemp.SetDouble( -99, 99 );
	m_editimpang.SetDouble( 0, 359 ); 
	m_editclsspd.SetDouble( -200.f, 200.f); 
	m_edittstref.SetString(0,10);
//	m_edittotcrv.SetDouble( 0, 999 );	// read only
	m_edittestdate.SetDate();
}	// SetBusinessRules

void CBioMechTestPage::OnDatetimechangeBiotesttstdat(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CString sDate;
    GetDlgItemText(IDC_BIOTESTTSTDAT, sDate);

	sDate.MakeUpper();
	m_edittestdate =  m_pBioData->m_tstdat = sDate;
	
	*pResult = 0;
}
