// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: BioOccPage.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description:  Member functions of CBioOccPage.
//               They relate to the loading and display of 
//               data on this page.
//
//  Date		Who			Description
//	2000    Y. Wong Adding business rules, recode all edit boxs
//					and correct other errors.
// -----------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "BioOccPage.h"
#include "search.h"
#include "CodeValidation.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CString search_code;

/////////////////////////////////////////////////////////////////////////////
// CBioOccPage property page

IMPLEMENT_DYNCREATE(CBioOccPage, CPropertyPage)

CBioOccPage::CBioOccPage() : CPropertyPage(CBioOccPage::IDD)
{
	//{{AFX_DATA_INIT(CBioOccPage)
	m_editbmccom = _T("");
	m_editbmcloc = _T("");
	m_editbmcmethod = _T("");
	m_editbmcunits = _T("");
	m_editcadan = _T("");
	m_editcadapp = _T("");
	m_editcsedth = _T("");
	m_editocccom = _T("");
	m_editoccloc = _T("");
	m_editoccref = _T("");
	m_editoccsex = _T("");
	m_editseposn = _T("");
	m_editoccage = _T("");
	m_editoccwt = _T("");
	m_editfrctrb = _T("");
	m_editrbfrct = _T("");
	m_editnotest = _T("");
	m_editbedcon = _T("");
	m_editbmc = _T("");
	m_editbcompwt = _T("");
	m_editaorpre = _T("");
	m_editcerpre = _T("");
	m_editpulpre = _T("");
	//}}AFX_DATA_INIT
}

CBioOccPage::~CBioOccPage()
{
}

void CBioOccPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBioOccPage)
	DDX_Control(pDX, IDC_BIOOCCPULPRE_SEARCH, m_pulpresearch);
	DDX_Control(pDX, IDC_BIOOCCCERPRE_SEARCH, m_cerpresearch);
	DDX_Control(pDX, IDC_BIOOCCAORPRE_SEARCH, m_aorpresearch);
	DDX_Control(pDX, IDC_SEPOSN_SEARCH, m_seposnsearch);
	DDX_Control(pDX, IDC_OCCSEX_SEARCH, m_occsexsearch);
	DDX_Control(pDX, IDC_OCCLOC_SEARCH, m_occlocsearch);
	DDX_Control(pDX, IDC_BIOOCCDTEDTH, m_dtedthctrl);
	DDX_Control(pDX, IDC_BIOOCCDAT, m_editoccdate);
	DDX_Control(pDX, IDC_BIOOCCBMCCOM, m_editbmccom);
	DDX_Control(pDX, IDC_BIOOCCBMCLOC, m_editbmcloc);
	DDX_Control(pDX, IDC_BIOOCCBMCMETHOD, m_editbmcmethod);
	DDX_Control(pDX, IDC_BIOOCCBMCUNITS, m_editbmcunits);
	DDX_Control(pDX, IDC_BIOOCCCADAN, m_editcadan);
	DDX_Control(pDX, IDC_BIOOCCCADAPP, m_editcadapp);
	DDX_Control(pDX, IDC_BIOOCCCSEDTH, m_editcsedth);
	DDX_Control(pDX, IDC_BIOOCCOCCCOM, m_editocccom);
	DDX_Control(pDX, IDC_BIOOCCOCCLOC, m_editoccloc);
	DDX_Control(pDX, IDC_BIOOCCOCCREF, m_editoccref);
	DDX_Control(pDX, IDC_BIOOCCOCCSEX, m_editoccsex);
	DDX_Control(pDX, IDC_BIOOCCSEPOSN, m_editseposn);
	DDX_Control(pDX, IDC_BIOOCCOCCAGE, m_editoccage);
	DDX_Control(pDX, IDC_BIOOCCOCCWT, m_editoccwt);
	DDX_Control(pDX, IDC_BIOOCCFRCTRB, m_editfrctrb);
	DDX_Control(pDX, IDC_BIOOCCRBFRCT, m_editrbfrct);
	DDX_Control(pDX, IDC_BIOOCCNOTEST, m_editnotest);
	DDX_Control(pDX, IDC_BIOOCCBEDCON, m_editbedcon);
	DDX_Control(pDX, IDC_BIOOCCBMC, m_editbmc);
	DDX_Control(pDX, IDC_BIOOCCBCOMPWT, m_editbcompwt);
	DDX_Control(pDX, IDC_BIOOCCAORPRE, m_editaorpre);
	DDX_Control(pDX, IDC_BIOOCCCERPRE, m_editcerpre);
	DDX_Control(pDX, IDC_BIOOCCPULPRE, m_editpulpre);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBioOccPage, CPropertyPage)
	//{{AFX_MSG_MAP(CBioOccPage)
	ON_BN_CLICKED(IDC_OCCLOC_SEARCH, OnOcclocSearch)
	ON_BN_CLICKED(IDC_OCCSEX_SEARCH, OnOccsexSearch)
	ON_BN_CLICKED(IDC_SEPOSN_SEARCH, OnSeposnSearch)
	ON_WM_HELPINFO()
	ON_BN_CLICKED(IDC_BMCUNITS_SEARCH, OnBmcunitsSearch)
	ON_BN_CLICKED(IDC_BMCLOC_SEARCH, OnBmclocSearch)
	ON_BN_CLICKED(IDC_BMCMETHOD_SEARCH, OnBmcmethodSearch)
	ON_NOTIFY(DTN_DATETIMECHANGE, IDC_BIOOCCDTEDTH, OnDatetimechangeBiooccdtedth)
	ON_BN_CLICKED(IDC_BIOOCCPULPRE_SEARCH, OnPulpreSearch)
	ON_BN_CLICKED(IDC_BIOOCCCERPRE_SEARCH, OnCerpreSearch)
	ON_BN_CLICKED(IDC_BIOOCCAORPRE_SEARCH, OnAorpreSearch)
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTW, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTA, 0, 0xFFFF, OnToolTipNotify )
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBioOccPage message handlers

BOOL CBioOccPage::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
	TOOLTIPTEXTA* pTTTA = (TOOLTIPTEXTA*)pNMHDR;
	TOOLTIPTEXTW* pTTTW = (TOOLTIPTEXTW*)pNMHDR;
	CString strTipText = "";
	UINT nID = pNMHDR->idFrom;
	if (pNMHDR->code == TTN_NEEDTEXTA && (pTTTA->uFlags & TTF_IDISHWND) ||
		pNMHDR->code == TTN_NEEDTEXTW && (pTTTW->uFlags & TTF_IDISHWND))
	{
		// idFrom is actually the HWND of the tool
		nID = ::GetDlgCtrlID((HWND)nID);
	}

	if (nID != 0) // will be zero on a separator
	{
		strTipText.Format("Control ID = %d", nID);
		switch (nID)
			{
			case IDC_BIOOCCOCCWT:
				strTipText = "kg (Integer, 0->999)";
				break;
			case IDC_BIOOCCOCCAGE:
				strTipText = "0->99";
				break;
			case IDC_BIOOCCFRCTRB:
				strTipText = "0->99";
				break;
			case IDC_BIOOCCRBFRCT:
				strTipText = "0->99";
				break;
			case IDC_BIOOCCNOTEST:
				strTipText = "0->99";
				break;
			case IDC_BIOOCCBEDCON:
				strTipText = "days (Integer, 0->999)";
				break;
			case IDC_BIOOCCAORPRE:
				strTipText = "YES/NO";
				break;
			case IDC_BIOOCCCERPRE:
				strTipText = "YES/NO";
				break;
			case IDC_BIOOCCPULPRE:
				strTipText = "YES/NO";
				break;
			case IDC_BIOOCCBMC:
				strTipText = "Unbounded Number";
				break;
			case IDC_BIOOCCDAT:
				strTipText = "Date (dd/MMM/yyyy)";
				break;
			default:
				strTipText = "";
			}
	}

	if (pNMHDR->code == TTN_NEEDTEXTA)
		lstrcpyn(pTTTA->szText, strTipText, sizeof(pTTTA->szText));
	else
		::MultiByteToWideChar( CP_ACP , 0, strTipText, -1, pTTTW->szText, sizeof(pTTTW->szText) );
	*pResult = 0;

	return TRUE;    // message was handled
}

BOOL CBioOccPage::OnKillActive() 
{
	if( ValidateOccPage() == true )
	{
		LoadBioOccData();
		
		return CPropertyPage::OnKillActive();
	}
	else
	{
		// Error are found on AnthPage.
		return FALSE;
	}
}

BOOL CBioOccPage::OnSetActive() 
{
	EnableControls();
		
//	m_totalcurves=max(m_pBioData->m_injno , 0) ; //initialize total curves.

	SetBusinessRules();

	DisplayBioOccData();

	ValidateOccPage();
	
	return CPropertyPage::OnSetActive();
}

BOOL CBioOccPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	EnableToolTips();
	m_dtedthctrl.SetFormat("dd'/'MMM'/'yyy");
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

// This function gets data from the entry screen and puts it into m_pBioData
// It is called from OnKillActive, ExportData, and record changed.
BOOL CBioOccPage::LoadBioOccData()
{
	// put data into m_pBioData
	if (m_hWnd==NULL) return TRUE;  // only return FALSE if data invalid
	if (!UpdateData(TRUE)) return FALSE;

	m_pBioData->m_aorpre = m_editaorpre.GetTextAsString();
	m_pBioData->m_bcompwt = m_editbcompwt.GetTextAsString();
	m_pBioData->m_bedcon = m_editbedcon.GetTextAsString();
	m_pBioData->m_bmc = m_editbmc.GetTextAsString();
	m_pBioData->m_bmccom = m_editbmccom.GetTextAsString();

	m_pBioData->m_bmcloc = m_editbmcloc.GetTextAsString();
	m_pBioData->m_bmcmethod = m_editbmcmethod.GetTextAsString();
	m_pBioData->m_bmcunits = m_editbmcunits.GetTextAsString();
	m_pBioData->m_cadan = m_editcadan.GetTextAsString();
	m_pBioData->m_cadapp = m_editcadapp.GetTextAsString();

	m_pBioData->m_cerpre = m_editcerpre.GetTextAsString();
	m_pBioData->m_csedth = m_editcsedth.GetTextAsString();
	m_pBioData->m_frctrb = m_editfrctrb.GetTextAsString();
	m_pBioData->m_notest = m_editnotest.GetTextAsString();
	m_pBioData->m_occage = m_editoccage.GetTextAsString();

	m_pBioData->m_boccom = m_editocccom.GetTextAsString();
	m_pBioData->m_boccloc = m_editoccloc.GetTextAsString();
	m_pBioData->m_occref = m_editoccref.GetTextAsString();
	m_pBioData->m_boccsex = m_editoccsex.GetTextAsString();
	m_pBioData->m_occwt = m_editoccwt.GetTextAsString();

	m_pBioData->m_pulpre = m_editpulpre.GetTextAsString();
	m_pBioData->m_rbfrct = m_editrbfrct.GetTextAsString();
	m_pBioData->m_bseposn = m_editseposn.GetTextAsString();

	CString ddate;
	GetDlgItemText(IDC_BIOOCCDAT, ddate);
	m_pBioData->m_dtedth = ddate;
	m_editoccdate = ddate;

	return TRUE;

}

//Get Data from m_pBioData and Display it.
void CBioOccPage::DisplayBioOccData()
{	
	m_editbcompwt = m_pBioData->m_bcompwt;
	m_editbedcon = m_pBioData->m_bedcon;
	m_editbmc = m_pBioData->m_bmc;
	m_editbmccom = m_pBioData->m_bmccom;
	m_editbmcloc = m_pBioData->m_bmcloc;

    m_editbmcmethod = m_pBioData->m_bmcmethod;
	m_editbmcunits = m_pBioData->m_bmcunits;
	m_editcadan = m_pBioData->m_cadan;
	m_editcadapp = m_pBioData->m_cadapp;
	m_editcsedth = m_pBioData->m_csedth;

	m_editfrctrb = m_pBioData->m_frctrb;
	m_editnotest = m_pBioData->m_notest;
	m_editoccage = m_pBioData->m_occage;	
	m_editocccom = m_pBioData->m_boccom;
	m_editoccloc = m_pBioData->m_boccloc;

	m_editoccref = m_pBioData->m_occref;
	m_editoccsex = m_pBioData->m_boccsex;
	m_editoccwt = m_pBioData->m_occwt;
	m_editrbfrct = m_pBioData->m_rbfrct;
	m_editseposn = m_pBioData->m_bseposn;
	
	m_editpulpre = m_pBioData->m_pulpre;
	m_editcerpre = m_pBioData->m_cerpre;
	m_editaorpre = m_pBioData->m_aorpre;

	m_dtedthctrl.SetTime(&(StringToTime(m_pBioData->m_dtedth)));
	m_pBioData->m_dtedth.MakeUpper();
	m_editoccdate = m_pBioData->m_dtedth;

	CCodeValidation( m_editoccloc, "BOCCLOC","BIODB" );
	CCodeValidation( m_editoccsex, "BOCCSEX","BIODB" );
	CCodeValidation( m_editseposn, "BSEPOSN","BIODB" );
	CCodeValidation( m_editbmcunits, "BMCUNITS","BIODB" );
	CCodeValidation( m_editbmcloc, "BMCLOC","BIODB" );

	CCodeValidation( m_editbmcmethod, "BMCMETHOD","BIODB" );
	CCodeValidation( m_editpulpre, "PULPRE","BIODB" );
	CCodeValidation( m_editcerpre, "CERPRE","BIODB" );
	CCodeValidation( m_editaorpre, "AORPRE","BIODB" );

	UpdateData(FALSE);
}

void CBioOccPage::OnOcclocSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"BOCCLOC","BIODB");
	if (search.DoModal ()==IDOK)
	{
		m_editoccloc = search_code;
		m_editoccloc.SetValidateColor();
	}
	UpdateData(FALSE);	
}

void CBioOccPage::OnOccsexSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"BOCCSEX","BIODB");
	if (search.DoModal ()==IDOK)
	{
		m_editoccsex = search_code;
		m_editoccsex.SetValidateColor();
	}
	UpdateData(FALSE);
}

void CBioOccPage::OnSeposnSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"BSEPOSN","BIODB");
	if (search.DoModal ()==IDOK)
	{
		m_editseposn = search_code;
		m_editseposn.SetValidateColor();
	}
	UpdateData(FALSE);
}

// CBioDumPage::EnableControls()
// If Dummy occupant, this page's controls are activated.  Otherwise,
// they are disabled.
void CBioOccPage::EnableControls()
{
	HWND temphwnd;
	if ( (m_pBioData->m_occtyp == "") || ( (m_pBioData->m_occtyp != "AN") && 
	   (m_pBioData->m_occtyp != "CD") && (m_pBioData->m_occtyp != "HU") ) ) 
	{
		m_seposnsearch.EnableWindow(FALSE);
		m_occsexsearch.EnableWindow(FALSE);
		m_occlocsearch.EnableWindow(FALSE);
	    m_dtedthctrl.EnableWindow(FALSE);

		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCAORPRE);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCBCOMPWT);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCBEDCON);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCBMC);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCBMCCOM);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCBMCLOC);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCBMCMETHOD);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCBMCUNITS);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCCADAN);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCCADAPP);
		::EnableWindow (temphwnd, FALSE);	
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCCERPRE);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCCSEDTH);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCFRCTRB);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCNOTEST);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCDAT);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCOCCAGE);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCOCCCOM);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCOCCLOC);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCOCCREF);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCOCCSEX);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCOCCWT);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCPULPRE);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCRBFRCT);
		::EnableWindow (temphwnd, FALSE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCSEPOSN);
		::EnableWindow (temphwnd, FALSE);
		
	}
	else   // enable.
	{
		m_seposnsearch.EnableWindow(TRUE);
		m_occsexsearch.EnableWindow(TRUE);
		m_occlocsearch.EnableWindow(TRUE);
	    m_dtedthctrl.EnableWindow(TRUE);

		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCAORPRE);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCBCOMPWT);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCBEDCON);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCBMC);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCBMCCOM);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCBMCLOC);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCBMCMETHOD);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCBMCUNITS);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCCADAN);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCCADAPP);
		::EnableWindow (temphwnd, TRUE);	
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCCERPRE);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCCSEDTH);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCFRCTRB);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCNOTEST);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCDAT);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCOCCAGE);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCOCCCOM);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCOCCLOC);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCOCCREF);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCOCCSEX);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCOCCWT);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCPULPRE);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCRBFRCT);
		::EnableWindow (temphwnd, TRUE);
		temphwnd = ::GetDlgItem(m_hWnd, IDC_BIOOCCSEPOSN);
		::EnableWindow (temphwnd, TRUE);
	}
}

BOOL CBioOccPage::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	WinHelp(Biological_Occupant);
	
	return TRUE;
}

void CBioOccPage::OnBmcunitsSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"BMCUNITS","BIODB");
	if (search.DoModal ()==IDOK)
	{
		m_editbmcunits = search_code;
		m_editbmcunits.SetValidateColor();
	}
	UpdateData(FALSE);
}

void CBioOccPage::OnBmclocSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"BMCLOC","BIODB");
	if (search.DoModal ()==IDOK)
	{
		m_editbmcloc = search_code;
		m_editbmcloc.SetValidateColor();
	}
	UpdateData(FALSE);	
}

void CBioOccPage::OnBmcmethodSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"BMCMETHOD","BIODB");
	if (search.DoModal ()==IDOK)
	{
		m_editbmcmethod = search_code;
		m_editbmcmethod.SetValidateColor();
	}
	UpdateData(FALSE);
}

//
bool CBioOccPage::ValidateOccPage( void )
{
	const int nTotal = 26;
	bool bRetArray[nTotal];

	bRetArray[0] = m_editbmccom.GetValidate();
	bRetArray[1] = m_editbmcloc.GetValidate();
	bRetArray[2] = m_editbmcmethod.GetValidate();
	bRetArray[3] = m_editbmcunits.GetValidate();
	bRetArray[4] = m_editcadan.GetValidate();
	bRetArray[5] = m_editcadapp.GetValidate();
	bRetArray[6] = m_editcsedth.GetValidate();
	bRetArray[7] = m_editocccom.GetValidate();
	bRetArray[8] = m_editoccref.GetValidate();
	bRetArray[9] = m_editoccage.GetValidate();
	bRetArray[10] = m_editoccwt.GetValidate();
	bRetArray[11] = m_editfrctrb.GetValidate();
	bRetArray[12] = m_editrbfrct.GetValidate();
	bRetArray[13] = m_editnotest.GetValidate();
	bRetArray[14] = m_editbedcon.GetValidate();
	bRetArray[15] = m_editbmc.GetValidate();
	bRetArray[16] = m_editoccdate.GetValidate();
	
	bRetArray[17] = m_editoccloc.GetValidate();
	bRetArray[18] = m_editoccsex.GetValidate();
	bRetArray[19] = m_editseposn.GetValidate();
	bRetArray[20] = m_editbmcunits.GetValidate();
	bRetArray[21] = m_editbmcloc.GetValidate();

	bRetArray[22] = m_editbmcmethod.GetValidate();
	bRetArray[23] = m_editpulpre.GetValidate();
	bRetArray[24] = m_editcerpre.GetValidate();
	bRetArray[25] = m_editaorpre.GetValidate();

	for(int i=0; i<nTotal; i++) { if (!bRetArray[i]) return false; }
	return true;
}	// ValidateAnthPage

void CBioOccPage::SetBusinessRules( void )
{
	m_editbmccom.SetString( 0, 70 );
	m_editbmcloc.SetString( 0, 3 );
	m_editbmcmethod.SetString( 0, 3 );
	m_editbmcunits.SetString( 0, 4 );
	m_editcadan.SetString( 0, 70 );
	m_editcadapp.SetString( 0, 70 );
	m_editcsedth.SetString( 0, 70 );
	m_editocccom.SetString( 0, 70 );
	m_editoccref.SetString( 0, 10 );
	m_editoccage.SetDouble( 0, 99 );
	m_editoccwt.SetDouble( 0, 999 );
	m_editfrctrb.SetDouble( 0, 99 );
	m_editrbfrct.SetDouble( 0, 99 );
	m_editnotest.SetDouble( 0, 99 );
	m_editbedcon.SetDouble( 0, 999 );
	m_editbmc.SetDouble( -999999999, 999999999);
	m_editoccdate.SetDate();
}	// SetBusinessRules

void CBioOccPage::OnDatetimechangeBiooccdtedth(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CString sDate;
    GetDlgItemText(IDC_BIOOCCDTEDTH, sDate);

	sDate.MakeUpper();
	m_editoccdate =  m_pBioData->m_csedth = sDate;
	
	*pResult = 0;
}

void CBioOccPage::OnPulpreSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"PULPRE","BIODB");
	if (search.DoModal ()==IDOK)
	{
		m_editpulpre = search_code;
		m_editpulpre.SetValidateColor();
	}
	UpdateData(FALSE);
}

void CBioOccPage::OnCerpreSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"CERPRE","BIODB");
	if (search.DoModal ()==IDOK)
	{
		m_editcerpre = search_code;
		m_editcerpre.SetValidateColor();
	}
	UpdateData(FALSE);
}

void CBioOccPage::OnAorpreSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"AORPRE","BIODB");
	if (search.DoModal ()==IDOK)
	{
		m_editaorpre = search_code;
		m_editaorpre.SetValidateColor();
	}
	UpdateData(FALSE);
}
