// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: BioRibPage.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description:  Member functions of CBioRibPage.
//               They relate to the loading and display of 
//               data on this page.
//
//  Modification History:
//  Date		Who			Description
//	2000    Y. Wong Adding business rules, recode all edit boxs
//					and correct other errors.
// -----------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "BioRibPage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBioRibPage property page

IMPLEMENT_DYNCREATE(CBioRibPage, CPropertyPage)

CBioRibPage::CBioRibPage() : CPropertyPage(CBioRibPage::IDD)
{
	//{{AFX_DATA_INIT(CBioRibPage)
	m_editribloc = _T("");
	m_retaindata = FALSE;
	m_editdefl = _T("");
	m_editload = _T("");
	m_editbrkld = _T("");
	m_editarmar = _T("");
	m_editrarea = _T("");
	m_editribin = _T("");
	m_editnadis = _T("");
	m_editsplen = _T("");
	//}}AFX_DATA_INIT

	m_currib = 0;     // Default to 0
}

CBioRibPage::~CBioRibPage()
{
}

void CBioRibPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBioRibPage)
	DDX_Control(pDX, IDC_RIBLIST, m_riblist);
	DDX_Control(pDX, IDC_NEXTSET_BUTTON, m_nextsetbutton);
	DDX_Control(pDX, IDC_DELETE_BUTTON, m_deletebutton);
	DDX_Control(pDX, IDC_BIORIB_RIBLOC, m_editribloc);
//	DDV_MaxChars(pDX, m_ribloc, 3);
	DDX_Check(pDX, IDC_RETAINDATA, m_retaindata);
	DDX_Control(pDX, IDC_BIORIB_DEFL, m_editdefl);
//	DDV_MinMaxDWord(pDX, m_defl, 0, 999999);
	DDX_Control(pDX, IDC_BIORIB_LOAD, m_editload);
//	DDV_MinMaxDWord(pDX, m_load, 0, 99999);
	DDX_Control(pDX, IDC_BIORIB_BRKLD, m_editbrkld);
//	DDV_MinMaxDWord(pDX, m_brkld, 0, 99999);
	DDX_Control(pDX, IDC_BIORIB_ARMAR, m_editarmar);
//	DDV_MinMaxDWord(pDX, m_armar, 0, 999999);
	DDX_Control(pDX, IDC_BIORIB_RAREA, m_editrarea);
//	DDV_MinMaxDWord(pDX, m_rarea, 0, 999999);
	DDX_Control(pDX, IDC_BIORIB_RIBIN, m_editribin);
//	DDV_MinMaxDWord(pDX, m_ribin, 0, 999999);
	DDX_Control(pDX, IDC_BIORIB_NADIS, m_editnadis);
//	DDV_MinMaxDWord(pDX, m_nadis, 0, 999999);
	DDX_Control(pDX, IDC_BIORIB_SPLEN, m_editsplen);
//	DDV_MinMaxDWord(pDX, m_splen, 0, 999999);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBioRibPage, CPropertyPage)
	//{{AFX_MSG_MAP(CBioRibPage)
	ON_BN_CLICKED(IDC_NEXTSET_BUTTON, OnNextsetButton)
	ON_BN_CLICKED(IDC_DELETE_BUTTON, OnDeleteButton)
	ON_LBN_SELCHANGE(IDC_RIBLIST, OnSelchangeRiblist)
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTW, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTA, 0, 0xFFFF, OnToolTipNotify )
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBioRibPage message handlers

BOOL CBioRibPage::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
	TOOLTIPTEXTA* pTTTA = (TOOLTIPTEXTA*)pNMHDR;
	TOOLTIPTEXTW* pTTTW = (TOOLTIPTEXTW*)pNMHDR;
	CString strTipText = "";
	UINT nID = pNMHDR->idFrom;
	if (pNMHDR->code == TTN_NEEDTEXTA && (pTTTA->uFlags & TTF_IDISHWND) ||
		pNMHDR->code == TTN_NEEDTEXTW && (pTTTW->uFlags & TTF_IDISHWND))
	{
		// idFrom is actually the HWND of the tool
		nID = ::GetDlgCtrlID((HWND)nID);
	}

	if (nID != 0) // will be zero on a separator
	{
		strTipText.Format("Control ID = %d", nID);
		switch (nID)
			{
			case IDC_BIORIB_LOAD:
				strTipText = "Newtons (0->99999)";
				break;
			case IDC_BIORIB_BRKLD:
				strTipText = "Newtons (0->99999)";
				break;
			case IDC_BIORIB_ARMAR:
				strTipText = "Square Millimeters (0->999999)";
				break;
			case IDC_BIORIB_RAREA:
				strTipText = "Square Millimeters (0->999999)";
				break;
			case IDC_BIORIB_RIBIN:
				strTipText = "Millimeters (0->999999)";
				break;
			case IDC_BIORIB_NADIS:
				strTipText = "Millimeters (0->999999)";
				break;
			case IDC_BIORIB_SPLEN:
				strTipText = "Millimeters (0->999999)";
				break;
			case IDC_BIORIB_DEFL:
				strTipText = "Millimeters (0->999999)";
				break;
			case IDC_NEXTSET_BUTTON:
				strTipText = "Go to or add next rib info set";
				break;
			case IDC_DELETE_BUTTON:
				strTipText = "Delete rib info set";
				break;
			default:
				strTipText = "";
			}
	}

	if (pNMHDR->code == TTN_NEEDTEXTA)
		lstrcpyn(pTTTA->szText, strTipText, sizeof(pTTTA->szText));
	else
		::MultiByteToWideChar( CP_ACP , 0, strTipText, -1, pTTTW->szText, sizeof(pTTTW->szText) );
	*pResult = 0;

	return TRUE;    // message was handled
}

BOOL CBioRibPage::OnKillActive() 
{
	if( ValidateRibPage() == true )
	{
		LoadBioRibData();

		int nOldCurIndx = m_currib;
		for (m_currib=1; m_currib<m_pBioData->m_ribno+1; m_currib++)
		{
			DisplayBioRibData();
			if (!ValidateRibPage()) { return false; }
		}
		m_currib = nOldCurIndx;

		DisplayBioRibData();

		return CPropertyPage::OnKillActive();
	}
	else { return FALSE; }
}

BOOL CBioRibPage::OnSetActive() 
{
	EnableControls();
		
//	m_totalcurves=max(m_pBioData->m_injno , 0) ; //initialize total curves.

	SetBusinessRules();

	DisplayBioRibData();

	ValidateRibPage();
	
	return CPropertyPage::OnSetActive();
}

BOOL CBioRibPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	EnableToolTips();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CBioRibPage::OnNextsetButton() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }
	if (m_currib==m_pBioData->m_ribno) //if at end, increase # of curves
	{
		if (m_currib!=0) { LoadBioRibData(); }
		m_pBioData->m_ribno++; 
		m_currib++;
		InitializeNextRib();
	} 
	else if (m_currib != 0) 
	{
		if(!LoadBioRibData())
		{
			MessageBox("Error: see CBioRibPage::OnNextcurveButton()");
			return;
		}
		m_currib++;
	}

	DisplayBioRibData();
	ValidateRibPage();

/***
	bool newrib=false;

	if (m_currib>=m_pBioData->m_ribno)
	{
		newrib=true;
	}   

	if (m_currib != 0)
	{
		if (!InsertBioRibData())     //wong correct to insert info
		{     
			return;
		}
	}
	
	m_currib++;           //goto next rib 
	m_pBioData->m_ribno++;//increment total ribs

	if (newrib) InitializeNextRib();

	DisplayBioRibData();  //display next set, if existing
	ValidateRibPage();
**/
}

void CBioRibPage::OnDeleteButton() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	if (m_currib==0) { return;  }

	m_pBioData->m_ribno--;

	m_pBioData->m_ribloc.RemoveAt (m_currib);
	m_pBioData->m_ribin.RemoveAt (m_currib);
	m_pBioData->m_nadis.RemoveAt (m_currib);
	m_pBioData->m_splen.RemoveAt (m_currib);
	m_pBioData->m_defl.RemoveAt (m_currib);
	m_pBioData->m_load.RemoveAt (m_currib);
	m_pBioData->m_brkld.RemoveAt (m_currib);
	m_pBioData->m_armar.RemoveAt (m_currib);
	m_pBioData->m_rarea.RemoveAt (m_currib);
	
	m_currib--;             //goto previous rib
		
	if (m_currib==0 && m_pBioData->m_ribno>0)
	{
		m_currib = 1;
	}

	DisplayBioRibData();  //display previous set, if existing
	
}

//  This function gets the data from the entry fields and puts it into 
//  m_pBioData.  It is called in OnKillActive, ExportData, record changed.
BOOL CBioRibPage::LoadBioRibData()
{
	if (m_hWnd==NULL) return TRUE;  // only return FALSE if data invalid
	
	if(!UpdateData(TRUE)) return FALSE;

	// put data into m_pBioData
	m_pBioData->m_ribno = max(m_pBioData->m_ribno, m_currib); 
	m_pBioData->m_ribloc[m_currib] = m_editribloc.GetTextAsString();
	m_pBioData->m_ribin[m_currib] = m_editribin.GetTextAsString();
	m_pBioData->m_nadis[m_currib] = m_editnadis.GetTextAsString();
	m_pBioData->m_splen[m_currib] = m_editsplen.GetTextAsString();
	m_pBioData->m_defl[m_currib] = m_editdefl.GetTextAsString();
	m_pBioData->m_load[m_currib] = m_editload.GetTextAsString();
	m_pBioData->m_brkld[m_currib] = m_editbrkld.GetTextAsString();
	m_pBioData->m_armar[m_currib] = m_editarmar.GetTextAsString();
	m_pBioData->m_rarea[m_currib] = m_editrarea.GetTextAsString();
	
	return TRUE;
}

// wong code in 03/02/00
bool CBioRibPage::InsertBioRibData()
{
	if (m_hWnd==NULL) return TRUE;  // only return FALSE if data invalid
	
	UpdateData();
 
//	m_pBioData->m_ais.InsertAt( m_curinj, m_ais);
	m_pBioData->m_ribno = max(m_pBioData->m_ribno, m_currib); 
	m_pBioData->m_ribloc.InsertAt( m_currib, m_editribloc.GetTextAsString() );
	m_pBioData->m_ribin.InsertAt( m_currib, m_editribin.GetTextAsString() );
	m_pBioData->m_nadis.InsertAt( m_currib, m_editnadis.GetTextAsString() );
	m_pBioData->m_splen.InsertAt( m_currib, m_editsplen.GetTextAsString() );
	m_pBioData->m_defl.InsertAt( m_currib, m_editdefl.GetTextAsString() );
	m_pBioData->m_load.InsertAt( m_currib, m_editload.GetTextAsString() );
	m_pBioData->m_brkld.InsertAt( m_currib, m_editbrkld.GetTextAsString() );
	m_pBioData->m_armar.InsertAt( m_currib, m_editarmar.GetTextAsString() );
	m_pBioData->m_rarea.InsertAt( m_currib, m_editrarea.GetTextAsString() );

	UpdateData(false);

	return true;
}	// InsertBioRibData

// get data from m_pBioData and display it.
void CBioRibPage::DisplayBioRibData()
{
	if (m_hWnd==NULL) return;

	UpdateCurveListbox();

	UpdateData();
	m_editribloc = m_pBioData->m_ribloc[m_currib];

	m_editribin = m_pBioData->m_ribin[m_currib];

	m_editnadis = m_pBioData->m_nadis[m_currib];

	m_editsplen = m_pBioData->m_splen[m_currib];

	m_editdefl =m_pBioData->m_defl[m_currib];

	m_editload = m_pBioData->m_load[m_currib];

	m_editbrkld =m_pBioData->m_brkld[m_currib];

	m_editarmar = m_pBioData->m_armar[m_currib];

	m_editrarea = m_pBioData->m_rarea[m_currib];

	UpdateData(FALSE);

}

// new rib, so expand m_pBioData arrays to hold info
void CBioRibPage::InitializeNextRib()
{
	// *******************************************
	//These temp variables are used because the reference that [] returns is invalid when SetAtGrow
	// happens, because SetAtGrow (sometimes) moves the array to a different location in memory.   
	// If you try to use that reference directly, you will get an access violation.
	// For Example:  m_pBioData->m_injcom.SetAtGrow (m_curinj,m_pBioData->injcom[m_curinj-1]); //BAD!!!!
	CString strtemp; 
	CString dwtemp;    
	// *******************************************

	if (m_retaindata)
	{
		strtemp= m_pBioData->m_ribloc[m_currib-1];
		m_pBioData->m_ribloc.SetAtGrow (m_currib, strtemp);

		dwtemp= m_pBioData->m_ribin[m_currib-1];
		m_pBioData->m_ribin.SetAtGrow (m_currib, dwtemp);

		dwtemp= m_pBioData->m_nadis[m_currib-1];
		m_pBioData->m_nadis.SetAtGrow (m_currib, dwtemp);

		dwtemp= m_pBioData->m_splen[m_currib-1];
		m_pBioData->m_splen.SetAtGrow (m_currib, dwtemp);

		dwtemp= m_pBioData->m_defl[m_currib-1];
		m_pBioData->m_defl.SetAtGrow (m_currib, dwtemp);

		dwtemp= m_pBioData->m_load[m_currib-1];
		m_pBioData->m_load.SetAtGrow (m_currib, dwtemp);

		dwtemp= m_pBioData->m_brkld[m_currib-1];
		m_pBioData->m_brkld.SetAtGrow (m_currib, dwtemp);

		dwtemp= m_pBioData->m_armar[m_currib-1];
		m_pBioData->m_armar.SetAtGrow (m_currib, dwtemp);

		dwtemp= m_pBioData->m_rarea[m_currib-1];
		m_pBioData->m_rarea.SetAtGrow (m_currib, dwtemp);

	}
	else
	{
		m_pBioData->m_ribloc.SetAtGrow (m_currib, "");
		m_pBioData->m_ribin.SetAtGrow (m_currib, 0);
		m_pBioData->m_nadis.SetAtGrow (m_currib, 0);
		m_pBioData->m_splen.SetAtGrow (m_currib, 0);
		m_pBioData->m_defl.SetAtGrow (m_currib, 0);
		m_pBioData->m_load.SetAtGrow (m_currib, 0);
		m_pBioData->m_brkld.SetAtGrow (m_currib, 0);
		m_pBioData->m_armar.SetAtGrow (m_currib, 0);
		m_pBioData->m_rarea.SetAtGrow (m_currib, 0);
	}


}


void CBioRibPage::UpdateCurveListbox()
{
	if (m_riblist.GetCount ()!=m_pBioData->m_ribno)
	{
		m_riblist.ResetContent();
		char crvbuf [10];
		for (int loop=1;loop <= m_pBioData->m_ribno;loop++)
		{
			itoa(loop,crvbuf,10);
			if (m_riblist.FindString (-1,crvbuf)==LB_ERR)  //if buf isnt there already.
			{
				m_riblist.AddString(crvbuf);
			}
		}
	}

	m_riblist.SetCurSel (max(0,m_currib-1));  // select current curve, zero based.
	
}

void CBioRibPage::OnSelchangeRiblist() 
{
	int nCurve = m_riblist.GetCurSel ();  //zero based

	if (m_currib != 0) 
	{
		BOOL success = LoadBioRibData();     //load current info (not zeroth curve)
		if (!success) //Data not valid, dont change curves.
		{
			m_riblist.SetCurSel (max(0,m_currib-1));  // select current curve, zero based.
			return;
		}
	}

	m_currib= nCurve+1;             //goto current curve 

	DisplayBioRibData();  //display next set, if existing
	ValidateRibPage();
}

BOOL CBioRibPage::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	WinHelp(Rib_Bending_Information);
	
	return TRUE;
}

//
bool CBioRibPage::ValidateRibPage( void )
{	
	bool bRetArray[9];

	bRetArray[0] =  m_editribloc.GetValidate();
	bRetArray[1] =  m_editdefl.GetValidate();
	bRetArray[2] =  m_editload.GetValidate();
	bRetArray[3] =  m_editbrkld.GetValidate();
	bRetArray[4] =  m_editarmar.GetValidate();
	bRetArray[5] =  m_editrarea.GetValidate();
	bRetArray[6] =  m_editribin.GetValidate();
	bRetArray[7] =  m_editnadis.GetValidate();
	bRetArray[8] =  m_editsplen.GetValidate();
	
	for(int i=0; i<9; i++) { if (!bRetArray[i]) return false; }
	return true;
}	// ValidateAnthPage

void CBioRibPage::SetBusinessRules( void )
{
	m_editribloc.SetString( 0, 3 );
	m_editdefl.SetDouble( 0, 999999);
	m_editload.SetDouble( 0, 99999);
	m_editbrkld.SetDouble( 0, 99999);
	m_editarmar.SetDouble( 0, 999999);
	m_editrarea.SetDouble( 0, 999999);
	m_editribin.SetDouble( 0, 999999);
	m_editnadis.SetDouble( 0, 999999);
	m_editsplen.SetDouble( 0, 999999);
}	// SetBusinessRules

void CBioRibPage::EnableControls()
{
	HWND temphwnd;
	if ( (m_pBioData->m_occtyp == "") || ( (m_pBioData->m_occtyp != "AN") && 
	   (m_pBioData->m_occtyp != "CD") /*&& (m_pBioData->m_occtyp != "HU")*/ ) ) 
	{
		temphwnd = ::GetDlgItem( m_hWnd, IDC_RIBLIST );
		::EnableWindow ( temphwnd, false );	//m_riblist.EnableWindow(false);
		temphwnd = ::GetDlgItem( m_hWnd, IDC_RETAINDATA );
		::EnableWindow ( temphwnd, false );

		m_nextsetbutton.EnableWindow(false);
		m_deletebutton.EnableWindow(false);
		m_editribloc.EnableWindow(false);		
		m_editdefl.EnableWindow(false);
		m_editload.EnableWindow(false);
		m_editbrkld.EnableWindow(false);
		m_editarmar.EnableWindow(false);
		m_editrarea.EnableWindow(false);
		m_editribin.EnableWindow(false);
		m_editnadis.EnableWindow(false);
		m_editsplen.EnableWindow(false);
	
	}
	else   // enable.
	{
		temphwnd = ::GetDlgItem( m_hWnd, IDC_RIBLIST );
		::EnableWindow ( temphwnd, true );
		temphwnd = ::GetDlgItem( m_hWnd, IDC_RETAINDATA );
		::EnableWindow ( temphwnd, true );

		m_riblist.EnableWindow(true);
		m_nextsetbutton.EnableWindow(true);
		m_deletebutton.EnableWindow(true);
		m_editribloc.EnableWindow(true);
		m_editdefl.EnableWindow(true);
		m_editload.EnableWindow(true);
		m_editbrkld.EnableWindow(true);
		m_editarmar.EnableWindow(true);
		m_editrarea.EnableWindow(true);
		m_editribin.EnableWindow(true);
		m_editnadis.EnableWindow(true);
		m_editsplen.EnableWindow(true);
	}
}	// EnableControls
