// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: ClearanceDist.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description:  Member functions of CClearanceDist.
//               Data is displayed when box opens, and 
//               loaded when closes.
// -----------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "ClearanceDist.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CClearanceDist dialog


CClearanceDist::CClearanceDist(CVehData* pData, int curocc, CWnd* pParent /*=NULL*/ )
	: CDialog(CClearanceDist::IDD, pParent)
{
	//{{AFX_DATA_INIT(CClearanceDist)
	m_ad	= _T("");
	m_cb	= _T("");
	m_cd	= _T("");
	m_cs	= _T("");
	m_hb	= _T("");
	m_hd	= _T("");
	m_hh	= _T("");
	m_hr	= _T("");
	m_hs	= _T("");
	m_hw	= _T("");
	m_kb	= _T("");
	m_kd	= _T("");
	m_nb	= _T("");
	//}}AFX_DATA_INIT
	m_curocc = curocc;
	m_pVehData = pData;

	m_bDisplay = true;
	m_bValidate = true;
}


void CClearanceDist::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CClearanceDist)
	DDX_Control(pDX, IDC_AD, m_ad);
	DDX_Control(pDX, IDC_CB, m_cb);
	DDX_Control(pDX, IDC_CD, m_cd);
	DDX_Control(pDX, IDC_CS, m_cs);
	DDX_Control(pDX, IDC_HB, m_hb);
	DDX_Control(pDX, IDC_HD, m_hd);
	DDX_Control(pDX, IDC_HH, m_hh);
	DDX_Control(pDX, IDC_HR, m_hr);
	DDX_Control(pDX, IDC_HS, m_hs);
	DDX_Control(pDX, IDC_HW, m_hw);
	DDX_Control(pDX, IDC_KB, m_kb);
	DDX_Control(pDX, IDC_KD, m_kd);
	DDX_Control(pDX, IDC_NB, m_nb);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CClearanceDist, CDialog)
	//{{AFX_MSG_MAP(CClearanceDist)
	ON_NOTIFY_EX( TTN_NEEDTEXT, 0, OnToolTipNotify )
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClearanceDist message handlers

BOOL CClearanceDist::OnInitDialog() 
{
	CDialog::OnInitDialog();

	SetBusinessRules();
	
	m_ad	= m_pVehData->m_ad[m_curocc];
	m_cb	= m_pVehData->m_cb[m_curocc];
	m_cd	= m_pVehData->m_cd[m_curocc];
	m_cs	= m_pVehData->m_cs[m_curocc];
	m_hb	= m_pVehData->m_hb[m_curocc];
	m_hd	= m_pVehData->m_hd[m_curocc];
	m_hh	= m_pVehData->m_hh[m_curocc];
	m_hr	= m_pVehData->m_hr[m_curocc];
	m_hs	= m_pVehData->m_hs[m_curocc];
	m_hw	= m_pVehData->m_hw[m_curocc];
	m_kb	= m_pVehData->m_kb[m_curocc];
	m_kd	= m_pVehData->m_kd[m_curocc];
	m_nb	= m_pVehData->m_nb[m_curocc];

	if( m_bDisplay == false )
	{
		if( ValidatePage() == false )
		{
			m_bValidate = false;
		}

		CDialog::OnOK();
	}
	else
	{
		ValidatePage();
	}

	UpdateData(FALSE);

	EnableToolTips();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Created -- Al Wilhelm -- 03/09/2000

******************************************************************************/
void CClearanceDist::OnOK()
{
	if( ValidatePage() == false )
	{
		return;
	}
	
	CDialog::OnOK();
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Created -- Al Wilhelm -- 03/10/2000

******************************************************************************/
void CClearanceDist::OnCancel() 
{
	if( ValidatePage() == false )
	{
		m_bValidate = false;
	}
	else
	{
		m_bValidate = true;
	}
	
	CDialog::OnCancel();
}

BOOL CClearanceDist::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
    TOOLTIPTEXT *pTTT = (TOOLTIPTEXT *)pNMHDR;
    int nID =pNMHDR->idFrom;
    if (pTTT->uFlags & TTF_IDISHWND)    
	{
        // idFrom is actually the HWND of the tool
        nID = ::GetDlgCtrlID((HWND)nID);    
		if(nID)        
		{
            pTTT->lpszText = "0->9999";
			return TRUE;
					
        }   
	}  

	return FALSE;
}

/******************************************************************************

	Name:		ValidatePage

	Action:		

	Params:		void

	Returns:	bool

	Notes:		

	Dates:		Created - Al Wilhelm - 03/07/2000

******************************************************************************/
bool CClearanceDist::ValidatePage( void )
{
	bool bRetArray[13];
	
	bRetArray[0]	= m_ad.GetValidate();
	bRetArray[1]	= m_cb.GetValidate();
	bRetArray[2]	= m_cd.GetValidate();
	bRetArray[3]	= m_cs.GetValidate();
	bRetArray[4]	= m_hb.GetValidate();
	bRetArray[5]	= m_hd.GetValidate();
	bRetArray[6]	= m_hh.GetValidate();
	bRetArray[7]	= m_hr.GetValidate();
	bRetArray[8]	= m_hs.GetValidate();
	bRetArray[9]	= m_hw.GetValidate();
	bRetArray[10]	= m_kb.GetValidate();
	bRetArray[11]	= m_kd.GetValidate();
	bRetArray[12]	= m_nb.GetValidate();

	for( int i = 0; i < 13; i++ )
	{
		if( !bRetArray[i] )
		{
			return false;
		}
	}

	return true;
}

/******************************************************************************

	Name:		SetBusinessRules

	Action:		

	Params:		void

	Returns:	void

	Notes:		

	Dates:		Created - Al Wilhelm - 03/07/2000

******************************************************************************/
void CClearanceDist::SetBusinessRules( void )
{
	m_ad.SetDouble( 0, 9999, true );
	m_cb.SetDouble( 0, 9999, true );
	m_cd.SetDouble( 0, 9999, true );
	m_cs.SetDouble( 0, 9999, true );
	m_hb.SetDouble( 0, 9999, true );
	m_hd.SetDouble( 0, 9999, true );
	m_hh.SetDouble( 0, 9999, true );
	m_hr.SetDouble( 0, 9999, true );
	m_hs.SetDouble( 0, 9999, true );
	m_hw.SetDouble( 0, 9999, true );
	m_kb.SetDouble( 0, 9999, true );
	m_kd.SetDouble( 0, 9999, true );
	m_nb.SetDouble( 0, 9999, true );
}
