//---------------------------------------------------------
// CodeValidation.cpp
//
// Purpose - Validate input code that is not check out from search dialog
//
// Author:	Yeun Wong
// Date:	04/27/2001
//
// Description - 
//				There are two choices for a SQL statement:
//				1. entering codename and db name;
//				2. entering a SQL statment.
//
// Revision History:
//
//---------------------------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "CodeValidation.h"

CCodeValidation::CCodeValidation( CNEdit& edit, const CString codename, const CString db )	
{
	CString sT = edit.GetTextAsString(); sT.TrimLeft();
	if (sT=="") { edit.SetValidateColor(); return; } // used after finishing debugging

	CString sqlSelect = "SELECT " + codename + " FROM NHTSADB_" + codename \
				+ " WHERE REFERENCE LIKE '%" + db  + "%' ORDER BY " + codename;

	Validation( edit, sqlSelect, codename );

}	// constructor

CCodeValidation::CCodeValidation(CNEdit& edit, const CString codename, const CString db, bool& bOk)
{
CString sT = edit.GetTextAsString(); sT.TrimLeft();
	if (sT=="") { edit.SetValidateColor(); return; } // used after finishing debugging

	CString sqlSelect = "SELECT " + codename + " FROM NHTSADB_" + codename \
				+ " WHERE REFERENCE LIKE '%" + db  + "%' ORDER BY " + codename;

	bOk = Validation( edit, sqlSelect, codename );
}	// constructor

CCodeValidation::CCodeValidation( CNEdit& edit, const CString sqlSelect )
{
	CString sT = edit.GetTextAsString(); sT.TrimLeft();
	if (sT=="") { edit.SetValidateColor(); return; } // used after finishing debugging

	sT = sqlSelect;
	sT.TrimLeft();
	int nFirst = sT.Find(' ');
	int nLast  = sT.Find(',');
	if (nLast==-1) { nLast = sT.Find("FROM"); }

	// find code name:
	CString codename;
	if ( nFirst<nLast ) 
	{ 
		codename = sT.Mid(nFirst+1, nLast-nFirst-1); 
		codename.TrimLeft(); codename.TrimRight();
	}
	else
	{ 
		AfxMessageBox("SQL statement error: code name not found."); 
		return;
	}

	Validation( edit, sqlSelect, codename );

}	// constructor

// ado data accessing and validation:
const bool CCodeValidation::Validation( CNEdit& edit, const CString sqlSelect, const CString codename )
{
	_bstr_t bstrQuery(sqlSelect);
//	_variant_t vtQuery( SQLSelect ); // for debug only
	_variant_t vRecsAffected(0L);

	_RecordsetPtr pRecordSet;
	try
	{
//		_variant_t vtString = CEntreeV5App::m_pConnection->ConnectionString; // for debug only
		pRecordSet= CEntreeV5App::m_pConnection->Execute(bstrQuery, &vRecsAffected, adOptionUnspecified);
		
		bool nFound = false;
		if (!pRecordSet->GetadoEOF())
		{
			_variant_t vCodenameIdx(codename);

			nFound = false;
			CString sData;
			CString sE = edit.GetTextAsString();
			sE.TrimLeft(); sE.TrimRight();

			while (!pRecordSet->GetadoEOF()) // while not end of dataset
			{
				_variant_t vData = pRecordSet->GetCollect(vCodenameIdx);
				sData =(char*)_bstr_t(vData);
				sData.TrimLeft(); sData.TrimRight();
				if (sData==sE) { nFound = true; break; }

				pRecordSet->MoveNext();
			}
			edit.SetValidateColor(nFound);
		}
		else { AfxMessageBox("No Data Found."); }

		pRecordSet->Close();

		return nFound;
	}
	catch (_com_error *e) //handle com errors
	{
		// Get info from _com_error
		CString Error = e->ErrorMessage();
		AfxMessageBox(e->ErrorMessage());						
	}
	catch (...)  //handle all other errors.  See codeguru->Database->ADO is AOK, Dmitri's response.
	{
		ErrorPtr errItem;
		_variant_t vIndex;
		_bstr_t strstr;
		long iNum=0;

		CEntreeV5App::m_pConnection -> Errors -> get_Count(&iNum);
	
		for(int i = 0; i < iNum; i++)
		{
			vIndex.vt = VT_I4;
			vIndex.lVal = i;
			errItem = CEntreeV5App::m_pConnection -> Errors ->GetItem(vIndex);
			strstr = errItem -> Description;
			AfxMessageBox(strstr);
		}
	}

	return false;
}	// Validation


