// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: CompCompPage.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description:  Member functions of CCompCompPage.
//               They relate to the loading and display of 
//               data on this page.
//
//  Modification History:
//  Date		Who			Description
//	2000    Y. Wong Adding business rules, recode all edit boxs
//					and correct other errors.
// -----------------------------------------


#include "stdafx.h"
#include "entreeV5.h"
#include "CompCompPage.h"
#include "search.h"
#include "CodeValidation.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CString search_code;

/////////////////////////////////////////////////////////////////////////////
// CCompCompPage property page

IMPLEMENT_DYNCREATE(CCompCompPage, CPropertyPage)

CCompCompPage::CCompCompPage() : CPropertyPage(CCompCompPage::IDD)
{
	//{{AFX_DATA_INIT(CCompCompPage)
	m_editcmpcom = _T("");
	m_editcmpnt = _T("");
	m_editcmptyp = _T("");
	m_editdumman = _T("");
	m_editdumsiz = _T("");
	m_editmoddsc = _T("");
	m_editmodind = _T("");
	m_editocctyp = _T("");
	m_retaindata = FALSE;
	m_editcmpwgt = _T("");
	m_editcmpno = _T("");
	m_editvehno = _T("");
	//}}AFX_DATA_INIT

	m_curset = 0;
	
}

CCompCompPage::~CCompCompPage()
{
}

void CCompCompPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCompCompPage)
	DDX_Control(pDX, IDC_COMPLIST, m_complist);
	DDX_Control(pDX, IDC_NEXTSET_BUTTON, m_nextsetbutton);
	DDX_Control(pDX, IDC_DELETE_BUTTON, m_deletebutton);
	DDX_Control(pDX, IDC_COMPCOMP_CMPCOM, m_editcmpcom);
//	DDV_MaxChars(pDX, m_cmpcom, 70);
	DDX_Control(pDX, IDC_COMPCOMP_CMPNT, m_editcmpnt);
	DDX_Control(pDX, IDC_COMPCOMP_CMPTYP, m_editcmptyp);
	DDX_Control(pDX, IDC_COMPCOMP_DUMMAN, m_editdumman);
//	DDV_MaxChars(pDX, m_dumman, 70);
	DDX_Control(pDX, IDC_COMPCOMP_DUMSIZ, m_editdumsiz);
	DDX_Control(pDX, IDC_COMPCOMP_MODDSC, m_editmoddsc);
//	DDV_MaxChars(pDX, m_moddsc, 70);
	DDX_Control(pDX, IDC_COMPCOMP_MODIND, m_editmodind);
	DDX_Control(pDX, IDC_COMPCOMP_OCCTYP, m_editocctyp);
	DDX_Check(pDX, IDC_RETAINDATA, m_retaindata);
	DDX_Control(pDX, IDC_COMPCOMP_CMPWGT, m_editcmpwgt);
//	DDV_MinMaxFloat(pDX, m_cmpwgt, 0.f, 10000.f);
	DDX_Control(pDX, IDC_COMPCOMP_CMPNO, m_editcmpno);
//	DDV_MinMaxDWord(pDX, m_cmpno, 1, 99);
	DDX_Control(pDX, IDC_COMPCOMP_VEHNO, m_editvehno);
//	DDV_MinMaxDWord(pDX, m_vehno, 1, 2);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCompCompPage, CPropertyPage)
	//{{AFX_MSG_MAP(CCompCompPage)
	ON_BN_CLICKED(IDC_COMPCOMP_CMPNTSEARCH, OnCompcompCmpntsearch)
	ON_BN_CLICKED(IDC_COMPCOMP_CMPTYPSEARCH, OnCompcompCmptypsearch)
	ON_BN_CLICKED(IDC_COMPCOMP_MODINDSEARCH, OnCompcompModindsearch)
	ON_BN_CLICKED(IDC_COMPCOMP_OCCTYPSEARCH, OnCompcompOcctypsearch)
	ON_BN_CLICKED(IDC_COMPCOMP_DUMSIZSEARCH, OnCompcompDumsizsearch)
	ON_BN_CLICKED(IDC_DELETE_BUTTON, OnDeleteButton)
	ON_BN_CLICKED(IDC_NEXTSET_BUTTON, OnNextsetButton)
	ON_LBN_SELCHANGE(IDC_COMPLIST, OnSelchangeComplist)
	ON_COMMAND(ID_HELP, OnHelpFinder)
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTW, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTA, 0, 0xFFFF, OnToolTipNotify )
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCompCompPage message handlers

BOOL CCompCompPage::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
	TOOLTIPTEXTA* pTTTA = (TOOLTIPTEXTA*)pNMHDR;
	TOOLTIPTEXTW* pTTTW = (TOOLTIPTEXTW*)pNMHDR;
	CString strTipText = "";
	UINT nID = pNMHDR->idFrom;
	if (pNMHDR->code == TTN_NEEDTEXTA && (pTTTA->uFlags & TTF_IDISHWND) ||
		pNMHDR->code == TTN_NEEDTEXTW && (pTTTW->uFlags & TTF_IDISHWND))
	{
		// idFrom is actually the HWND of the tool
		nID = ::GetDlgCtrlID((HWND)nID);
	}

	if (nID != 0) // will be zero on a separator
	{
		strTipText.Format("Control ID = %d", nID);
		switch (nID)
			{
			case IDC_COMPCOMP_CMPWGT:
				strTipText = "kg (0.000->9999.999)";
				break;
			case IDC_NEXTSET_BUTTON:
				strTipText = "Advance to Next Component Info Set";
				break;
			case IDC_DELETE_BUTTON:
				strTipText = "Delete Component Info Set";
				break;
			default:
				strTipText = "";
			}
	}

	if (pNMHDR->code == TTN_NEEDTEXTA)
		lstrcpyn(pTTTA->szText, strTipText, sizeof(pTTTA->szText));
	else
		::MultiByteToWideChar( CP_ACP , 0, strTipText, -1, pTTTW->szText, sizeof(pTTTW->szText) );
	*pResult = 0;

	return TRUE;    // message was handled
}

void CCompCompPage::OnCompcompCmpntsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"CMPNT","COMDB");
	if (search.DoModal ()==IDOK)
	{
		m_editcmpnt = search_code;
		m_editcmpnt.SetValidateColor();
	}
	UpdateData(FALSE);
	
}

void CCompCompPage::OnCompcompCmptypsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"CMPTYP","COMDB");
	if (search.DoModal ()==IDOK)
	{
		m_editcmptyp = search_code;
		m_editcmptyp.SetValidateColor();
	}
	UpdateData(FALSE);
}

void CCompCompPage::OnCompcompModindsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"MODIND","COMDB");
	if (search.DoModal ()==IDOK)
	{
		m_editmodind = search_code;
		m_editmodind.SetValidateColor();
	}
	UpdateData(FALSE);
}

void CCompCompPage::OnCompcompOcctypsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"OCCTYP","COMDB");
	if (search.DoModal ()==IDOK)
	{
		m_editocctyp = search_code;
		m_editocctyp.SetValidateColor();
	}
	UpdateData(FALSE);
}

void CCompCompPage::OnCompcompDumsizsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"DUMSIZ","COMDB");
	if (search.DoModal ()==IDOK)
	{
		m_editdumsiz = search_code;
		m_editdumsiz.SetValidateColor();
	}
	UpdateData(FALSE);
}

BOOL CCompCompPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	EnableToolTips();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CCompCompPage::OnSetActive() 
{
	m_settot=max(m_pCompData->m_compsets , 0) ; //initialize total curves.
	
	SetBusinessRules();

	DisplayCompCompData();

	ValidateCompPage();
	
	return CPropertyPage::OnSetActive();
}

BOOL CCompCompPage::OnKillActive() 
{			
	if( ValidateCompPage() == true )
	{
		LoadCompCompData();

		int nOldCurIndx = m_curset;
		for (m_curset=1; m_curset<m_settot+1; m_curset++)
		{
			DisplayCompCompData();
			if (!ValidateCompPage()) { return false; }
		}
		m_curset = nOldCurIndx;

		DisplayCompCompData();

		return CPropertyPage::OnKillActive();
	}
	else
	{
		// Error are found on AnthPage.
		return FALSE;
	}
}

void CCompCompPage::OnDeleteButton() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	if (m_curset==0) { return;  }

	m_settot--;
	// Remove the data from all of the arrays.
	m_pCompData->m_cmpcom.RemoveAt(m_curset); 
	m_pCompData->m_cmpno.RemoveAt(m_curset); 
	m_pCompData->m_cmpnt.RemoveAt(m_curset); 
	m_pCompData->m_cmptyp.RemoveAt(m_curset); 
	m_pCompData->m_cmpwgt.RemoveAt(m_curset); 
	m_pCompData->m_dumman.RemoveAt(m_curset); 
	m_pCompData->m_dumsiz.RemoveAt(m_curset); 
	m_pCompData->m_moddsc.RemoveAt(m_curset); 
	m_pCompData->m_modind.RemoveAt(m_curset); 
	m_pCompData->m_occtyp.RemoveAt(m_curset); 
	m_pCompData->m_Comp_vehno.RemoveAt(m_curset); 

	m_curset--;

	//if m_curset == 0 now, and there are remaining curves, set curve 1 as active (m_curset=1)
	if (m_curset==0 && m_settot>0)
	{
		m_curset = 1;
	}
	
	DisplayCompCompData();  //display previous set, if existing

}

void CCompCompPage::OnNextsetButton() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	if (m_curset==m_settot) //if at end, increase # of curves
	{
		if (m_curset!=0) { LoadCompCompData(); }
		m_settot++; 
		m_curset++;
		InitializeNextSet();
	} 
	else if (m_curset != 0) 
	{
		if(!LoadCompCompData())
		{
			MessageBox("Error: see CCompCompPage::OnNextcurveButton()");
			return;
		}
		m_curset++;
	}

	DisplayCompCompData();
	ValidateCompPage( );
/***
	bool newset=false;

	if (m_curset==m_settot) //wong note: can be inserted between any two adjacent sets
	{  
		newset=true;
	}   

	if (m_curset != 0) 
	{
//		BOOL success = LoadCompCompData(); //load current info into m_pCompData(not zeroth set)
		if (!InsertCompCompData()) //	wong corrected in 03/02/00
		{
			if (newset) m_settot--;
			return;
		}
	}

	m_curset++;             //goto next set
	m_settot++;

	if (newset) InitializeNextSet();

	DisplayCompCompData();  //display next set, if existing
	ValidateCompPage( );

	if ((m_curset==m_settot) || (newset)) m_deletebutton.EnableWindow();
**/	
}


//  This function gets the data from the entry fields and puts it into 
//  m_pCompData.  It is called in OnKillActive, ExportData, record changed.
BOOL CCompCompPage::LoadCompCompData()
{
	if (m_hWnd==NULL) return TRUE;  // only return FALSE if data invalid

	if (!UpdateData()) return FALSE;

	m_pCompData->m_cmpcom[m_curset]	= m_editcmpcom.GetTextAsString();
	m_pCompData->m_cmpno[m_curset]	= m_editcmpno.GetTextAsString();
	m_pCompData->m_cmpnt[m_curset]	= m_editcmpnt.GetTextAsString();
	m_pCompData->m_cmptyp[m_curset] = m_editcmptyp.GetTextAsString();
	m_pCompData->m_cmpwgt[m_curset] = m_editcmpwgt.GetTextAsString();
	m_pCompData->m_dumman[m_curset] = m_editdumman.GetTextAsString();
	m_pCompData->m_dumsiz[m_curset] = m_editdumsiz.GetTextAsString();
	m_pCompData->m_moddsc[m_curset] = m_editmoddsc.GetTextAsString();
	m_pCompData->m_modind[m_curset] = m_editmodind.GetTextAsString();
	m_pCompData->m_occtyp[m_curset] = m_editocctyp.GetTextAsString();
	m_pCompData->m_Comp_vehno[m_curset] = m_editvehno.GetTextAsString();
	m_pCompData->m_compsets = m_settot;

	return TRUE;

}

// wong code in 03/02/00
bool CCompCompPage::InsertCompCompData()
{
	if (m_hWnd==NULL) return TRUE;  // only return FALSE if data invalid
	
	UpdateData();
 
//	m_pBioData->m_ais.InsertAt( m_curinj, m_ais);
	m_pCompData->m_cmpcom.InsertAt( m_curset, m_editcmpcom.GetTextAsString() );
	m_pCompData->m_cmpno.InsertAt( m_curset, m_editcmpno.GetTextAsString() );
	m_pCompData->m_cmpnt.InsertAt( m_curset, m_editcmpnt.GetTextAsString() );
	m_pCompData->m_cmptyp.InsertAt( m_curset, m_editcmptyp.GetTextAsString() );
	m_pCompData->m_cmpwgt.InsertAt( m_curset, m_editcmpwgt.GetTextAsString() );
	m_pCompData->m_dumman.InsertAt( m_curset, m_editdumman.GetTextAsString() );
	m_pCompData->m_dumsiz.InsertAt( m_curset, m_editdumsiz.GetTextAsString() );
	m_pCompData->m_moddsc.InsertAt( m_curset, m_editmoddsc.GetTextAsString() );
	m_pCompData->m_modind.InsertAt( m_curset, m_editmodind.GetTextAsString() );
	m_pCompData->m_occtyp.InsertAt( m_curset, m_editocctyp.GetTextAsString() );
	m_pCompData->m_Comp_vehno.InsertAt( m_curset, m_editvehno.GetTextAsString() );

	m_pCompData->m_compsets = m_settot;

	UpdateData(false);

	return true;
}	// InsertCompCompData

//Get data from m_pCompData and display it.
void CCompCompPage::DisplayCompCompData()
{
	if (m_hWnd==NULL) return;

	UpdateCurveListbox();

	UpdateData();
	m_editcmpcom = m_pCompData->m_cmpcom[m_curset];	
	m_editcmpno = m_pCompData->m_cmpno[m_curset];
	m_editcmpnt = m_pCompData->m_cmpnt[m_curset];
	m_editcmptyp = m_pCompData->m_cmptyp[m_curset];
	m_editcmpwgt = m_pCompData->m_cmpwgt[m_curset];

	m_editdumman = m_pCompData->m_dumman[m_curset];
	m_editdumsiz = m_pCompData->m_dumsiz[m_curset];
	m_editmoddsc = m_pCompData->m_moddsc[m_curset];
	m_editmodind = m_pCompData->m_modind[m_curset];
	m_editocctyp= m_pCompData->m_occtyp[m_curset];
	
	m_editvehno = m_pCompData->m_Comp_vehno[m_curset];

	CCodeValidation( m_editcmpnt, "CMPNT","COMDB" );
	CCodeValidation( m_editcmptyp, "CMPTYP","COMDB" );
	CCodeValidation( m_editmodind, "MODIND","COMDB" );
	CCodeValidation( m_editocctyp, "OCCTYP","COMDB" );
	CCodeValidation( m_editdumsiz, "DUMSIZ","COMDB" );

	UpdateData(FALSE);

}


// new set, expand arrays in m_pCompData to hold info.
void CCompCompPage::InitializeNextSet()
{
// *******************************************
//These temp variables are used because the reference that [] returns is invalid when SetAtGrow
// happens, because SetAtGrow (sometimes) moves the array to a different location in memory.   
// If you try to use that reference directly, you will get an access violation.
// For Example:  m_pCompData->m_inscom.SetAtGrow (m_icurno,m_pCompData->inscom[m_icurno-1]); //BAD!!!!
	CString strtemp; 
	CString   dwtemp;    
	CString   ftemp;
// *******************************************

	if (m_retaindata)
	{
		strtemp = m_pCompData->m_cmpcom[m_curset-1];
		m_pCompData->m_cmpcom.SetAtGrow(m_curset, strtemp); 

		dwtemp = m_pCompData->m_cmpno[m_curset - 1];
		m_pCompData->m_cmpno.SetAtGrow(m_curset, dwtemp);

		strtemp = m_pCompData->m_cmpnt[m_curset-1];
		m_pCompData->m_cmpnt.SetAtGrow(m_curset, strtemp);

		strtemp = m_pCompData->m_cmptyp[m_curset -1];
		m_pCompData->m_cmptyp.SetAtGrow(m_curset, strtemp);

		ftemp = m_pCompData->m_cmpwgt[m_curset - 1];
		m_pCompData->m_cmpwgt.SetAtGrow(m_curset, ftemp);

		strtemp = m_pCompData->m_dumman[m_curset -1];
		m_pCompData->m_dumman.SetAtGrow(m_curset, strtemp);

		strtemp = m_pCompData->m_dumsiz[m_curset -1];
		m_pCompData->m_dumsiz.SetAtGrow(m_curset, strtemp);

		strtemp = m_pCompData->m_moddsc[m_curset -1];
		m_pCompData->m_moddsc.SetAtGrow(m_curset, strtemp);

		strtemp = m_pCompData->m_modind[m_curset -1];
		m_pCompData->m_modind.SetAtGrow(m_curset, strtemp);

		strtemp = m_pCompData->m_occtyp[m_curset -1];
		m_pCompData->m_occtyp.SetAtGrow(m_curset, strtemp);

		dwtemp = m_pCompData->m_Comp_vehno[m_curset-1];
		m_pCompData->m_Comp_vehno.SetAtGrow(m_curset, dwtemp);

	}
	else
	{
		m_pCompData->m_cmpcom.SetAtGrow(m_curset, ""); 
		m_pCompData->m_cmpno.SetAtGrow(m_curset, "");
		m_pCompData->m_cmpnt.SetAtGrow(m_curset, "");
		m_pCompData->m_cmptyp.SetAtGrow(m_curset, "");
		m_pCompData->m_cmpwgt.SetAtGrow(m_curset, "");
		m_pCompData->m_dumman.SetAtGrow(m_curset, "");
		m_pCompData->m_dumsiz.SetAtGrow(m_curset, "");
		m_pCompData->m_moddsc.SetAtGrow(m_curset, "");
		m_pCompData->m_modind.SetAtGrow(m_curset, "");
		m_pCompData->m_occtyp.SetAtGrow(m_curset, "");
		m_pCompData->m_Comp_vehno.SetAtGrow(m_curset, "");
	
	}
}

// user clicked the curves listbox, so change to that curve
void CCompCompPage::OnSelchangeComplist() 
{
	int nCurve = m_complist.GetCurSel ();  //zero based

	if (m_curset != 0) 
	{
		BOOL success = LoadCompCompData();     //load current info (not zeroth curve)
		if (!success) //Data not valid, dont change curves.
		{
			m_complist.SetCurSel (max(0,m_curset-1));  // select current curve, zero based.
			return;
		}
	}

	m_curset= nCurve+1;             //goto current curve 

	DisplayCompCompData();  //display next set, if existing	
	ValidateCompPage( );
}

void CCompCompPage::UpdateCurveListbox()
{
	if (m_complist.GetCount ()!=m_settot)
	{
		m_complist.ResetContent();
		char crvbuf [10];
		for (int loop=1;loop <= m_settot;loop++)
		{
			itoa(loop,crvbuf,10);
			if (m_complist.FindString (-1,crvbuf)==LB_ERR)  //if buf isnt there already.
			{
				m_complist.AddString(crvbuf);
			}
		}
	}

	m_complist.SetCurSel (max(0,m_curset-1));  // select current curve, zero based.
	
}

BOOL CCompCompPage::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	WinHelp(Component);
	
	return TRUE;
}

// new  added
//
bool CCompCompPage::ValidateCompPage( )
{
	const int nTotal = 11;
	bool bRetArray[nTotal];

	bRetArray[0] = m_editcmpcom.GetValidate();
	bRetArray[1] = m_editdumman.GetValidate();
	bRetArray[2] = m_editmoddsc.GetValidate();
	bRetArray[3] = m_editcmpwgt.GetValidate();
	bRetArray[4] = m_editcmpno.GetValidate();
	bRetArray[5] = m_editvehno.GetValidate();
	
	bRetArray[6]	= m_editcmpnt.GetValidate();
	bRetArray[7]	= m_editcmptyp.GetValidate();
	bRetArray[8]	= m_editmodind.GetValidate();
	bRetArray[9]	= m_editocctyp.GetValidate();
	bRetArray[10]	= m_editdumsiz.GetValidate();

	for(int i=0; i<nTotal; i++) { if (!bRetArray[i]) return false; }
	return true;
}	// ValidateAnthPage

void CCompCompPage::SetBusinessRules( )
{
	 m_editcmpcom.SetString( 0, 70);
	 m_editdumman.SetString( 0, 70);
	 m_editmoddsc.SetString( 0, 70);
	 m_editcmpwgt.SetDouble( 0.f, 10000.f);
	 m_editcmpno.SetDouble( 1, 99);
	 m_editvehno.SetDouble( 1, 2);

}	// SetBusinessRules