// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: CompConfPage.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description:  Member functions of CCompConfPage.
//               They relate to the loading and display of 
//               data on this page.
//
//  Modification History:
//  Date		Who			Description
//	2000    Y. Wong Adding business rules, recode all edit boxs
//					and correct other errors.
// -----------------------------------------


#include "stdafx.h"
#include "entreeV5.h"
#include "CompConfPage.h"
#include "search.h"
#include "CodeValidation.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CString search_code;

/////////////////////////////////////////////////////////////////////////////
// CCompConfPage property page

IMPLEMENT_DYNCREATE(CCompConfPage, CPropertyPage)

CCompConfPage::CCompConfPage() : CPropertyPage(CCompConfPage::IDD)
{
	//{{AFX_DATA_INIT(CCompConfPage)
	m_editcfncom	= _T("");
	m_editcntcom	= _T("");
	m_editconfig	= _T("");
	m_editdevcom	= _T("");
	m_edittstdev	= _T("");
	m_retaindata = FALSE;
	m_editvehno		= _T("");
	m_editcmpno		= _T("");
	m_editcnfno		= _T("");
	m_editdevspd	= _T("");
	m_editcmpspd	= _T("");
	m_editcntang	= _T("");
	m_editcntloc1	= _T("");
	m_editcntloc2	= _T("");
	//}}AFX_DATA_INIT
	
	m_curset = 0;
}

CCompConfPage::~CCompConfPage()
{
}

void CCompConfPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCompConfPage)
	DDX_Control(pDX, IDC_CONFLIST, m_conflist);
	DDX_Control(pDX, IDC_NEXTSET_BUTTON, m_nextsetbutton);
	DDX_Control(pDX, IDC_DELETE_BUTTON, m_deletebutton);
	DDX_Control(pDX, IDC_COMPCONF_CFNCOM, m_editcfncom);
//	DDV_MaxChars(pDX, m_cfncom, 70);
	DDX_Control(pDX, IDC_COMPCONF_CNTCOM, m_editcntcom);
//	DDV_MaxChars(pDX, m_cntcom, 70);
	DDX_Control(pDX, IDC_COMPCONF_CONFIG, m_editconfig);
	DDX_Control(pDX, IDC_COMPCONF_DEVCOM, m_editdevcom);
//	DDV_MaxChars(pDX, m_devcom, 70);
	DDX_Control(pDX, IDC_COMPCONF_TSTDEV, m_edittstdev);
	DDX_Check(pDX, IDC_RETAINDATA, m_retaindata);
	DDX_Control(pDX, IDC_COMPCONF_VEHNO, m_editvehno);
//	DDV_MinMaxDWord(pDX, m_vehno, 1, 2);
	DDX_Control(pDX, IDC_COMPCONF_CMPNO, m_editcmpno);
//	DDV_MinMaxDWord(pDX, m_cmpno, 1, 99);
	DDX_Control(pDX, IDC_COMPCONF_CNFNO, m_editcnfno);
//	DDV_MinMaxDWord(pDX, m_cnfno, 1, 999);
	DDX_Control(pDX, IDC_COMPCONF_DEVSPD, m_editdevspd);
//	DDV_MinMaxDouble(pDX, m_devspd, 1.e-004, 99999.);
	DDX_Control(pDX, IDC_COMPCONF_CMPSPD, m_editcmpspd);
//	DDV_MinMaxDouble(pDX, m_cmpspd, 1.e-004, 99999.);
	DDX_Control(pDX, IDC_COMPCONF_CNTANG, m_editcntang);
//	DDV_MinMaxDWord(pDX, m_cntang, 0, 359);
	DDX_Control(pDX, IDC_COMPCONF_CNTLOC1, m_editcntloc1);
//	DDV_MinMaxDWord(pDX, m_cntloc1, 0, 99999);
	DDX_Control(pDX, IDC_COMPCONF_CNTLOC2, m_editcntloc2);
//	DDV_MinMaxDWord(pDX, m_cntloc2, 0, 99999);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCompConfPage, CPropertyPage)
	//{{AFX_MSG_MAP(CCompConfPage)
	ON_BN_CLICKED(IDC_TSTDEVSEARCH, OnTstdevsearch)
	ON_BN_CLICKED(IDC_CONFIGSEARCH, OnConfigsearch)
	ON_BN_CLICKED(IDC_DELETE_BUTTON, OnDeleteButton)
	ON_BN_CLICKED(IDC_NEXTSET_BUTTON, OnNextsetButton)
	ON_LBN_SELCHANGE(IDC_CONFLIST, OnSelchangeConflist)
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTW, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTA, 0, 0xFFFF, OnToolTipNotify )
	ON_COMMAND(ID_HELP, OnHelpFinder)
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCompConfPage message handlers

BOOL CCompConfPage::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
	TOOLTIPTEXTA* pTTTA = (TOOLTIPTEXTA*)pNMHDR;
	TOOLTIPTEXTW* pTTTW = (TOOLTIPTEXTW*)pNMHDR;
	CString strTipText = "";
	UINT nID = pNMHDR->idFrom;
	if (pNMHDR->code == TTN_NEEDTEXTA && (pTTTA->uFlags & TTF_IDISHWND) ||
		pNMHDR->code == TTN_NEEDTEXTW && (pTTTW->uFlags & TTF_IDISHWND))
	{
		// idFrom is actually the HWND of the tool
		nID = ::GetDlgCtrlID((HWND)nID);
	}

	if (nID != 0) // will be zero on a separator
	{
		strTipText.Format("Control ID = %d", nID);
		switch (nID)
			{
			case IDC_DELETE_BUTTON:
				strTipText = "Delete Configuration Info Set";
				break;
			case IDC_NEXTSET_BUTTON:
				strTipText = "Advance to Next Configuration Info Set";
				break;
			case IDC_COMPCONF_CNTANG:
				strTipText = "Degrees";
				break;
			case IDC_COMPCONF_DEVSPD:
				strTipText = "km/hr (0.0->99999.9999)";
				break;
			case IDC_COMPCONF_CMPSPD:
				strTipText = "km/hr (0.0001->99999.9999)";
				break;
			case IDC_COMPCONF_VEHNO:
				strTipText = "1->2";
				break;
			case IDC_COMPCONF_CMPNO:
				strTipText = "1->99";
				break;
			case IDC_COMPCONF_CNFNO:
				strTipText = "1->999";
				break;
			case IDC_COMPCONF_CNTLOC1:
				strTipText = "0->99999";
				break;
			case IDC_COMPCONF_CNTLOC2:
				strTipText = "0->99999";
				break;
			default:
				strTipText = "";
			}
	}

	if (pNMHDR->code == TTN_NEEDTEXTA)
		lstrcpyn(pTTTA->szText, strTipText, sizeof(pTTTA->szText));
	else
		::MultiByteToWideChar( CP_ACP , 0, strTipText, -1, pTTTW->szText, sizeof(pTTTW->szText) );
	*pResult = 0;

	return TRUE;    // message was handled
}

BOOL CCompConfPage::OnKillActive() 
{
	if( ValidateConfPage() == true )
	{
		LoadCompConfData();

		int nOldCurIndx = m_curset;
		for (m_curset=1; m_curset<m_settot+1; m_curset++)
		{
			DisplayCompConfData();
			if (!ValidateConfPage()) { return false; }
		}
		m_curset = nOldCurIndx;

		DisplayCompConfData();

		return CPropertyPage::OnKillActive();
	}
	else
	{
		// Error are found on AnthPage.
		return FALSE;
	}
}

BOOL CCompConfPage::OnSetActive() 
{
	m_settot=max(m_pCompData->m_confsets , 0) ; //initialize total curves.

	SetBusinessRules();

	DisplayCompConfData();

	ValidateConfPage();
	
	return CPropertyPage::OnSetActive();
}

BOOL CCompConfPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	EnableToolTips();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCompConfPage::OnTstdevsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"TSTDEV","COMDB");
	if (search.DoModal ()==IDOK)
	{
		m_edittstdev = search_code;
		m_edittstdev.SetValidateColor();
	}
	UpdateData(FALSE);
}

void CCompConfPage::OnConfigsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"CONFIG","COMDB");
	if (search.DoModal ()==IDOK)
	{
		m_editconfig = search_code;
		m_editconfig.SetValidateColor();
	}
	UpdateData(FALSE);
}

//  This function gets the data from the entry fields and puts it into 
//  m_pCompData.  It is called in OnKillActive, ExportData, record changed.
BOOL CCompConfPage::LoadCompConfData()
{
	if (m_hWnd==NULL) return TRUE;  // only return FALSE if data invalid
	if (!UpdateData()) return FALSE;

	m_pCompData->m_confsets = m_settot;

	//put data into m_pCompData
	m_pCompData->m_cnfcom[m_curset] = m_editcfncom.GetTextAsString();
	m_pCompData->m_Conf_cmpno[m_curset]  = m_editcmpno.GetTextAsString();
	m_pCompData->m_cmpspd[m_curset] = m_editcmpspd.GetTextAsString();
	m_pCompData->m_cnfno[m_curset]  = m_editcnfno.GetTextAsString();
	m_pCompData->m_cntang[m_curset] = m_editcntang.GetTextAsString();
	m_pCompData->m_cntcom[m_curset] = m_editcntcom.GetTextAsString();
	m_pCompData->m_cntloc1[m_curset]= m_editcntloc1.GetTextAsString();
	m_pCompData->m_cntloc2[m_curset]= m_editcntloc2.GetTextAsString();
	m_pCompData->m_config[m_curset] = m_editconfig.GetTextAsString();
	m_pCompData->m_devcom[m_curset] = m_editdevcom.GetTextAsString();
	m_pCompData->m_devspd[m_curset] = m_editdevspd.GetTextAsString();
	m_pCompData->m_tstdev[m_curset] = m_edittstdev.GetTextAsString();
	m_pCompData->m_Conf_vehno[m_curset]  = m_editvehno.GetTextAsString();

	return TRUE;

}

// wong code in 03/02/00
bool CCompConfPage::InsertCompConfData()
{
	if (m_hWnd==NULL) return true;  // only return FALSE if data invalid
	
	UpdateData();
 
	m_pCompData->m_confsets = m_settot;

	//put data into m_pCompData
	m_pCompData->m_cnfcom.InsertAt( m_curset, m_editcfncom.GetTextAsString() );
	m_pCompData->m_Conf_cmpno.InsertAt( m_curset, m_editcmpno.GetTextAsString() );
	m_pCompData->m_cmpspd.InsertAt( m_curset, m_editcmpspd.GetTextAsString() );
	m_pCompData->m_cnfno.InsertAt( m_curset, m_editcnfno.GetTextAsString() );
	m_pCompData->m_cntang.InsertAt( m_curset, m_editcntang.GetTextAsString() );
	m_pCompData->m_cntcom.InsertAt( m_curset, m_editcntcom.GetTextAsString() );
	m_pCompData->m_cntloc1.InsertAt( m_curset, m_editcntloc1.GetTextAsString() );
	m_pCompData->m_cntloc2.InsertAt( m_curset, m_editcntloc2.GetTextAsString() );
	m_pCompData->m_config.InsertAt( m_curset, m_editconfig.GetTextAsString() );
	m_pCompData->m_devcom.InsertAt( m_curset, m_editdevcom.GetTextAsString() );
	m_pCompData->m_devspd.InsertAt( m_curset, m_editdevspd.GetTextAsString() );
	m_pCompData->m_tstdev.InsertAt( m_curset, m_edittstdev.GetTextAsString() );
	m_pCompData->m_Conf_vehno.InsertAt( m_curset, m_editvehno.GetTextAsString() );

	UpdateData(false);

	return true;
}	// InsertCompCompData

//Get data from m_pCompData and display it.
void CCompConfPage::DisplayCompConfData()
{
	if (m_hWnd==NULL) return;

	UpdateCurveListbox();

	UpdateData();
	m_editcfncom = m_pCompData->m_cnfcom[m_curset];	
	m_editcmpno = m_pCompData->m_Conf_cmpno[m_curset];
	m_editcmpspd = m_pCompData->m_cmpspd [m_curset];
	m_editcnfno = m_pCompData->m_cnfno[m_curset];
	m_editcntang = m_pCompData->m_cntang[m_curset];

	m_editcntcom = m_pCompData->m_cntcom[m_curset];	
	m_editcntloc1 = m_pCompData->m_cntloc1[m_curset];
	m_editcntloc2 = m_pCompData->m_cntloc2[m_curset];
	m_editconfig = m_pCompData->m_config[m_curset];
	m_editdevcom = m_pCompData->m_devcom[m_curset];

	m_editdevspd = m_pCompData->m_devspd [m_curset];
	m_edittstdev = m_pCompData->m_tstdev[m_curset];	
	m_editvehno = m_pCompData->m_Conf_vehno[m_curset];
	
	CCodeValidation( m_edittstdev, "TSTDEV","COMDB" );
	CCodeValidation( m_editconfig, "CONFIG","COMDB" );

	UpdateData(false);
}

void CCompConfPage::OnDeleteButton() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	if (m_curset==0) { return;  }

	m_settot--;
	// Remove the data from all of the arrays.
	m_pCompData->m_cnfcom.RemoveAt(m_curset);
	m_pCompData->m_Conf_cmpno.RemoveAt(m_curset);
	m_pCompData->m_cmpspd.RemoveAt(m_curset);
	m_pCompData->m_cnfno.RemoveAt(m_curset);
	m_pCompData->m_cntang.RemoveAt(m_curset);
	m_pCompData->m_cntcom.RemoveAt(m_curset);
	m_pCompData->m_cntloc1.RemoveAt(m_curset);
	m_pCompData->m_cntloc2.RemoveAt(m_curset);
	m_pCompData->m_config.RemoveAt(m_curset);
	m_pCompData->m_devcom.RemoveAt(m_curset);
	m_pCompData->m_devspd.RemoveAt(m_curset);
	m_pCompData->m_tstdev.RemoveAt(m_curset);
	m_pCompData->m_Conf_vehno.RemoveAt(m_curset);

	m_curset--;

	//if m_curset == 0 now, and there are remaining curves, set curve 1 as active (m_curset=1)
	if (m_curset==0 && m_settot>0)
	{
		m_curset = 1;
	}
	
	DisplayCompConfData();  //display previous set, if existing
	
}
void CCompConfPage::OnNextsetButton() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	if (m_curset==m_settot) //if at end, increase # of curves
	{
		if (m_curset!=0) { LoadCompConfData(); }
		m_settot++; 
		m_curset++;
		InitializeNextSet();
	} 
	else if (m_curset != 0) 
	{
		if(!LoadCompConfData())
		{
			MessageBox("Error: see CCompConfPage::OnNextcurveButton()");
			return;
		}
		m_curset++;
	}

	DisplayCompConfData();
	ValidateConfPage( );
/***
	bool newset=false;

	if (m_curset==m_settot) //if at end, increase # of sets
	{
//		m_settot++;  	// wong corrected in 03/02/00
		newset=true;
	}   

	if (m_curset != 0) 
	{
//		if(!LoadCompConfData()) //load current info into m_pCompData(not zeroth set)
		if(!InsertCompConfData())	// wong added in 03/02/00
		{
			if (newset) m_settot--;
			return;
		}
	}

	m_curset++;             //goto next set
	m_settot++;	// wong added in 03/02/00

	if (newset) InitializeNextSet();

	DisplayCompConfData();  //display next set, if existing
	ValidateConfPage( );
**/
}

// new set, expand arrays in m_pCompData to hold info
void CCompConfPage::InitializeNextSet()
{
// *******************************************
//These temp variables are used because the reference that [] returns is invalid when SetAtGrow
// happens, because SetAtGrow (sometimes) moves the array to a different location in memory.   
// If you try to use that reference directly, you will get an access violation.
// For Example:  m_pCompData->m_inscom.SetAtGrow (m_icurno,m_pCompData->inscom[m_icurno-1]); //BAD!!!!
	CString strtemp; 
	CString   dwtemp;    
	CString  dbltemp;
// *******************************************

	if (m_retaindata)
	{
		strtemp = m_pCompData->m_cnfcom[m_curset-1];
		m_pCompData->m_cnfcom.SetAtGrow(m_curset,strtemp);

		dwtemp = m_pCompData->m_Conf_cmpno[m_curset - 1];
		m_pCompData->m_Conf_cmpno.SetAtGrow(m_curset,dwtemp);

		dbltemp = m_pCompData->m_cmpspd[m_curset - 1];
		m_pCompData->m_cmpspd.SetAtGrow(m_curset,dbltemp);

		dwtemp = m_pCompData->m_cnfno[m_curset -1];
		m_pCompData->m_cnfno.SetAtGrow(m_curset,dwtemp);

		dwtemp = m_pCompData->m_cntang[m_curset -1];
		m_pCompData->m_cntang.SetAtGrow(m_curset,dwtemp);

		strtemp = m_pCompData->m_cntcom[m_curset-1];
		m_pCompData->m_cntcom.SetAtGrow(m_curset,strtemp);

		dwtemp = m_pCompData->m_cntloc1[m_curset -1];
		m_pCompData->m_cntloc1.SetAtGrow(m_curset,dwtemp);

		dwtemp = m_pCompData->m_cntloc2[m_curset -1];
		m_pCompData->m_cntloc2.SetAtGrow(m_curset,dwtemp);

		strtemp = m_pCompData->m_config[m_curset -1];
		m_pCompData->m_config.SetAtGrow(m_curset,strtemp);

		strtemp = m_pCompData->m_devcom[m_curset -1];
		m_pCompData->m_devcom.SetAtGrow(m_curset,strtemp);

		dbltemp = m_pCompData->m_devspd[m_curset-1];
		m_pCompData->m_devspd.SetAtGrow(m_curset,dbltemp);

		strtemp = m_pCompData->m_tstdev[m_curset -1];
		m_pCompData->m_tstdev.SetAtGrow(m_curset,strtemp);

		dwtemp = m_pCompData->m_Conf_vehno[m_curset -1];
		m_pCompData->m_Conf_vehno.SetAtGrow(m_curset,dwtemp);

	}
	else
	{
		m_pCompData->m_cnfcom.SetAtGrow(m_curset,"");
		m_pCompData->m_Conf_cmpno.SetAtGrow(m_curset,"");
		m_pCompData->m_cmpspd.SetAtGrow(m_curset,"");
		m_pCompData->m_cnfno.SetAtGrow(m_curset,"");
		m_pCompData->m_cntang.SetAtGrow(m_curset,"");
		m_pCompData->m_cntcom.SetAtGrow(m_curset,"");
		m_pCompData->m_cntloc1.SetAtGrow(m_curset,"");
		m_pCompData->m_cntloc2.SetAtGrow(m_curset,"");
		m_pCompData->m_config.SetAtGrow(m_curset,"");
		m_pCompData->m_devcom.SetAtGrow(m_curset,"");
		m_pCompData->m_devspd.SetAtGrow(m_curset,"");
		m_pCompData->m_tstdev.SetAtGrow(m_curset,"");
		m_pCompData->m_Conf_vehno.SetAtGrow(m_curset,"");
	}

}

void CCompConfPage::UpdateCurveListbox()
{
	if (m_conflist.GetCount()!=m_settot)
	{
		m_conflist.ResetContent();
		char crvbuf [10];
		for (int loop=1;loop <= m_settot;loop++)
		{
			itoa(loop,crvbuf,10);
			if (m_conflist.FindString (-1,crvbuf)==LB_ERR)  //if buf isnt there already.
			{
				m_conflist.AddString(crvbuf);
			}
		}
	}

	m_conflist.SetCurSel (max(0,m_curset-1));  // select current curve, zero based.
	
}

// user clicked the curves listbox, so change to that curve
void CCompConfPage::OnSelchangeConflist() 
{
	int nCurve = m_conflist.GetCurSel ();  //zero based

	if (m_curset != 0) 
	{
		BOOL success = LoadCompConfData();     //load current info (not zeroth curve)
		if (!success) //Data not valid, dont change curves.
		{
			m_conflist.SetCurSel (max(0,m_curset-1));  // select current curve, zero based.
			return;
		}
	}

	m_curset= nCurve+1;             //goto current curve 

	DisplayCompConfData();  //display next set, if existing	
	ValidateConfPage( );
}

BOOL CCompConfPage::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	WinHelp(Test_Configuration);
	
	return TRUE;
}

// new  added
//
bool CCompConfPage::ValidateConfPage( )
{
	const int nTotal = 13;
	bool bRetArray[nTotal];

	bRetArray[0] = m_editcfncom.GetValidate();
	bRetArray[1] = m_editcntcom.GetValidate();
	bRetArray[2] = m_editdevcom.GetValidate();
	bRetArray[3] = m_editvehno.GetValidate();
	bRetArray[4] = m_editcmpno.GetValidate();
	bRetArray[5] = m_editcnfno.GetValidate();
	bRetArray[6] = m_editdevspd.GetValidate();
	bRetArray[7] = m_editcmpspd.GetValidate();
	bRetArray[8] = m_editcntang.GetValidate(); 
	bRetArray[9] = m_editcntloc1.GetValidate();
	bRetArray[10] = m_editcntloc2.GetValidate();

	bRetArray[11]	= m_edittstdev.GetValidate();
	bRetArray[12]	= m_editconfig.GetValidate();

	for(int i=0; i<nTotal; i++) { if (!bRetArray[i]) return false; }
	return true;
}	// ValidateAnthPage

void CCompConfPage::SetBusinessRules( )
{
	 m_editcfncom.SetString( 0, 70);
	 m_editcntcom.SetString( 0, 70);
	 m_editdevcom.SetString( 0, 70);
	 m_editvehno.SetDouble( 1, 2);
	 m_editcmpno.SetDouble( 1, 99);
	 m_editcnfno.SetDouble( 1, 999);
	 m_editdevspd.SetDouble( 0, 99999.);
	 m_editcmpspd.SetDouble( 1.e-004, 99999.);
	 m_editcntang.SetDouble( 0, 359);
	 m_editcntloc1.SetDouble( 0, 99999);
	 m_editcntloc2.SetDouble( 0, 99999);
}	// SetBusinessRules