// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: CompData.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description:  CompData constructors and member functions to
//               process, import and export data.
//
//  Date		Who			Description
//	2000    Y. Wong Adding business rules, recode all edit boxs
//					and correct other errors.
// -----------------------------------------
#include "stdafx.h"
#include "entreeV5.h"
#include "CompData.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCompData::CCompData()
{
	//Member Initialization
	//Test Info Data
	m_verno="C5";
	m_title="";
	m_tstobj="";
	m_tstdat="";
	m_tstprf="";
	m_conno="";
	m_tstref="";
	m_tsttyp="";
	m_temp="";
	m_totcrv=0;
	m_tstcom="";
	//Vehicle Info Data - arrays for multiple vehicles- currently only 2 allowed.*****
	m_vehno=0; //number of vehicles, also used as array index
	m_make.SetSize (3); m_make.SetAtGrow(0,""); m_make.SetAtGrow(1,""); m_make.SetAtGrow(2,"");
	m_model.SetSize (3); m_model.SetAtGrow (0,""); m_model.SetAtGrow (1,""); m_model.SetAtGrow (2,"");
	m_year.SetSize (3); m_year.SetAtGrow (0,"2000"); m_year.SetAtGrow (1,""); m_year.SetAtGrow (2,"2000");
	m_nhtsano.SetSize (3); m_nhtsano.SetAtGrow (0,"");m_nhtsano.SetAtGrow (1,"");m_nhtsano.SetAtGrow (2,"");
	m_body.SetSize (3); m_body.SetAtGrow (0,"");m_body.SetAtGrow (1,"");m_body.SetAtGrow (2,"");
	m_vin.SetSize (3); m_vin.SetAtGrow (0,"");m_vin.SetAtGrow (1,"");m_vin.SetAtGrow (2,"");
	m_crtest.SetSize (3);m_crtest.SetAtGrow (0,"");m_crtest.SetAtGrow (1,"");m_crtest.SetAtGrow (2,"");
	m_vehcom.SetSize (3);m_vehcom.SetAtGrow (0,"");m_vehcom.SetAtGrow (1,"");m_vehcom.SetAtGrow (2,"");
	// Component Info Data
	m_compsets = 0;
	m_Comp_vehno.SetAtGrow (0,""); m_Comp_vehno.SetAtGrow (1,"");
	m_cmpno.SetAtGrow (0,""); m_cmpno.SetAtGrow (1,"");
	m_cmpnt.SetAtGrow (0,"");m_cmpnt.SetAtGrow (1,"");
	m_cmptyp.SetAtGrow (0,"");m_cmptyp.SetAtGrow (1,"");
	m_cmpwgt.SetAtGrow (0,"");m_cmpwgt.SetAtGrow (1,"");
	m_modind.SetAtGrow (0,"");m_modind.SetAtGrow (1,"");
	m_moddsc.SetAtGrow (0,"");m_moddsc.SetAtGrow (1,"");
	m_occtyp.SetAtGrow (0,"");m_occtyp.SetAtGrow (1,"");
	m_dumsiz.SetAtGrow (0,"");m_dumsiz.SetAtGrow (1,"");
	m_dumman.SetAtGrow (0,"");m_dumman.SetAtGrow (1,"");
	m_cmpcom.SetAtGrow (0,"");m_cmpcom.SetAtGrow (1,"");
	// Configuration Info data;
	m_confsets = 0;
	m_Conf_vehno.SetAtGrow (0,""); m_Conf_vehno.SetAtGrow (1,"");
	m_Conf_cmpno.SetAtGrow (0,"");m_Conf_cmpno.SetAtGrow (1,"");
	m_cnfno.SetAtGrow (0,"");m_cnfno.SetAtGrow (1,"");
	m_tstdev.SetAtGrow (0,"");m_tstdev.SetAtGrow (1,"");
	m_devspd.SetAtGrow (0,"");m_devspd.SetAtGrow (1,"");
	m_devcom.SetAtGrow (0,"");m_devcom.SetAtGrow (1,"");
	m_config.SetAtGrow (0,"");m_config.SetAtGrow (1,"");
	m_cmpspd.SetAtGrow (0,"");m_cmpspd.SetAtGrow (1,"");
	m_cntang.SetAtGrow (0,"");m_cntang.SetAtGrow (1,"");
	m_cntloc1.SetAtGrow (0,"");m_cntloc1.SetAtGrow (1,"");
	m_cntloc2.SetAtGrow (0,"");m_cntloc2.SetAtGrow (1,"");
	m_cntcom.SetAtGrow (0,"");m_cntcom.SetAtGrow (1,"");
	m_cnfcom.SetAtGrow (0,"");m_cnfcom.SetAtGrow (1,"");
	//Instrument Info Data
	m_Inst_vehno.SetAtGrow (0,"");m_Inst_vehno.SetAtGrow (1,"");
	m_Inst_cmpno.SetAtGrow (0,"");m_Inst_cmpno.SetAtGrow (1,"");
	m_Inst_cnfno.SetAtGrow (0,"");m_Inst_cnfno.SetAtGrow (1,"");
	m_curno=0;  //number of curves, also used as array index
	m_sentyp.SetAtGrow (0,"");m_sentyp.SetAtGrow (1,"");
	m_senatt.SetAtGrow (0,"");m_senatt.SetAtGrow (1,"");
	m_axis.SetAtGrow (0,"");m_axis.SetAtGrow (1,"");
	m_xunits.SetAtGrow (0,"SEC");m_xunits.SetAtGrow (1,"SEC");
	m_yunits.SetAtGrow (0,"");m_yunits.SetAtGrow (1,"");
	m_prefil.SetAtGrow (0,"");m_prefil.SetAtGrow (1,"");
	m_insman.SetAtGrow (0,"");m_insman.SetAtGrow (1,"");
	m_caldat.SetAtGrow (0,"");m_caldat.SetAtGrow (1,"");
	m_insrat.SetAtGrow (0,"");m_insrat.SetAtGrow (1,"");
	m_chlmax.SetAtGrow (0,"");m_chlmax.SetAtGrow (1,"");
	m_inivel.SetAtGrow (0,"");m_inivel.SetAtGrow (1,"");
	m_nfp.SetAtGrow (0,"");m_nfp.SetAtGrow (1,"");
	m_nlp.SetAtGrow (0,"");m_nlp.SetAtGrow (1,"");
	m_delt.SetAtGrow (0,"");m_delt.SetAtGrow (1,"");
	m_dastat.SetAtGrow (0,"");m_dastat.SetAtGrow (1,"");
	m_chstat.SetAtGrow (0,"");m_chstat.SetAtGrow (1,"");
	m_inscom.SetAtGrow (0,"");m_inscom.SetAtGrow (1,"");

}

CCompData::~CCompData()
{

}

//Test Info Data
bool CCompData::ValidateCompTestData()
{
	if ( (m_verno=="C5") && (m_title=="") && (m_tstobj=="") && (m_tstdat=="") &&
		 (m_tstprf=="") && (m_conno=="") && (m_tstref=="") && (m_tsttyp=="") &&
		 (m_temp=="") && (m_totcrv==0) && (m_tstcom=="") ) { return false; }

	return true;
}	// ValidateCompTestData

//Vehicle Info Data - arrays for multiple vehicles- currently only 2 allowed.*****
bool CCompData::ValidateCompVehData()
{
	if (m_vehno>0) { return true; }
	return false;
}	// 

// Component Info Data
bool CCompData::ValidateCompCompData()
{
	if (m_compsets > 0) { return true; }
	return false;
} // 

// Configuration Info data;
bool CCompData::ValidateCompConfData()
{
	if (m_confsets > 0) { return true; }
	return false;
}	// 

//Instrument Info Data
bool CCompData::ValidateCompInstData()
{
	if (m_totcrv>0) { return true; }
	return false;
}	// 

//******************
// ExportEV5 
// This function creates a .ev5 file and writes the data in CompData out to it. 
// *****************
BOOL CCompData::ExportEV5(CString & strfile_out)
{
    CStdioFile myFile;
	CFileException fileException;

	myFile.Open( strfile_out, CFile::modeCreate | CFile::modeReadWrite | CFile::typeText,
		&fileException );
	if (!myFile.m_pStream)  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_out, fileException.m_cause );
		MessageBox(NULL,msg,"Error",MB_OK);
		return FALSE;
	}
		
	CTime now = CTime::GetCurrentTime ();
	myFile.WriteString ("# Source: Entree for Windows v5\n");
	CString strToday;
	strToday.Format("# Date: <%d/%d/%d>\n", now.GetMonth(), now.GetDay(), now.GetYear() );
	myFile.WriteString (strToday);
	myFile.WriteString ("----- EV5 -----\n");

	WriteCompTest (myFile);
	WriteCompVeh  (myFile);
	WriteCompComp (myFile);
	WriteCompConf (myFile);
	WriteCompInst (myFile);

	myFile.WriteString ("----- END -----\n");

	myFile.Close ();
	
	return TRUE;
}

CString CCompData::OutString(CString str)
{
	if (str=="")
	{
		str=" |";
	}
	else
	{
		str+= "|";
	}
	
	return str;
}

void CCompData::WriteCompTest(CStdioFile & myFile)
{
	if (!ValidateCompTestData()) { return; }

	myFile.WriteString ("----- TEST -----\n");
	
	char temp [100];	
	myFile.WriteString (OutString("C5")); // myFile.WriteString (OutString(m_verno));
	myFile.WriteString (OutString(m_title));	
	myFile.WriteString (OutString(m_tstobj));
	m_tstdat.MakeUpper();
	myFile.WriteString (OutString(m_tstdat));

	myFile.WriteString (OutString(m_tstprf));	
	myFile.WriteString (OutString(m_conno));	
	myFile.WriteString (OutString(m_tstref));		
	myFile.WriteString (OutString(m_tsttyp));
	myFile.WriteString (OutString(m_temp));

	itoa(m_totcrv,temp,10);
	myFile.WriteString (OutString(temp));
	
	myFile.WriteString (m_tstcom + '\n');
}

void CCompData::WriteCompVeh(CStdioFile & myFile)
{
	if (!ValidateCompVehData()) { return; }

	myFile.WriteString ("----- VEHICLE -----\n");

	char temp [100];
		
	for ( int loop=1; loop <= m_vehno ; loop++)  
	{
		
		itoa(loop,temp,10);
		myFile.WriteString (OutString(temp));
		myFile.WriteString (OutString(m_make[loop]));
		myFile.WriteString (OutString(m_model[loop]));
		myFile.WriteString (OutString(m_year[loop]));
		myFile.WriteString (OutString(m_nhtsano[loop]));

		myFile.WriteString (OutString(m_body[loop]));
		myFile.WriteString (OutString(m_vin[loop]));
		myFile.WriteString (OutString(m_crtest[loop]));
		myFile.WriteString (m_vehcom[loop] + '\n');
	}
		
}

void CCompData::WriteCompComp(CStdioFile & myFile)
{
	if (!ValidateCompCompData()) { return; }

	myFile.WriteString ("----- COMPONENT -----\n");

	for ( int loop=1; loop<=m_compsets ; loop++)  
	{
		myFile.WriteString (OutString(m_Comp_vehno[loop]));
		myFile.WriteString (OutString(m_cmpno[loop]));
		myFile.WriteString (OutString(m_cmpnt[loop]));
		myFile.WriteString (OutString(m_cmptyp[loop]));
		myFile.WriteString (OutString(m_cmpwgt[loop]));

		myFile.WriteString (OutString(m_modind[loop]));
		myFile.WriteString (OutString(m_moddsc[loop]));
		myFile.WriteString (OutString(m_occtyp[loop]));
		myFile.WriteString (OutString(m_dumsiz[loop]));
		myFile.WriteString (OutString(m_dumman[loop]));

		myFile.WriteString (m_cmpcom[loop] + '\n');   
	}
}


void CCompData::WriteCompConf(CStdioFile & myFile)
{
	if (!ValidateCompConfData()) { return; }

	myFile.WriteString ("----- CONFIGURATION -----\n");

	for ( int loop=1; loop<=m_confsets; loop++)  
	{
		myFile.WriteString (OutString(m_Conf_vehno[loop]));
		myFile.WriteString (OutString(m_Conf_cmpno[loop]));
		myFile.WriteString (OutString(m_cnfno[loop]));
		myFile.WriteString (OutString(m_tstdev[loop]));
		myFile.WriteString (OutString(m_devspd[loop]));

		myFile.WriteString (OutString(m_devcom[loop]));
		myFile.WriteString (OutString(m_config[loop]));
		myFile.WriteString (OutString(m_cmpspd[loop]));
		myFile.WriteString (OutString(m_cntang[loop]));
		myFile.WriteString (OutString(m_cntloc1[loop]));

		myFile.WriteString (OutString(m_cntloc2[loop]));
		myFile.WriteString (OutString(m_cntcom[loop]));
		myFile.WriteString (m_cnfcom[loop] + '\n');											
	}
}

void CCompData::WriteCompInst(CStdioFile & myFile)
{
	if (!ValidateCompInstData()) { return; }

	myFile.WriteString("----- INSTRUMENTATION -----\n");

	char temp [100];

	for (int loop=1; loop<=m_curno; loop++)  
	{
	
		myFile.WriteString (OutString(m_Inst_vehno[loop]));
		myFile.WriteString (OutString(m_Inst_cmpno[loop]));
		myFile.WriteString (OutString(m_Inst_cnfno[loop]));
		itoa(loop,temp,10);
		myFile.WriteString (OutString(temp));		
		myFile.WriteString (OutString(m_sentyp[loop]));

		myFile.WriteString (OutString(m_senatt[loop]));
		myFile.WriteString (OutString(m_axis[loop]));
		myFile.WriteString (OutString(m_xunits[loop]));
		myFile.WriteString (OutString(m_yunits[loop]));
		myFile.WriteString (OutString(m_prefil[loop]));

		myFile.WriteString (OutString(m_insman[loop]));
		myFile.WriteString (OutString(m_caldat[loop]));
		myFile.WriteString (OutString(m_insrat[loop]));
		myFile.WriteString (OutString(m_chlmax[loop]));
		myFile.WriteString (OutString(m_inivel[loop]));

		myFile.WriteString (OutString(m_nfp[loop]));
		myFile.WriteString (OutString(m_nlp[loop]));
		myFile.WriteString (OutString(m_delt[loop]));
		myFile.WriteString (OutString(m_dastat[loop]));
		myFile.WriteString (OutString(m_chstat[loop]));

		myFile.WriteString (m_inscom[loop] + '\n');// inscom is last string, so dont
											// use OutString to append |, instead
											// append \n		
	}
}

//***************************************
//Create a Report (.evr) from the current CompData
//
//***************************************
BOOL CCompData::ExportEVR(CString & strfile_out)
{
	
	CStdioFile myFile;
	CFileException fileException;

	myFile.Open( strfile_out, CFile::modeCreate | CFile::modeReadWrite | CFile::typeText,
		&fileException );
	if (!myFile.m_pStream)  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_out, fileException.m_cause );
		MessageBox(NULL,msg,"Error",MB_OK);
		return FALSE;
	}
	
	CTime now = CTime::GetCurrentTime ();
	myFile.WriteString ("# Source: Entree for Windows v5\n");
	CString strToday;
	strToday.Format("# Date: <%d/%d/%d>\n", now.GetMonth(), now.GetDay(), now.GetYear() );
	myFile.WriteString (strToday);
	myFile.WriteString ("----- EV5 REPORT FILE -----\n");

	WriteCompTestReport (myFile);
	WriteCompCompReport (myFile);
	WriteCompConfReport (myFile);
	WriteCompVehReport (myFile);
	WriteCompInstReport (myFile);

	myFile.WriteString ("----- END -----\n");

	myFile.Close ();

	return TRUE;

}

// Write CompTest part of a report (evr) file
void CCompData::WriteCompTestReport(CStdioFile & myFile)
{
	if (!ValidateCompTestData()) { return; }

	myFile.WriteString ("----- TEST -----\n");
	
	char temp [100];
	
	myFile.WriteString ("Version Number:	"+m_verno+"\n");
	myFile.WriteString ("Test Title:	"+m_title+"\n");	
	myFile.WriteString ("Test Objectives:	"+m_tstobj+"\n");
	m_tstdat.MakeUpper();
	myFile.WriteString ("Test Date:	"+m_tstdat+"\n");

	myFile.WriteString ("Test Performer:	"+m_tstprf+"\n");	
	myFile.WriteString ("Contract Number:	"+m_conno+"\n");	
	myFile.WriteString ("Test Reference Number:	"+m_tstref+"\n");
	
	myFile.WriteString ("Test Type:	"+m_tsttyp+"\n");

//	itoa(m_temp,temp,10);
//	CString strTemp=temp;
	myFile.WriteString ("Ambient Temperature:	"+m_temp+"\n");

	myFile.WriteString ("Test Comments:	"+m_tstcom + '\n'); 

	itoa(m_totcrv,temp,10);
	CString strTemp=temp;
	myFile.WriteString ("Total Number of Curves:	"+strTemp+"\n");		
}

// write CompComp part of a report(evr) file.
void CCompData::WriteCompCompReport(CStdioFile & myFile)
{
	if (!ValidateCompCompData()) { return; }

	myFile.WriteString ("----- COMPONENT -----\n");

	for ( int loop=1; loop<=m_compsets ; loop++)  
	{		
		if (m_compsets>1)
		{
			char temp [100];
			CString strTemp;
			itoa (loop,temp,10);
			strTemp=temp;
			myFile.WriteString ("Record "+strTemp+":\n");
		}

		myFile.WriteString ("Component Number:	"+m_cmpno[loop]+"\n");
		myFile.WriteString ("Component Tested:	"+m_cmpnt[loop]+"\n");
		myFile.WriteString ("Component Type:	"+m_cmptyp[loop]+"\n");
		myFile.WriteString ("Component Weight:	"+m_cmpwgt[loop]+ "\n");
		myFile.WriteString ("Component Modification Indicator:	"+m_modind[loop]+"\n");

		myFile.WriteString ("Modification Description:	"+m_moddsc[loop]+"\n");
		myFile.WriteString ("Occupant Type:	"+m_occtyp[loop]+"\n");
		myFile.WriteString ("Dummy Size Percentile:	"+m_dumsiz[loop]+"\n");
		myFile.WriteString ("Dummy Manufacturer:	"+m_dumman[loop]+"\n");
		myFile.WriteString ("Component Comments:	"+m_cmpcom[loop]+"\n");   
	}
}

// Write CompConf part of a report (evr) file.
void CCompData::WriteCompConfReport(CStdioFile & myFile)
{
	if (!ValidateCompConfData()) { return; }

	myFile.WriteString ("----- CONFIGURATION -----\n");

	for ( int loop=1; loop<=m_confsets; loop++)  
	{
		if (m_confsets>1)
		{
			char temp [100];
			CString strTemp;
			itoa (loop,temp,10);
			strTemp=temp;
			myFile.WriteString ("Record "+strTemp+":\n");
		}

		myFile.WriteString ("Component Number:	"+m_Conf_cmpno[loop]+"\n");
		myFile.WriteString ("Configuration Number:	"+m_cnfno[loop]+"\n");
		myFile.WriteString ("Test Device:	"+m_tstdev[loop] +"\n");
		myFile.WriteString ("Device Speed:	"+m_devspd[loop]+"\n");
		myFile.WriteString ("Device Comments:	"+m_devcom[loop] +"\n");

		myFile.WriteString ("Test Configuration:	"+m_config[loop]+"\n");
		myFile.WriteString ("Component Speed:	"+m_cmpspd[loop]+"\n");
		myFile.WriteString ("Contact Angle:	"+m_cntang[loop]+"\n");
		myFile.WriteString ("Contact Location 1:	"+m_cntloc1[loop]+"\n");
		myFile.WriteString ("Contract Location2:	"+m_cntloc2[loop]+"\n");

		myFile.WriteString ("Contact Commentary:	"+m_cntcom[loop]+"\n");
		myFile.WriteString ("Configuration Commentary:	"+m_cnfcom[loop] + "\n");
										
	}
}

// write CompVeh part of report (evr) file.
void CCompData::WriteCompVehReport(CStdioFile & myFile)
{
	if (!ValidateCompVehData()) { return; }

	myFile.WriteString ("----- VEHICLE -----\n");
		
	for ( int loop=1; loop <= m_vehno ; loop++)  
	{
		if (m_vehno>1)
		{
			char temp [100];
			CString strTemp;
			itoa (loop,temp,10);
			strTemp=temp;
			myFile.WriteString ("Record "+strTemp+":\n");
		}

		myFile.WriteString ("Vehicle Make:	"+m_make[loop]+"\n");
		myFile.WriteString ("Vehicle Model:	"+m_model[loop]+"\n");
		myFile.WriteString ("Vehicle Model Year:	"+m_year[loop]+"\n");
		myFile.WriteString ("NHTSA Number:	"+m_nhtsano[loop]+"\n");
		myFile.WriteString ("Body Type:	"+m_body[loop]+"\n");

		myFile.WriteString ("Manufacturer VIN:	"+m_vin[loop]+"\n");
		myFile.WriteString ("Crash Tested Indicator:	"+m_crtest[loop]+"\n");
		myFile.WriteString ("Vehicle Comments:	"+m_vehcom[loop] + "\n");
	}
}

// write CompInst part of report (evr) file.
void CCompData::WriteCompInstReport(CStdioFile & myFile)
{
	if (!ValidateCompInstData()) { return; }

	myFile.WriteString("----- INSTRUMENTATION -----\n");

	for (int loop=1; loop<=m_curno; loop++)  
	{
		if (m_curno>1)
		{
			char temp [100];
			CString strTemp;
			itoa (loop,temp,10);
			strTemp=temp;
			myFile.WriteString ("Record "+strTemp+":\n");
		}

		myFile.WriteString ("Vehicle Number:	"+m_Inst_vehno[loop]+"\n");
		myFile.WriteString ("Component Number:	"+m_Inst_cmpno[loop]+"\n");
		myFile.WriteString ("Configuration Number:	"+m_Inst_cnfno[loop]+"\n");
		myFile.WriteString ("Sensor Type:	"+m_sentyp[loop]+"\n");		
		myFile.WriteString ("Sensor Attachment Location:	"+m_senatt[loop]+"\n");

		myFile.WriteString ("Axis:	"+m_axis[loop]+"\n");
		myFile.WriteString ("Xunits:	"+m_xunits[loop]+"\n");
		myFile.WriteString ("Yunits:	"+m_yunits[loop]+"\n");
		myFile.WriteString ("Prefilter Frequency:	"+m_prefil[loop]+"\n");
		myFile.WriteString ("Instrument Manufacturer:	"+m_insman[loop]+"\n");

		myFile.WriteString ("Calibration Date:	"+m_caldat[loop]+"\n");
		myFile.WriteString ("Instrument Rating:	"+m_insrat[loop]+"\n");
		myFile.WriteString ("Channel Maximum Rating:	"+m_chlmax[loop]+"\n");
		myFile.WriteString ("Initial Velocity:	"+m_inivel[loop]+"\n");
		myFile.WriteString ("Number of First Point:	"+m_nfp[loop]+"\n");

		myFile.WriteString ("Number of Last Point:	"+m_nlp[loop]+"\n");
		myFile.WriteString ("Time Step:	"+m_delt[loop]+"\n");
		myFile.WriteString ("Data Status:	"+m_dastat[loop]+"\n");
		myFile.WriteString ("Channel Status:	"+m_chstat[loop]+"\n");

		myFile.WriteString ("Instrument Comments:	"+m_inscom[loop] + "\n");
	}
}

// Open an EV5 file to read in the data
BOOL CCompData::ImportEV5(CString & strfile_in)
{
	CStdioFile myFile;
	CFileException fileException;

	myFile.Open( strfile_in, CFile::modeRead | CFile::typeText,
		&fileException );
	if (!myFile.m_pStream)  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_in, fileException.m_cause );
		MessageBox(NULL,msg,"Error",MB_OK);
		return FALSE;
	}

	return LoadCompEV5Data(myFile);

}

// Open an EV4 file to read in the data
BOOL CCompData::ImportEV4(CString & strfile_in)
{
	CStdioFile myFile;
	CFileException fileException;

	myFile.Open( strfile_in, CFile::modeRead | CFile::typeText,
		&fileException );
	if (!myFile.m_pStream)  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_in, fileException.m_cause );
		MessageBox(NULL,msg,"Error",MB_OK);
		return FALSE;
	}

	ExtractTestData(myFile, EV4);   // finds test section intelligently
	
	ExtractVehData (myFile, EV4); // finds vehicle section intelligently
	
	ExtractCompData(myFile, EV4);  // finds component section intelligently. 
	
	ExtractConfData(myFile, EV4);  // finds configuration section intelligently. 
	
	ExtractInstData (myFile, EV4);  // finds Instrumentation section intelligently. 
	
	return TRUE;
}

// put data from ev5 file in CCompData data members
BOOL CCompData::LoadCompEV5Data(CStdioFile & myFile)
{
	CString strLine;

	myFile.SeekToBegin ();  // back to beginning
	
	ExtractTestData(myFile, EV5);  // finds Test section intelligently

	ExtractVehData (myFile, EV5); // finds vehicle section intelligently
	
	ExtractCompData(myFile, EV5);  // finds component section intelligently. 
	
	ExtractConfData(myFile, EV5);  // finds configuration section intelligently. 
	
	ExtractInstData (myFile, EV5);  // finds Instrumentation section intelligently. 

	return TRUE;
}

// ExtractTestData()  *******************************************
// Looks for a TEST section in a Comp EV file.  If found, extracts the
// data and puts it into members of CCompData.
// ***
void CCompData::ExtractTestData(CStdioFile & myFile, int nVersion)
{
	CString strLine;
	myFile.SeekToBegin ();  // back to beginning

	// find ----- TEST -----
	int nRes = -1;
	while (myFile.ReadString (strLine))
	{
		nRes = strLine.Find("----- TEST -----");
		if (nRes != -1) break;
	}

	if (nRes == -1) return;  // TEST section not found
    // now read line after ----- TEST -----
	
	myFile.ReadString (strLine);	
	if ((strLine.GetLength ()) <1) return;  // don't process empty string

	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}

	int loc1 = strLine.Find ('|',0);

	if (loc1==-1)  return;  // | not found in line after ----- TEST -----,
					        // must be another section, so return.
	
	//10 pipes.EV5  12 EV4
	int nPipes = CountPipes(strLine);
	if (nVersion ==EV4)
	{
		//		if (nPipes!=12)	// wong note: there are 11 pipes in TEST INFORMATION -- see APPENDIX C: FIELD FORMATS, 02/24/00
		if ( (nPipes!=11)&&(nPipes!=12)	) // there may be 12 pipes in older ev4 document
		{
			char buf [10];
			itoa (nPipes,buf,10);
			CString strPipes = buf;
			CString strErr = "This EV4 file has "+strPipes +" | characters in the TEST section, should have 12.";
			MessageBox(NULL, strErr, "Error",MB_OK);
			return;
			
		}
	}
	else if (nVersion==EV5)
	{
		if (nPipes!=10)
		{
			char buf [10];
			itoa (nPipes,buf,10);
			CString strPipes = buf;
			CString strErr = "This EV5 file has "+strPipes +" | characters in the TEST section, should have 10.";
			MessageBox(NULL, strErr, "Error",MB_OK);
			return;
			
		}
	}
	
	if (nVersion==EV4)  //only skip one if EV4.  EV5 has no tstno.
	{
		m_verno = GetTextBetweenPipes(strLine, 1,2);
		m_title = GetTextBetweenPipes(strLine, 2,3);
		m_tstobj= GetTextBetweenPipes(strLine, 3,4);
		m_tstdat= GetTextBetweenPipes(strLine, 4,5);
		m_tstprf= GetTextBetweenPipes(strLine, 5,6);
		m_conno = GetTextBetweenPipes(strLine, 6,7);
		m_tstref= GetTextBetweenPipes(strLine, 7,8);
		m_tsttyp= GetTextBetweenPipes(strLine, 8,9);
//		m_temp  = atoi(GetTextBetweenPipes(strLine, 9,10));	// wong note, original

//		m_totcrv=atoi(GetTextBetweenPipes(strLine, 11,12));	// wong 11 -> 10, 02/24/00, original
//		m_tstcom = GetTextBetweenPipes(strLine, 12,13);	// wong 12 -> 11, 02/24/00, original
		
		if (nPipes==11)// wong updates at 02/24/00
		{
			m_temp  = GetTextBetweenPipes(strLine, 9,10);
			m_totcrv= atoi(GetTextBetweenPipes(strLine, 10,11));
			m_tstcom = GetTextBetweenPipes(strLine, 11,12);
		}
		else // if (nPipes==12)
		{
			//only skip one if EV4.  EV5 has no Impact Point.
			m_temp  = GetTextBetweenPipes(strLine, 10,11);
			m_totcrv= atoi(GetTextBetweenPipes(strLine, 11,12));
			m_tstcom = GetTextBetweenPipes(strLine, 12,13);
		}
		
	}
	else //EV5
	{
		m_verno = GetTextBetweenPipes(strLine, 0,1);
		m_title = GetTextBetweenPipes(strLine, 1,2);
		m_tstobj= GetTextBetweenPipes(strLine, 2,3);
		m_tstdat= GetTextBetweenPipes(strLine, 3,4);
		m_tstprf= GetTextBetweenPipes(strLine, 4,5);
		m_conno = GetTextBetweenPipes(strLine, 5,6);
		m_tstref= GetTextBetweenPipes(strLine, 6,7);
		m_tsttyp= GetTextBetweenPipes(strLine, 7,8);
		m_temp  = GetTextBetweenPipes(strLine, 8,9);
		m_totcrv= atoi(GetTextBetweenPipes(strLine, 9,10));
		m_tstcom = GetTextBetweenPipes(strLine, 10,11);
	}
	return;
}

// ******
// ExtractVehData
// This function finds and separates the Vehicle data in an .ev5 file if any,
// and fills in CCompData with that info.
// ******
void CCompData::ExtractVehData(CStdioFile & myFile, int nVersion)
{
	CString strLine;
	myFile.SeekToBegin ();  // back to beginning

	// find ----- VEHICLE -----
	int nRes = -1;
	while (myFile.ReadString (strLine))
	{
		nRes = strLine.Find("----- VEHICLE -----");
		if (nRes != -1) break;
	}

	if (nRes == -1) return;  // VEHICLE section not found

	// now read line after ----- VEHICLE -----
	myFile.ReadString (strLine);

	if ((strLine.GetLength ()) <1) 
	{
		return;  // don't process empty string
	}

	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}

	int loc1 = strLine.Find ('|',0);

	if (loc1==-1) 
	{
		return;      // | not found in line after ----- VEHICLE -----,
				     // must be another section, so return.
	}

	//8 pipes.EV5 and 9 EV4
	int nPipes = CountPipes(strLine);
	if (nVersion==EV4)
	{
		if (nPipes!= 9)
		{
			char buf [10];
			itoa (nPipes,buf,10);
			CString strPipes = buf;
			CString strErr = "This EV4 file has "+strPipes +" | characters in the VEHICLE section, should have 9.";
			MessageBox(NULL, strErr, "Error",MB_OK);
			return;
		}
	}
	else if (nVersion==EV5)
	{
		if (nPipes!= 8)
		{
			char buf [10];
			itoa (nPipes,buf,10);
			CString strPipes = buf;
			CString strErr = "This EV5 file has "+strPipes +" | characters in the VEHICLE section, should have 8.";
			MessageBox(NULL, strErr, "Error",MB_OK);
			return;
		}
	}
	
	if (nVersion==EV4)  // skip tstno if EV4
	{
		m_vehno = atoi(GetTextBetweenPipes(strLine, 1,2));
		m_make[1] = GetTextBetweenPipes(strLine, 2,3);
		m_model[1] = GetTextBetweenPipes(strLine, 3,4);
		m_year[1] = GetTextBetweenPipes(strLine, 4,5);
		if (m_year[1].GetLength()==2) { m_year[1] = "19" + m_year[1]; }
		m_nhtsano[1] = GetTextBetweenPipes(strLine, 5,6);
		m_body[1] = GetTextBetweenPipes(strLine, 6,7);
		m_vin[1] = GetTextBetweenPipes(strLine, 7,8);
		m_crtest[1] = GetTextBetweenPipes(strLine, 8,9);
		m_vehcom[1] = GetTextBetweenPipes(strLine, 9,10);
	}
	else  //skip nothing if EV5
	{
		m_vehno = atoi(GetTextBetweenPipes(strLine, 0,1));
		m_make[1] = GetTextBetweenPipes(strLine, 1,2);
		m_model[1] = GetTextBetweenPipes(strLine, 2,3);
		m_year[1] = GetTextBetweenPipes(strLine, 3,4);
		if (m_year[1].GetLength()==2) { m_year[1] = "19" + m_year[1]; }
		m_nhtsano[1] = GetTextBetweenPipes(strLine, 4,5);
		m_body[1] = GetTextBetweenPipes(strLine, 5,6);
		m_vin[1] = GetTextBetweenPipes(strLine, 6,7);
		m_crtest[1] = GetTextBetweenPipes(strLine, 7,8);
		m_vehcom[1] = GetTextBetweenPipes(strLine, 8,9);
	}

	// read second vehicle (if present)
	myFile.ReadString (strLine);  // next vehicle should be next line
	if ((strLine.GetLength ()) <1) 
	{
		return;  // don't process empty string
	}

	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}


	loc1 = strLine.Find ('|',0);
	if (loc1==-1) 
	{
		return;      // | not found in line after ----- VEHICLE -----,
				     // must be another section, so return.
	}

	//8 pipes.EV5 and 9 EV4
	nPipes = CountPipes(strLine);
	if (nVersion==EV4)
	{
		if (nPipes!= 9)
		{
			char buf [10];
			itoa (nPipes,buf,10);
			CString strPipes = buf;
			CString strErr = "This EV4 file has "+strPipes +" | characters in the VEHICLE section, should have 9.";
			MessageBox(NULL, strErr, "Error",MB_OK);
			return;
		}
	}
	else if (nVersion==EV5)
	{
		if (nPipes!= 8)
		{
			char buf [10];
			itoa (nPipes,buf,10);
			CString strPipes = buf;
			CString strErr = "This EV5 file has "+strPipes +" | characters in the VEHICLE section, should have 8.";
			MessageBox(NULL, strErr, "Error",MB_OK);
			return;
		}
	}
	
if (nVersion==EV4)  // skip tstno if EV4
	{
		m_vehno = atoi(GetTextBetweenPipes(strLine, 1,2));
		m_make[2] = GetTextBetweenPipes(strLine, 2,3);
		m_model[2] = GetTextBetweenPipes(strLine, 3,4);
		m_year[2] = GetTextBetweenPipes(strLine, 4,5);
		m_nhtsano[2] = GetTextBetweenPipes(strLine, 5,6);
		m_body[2] = GetTextBetweenPipes(strLine, 6,7);
		m_vin[2] = GetTextBetweenPipes(strLine, 7,8);
		m_crtest[2] = GetTextBetweenPipes(strLine, 8,9);
		m_vehcom[2] = GetTextBetweenPipes(strLine, 9,10);
	}
	else  //skip nothing if EV5
	{
		m_vehno = atoi(GetTextBetweenPipes(strLine, 0,1));
		m_make[2] = GetTextBetweenPipes(strLine, 1,2);
		m_model[2] = GetTextBetweenPipes(strLine, 2,3);
		m_year[2] = GetTextBetweenPipes(strLine, 3,4);
		m_nhtsano[2] = GetTextBetweenPipes(strLine, 4,5);
		m_body[2] = GetTextBetweenPipes(strLine, 5,6);
		m_vin[2] = GetTextBetweenPipes(strLine, 6,7);
		m_crtest[2] = GetTextBetweenPipes(strLine, 7,8);
		m_vehcom[2] = GetTextBetweenPipes(strLine, 8,9);
	}
	return;

}

// ******
// ExtractCompData
// This function finds and separates the Component data in an .ev5 file if any,
// and fills in CCompData with that info.
// ******
void CCompData::ExtractCompData(CStdioFile & myFile, int nVersion)
{
	CString strLine;
	myFile.SeekToBegin ();  // back to beginning

	// find ----- COMPONENT -----
	int nRes=-1;
	while (myFile.ReadString (strLine))
	{
		nRes = strLine.Find("----- COMPONENT -----");
		if (nRes != -1) break;
	}
	if (nRes == -1)   // COMPONENT section not found
	{
		m_compsets=0;
		return;
	}

    // now read line after ----- COMPONENT -----
	myFile.ReadString (strLine);

	if ((strLine.GetLength ()) <1) 
	{
		m_compsets=0;
		return;  // don't process empty string
	}

	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}


	int loc1 = strLine.Find ('|',0);

	if (loc1==-1) 
	{
		m_compsets=0;
		return;      // | not found in line after ----- COMPONENT -----,
				     // must be another section, so return.
	}

	int loop =1;
	while ((strLine.Left(6) !="----- "))  // not at another header.
	{
		//10 pipes.EV5 and 11 EV4
		int nPipes = CountPipes(strLine);
		if (nVersion==EV4)
		{
			if (nPipes!= 11)
			{
				char buf [10];
				itoa (nPipes,buf,10);
				CString strPipes = buf;
				CString strErr = "This EV4 file has "+strPipes +" | characters in the COMPONENT section, should have 11.";
				MessageBox(NULL, strErr, "Error",MB_OK);
				m_compsets=0;
				return;
			}
		}
		else if (nVersion==EV5)
		{
			if (nPipes!= 10)
			{
				char buf [10];
				itoa (nPipes,buf,10);
				CString strPipes = buf;
				CString strErr = "This EV5 file has "+strPipes +" | characters in the COMPONENT section, should have 10.";
				MessageBox(NULL, strErr, "Error",MB_OK);
				m_compsets=0;
				return;
			}
		}

		if (nVersion==EV4) //Skip tstno in EV4
		{
			m_Comp_vehno.SetAtGrow(loop, GetTextBetweenPipes(strLine, 1,2));
			m_cmpno.SetAtGrow(loop, GetTextBetweenPipes(strLine, 2,3));
			m_cmpnt.SetAtGrow(loop, GetTextBetweenPipes(strLine, 3,4));
			m_cmptyp.SetAtGrow(loop, GetTextBetweenPipes(strLine, 4,5));
			m_cmpwgt.SetAtGrow(loop, GetTextBetweenPipes(strLine, 5,6));
			m_modind.SetAtGrow(loop, GetTextBetweenPipes(strLine, 6,7));
			m_moddsc.SetAtGrow(loop, GetTextBetweenPipes(strLine, 7,8));
			m_occtyp.SetAtGrow(loop, GetTextBetweenPipes(strLine, 8,9));
			m_dumsiz.SetAtGrow(loop, GetTextBetweenPipes(strLine, 9,10));
			m_dumman.SetAtGrow(loop, GetTextBetweenPipes(strLine, 10,11));
			m_cmpcom.SetAtGrow (loop, GetTextBetweenPipes(strLine, 11,12));
		}
		else if (nVersion==EV5) //nothing to skip in EV5
		{
			m_Comp_vehno.SetAtGrow(loop, GetTextBetweenPipes(strLine, 0,1));
			m_cmpno.SetAtGrow(loop, GetTextBetweenPipes(strLine, 1,2));
			m_cmpnt.SetAtGrow(loop, GetTextBetweenPipes(strLine, 2,3));
			m_cmptyp.SetAtGrow(loop, GetTextBetweenPipes(strLine, 3,4));
			m_cmpwgt.SetAtGrow(loop, GetTextBetweenPipes(strLine, 4,5));
			m_modind.SetAtGrow(loop, GetTextBetweenPipes(strLine, 5,6));
			m_moddsc.SetAtGrow(loop, GetTextBetweenPipes(strLine, 6,7));
			m_occtyp.SetAtGrow(loop, GetTextBetweenPipes(strLine, 7,8));
			m_dumsiz.SetAtGrow(loop, GetTextBetweenPipes(strLine, 8,9));
			m_dumman.SetAtGrow(loop, GetTextBetweenPipes(strLine, 9,10));
			m_cmpcom.SetAtGrow (loop, GetTextBetweenPipes(strLine, 10,11));
		}
		// now increment loop and read next string.
		loop++;
		myFile.ReadString (strLine);	
	
		while (strLine[0]=='#')  //comment line, so read another.
		{
			myFile.ReadString (strLine);	
		}
	}
	m_compsets = loop-1 ;

}

// ******
// ExtractConfData
// This function finds and separates the Configuration data in an .ev5 file if any,
// and fills in CCompData with that info.
// ******
void CCompData::ExtractConfData(CStdioFile & myFile, int nVersion)
{
	CString strLine;
	myFile.SeekToBegin ();  // back to beginning

	// find ----- CONFIGURATION -----
	int nRes=-1;
	while (myFile.ReadString (strLine))
	{
		nRes = strLine.Find("----- CONFIGURATION -----");
		if (nRes != -1) break;
	}

	if (nRes == -1)   // COMPONENT section not found
	{
		m_confsets=0;
		return;
	}

    // now read line after ----- CONFIGURATION -----
	myFile.ReadString (strLine);	

	if ((strLine.GetLength ()) <1) 
	{
		m_confsets=0;
		return;  // don't process empty string
	}

	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}

	int loc1 = strLine.Find ('|',0);

	if (loc1==-1) 
	{
		m_confsets=0;
		return;      // | not found in line after ----- CONFIGURATION -----,
				     // must be another section, so return.
	}

	int loop =1;
	while ((strLine.Left(6) !="----- "))  // not at another header.
	{
		//12 pipes.EV5 and 13 EV4
		int nPipes = CountPipes(strLine);
		if (nVersion==EV4)
		{
			if (nPipes!= 13)
			{
				char buf [10];
				itoa (nPipes,buf,10);
				CString strPipes = buf;
				CString strErr = "This EV4 file has "+strPipes +" | characters in the CONFIGURATION section, should have 13.";
				MessageBox(NULL, strErr, "Error",MB_OK);
				m_confsets=0;
				return;
			}
		}
		else if (nVersion==EV5)
		{
			if (nPipes!= 12)
			{
				char buf [10];
				itoa (nPipes,buf,10);
				CString strPipes = buf;
				CString strErr = "This EV5 file has "+strPipes +" | characters in the CONFIGURATION section, should have 12.";
				MessageBox(NULL, strErr, "Error",MB_OK);
				m_confsets=0;
				return;
			}
		}

		if (nVersion==EV4)  //if EV4, skip tstno
		{
			m_Conf_vehno.SetAtGrow(loop, GetTextBetweenPipes(strLine, 1,2));
			m_Conf_cmpno.SetAtGrow(loop, GetTextBetweenPipes(strLine, 2,3));
			m_cnfno.SetAtGrow(loop, GetTextBetweenPipes(strLine, 3,4));
			m_tstdev.SetAtGrow(loop, GetTextBetweenPipes(strLine, 4,5));
			m_devspd.SetAtGrow(loop, GetTextBetweenPipes(strLine, 5,6));
			m_devcom.SetAtGrow(loop, GetTextBetweenPipes(strLine, 6,7));
			m_config.SetAtGrow(loop, GetTextBetweenPipes(strLine, 7,8));
			m_cmpspd.SetAtGrow(loop, GetTextBetweenPipes(strLine, 8,9));
			m_cntang.SetAtGrow(loop, GetTextBetweenPipes(strLine, 9,10));
			m_cntloc1.SetAtGrow(loop, GetTextBetweenPipes(strLine, 10,11));
			m_cntloc2.SetAtGrow(loop, GetTextBetweenPipes(strLine, 11,12));
			m_cntcom.SetAtGrow(loop, GetTextBetweenPipes(strLine, 12,13));
			m_cnfcom.SetAtGrow (loop, GetTextBetweenPipes(strLine, 13,14));
		}
		else  //EV5, nothing to skip
		{
			m_Conf_vehno.SetAtGrow(loop, GetTextBetweenPipes(strLine, 0,1));
			m_Conf_cmpno.SetAtGrow(loop, GetTextBetweenPipes(strLine, 1,2));
			m_cnfno.SetAtGrow(loop, GetTextBetweenPipes(strLine, 2,3));
			m_tstdev.SetAtGrow(loop, GetTextBetweenPipes(strLine, 3,4));
			m_devspd.SetAtGrow(loop, GetTextBetweenPipes(strLine, 4,5));
			m_devcom.SetAtGrow(loop, GetTextBetweenPipes(strLine, 5,6));
			m_config.SetAtGrow(loop, GetTextBetweenPipes(strLine, 6,7));
			m_cmpspd.SetAtGrow(loop, GetTextBetweenPipes(strLine, 7,8));
			m_cntang.SetAtGrow(loop, GetTextBetweenPipes(strLine, 8,9));
			m_cntloc1.SetAtGrow(loop, GetTextBetweenPipes(strLine, 9,10));
			m_cntloc2.SetAtGrow(loop, GetTextBetweenPipes(strLine, 10,11));
			m_cntcom.SetAtGrow(loop, GetTextBetweenPipes(strLine, 11,12));
			m_cnfcom.SetAtGrow (loop, GetTextBetweenPipes(strLine, 12,13));
		}

		// now increment loop and read next string.
		loop++;
		myFile.ReadString (strLine);	

		while (strLine[0]=='#')  //comment line, so read another.
		{
			myFile.ReadString (strLine);	
		}

	}
	m_confsets=loop-1;

}

// ******
// ExtractInstData
// This function finds and separates the Curve data in an .ev file if any,
// and fills in CCompData with that info.
// ******
void CCompData::ExtractInstData(CStdioFile & myFile, int nVersion)
{
	CString strLine;
	myFile.SeekToBegin ();  // back to beginning

	// find ----- INSTRUMENTATION -----
	int nRes =-1;
	while (myFile.ReadString (strLine))
	{
		nRes = strLine.Find("----- INSTRUMENTATION -----");
		if (nRes != -1) break;
	}

	if (nRes == -1)   // INSTRUMENTATION section not found
	{
		m_totcrv=0;
		return;
	}

    // now read line after ----- INSTRUMENTATION -----
	myFile.ReadString (strLine);	

	if ((strLine.GetLength ()) <1) 
	{
		m_totcrv=0;
		return;  // don't process empty string
	}

	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}

	int loc1 = strLine.Find ('|',0);

	if (loc1==-1) 
	{
		m_totcrv=0;
		return;      // | not found in line after ----- INSTRUMENTATION -----,
				     // must be another section, so return.
	}

	int loop =1;
	while ((strLine.Left(6) !="----- "))  // not at another header.
	{
		//20 pipes.EV5 and EV4
		int nPipes = CountPipes(strLine);
//		if ((nVersion==EV5) || (nVersion==EV4)) // wong 19 for EV4 and 20 for EV5, original line
		if ( ((nVersion==EV5) || (nVersion==EV4)) && (nPipes!= 20) ) // wong rewrites at 02/25/00
		{
				char buf [10];
				itoa (nPipes,buf,10);
				CString strPipes = buf;
				CString strErr = "This EV4/EV5 file has "+strPipes +" | characters in the INSTRUMENTATION section, should have 20.";
				MessageBox(NULL, strErr, "Error",MB_OK);
				m_totcrv=0;
				return;
		}
		
		if (nVersion == EV4)  //EV4 skips first field (tstno)
		{
			m_Inst_vehno.SetAtGrow(loop, GetTextBetweenPipes(strLine, 1,2)); 
			m_Inst_cmpno.SetAtGrow (loop, GetTextBetweenPipes(strLine, 2,3)); 
			m_Inst_cnfno.SetAtGrow (loop, GetTextBetweenPipes(strLine, 3,4));  
			m_curno = atoi(GetTextBetweenPipes(strLine, 4,5)); 
			
			m_sentyp.SetAtGrow(loop, GetTextBetweenPipes(strLine, 5,6));
			m_senatt.SetAtGrow(loop, GetTextBetweenPipes(strLine, 6,7));
			m_axis.SetAtGrow(loop, GetTextBetweenPipes(strLine, 7,8));
//			m_xunits.SetAtGrow(loop, GetTextBetweenPipes(strLine, 8,9));// EV4 doesen't have xUnit, it is scaled by 10EXP(-6) second
			m_xunits.SetAtGrow(loop, _T("SEC"));	// wong added
			m_yunits.SetAtGrow(loop, GetTextBetweenPipes(strLine, 8,9));
			m_prefil.SetAtGrow(loop, GetTextBetweenPipes(strLine, 9,10));

			m_insman.SetAtGrow(loop, GetTextBetweenPipes(strLine, 10,11));
			m_caldat.SetAtGrow(loop, GetTextBetweenPipes(strLine, 11,12));		
			m_insrat.SetAtGrow(loop, GetTextBetweenPipes(strLine, 12,13));
			m_chlmax.SetAtGrow(loop, GetTextBetweenPipes(strLine, 13,14));
			m_inivel.SetAtGrow(loop, GetTextBetweenPipes(strLine, 14,15));

			m_nfp.SetAtGrow(loop, GetTextBetweenPipes(strLine, 15,16));
			m_nlp.SetAtGrow(loop, GetTextBetweenPipes(strLine, 16,17));
			m_delt.SetAtGrow(loop, GetTextBetweenPipes(strLine, 17,18));
			m_dastat.SetAtGrow(loop, GetTextBetweenPipes(strLine, 18,19));
			m_chstat.SetAtGrow(loop, GetTextBetweenPipes(strLine, 19,20));

			m_inscom.SetAtGrow (loop, GetTextBetweenPipes(strLine, 20,21));
		}
		else
		{
			m_Inst_vehno.SetAtGrow(loop, GetTextBetweenPipes(strLine, 0,1));
			m_Inst_cmpno.SetAtGrow (loop, GetTextBetweenPipes(strLine, 1,2)); 
			m_Inst_cnfno.SetAtGrow (loop, GetTextBetweenPipes(strLine, 2,3));
			m_curno = atoi(GetTextBetweenPipes(strLine, 3,4));  
			m_sentyp.SetAtGrow(loop, GetTextBetweenPipes(strLine, 4,5));
			m_senatt.SetAtGrow(loop, GetTextBetweenPipes(strLine, 5,6));
			m_axis.SetAtGrow(loop, GetTextBetweenPipes(strLine, 6,7));
			m_xunits.SetAtGrow(loop, GetTextBetweenPipes(strLine, 7,8));
			m_yunits.SetAtGrow(loop, GetTextBetweenPipes(strLine, 8,9));
			m_prefil.SetAtGrow(loop, GetTextBetweenPipes(strLine, 9,10));
			m_insman.SetAtGrow(loop, GetTextBetweenPipes(strLine, 10,11));
			m_caldat.SetAtGrow(loop, GetTextBetweenPipes(strLine, 11,12));		
			m_insrat.SetAtGrow(loop, GetTextBetweenPipes(strLine, 12,13));
			m_chlmax.SetAtGrow(loop, GetTextBetweenPipes(strLine, 13,14));
			m_inivel.SetAtGrow(loop, GetTextBetweenPipes(strLine, 14,15));
			m_nfp.SetAtGrow(loop, GetTextBetweenPipes(strLine, 15,16));
			m_nlp.SetAtGrow(loop, GetTextBetweenPipes(strLine, 16,17));
			m_delt.SetAtGrow(loop, GetTextBetweenPipes(strLine, 17,18));
			m_dastat.SetAtGrow(loop, GetTextBetweenPipes(strLine, 18,19));
			m_chstat.SetAtGrow(loop, GetTextBetweenPipes(strLine, 19,20));
			m_inscom.SetAtGrow (loop, GetTextBetweenPipes(strLine, 20,21));
		}

		// now increment loop and read next string.
		loop++;
		myFile.ReadString (strLine);
		while (strLine[0]=='#')  //comment line, so read another.
		{
			myFile.ReadString (strLine);	
		}

	}
	m_totcrv = loop-1;  // total curve infos read from file.

}


// ------------------------------------
// BOOL ImportGR1(CString&)
// Description:  Opens GR1 file. Sets CompData member vars with
//               Data found there, using the offsets defined in
//               CompGR1.h
// ------------------------------------
BOOL CCompData::ImportGR1(CString & strfile_in)
{
	CStdioFile myFile;
	CFileException fileException;

	myFile.Open( strfile_in, CFile::modeRead | CFile::typeText,
		&fileException );
	if (!myFile.m_pStream)  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_in, fileException.m_cause );
		MessageBox(NULL,msg,"Error",MB_OK);
		return FALSE;
	}

	CString strLine;
	myFile.ReadString (strLine);

	if ((strLine.GetLength ()) <1) return FALSE;  // don't process empty string

	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}

	int nLen = strLine.GetLength ();
	if (nLen != m_GR1.m_totallen)
	{
		MessageBox(NULL,strfile_in+" is not in proper GR1 format.","ERROR", MB_OK);
		return FALSE;
	}
	// load member variables
	 //m_tstno = atoi(strLine.Mid(m_GR1.m_tstnooff ,m_GR1.m_tstnolen ));

	 m_title = strLine.Mid(m_GR1.m_titleoff ,m_GR1.m_titlelen );
	 m_tstobj = strLine.Mid(m_GR1.m_tstobjoff ,m_GR1.m_tstobjlen );
	 m_tstdat = strLine.Mid(m_GR1.m_tstdatoff ,m_GR1.m_tstdatlen );
	 m_tstprf = strLine.Mid(m_GR1.m_tstprfoff ,m_GR1.m_tstprflen );
	 m_conno = strLine.Mid(m_GR1.m_connooff ,m_GR1.m_connolen );

	 m_tstref = strLine.Mid(m_GR1.m_tstrefoff ,m_GR1.m_tstreflen );
	 m_tsttyp = strLine.Mid(m_GR1.m_tsttypoff ,m_GR1.m_tsttyplen );
	 //m_totcrv =  atoi(strLine.Mid(m_GR1.m_totcrvoff ,m_GR1.m_totcrvlen ));  GR5 controlled.
	 m_temp = strLine.Mid(m_GR1.m_tempoff ,m_GR1.m_templen );
	 m_tstcom = strLine.Mid(m_GR1.m_tstcomoff ,m_GR1.m_tstcomlen );

	return TRUE;
}

// ------------------------------------
// BOOL ImportGR5(CString&)
// Description:  Opens GR5 file. Sets CompData member vars with
//               Data found there, using the offsets defined in
//               CompGR5.h
// ------------------------------------
BOOL CCompData::ImportGR5(CString & strfile_in)
{
	CStdioFile myFile;
	CFileException fileException;
	
	myFile.Open( strfile_in, CFile::modeRead | CFile::typeText,
		&fileException );
	if (!myFile.m_pStream)  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_in, fileException.m_cause );
		MessageBox(NULL,msg,"Error",MB_OK);
		return FALSE;
	}
	
	CString strLine;
	while(myFile.ReadString (strLine))
	{
		if ((strLine.GetLength ()) <1) return FALSE;  // don't process empty string

		while (strLine[0]=='#')  //comment line, so read another.
		{
			myFile.ReadString (strLine);	
		}

		int nLen = strLine.GetLength ();
		if (nLen != m_GR5.m_totallen)
		{
			MessageBox(NULL,strfile_in+" is not in proper GR5 format.","ERROR", MB_OK);
			return FALSE;
		}
		
		// load member variables  

		m_curno = atoi(strLine.Mid(m_GR5.m_curnooff ,m_GR5.m_curnolen ));
		m_Inst_cmpno.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_cmpnooff ,m_GR5.m_cmpnolen ));		
		m_sentyp.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_sentypoff ,m_GR5.m_sentyplen ));		
		m_senatt.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_senattoff ,m_GR5.m_senattlen ));		
		m_axis.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_axisoff ,m_GR5.m_axislen ));
		
		m_xunits.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_unitsoff ,m_GR5.m_unitslen ));
		m_yunits.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_unitsoff ,m_GR5.m_unitslen ));		
		m_prefil.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_prefiloff ,m_GR5.m_prefillen ));		
		m_insman.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_insmanoff ,m_GR5.m_insmanlen ));		
		m_caldat.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_caldatoff ,m_GR5.m_caldatlen ));
		
		m_insrat.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_insratoff ,m_GR5.m_insratlen ));		
		m_chlmax.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_chlmaxoff ,m_GR5.m_chlmaxlen ));		
		m_inivel.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_iniveloff ,m_GR5.m_inivellen ));		
		m_nfp.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_nfpoff ,m_GR5.m_nfplen ));		
		m_nlp.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_nlpoff ,m_GR5.m_nlplen ));
		
		m_delt.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_deltoff ,m_GR5.m_deltlen ));		
		m_dastat.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_dastatoff ,m_GR5.m_dastatlen ));		
		m_inscom.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_inscomoff ,m_GR5.m_inscomlen ));

		// These don't exist in GR5, so give them default data to avoid access violations
		m_Inst_vehno.SetAtGrow (m_curno, "");
		m_Inst_cnfno.SetAtGrow (m_curno, "");
		m_chstat.SetAtGrow (m_curno, "");

		
	}
	m_totcrv = m_curno;
	
	return TRUE;
}

// ------------------------------------
// short ImportGR9(CString&)
// Description:  Opens GR9 file. Sets CompData member vars with
//               Data found there, using the offsets defined in
//               CompGR9.h
// ------------------------------------
short CCompData::ImportGR9(CString &strfile_in)
{
	CStdioFile myFile;
	CFileException fileException;
	
	myFile.Open( strfile_in, CFile::modeRead | CFile::typeText,
		&fileException );
	if (!myFile.m_pStream)  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_in, fileException.m_cause );
		MessageBox(NULL,msg,"Error",MB_OK);
		return FALSE;
	}

	CString strLine;
	short loop = 1;

	while(myFile.ReadString (strLine))
	{
		if ((strLine.GetLength ()) <1) return 0;  // don't process empty string

		while (strLine[0]=='#')  //comment line, so read another.
		{
			myFile.ReadString (strLine);	
		}

		int nLen = strLine.GetLength ();
		if (nLen != m_GR9.m_totallen)
		{
			MessageBox(NULL,strfile_in+" is not in proper GR9 format.","ERROR", MB_OK);
			return 0;
		}
				
		// load member variables
		m_cmpno.SetAtGrow (loop, strLine.Mid(m_GR9.m_cmpnooff ,m_GR9.m_cmpnolen));
		m_cmpnt.SetAtGrow (loop, strLine.Mid(m_GR9.m_cmpntoff ,m_GR9.m_cmpntlen));
		m_cmptyp.SetAtGrow (loop, strLine.Mid(m_GR9.m_cmptypoff ,m_GR9.m_cmptyplen));
		m_modind.SetAtGrow (loop, strLine.Mid(m_GR9.m_modindoff ,m_GR9.m_modindlen));
		m_moddsc.SetAtGrow (loop, strLine.Mid(m_GR9.m_moddscoff ,m_GR9.m_moddsclen));
		m_cmpwgt.SetAtGrow (loop, strLine.Mid(m_GR9.m_cmpwgtoff ,m_GR9.m_cmpwgtlen));
		m_occtyp.SetAtGrow (loop, strLine.Mid(m_GR9.m_occtypoff ,m_GR9.m_occtyplen));
		m_dumsiz.SetAtGrow (loop, strLine.Mid(m_GR9.m_dumsizoff ,m_GR9.m_dumsizlen));
		m_dumman.SetAtGrow (loop, strLine.Mid(m_GR9.m_dummanoff ,m_GR9.m_dummanlen));
		m_cmpcom.SetAtGrow (loop, strLine.Mid(m_GR9.m_cmpcomoff ,m_GR9.m_cmpcomlen));
		// not in GR9, so set default.	
		m_Comp_vehno.SetAtGrow (loop, "");
		
		//   CmpSpd is in Comp Configuration Data
		//   m_cmpspd.SetAtGrow (loop, atof(strLine.Mid(m_GR9.m_cmpspdoff ,m_GR9.m_cmpspdlen)));
		//   The following are all in Comp Vehicle Data
		//	 m_make.SetAtGrow (loop, atoi(strLine.Mid(m_GR9.m_makeoff ,m_GR9.m_makelen)));
		//	 m_model.SetAtGrow (loop, atoi(strLine.Mid(m_GR9.m_modeloff ,m_GR9.m_modellen)));
		//	 m_year.SetAtGrow (loop, atoi(strLine.Mid(m_GR9.m_yearoff ,m_GR9.m_yearlen)));
		//	 m_body.SetAtGrow (loop, atoi(strLine.Mid(m_GR9.m_bodyoff ,m_GR9.m_bodylen)));
		//	 m_vin.SetAtGrow (loop, atoi(strLine.Mid(m_GR9.m_vinoff ,m_GR9.m_vinlen)));
		//	 m_crtest.SetAtGrow (loop, atoi(strLine.Mid(m_GR9.m_crtestoff ,m_GR9.m_crtestlen)));
		
		loop++;
	}
	
	return --loop;
}

