// CompData.h: interface for the CCompData class.
//
//////////////////////////////////////////////////////////////////////

#include "CompGR1.h"
#include "CompGR5.h"
#include "CompGR9.h"
#include "HighSpeedVideoData.h"

#if !defined(AFX_COMPDATA_H__6559AE97_69D0_11D2_9494_0008C7AA9033__INCLUDED_)
#define AFX_COMPDATA_H__6559AE97_69D0_11D2_9494_0008C7AA9033__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CCompData : public CHighSpeedVideoData
{
public:
	//Constructors/Destructors
	CCompData();
	virtual ~CCompData();

	//member functions
	short ImportGR9(CString&);
	BOOL ImportGR5(CString &);
	BOOL ImportGR1(CString &);
	void ExtractInstData(CStdioFile &, int);
	void ExtractConfData (CStdioFile &, int);
	void ExtractCompData (CStdioFile &, int);
	void ExtractVehData(CStdioFile &, int);
	void ExtractTestData (CStdioFile &, int);
	BOOL LoadCompEV5Data(CStdioFile &);
	BOOL ImportEV3(CString &);
	BOOL ImportEV4 (CString &);
	BOOL ImportEV5 (CString &);
	void WriteCompInstReport (CStdioFile &);
	void WriteCompVehReport (CStdioFile &);
	void WriteCompConfReport(CStdioFile &);
	void WriteCompCompReport(CStdioFile &);
	void WriteCompTestReport(CStdioFile &);
	BOOL ExportEVR(CString &);
	void WriteCompInst(CStdioFile &);
	void WriteCompConf(CStdioFile &);
	void WriteCompComp(CStdioFile &);
	void WriteCompVeh(CStdioFile &);
	void WriteCompTest(CStdioFile &);
	CString OutString(CString);
	BOOL ExportEV5(CString &);


// members
public:
	CCompGR1 m_GR1;
	CCompGR5 m_GR5;
	CCompGR9 m_GR9;
	int m_confsets;
	int m_compsets;
	//Test Info Data
	CString m_verno;
	CString m_title;
	CString m_tstobj;
	CString m_tstdat;
	CString m_tstprf;
	CString m_conno;
	// CString m_tstref;	// defined in CHighSpeedVideo
	CString m_tsttyp;
	CString m_temp;
	int m_totcrv;
	CString m_tstcom;
	//Vehicle Info Data - arrays for multiple vehicles- currently only 2 allowed.*****
	int m_vehno;   //number of vehicles, also used as array index
	CStringArray m_make;
	CStringArray m_model;
	CStringArray m_year;
	CStringArray m_nhtsano;
	CStringArray m_body;
	CStringArray m_vin;
	CStringArray m_crtest;
	CStringArray m_vehcom;
	// Component Info Data
	CStringArray m_Comp_vehno;
	CStringArray m_cmpno;
	CStringArray m_cmpnt;
	CStringArray m_cmptyp;
	CStringArray m_cmpwgt; // CArray<float,float> m_cmpwgt;
	CStringArray m_modind;
	CStringArray m_moddsc;
	CStringArray m_occtyp;
	CStringArray m_dumsiz;
	CStringArray m_dumman;
	CStringArray m_cmpcom;
	// Configuration Info data;
	CStringArray m_Conf_vehno;
	CStringArray m_Conf_cmpno;
	CStringArray m_cnfno;
	CStringArray m_tstdev;
	CStringArray m_devspd; // CArray<double,double> m_devspd;
	CStringArray m_devcom;
	CStringArray m_config;
	CStringArray m_cmpspd; // CArray<double,double> m_cmpspd;
	CStringArray m_cntang;
	CStringArray m_cntloc1;
	CStringArray m_cntloc2;
	CStringArray m_cntcom;
	CStringArray m_cnfcom;
	//Instrument Info Data
	CStringArray m_Inst_vehno;
	CStringArray m_Inst_cmpno;
	CStringArray m_Inst_cnfno;
	int m_curno;  //number of vehicles, also used as array index
	CStringArray m_sentyp;
	CStringArray m_senloc;
	CStringArray m_senatt;
	CStringArray m_axis;
	CStringArray m_xunits;
	CStringArray m_yunits;
	CStringArray m_prefil;
	CStringArray m_insman;
	CStringArray m_caldat;
	CStringArray m_insrat; // CArray<int,int> m_insrat;
	CStringArray m_chlmax;
	CStringArray m_inivel; // CArray<float,float> m_inivel;
	CStringArray m_nfp; // CArray<int,int> m_nfp;
	CStringArray m_nlp; // CArray<int,int> m_nlp;
	CStringArray m_delt;
	CStringArray m_dastat;
	CStringArray m_chstat;
	CStringArray m_inscom;

private:
	bool	ValidateCompTestData();
	bool	ValidateCompVehData();
	bool	ValidateCompCompData();
	bool	ValidateCompConfData();
	bool	ValidateCompInstData();

};

#endif // !defined(AFX_COMPDATA_H__6559AE97_69D0_11D2_9494_0008C7AA9033__INCLUDED_)
