// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: CompGR1.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description: CCompGR1 constructor.  All this class does is
//              hold the offsets and lengths used for parsing data out of
//              a GR1 file.
// -----------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "CompGR1.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCompGR1::CCompGR1()
{
	
	 m_tstnooff = 2;
	 m_tstnolen = 1;

	 m_titleoff = 3;
	 m_titlelen = 70;

	 m_tstobjoff = 73;
	 m_tstobjlen = 70;

	 m_tstdatoff = 143;
	 m_tstdatlen = 9;

	 m_tstprfoff = 152;
	 m_tstprflen = 3;

	 m_connooff = 155;
	 m_connolen = 17;

	 m_cotroff = 172;
	 m_cotrlen = 25;

	 m_tstrefoff = 197;
	 m_tstreflen = 10;

	 m_tsttypoff = 207;
	 m_tsttyplen = 3;

	 m_tstratoff = 210;
	 m_tstratlen = 3;

	 m_tstcfnoff = 213;
	 m_tstcfnlen = 3;

	 m_tempoff = 216;
	 m_templen = 3;

	 m_impangoff = 219;
	 m_impanglen = 3;

	 m_totcrvoff = 222;
	 m_totcrvlen = 3;

	 m_tstcomoff = 225;
	 m_tstcomlen = 70;

	 m_totallen = 295;

}

CCompGR1::~CCompGR1()
{

}
