// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: CompGR5.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description: CCompGR5 constructor.  All this class does is
//              hold the offsets and lengths used for parsing data out of
//              a GR5 file.
// -----------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "CompGR5.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCompGR5::CCompGR5()
{
	 m_cmpnooff = 1;
	 m_cmpnolen = 1;

	 m_curnooff = 2;
	 m_curnolen = 3;

	 m_sennumoff = 5;
	 m_sennumlen = 1;

	 m_sentypoff = 6;
	 m_sentyplen = 2;

	 m_senattoff = 8;
	 m_senattlen = 4;

	 m_axisoff = 12;
	 m_axislen = 2;

	 m_unitsoff = 14;
	 m_unitslen = 3;  //dont forget both units

	 m_prefiloff = 17;
	 m_prefillen = 5;

	 m_insmanoff = 22;
	 m_insmanlen = 70;

	 m_caldatoff = 92;
	 m_caldatlen = 9;

	 m_insratoff = 101;
	 m_insratlen = 5;

	 m_chlmaxoff = 106;
	 m_chlmaxlen = 3;

	 m_iniveloff = 109;
	 m_inivellen = 5;

	 m_nfpoff = 114;
	 m_nfplen = 5;

	 m_nlpoff = 119;
	 m_nlplen = 5;

	 m_deltoff = 124;
	 m_deltlen = 6;
	
	 m_dastatoff = 130;
	 m_dastatlen = 2;

	 m_inscomoff = 132;
	 m_inscomlen = 70;

	 m_totallen = 202;

}

CCompGR5::~CCompGR5()
{

}
