// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: CompGR9.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description: CCompGR9 constructor.  All this class does is
//              hold the offsets and lengths used for parsing data out of
//              a GR9 file.
// -----------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "CompGR9.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCompGR9::CCompGR9()
{
	
	 m_cmpnooff = 1;
	 m_cmpnolen = 1;

	 m_cmpntoff = 2;
	 m_cmpntlen = 4;

	 m_cmptypoff = 6;
	 m_cmptyplen = 2;

	 m_modindoff = 8;
	 m_modindlen = 1;

	 m_moddscoff = 9;
	 m_moddsclen = 70;

	 m_cmpwgtoff = 79;
	 m_cmpwgtlen = 6;

	 m_cmpspdoff = 85;
	 m_cmpspdlen = 5;

	 m_imppnt1off = 90;
	 m_imppnt1len = 6;

	 m_imppnt2off = 96;
	 m_imppnt2len = 6;

	 m_makeoff = 102;
	 m_makelen = 2;

	 m_modeloff = 104;
	 m_modellen = 2;

	 m_yearoff = 106;
	 m_yearlen = 2;

	 m_bodyoff = 108;
	 m_bodylen = 2;

	 m_vinoff = 110;
	 m_vinlen = 20;

	 m_crtestoff = 130;
	 m_crtestlen = 1;

	 m_occtypoff = 131;
	 m_occtyplen = 2;

	 m_dumsizoff = 133;
	 m_dumsizlen = 2;

	 m_dummanoff = 135;
	 m_dummanlen = 70;	

	 m_dummodoff = 205;
	 m_dummodlen = 70;

	 m_dumdscoff = 275;
	 m_dumdsclen = 70;

	 m_cmpcomoff = 345;
	 m_cmpcomlen = 70;

	 m_totallen = 415;


}

CCompGR9::~CCompGR9()
{

}
