// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: CompInstPage.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description:  Member functions of CCompInstPage.
//               They relate to the loading and display of 
//               data on this page.
//
//  Modification History:
//  Date		Who			Description
//	2000    Y. Wong Adding business rules, recode all edit boxs
//					and correct other errors.
// -----------------------------------------


#include "stdafx.h"
#include "entreeV5.h"
#include "CompInstPage.h"
#include "search.h"
#include "CodeValidation.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CString search_code;

/////////////////////////////////////////////////////////////////////////////
// CCompInstPage property page

IMPLEMENT_DYNCREATE(CCompInstPage, CPropertyPage)

CCompInstPage::CCompInstPage() : CPropertyPage(CCompInstPage::IDD)
{
	//{{AFX_DATA_INIT(CCompInstPage)
	m_editaxis		= _T("");
	m_editchstat	= _T("");
	m_editdastat	= _T("");
	m_editinscom	= _T("");
	m_editinsman	= _T("");
	m_editsenatt	= _T("");
	m_editsentyp	= _T("");
	m_editxunits	= _T("");
	m_edityunits	= _T("");
	m_retaindata	= FALSE;
	m_editcmpno		= _T("");
	m_editcnfno		= _T("");
	m_editvehno		= _T("");
	m_editinsrat	= _T("");
	m_editchlmax	= _T("");
	m_editinivel	= _T("");
	m_editnfp		= _T("");
	m_editnlp		= _T("");
	m_editdelt		= _T("");
	m_editprefil	= _T("");
	//}}AFX_DATA_INIT

	m_icurno= 0;     // Default to first curve.
}

CCompInstPage::~CCompInstPage()
{
}

void CCompInstPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCompInstPage)
	DDX_Control(pDX, IDC_COMPINSTDAT, m_editinstdate);
	DDX_Control(pDX, IDC_CURVELIST, m_curvelist);
	DDX_Control(pDX, IDC_COMPINST_CALDAT, m_caldatctrl);
	DDX_Control(pDX, IDC_NEXTCURVE_BUTTON, m_nextcurvebutton);
	DDX_Control(pDX, IDC_DELETE_BUTTON, m_deletebutton);
	DDX_Control(pDX, IDC_COMPINST_AXIS, m_editaxis);
	DDX_Control(pDX, IDC_COMPINST_CHSTAT, m_editchstat);
	DDX_Control(pDX, IDC_COMPINST_DASTAT, m_editdastat);
	DDX_Control(pDX, IDC_COMPINST_INSCOM, m_editinscom);
	DDX_Control(pDX, IDC_COMPINST_INSMAN, m_editinsman);
	DDX_Control(pDX, IDC_COMPINST_SENATT, m_editsenatt);
	DDX_Control(pDX, IDC_COMPINST_SENTYP, m_editsentyp);
	DDX_Control(pDX, IDC_COMPINST_XUNITS, m_editxunits);
	DDX_Control(pDX, IDC_COMPINST_YUNITS, m_edityunits);
	DDX_Check(pDX, IDC_RETAINDATA, m_retaindata);
	DDX_Control(pDX, IDC_COMPINST_CMPNO, m_editcmpno);
	DDX_Control(pDX, IDC_COMPINST_CNFNO, m_editcnfno);
	DDX_Control(pDX, IDC_COMPINST_VEHNO, m_editvehno);
	DDX_Control(pDX, IDC_COMPINST_INSRAT, m_editinsrat);
	DDX_Control(pDX, IDC_COMPINST_CHLMAX, m_editchlmax);
	DDX_Control(pDX, IDC_COMPINST_INIVEL, m_editinivel);
	DDX_Control(pDX, IDC_COMPINST_NFP, m_editnfp);
	DDX_Control(pDX, IDC_COMPINST_NLP, m_editnlp);
	DDX_Control(pDX, IDC_COMPINST_DELT, m_editdelt);
	DDX_Control(pDX, IDC_COMPINST_PREFIL, m_editprefil);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCompInstPage, CPropertyPage)
	//{{AFX_MSG_MAP(CCompInstPage)
	ON_BN_CLICKED(IDC_NEXTCURVE_BUTTON, OnNextcurveButton)
	ON_BN_CLICKED(IDC_DELETE_BUTTON, OnDeleteButton)
	ON_BN_CLICKED(IDC_SENTYP_SEARCH, OnSentypSearch)
	ON_BN_CLICKED(IDC_SENATT_SEARCH, OnSenattSearch)
	ON_BN_CLICKED(IDC_AXIS_SEARCH, OnAxisSearch)
	ON_BN_CLICKED(IDC_XUNITS_SEARCH, OnXUnitsSearch)
	ON_BN_CLICKED(IDC_DASTAT_SEARCH, OnDastatSearch)
	ON_BN_CLICKED(IDC_CHSTAT_SEARCH, OnChstatSearch)
	ON_BN_CLICKED(IDC_YUNITS_SEARCH, OnYUnitsSearch)
	ON_LBN_SELCHANGE(IDC_CURVELIST, OnSelchangeCurvelist)
	ON_WM_HELPINFO()
	ON_COMMAND(ID_HELP, OnHelpFinder)
	ON_NOTIFY(DTN_DATETIMECHANGE, IDC_COMPINST_CALDAT, OnDatetimechangeCompinstCaldat)
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTW, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTA, 0, 0xFFFF, OnToolTipNotify )
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCompInstPage message handlers

BOOL CCompInstPage::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
	TOOLTIPTEXTA* pTTTA = (TOOLTIPTEXTA*)pNMHDR;
	TOOLTIPTEXTW* pTTTW = (TOOLTIPTEXTW*)pNMHDR;
	CString strTipText = "";
	UINT nID = pNMHDR->idFrom;
	if (pNMHDR->code == TTN_NEEDTEXTA && (pTTTA->uFlags & TTF_IDISHWND) ||
		pNMHDR->code == TTN_NEEDTEXTW && (pTTTW->uFlags & TTF_IDISHWND))
	{
		// idFrom is actually the HWND of the tool
		nID = ::GetDlgCtrlID((HWND)nID);
	}

	if (nID != 0) // will be zero on a separator
	{
		strTipText.Format("Control ID = %d", nID);
		switch (nID)
			{
			case IDC_NEXTCURVE_BUTTON:
				strTipText = "Go to (or add) the next curve";
				break;
			case IDC_DELETE_BUTTON:
				strTipText = "Delete curve";
				break;
			case IDC_COMPINST_PREFIL:
				strTipText = "Hz (0->99999)";
				break;
			case IDC_COMPINST_DELT:
				strTipText = "Microseconds (0->99999999)";
				break;
			case IDC_COMPINST_INIVEL:
				strTipText = "km/hr (-200.000->200.000)";
				break;
			case IDC_COMPINST_CHLMAX:
				strTipText = "% (Integer 0->999)";
				break;
			case IDC_COMPINST_VEHNO:
				strTipText = "1->2";
				break;
			case IDC_COMPINST_CMPNO:
				strTipText = "1->99";
				break;
			case IDC_COMPINST_CNFNO:
				strTipText = "1->999";
				break;
			case IDC_COMPINST_INSRAT:
				strTipText = "-999999->999999";
				break;
			case IDC_COMPINST_NFP:
				strTipText = "-10000->0";
				break;
			case IDC_COMPINST_NLP:
				strTipText = "0->99999";
				break;
			case IDC_COMPINSTDAT:
				strTipText = "Date (dd/MMM/yyyy)";
				break;
			default:
				strTipText = "";
			}
	}

	if (pNMHDR->code == TTN_NEEDTEXTA)
		lstrcpyn(pTTTA->szText, strTipText, sizeof(pTTTA->szText));
	else
		::MultiByteToWideChar( CP_ACP , 0, strTipText, -1, pTTTW->szText, sizeof(pTTTW->szText) );
	*pResult = 0;

	return TRUE;    // message was handled
}

BOOL CCompInstPage::OnKillActive() 
{
	if( ValidateInstPage() == true )
	{
		LoadCompInstData();
		
		int nOldCurIndx = m_icurno;
		for (m_icurno=1; m_icurno<m_totalcurves+1; m_icurno++)
		{
			DisplayCompInstData();
			if (!ValidateInstPage()) { return false; }
		}
		m_icurno = nOldCurIndx;

		DisplayCompInstData();

		return CPropertyPage::OnKillActive();
	}
	else
	{
		// Error are found on AnthPage.
		return FALSE;
	}
}

BOOL CCompInstPage::OnSetActive() 
{
	m_totalcurves=max(m_pCompData->m_totcrv , 0) ; //initialize total curves.
		
	SetBusinessRules();

	DisplayCompInstData();

	ValidateInstPage();
	
	return CPropertyPage::OnSetActive();
}

BOOL CCompInstPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	EnableToolTips();
	m_caldatctrl.SetFormat("dd'/'MMM'/'yyy");
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
	
// This function gets data from the entry screen and puts it into m_pCompData
// It is called from OnKillActive, ExportData, and record changed.
bool CCompInstPage::LoadCompInstData()
{
	//put data into m_pCompData

	if (m_hWnd==NULL) return TRUE;  //only return FALSE if Data invalid

	if (!UpdateData()) return FALSE;

	m_pCompData->m_axis[m_icurno] = m_editaxis.GetTextAsString();
	m_pCompData->m_chlmax[m_icurno] = m_editchlmax.GetTextAsString();
	m_pCompData->m_chstat[m_icurno] = m_editchstat.GetTextAsString();
	m_pCompData->m_Inst_cmpno[m_icurno] = m_editcmpno.GetTextAsString();
	m_pCompData->m_Inst_cnfno[m_icurno] = m_editcnfno.GetTextAsString();
	m_pCompData->m_Inst_vehno[m_icurno] = m_editvehno.GetTextAsString();
	m_pCompData->m_dastat[m_icurno] = m_editdastat.GetTextAsString();
	m_pCompData->m_delt[m_icurno] = m_editdelt.GetTextAsString();
	m_pCompData->m_inivel[m_icurno] = m_editinivel.GetTextAsString();
	m_pCompData->m_inscom[m_icurno] = m_editinscom.GetTextAsString();
	m_pCompData->m_insman[m_icurno] = m_editinsman.GetTextAsString();
	m_pCompData->m_insrat[m_icurno] = m_editinsrat.GetTextAsString();
	m_pCompData->m_nfp[m_icurno] = m_editnfp.GetTextAsString();
	m_pCompData->m_nlp[m_icurno] = m_editnlp.GetTextAsString();
	m_pCompData->m_prefil[m_icurno] = m_editprefil.GetTextAsString();
	m_pCompData->m_senatt[m_icurno] = m_editsenatt.GetTextAsString();
	m_pCompData->m_sentyp[m_icurno] = m_editsentyp.GetTextAsString();
	m_pCompData->m_xunits[m_icurno] = m_editxunits.GetTextAsString();
	m_pCompData->m_yunits[m_icurno] = m_edityunits.GetTextAsString();

	CString caldate;
	GetDlgItemText(IDC_COMPINSTDAT,caldate);
	m_pCompData->m_caldat[m_icurno]= caldate;

	m_pCompData->m_totcrv = m_totalcurves;
	m_pCompData->m_curno = m_totalcurves;

	UpdateData(false);

	return true;

}

// wong code in 03/02/00
bool CCompInstPage::InsertCompInstData()
{
	if (m_hWnd==NULL) return TRUE;  // only return FALSE if data invalid

	UpdateData();
	m_pCompData->m_axis.InsertAt( m_icurno, m_editaxis.GetTextAsString() );
	m_pCompData->m_chlmax.InsertAt( m_icurno, m_editchlmax.GetTextAsString() );
	m_pCompData->m_chstat.InsertAt( m_icurno, m_editchstat.GetTextAsString() );
	m_pCompData->m_Inst_cmpno.InsertAt( m_icurno, m_editcmpno.GetTextAsString() );
	m_pCompData->m_Inst_cnfno.InsertAt( m_icurno, m_editcnfno.GetTextAsString() );
	m_pCompData->m_Inst_vehno.InsertAt( m_icurno, m_editvehno.GetTextAsString() );
	m_pCompData->m_dastat.InsertAt( m_icurno, m_editdastat.GetTextAsString() );
	m_pCompData->m_delt.InsertAt( m_icurno, m_editdelt.GetTextAsString() );
	m_pCompData->m_inivel.InsertAt( m_icurno, m_editinivel.GetTextAsString() );
	m_pCompData->m_inscom.InsertAt( m_icurno, m_editinscom.GetTextAsString() );
	m_pCompData->m_insman.InsertAt( m_icurno, m_editinsman.GetTextAsString() );
	m_pCompData->m_insrat.InsertAt( m_icurno, m_editinsrat.GetTextAsString() );
	m_pCompData->m_nfp.InsertAt( m_icurno, m_editnfp.GetTextAsString() );
	m_pCompData->m_nlp.InsertAt( m_icurno, m_editnlp.GetTextAsString() );
	m_pCompData->m_prefil.InsertAt( m_icurno, m_editprefil.GetTextAsString() );
	m_pCompData->m_senatt.InsertAt( m_icurno, m_editsenatt.GetTextAsString() );
	m_pCompData->m_sentyp.InsertAt( m_icurno, m_editsentyp.GetTextAsString() );
	m_pCompData->m_xunits.InsertAt( m_icurno, m_editxunits.GetTextAsString() );
	m_pCompData->m_yunits.InsertAt( m_icurno, m_edityunits.GetTextAsString() );

	CString caldate;
	GetDlgItemText(IDC_COMPINST_CALDAT,caldate);
	m_pCompData->m_caldat.InsertAt( m_icurno, caldate );

	m_pCompData->m_totcrv = m_totalcurves;
	m_pCompData->m_curno = m_totalcurves;
	
	UpdateData(false);

	return true;
}	// InsertBioInstData

// get data from m_pCompData and display it.
void CCompInstPage::DisplayCompInstData()
{
	if (m_hWnd==NULL) return;

	UpdateCurveListbox();
	
	UpdateData();

	m_caldatctrl.SetTime(&(StringToTime(m_pCompData->m_caldat[m_icurno])));
	m_pCompData->m_caldat[m_icurno].MakeUpper();
	m_editinstdate = m_pCompData->m_caldat[m_icurno];
	m_editaxis = m_pCompData->m_axis[m_icurno];
	m_editchlmax = m_pCompData->m_chlmax[m_icurno];
	m_editchstat = m_pCompData->m_chstat[m_icurno];

	m_editcmpno = m_pCompData->m_Inst_cmpno[m_icurno];
	m_editvehno = m_pCompData->m_Inst_vehno[m_icurno];
	m_editcnfno = m_pCompData->m_Inst_cnfno[m_icurno];
	m_editdastat = m_pCompData->m_dastat[m_icurno];	
	m_editdelt = m_pCompData->m_delt[m_icurno];

	m_editinivel = m_pCompData->m_inivel [m_icurno];
	m_editinscom = m_pCompData->m_inscom[m_icurno];
	m_editinsman = m_pCompData->m_insman[m_icurno];
	m_editinsrat = m_pCompData->m_insrat[m_icurno];
	m_editnfp = m_pCompData->m_nfp[m_icurno];

	m_editnlp = m_pCompData->m_nlp[m_icurno];
	m_editprefil = m_pCompData->m_prefil[m_icurno];
	m_editsenatt = m_pCompData->m_senatt[m_icurno];
	m_editsentyp = m_pCompData->m_sentyp[m_icurno];
	m_editxunits = m_pCompData->m_xunits[m_icurno];

	m_edityunits = m_pCompData->m_yunits[m_icurno];

	if (m_editdelt.GetValidate()) { m_editdelt.SetColor(RGB( 0, 0, 0 ), RGB( 255, 255, 255 )); }
	CCodeValidation( m_editsentyp, "SENTYP","COMDB" );
	CCodeValidation( m_editsenatt, "SENATT","COMDB" );
	CCodeValidation( m_editaxis, "AXIS","COMDB" );
	CCodeValidation( m_editxunits, "UNITS","COMDB" );
	CCodeValidation( m_editdastat, "DASTAT","COMDB" );

	CCodeValidation( m_editchstat, "CHSTAT","COMDB" );
	CCodeValidation( m_edityunits, "UNITS","COMDB" );

	UpdateData(false);

	if (m_pCompData->m_xunits[m_icurno]=="SEC") { m_editdelt.EnableWindow(); }
	else 
	{ 
		m_editdelt.SetColor(RGB( 0, 0, 0 ), RGB( 192, 192, 192 ));
		m_editdelt.EnableWindow(false); 
	}
}

void CCompInstPage::OnNextcurveButton() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	if (m_icurno==m_totalcurves) //if at end, increase # of curves
	{
		if (m_icurno!=0) { LoadCompInstData(); }
		m_totalcurves++; 
		m_icurno++;
		InitializeNextCurve();
	} 
	else if (m_icurno != 0) 
	{
		if(!LoadCompInstData())
		{
			MessageBox("Error: see CCompInstPage::OnNextcurveButton()");
			return;
		}
		m_icurno++;
	}

	DisplayCompInstData();
	ValidateInstPage();
/***
	bool newcurve=false;

	if (m_icurno==m_totalcurves) //wong note: can be inserted between any two adjacent sets
	{
//		m_totalcurves++;  // wong commands it out in 03/02/00
		newcurve=true;
	}   

	if (m_icurno != 0)
	{
//		BOOL success = LoadCompInstData();     //load current info (not zeroth curve)
		if (!InsertCompInstData())	// wong note: should insert not just load
		{
			if (newcurve) m_totalcurves--;
			return;
		}
	}

	m_icurno++;             //goto next curve
	m_totalcurves++;		// wong added in 03/02/00

	if (newcurve) InitializeNextCurve();

	DisplayCompInstData();  //display next set, if existing
	ValidateInstPage();
***/
}

void CCompInstPage::OnDeleteButton() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	if (m_icurno==0) { return;  }

	m_totalcurves--;
	
	m_pCompData->m_axis.RemoveAt(m_icurno);
	m_pCompData->m_chlmax.RemoveAt(m_icurno);
	m_pCompData->m_chstat.RemoveAt(m_icurno);
	m_pCompData->m_Inst_cmpno.RemoveAt(m_icurno);
	m_pCompData->m_Inst_vehno.RemoveAt(m_icurno);
	m_pCompData->m_Inst_cnfno.RemoveAt(m_icurno);
	m_pCompData->m_dastat.RemoveAt(m_icurno);
	m_pCompData->m_delt.RemoveAt(m_icurno);
	m_pCompData->m_inivel.RemoveAt(m_icurno);
	m_pCompData->m_inscom.RemoveAt(m_icurno);
	m_pCompData->m_insman.RemoveAt(m_icurno);
	m_pCompData->m_insrat.RemoveAt(m_icurno);
	m_pCompData->m_nfp.RemoveAt(m_icurno);
	m_pCompData->m_nlp.RemoveAt(m_icurno);
	m_pCompData->m_prefil.RemoveAt(m_icurno);
	m_pCompData->m_senatt.RemoveAt(m_icurno);
	m_pCompData->m_sentyp.RemoveAt(m_icurno);
	m_pCompData->m_xunits.RemoveAt(m_icurno);
	m_pCompData->m_yunits.RemoveAt(m_icurno);

	m_icurno--;             //goto previous curve 

	//if m_icurno == 0 now, and there are remaining curves, set curve 1 as active (m_icurno=1)
	if (m_icurno==0 && m_totalcurves>0)
	{
		m_icurno = 1;
	}
		
	DisplayCompInstData();  //display previous set, if existing
	
}

void CCompInstPage::OnSentypSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"SENTYP","COMDB");
	if (search.DoModal ()==IDOK)
	{
		m_editsentyp = search_code;
		m_editsentyp.SetValidateColor();
	}
	UpdateData(FALSE);
}

void CCompInstPage::OnSenattSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"SENATT","COMDB");
	if (search.DoModal ()==IDOK)
	{
		m_editsenatt = search_code;
		m_editsenatt.SetValidateColor();
	}
	UpdateData(FALSE);
}

void CCompInstPage::OnAxisSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"AXIS","COMDB");
	if (search.DoModal ()==IDOK)
	{
		m_editaxis = search_code;
		m_editaxis.SetValidateColor();
	}
	UpdateData(FALSE);
}

void CCompInstPage::OnXUnitsSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"UNITS","COMDB");
	if (search.DoModal ()==IDOK)
	{
		m_editxunits = search_code;
		m_editxunits.SetValidateColor();

		COLORREF colorGreyBack = RGB( 192, 192, 192 );		
		COLORREF colorBlackText = RGB( 0, 0, 0 );
		if (search_code!="SEC") 
		{ 
			m_editdelt = "0";
			m_editdelt.SetColor(colorBlackText, colorGreyBack);
			m_editdelt.EnableWindow(false);
		}
		else 
		{ 
			m_editdelt.EnableWindow();
			COLORREF colorYellowBack = RGB( 255, 255, 0 );
			COLORREF colorWhiteBack = RGB( 255, 255, 255 );
			m_editdelt = m_pCompData->m_delt[m_icurno];			
			if (m_editdelt.GetValidate()) { m_editdelt.SetColor(colorBlackText, colorWhiteBack); }
			else { m_editdelt.SetColor(colorBlackText, colorYellowBack); }
		}
	}
	UpdateData(FALSE);
}

void CCompInstPage::OnDastatSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"DASTAT","COMDB");
	if (search.DoModal ()==IDOK)
	{
		m_editdastat = search_code;
		m_editdastat.SetValidateColor();
	}
	UpdateData(FALSE);
}

void CCompInstPage::OnChstatSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"CHSTAT","COMDB");
	if (search.DoModal ()==IDOK)
	{
		m_editchstat = search_code;
		m_editchstat.SetValidateColor();
	}
	UpdateData(FALSE);
}

void CCompInstPage::OnYUnitsSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"UNITS","COMDB");
	if (search.DoModal ()==IDOK)
	{
		m_edityunits = search_code;
		m_edityunits.SetValidateColor();
	}
	UpdateData(FALSE);
}


// new curve, so expand arrays in m_pCompData for new info
void CCompInstPage::InitializeNextCurve()
{

	// *******************************************
	//These temp variables are used because the reference that [] returns is invalid when SetAtGrow
	// happens, because SetAtGrow (sometimes) moves the array to a different location in memory.   
	// If you try to use that reference directly, you will get an access violation.
	// For Example:  m_pCompData->m_inscom.SetAtGrow (m_icurno,m_pCompData->inscom[m_icurno-1]); //BAD!!!!
	CString itemp;       
	CString strtemp; 
	CString dwtemp;    
	CString ftemp;
	// *******************************************

	if (m_retaindata)
	{
		strtemp = m_pCompData->m_axis[m_icurno -1];
		m_pCompData->m_axis.SetAtGrow(m_icurno,strtemp);

		dwtemp = m_pCompData->m_chlmax[m_icurno -1];
		m_pCompData->m_chlmax.SetAtGrow(m_icurno,dwtemp);

		strtemp = m_pCompData->m_chstat[m_icurno -1];
		m_pCompData->m_chstat.SetAtGrow(m_icurno,strtemp);

		dwtemp = m_pCompData->m_Inst_cmpno[m_icurno -1];
		m_pCompData->m_Inst_cmpno.SetAtGrow(m_icurno,dwtemp);

		dwtemp = m_pCompData->m_Inst_vehno[m_icurno -1];
		m_pCompData->m_Inst_vehno.SetAtGrow(m_icurno,dwtemp);

		dwtemp = m_pCompData->m_Inst_cnfno[m_icurno -1];
		m_pCompData->m_Inst_cnfno.SetAtGrow(m_icurno,dwtemp);

		strtemp = m_pCompData->m_dastat[m_icurno -1];
		m_pCompData->m_dastat.SetAtGrow(m_icurno,strtemp);

		dwtemp = m_pCompData->m_delt[m_icurno -1];
		m_pCompData->m_delt.SetAtGrow(m_icurno,dwtemp);

		ftemp =m_pCompData->m_inivel[m_icurno -1];
		m_pCompData->m_inivel.SetAtGrow(m_icurno,ftemp);

		strtemp = m_pCompData->m_inscom[m_icurno -1];
		m_pCompData->m_inscom.SetAtGrow(m_icurno,strtemp);

		strtemp = m_pCompData->m_insman[m_icurno -1];
		m_pCompData->m_insman.SetAtGrow(m_icurno,strtemp);

		itemp = m_pCompData->m_insrat[m_icurno-1];
		m_pCompData->m_insrat.SetAtGrow(m_icurno,itemp);

		itemp = m_pCompData->m_nfp[m_icurno-1];
		m_pCompData->m_nfp.SetAtGrow(m_icurno,itemp);

		itemp = m_pCompData->m_nlp[m_icurno-1];
		m_pCompData->m_nlp.SetAtGrow(m_icurno,itemp);

		dwtemp = m_pCompData->m_prefil[m_icurno-1];
		m_pCompData->m_prefil.SetAtGrow(m_icurno,dwtemp);

		strtemp = m_pCompData->m_senatt[m_icurno -1];
		m_pCompData->m_senatt.SetAtGrow(m_icurno,strtemp);

		strtemp = m_pCompData->m_sentyp[m_icurno -1];
		m_pCompData->m_sentyp.SetAtGrow(m_icurno,strtemp);

		strtemp = m_pCompData->m_xunits[m_icurno -1];
		m_pCompData->m_xunits.SetAtGrow(m_icurno,strtemp);

		strtemp = m_pCompData->m_yunits[m_icurno -1];
		m_pCompData->m_yunits.SetAtGrow(m_icurno,strtemp);

		strtemp = m_pCompData->m_caldat[m_icurno -1];
		m_pCompData->m_caldat.SetAtGrow (m_icurno, strtemp);

	}
	else
	{
		m_pCompData->m_axis.SetAtGrow(m_icurno,"");
		m_pCompData->m_chlmax.SetAtGrow(m_icurno,"");
		m_pCompData->m_chstat.SetAtGrow(m_icurno,"");
		m_pCompData->m_Inst_cmpno.SetAtGrow(m_icurno,"");
		m_pCompData->m_Inst_vehno.SetAtGrow(m_icurno,"");
		m_pCompData->m_Inst_cnfno.SetAtGrow(m_icurno,"");
		m_pCompData->m_dastat.SetAtGrow(m_icurno,"");
		m_pCompData->m_delt.SetAtGrow(m_icurno,"");
		m_pCompData->m_inivel.SetAtGrow(m_icurno,"");
		m_pCompData->m_inscom.SetAtGrow(m_icurno,"");
		m_pCompData->m_insman.SetAtGrow(m_icurno,"");
		m_pCompData->m_insrat.SetAtGrow(m_icurno,"");
		m_pCompData->m_nfp.SetAtGrow(m_icurno,"");
		m_pCompData->m_nlp.SetAtGrow(m_icurno,"");
		m_pCompData->m_prefil.SetAtGrow(m_icurno,"");
		m_pCompData->m_senatt.SetAtGrow(m_icurno,"");
		m_pCompData->m_sentyp.SetAtGrow(m_icurno,"");
		m_pCompData->m_xunits.SetAtGrow(m_icurno,"SEC");
		m_pCompData->m_yunits.SetAtGrow(m_icurno,"");
		m_pCompData->m_caldat.SetAtGrow(m_icurno,"");
		
		//  The caldat field is grown above.  Here, just set the control to today.
		CTime now;
		now= CTime::GetCurrentTime ();
		m_caldatctrl.SetTime(&now);
	}

}

// associate the listbox with m_totalcurves
void CCompInstPage::UpdateCurveListbox()
{
	if (m_curvelist.GetCount ()!=m_totalcurves)
	{
		m_curvelist.ResetContent();
		char crvbuf [10];
		for (int loop=1;loop <= m_totalcurves;loop++)
		{
			itoa(loop,crvbuf,10);
			if (m_curvelist.FindString (-1,crvbuf)==LB_ERR)  //if buf isnt there already.
			{
				m_curvelist.AddString(crvbuf);
			}
		}
	}

	m_curvelist.SetCurSel (max(0,m_icurno-1));  // select current curve, zero based.
	
}

// user clicked the curves listbox, so change to that curve
void CCompInstPage::OnSelchangeCurvelist() 
{
	int nCurve = m_curvelist.GetCurSel ();  //zero based

	if (m_icurno != 0) 
	{
		BOOL success = LoadCompInstData();     //load current info (not zeroth curve)
		if (!success) //Data not valid, dont change curves.
		{
			m_curvelist.SetCurSel (max(0,m_icurno-1));  // select current curve, zero based.
			return;
		}
	}

	m_icurno= nCurve+1;             //goto current curve 

	DisplayCompInstData();  //display next set, if existing	
	ValidateInstPage();
}

BOOL CCompInstPage::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	WinHelp(Instruments);
	
	return TRUE;
}

// new  added
//
bool CCompInstPage::ValidateInstPage( )
{
	const int nTotal = 20;
	bool bRetArray[nTotal];

	bRetArray[0] = m_editinscom.GetValidate();
	bRetArray[1] = m_editinsman.GetValidate();
	bRetArray[2] = m_editcmpno.GetValidate();
	bRetArray[3] = m_editcnfno.GetValidate();
	bRetArray[4] = m_editvehno.GetValidate();
	bRetArray[5] = m_editinsrat.GetValidate();
	bRetArray[6] = m_editchlmax.GetValidate();
	bRetArray[7] = m_editinivel.GetValidate();
	bRetArray[8] = m_editnfp.GetValidate();
	bRetArray[9] = m_editnlp.GetValidate();
	bRetArray[10] = m_editdelt.GetValidate();
	bRetArray[11] = m_editprefil.GetValidate();
	bRetArray[12] = m_editinstdate.GetValidate();
	
	bRetArray[13]	= m_editsentyp.GetValidate();
	bRetArray[14]	= m_editsenatt.GetValidate();
	bRetArray[15]	= m_editaxis.GetValidate();
	bRetArray[16]	= m_editxunits.GetValidate();
	bRetArray[17]	= m_editdastat.GetValidate();

	bRetArray[18]	= m_editchstat.GetValidate();
	bRetArray[19]	= m_edityunits.GetValidate();

	for(int i=0; i<nTotal; i++) { if (!bRetArray[i]) return false; }
	return true;
}	// ValidateAnthPage

void CCompInstPage::SetBusinessRules( )
{
	 m_editinscom.SetString( 0, 70 );
	 m_editinsman.SetString( 0, 70 );
	 m_editcmpno.SetDouble( 1, 99);
	 m_editcnfno.SetDouble( 1, 999 );
	 m_editvehno.SetDouble( 1, 2 );
	 m_editinsrat.SetDouble( -999999, 999999);
	 m_editchlmax.SetDouble( 0, 999);
	 m_editinivel.SetDouble( -200.f, 200.f);
	 m_editnfp.SetDouble( -99999, 99999 );
	 m_editnlp.SetDouble( -99999, 99999);
	 m_editdelt.SetDouble( 0, 999999.);
	 m_editprefil.SetDouble( 0, 99999);
	 m_editinstdate.SetDate();
}	// SetBusinessRules

void CCompInstPage::OnDatetimechangeCompinstCaldat(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CString sDate;
    GetDlgItemText(IDC_COMPINST_CALDAT, sDate);

	sDate.MakeUpper();
	m_editinstdate =  m_pCompData->m_caldat[m_icurno] = sDate;
	
	*pResult = 0;
}
