// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: CompTestPage.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description:  Member functions of CCompTestPage.
//               They relate to the loading and display of 
//               data on this page.
//
//  Date		Who			Description
//	2000    Y. Wong Adding business rules, recode all edit boxs
//					and correct other errors.
// -----------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "CompTestPage.h"
#include "search.h"
#include "CodeValidation.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CString search_code;
/////////////////////////////////////////////////////////////////////////////
// CCompTestPage property page

IMPLEMENT_DYNCREATE(CCompTestPage, CPropertyPage)

CCompTestPage::CCompTestPage() : CPropertyPage(CCompTestPage::IDD)
{
	//{{AFX_DATA_INIT(CCompTestPage)
	m_edittstdate	= _T("");
	m_editconno		= _T("");
	m_edittitle		= _T("");
	m_edittotcrv	= _T("");
	m_edittstcom	= _T("");
	m_edittstobj	= _T("");
	m_edittstprf	= _T("");
	m_edittstref	= _T("");
	m_edittsttyp	= _T("");
	m_editverno		= _T("C5");
	m_edittemp		= _T("");
	//}}AFX_DATA_INIT
}

CCompTestPage::~CCompTestPage()
{
}

void CCompTestPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCompTestPage)
	DDX_Control(pDX, IDC_COMPTESTDAT, m_edittstdate);
	DDX_Control(pDX, IDC_COMPTESTTSTDAT, m_tstdatctrl);
	DDX_Control(pDX, IDC_COMPTESTCONNO, m_editconno);
	DDX_Control(pDX, IDC_COMPTESTTITLE, m_edittitle);
	DDX_Control(pDX, IDC_COMPTESTTOTCRV, m_edittotcrv);
	DDX_Control(pDX, IDC_COMPTESTTSTCOM, m_edittstcom);
	DDX_Control(pDX, IDC_COMPTESTTSTOBJ, m_edittstobj);
	DDX_Control(pDX, IDC_COMPTESTTSTPRF, m_edittstprf);
	DDX_Control(pDX, IDC_COMPTESTTSTREF, m_edittstref);
	DDX_Control(pDX, IDC_COMPTESTTSTTYP, m_edittsttyp);
	DDX_Control(pDX, IDC_COMPTESTVERNO, m_editverno);
	DDX_Control(pDX, IDC_COMPTESTTEMP, m_edittemp);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCompTestPage, CPropertyPage)
	//{{AFX_MSG_MAP(CCompTestPage)
	ON_BN_CLICKED(IDC_COMPTSTTYP_SEARCH, OnComptsttypSearch)
	ON_BN_CLICKED(IDC_COMPTSTPRF_SEARCH, OnComptstprfSearch)
	ON_WM_HELPINFO()
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTW, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTA, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY(DTN_DATETIMECHANGE, IDC_COMPTESTTSTDAT, OnDatetimechangeComptesttstdat)
	ON_COMMAND(ID_HELP, OnHelpFinder)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCompTestPage message handlers

BOOL CCompTestPage::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
	TOOLTIPTEXTA* pTTTA = (TOOLTIPTEXTA*)pNMHDR;
	TOOLTIPTEXTW* pTTTW = (TOOLTIPTEXTW*)pNMHDR;
	CString strTipText = "";
	UINT nID = pNMHDR->idFrom;
	if (pNMHDR->code == TTN_NEEDTEXTA && (pTTTA->uFlags & TTF_IDISHWND) ||
		pNMHDR->code == TTN_NEEDTEXTW && (pTTTW->uFlags & TTF_IDISHWND))
	{
		// idFrom is actually the HWND of the tool
		nID = ::GetDlgCtrlID((HWND)nID);
	}

	if (nID != 0) // will be zero on a separator
	{
		strTipText.Format("Control ID = %d", nID);
		switch (nID)
			{
			case IDC_COMPTESTTEMP:
				strTipText = "Degrees Celsius (-99->99)";
				break;
			case IDC_COMPTESTDAT:
				strTipText = "Date (dd/MMM/yyyy)";
				break;
			default:
				strTipText = "";
			}
	}

	if (pNMHDR->code == TTN_NEEDTEXTA)
		lstrcpyn(pTTTA->szText, strTipText, sizeof(pTTTA->szText));
	else
		::MultiByteToWideChar( CP_ACP , 0, strTipText, -1, pTTTW->szText, sizeof(pTTTW->szText) );
	*pResult = 0;

	return TRUE;    // message was handled
}

BOOL CCompTestPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	

	CancelToClose();
	EnableToolTips();	
	
	m_tstdatctrl.SetFormat("dd'/'MMM'/'yyy");

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCompTestPage::OnComptsttypSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"TSTTYP","COMDB");
	if (search.DoModal ()==IDOK)
	{
		m_edittsttyp = search_code;
		m_edittsttyp.SetValidateColor();
	}
	UpdateData(FALSE);
}

void CCompTestPage::OnComptstprfSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"TSTPRF","COMDB");
	if (search.DoModal ()==IDOK)
	{
		m_edittstprf = search_code;
		m_edittstprf.SetValidateColor();
	}
	UpdateData(FALSE);
}

// This function gets data from the entry screen and puts it into m_pCompData
// It is called from OnKillActive, ExportData, and record changed.
BOOL CCompTestPage::LoadCompTestData()
{
	// put data into m_pCompData
	UpdateData(TRUE);

	m_pCompData->m_verno = m_editverno.GetTextAsString();
	m_pCompData->m_title = m_edittitle.GetTextAsString();
	m_pCompData->m_tstobj= m_edittstobj.GetTextAsString();
	m_pCompData->m_tstprf= m_edittstprf.GetTextAsString();
	m_pCompData->m_conno = m_editconno.GetTextAsString();
	m_pCompData->m_tsttyp= m_edittsttyp.GetTextAsString();
	m_pCompData->m_tstref= m_edittstref.GetTextAsString();
	m_pCompData->m_temp  = m_edittemp.GetTextAsString();
	m_pCompData->m_totcrv= atoi(m_edittotcrv.GetTextAsString());
	m_pCompData->m_tstcom= m_edittstcom.GetTextAsString();

	CString testdate;
//    GetDlgItemText(IDC_COMPTESTTSTDAT, testdate);
	GetDlgItemText(IDC_COMPTESTDAT, testdate);
	m_pCompData->m_tstdat=testdate;

	m_edittstdate = testdate;
	UpdateData(false);
	return TRUE;

}

//Get data from m_pCompData and display it.
void CCompTestPage::DisplayCompTestData()
{
	char buf [100];

	m_editverno	= m_pCompData->m_verno;
	m_edittitle = m_pCompData->m_title;
	m_edittstobj= m_pCompData->m_tstobj;
	m_edittstprf= m_pCompData->m_tstprf;
	m_editconno = m_pCompData->m_conno;

	m_edittsttyp= m_pCompData->m_tsttyp;
	m_edittstref= m_pCompData->m_tstref;
	m_edittemp	= m_pCompData->m_temp;
	itoa(m_pCompData->m_totcrv, buf, 10);
	m_edittotcrv = buf;
	m_edittstcom = m_pCompData->m_tstcom;
	
	m_tstdatctrl.SetTime(&(StringToTime(m_pCompData->m_tstdat)));
	m_pCompData->m_tstdat.MakeUpper();
	m_edittstdate = m_pCompData->m_tstdat;

	CCodeValidation( m_edittsttyp, "TSTTYP","COMDB" );
	CCodeValidation( m_edittstprf, "TSTPRF","COMDB" );

	UpdateData(FALSE);
}

BOOL CCompTestPage::OnKillActive() 
{
	if( ValidateTestPage() == true )
	{
		LoadCompTestData();

		return CPropertyPage::OnKillActive();
	}
	else
	{
		// Error are found on AnthPage.
		return FALSE;
	}
}

BOOL CCompTestPage::OnSetActive() 
{
	EnableToolTips();

	SetBusinessRules();

	DisplayCompTestData();

	ValidateTestPage();
	
	return CPropertyPage::OnSetActive();

}

BOOL CCompTestPage::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	WinHelp(Test_Information);
	
	return TRUE;
}

// new  added
//
bool CCompTestPage::ValidateTestPage( )
{
	const int nTotal = 10;
	bool bRetArray[nTotal];

	bRetArray[0] = m_editconno.GetValidate();
	bRetArray[1] = m_edittitle.GetValidate();
	bRetArray[2] = m_edittstcom.GetValidate();
	bRetArray[3] = m_edittstobj.GetValidate();
	bRetArray[4] = m_edittstref.GetValidate();
	bRetArray[5] = m_editverno.GetValidate();
	bRetArray[6] = m_edittemp.GetValidate();
	bRetArray[7] = m_edittstdate.GetValidate();
	
	bRetArray[8]	= m_edittsttyp.GetValidate();
	bRetArray[9]	= m_edittstprf.GetValidate();

	for(int i=0; i<nTotal; i++) { if (!bRetArray[i]) return false; }
	return true;
}	// ValidateAnthPage

void CCompTestPage::SetBusinessRules( )
{
	 m_editconno.SetString( 0, 17 );
	 m_edittitle.SetString( 0, 70);
	 m_edittstcom.SetString( 0, 70);
	 m_edittstobj.SetString( 0, 70);
	 m_edittstref.SetString( 0, 10);
	 m_editverno.SetString( 0, 2);
	 m_edittemp.SetDouble( -99, 99 );
	 m_edittstdate.SetDate();
}	// SetBusinessRules

void CCompTestPage::OnDatetimechangeComptesttstdat(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	CString sDate;
    GetDlgItemText(IDC_COMPTESTTSTDAT, sDate);

	sDate.MakeUpper();
	m_edittstdate =  m_pCompData->m_tstdat = sDate;

	*pResult = 0;
}
