// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: CompVehPage.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description:  Member functions of CCompVehPage.
//               They relate to the loading and display of 
//               data on this page.
//
//  Date		Who			Description
//	2000    Y. Wong Adding business rules, recode all edit boxs
//					and correct other errors.
//	2003    Use new tooltip functions
// -----------------------------------------


#include "stdafx.h"
#include "entreeV5.h"
#include "CompVehPage.h"
#include "search.h"
#include "CodeValidation.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CString search_code;


/////////////////////////////////////////////////////////////////////////////
// CCompVehPage property page

IMPLEMENT_DYNCREATE(CCompVehPage, CPropertyPage)

CCompVehPage::CCompVehPage() : CPropertyPage(CCompVehPage::IDD)
{
	//{{AFX_DATA_INIT(CCompVehPage)
	m_editbody		= _T("");
	m_editcrtest	= _T("");
	m_editmake		= _T("");
	m_editmodel		= _T("");
	m_editnhtsano	= _T("");
	m_editvehcom	= _T("");
	m_editvehno		= _T("");
	m_editvin		= _T("");
	m_edityear		= _T("");;
	//}}AFX_DATA_INIT
}

CCompVehPage::~CCompVehPage()
{
}

void CCompVehPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCompVehPage)
	DDX_Control(pDX, IDC_VEHNOSPIN, m_vehnospin);
	DDX_Control(pDX, IDC_COMPVEHBODY, m_editbody);
	DDX_Control(pDX, IDC_COMPVEHCRTEST, m_editcrtest);
	DDX_Control(pDX, IDC_COMPVEHMAKE, m_editmake);
	DDX_Control(pDX, IDC_COMPVEHMODEL, m_editmodel);
	DDX_Control(pDX, IDC_COMPVEHNHTSANO, m_editnhtsano);
//	DDV_MaxChars(pDX, m_nhtsano, 6);
	DDX_Control(pDX, IDC_COMPVEHVEHCOM, m_editvehcom);
//	DDV_MaxChars(pDX, m_vehcom, 70);
	DDX_Control(pDX, IDC_COMPVEHVEHNO, m_editvehno);
	DDX_Control(pDX, IDC_COMPVEHVIN, m_editvin);
//	DDV_MaxChars(pDX, m_vin, 20);
	DDX_Control(pDX, IDC_COMPVEHYEAR, m_edityear);
//	DDV_MinMaxDWord(pDX, m_year, 1900, 9999);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCompVehPage, CPropertyPage)
	//{{AFX_MSG_MAP(CCompVehPage)
	ON_BN_CLICKED(IDC_COMPVEHMAKE_SEARCH, OnCompvehmakeSearch)
	ON_BN_CLICKED(IDC_COMPVEHMODEL_SEACH, OnCompvehmodelSeach)
	ON_BN_CLICKED(IDC_COMPVEHBODY_SEARCH, OnCompvehbodySearch)
	ON_NOTIFY(UDN_DELTAPOS, IDC_VEHNOSPIN, OnDeltaposVehnospin)
	ON_BN_CLICKED(IDC_COMPCRTEST_SEARCH, OnCompcrtestSearch)
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTW, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTA, 0, 0xFFFF, OnToolTipNotify )
	ON_COMMAND(ID_HELP,OnHelpFinder)
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCompVehPage message handlers

BOOL CCompVehPage::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
	TOOLTIPTEXTA* pTTTA = (TOOLTIPTEXTA*)pNMHDR;
	TOOLTIPTEXTW* pTTTW = (TOOLTIPTEXTW*)pNMHDR;
	CString strTipText = "";
	UINT nID = pNMHDR->idFrom;
	if (pNMHDR->code == TTN_NEEDTEXTA && (pTTTA->uFlags & TTF_IDISHWND) ||
		pNMHDR->code == TTN_NEEDTEXTW && (pTTTW->uFlags & TTF_IDISHWND))
	{
		// idFrom is actually the HWND of the tool
		nID = ::GetDlgCtrlID((HWND)nID);
	}

	if (nID != 0) // will be zero on a separator
	{
		strTipText.Format("Control ID = %d", nID);
		switch (nID)
		{
		case IDC_COMPVEHYEAR:
			strTipText = "1900->9999";
			break;
		default:
			strTipText = "";
		}
	}

	if (pNMHDR->code == TTN_NEEDTEXTA)
		lstrcpyn(pTTTA->szText, strTipText, sizeof(pTTTA->szText));
	else
		::MultiByteToWideChar( CP_ACP , 0, strTipText, -1, pTTTW->szText, sizeof(pTTTW->szText) );
	*pResult = 0;

	return TRUE;    // message was handled
}


void CCompVehPage::OnCompvehmakeSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"MAKE","COMDB");
	if (search.DoModal ()==IDOK)
	{
		if (search_code!=m_editmake.GetTextAsString())  // if you change the make, reset the model.
		{
			m_editmodel="";
		}
		m_editmake = search_code;
		m_editmake.SetValidateColor();
	}
	UpdateData(FALSE);
}

void CCompVehPage::OnCompvehmodelSeach() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	if ( m_editmake.GetTextAsString()==("") )
	{
		MessageBox("Please enter 'Vehicle Make' prior to searching 'Vehicle Model'.");
		return;	
	}

	UpdateData(TRUE);  //First save data

	// Pass the whole SQL Select line because choices are narrowed based on MAKE.
	CSearch search(NULL, "MODEL","",
		"SELECT MODEL,MODELD,MODEL_COMMENT FROM NHTSADB_MODEL WHERE MAKE LIKE '"+m_editmake.GetTextAsString()+"%' AND REFERENCE LIKE '%COMDB%' ORDER BY MODEL");
	
	if (search.DoModal ()==IDOK)
	{
		m_editmodel = search_code.Right (2);
		UpdateData(FALSE);
	}
	
}

void CCompVehPage::OnCompvehbodySearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"BODY","COMDB");
	if (search.DoModal ()==IDOK)
	{
		m_editbody = search_code;
		m_editbody.SetValidateColor();
	}
	UpdateData(FALSE);
}

void CCompVehPage::OnDeltaposVehnospin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	
	int pos = pNMUpDown->iPos;   //current position, before the change
	int delt = pNMUpDown->iDelta;//change direction, +1 or -1

	if (pos==2 && delt==-1)
	{
		//going down, m_vehno currently equals 2
		if(!LoadCompVehData()) return;

		m_editvehno = "1";   //Needs to be changed here before call to DisplayVehVehData.
						 //It would happen automatically later.
		DisplayCompVehData();
	
	}
	else if (pos==1 && delt==1)
	{
		// going up, m_vehno currently equals 1   
		if (!LoadCompVehData()) return;

		m_editvehno = "2";    //Needs to be changed here before call to DisplayVehVehData.
						 //It would happen automatically later.
		DisplayCompVehData();
	
	}
	*pResult = 0;
}

//Get Data from m_pCompData and Display it.
void CCompVehPage::DisplayCompVehData()
{
	//get data from m_pVehData and display it

	int i = atoi(m_editvehno.GetTextAsString());

	m_editbody		= m_pCompData->m_body[i] ;
	m_editcrtest	= m_pCompData->m_crtest[i];
	m_editmake		= m_pCompData->m_make[i];
	m_editmodel		= m_pCompData->m_model[i];
	m_editnhtsano	= m_pCompData->m_nhtsano[i];

	m_editvehcom	= m_pCompData->m_vehcom[i];
	m_editvin		= m_pCompData->m_vin[i];
	m_edityear		= m_pCompData->m_year[i];
	
	CCodeValidation( m_editmake, "MAKE","COMDB" );
	CCodeValidation( m_editbody, "BODY","COMDB" );
	CCodeValidation( m_editcrtest, "CRTEST","COMDB" );

	UpdateData(FALSE);

}

// This function gets data from the entry screen and puts it into m_pCompData
// It is called from OnKillActive, ExportData, and record changed.
BOOL CCompVehPage::LoadCompVehData()
{
	if (m_hWnd==NULL) return TRUE;  //only return FALSE if data invalid
	BOOL success = UpdateData(TRUE);
	if (!success) return FALSE;

	// if you advanced to a new vehno, set m_pCompData->m_vehno.
	int i = atoi(m_editvehno.GetTextAsString());
	if ( i > m_pCompData->m_vehno )
	{
		m_pCompData->m_vehno= i; // atoi(m_vehno);
	}
	
	//put data into m_pVehData
	m_pCompData->m_body[i]		= m_editbody.GetTextAsString();
	m_pCompData->m_crtest[i]	= m_editcrtest.GetTextAsString();
	m_pCompData->m_make[i]		= m_editmake.GetTextAsString();
	m_pCompData->m_model[i]		= m_editmodel.GetTextAsString();
	m_pCompData->m_nhtsano[i]	= m_editnhtsano.GetTextAsString();
	m_pCompData->m_vehcom[i]	= m_editvehcom.GetTextAsString();
	m_pCompData->m_vin[i]		= m_editvin.GetTextAsString();
	m_pCompData->m_year[i]		= m_edityear.GetTextAsString();

	return TRUE;
	
}

BOOL CCompVehPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	EnableToolTips();
	
//char buf [100];
//	itoa(m_pCompData->m_vehno, buf, 10);
	m_editvehno = "1";

	m_vehnospin.SetRange (1,2);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CCompVehPage::OnKillActive() 
{
	if( ValidateSpinControl() == false )
	{
		return FALSE;
	}

	if( ValidateVehPage() == true )
	{
		LoadCompVehData();

		return CPropertyPage::OnKillActive();
	}
	else
	{
		// Error are found on AnthPage.
		return FALSE;
	}
}

BOOL CCompVehPage::OnSetActive() 
{	
	m_editmodel.SetColor(RGB( 0, 0, 0 ), RGB( 192, 192, 192 )); // grey backgroud

	SetBusinessRules();

	DisplayCompVehData();

	ValidateVehPage();
	
	return CPropertyPage::OnSetActive();
}

void CCompVehPage::OnCompcrtestSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"CRTEST","COMDB");
	if (search.DoModal ()==IDOK)
	{
		m_editcrtest = search_code;
		m_editcrtest.SetValidateColor();
	}
	UpdateData(FALSE);
}

BOOL CCompVehPage::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	WinHelp(Vehicular_Information);
	
	return TRUE;
}

// new  added
//
bool CCompVehPage::ValidateVehPage( )
{
	const int nTotal = 7;
	bool bRetArray[nTotal];

	bRetArray[0] = m_editnhtsano.GetValidate();
	bRetArray[1] = m_editvehcom.GetValidate();
	bRetArray[2] = m_editvin.GetValidate();
	bRetArray[3] = m_edityear.GetValidate();
	
	bRetArray[4]	= m_editmake.GetValidate();
	bRetArray[5]	= m_editbody.GetValidate();
	bRetArray[6]	= m_editcrtest.GetValidate();

	for(int i=0; i<nTotal; i++) { if (!bRetArray[i]) return false; }
	return true;
}	// ValidateAnthPage

void CCompVehPage::SetBusinessRules( )
{
	m_editnhtsano.SetString( 0, 6);
	m_editvehcom.SetString( 0, 70);
	m_editvin.SetString( 0, 20);
	m_edityear.SetDouble( 1900, 9999 );
}	// SetBusinessRules

bool CCompVehPage::ValidateSpinControl( void )
{
	if( ValidateVehPage() == false  )
	{
		return false;
	}

	CString cstrValue("");

	CSpinButtonCtrl * pSpin = NULL;

	GetDlgItemText( IDC_COMPVEHVEHNO, cstrValue );

	pSpin = (CSpinButtonCtrl *)GetDlgItem( IDC_VEHNOSPIN );
	pSpin->SetRange( 1, 2 );

	if( cstrValue == "1" )
	{
		// going up, m_vehno currently equals 1   
		if (!LoadCompVehData())
		{
			return false;
		}

		//Needs to be changed here before call to DisplayVehVehData.
		SetDlgItemText( IDC_COMPVEHVEHNO, _T("2") );
		 //It would happen automatically later.
		DisplayCompVehData();

		pSpin->SetPos( 2 );

		if( ValidateVehPage() == false  )
		{
			return false;
		}
	}
	
	if( cstrValue == "2" )
	{
		// going up, m_vehno currently equals 1   
		if (!LoadCompVehData())
		{
			return false;
		}

		//Needs to be changed here before call to DisplayVehVehData.
		SetDlgItemText( IDC_COMPVEHVEHNO, _T("1") );
		 //It would happen automatically later.
		DisplayCompVehData();

		pSpin->SetPos( 1 );

		if( ValidateVehPage() == false  )
		{
			return false;
		}
	}

	return true;
}