// CNEdit.cpp : implementation file
//

#include "stdafx.h"
#include "entreeV5.h"
#include "EditEx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning(disable: 4100) // turn off "unreferenced formal parameter" warning 

/////////////////////////////////////////////////////////////////////////////
// CNEdit

/*lint -esym(1539, CNEdit::m_* ) */		// members not assigned in assignment operators


/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
CNEdit::CNEdit() :
	CEdit(),
	m_bReadOnly(false),
	m_bRequired(false),
	m_bNumber(false),
	m_bString(false),
	m_bMoney(false),
	m_bDate(false),
	m_bPhoneNumber(false),
	m_bEmptyIfZero(false),
	m_nMaxCharacters(0),
	m_nMinCharacters(0),
	m_clrText(0),
	m_clrBkgnd(0),
	m_RequiredBrush(),
	m_NormalBrush(),
	m_sWindowText()
{

	m_clrText	= RGB( 0, 0, 0 );
	m_clrBkgdErr = RGB( 255, 255, 0 );
	m_clrBkgdOk	= RGB( 255, 255, 255 );

	m_clrRed = RGB( 255, 0, 0 );
	m_bValidate = true;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
CNEdit::~CNEdit()
{
}


// Assignment operators so that we can simplify the code written
/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
const CNEdit& CNEdit::operator = ( const CNEdit & e )
{
	CString csPriorWindowText = m_sWindowText;

	if ( !( &e == this || e == *this ) )
	{
		m_sWindowText = e.m_sWindowText;
		m_sWindowText.TrimLeft();
		m_sWindowText.TrimRight();

		m_bReadOnly			= e.m_bReadOnly;
		m_bRequired			= e.m_bRequired;
		m_bNumber			= e.m_bNumber;
		m_bString			= e.m_bString;
		m_bMoney			= e.m_bMoney;
		m_bDate				= e.m_bDate;
		m_bEmptyIfZero		= e.m_bEmptyIfZero;
		m_nMaxCharacters	= e.m_nMaxCharacters;
		m_nMinCharacters	= e.m_nMinCharacters;
		m_clrText			= e.m_clrText;
		m_clrBkgnd			= e.m_clrBkgnd;


		if ( 0 != m_sWindowText.Compare( csPriorWindowText ) )
		{
			if ( ::IsWindow(m_hWnd) )
			{
				SetWindowText( m_sWindowText );
			}
		}
	}

	return *this;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
void CNEdit::operator = ( const COleDateTime & d )
{
	CString csPriorWindowText = m_sWindowText;

	
	CString s;

	if ( COleDateTime::valid == d.GetStatus() )
	{
		if ( 6 == m_nMinCharacters )
		{
			s = d.Format( "%m%d%y" );
		}
		else
		if ( 8 == m_nMinCharacters )
		{
			s = d.Format( "%m%d%Y" );
		}
		else
		{
			s = d.Format( "%b %d, %Y" );
		}
	}

	m_sWindowText = s;

	if ( 0 != m_sWindowText.Compare( csPriorWindowText ) )
	{
		if ( ::IsWindow(m_hWnd) )
		{
			SetWindowText( m_sWindowText );
		}
	}
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
void CNEdit::operator = ( const COleCurrency & m )
{
	CString csPriorWindowText = m_sWindowText;
	
	CString s;

	if ( COleCurrency::valid == m.GetStatus() )
	{
		if ( m != COleCurrency(0,0) || ! m_bEmptyIfZero )
		{
			s = m.Format();
			double nResult = atof( s );
			s.Format( "%.2lf", nResult );
		}
	}

	m_sWindowText = s;
	
	if ( 0 != m_sWindowText.Compare( csPriorWindowText ) )
	{
		if ( ::IsWindow(m_hWnd) )
		{
			SetWindowText( m_sWindowText );
		}
	}
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
void CNEdit::operator = ( const double & n )
{
	CString csPriorWindowText = m_sWindowText;
	
	CString s;
	if ( n != 0.0 || ! m_bEmptyIfZero )
	{
		s.Format( "%.2lf", n );
		m_sWindowText = s;
		if ( ::IsWindow(m_hWnd) )
		{
			SetWindowText( s );
		}
	}
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
void CNEdit::operator = ( const float & n )
{
	CString csPriorWindowText = m_sWindowText;
	
	CString s;

	if ( n != 0.0 || ! m_bEmptyIfZero )
	{
		s.Format( "%.2lf", n );
		m_sWindowText = s;
	}
	else
	{
		m_sWindowText = "";
	}

	if ( 0 != m_sWindowText.Compare( csPriorWindowText ) )
	{
		if ( ::IsWindow(m_hWnd) )
		{
			SetWindowText( m_sWindowText );
		}
	}
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
void CNEdit::operator = ( const long & n )
{
	CString csPriorWindowText = m_sWindowText;
	
	CString s;

	if ( m_nMinCharacters > 0 )
	{
		if ( n != 0 || ! m_bEmptyIfZero )
		{
			s.Format( "%0*d", m_nMinCharacters, n );
		}
	}
	else
	{
		if ( n != 0 || ! m_bEmptyIfZero )
		{
			s.Format( "%d", n );
		}
	}

	m_sWindowText = s;

	if ( 0 != m_sWindowText.Compare( csPriorWindowText ) )
	{
		if ( ::IsWindow(m_hWnd) )
		{
			SetWindowText( m_sWindowText );
		}
	}
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
void CNEdit::operator = ( const int & n )
{
	CString csPriorWindowText = m_sWindowText;
	
	CString s;

	if ( m_nMinCharacters > 0 )
	{
		if ( n != 0 || ! m_bEmptyIfZero )
		{
			s.Format( "%0*d", m_nMinCharacters, n );
		}
	}
	else
	{
		if ( n != 0 || ! m_bEmptyIfZero )
		{
			s.Format( "%d", n );
		}
	}

	m_sWindowText = s;

	if ( 0 != m_sWindowText.Compare( csPriorWindowText ) )
	{
		if ( ::IsWindow(m_hWnd) )
		{
			SetWindowText( m_sWindowText );
		}
	}
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
void CNEdit::operator = ( LPCTSTR c )
{
	CString csPriorWindowText = m_sWindowText;
	
	if ( m_bPhoneNumber )
	{
		CString sPhoneNumber( c );
		ValidatePhoneNumber( sPhoneNumber, m_sWindowText );
	}
	else
	{
		m_sWindowText = c; 
	}

	m_sWindowText.TrimLeft();
	m_sWindowText.TrimRight();

	if ( 0 != m_sWindowText.Compare( csPriorWindowText ) )
	{
		if ( ::IsWindow(m_hWnd) )
		{
			SetWindowText( m_sWindowText );
		}
	}
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
BEGIN_MESSAGE_MAP(CNEdit, CEdit)
	//{{AFX_MSG_MAP(CNEdit)
	ON_CONTROL_REFLECT_EX(EN_CHANGE, OnChange)
//	ON_CONTROL_REFLECT_EX(EN_KILLFOCUS, OnKillfocus)
	ON_CONTROL_REFLECT_EX(EN_SETFOCUS, OnSetfocus)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_CTLCOLOR_REFLECT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNEdit message handlers

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
void CNEdit::PreSubclassWindow() 
{
	m_clrText = RGB( 0, 0, 0 );
	m_clrBkgnd = RGB( 255, 255, 255 );
	
	(void) m_NormalBrush.CreateSolidBrush( RGB(255,255,255) );
	(void) m_RequiredBrush.CreateSolidBrush( RGB( 255, 255, 0 ) );
	
	SetWindowText( m_sWindowText );

	CEdit::PreSubclassWindow();
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/

BOOL CNEdit::OnChange() 
{
	COLORREF clrOldText = m_clrText;
	CString  sOldWindowText = m_sWindowText;

	m_clrText = RGB( 0, 0, 0 );
	CString s;
	GetWindowText(s);

	s.TrimRight();
	s.TrimLeft();

	m_sWindowText = s;

	if (m_bNumber)
	{
		m_bValidate = SetDoubleColor( m_clrText, m_clrBkgdErr, m_clrBkgdOk);
	}
	else if (m_bString)
	{
		m_bValidate = SetStringColor( m_clrText, m_clrBkgdErr, m_clrBkgdOk );
	}
	else if (m_bDate)
	{
		m_bValidate = SetDateColor( m_clrText, m_clrBkgdErr, m_clrBkgdOk );
		m_sWindowText.MakeUpper();
	}

	if ( (m_clrText != clrOldText) || ( 0 != m_sWindowText.Compare( sOldWindowText ) ) )
	{
		(void) RedrawWindow();
	}

	return FALSE;	// continue routing

	/***
	COLORREF clrOldText = m_clrText;
	CString  sOldWindowText = m_sWindowText;

	m_clrText = RGB( 0, 0, 0 );
	
	CString s;
	GetWindowText(s);

	s.TrimRight();
	s.TrimLeft();

	m_sWindowText = s;

	if ( s.GetLength() )
	{
		if ( m_bNumber )
		{
			long n;
			if ( ! ValidateNumber( s, n ) )
			{
				m_clrText = RGB( 255, 0, 0 );
			}
		}
		else
		if ( m_bString )
		{
			if ( ! ValidateString( s ) )
			{
				m_clrText = RGB( 255, 0, 0 );
			}
		}
		else
		if ( m_bMoney )
		{
			COleCurrency mn;
			if ( ! ValidateMoney( s, mn ) )
			{
				m_clrText = RGB( 255, 0, 0 );
			}
		}
		else
		if ( m_bDate )
		{
			COleDateTime dt;
			if ( ! ValidateDate( s, dt ) )
			{
				m_clrText = RGB( 255, 0, 0 );
			}
		}
		else
		if ( m_bPhoneNumber )
		{
			CString sNewPhone;
			if ( ! ValidatePhoneNumber( s, sNewPhone ) )
			{
				m_clrText = RGB( 255, 0, 0 );
			}
		}
	}

	if ( (m_clrText == clrOldText) && ( 0 == m_sWindowText.Compare( sOldWindowText ) ) )
	{
		// Nothing changed so the window is okay the way it is
	}
	else
	{
		(void) RedrawWindow();
	}

	return FALSE;	// continue routing
	***/
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
/*
BOOL CNEdit::OnKillfocus() 
{
	CString s;
	GetWindowText(s);

	s.TrimRight();
	s.TrimLeft();

	if ( m_bDate )
	{
		COleDateTime dt;
		(void) ValidateDate( s, dt );
	}
	else
	if ( m_bMoney )
	{
		COleCurrency mn;
		(void) ValidateMoney( s, mn );
	}
	else
	if ( m_bPhoneNumber )
	{
		CString sNewPhoneNumber;
		if ( ValidatePhoneNumber( s, sNewPhoneNumber ) )
		{
			s = sNewPhoneNumber;
		}
	}

	if ( 0 != m_sWindowText.Compare( s ) )
	{
		m_sWindowText = s;
		SetWindowText(s);
	}

	return TRUE;	// continue routing
}
*/
/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
void CNEdit::GetColor( COLORREF &clrText, COLORREF & clrBackground )
{
	clrText = m_clrText;
	clrBackground = m_clrBkgnd;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
void CNEdit::SetColor(COLORREF clrText, COLORREF clrBackground)
{
	if ( (clrText != m_clrText) || (clrBackground != m_clrBkgnd) )
	{
		m_clrText	= clrText;
		m_clrBkgnd	= clrBackground;
		(void) RedrawWindow();
	}

    _ASSERT(::IsWindow(m_hWnd)); 

    COLORREF crPrevBkColor = m_clrBkgnd;

    m_clrBkgnd = clrBackground;
    
	m_brBkGround.DeleteObject();

	m_brBkGround.CreateSolidBrush( m_clrBkgnd );

    Invalidate();
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
BOOL CNEdit::OnSetfocus() 
{
	if ( m_bReadOnly )
	{
		(void) GetParent()->PostMessage( WM_NEXTDLGCTL, 0, 0 );
	}
	else
	{
		SetSel( 0, -1 );
	}

	return TRUE;	
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
HBRUSH CNEdit::CtlColor(CDC* pDC, UINT nCtlColor) 
{
	pDC->SetTextColor( m_clrText );
	pDC->SetBkColor( m_clrBkgnd );

	return (HBRUSH)m_brBkGround;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
void CNEdit::SetMinMaxChars(unsigned int nMin, unsigned int nMax)
{
	m_nMinCharacters = nMin;
	m_nMaxCharacters = nMax;

	SetLimitText( nMax );

}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
void CNEdit::SetMinMaxRange( long lMin, long lMax )
{
	
	m_lMinRange = lMin;
	m_lMaxRange = lMax;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
void CNEdit::SetMinMaxDoubleRange( double dMin, double dMax )
{
	m_dMinRange = dMin;
	m_dMaxRange = dMax;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
void CNEdit::SetEmptyIfZero( bool bSetEmptyIfZero )
{
	m_bEmptyIfZero = bSetEmptyIfZero;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
void CNEdit::SetBlank( bool bBlank )
{
	m_bBlank = bBlank;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
void CNEdit::SetAsDate()
{
	m_bNumber		= false;
	m_bString		= false;
	m_bMoney		= false;
	m_bDate			= true;
	m_bPhoneNumber	= false;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
void CNEdit::SetAsMoney()
{
	m_bNumber		= false;
	m_bString		= false;
	m_bMoney		= true;
	m_bDate			= false;
	m_bPhoneNumber	= false;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
void CNEdit::SetAsString()
{
	m_bNumber		= false;
	m_bString		= true;
	m_bMoney		= false;
	m_bDate			= false;
	m_bPhoneNumber	= false;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
void CNEdit::SetAsNumber()
{
	m_bNumber		= true;
	m_bString		= false;
	m_bMoney		= false;
	m_bDate			= false;
	m_bPhoneNumber	= false;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
void CNEdit::SetAsPhoneNumber( void )
{
	m_bNumber		= false;
	m_bString		= false;
	m_bMoney		= false;
	m_bDate			= false;
	m_bPhoneNumber	= true;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
void CNEdit::SetRequiredStatus(bool bRequired)
{
	m_bRequired = bRequired;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
void CNEdit::SetReadOnly( bool bReadOnly )
{
	bool bSendMessage = false;	// Added optimization not to send read only to the control if the
								// control is already set the way we would set it. This saves a lot of time
								// 25 January 1999 - Russell Bennett
	if ( bReadOnly != m_bReadOnly )
	{
		bSendMessage = true;
	}
	
	m_bReadOnly = bReadOnly;

	if ( bSendMessage )
	{
		(void) CEdit::SetReadOnly( (BOOL) bReadOnly );
	}
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
COleDateTime CNEdit::GetTextAsDate()
{
	COleDateTime d;

	CString s = m_sWindowText;

	(void) ValidateDate( s, d );

	return d;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
COleCurrency CNEdit::GetTextAsMoney()
{
	COleCurrency m;

	CString s = m_sWindowText;

	(void) ValidateMoney( s, m );

	return m;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
long CNEdit::GetTextAsNumber()
{
	long n(0);

	n = atol( m_sWindowText );

	return n;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
double CNEdit::GetTextAsDouble( void )
{
	double fReturn( 0 );

	fReturn = ::atof( m_sWindowText );

	return fReturn;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
CString CNEdit::GetTextAsString()
{
	return m_sWindowText;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
wchar_t * CNEdit::GetTextAsWChar( void )
{
	return (LPWSTR)((LPCTSTR)m_sWindowText);
}

/******************************************************************************

	Name:		CheckCharRange

	Action:		

	Params:		void

	Returns:	bool

	Notes:	

******************************************************************************/
bool CNEdit::CheckCharRange( void )
{
	bool bReturn = true;

	if( ( CheckMaxCharRange() == false ) || ( CheckMinCharRange() == false ) )
	{
		bReturn = false;
	}

	return bReturn;
}

/******************************************************************************

	Name:		CheckMaxCharRange

	Action:		

	Params:		void

	Returns:	bool

	Notes:	

******************************************************************************/
bool CNEdit::CheckMaxCharRange( void )
{
	bool bReturn = true;

	if( ::IsWindow(m_hWnd) )
	{
		if( ( m_bString == true ) && ( !m_sWindowText.IsEmpty() ) )
		{
			long lMaxCharacters = m_sWindowText.GetLength();

			if(	lMaxCharacters > (long)m_nMaxCharacters )
			{
				return bReturn = false;
			}
		}
	}

	return bReturn;	
}

/******************************************************************************

	Name:		CheckMinCharRange

	Action:		

	Params:		void

	Returns:	bool

	Notes:	


******************************************************************************/
bool CNEdit::CheckMinCharRange( void )
{
	bool bReturn = true;

	if( ::IsWindow(m_hWnd) )
	{
		if( ( m_bString == true ) && ( !m_sWindowText.IsEmpty() ) )
		{
			long lMinCharacters = m_sWindowText.GetLength();

			if(	lMinCharacters < (long)m_nMinCharacters )
			{
				return bReturn = false;
			}
		}
	}

	return bReturn;
}

/******************************************************************************

	Name:		CheckRange

	Action:		

	Params:		void

	Returns:	bool

	Notes:	

******************************************************************************/
bool CNEdit::CheckRange( void )
{
	bool bReturn = true;

	if( ( CheckMaxRange() == false ) || ( CheckMinRange() == false ) )
	{
		bReturn = false;
	}

	return bReturn;
}

/******************************************************************************

	Name:		CheckMaxRange	

	Action:		

	Params:		void

	Returns:	bool

	Notes:	

******************************************************************************/
bool CNEdit::CheckMaxRange( void )
{
	bool bReturn = true;

	if( ::IsWindow(m_hWnd) )
	{
		if( ( m_bNumber == true ) && ( !m_sWindowText.IsEmpty() ) )
		{
			long lValue = atol( m_sWindowText );

			if(	lValue > m_lMaxRange )
			{
				return bReturn = false;
			}
		}
	}
	
	return bReturn;
}

/******************************************************************************

	Name:		CheckMinRange	

	Action:		

	Params:		void

	Returns:	bool

	Notes:	

******************************************************************************/
bool CNEdit::CheckMinRange( void )
{
	bool bReturn = true;

	if( ::IsWindow(m_hWnd) )
	{
		if( ( m_bNumber == true ) && ( !m_sWindowText.IsEmpty() ) )
		{
			long lValue = atol( m_sWindowText );

			if(	lValue < m_lMinRange )
			{
				return bReturn = false;
			}
			
		}
	}

	return bReturn;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
bool CNEdit::CheckDoubleRange( void )
{
	bool bReturn = true;

	if( ( CheckMaxDoubleRange() == false ) || ( CheckMinDoubleRange() == false ) )
	{
		bReturn = false;
	}

	return bReturn;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
bool CNEdit::CheckMaxDoubleRange( void )
{
	bool bReturn = true;

	if( ::IsWindow(m_hWnd) )
	{
		if( ( m_bNumber == true ) && ( !m_sWindowText.IsEmpty() ) )
		{
			double dValue = ::atof( m_sWindowText );

			if(	dValue > m_dMaxRange )
			{
				return bReturn = false;
			}
		}
	}
	
	return bReturn;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
bool CNEdit::CheckMinDoubleRange( void )
{
	bool bReturn = true;

	if( ::IsWindow(m_hWnd) )
	{
		if( ( m_bNumber == true ) && ( !m_sWindowText.IsEmpty() ) )
		{
			double dValue = ::atof( m_sWindowText );

			if(	dValue < m_dMinRange )
			{
				return bReturn = false;
			}
			
		}
	}

	return bReturn;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
bool CNEdit::IsEmpty()
{
	return ( 0 == m_sWindowText.GetLength() );
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
bool CNEdit::ValidatePhoneNumber( CString sInput, CString &sReturn )
{
	bool bValidPhoneNumber = false;

	CString sPhone;

	long nLength = sInput.GetLength();

	for ( int i = 0 ; i < nLength; i++ )
	{
		if ( isdigit( sInput[i] ) )
		{
			sPhone += sInput[i];
		}
	}

	nLength = sPhone.GetLength();
	long nAreaCode = 0;
	long nSuffix = 0;
	long nNumber = 0;
	CString sExtension;

	if ( nLength > 10 )
	{	
		nAreaCode	= atol( sPhone.Left( 3 ) );
		nSuffix		= atol( sPhone.Mid( 3, 3 ) );
		nNumber		= atol( sPhone.Mid( 6, 4 ) );
		sExtension	= sPhone.Mid( 10 );
		bValidPhoneNumber = true;
	}
	else
	if ( 10 == nLength )
	{
		nAreaCode	= atol( sPhone.Left( 3 ) );
		nSuffix		= atol( sPhone.Mid( 3, 3 ) );
		nNumber		= atol( sPhone.Mid( 6, 4 ) );
		bValidPhoneNumber = true;
	}

	if ( bValidPhoneNumber )
	{
		CString sAreaCode;
		if ( nAreaCode > 0 )
		{
			sAreaCode.Format( "(%03d) ", nAreaCode );
		}
		else
		{
			sAreaCode = "(   ) ";
		}

		CString sSuffix;

		if ( nSuffix >= 0 )
		{
			sSuffix.Format( "%03d - ", nSuffix );
		}
		else
		{
			sSuffix = "    - ";
		}

		CString sNumber;

		if ( nNumber >= 0 )
		{
			sNumber.Format( "%04d", nNumber );
		}
		else
		{
			sNumber.Format( "    " );
		}

		sReturn.Format( "%s%s%s", sAreaCode, sSuffix, sNumber );

		if ( sExtension.GetLength() > 0 )
		{
			sReturn += " x ";
			sReturn += sExtension;
		}
	}
	else
	{
		sReturn = "";
	}

	return bValidPhoneNumber;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
bool CNEdit::ValidateMoney( CString &strInput, COleCurrency &mn )
{
	bool bValid = true;

	int nNegative = strInput.Find( '-' );

	if ( nNegative > -1 )
	{
		strInput.SetAt( nNegative, ' ' );
	}

	if ( mn.ParseCurrency( strInput ) )
	{
		mn /= 100;	// To Get Rid of any tenths and hundredths that might be lingering
		mn *= 100;

		if ( nNegative > -1 )
		{
			mn *= -1;
		}
		
	}
	else
	{
		bValid = false;
		mn = COleCurrency(0,0);
	}	

	strInput.Empty();

	if ( mn != COleCurrency(0,0) || ! m_bEmptyIfZero )
	{
		strInput = mn.Format();
		double nResult = atof( strInput );
		strInput.Format( "%.2lf", nResult );
	}
	

	return bValid;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
bool CNEdit::ValidateDate( CString &strDate, COleDateTime &dt )
{
	CString strInput = strDate;
	CString strTemp;
	BOOL    bValidDate = FALSE;

	// MM-DD-YY or other string that the parsing routine will like
	bValidDate = dt.ParseDateTime( strInput, VAR_DATEVALUEONLY );

	if ( ! bValidDate )
	{
		if ( strInput.GetLength() == 6 )
		{
			strTemp.Format( "%c%c-%c%c-%c%c", strInput[0], strInput[1], strInput[2], strInput[3], strInput[4], strInput[5] );
			bValidDate = dt.ParseDateTime( strTemp, VAR_DATEVALUEONLY );
		}
		else
		if ( strInput.GetLength() == 8 )
		{
			strTemp.Format( "%c%c-%c%c-%c%c%c%c", strInput[0], strInput[1], strInput[2], strInput[3], strInput[4], strInput[5], strInput[6], strInput[7] );
			bValidDate = dt.ParseDateTime( strTemp, VAR_DATEVALUEONLY );
		}
	}

	if ( ! bValidDate )
	{
		dt.SetStatus( COleDateTime::null );
	}
	else
	if ( 6 == m_nMinCharacters )
	{
		strDate = dt.Format( "%m%d%y" );
	}
	else
	if ( 8 == m_nMinCharacters )
	{
		strDate = dt.Format( "%m%d%Y" );
	}
	else
	{
		strDate = dt.Format( "%b %d, %Y" );
	}
	

	return ( TRUE == bValidDate );
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
bool CNEdit::ValidateString( CString str )
{
	bool bValid = true;

	if ( m_nMinCharacters )
	{
		str.TrimRight();
		str.TrimLeft();

		if ( str.GetLength() > 0 )
		{
			if ( (unsigned int) str.GetLength() < m_nMinCharacters )
			{
				bValid = false;
			}
		}
	}

	return bValid;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

******************************************************************************/
bool CNEdit::ValidateNumber( CString str, long &n )
{
	bool bValid = true;

	str.TrimRight();
	str.TrimLeft();

	n = atol( str );
	unsigned int nLength = (unsigned int) str.GetLength();

	CString sNewString;
	sNewString.Format( "%0*d", nLength, n );

	if ( sNewString != str )
	{
		bValid = false;
	}

	if ( m_nMinCharacters )
	{
		if ( nLength < m_nMinCharacters )
		{
			bValid = false;
		}
	}

	return bValid;

}

//----------------------------------------------------------------------
// CNEdit::SetNumberColor()
// Description: Set number color
//----------------------------------------------------------------------
bool CNEdit::SetNumberColor( COLORREF clrText, COLORREF clrBackgroundError, COLORREF clrBackgroundCorrect )
{
	if( IsNumber( GetTextAsString()) == false )
	{
		SetColor( clrText, clrBackgroundError );
		return false;
	}
	else
	{
		if( CheckRange() == false )
		{
			SetColor( clrText, clrBackgroundError );
			return false;
		}
		else if ( (!GetBlank())&& (GetTextAsString()=="") )
		{ 
			SetColor( clrText, clrBackgroundError );
			return false;
		}
		SetColor( clrText, clrBackgroundCorrect );	
	}

	return true;
}	// SetNumberColor

//----------------------------------------------------------------------
// CNEdit::SetDoubleColor()
// Description: Set double float color
//----------------------------------------------------------------------
bool CNEdit::SetDoubleColor( COLORREF clrText, COLORREF clrBackgroundError, COLORREF clrBackgroundCorrect )
{
	if ((m_bBlank)&&(GetTextAsString()=="")) 
	{ 
		SetColor( clrText, clrBackgroundCorrect );
		return true;
	}
	else if( !IsNumber( GetTextAsString()) )
	{
		SetColor( clrText, clrBackgroundError );
		return false;
	}
	else
	{
		if( !CheckDoubleRange() )
		{
			SetColor( clrText, clrBackgroundError );
			return false;
		}
//		else if ( (!GetBlank())&& (GetTextAsString()=="") )
//		{ 
//			SetColor( clrText, clrBackgroundError );
//			return false;
//		}
		SetColor( clrText, clrBackgroundCorrect );	
	}

	return true;
}	// SetDoubleColor

//----------------------------------------------------------------------
// CNEdit::SetStringColor()
// Description: Set number color
//----------------------------------------------------------------------
bool CNEdit::SetStringColor( COLORREF clrText, COLORREF clrBackgroundError, COLORREF clrBackgroundCorrect )
{
	GetTextAsString();

    if( !CheckCharRange() )
	{
		SetColor( clrText, clrBackgroundError );
		return false;
	}
	else if ( (!GetBlank()) && (GetTextAsString()=="") )
	{ 
		SetColor( clrText, clrBackgroundError );
		return false;
	}
	SetColor( clrText, clrBackgroundCorrect );

	return true;
}	// SetStringColor

//----------------------------------------------------------------------
// CNEdit::SetDateColor()
// Description: Set number color
//----------------------------------------------------------------------
bool CNEdit::SetDateColor( COLORREF clrText, COLORREF clrBackgroundError, COLORREF clrBackgroundCorrect )
{
	COleDateTime d;

	if (m_sWindowText=="") { SetColor( clrText, clrBackgroundCorrect ); }
	else if (!ValidateDate( m_sWindowText, d ))
	{
		SetColor( clrText, clrBackgroundError );
		return false;
	}
	else if ( (!GetBlank()) && (GetTextAsString()=="") )
	{ 
		SetColor( clrText, clrBackgroundError );
		return false;
	}
	SetColor( clrText, clrBackgroundCorrect );

	return true;
}	// SetDateColor

//----------------------------------------------------------------------
// CNEdit::SetNumber()
// Description: Set number in box
//----------------------------------------------------------------------
void CNEdit::SetNumber( const long nMin, const long nMax, bool bBlank /*=true*/)
{
	SetAsNumber();
	SetMinMaxRange( nMin, nMax );
	SetBlank( bBlank );
}	// SetNumber

//----------------------------------------------------------------------
// CNEdit::SetDouble()
// Description: Set float in box
//----------------------------------------------------------------------
void CNEdit::SetDouble( const double fMin, const double fMax, bool bBlank /*=true*/)
{
	SetAsNumber();
	SetMinMaxDoubleRange( fMin, fMax );
	SetBlank( bBlank );
}	// SetDouble

//----------------------------------------------------------------------
// CNEdit::SetString()
// Description: Set SetString in box
//----------------------------------------------------------------------
void CNEdit::SetString( const int nMin, const int nMax, bool bBlank/*=true*/)
{
	SetAsString();
	SetMinMaxChars( nMin, nMax );
	SetBlank( bBlank );
}	// SetString

//----------------------------------------------------------------------
// CNEdit::SetDate()
// Description: Set date in box
//----------------------------------------------------------------------
void CNEdit::SetDate( bool bBlank/*=true*/)
{
	SetAsDate();
	SetBlank( bBlank );
}	// SetDate

void CNEdit::SetValidateColor( bool valid /* = true */) 
{ 
	m_bValidate = valid;
	if (valid) 
	{ 
		COLORREF colorBlack = RGB( 0, 0, 0 );
		COLORREF colorGrey = RGB( 192, 192, 192 );
		SetColor( colorBlack, colorGrey ); 
	}
	else 
	{ 
		COLORREF colorYellow = RGB( 255, 255, 0 );
		COLORREF colorRed = RGB( 255, 0, 0 );
		SetColor( colorRed, colorYellow ); 
	}
}
