#if !defined(AFX_EDITEX_H__0B3BE1AF_AAF3_11D2_814C_00105A1C67CB__INCLUDED_)
#define AFX_EDITEX_H__0B3BE1AF_AAF3_11D2_814C_00105A1C67CB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// RbEdit.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CNEdit window

class CNEdit : public CEdit
{
// Construction
public:
	CNEdit();

	// Assignment Operators
	const CNEdit& operator = ( const CNEdit & e );
	void operator = ( const COleDateTime & d );
	void operator = ( const COleCurrency & m );
	void operator = ( const double & n );
	void operator = ( const float & n );
	void operator = ( const long & n );
	void operator = ( const int & n );
	void operator = ( LPCTSTR c );

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CNEdit)
	protected:
	virtual void PreSubclassWindow();
	//}}AFX_VIRTUAL

// Implementation
public:
	void SetColor( COLORREF clrText, COLORREF clrBackground );
	void GetColor( COLORREF &clrText, COLORREF & clrBackground );

	bool IsEmpty( void );

	bool CheckMaxRange( void );
	bool CheckMinRange( void );
	bool CheckRange( void );
	bool CheckMaxCharRange( void );
	bool CheckMinCharRange( void );
	bool CheckCharRange( void );
	bool CheckMaxDoubleRange( void );
	bool CheckMinDoubleRange( void );
	bool CheckDoubleRange( void );

	bool GetValidate() { return m_bValidate; }
	bool GetBlank() { return m_bBlank; }
	CString GetTextAsString( void );
	wchar_t * GetTextAsWChar( void );
	long GetTextAsNumber( void );
	double GetTextAsDouble( void );
	COleCurrency GetTextAsMoney( void );
	COleDateTime GetTextAsDate( void );

	void SetReadOnly( bool bReadOnly );
	void SetRequiredStatus( bool bRequired );
	void SetAsNumber( void );
	void SetAsString( void );
	void SetAsMoney( void );
	void SetAsDate( void );
	void SetAsPhoneNumber( void );
	void SetMinMaxChars( unsigned int nMin, unsigned int nMax );
	void SetMinMaxRange( long lMin, long lMax );
	void SetMinMaxDoubleRange( double dMin, double dMax );
	void SetBlank( bool bBlank );
	void SetEmptyIfZero( bool bSetEmptyIfZero );

	bool	SetNumberColor( COLORREF clrText, COLORREF clrBackgroundError, COLORREF clrBackgroundCorrect );
	bool	SetStringColor( COLORREF clrText, COLORREF clrBackgroundError, COLORREF clrBackgroundCorrect );
	bool	SetDoubleColor( COLORREF clrText, COLORREF clrBackgroundError, COLORREF clrBackgroundCorrect );
	bool	SetDateColor( COLORREF clrText, COLORREF clrBackgroundError, COLORREF clrBackgroundCorrect );
	void	SetNumber( const long nMin, const long nMax, bool bBlank=true);
	void	SetString( const int nMin, const int nMax, bool bBlank=true);
	void	SetDouble( const double fMin, const double fMax, bool bBlank=true);
	void	SetDate( bool bBlank=true);
	void	SetValidateColor( bool valid = true );
	void	SetValidate( const bool valid = true ) { m_bValidate = valid; }

	virtual ~CNEdit();

	// Generated message map functions
protected:
	//{{AFX_MSG(CNEdit)
	afx_msg BOOL OnChange();
//	afx_msg BOOL OnKillfocus();
	afx_msg BOOL OnSetfocus();
	afx_msg HBRUSH CtlColor(CDC* pDC, UINT nCtlColor);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

private:

	bool		m_bReadOnly;
	bool		m_bRequired;
	bool		m_bNumber;
	bool		m_bString;
	bool		m_bMoney;
	bool		m_bDate;
	bool		m_bPhoneNumber;
	
	bool		m_bEmptyIfZero;

	bool		m_bBlank;
	bool		m_bValidate;

	long		m_lMaxRange;
	long		m_lMinRange;

	double		m_dMinRange;
	double		m_dMaxRange;

	unsigned int m_nMaxCharacters;
	unsigned int m_nMinCharacters;

	COLORREF	m_clrText;
	COLORREF	m_clrBkgnd;

	COLORREF	m_clrBkgdErr;
	COLORREF	m_clrBkgdOk;
	COLORREF	m_clrRed;

	CBrush		m_brBkGround;

	CBrush		m_RequiredBrush;
	CBrush		m_NormalBrush;

	bool ValidatePhoneNumber( CString sInput, CString &sReturn );
	bool ValidateMoney( CString &strInput, COleCurrency &mn );
	bool ValidateDate( CString &strDate, COleDateTime &dt );
	bool ValidateString( CString str );
	bool ValidateNumber( CString str, long &n );

	CString			m_sWindowText;

};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EDITEX_H__0B3BE1AF_AAF3_11D2_814C_00105A1C67CB__INCLUDED_)
