// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: entreev5.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description:  Defines the class behaviors for the application
//
// -----------------------------------------


#include "stdafx.h"
#include "entreeV5.h"
#include "entreeV5Dlg.h"
#include "choosedb.h"
#include "direct.h"


#ifdef _DEBUG
//#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//CDaoDatabase daodata;

/////////////////////////////////////////////////////////////////////////////
// CEntreeV5App

BEGIN_MESSAGE_MAP(CEntreeV5App, CWinApp)
	//{{AFX_MSG_MAP(CEntreeV5App)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEntreeV5App construction

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
CEntreeV5App::CEntreeV5App()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////

//Mandatory static definitions
BOOL CEntreeV5App::m_IsConnectionOpen = FALSE;
_ConnectionPtr CEntreeV5App::m_pConnection;
CString CEntreeV5App::m_username("");
CString CEntreeV5App::m_password("");
// The one and only CEntreeV5App object
CEntreeV5App theApp;
/////////////////////////////////////////////////////////////////////////////
// CEntreeV5App initialization

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CEntreeV5App::InitInstance()
{
	AfxEnableControlContainer();

	AfxOleInit();

	CEntreeV5Dlg dlg;

	char wdbuffer[_MAX_PATH];   /* Get the current working directory: */
	char pathbuffer [_MAX_PATH];
	CString file="ncodes.mdb" ; //Name of DaoDatabase file which has NHTSADB.CODE data

	_getcwd( wdbuffer, _MAX_PATH );  //get current working directory


	// This registry code is not in use.
	/*
	char *	szKey	= "SOFTWARE\\NHTSA Crashworthiness\\Entree V5";
	HKEY	hKey	= 0;
	char *	szEnv	= "entreeV5";
	
	unsigned char	szValue[_MAX_PATH +1] = "C:\\Program Files\\Entree V5";

	DWORD	lpType	= REG_SZ;
	DWORD	lpLength = _MAX_PATH;
	DWORD	lKeyDisposition;


//	if( RegOpenKeyEx( HKEY_LOCAL_MACHINE, szKey, 0, KEY_QUERY_VALUE, &hKey ) == ERROR_SUCCESS )
//	{
//		if( RegQueryValueEx( hKey, szEnv, 0, &lpType, szValue, &lpLength ) == ERROR_SUCCESS )
//		{
//			RegCloseKey( hKey );

//			hKey = 0;

			if( RegCreateKeyEx( HKEY_LOCAL_MACHINE, szKey, 0, "REG_SZ", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, 0, &hKey, &lKeyDisposition ) == ERROR_SUCCESS )
			{
				RegSetValueEx( hKey, szEnv, 0, REG_SZ, szValue, strlen( (char *)szValue ) + 1 );
				RegCloseKey( hKey );
			}
//		}
//	}

	*/

	_searchenv( file, wdbuffer, pathbuffer );// search for file in working dir

	// Initialization Error Checking *******************************
	if( *pathbuffer == '\0' ) //didn't find ncodes.mdb in working dir, so quit.
	{
		MessageBox(NULL,"ncodes.mdb was not found in the path.", "Error", MB_OK|MB_ICONERROR);
		return FALSE;
	}
	
	HWND desktop = ::GetDesktopWindow();
	CRect rect;
	::GetClientRect(desktop, &rect);

	if ((rect.Width () <1024) || (rect.Height () <768))
	{
		MessageBox(NULL,"Your screen resolution must be at least 1024x768 to use Entree v5.0",
			       "Error", MB_OK|MB_ICONERROR);
		return FALSE;
	}
	// ***********************************

	//***  Open DaoDatabase which is stored in working dir
//	daodata.Open (pathbuffer, TRUE);
	if (!InitDB(pathbuffer)) { return false; }

	dlg.DoModal();

    // splash screen done, start real dialogs now.
	CChooseDB choosedb;
	choosedb.DoModal ();

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.

	// Also close the database connection.
//	daodata.Close();

	return FALSE;
}

/******************************************************************************

	Name:		

	Action:		Used in many places to convert a CString to a CTime.
				There are all kinds of formats to check for.  I'm gonna look
				for 2 separators (/,-).
				The correct format is DD-MMM-YYYY

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
CTime StringToTime(CString strDat)
{
	BOOL bSlash=FALSE;
	BOOL bDash =FALSE;

	// Search for 2 slashes or 2 dashes, to decide separator.
	int slash1 = strDat.Find('/');
	int slash2 = -1;
	if (slash1 != -1)
	{
		slash2 = strDat.Find('/', slash1+1);
		if (slash2 != -1) bSlash = TRUE;
	}

	int dash1    = strDat.Find('-');
	int dash2 = -1;
	if (dash1 != -1)
	{
		dash2 = strDat.Find('-',dash1+1);
		if (dash2 != -1) bDash = TRUE;
	}

	//if(strDat.GetLength ()>10)
	if (bSlash)
	{
		CString year, month, day;
		
		//year = strDat.Mid (7,4);
		//day = strDat.Mid(0,2);
		//month = strDat.Mid (3,3);
		year = strDat.Right(strDat.GetLength () - (slash2+1));
		if (year>="2038") { return CTime::GetCurrentTime (); } // wong added in 02/25/00

		day = strDat.Left(slash1);
		month = strDat.Mid(slash1+1,slash2-(slash1+1));

		int imonth;
		month.MakeUpper ();
	
	    if (month== "JAN")	imonth = 1;
		else if (month =="FEB") imonth = 2;
		else if (month =="MAR") imonth = 3;
		else if (month =="APR") imonth = 4;
		else if (month =="MAY") imonth = 5;
		else if (month =="JUN") imonth = 6;
		else if (month =="JUL") imonth = 7;
		else if (month =="AUG") imonth = 8;
		else if (month =="SEP") imonth = 9;
		else if (month =="OCT") imonth = 10;
		else if (month =="NOV") imonth = 11;
		else if (month =="DEC") imonth = 12;
		else // not a month, string is wrong format
		{
			CTime now;
			now=CTime::GetCurrentTime ();
			return now;

		}
		
		int nYear=atoi(year);
		// These two years are the limits in CTime.
		if (nYear<1970) nYear = 1970;
		if (nYear>2037) nYear = 2037;

		CTime caldat(nYear,imonth,atoi(day),0,0,0);
		
		return caldat;
	}

	else if (bDash)
	{
		CString year, month, day;
		
		//year = strDat.Mid (7,4);
		//day = strDat.Mid(0,2);
		//month = strDat.Mid (3,3);
		year = strDat.Right(strDat.GetLength () - (dash2+1));
		if (year>="2038") { return CTime::GetCurrentTime (); } // wong added in 02/25/00

		day = strDat.Left(dash1);
		month = strDat.Mid(dash1+1,dash2-(dash1+1));

		int imonth;
		month.MakeUpper ();
	
	    if (month== "JAN")	imonth = 1;
		else if (month =="FEB") imonth = 2;
		else if (month =="MAR") imonth = 3;
		else if (month =="APR") imonth = 4;
		else if (month =="MAY") imonth = 5;
		else if (month =="JUN") imonth = 6;
		else if (month =="JUL") imonth = 7;
		else if (month =="AUG") imonth = 8;
		else if (month =="SEP") imonth = 9;
		else if (month =="OCT") imonth = 10;
		else if (month =="NOV") imonth = 11;
		else if (month =="DEC") imonth = 12;
		else // not a month, string is wrong format
		{
			CTime now;
			now=CTime::GetCurrentTime ();
			return now;

		}
		
		int nYear=atoi(year);
		if (nYear<1900) nYear+=1900;

		CTime caldat(nYear,imonth,atoi(day),0,0,0); // wong note: available from 1/JAN/1970 - 18/JAN/2038
		
		return caldat;
	}
	else  // string not valid, return today.
	{
		CTime now;
		now=CTime::GetCurrentTime ();

		return now;
	}
}

/******************************************************************************

	Name:		

	Action:		returns number of | chars in a CString

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
int CountPipes(CString &strLine)
{
	int nPipes = 0;
	int nLoc = strLine.Find ('|', 0);  // Find first pipe

	while (nLoc!=-1)
	{
		nPipes++;
		nLoc = strLine.Find ('|', nLoc+1);  // Find next pipe
	}

	return nPipes;
}

/******************************************************************************

	Name:		GetTextBetweenPipes

	Action:		Get the text in a certain area of a line from a file.  No error
				checking is done on the string because it is assumed the
				CString passed is ok.
				This is checked in Extract...Data()

	Params:		CString &, int, int

	Returns:	CString

	Notes:	

	Dates:

******************************************************************************/
CString GetTextBetweenPipes(CString &strLine, int nBegin, int nEnd)
{
	if ((nBegin < 0) || (nEnd <= nBegin))
	{
		return "";   // bad beginning or end
	}

	int loc1,loc2;
	loc1 = loc2 = 0;

	if (nBegin==0)  // loc1 before first pipe.
	{
		if (strLine[0]=='|') { return ""; } // Y. Wong added in 06/14/00

		loc1 = 0;
		loc2 = strLine.Find ('|',loc1+1); //loc2 now has first pipe location
	
		int loop,temp;
		for (loop=1; loop < nEnd; loop++) //advance loc2 to nEnd
		{
			temp = loc2;
			loc2 = strLine.Find ('|', temp+1);

		}

		if (loc2 !=-1)  //valid loc
		{
			CString strRet = strLine.Mid (0, loc2);	
			return strRet;
		}
		else  // This is for the last data in a line, not bound by a |.  
		{
			return strLine;
		}
	
	}
	else  // put loc1 at nBegin
	{
		loc1 = strLine.Find ('|',0);  // loc1 now has first pipe location
		loc2 = strLine.Find ('|',loc1+1); //loc2 now has second pipe location
		
		int loop;
		for (loop=1; loop < nBegin; loop++) //advance loc1 to nBegin
		{
			loc1 = loc2;
			loc2 = strLine.Find ('|', loc1+1);

		}
		loop++; // advance the loop, nEnd starts at 2.
		int temp = loc1;
		for (;loop < nEnd; loop++)  // advance loc2 to nEnd
		{
			temp = loc2;
			loc2 = strLine.Find ('|', temp+1);
		}

		if ((loc1 != -1) && (loc2 !=-1))  //valid locs
		{
			CString strRet = strLine.Mid (loc1 +1, loc2 - (loc1+1));	
			return strRet;
		}
		else  // This is for the last data in a line, not bound by a |.  
		{
			CString strRet = strLine.Mid (loc1+1, strLine.GetLength () -(loc1+1)) ;   
			return strRet;
		}
	}

}

/******************************************************************************

	Name:		IsNumber

	Action:		Checks to see, if a CString expresses is a numeric number.
				Returns true is the expressesion is numeric.
				Returns false if the expression is not numeric.

	Params:		const CString

	Returns:	bool

	Notes:	

******************************************************************************/
const bool IsNumber(const CString Str)
{
	CString str = Str; str.TrimLeft(); str.TrimRight();
	if (str==".") { return false; }
	int nLen = str.GetLength();
	if (nLen==0) { return false; }
	int dotIndex = 0;

	if ( !isdigit(str[0]) ) // (str[0]<48)||(str[0]>57) )
	{
		if (str[0]=='.') { dotIndex++; }
		else if (str[0]!='-') { return false; } 
	}

	for (int i=1; i<nLen; i++)
	{
 		if ( isdigit(str[i]) ) { continue; } // (str[i]>47)&&(str[i]<58) ) { continue; }
		if (str[i]=='.') 
		{
			if (dotIndex==0) { dotIndex++; }
			else return false;
		}
		else if (str[i]=='E' || str[i]=='e')	// scientific notation
		{
			if ( (str[++i]!='+') && (str[i]!='-') ) { return false; }
			for (int j=i+1; j<nLen; j++)
			{
				if ( !isdigit(str[j]) ) { return false; } 
			}
			return true;
		}
		else { return false; }
	}

	return true;
}	// isNumber
/** old
bool IsNumber( const CString ccstr )
{
	int iLength = ccstr.GetLength();
	char ch;
	int iDot = 0;

	for( int i = 0; i < iLength; i++ )
	{
		ch = ccstr.GetAt( i );

		if( ( !isdigit( ch ) ) && ( ch != '.' ) && ( ch !='-' ) )
		{ 
			return false;
		}

		if( ch == '.' )
		{
			iDot++;

			if( iDot == 2 )
			{
				return false;
			}
		}
		else if( ch == '-' )
		{
			iDot++;

			if( iDot == 2 )
			{
				return false;
			}
		}
	}

	return true;
}	// IsNumber
**/

int CEntreeV5App::ExitInstance() 
{
	if( m_IsConnectionOpen )
	{
		m_IsConnectionOpen = FALSE;
		m_pConnection->Close();
		m_pConnection = NULL;
	}

	return CWinApp::ExitInstance();
}

// --------------
// bool CEntreeV5App::InitDB()
// Initialize Database Connection, using my name and password.  Shouldn't be
// a problem, this program only reads.
/*
enum CursorTypeEnum
{
    adOpenUnspecified = -1,
    adOpenForwardOnly = 0,
    adOpenKeyset = 1,
    adOpenDynamic = 2,
    adOpenStatic = 3
};
*/

// --------------
bool CEntreeV5App::InitDB(const CString pathbuffer)
{
	m_username = m_password = "";
	HRESULT hr;
	try
	{
		hr = m_pConnection.CreateInstance( __uuidof( Connection ) );
		if (SUCCEEDED(hr))
		{ //Open connection to DB
			CString strOpen("");
			strOpen = CString("Provider=Microsoft.Jet.OLEDB.4.0;") + CString("Data Source=") + pathbuffer + CString(";"); // + ";UID=" + m_username + ";PWD="+ m_password;
			hr = m_pConnection->Open( _bstr_t(strOpen), "", "", adOpenUnspecified );
			if (SUCCEEDED(hr))
			{
				m_IsConnectionOpen = TRUE;
			}
			
		}
	}
	catch (_com_error *e) //handle com errors
	{
		// Get info from _com_error
		CString Error = e->ErrorMessage();
		AfxMessageBox(e->ErrorMessage());
		return false;
						
	}
	catch (...)  //handle all other errors.  See codeguru->Database->ADO is AOK, Dmitri's response.
	{
		ErrorPtr errItem;
		_variant_t vIndex;
		_bstr_t strstr;
		long iNum=0;

		m_pConnection -> Errors -> get_Count(&iNum);
	
		for(int i = 0; i < iNum; i++)
		{
			vIndex.vt = VT_I4;
			vIndex.lVal = i;
			errItem = m_pConnection -> Errors ->GetItem(vIndex);
			strstr = errItem -> Description;
			AfxMessageBox(strstr);
		}
		return false;
	}

	return true;
}	// InitDb
