// entreeV5.h : main header file for the ENTREEV5 application
//

#if !defined(AFX_ENTREEV5_H__96CE046D_5893_11D2_9493_0008C7AA9033__INCLUDED_)
#define AFX_ENTREEV5_H__96CE046D_5893_11D2_9493_0008C7AA9033__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols

#include "SWGPropertySheet.h"
#include "VehiclePropertySheet.h"
#include "BioMechPropertySheet.h"
#include "ComponentPropertySheet.h"
#include "ChooseDB.h"
// help map file
#include "Entreev5.hh"

const int VEHICLEDB=101;
const int BIOMECHDB=102;
const int COMPONENTDB=103;
const int SWGDB=104;
const int EV4=4;
const int EV5=5;
const int MAXCBANDS = 5;

//Global functions:
CString GetTextBetweenPipes(CString &, int, int);
const bool IsNumber( const CString ccstr );
CTime StringToTime(CString strDat);
int CountPipes(CString &strLine);


/////////////////////////////////////////////////////////////////////////////
// CEntreeV5App:
// See entreeV5.cpp for the implementation of this class
//

class CEntreeV5App : public CWinApp
{
public:
	CEntreeV5App();

	static BOOL m_IsConnectionOpen;  //DB Connection flag
	static _ConnectionPtr m_pConnection; //DB Connection pointer
	static CString m_password;
	static CString m_username;
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEntreeV5App)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CEntreeV5App)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	private:
	
	bool InitDB(const CString pathbuffer);

};




/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ENTREEV5_H__96CE046D_5893_11D2_9493_0008C7AA9033__INCLUDED_)
