// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: Entreev5Dlg.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description:  Entreev5dlg is the splash screen.
//               
// -----------------------------------------



#include "stdafx.h"
#include "entreeV5.h"
#include "entreeV5Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_cstrProductVersion = _T("");
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_PRODUCT_VERSION, m_cstrProductVersion);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CAboutDlg::OnInitDialog() 
{
	// Need to include lib. version.lib.

	CDialog::OnInitDialog();

	m_cstrProductVersion = "Version: ";
	
    LPBYTE  m_lpVersionData; 
    DWORD   m_dwLangCharset; 
	LPCTSTR lpszModuleName;

    m_lpVersionData = NULL;
    m_dwLangCharset = 0;


	lpszModuleName = __argv[0];

  
	ASSERT(_tcslen(lpszModuleName) > 0);
    ASSERT(m_lpVersionData == NULL);

    // Get the version information size for allocate the buffer
    DWORD dwHandle;     
    DWORD dwDataSize = ::GetFileVersionInfoSize((LPTSTR)lpszModuleName, &dwHandle); 
    if ( dwDataSize == 0 )
	{
		// Do Nothing
	}
	else
	{
	    // Allocate buffer and retrieve version information
		m_lpVersionData = new BYTE[dwDataSize]; 
		if (!::GetFileVersionInfo(	(LPTSTR)lpszModuleName, dwHandle, dwDataSize, 
									(void**)m_lpVersionData) )
		{
			delete[] m_lpVersionData; 
			m_lpVersionData = NULL;
			m_dwLangCharset = 0;
		}
		else
		{
			// Retrieve the first language and character-set identifier
			UINT nQuerySize;
			DWORD* pTransTable;
			if (!::VerQueryValue(m_lpVersionData, _T("\\VarFileInfo\\Translation"),
								(void **)&pTransTable, &nQuerySize) )
			{
				delete[] m_lpVersionData; 
				m_lpVersionData = NULL;
				m_dwLangCharset = 0;
			}
			else
			{
				// Swap the words to have lang-charset in the correct format
				m_dwLangCharset = MAKELONG(HIWORD(pTransTable[0]), LOWORD(pTransTable[0]));

				VS_FIXEDFILEINFO vsffi;

				// Must call Open() first
				ASSERT(m_lpVersionData != NULL);
				if ( m_lpVersionData == NULL )
				{
					// Do Nothing
				}
				else
				{
					UINT nQuerySize;
					VS_FIXEDFILEINFO* pVsffi;
					if ( ::VerQueryValue((void **)m_lpVersionData, _T("\\"),
										(void**)&pVsffi, &nQuerySize) )
					{
						vsffi = *pVsffi;

						CString cstrValue("");
		
						cstrValue.Format (	"%u,%u,%u,%u",
											HIWORD(vsffi.dwProductVersionMS),
											LOWORD(vsffi.dwProductVersionMS),
											HIWORD(vsffi.dwProductVersionLS),
											LOWORD(vsffi.dwProductVersionLS) );

						if( cstrValue.IsEmpty() == FALSE )
						{
							m_cstrProductVersion = m_cstrProductVersion + cstrValue;
						}
					}

					delete[] m_lpVersionData; 
					m_lpVersionData = NULL;
					m_dwLangCharset = 0;
				}
			}
		}
	}

	GetDlgItem( IDC_PRODUCT_VERSION )->SetWindowText( m_cstrProductVersion );

	getDatabaseVersion();



	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


/////////////////////////////////////////////////////////////////////////////
// CEntreeV5Dlg dialog

CEntreeV5Dlg::CEntreeV5Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEntreeV5Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEntreeV5Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CEntreeV5Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEntreeV5Dlg)
	DDX_Control(pDX, IDC_SPLASH, m_splash);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CEntreeV5Dlg, CDialog)
	//{{AFX_MSG_MAP(CEntreeV5Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_LBUTTONDOWN()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEntreeV5Dlg message handlers

BOOL CEntreeV5Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_splash.CenterWindow (this);
	// Set timer here.
	SetTimer(1,4000, NULL);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CEntreeV5Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CEntreeV5Dlg::OnDestroy()
{
	WinHelp(0L, HELP_QUIT);
	CDialog::OnDestroy();
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CEntreeV5Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CEntreeV5Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CEntreeV5Dlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CDialog::OnOK();	
	//CDialog::OnLButtonDown(nFlags, point);
}

// The timer is to leave the EntreeV5 bitmap up only 4 seconds.
void CEntreeV5Dlg::OnTimer(UINT nIDEvent) 
{

	CPoint pt(0,0);
	OnLButtonDown(1,pt);
}

/******************************************************************************

	Name:		getDatabaseVersion

	Action:		To retieve the Database Version from the ncodes database.

	Params:		void

	Returns:	void	

	Notes:		Not all ncodes databases have, DATABASE_VERSION table in them.

	Dates:		Created on 06-28-2001

******************************************************************************/
void CAboutDlg::getDatabaseVersion( void )
{
	m_cstrDatabaseVersion = "Database Version: ";

	GetDlgItem( IDC_DATABASE_VERSION )->SetWindowText( m_cstrDatabaseVersion );

	CString SQLSelect;

	SQLSelect = "SELECT DATABASE_VERSION FROM DATABASE_VERSION ORDER BY DATABASE_VERSION DESC";

	// ado:
	_bstr_t bstrQuery(SQLSelect);
	_variant_t vRecsAffected(0L);

	_RecordsetPtr pRecordSet = NULL;

	try {
		pRecordSet= CEntreeV5App::m_pConnection->Execute(bstrQuery, &vRecsAffected, adOptionUnspecified );


		if( !pRecordSet->GetadoEOF() ) {
			_variant_t vCodenameIdx( "DATABASE_VERSION" );

			_variant_t vData = pRecordSet->GetCollect( vCodenameIdx );

			m_cstrDatabaseVersion += (char*)_bstr_t(vData);

			GetDlgItem( IDC_DATABASE_VERSION )->SetWindowText( m_cstrDatabaseVersion );
		} else {
			m_cstrDatabaseVersion = "Database Version: ";
			m_cstrDatabaseVersion += "No Database Version Table.";

			GetDlgItem( IDC_DATABASE_VERSION )->SetWindowText( m_cstrDatabaseVersion );			
		}

		pRecordSet->Close();
		pRecordSet = NULL;
	} catch( _com_error * e ) {
		m_cstrDatabaseVersion = "Database Version: ";
		m_cstrDatabaseVersion += e->ErrorMessage();

		GetDlgItem( IDC_DATABASE_VERSION )->SetWindowText( m_cstrDatabaseVersion );
						
	} catch( ... ) {
		m_cstrDatabaseVersion = "Database Version: ";
		m_cstrDatabaseVersion += "No Database Version Table.";

		GetDlgItem( IDC_DATABASE_VERSION )->SetWindowText( m_cstrDatabaseVersion );

	}
}