// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: ExecuteStoredProc.h
//
// Author: Yeun Wong
//
// Date Created: October, 2000
//
// Description:  Use ADO technique to execute stored procedures
//
// -----------------------------------------


#ifndef _ADOEXECUTESTROEDPROCEDURE10272000NRDDOTUSA_H_
#define _ADOEXECUTESTROEDPROCEDURE10272000NRDDOTUSA_H_

#include "StdAfx.h"

class CAdoStoredProcExe
{
public:
	CAdoStoredProcExe();
	CAdoStoredProcExe(_ConnectionPtr pConnection);
	~CAdoStoredProcExe();

	bool	OpenDatabase(const CString sPathAndDbName);

	void	setConnection(_ConnectionPtr pConnection) { m_pConnection = pConnection; }
	void	setAltConnection(const bool UseAltConnection) { m_UseAltConnection = UseAltConnection; }
	void	setUserName(const CString username) { m_username = username; }
	void	setPassword(const CString password) { m_password = password; }

	const	_ConnectionPtr	getConnection(){ return m_pConnection; }
	const	bool			getAltConnection(){ return m_UseAltConnection; }
	const	CString			getUserName(){ return m_username; }
	const	CString			getPassword(){ return m_password; }

	STDMETHODIMP			ADOMakeSafeArray(short ArraySize, BSTR Types, BSTR Values, SAFEARRAY **Result);
	STDMETHODIMP			ADOExecuteSP(BSTR SPName, VARIANT ParamArray, _variant_t& Result);
	const _variant_t		ADOExecuteSP(const CString SPName, CString sParamList = "");
	STDMETHODIMP			ADOExecuteSP(BSTR SPName, const CString single_param, _variant_t& Result);
private:
	void			ConnectionErrors();
	const bool		CAdoStoredProcExe::isInteger(const CString Str);	
	const bool		isNumber(const CString Str);
	const int		ParseParam( const CString sArr, CString& sParamType, CString& sParamValue);

private:	// members:

	CString			m_username, m_password;
	bool			m_IsConnectionOpen;
	bool			m_UseAltConnection;

	_ConnectionPtr	m_pConnection;
	_CommandPtr		m_pCommand;
	_RecordsetPtr	m_pRecordSet;

};

#endif //_ADOEXECUTESTROEDPROCEDURE10272000NRDDOTUSA_H_