// Injmeas.cpp : implementation file
//

#include "stdafx.h"
#include "entreeV5.h"
#include "Injmeas.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CInjmeas dialog


CInjmeas::CInjmeas(CVehData* pData, int curocc, CWnd* pParent /*=NULL*/)
	: CDialog(CInjmeas::IDD, pParent)
{
	//{{AFX_DATA_INIT(CInjmeas)
	m_clip3m	= _T("");
	m_csi		= _T("");
	m_hic		= _T("");
	m_pelvg		= _T("");
	m_t1		= _T("");
	m_t2		= _T("");
	m_tti		= _T("");
	//}}AFX_DATA_INIT
	m_curocc = curocc;
	m_pVehData = pData;

	m_bDisplay = true;
	m_bValidate = true;
}


void CInjmeas::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CInjmeas)
	DDX_Control(pDX, IDC_VEHOCC_CLIP3M, m_clip3m);
	DDX_Control(pDX, IDC_VEHOCC_CSI, m_csi);
	DDX_Control(pDX, IDC_VEHOCC_HIC, m_hic);
	DDX_Control(pDX, IDC_VEHOCC_PELVG, m_pelvg);
	DDX_Control(pDX, IDC_VEHOCC_T1, m_t1);
	DDX_Control(pDX, IDC_VEHOCC_T2, m_t2);
	DDX_Control(pDX, IDC_VEHOCC_TTI, m_tti);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CInjmeas, CDialog)
	//{{AFX_MSG_MAP(CInjmeas)
	ON_NOTIFY_EX( TTN_NEEDTEXT, 0, OnToolTipNotify )
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInjmeas message handlers

BOOL CInjmeas::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
    TOOLTIPTEXT *pTTT = (TOOLTIPTEXT *)pNMHDR;
    int nID =pNMHDR->idFrom;
    if (pTTT->uFlags & TTF_IDISHWND)    
	{
        // idFrom is actually the HWND of the tool
        nID = ::GetDlgCtrlID((HWND)nID);    
		if(nID)        
		{
            switch (nID)
			{
			case IDC_VEHOCC_HIC:
				pTTT->lpszText = "0->9999";
				return TRUE;
			case IDC_VEHOCC_CSI:
				pTTT->lpszText = "0->9999";
				return TRUE;
			case IDC_VEHOCC_CLIP3M:
				pTTT->lpszText = "Acceleration (g, 00000.00->99999.99)";
				return TRUE;
			case IDC_VEHOCC_T1:
				pTTT->lpszText = "ms (000000.00->999999.99)";
				return TRUE;
			case IDC_VEHOCC_T2:
				pTTT->lpszText = "ms (000000.00->999999.99)";
				return TRUE;
			case IDC_VEHOCC_PELVG:
				pTTT->lpszText = "00000.00->99999.99";
				return TRUE;
			case IDC_VEHOCC_TTI:
				pTTT->lpszText = "Acceleration (g, 00000.00->99999.99)";
				return TRUE;
						
			}
        }   
	}  
	return FALSE;
}

BOOL CInjmeas::OnInitDialog() 
{
	CDialog::OnInitDialog();
	EnableToolTips();

	SetBusinessRules();

	m_clip3m = m_pVehData->m_clip3m[m_curocc];
	m_csi = m_pVehData->m_csi[m_curocc];
	m_hic = m_pVehData->m_hic[m_curocc];
	m_pelvg = m_pVehData->m_pelvg[m_curocc];
	m_t1 = m_pVehData->m_t1[m_curocc];
	m_t2 = m_pVehData->m_t2[m_curocc];
	m_tti = m_pVehData->m_tti[m_curocc];

	if( m_bDisplay == false )
	{
		if( ValidatePage() == false )
		{
			m_bValidate = false;
		}

		CDialog::OnOK();
	}
	else
	{
		ValidatePage();
	}

	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Created -- Al Wilhelm -- 03/09/2000

******************************************************************************/
void CInjmeas::OnOK()
{
	if( ValidatePage() == false )
	{
		return;
	}
	
	CDialog::OnOK();
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Created -- Al Wilhelm -- 03/10/2000

******************************************************************************/
void CInjmeas::OnCancel() 
{
	if( ValidatePage() == false )
	{
		m_bValidate = false;
	}
	else
	{
		m_bValidate = true;
	}
	
	CDialog::OnCancel();
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Created - Al Wilhelm - 03/08/2000

******************************************************************************/
bool CInjmeas::ValidatePage( void )
{
	bool bRetArray[7];
	
	bRetArray[0] = m_clip3m.GetValidate();
	bRetArray[1] = m_csi.GetValidate();
	bRetArray[2] = m_hic.GetValidate();
	bRetArray[3] = m_pelvg.GetValidate();
	bRetArray[4] = m_t1.GetValidate();
	bRetArray[5] = m_t2.GetValidate();
	bRetArray[6] = m_tti.GetValidate();

	for( int i = 0; i < 7; i++ )
	{
		if( !bRetArray[i] )
		{
			return false;
		}
	}

	return true;
}

/******************************************************************************

	Name:		SetBusinessRules

	Action:		

	Params:		void

	Returns:	void

	Notes:		

	Dates:		Created - Al Wilhelm - 03/08/2000

******************************************************************************/
void CInjmeas::SetBusinessRules( void )
{
	m_clip3m.SetDouble( 0.0, 99999.99, true );
	m_csi.SetDouble( 0, 9999, true );
	m_hic.SetDouble( 0, 9999, true );
	m_pelvg.SetDouble( 0.0, 99999.99, true );
	m_t1.SetDouble( 0.0, 999999.99, true );
	m_t2.SetDouble( 0.0, 999999.99, true );
	m_tti.SetDouble( 0.0, 99999.99, true );
}