// Peakload.cpp : implementation file
//

#include "stdafx.h"
#include "entreeV5.h"
#include "Peakload.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPeakload dialog


CPeakload::CPeakload(CVehData* pData, int curocc, CWnd* pParent /*=NULL*/)
	: CDialog(CPeakload::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPeakload)
	m_lfem	= _T("");
	m_rfem	= _T("");
	m_lbelt	= _T("");
	m_sbelt	= _T("");
	//}}AFX_DATA_INIT
	m_curocc = curocc;
	m_pVehData = pData;

	m_bDisplay = true;
	m_bValidate = true;
}


void CPeakload::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPeakload)
	DDX_Control(pDX, IDC_VEHOCC_LFEM, m_lfem);
	DDX_Control(pDX, IDC_VEHOCC_RFEM, m_rfem);
	DDX_Control(pDX, IDC_VEHOCC_LBELT, m_lbelt);
	DDX_Control(pDX, IDC_VEHOCC_SBELT, m_sbelt);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPeakload, CDialog)
	//{{AFX_MSG_MAP(CPeakload)
	ON_NOTIFY_EX( TTN_NEEDTEXT, 0, OnToolTipNotify )
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPeakload message handlers

BOOL CPeakload::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	EnableToolTips();

	SetBusinessRules();

	m_lfem = m_pVehData->m_lfem[m_curocc];
	m_rfem = m_pVehData->m_rfem[m_curocc];
	m_lbelt = m_pVehData->m_lbelt[m_curocc];
	m_sbelt = m_pVehData->m_sbelt[m_curocc];

	if( m_bDisplay == false )
	{
		if( ValidatePage() == false )
		{
			m_bValidate = false;
		}

		CDialog::OnOK();
	}
	else
	{
		ValidatePage();
	}

	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Created -- Al Wilhelm -- 03/09/2000

******************************************************************************/
void CPeakload::OnOK()
{
	if( ValidatePage() == false )
	{
		return;
	}
	
	CDialog::OnOK();
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Created -- Al Wilhelm -- 03/10/2000

******************************************************************************/
void CPeakload::OnCancel() 
{
	if( ValidatePage() == false )
	{
		m_bValidate = false;
	}
	else
	{
		m_bValidate = true;
	}
	
	CDialog::OnCancel();
}

BOOL CPeakload::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
    TOOLTIPTEXT *pTTT = (TOOLTIPTEXT *)pNMHDR;
    int nID =pNMHDR->idFrom;
    if (pTTT->uFlags & TTF_IDISHWND)    
	{
        // idFrom is actually the HWND of the tool
        nID = ::GetDlgCtrlID((HWND)nID);    
		if(nID)        
		{
            switch (nID)
			{
			case IDC_VEHOCC_LFEM:
				pTTT->lpszText = "newtons (-99999->0)";
				return TRUE;
			case IDC_VEHOCC_RFEM:
				pTTT->lpszText = "newtons (-99999->0)";
				return TRUE;
			case IDC_VEHOCC_LBELT:
				pTTT->lpszText = "newtons (0->99999)";
				return TRUE;
			case IDC_VEHOCC_SBELT:
				pTTT->lpszText = "newtons (0->99999)";
				return TRUE;
			}
        }   
	}  
	return FALSE;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Created - Al Wilhelm - 03/08/2000

******************************************************************************/
bool CPeakload::ValidatePage( void )
{
	bool bRetArray[4];

	bRetArray[0] = m_lfem.GetValidate();
	bRetArray[1] = m_rfem.GetValidate();
	bRetArray[2] = m_lbelt.GetValidate();
	bRetArray[3] = m_sbelt.GetValidate();

	for( int i = 0; i < 4; i++ )
	{
		if( !bRetArray[i] )
		{
			return false;
		}
	}

	return true;
}

/******************************************************************************

	Name:		SetBusinessRules

	Action:		

	Params:		void

	Returns:	void

	Notes:	

	Dates:		Created - Al Wilhelm - 03/08/2000

******************************************************************************/
void CPeakload::SetBusinessRules( void )
{
	m_lfem.SetDouble( -99999.0, 0.0, true );
	m_rfem.SetDouble( -99999.0, 0.0, true );
	m_lbelt.SetDouble( 0.0, 99999.0, true );
	m_sbelt.SetDouble( 0.0, 99999.0, true );
}