// ----------------------------------------------------------------------------------
// File: Search.h
//
// Description:  
//               Display a dlg with results of SQL Query 
//               so the user can select an item (code). 
//				 Use ADO technique to get inside the ado recordset.
//
// ReCoding: Yeun T Wong in 2000 ( ADO version )
// Update:	 Adding quick search, 2003
//
// ----------------------------------------------------------------------------------

#if !defined(AFX_SEARCH_H__FF4BE483_5DF6_11D2_9493_0008C7AA9033__INCLUDED_)
#define AFX_SEARCH_H__FF4BE483_5DF6_11D2_9493_0008C7AA9033__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ListCtrlEx.h"  

/////////////////////////////////////////////////////////////////////////////
// CSearch dialog

class CSearch : public CDialog
{
// Construction
public:
	
	CString m_db;
	CString m_codename;	// table name

	CString m_storedproc;
	CString m_parameter;

	CString m_SQLSelect;

	CSearch(CWnd* pParent = NULL, CString codename = "", CString db="", CString sqlselect = "", bool bSenatt=false);   // standard constructor for SQL command
	void	runStoredProc( CString storedproc, CString parameter, CString codename="", CString db="", CWnd* pParent = NULL );   // special constructor for stored Procedure
	void	SqlExecution();

	CStringArray* getColArray0() { return &Array0; }
	CStringArray* getColArray1() { return &Array1; }
	CStringArray* getColArray2() { return &Array2; }
	CStringArray* getColArray3() { return &Array3; }
	void	SetColumnNames(const CString sN0, const CString sN1, const CString sN2, const CString sN3 );
	CString& GetSecondCode(){ return m_sSecondCode; }
// Dialog Data
	//{{AFX_DATA(CSearch)
	enum { IDD = IDD_SEARCH };
	CButton	m_clear;
	CListCtrlEx	m_searchlist;
	CEdit m_edQSearch;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSearch)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CSearch)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	afx_msg void OnClear();
	afx_msg void OnDblclkSearchlist(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnEnChangeEditQsearch();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	bool	m_SqlCommand;
	void	SqlExecutionAndList();
	void	StoredProcExecution();
	void	AddItemToList(_RecordsetPtr pRecs, const _variant_t & pItem, const int nRow, const int nCol );
	void	AddItemToArray(_RecordsetPtr pRecs, const _variant_t & pItem, const int nRow, const int nCol );
	void	CustomizedList();
	const CString sSenloc(const CString sSenl, CStringArray& sArr0, CStringArray& sArr1);

	bool	m_bSenatt;
	bool	m_bDataFound;

	CString m_sColName0;
	CString m_sColName1;
	CString m_sColName2;
	CString m_sColName3;
	CString m_sSecondCode;
	CString m_sQCode;
	CString m_sOldQCode;

	CStringArray Array0;
	CStringArray Array1;
	CStringArray Array2;
	CStringArray Array3;

public:
	

	afx_msg void OnNMClickSearchlist(NMHDR *pNMHDR, LRESULT *pResult);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SEARCH_H__FF4BE483_5DF6_11D2_9493_0008C7AA9033__INCLUDED_)
