// SWGData.h: interface for the CSWGData class.
//
//////////////////////////////////////////////////////////////////////

#include "SWGGR1.h"
#include "SWGGR5.h"
#include "HighSpeedVideoData.h"

#if !defined(AFX_SWGDATA_H__5BFE7F44_5EB5_11D2_9493_0008C7AA9033__INCLUDED_)
#define AFX_SWGDATA_H__5BFE7F44_5EB5_11D2_9493_0008C7AA9033__INCLUDED_


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CSWGData : public CHighSpeedVideoData
{
public:
	// Constructors/Destructors
	CSWGData();
	virtual ~CSWGData();
	
	//member functions
	BOOL ImportGR5(CString &);
	BOOL ImportGR1(CString &);
	void ExtractTestData(CStdioFile &, int);
	void ExtractCurveData(CStdioFile &, int);
	BOOL ImportEV4(CString &);
	BOOL ImportEV5(CString &);
	void WriteSWGInstReport(CStdioFile &);
	void WriteSWGTestReport(CStdioFile &);
	BOOL ExportEVR (CString &);
	void WriteSWGInst(CStdioFile &);
	void WriteSWGTest(CStdioFile &);
	CString OutString (CString str);
	BOOL ExportEV5(CString&);
	bool ValidateEmptyTest( void );


// data members
public:
	CSWGGR1 m_GR1;
	CSWGGR5 m_GR5;
	
	// CSWGTestPage -- BEGIN
	CString	m_verno;
	CString	m_swgno;
	CString	m_title;
	CString	m_tstobj; 
	CString	m_tstdat;
	CString	m_cerdat;
	CString	m_tstprf;
	CString	m_conno;
	// CString m_tstref;	// defined in CHighSpeedVideo
	CString	m_tsttyp;
	CString	m_temp;
	CString	m_rectyp;
	CString	m_link;
	int		m_totcrv;
	CString	m_tstcom;
	// CSWGTestPage -- END

	// CSWGInstPage -- BEGIN
	// Arrays are used because of multiple curves.
	int m_curno;	// Total number of curves.  Used as an array index, also.
	CStringArray	m_sigsrc;
	CStringArray	m_siglev;
	CStringArray	m_sentyp;
	CStringArray	m_senloc;
	CStringArray	m_senatt;
	CStringArray	m_axis;
	CStringArray	m_xunits;
	CStringArray	m_yunits;
	CStringArray	m_prefil;
	CStringArray	m_insrat;
	CStringArray	m_chlmax;
	CStringArray	m_nfp;
	CStringArray	m_nlp;
	CStringArray	m_delt;
	CStringArray	m_dastat;
	CStringArray	m_chstat;
	CStringArray	m_inscom;
	// CSWGInstPage -- END
};

#endif // !defined(AFX_SWGDATA_H__5BFE7F44_5EB5_11D2_9493_0008C7AA9033__INCLUDED_)
