// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: SWGInstPage.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description:  Member functions of CSWGInstPage.
//               They relate to the loading and display of 
//               data on this page.
//
//  Modification History:
//  Date		Who			Description
//  03/03/00	Yeun Wong	add info data insertion and correct info data indexing
// -----------------------------------------



#include "stdafx.h"
#include "entreeV5.h"
#include "SWGInstPage.h"
#include "search.h"
#include "CodeValidation.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CString search_code;

/////////////////////////////////////////////////////////////////////////////
// CSWGInstPage property page

IMPLEMENT_DYNCREATE(CSWGInstPage, CPropertyPage)

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
CSWGInstPage::CSWGInstPage() : CPropertyPage(CSWGInstPage::IDD)
{
	//{{AFX_DATA_INIT(CSWGInstPage)
	m_axis			= _T("");
	m_chstat		= _T("");
	m_dastat		= _T("");
	m_inscom		= _T("");
	m_senatt		= _T("");
	m_senloc		= _T("");
	m_sentyp		= _T("");
	m_sigsrc		= _T("");
	m_xunits		= _T("");
	m_yunits		= _T("");
	m_retaindata	= FALSE;
	m_siglev		= _T("5");
	m_prefil		= _T("");
	m_insrat		= _T("");
	m_chlmax		= _T("");
	m_nfp			= _T("");
	m_nlp			= _T("");
	m_delt			= _T("");
	//}}AFX_DATA_INIT

	m_icurno= 0;     // Default to 0th curve.
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
CSWGInstPage::~CSWGInstPage()
{
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CSWGInstPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSWGInstPage)
	DDX_Control(pDX, IDC_CURVELIST, m_curvelist);
	DDX_Control(pDX, IDC_NEXTRECORD, m_nextrecordbutton);
	DDX_Control(pDX, IDC_DELETECURVE, m_deletecurvebutton);
	DDX_Control(pDX, IDC_SWGINST_AXIS, m_axis);
	DDX_Control(pDX, IDC_SWGINST_CHSTAT, m_chstat);
	DDX_Control(pDX, IDC_SWGINST_DASTAT, m_dastat);
	DDX_Control(pDX, IDC_SWGINST_INSCOM, m_inscom);
	DDX_Control(pDX, IDC_SWGINST_SENATT, m_senatt);
	DDX_Control(pDX, IDC_SWGINST_SENLOC, m_senloc);
	DDX_Control(pDX, IDC_SWGINST_SENTYP, m_sentyp);
	DDX_Control(pDX, IDC_SWGINST_SIGSRC, m_sigsrc);
	DDX_Control(pDX, IDC_SWGINST_XUNITS, m_xunits);
	DDX_Control(pDX, IDC_SWGINST_YUNITS, m_yunits);
	DDX_Check(pDX, IDC_RETAINDATA, m_retaindata);
	DDX_Control(pDX, IDC_SWGINST_SIGLEV, m_siglev);
	DDX_Control(pDX, IDC_SWGINST_PREFIL, m_prefil);
	DDX_Control(pDX, IDC_SWGINST_INSRAT, m_insrat);
	DDX_Control(pDX, IDC_SWGINST_CHLMAX, m_chlmax);
	DDX_Control(pDX, IDC_SWGINST_NFP, m_nfp);
	DDX_Control(pDX, IDC_SWGINST_NLP, m_nlp);
	DDX_Control(pDX, IDC_SWGINST_DELT, m_delt);
	//}}AFX_DATA_MAP
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BEGIN_MESSAGE_MAP(CSWGInstPage, CPropertyPage)
	//{{AFX_MSG_MAP(CSWGInstPage)
	ON_BN_CLICKED(IDC_NEXTRECORD, OnNextrecord)
	ON_BN_CLICKED(IDC_SWGSIGSRCSEARCH, OnSwgsigsrcsearch)
	ON_BN_CLICKED(IDC_SWGSENTYPSEARCH, OnSwgsentypsearch)
	ON_BN_CLICKED(IDC_SWGSENLOCSEARCH, OnSwgsenlocsearch)
	ON_BN_CLICKED(IDC_SWGSENATTSEARCH, OnSwgsenattsearch)
	ON_BN_CLICKED(IDC_SWGAXISSEARCH, OnSwgaxissearch)
	ON_BN_CLICKED(IDC_SWGXUNITSSEARCH, OnSwgxunitssearch)
	ON_BN_CLICKED(IDC_SWGYUNITSSEARCH, OnSwgyunitssearch)
	ON_BN_CLICKED(IDC_SWGDASTATSEARCH, OnSwgdastatsearch)
	ON_BN_CLICKED(IDC_SWGCHSTATSEARCH, OnSwgchstatsearch)
	ON_BN_CLICKED(IDC_DELETECURVE, OnDeletecurve)
	ON_LBN_SELCHANGE(IDC_CURVELIST, OnSelchangeCurvelist)
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTW, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTA, 0, 0xFFFF, OnToolTipNotify )
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSWGInstPage message handlers

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:		return TRUE unless you set the focus to a control
				EXCEPTION: OCX Property Pages should return FALSE

	Dates:

******************************************************************************/
BOOL CSWGInstPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	CancelToClose();	
	EnableToolTips();

	return TRUE;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CSWGInstPage::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
	TOOLTIPTEXTA* pTTTA = (TOOLTIPTEXTA*)pNMHDR;
	TOOLTIPTEXTW* pTTTW = (TOOLTIPTEXTW*)pNMHDR;
	CString strTipText = "";
	UINT nID = pNMHDR->idFrom;
	if (pNMHDR->code == TTN_NEEDTEXTA && (pTTTA->uFlags & TTF_IDISHWND) ||
		pNMHDR->code == TTN_NEEDTEXTW && (pTTTW->uFlags & TTF_IDISHWND))
	{
		// idFrom is actually the HWND of the tool
		nID = ::GetDlgCtrlID((HWND)nID);
	}

	if (nID != 0) // will be zero on a separator
	{
		strTipText.Format("Control ID = %d", nID);
		switch (nID)
		{
		case IDC_NEXTRECORD:
			strTipText = "Go to (or add) the next curve";
			break;
		case IDC_SWGINST_SIGLEV:
			strTipText = "Integer between 5-5000 for Sensor Type ET, between 5-500 for Sensor Type LL or HL";
			break;
		case IDC_SWGINST_PREFIL:
			strTipText = "Hz (0->99999)";
			break;
		case IDC_SWGINST_INSRAT:
			strTipText = "Integer (-999999->999999)";
			break;
		case IDC_SWGINST_CHLMAX:
			strTipText = "% Integer (0->999)";
			break;
		case IDC_SWGINST_NLP:
			strTipText = "Integer (0->99999)";
			break;
		case IDC_SWGINST_NFP:
			strTipText = "Integer (-10000->0)";
			break;
		case IDC_SWGINST_DELT:
			strTipText = "Microseconds (0->999999)";
			break;
		case IDC_DELETECURVE:
			strTipText = "Delete curve";
			break;
		default:
			strTipText = "";
		}
	}

	if (pNMHDR->code == TTN_NEEDTEXTA)
		lstrcpyn(pTTTA->szText, strTipText, sizeof(pTTTA->szText));
	else
		::MultiByteToWideChar( CP_ACP , 0, strTipText, -1, pTTTW->szText, sizeof(pTTTW->szText) );
	*pResult = 0;

	return TRUE;    // message was handled
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CSWGInstPage::OnNextrecord() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	if (m_icurno==m_totalcurves) //if at end, increase # of curves
	{
		if (m_icurno!=0) { LoadSWGInstData(); }
		m_totalcurves++; 
		m_icurno++;
		InitializeNextCurve();
	} 
	else if (m_icurno != 0) 
	{
		if(!LoadSWGInstData())
		{
			MessageBox("Error: see CSWGInstPage::OnNextcurveButton()");
			return;
		}
		m_icurno++;
	}

	DisplaySWGInstData();
	ValidatePage();

/***
	bool newcurve=false;

	if (m_icurno==m_totalcurves)
	{
//		m_totalcurves++;  // wong corrects
		newcurve=true;
	}   

	if (m_icurno != 0) 
	{
//		BOOL success = LoadSWGInstData();     //load current info (not zeroth curve)
		if (!InsertSWGInstData()) //Data not valid
		{
			if (newcurve) m_totalcurves--;
			return;
		}
	}

	m_icurno++;             //goto next curve 
	m_totalcurves++; // wong added

	if (newcurve) InitializeNextCurve();

	DisplaySWGInstData();  //display next set, if existing

	ValidatePage();
**/
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CSWGInstPage::OnSwgsigsrcsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"SIGSRC","SWGDB");
	if (search.DoModal ()==IDOK)
	{
		m_sigsrc = search_code;
		m_sigsrc.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CSWGInstPage::OnSwgsentypsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"SENTYP","SWGDB");
	if (search.DoModal ()==IDOK)
	{
		m_sentyp = search_code;
		m_sentyp.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CSWGInstPage::OnSwgsenlocsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"SENLOC","SWGDB");
	if (search.DoModal ()==IDOK)
	{
		m_senloc = search_code;
		m_senloc.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CSWGInstPage::OnSwgsenattsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"SENATT","SWGDB");
	if (search.DoModal ()==IDOK)
	{
		m_senatt = search_code;
		m_senatt.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CSWGInstPage::OnSwgaxissearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"AXIS","SWGDB");
	if (search.DoModal ()==IDOK)
	{
		m_axis = search_code;
		m_axis.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CSWGInstPage::OnSwgxunitssearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"UNITS","SWGDB");
	if (search.DoModal ()==IDOK)
	{
		m_xunits = search_code;
		m_xunits.SetValidateColor();

		// for the rule xunits!="SEC"
		COLORREF colorGreyBack = RGB( 192, 192, 192 );		
		COLORREF colorBlackText = RGB( 0, 0, 0 );
		if (search_code!="SEC") 
		{ 
			m_delt = "0";
			m_delt.SetColor(colorBlackText, colorGreyBack);
			m_delt.EnableWindow(false);
		}
		else 
		{ 
			m_delt.EnableWindow();
			COLORREF colorYellowBack = RGB( 255, 255, 0 );
			COLORREF colorWhiteBack = RGB( 255, 255, 255 );
			m_delt = m_pSWGData->m_delt[m_icurno];			
			if (m_delt.GetValidate()) { m_delt.SetColor(colorBlackText, colorWhiteBack); }
			else { m_delt.SetColor(colorBlackText, colorYellowBack); }
		}
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CSWGInstPage::OnSwgyunitssearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"UNITS","SWGDB");
	if (search.DoModal ()==IDOK)
	{
		m_yunits = search_code;
		m_yunits.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CSWGInstPage::OnSwgdastatsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"DASTAT","SWGDB");
	if (search.DoModal ()==IDOK)
	{
		m_dastat = search_code;
		m_dastat.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CSWGInstPage::OnSwgchstatsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"CHSTAT","SWGDB");
	if (search.DoModal ()==IDOK)
	{
		m_chstat = search_code;
		m_chstat.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		This function gets the data from the entry fields and puts
				it into m_pSWGData.  It is called in OnKillActive, ExportData,
				record changed.

	Params:		

	Returns:	

	Notes:		put data into m_pSWGData

	Dates:

******************************************************************************/
BOOL CSWGInstPage::LoadSWGInstData()
{
	if( m_hWnd == NULL )
	{
		// Only return FALSE if bad data.
		return TRUE;
	}

	if( !UpdateData() )
	{
		return FALSE;
	}

	m_pSWGData->m_axis[m_icurno]   = m_axis.GetTextAsString();
	m_pSWGData->m_chlmax[m_icurno] = m_chlmax.GetTextAsString();
	m_pSWGData->m_chstat[m_icurno] = m_chstat.GetTextAsString();
	m_pSWGData->m_curno            = m_totalcurves;
	m_pSWGData->m_dastat[m_icurno] = m_dastat.GetTextAsString();
	m_pSWGData->m_delt[m_icurno]   = m_delt.GetTextAsString();
	m_pSWGData->m_inscom[m_icurno] = m_inscom.GetTextAsString();
	m_pSWGData->m_insrat[m_icurno] = m_insrat.GetTextAsString();
	m_pSWGData->m_nfp[m_icurno]    = m_nfp.GetTextAsString();
	m_pSWGData->m_nlp[m_icurno]    = m_nlp.GetTextAsString();
	m_pSWGData->m_prefil[m_icurno] = m_prefil.GetTextAsString();
	m_pSWGData->m_senatt[m_icurno] = m_senatt.GetTextAsString();
	m_pSWGData->m_senloc[m_icurno] = m_senloc.GetTextAsString();
	m_pSWGData->m_sentyp[m_icurno] = m_sentyp.GetTextAsString();
	m_pSWGData->m_siglev[m_icurno] = m_siglev.GetTextAsString();
	m_pSWGData->m_sigsrc[m_icurno] = m_sigsrc.GetTextAsString();
	m_pSWGData->m_xunits[m_icurno] = m_xunits.GetTextAsString();
	m_pSWGData->m_yunits[m_icurno] = m_yunits.GetTextAsString();

	m_pSWGData->m_totcrv = m_totalcurves;

	return TRUE;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Modify -- Wong 03/02/2000

******************************************************************************/
bool CSWGInstPage::InsertSWGInstData()
{
	if( m_hWnd==NULL )
	{
		// Only return FALSE if data invalid
		return TRUE;
	}
	
	UpdateData();
 
//	m_pBioData->m_ais.InsertAt( m_curinj, m_ais);
	m_pSWGData->m_axis.InsertAt( m_icurno, m_axis.GetTextAsString() );
	m_pSWGData->m_chlmax.InsertAt( m_icurno, m_chlmax.GetTextAsString() );
	m_pSWGData->m_chstat.InsertAt( m_icurno, m_chstat.GetTextAsString() );
	m_pSWGData->m_curno            = m_totalcurves;
	m_pSWGData->m_dastat.InsertAt( m_icurno, m_dastat.GetTextAsString() );
	m_pSWGData->m_delt.InsertAt( m_icurno, m_delt.GetTextAsString() );
	m_pSWGData->m_inscom.InsertAt( m_icurno, m_inscom.GetTextAsString() );
	m_pSWGData->m_insrat.InsertAt( m_icurno, m_insrat.GetTextAsString() );
	m_pSWGData->m_nfp.InsertAt( m_icurno, m_nfp.GetTextAsString() );
	m_pSWGData->m_nlp.InsertAt( m_icurno, m_nlp.GetTextAsString() );
	m_pSWGData->m_prefil.InsertAt( m_icurno, m_prefil.GetTextAsString() );
	m_pSWGData->m_senatt.InsertAt( m_icurno, m_senatt.GetTextAsString() );
	m_pSWGData->m_senloc.InsertAt( m_icurno, m_senloc.GetTextAsString() );
	m_pSWGData->m_sentyp.InsertAt( m_icurno, m_sentyp.GetTextAsString() );
	m_pSWGData->m_siglev.InsertAt( m_icurno, m_siglev.GetTextAsString() );
	m_pSWGData->m_sigsrc.InsertAt( m_icurno, m_sigsrc.GetTextAsString() );
	m_pSWGData->m_xunits.InsertAt( m_icurno, m_xunits.GetTextAsString() );
	m_pSWGData->m_yunits.InsertAt( m_icurno, m_yunits.GetTextAsString() );

	m_pSWGData->m_totcrv = m_totalcurves;

	UpdateData(false);

	return true;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CSWGInstPage::OnKillActive() 
{
	if( ValidatePage() == true )
	{
		LoadSWGInstData();

		
		int nOldCurIndx = m_icurno;
		for (m_icurno=1; m_icurno<m_totalcurves+1; m_icurno++)
		{
			DisplaySWGInstData();
			if (!ValidatePage()) { return false; }
		}
		m_icurno = nOldCurIndx;

		DisplaySWGInstData();

		return CPropertyPage::OnKillActive();
	}
	else
	{
		// Error are found on AnthPage.
		return FALSE;
	}
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CSWGInstPage::OnSetActive() 
{
	SetBusinessRules();

	// Initialize total curves.
	m_totalcurves = max( m_pSWGData->m_totcrv , 0 );

	DisplaySWGInstData();

	ValidatePage();
	
	return CPropertyPage::OnSetActive();
}

/******************************************************************************

	Name:		

	Action:		Get data from m_pSWGData and display it.

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CSWGInstPage::DisplaySWGInstData()
{
	if (m_hWnd==NULL) return;

	char buf[100];

	UpdateCurveListbox();
	
	UpdateData();

	m_axis		= m_pSWGData->m_axis[m_icurno];
	m_chlmax	= m_pSWGData->m_chlmax[m_icurno];
	m_chstat	= m_pSWGData->m_chstat[m_icurno];

	itoa( m_icurno, buf, 10 );
	m_dastat	= m_pSWGData->m_dastat[m_icurno];
	m_delt		= m_pSWGData->m_delt [m_icurno];
 	m_inscom	= m_pSWGData->m_inscom[m_icurno];
 	m_insrat	= m_pSWGData->m_insrat [m_icurno]; 
	m_nfp		= m_pSWGData->m_nfp[m_icurno]; 
 	m_nlp		= m_pSWGData->m_nlp [m_icurno]; 
 	m_prefil	= m_pSWGData->m_prefil[m_icurno]; 
 	m_senatt	= m_pSWGData->m_senatt [m_icurno];
 	m_senloc	= m_pSWGData->m_senloc [m_icurno];
 	m_sentyp	= m_pSWGData->m_sentyp [m_icurno];
 	m_siglev	= m_pSWGData->m_siglev [m_icurno]; 
 	m_sigsrc	= m_pSWGData->m_sigsrc [m_icurno];
	m_xunits	= m_pSWGData->m_xunits [m_icurno];
	m_yunits	= m_pSWGData->m_yunits [m_icurno]; 
	
	if (m_delt.GetValidate()) { m_delt.SetColor(RGB( 0, 0, 0 ), RGB( 255, 255, 255 )); }
	CCodeValidation( m_sigsrc, "SIGSRC","SWGDB" );
	CCodeValidation( m_sentyp, "SENTYP","SWGDB" );
	CCodeValidation( m_senloc, "SENLOC","SWGDB" );
	CCodeValidation( m_senatt, "SENATT","SWGDB" );
	CCodeValidation( m_axis, "AXIS","SWGDB" );

	CCodeValidation( m_xunits, "UNITS","SWGDB" );
	CCodeValidation( m_yunits, "UNITS","SWGDB" );
	CCodeValidation( m_dastat, "DASTAT","SWGDB" );
	CCodeValidation( m_chstat, "CHSTAT","SWGDB" );

	UpdateData(FALSE);
	if (m_pSWGData->m_xunits[m_icurno]=="SEC") { m_delt.EnableWindow(); }
	else 
	{ 
		m_delt.SetColor(RGB( 0, 0, 0 ), RGB( 192, 192, 192 ));
		m_delt.EnableWindow(false); 
	}
}

/******************************************************************************

	Name:		

	Action:		New curve, expand arrays in SWGData for info

	Params:		

	Returns:	

	Notes:		These temp variables are used because the reference that [] 
				returns is invalid when SetAtGrow happens, because SetAtGrow
				(sometimes) moves the array to a different location in memory.   
				If you try to use that reference directly, you will get an
				access violation.

	For Example:	Bad Example
	m_pSWGData->m_inscom.SetAtGrow (m_icurno,m_pSWGData->inscom[m_icurno-1]);

	Dates:

******************************************************************************/
void CSWGInstPage::InitializeNextCurve()
{
	if( m_retaindata )
	{
		CString temp = m_pSWGData->m_axis[m_icurno - 1];
		m_pSWGData->m_axis.SetAtGrow( m_icurno, temp);
		temp = m_pSWGData->m_chlmax[m_icurno - 1];
		m_pSWGData->m_chlmax.SetAtGrow(m_icurno, temp);
		temp = m_pSWGData->m_chstat[m_icurno - 1];
		m_pSWGData->m_chstat.SetAtGrow (m_icurno, temp);
		temp = m_pSWGData->m_dastat[m_icurno - 1];
		m_pSWGData->m_dastat.SetAtGrow (m_icurno, temp);
		temp = m_pSWGData->m_delt[m_icurno - 1];
		m_pSWGData->m_delt.SetAtGrow   (m_icurno, temp);
		temp = m_pSWGData->m_inscom [m_icurno -1];
		m_pSWGData->m_inscom.SetAtGrow (m_icurno, temp);
		temp = m_pSWGData->m_insrat[m_icurno - 1];
		m_pSWGData->m_insrat.SetAtGrow (m_icurno, temp);
		temp = m_pSWGData->m_nfp[m_icurno - 1];
		m_pSWGData->m_nfp.SetAtGrow    (m_icurno, temp);
		temp = m_pSWGData->m_nlp [m_icurno -1];
		m_pSWGData->m_nlp.SetAtGrow    (m_icurno, temp);
		temp = m_pSWGData->m_prefil[m_icurno - 1];
		m_pSWGData->m_prefil.SetAtGrow (m_icurno, temp);
		temp = m_pSWGData->m_senatt[m_icurno - 1];
		m_pSWGData->m_senatt.SetAtGrow (m_icurno, temp);
		temp = m_pSWGData->m_senloc[m_icurno - 1];
		m_pSWGData->m_senloc.SetAtGrow (m_icurno, temp);
		temp = m_pSWGData->m_sentyp[m_icurno - 1];
		m_pSWGData->m_sentyp.SetAtGrow (m_icurno, temp);
		temp = m_pSWGData->m_siglev[m_icurno - 1];
		m_pSWGData->m_siglev.SetAtGrow (m_icurno, temp);
		temp = m_pSWGData->m_sigsrc[m_icurno - 1];
		m_pSWGData->m_sigsrc.SetAtGrow (m_icurno, temp);
		temp = m_pSWGData->m_xunits[m_icurno - 1];
		m_pSWGData->m_xunits.SetAtGrow (m_icurno, temp);
		temp = m_pSWGData->m_yunits[m_icurno - 1];
		m_pSWGData->m_yunits.SetAtGrow (m_icurno, temp);
	}
	else
	{
		m_pSWGData->m_axis.SetAtGrow   (m_icurno,"");
		m_pSWGData->m_chlmax.SetAtGrow (m_icurno,"");
		m_pSWGData->m_chstat.SetAtGrow (m_icurno,"");
		m_pSWGData->m_dastat.SetAtGrow (m_icurno,"");
		m_pSWGData->m_delt.SetAtGrow   (m_icurno,"");
		m_pSWGData->m_inscom.SetAtGrow (m_icurno,"");
		m_pSWGData->m_insrat.SetAtGrow (m_icurno,"");
		m_pSWGData->m_nfp.SetAtGrow    (m_icurno,"");
		m_pSWGData->m_nlp.SetAtGrow    (m_icurno,"");
		m_pSWGData->m_prefil.SetAtGrow (m_icurno,"");
		m_pSWGData->m_senatt.SetAtGrow (m_icurno,"");
		m_pSWGData->m_senloc.SetAtGrow (m_icurno,"");
		m_pSWGData->m_sentyp.SetAtGrow (m_icurno,"");
		m_pSWGData->m_siglev.SetAtGrow (m_icurno,"5");
		m_pSWGData->m_sigsrc.SetAtGrow (m_icurno,"");
		m_pSWGData->m_xunits.SetAtGrow (m_icurno,"SEC");
		m_pSWGData->m_yunits.SetAtGrow (m_icurno,"");
	}
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CSWGInstPage::OnDeletecurve() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	if( m_icurno == 0 ) { return; }

	m_totalcurves--;

	m_pSWGData->m_axis.RemoveAt  (m_icurno);
	m_pSWGData->m_chlmax.RemoveAt(m_icurno);
	m_pSWGData->m_chstat.RemoveAt(m_icurno);
	m_pSWGData->m_dastat.RemoveAt(m_icurno);
	m_pSWGData->m_delt.RemoveAt  (m_icurno);
	m_pSWGData->m_inscom.RemoveAt(m_icurno);
	m_pSWGData->m_insrat.RemoveAt(m_icurno);
	m_pSWGData->m_nfp.RemoveAt   (m_icurno);
	m_pSWGData->m_nlp.RemoveAt   (m_icurno);
	m_pSWGData->m_prefil.RemoveAt(m_icurno);
	m_pSWGData->m_senatt.RemoveAt(m_icurno);
	m_pSWGData->m_senloc.RemoveAt(m_icurno);
	m_pSWGData->m_sentyp.RemoveAt(m_icurno);
	m_pSWGData->m_siglev.RemoveAt(m_icurno);
	m_pSWGData->m_sigsrc.RemoveAt(m_icurno);
	m_pSWGData->m_xunits.RemoveAt(m_icurno);
	m_pSWGData->m_yunits.RemoveAt(m_icurno);

	m_icurno--;		// Goto previous curve 

	// if m_icurno == 0 now, and there are remaining curves,
	// set curve 1 as active (m_icurno=1)
	if( ( m_icurno == 0 ) && ( m_totalcurves > 0 ) )
	{
		m_icurno = 1;
	}
		
	DisplaySWGInstData(); // Display previous set, if existing
}

/******************************************************************************

	Name:		

	Action:		User clicked the curves listbox, so change to that curve

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CSWGInstPage::OnSelchangeCurvelist() 
{
	int nCurve = m_curvelist.GetCurSel ();  //zero based

	if( m_icurno != 0 ) 
	{
		BOOL success = LoadSWGInstData();     //load current info (not zeroth curve)
		if (!success) //Data not valid, dont change curves.
		{
			m_curvelist.SetCurSel (max(0,m_icurno-1));  // select current curve, zero based.
			return;
		}
	}

	m_icurno = nCurve + 1;	// Goto current curve 

	DisplaySWGInstData();	// Display next set, if existing

	ValidatePage();
}

/******************************************************************************

	Name:		

	Action:		Associate the listbox with m_totalcurves

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CSWGInstPage::UpdateCurveListbox()
{
	if (m_curvelist.GetCount () != m_totalcurves)
	{
		m_curvelist.ResetContent();
		char crvbuf [10];
		for (int loop=1;loop <= m_totalcurves;loop++)
		{
			itoa(loop,crvbuf,10);
			if (m_curvelist.FindString (-1,crvbuf)==LB_ERR)  //if buf isnt there already.
			{
				m_curvelist.AddString(crvbuf);
			}
		}
	}

	m_curvelist.SetCurSel (max(0,m_icurno-1));  // select current curve, zero based.
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CSWGInstPage::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	WinHelp(Instruments_Information);
	
	return TRUE;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Created -- Al Wilhelm -- 03/08/2000

******************************************************************************/
bool CSWGInstPage::ValidatePage( void )
{
	const int nTotal = 17;
	bool bRetArray[nTotal];
	
	bRetArray[0] = m_inscom.GetValidate();
	bRetArray[1] = m_siglev.GetValidate();
	bRetArray[2] = m_prefil.GetValidate();
	bRetArray[3] = m_insrat.GetValidate();
	bRetArray[4] = m_chlmax.GetValidate();
	bRetArray[5] = m_nfp.GetValidate();
	bRetArray[6] = m_nlp.GetValidate();
	bRetArray[7] = m_delt.GetValidate();

	bRetArray[8]	= m_sigsrc.GetValidate();
	bRetArray[9]	= m_sentyp.GetValidate();
	bRetArray[10]	= m_senloc.GetValidate();
	bRetArray[11]	= m_senatt.GetValidate();
	bRetArray[12]	= m_axis.GetValidate();

	bRetArray[13]	= m_xunits.GetValidate();
	bRetArray[14]	= m_yunits.GetValidate();
	bRetArray[15]	= m_dastat.GetValidate();
	bRetArray[16]	= m_chstat.GetValidate();

	for( int i = 0; i < nTotal; i++ )
	{
		if( !bRetArray[i] )
		{
			return false;
		}
	}

	return true;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Created -- Al Wilhelm -- 03/08/2000

******************************************************************************/
void CSWGInstPage::SetBusinessRules( void )
{
	m_inscom.SetString( 0, 70, true );
	m_siglev.SetDouble( 5.0, 5000.0, true );
	m_prefil.SetDouble( 0.0, 99999.0, true );
	m_insrat.SetDouble( -999999.0, 999999.0, true );
	m_chlmax.SetDouble( 0, 999, true );
	m_nfp.SetDouble( -10000.0, 0.0, true );
	m_nlp.SetDouble( 0.0, 99999.0, true );
	m_delt.SetDouble( 0.0, 999999.0, true );
}