// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: SWGTestPage.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description:  Member functions of CSWGTestPage.
//               They relate to the loading and display of 
//               data on this page.
// -----------------------------------------



#include "stdafx.h"
#include "entreeV5.h"
#include "SWGTestPage.h"
#include "search.h"
#include "CodeValidation.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CString search_code;

/////////////////////////////////////////////////////////////////////////////
// CSWGTestPage property page

IMPLEMENT_DYNCREATE(CSWGTestPage, CPropertyPage)

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
CSWGTestPage::CSWGTestPage() : CPropertyPage(CSWGTestPage::IDD)
{
	
	//{{AFX_DATA_INIT(CSWGTestPage)
	m_link		= _T("");
	m_rectyp	= _T("");
	m_tstprf	= _T("");
	m_tsttyp	= _T("");
	m_conno		= _T("");
	m_swgno		= _T("");
	m_title		= _T("");
	m_totcrv	= _T("");
	m_tstcom	= _T("");
	m_tstobj	= _T("");
	m_tstref	= _T("");
	m_verno		= _T("");
	m_temp		= _T("");
	//}}AFX_DATA_INIT
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
CSWGTestPage::~CSWGTestPage()
{
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CSWGTestPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSWGTestPage)
	DDX_Control(pDX, IDC_SWGTESTDAT, m_edittestdate);
	DDX_Control(pDX, IDC_SWGCERTDAT, m_editcertdate);
	DDX_Control(pDX, IDC_SWGTESTCERDAT, m_cerdatctrl);
	DDX_Control(pDX, IDC_SWGTESTTSTDAT, m_tstdatctrl);
	DDX_Control(pDX, IDC_SWGTESTLINK, m_link);
	DDX_Control(pDX, IDC_SWGTESTRECTYP, m_rectyp);
	DDX_Control(pDX, IDC_SWGTESTTSTPRF, m_tstprf);
	DDX_Control(pDX, IDC_SWGTESTTSTTYP, m_tsttyp);
	DDX_Control(pDX, IDC_SWGTESTCONNO, m_conno);
	DDX_Control(pDX, IDC_SWGTESTSWGNO, m_swgno);
	DDX_Control(pDX, IDC_SWGTESTTITLE, m_title);
	DDX_Control(pDX, IDC_SWGTESTTOTCRV, m_totcrv);
	DDX_Control(pDX, IDC_SWGTESTTSTCOM, m_tstcom);
	DDX_Control(pDX, IDC_SWGTESTTSTOBJ, m_tstobj);
	DDX_Control(pDX, IDC_SWGTESTTSTREF, m_tstref);
	DDX_Control(pDX, IDC_SWGTESTVERNO, m_verno);
	DDX_Control(pDX, IDC_SWGTESTTEMP, m_temp);
	//}}AFX_DATA_MAP
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BEGIN_MESSAGE_MAP(CSWGTestPage, CPropertyPage)
	//{{AFX_MSG_MAP(CSWGTestPage)
	ON_BN_CLICKED(IDC_SWGTSTTYPSEARCH, OnSwgtsttypsearch)
	ON_BN_CLICKED(IDC_SWGTSTPRFSEARCH, OnSwgtstprfsearch)
	ON_BN_CLICKED(IDC_SWGRECTYPSEARCH, OnSwgrectypsearch)
	ON_BN_CLICKED(IDC_SWGLINKSEARCH, OnSwglinksearch)
	ON_WM_HELPINFO()
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTW, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTA, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY(DTN_DATETIMECHANGE, IDC_SWGTESTCERDAT, OnDatetimechangeSwgtestcerdat)
	ON_NOTIFY(DTN_DATETIMECHANGE, IDC_SWGTESTTSTDAT, OnDatetimechangeSwgtesttstdat)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSWGTestPage message handlers

/******************************************************************************

	Name:		OnInitDialog

	Action:		

	Params:		void

	Returns:	BOOL

	Notes:		return TRUE unless you set the focus to a control
				EXCEPTION: OCX Property Pages should return FALSE

	Dates:

******************************************************************************/
BOOL CSWGTestPage::OnInitDialog( void ) 
{
	CPropertyPage::OnInitDialog();

	m_pSWGData->m_totcrv = 0;

	CancelToClose();
	EnableToolTips();

	m_cerdatctrl.SetFormat( _T("dd/MMM/yyyy") );
	m_tstdatctrl.SetFormat( _T("dd/MMM/yyyy") );
	
	UpdateData(FALSE);

	return TRUE;  
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CSWGTestPage::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
	TOOLTIPTEXTA* pTTTA = (TOOLTIPTEXTA*)pNMHDR;
	TOOLTIPTEXTW* pTTTW = (TOOLTIPTEXTW*)pNMHDR;
	CString strTipText = "";
	UINT nID = pNMHDR->idFrom;
	if (pNMHDR->code == TTN_NEEDTEXTA && (pTTTA->uFlags & TTF_IDISHWND) ||
		pNMHDR->code == TTN_NEEDTEXTW && (pTTTW->uFlags & TTF_IDISHWND))
	{
		// idFrom is actually the HWND of the tool
		nID = ::GetDlgCtrlID((HWND)nID);
	}

	if (nID != 0) // will be zero on a separator
	{
		strTipText.Format("Control ID = %d", nID);
		switch (nID)
		{
		case IDC_SWGTESTTEMP:
			strTipText = "Degrees Celsius (-99->99)";
			break;
		case IDC_SWGTESTDAT:
			strTipText = "Date (dd/MMM/yyyy)";
			break;
		case IDC_SWGCERTDAT:
			strTipText = "Date (dd/MMM/yyyy)";
			break;
		default:
			strTipText = "";
		}
	}

	if (pNMHDR->code == TTN_NEEDTEXTA)
		lstrcpyn(pTTTA->szText, strTipText, sizeof(pTTTA->szText));
	else
		::MultiByteToWideChar( CP_ACP , 0, strTipText, -1, pTTTW->szText, sizeof(pTTTW->szText) );
	*pResult = 0;

	return TRUE;    // message was handled
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CSWGTestPage::OnSwgtsttypsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"TSTTYP","SWGDB");
	if (search.DoModal ()==IDOK)
	{
		m_tsttyp = search_code;
		m_tsttyp.SetValidateColor();
	}
	UpdateData(FALSE);	
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CSWGTestPage::OnSwgtstprfsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

   	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"TSTPRF","SWGDB");
	if (search.DoModal ()==IDOK)
	{
		m_tstprf = search_code;
		m_tstprf.SetValidateColor();
	}
	UpdateData(FALSE);	
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CSWGTestPage::OnSwgrectypsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"RECTYP","SWGDB");
	if (search.DoModal ()==IDOK)
	{
		m_rectyp = search_code;
		m_rectyp.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CSWGTestPage::OnSwglinksearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"LINK","SWGDB");
	if (search.DoModal ()==IDOK)
	{
		m_link = search_code;
		m_link.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CSWGTestPage::OnKillActive() 
{
	if( ValidatePage() == true )
	{
		LoadSWGTestData();

		return CPropertyPage::OnKillActive();
	}
	else
	{
		// Error are found on AnthPage.
		return FALSE;
	}
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CSWGTestPage::OnSetActive() 
{
	SetBusinessRules();

	DisplaySWGTestData();

	ValidatePage();
	
	return CPropertyPage::OnSetActive();
}

/******************************************************************************

	Name:		

	Action:		Get Data out of m_pSWGData, and put it into members of
				SWGTestPage, and then UpdateData(FALSE).

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CSWGTestPage::DisplaySWGTestData()
{
	m_totcrv	= m_pSWGData->m_totcrv;
	m_link		= m_pSWGData->m_link;
	m_rectyp	= m_pSWGData->m_rectyp;
	m_tstprf	= m_pSWGData->m_tstprf;
	m_tsttyp	= m_pSWGData->m_tsttyp;
	m_conno		= m_pSWGData->m_conno;
	m_swgno		= m_pSWGData->m_swgno;
	m_temp		= m_pSWGData->m_temp;
	m_title		= m_pSWGData->m_title;
	m_tstcom	= m_pSWGData->m_tstcom;
	m_tstobj	= m_pSWGData->m_tstobj;
	m_tstref	= m_pSWGData->m_tstref;
	m_verno		= m_pSWGData->m_verno;

	m_cerdatctrl.SetTime(&(StringToTime(m_pSWGData->m_cerdat)));
	m_pSWGData->m_cerdat.MakeUpper();
	m_editcertdate = m_pSWGData->m_cerdat;

	m_tstdatctrl.SetTime(&(StringToTime(m_pSWGData->m_tstdat)));
	m_pSWGData->m_tstdat.MakeUpper();
	m_edittestdate = m_pSWGData->m_tstdat;

	CCodeValidation( m_tsttyp, "TSTTYP","SWGDB" );
	CCodeValidation( m_tstprf, "TSTPRF","SWGDB" );
	CCodeValidation( m_rectyp, "RECTYP","SWGDB" );
	CCodeValidation( m_link, "LINK","SWGDB" );

	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		UpdateData(TRUE), then put data into m_pSWGData from members 
				of SWGTestPage

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CSWGTestPage::LoadSWGTestData()
{
	if( !UpdateData(TRUE) )
	{
		return FALSE;
	}

	m_pSWGData->m_link		= m_link.GetTextAsString();
	m_pSWGData->m_rectyp	= m_rectyp.GetTextAsString();
	m_pSWGData->m_tstprf	= m_tstprf.GetTextAsString();
	m_pSWGData->m_tsttyp	= m_tsttyp.GetTextAsString();
	m_pSWGData->m_conno		= m_conno.GetTextAsString();
	m_pSWGData->m_swgno		= m_swgno.GetTextAsString();
	m_pSWGData->m_temp		= m_temp.GetTextAsString();
	m_pSWGData->m_title		= m_title.GetTextAsString();
	m_pSWGData->m_totcrv	= (int)m_totcrv.GetTextAsNumber();
	m_pSWGData->m_tstcom	= m_tstcom.GetTextAsString();
	m_pSWGData->m_tstobj	= m_tstobj.GetTextAsString();
	m_pSWGData->m_tstref	= m_tstref.GetTextAsString();
	m_pSWGData->m_verno		= m_verno.GetTextAsString();
	
	CString	cerdate("");
	CString	tstdate("");

	GetDlgItemText( IDC_SWGCERTDAT, cerdate );
	GetDlgItemText( IDC_SWGTESTDAT, tstdate );

	m_pSWGData->m_cerdat = cerdate;
	m_pSWGData->m_tstdat = tstdate;

	return TRUE;
}

/******************************************************************************

	Name:		

	Action:		Call Help for specific page.

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CSWGTestPage::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	WinHelp(Test_Information_Group);
	
	return TRUE;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		 

	Returns:	

	Notes:		0 = Number
				1 = String
				2 = Float

	Dates:		Created -- Al Wilhelm -- 03/08/2000

******************************************************************************/
bool CSWGTestPage::ValidatePage( void )
{
	const int nTotal = 14;
	bool bRetArray[nTotal];
	
	bRetArray[0] = m_conno.GetValidate();
	bRetArray[1] = m_swgno.GetValidate();
	bRetArray[2] = m_title.GetValidate();
	bRetArray[3] = m_tstcom.GetValidate();
	bRetArray[4] = m_tstobj.GetValidate();
	bRetArray[5] = m_tstref.GetValidate();
	bRetArray[6] = m_verno.GetValidate();
	bRetArray[7] = m_temp.GetValidate();
	bRetArray[8] = m_edittestdate.GetValidate();
	bRetArray[9] = m_editcertdate.GetValidate();

	bRetArray[10]	= m_tsttyp.GetValidate();
	bRetArray[11]	= m_tstprf.GetValidate();
	bRetArray[12]	= m_rectyp.GetValidate();
	bRetArray[13]	= m_link.GetValidate();

	for( int i = 0; i < nTotal; i++ )
	{
		if( !bRetArray[i] )
		{
			return false;
		}
	}

	return true;
}

/******************************************************************************

	Name:		SetBusinessRules

	Action:		

	Params:		void

	Returns:	void

	Notes:		

	Dates:		Created -- Al Wilhelm -- 03/08/2000

******************************************************************************/
void CSWGTestPage::SetBusinessRules( void )
{
	m_conno.SetString( 0, 17, true );
	m_swgno.SetString( 0, 6, true );
	m_title.SetString( 0, 70, true );
	m_tstcom.SetString( 0, 70, true );
	m_tstobj.SetString( 0, 70, true );
	m_tstref.SetString( 0, 10, true );
	m_verno.SetString( 0, 2, true );
	m_temp.SetDouble( -99, 99, true );
	m_edittestdate.SetDate();
	m_editcertdate.SetDate();
}
void CSWGTestPage::OnDatetimechangeSwgtestcerdat(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CString sDate;
    GetDlgItemText(IDC_SWGTESTCERDAT, sDate);

	sDate.MakeUpper();
	m_editcertdate =  m_pSWGData->m_cerdat = sDate;
	
	*pResult = 0;
}

void CSWGTestPage::OnDatetimechangeSwgtesttstdat(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CString sDate;
    GetDlgItemText(IDC_SWGTESTTSTDAT, sDate);

	sDate.MakeUpper();
	m_edittestdate =  m_pSWGData->m_tstdat = sDate;
	
	*pResult = 0;
}
