// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: VehBarPage.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description:  Member functions of CVehBarPage.
//               They relate to the loading and display of 
//               data on this page.
// -----------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "VehBarPage.h"
#include "search.h"
#include "CodeValidation.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CString search_code;

/////////////////////////////////////////////////////////////////////////////
// CVehBarPage property page

IMPLEMENT_DYNCREATE(CVehBarPage, CPropertyPage)

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
CVehBarPage::CVehBarPage() : CPropertyPage(CVehBarPage::IDD)
{
	//{{AFX_DATA_INIT(CVehBarPage)
	m_editbarshp = _T("");
	m_editbarcom = _T("");
	m_editbardia = _T("");
	m_editbarang = _T("");
	//}}AFX_DATA_INIT
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
CVehBarPage::~CVehBarPage()
{
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
void CVehBarPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVehBarPage)
	DDX_Control(pDX, IDC_VEHBAR_BARSHPSEARCH, m_barshpsearch);
	DDX_Control(pDX, IDC_VEHBAR_BARSHP, m_editbarshp);
	DDX_Control(pDX, IDC_VEHBAR_BARCOM, m_editbarcom);
	DDX_Control(pDX, IDC_VEHBAR_BARDIA, m_editbardia);
	DDX_Control(pDX, IDC_VEHBAR_BARANG, m_editbarang);
	//}}AFX_DATA_MAP
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		

******************************************************************************/
BEGIN_MESSAGE_MAP(CVehBarPage, CPropertyPage)
	//{{AFX_MSG_MAP(CVehBarPage)
	ON_BN_CLICKED(IDC_VEHBAR_BARSHPSEARCH, OnVehbarBarshpsearch)
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTW, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTA, 0, 0xFFFF, OnToolTipNotify )
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVehBarPage message handlers
/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		

******************************************************************************/
void CVehBarPage::OnVehbarBarshpsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"BARSHP","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_editbarshp = search_code;
		m_editbarshp.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Modify - Al Wilhelm - 03/08/2000

******************************************************************************/
BOOL CVehBarPage::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
	TOOLTIPTEXTA* pTTTA = (TOOLTIPTEXTA*)pNMHDR;
	TOOLTIPTEXTW* pTTTW = (TOOLTIPTEXTW*)pNMHDR;
	CString strTipText = "";
	UINT nID = pNMHDR->idFrom;
	if (pNMHDR->code == TTN_NEEDTEXTA && (pTTTA->uFlags & TTF_IDISHWND) ||
		pNMHDR->code == TTN_NEEDTEXTW && (pTTTW->uFlags & TTF_IDISHWND))
	{
		// idFrom is actually the HWND of the tool
		nID = ::GetDlgCtrlID((HWND)nID);
	}

	if (nID != 0) // will be zero on a separator
	{
		strTipText.Format("Control ID = %d", nID);
		switch (nID)
		{
		case IDC_VEHBAR_BARANG:
			strTipText = "Degrees (0->90)";
			break;
		case IDC_VEHBAR_BARDIA:
			strTipText = "mm (0->9999)";
			break;
		case IDC_VEHBAR_BARCOM:
			strTipText = "Comments length can not be longer, then 70 characters.";
			break;
		default: strTipText = "";
		}
	}

	if (pNMHDR->code == TTN_NEEDTEXTA)
		lstrcpyn(pTTTA->szText, strTipText, sizeof(pTTTA->szText));
	else
		::MultiByteToWideChar( CP_ACP , 0, strTipText, -1, pTTTW->szText, sizeof(pTTTW->szText) );
	*pResult = 0;

	return TRUE;    // message was handled
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		

******************************************************************************/
BOOL CVehBarPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	EnableToolTips();

	SendDlgItemMessage(IDC_VEHBAR_DEFBAR,BM_SETCHECK, BST_CHECKED, 0);
	
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/******************************************************************************

	Name:		LoadVehBarData

	Action:		This function gets data from the entry screen and puts it
				into m_pVehData
				It is called from OnKillActive, ExportData, and record changed.

	Params:		void

	Returns:	BOOL

	Notes:	

	Dates:		Modify -- Al Wilhelm -- 03/06/2000

******************************************************************************/
BOOL CVehBarPage::LoadVehBarData( void )
{
	if (m_hWnd==NULL) return TRUE;  //only return false if data invalid

	//put data into m_pVehData
	if( !UpdateData(TRUE) )
	{
		return FALSE;
	}

	m_pVehData->m_cstrbarang	= m_editbarang.GetTextAsString();
	m_pVehData->m_cstrbarcom	= m_editbarcom.GetTextAsString();
	m_pVehData->m_cstrbardia	= m_editbardia.GetTextAsString();
	m_pVehData->m_cstrbarshp	= m_editbarshp.GetTextAsString();
	m_pVehData->m_cstrbarrig	= (	SendDlgItemMessage(
												IDC_VEHBAR_DEFBAR,
												BM_GETCHECK ) == BST_CHECKED ?
												"D" : "R" );
	return TRUE;

}

/******************************************************************************

	Name:		DisplayVehBarData

	Action:		Get data from VehData and display it.

	Params:		void

	Returns:	void

	Notes:	

	Dates:		Modify -- Al Wilhelm -- 03/06/2000

******************************************************************************/
void CVehBarPage::DisplayVehBarData( void )
{

	if( m_pVehData->m_cstrbarrig == "R" )
	{
		SendDlgItemMessage(IDC_VEHBAR_RIGBAR, BM_SETCHECK, BST_CHECKED);
		SendDlgItemMessage(IDC_VEHBAR_DEFBAR, BM_SETCHECK, BST_UNCHECKED);
	}
	else 
	{
		SendDlgItemMessage(IDC_VEHBAR_DEFBAR, BM_SETCHECK, BST_CHECKED);
		SendDlgItemMessage(IDC_VEHBAR_RIGBAR, BM_SETCHECK, BST_UNCHECKED);
	}

	m_editbarshp	= m_pVehData->m_cstrbarshp;
	m_editbarang	= m_pVehData->m_cstrbarang;
	m_editbardia	= m_pVehData->m_cstrbardia;
	m_editbarcom	= m_pVehData->m_cstrbarcom;

	CCodeValidation( m_editbarshp, "BARSHP","VEHDB" );

	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
BOOL CVehBarPage::OnKillActive() 
{
	if( ValidatePage() == true )
	{
		LoadVehBarData();

		return CPropertyPage::OnKillActive();
	}
	else
	{
		// Error are found on AnthPage.
		return FALSE;
	}
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Modify -- Al Wilhelm -- 03/06/2000

******************************************************************************/
BOOL CVehBarPage::OnSetActive() 
{
	SetBusinessRules();

	DisplayVehBarData();

	EnableControls();

	ValidatePage();
	
	return CPropertyPage::OnSetActive();
}

/******************************************************************************

	Name:		EnableControls()

	Action:		If m_pVehData->m_tstcfn is VTB or ITB, enable the controls on
				vehbarpage.  Otherwise, disable them.

	Params:		void

	Returns:	void

	Notes:	

	Dates:		

******************************************************************************/
void CVehBarPage::EnableControls( void )
{
	BOOL bBarrier;
	HWND hWnd;

	if ((m_pVehData->m_tstcfn == "VTB") || (m_pVehData->m_tstcfn == "ITB") ||
		(m_pVehData->m_tstcfn == "OTH") || (m_pVehData->m_tstcfn == "ROL") )
	{
		bBarrier = TRUE;
	}
	else
	{
		bBarrier = FALSE;
	}
	
	m_barshpsearch.EnableWindow (bBarrier);

	hWnd = ::GetDlgItem(m_hWnd, IDC_VEHBAR_BARANG);
	::EnableWindow (hWnd, bBarrier);
	
	hWnd = ::GetDlgItem(m_hWnd, IDC_VEHBAR_BARDIA);
	::EnableWindow (hWnd, bBarrier);

	hWnd = ::GetDlgItem(m_hWnd, IDC_VEHBAR_BARCOM);
	::EnableWindow (hWnd, bBarrier);

	hWnd = ::GetDlgItem(m_hWnd, IDC_VEHBAR_RIGBAR);
	::EnableWindow (hWnd, bBarrier);

	hWnd = ::GetDlgItem(m_hWnd, IDC_VEHBAR_DEFBAR);
	::EnableWindow (hWnd, bBarrier);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		

******************************************************************************/
BOOL CVehBarPage::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	WinHelp(Barrier);
	
	return TRUE;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Created -- Al Wilhelm -- 03/06/2000

******************************************************************************/
bool CVehBarPage::ValidatePage( void )
{
	const int nTotal = 4;
	bool bRetArray[nTotal];
	
	bRetArray[0] = m_editbarcom.GetValidate();
	bRetArray[1] = m_editbardia.GetValidate();
	bRetArray[2] = m_editbarang.GetValidate();

	bRetArray[3] = m_editbarshp.GetValidate();

	for( int i = 0; i < nTotal; i++ )
	{
		if( !bRetArray[i] )
		{
			return false;
		}
	}

	return true;
}

/******************************************************************************

	Name:		SetBusinessRules

	Action:		

	Params:		void

	Returns:	void

	Notes:		0 = Number
				1 = String

	Dates:		Created -- Al Wilhelm -- 03/06/2000

******************************************************************************/
void CVehBarPage::SetBusinessRules( void )
{
	m_editbarcom.SetString( 0, 70, true );
	m_editbardia.SetDouble( 0, 9999, true );
	m_editbarang.SetDouble( 0, 90, true );
}