// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: VehDamage.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description:  Member functions of CVehDamage.
//               Data is displayed and loaded on the
//				 opening and closing of this dlg.
// -----------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "VehDamage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVehDamage dialog

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
CVehDamage::CVehDamage(CVehData* pdata, int vehno, CWnd* pParent /*=NULL*/)
	: CDialog(CVehDamage::IDD, pParent)
{

	//{{AFX_DATA_INIT(CVehDamage)

	//}}AFX_DATA_INIT
	
	m_pVehData = pdata;
	m_vehno = vehno;

	m_bDisplay = true;
	m_bValidate = true;

}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
void CVehDamage::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVehDamage)
	DDX_Control(pDX, IDC_DPD1, m_editdpd1);
	DDX_Control(pDX, IDC_DPD2, m_editdpd2);
	DDX_Control(pDX, IDC_DPD3, m_editdpd3);
	DDX_Control(pDX, IDC_DPD4, m_editdpd4);
	DDX_Control(pDX, IDC_DPD5, m_editdpd5);
	DDX_Control(pDX, IDC_DPD6, m_editdpd6);
	//}}AFX_DATA_MAP
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
BEGIN_MESSAGE_MAP(CVehDamage, CDialog)
	//{{AFX_MSG_MAP(CVehDamage)
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTW, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTA, 0, 0xFFFF, OnToolTipNotify )
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVehDamage message handlers

/******************************************************************************

	Name:		OnInitDialog

	Action:		

	Params:		void

	Returns:	BOOL

	Notes:		Return TRUE unless you set the focus to a control
	            EXCEPTION: OCX Property Pages should return FALSE

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
BOOL CVehDamage::OnInitDialog( void ) 
{
	CDialog::OnInitDialog();

	SetBusinessRules();

	m_editdpd1 = m_pVehData->m_dpd1[m_vehno];
	m_editdpd2 = m_pVehData->m_dpd2[m_vehno];
	m_editdpd3 = m_pVehData->m_dpd3[m_vehno];
	m_editdpd4 = m_pVehData->m_dpd4[m_vehno];
	m_editdpd5= m_pVehData->m_dpd5[m_vehno];
	m_editdpd6 = m_pVehData->m_dpd6[m_vehno];

	if( m_bDisplay == false )
	{
		if( ValidatePage() == false )
		{
			m_bValidate = false;
		}

		CDialog::OnOK();
	}
	else
	{
		ValidatePage();
	}
	
	UpdateData(FALSE);	

	EnableToolTips();

	return TRUE;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Created -- Al Wilhelm -- 03/09/2000

******************************************************************************/
void CVehDamage::OnOK() 
{
	if( ValidatePage() == false )
	{
		return;
	}

	m_bValidate = true;
	
	CDialog::OnOK();
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Created -- Al Wilhelm -- 03/10/2000

******************************************************************************/
void CVehDamage::OnCancel() 
{
	if( ValidatePage() == false )
	{
		m_bValidate = false;
	}
	else
	{
		m_bValidate = true;
	}
	
	CDialog::OnCancel();
}

/******************************************************************************

	Name:		OnToolTipNotify

	Action:		

	Params:		UINT id, NMHDR * pNMHDR, LRESULT * pResult

	Returns:	BOOL

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
BOOL CVehDamage::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
	TOOLTIPTEXTA* pTTTA = (TOOLTIPTEXTA*)pNMHDR;
	TOOLTIPTEXTW* pTTTW = (TOOLTIPTEXTW*)pNMHDR;
	CString strTipText = "";
	UINT nID = pNMHDR->idFrom;
	if (pNMHDR->code == TTN_NEEDTEXTA && (pTTTA->uFlags & TTF_IDISHWND) ||
		pNMHDR->code == TTN_NEEDTEXTW && (pTTTW->uFlags & TTF_IDISHWND))
	{
		// idFrom is actually the HWND of the tool
		nID = ::GetDlgCtrlID((HWND)nID);
	}

	if (nID != 0) // will be zero on a separator
	{
		strTipText.Format("Control ID = %d", nID);
		switch (nID)
		{
		//case IDC_COMPVEHYEAR:
		//	strTipText = "1900->9999";
		//	break;
		//default:
			strTipText = "-9999->9999";
		}
	}

	if (pNMHDR->code == TTN_NEEDTEXTA)
		lstrcpyn(pTTTA->szText, strTipText, sizeof(pTTTA->szText));
	else
		::MultiByteToWideChar( CP_ACP , 0, strTipText, -1, pTTTW->szText, sizeof(pTTTW->szText) );
	*pResult = 0;

	return TRUE;    // message was handled
}

/******************************************************************************

	Name:		ValidateAnthPage

	Action:		

	Params:		void

	Returns:	bool

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
bool CVehDamage::ValidatePage( void )
{
	COLORREF clrText				= RGB( 0, 0, 0 );
	COLORREF clrBackgroundError		= RGB( 255, 255, 0 );
	COLORREF clrBackgroundCorrect	= RGB( 255, 255, 255 );

	bool bRetArray[6];
	
	bRetArray[0] = m_editdpd1.GetValidate();
	bRetArray[1] = m_editdpd2.GetValidate();
	bRetArray[2] = m_editdpd3.GetValidate();
	bRetArray[3] = m_editdpd4.GetValidate();
	bRetArray[4] = m_editdpd5.GetValidate();
	bRetArray[5] = m_editdpd6.GetValidate();

	for( int i = 0; i < 6; i++ )
	{
		if( !bRetArray[i] )
		{
			return false;
		}
	}

	return true;
}

/******************************************************************************

	Name:		SetBusinessRules

	Action:		

	Params:		void

	Returns:	void

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
void CVehDamage::SetBusinessRules( void )
{
	m_editdpd1.SetDouble(  -9999.0, 9999.0, true );
	m_editdpd2.SetDouble(  -9999.0, 9999.0, true );
	m_editdpd3.SetDouble(  -9999.0, 9999.0, true );
	m_editdpd4.SetDouble(  -9999.0, 9999.0, true );
	m_editdpd5.SetDouble(  -9999.0, 9999.0, true );
	m_editdpd6.SetDouble(  -9999.0, 9999.0, true );
}