// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: VehData.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description:  VehData constructors and member functions to
//               process, import and export data.
// -----------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "VehData.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
CVehData::CVehData()
{
	//Member Initialization.
	// General Test Data
	m_verno		= _T("V5");
	m_title		= _T("");
	m_tstobj	= _T("");
	m_tstdat	= _T("");
	m_tstprf	= _T("");
	m_conno		= _T("");
	m_tsttyp	= _T("");
	m_tstref	= _T("");
	m_tstcfn	= _T("VTB");
	m_tksurf	= _T("");
	m_tkcond	= _T("");
	m_temp		= _T("");
	m_rectyp	= _T("");
	m_link		= _T("");
	m_clsspd	= _T("");
	m_impang	= _T("");
	m_offset	= _T("");
	m_imppnt	= _T("");
	m_totcrv	= 0;
	m_tstcom	= _T("");

	//Vehicle Info Data - arrays for multiple vehicles- currently only 2 allowed.*****
	m_vehno=1;   //number of vehicles, also used as array index
	m_make.SetSize (3); m_make.SetAtGrow(0,""); m_make.SetAtGrow (1,""); m_make.SetAtGrow (2,"");
	m_model.SetSize (3); m_model.SetAtGrow(0,""); m_model.SetAtGrow(1,""); m_model.SetAtGrow(2,"");

	m_year.SetSize( 3 );
	m_year.SetAtGrow( 0, "1999" );
	m_year.SetAtGrow( 1, "1999" );
	m_year.SetAtGrow( 2, "1999" );

	m_nhtsano.SetSize(3); m_nhtsano.SetAtGrow( 0, "" ); m_nhtsano.SetAtGrow( 1, "" ); m_nhtsano.SetAtGrow( 2, "" );

	m_body.SetSize(3); m_body.SetAtGrow(0,""); m_body.SetAtGrow(1,""); m_body.SetAtGrow(2,"");
	m_vin.SetSize(3); m_vin.SetAtGrow(0,""); m_vin.SetAtGrow(1,""); m_vin.SetAtGrow(2,"");
	m_engine.SetSize(3); m_engine.SetAtGrow(0,""); m_engine.SetAtGrow(1,""); m_engine.SetAtGrow(2,"");

	m_engdsp.SetSize( 3 );
	m_engdsp.SetAtGrow( 0, "" );
	m_engdsp.SetAtGrow( 1, "" );
	m_engdsp.SetAtGrow( 2, "" );

	m_transm.SetSize(3); m_transm.SetAtGrow(0,""); m_transm.SetAtGrow(1,"");m_transm.SetAtGrow(2,"");
	m_vehtwt.SetSize(3); m_vehtwt.SetAtGrow( 0, "" ); m_vehtwt.SetAtGrow( 1, "" );m_vehtwt.SetAtGrow( 2, "" );
	m_whlbas.SetSize(3); m_whlbas.SetAtGrow( 0, "" ); m_whlbas.SetAtGrow( 1, "" );m_whlbas.SetAtGrow( 2, "" );
	m_vehlen.SetSize(3); m_vehlen.SetAtGrow( 0, "" ); m_vehlen.SetAtGrow( 1, "" );m_vehlen.SetAtGrow( 2, "" );
	m_vehwid.SetSize(3); m_vehwid.SetAtGrow( 0, "" ); m_vehwid.SetAtGrow( 1, "" );m_vehwid.SetAtGrow( 2, "" );
	m_vehcg.SetSize(3); m_vehcg.SetAtGrow( 0, "" ); m_vehcg.SetAtGrow( 1, "" );m_vehcg.SetAtGrow( 2, "" );
	m_strsep.SetSize(3); m_strsep.SetAtGrow(0,""); m_strsep.SetAtGrow(1,""); m_strsep.SetAtGrow(2,"");
	m_colmec.SetSize(3); m_colmec.SetAtGrow(0,""); m_colmec.SetAtGrow(1,"");m_colmec.SetAtGrow(2,"");
	m_modind.SetSize(3); m_modind.SetAtGrow(0,""); m_modind.SetAtGrow(1,"");m_modind.SetAtGrow(2,"");
	m_moddsc.SetSize(3); m_moddsc.SetAtGrow(0,""); m_moddsc.SetAtGrow(1,"");m_moddsc.SetAtGrow(2,"");
	m_bx1.SetSize(3); m_bx1.SetAtGrow( 0, "" ); m_bx1.SetAtGrow( 1, "" );m_bx1.SetAtGrow( 2, "" );
	m_bx2.SetSize(3); m_bx2.SetAtGrow( 0, "" ); m_bx2.SetAtGrow( 1, "" );m_bx2.SetAtGrow( 2, "" );
	m_bx3.SetSize(3); m_bx3.SetAtGrow( 0, "" ); m_bx3.SetAtGrow( 1, "" );m_bx3.SetAtGrow( 2, "" );
	m_bx4.SetSize(3); m_bx4.SetAtGrow( 0, "" ); m_bx4.SetAtGrow( 1, "" );m_bx4.SetAtGrow( 2, "" );
	m_bx5.SetSize(3); m_bx5.SetAtGrow( 0, "" ); m_bx5.SetAtGrow( 1, "" );m_bx5.SetAtGrow( 2, "" );
	m_bx6.SetSize(3); m_bx6.SetAtGrow( 0, "" ); m_bx6.SetAtGrow( 1, "" );m_bx6.SetAtGrow( 2, "" );
	m_bx7.SetSize(3); m_bx7.SetAtGrow( 0, "" ); m_bx7.SetAtGrow( 1, "" );m_bx7.SetAtGrow( 2, "" );
	m_bx8.SetSize(3); m_bx8.SetAtGrow( 0, "" ); m_bx8.SetAtGrow( 1, "" );m_bx8.SetAtGrow( 2, "" );
	m_bx9.SetSize(3); m_bx9.SetAtGrow( 0, "" ); m_bx9.SetAtGrow( 1, "" );m_bx9.SetAtGrow( 2, "" );
	m_bx10.SetSize(3); m_bx10.SetAtGrow( 0, "" ); m_bx10.SetAtGrow( 1, "" );m_bx10.SetAtGrow( 2, "" );
	m_bx11.SetSize(3); m_bx11.SetAtGrow( 0, "" ); m_bx11.SetAtGrow( 1, "" );m_bx11.SetAtGrow( 2, "" );
	m_bx12.SetSize(3); m_bx12.SetAtGrow( 0, "" ); m_bx12.SetAtGrow( 1, "" );m_bx12.SetAtGrow( 2, "" );
	m_bx13.SetSize(3); m_bx13.SetAtGrow( 0, "" ); m_bx13.SetAtGrow( 1, "" );m_bx13.SetAtGrow( 2, "" );
	m_bx14.SetSize(3); m_bx14.SetAtGrow( 0, "" ); m_bx14.SetAtGrow( 1, "" );m_bx14.SetAtGrow( 2, "" );
	m_bx15.SetSize(3); m_bx15.SetAtGrow( 0, "" ); m_bx15.SetAtGrow( 1, "" );m_bx15.SetAtGrow( 2, "" );
	m_bx16.SetSize(3); m_bx16.SetAtGrow( 0, "" ); m_bx16.SetAtGrow( 1, "" );m_bx16.SetAtGrow( 2, "" );
	m_bx17.SetSize(3); m_bx17.SetAtGrow( 0, "" ); m_bx17.SetAtGrow( 1, "" );m_bx17.SetAtGrow( 2, "" );
	m_bx18.SetSize(3); m_bx18.SetAtGrow( 0, "" ); m_bx18.SetAtGrow( 1, "" );m_bx18.SetAtGrow( 2, "" );
	m_bx19.SetSize(3); m_bx19.SetAtGrow( 0, "" ); m_bx19.SetAtGrow( 1, "" );m_bx19.SetAtGrow( 2, "" );
	m_bx20.SetSize(3); m_bx20.SetAtGrow( 0, "" ); m_bx20.SetAtGrow( 1, "" );m_bx20.SetAtGrow( 2, "" );
	m_bx21.SetSize(3); m_bx21.SetAtGrow( 0, "" ); m_bx21.SetAtGrow( 1, "" );m_bx21.SetAtGrow( 2, "" );

	m_vehspd.SetSize( 3 );
	m_vehspd.SetAtGrow( 0, "" );
	m_vehspd.SetAtGrow( 1, "" );
	m_vehspd.SetAtGrow( 2, "" );

	m_crbang.SetSize(3); m_crbang.SetAtGrow( 0, "" ); m_crbang.SetAtGrow( 1, "" );m_crbang.SetAtGrow( 2, "" );
	m_pdof.SetSize(3); m_pdof.SetAtGrow( 0, "" ); m_pdof.SetAtGrow( 1, "" );m_pdof.SetAtGrow( 2, "" );
	m_bmpeng.SetSize(3); m_bmpeng.SetAtGrow(0,""); m_bmpeng.SetAtGrow(1,"");m_bmpeng.SetAtGrow( 2, "" );
	m_sileng.SetSize(3); m_sileng.SetAtGrow(0,""); m_sileng.SetAtGrow(1,"");m_sileng.SetAtGrow( 2, "" );
	m_apleng.SetSize(3); m_apleng.SetAtGrow(0,""); m_apleng.SetAtGrow(1,"");m_apleng.SetAtGrow( 2, "" );

	m_dpd1.SetSize( 3 );
	m_dpd1.SetAtGrow( 0, "" );
	m_dpd1.SetAtGrow( 1, "" );
	m_dpd1.SetAtGrow( 2, "" );

	m_dpd2.SetSize( 3 );
	m_dpd2.SetAtGrow( 0, "" );
	m_dpd2.SetAtGrow( 1, "" );
	m_dpd2.SetAtGrow( 2, "" );

	m_dpd3.SetSize( 3 );
	m_dpd3.SetAtGrow( 0, "" );
	m_dpd3.SetAtGrow( 1, "" );
	m_dpd3.SetAtGrow( 2, "" );

	m_dpd4.SetSize( 3 );
	m_dpd4.SetAtGrow( 0, "" );
	m_dpd4.SetAtGrow( 1, "" );
	m_dpd4.SetAtGrow( 2, "" );

	m_dpd5.SetSize(3);
	m_dpd5.SetAtGrow( 0, "" );
	m_dpd5.SetAtGrow( 1, "" );
	m_dpd5.SetAtGrow( 2, "" );

	m_dpd6.SetSize( 3 );
	m_dpd6.SetAtGrow( 0, "" );
	m_dpd6.SetAtGrow( 1, "" );
	m_dpd6.SetAtGrow( 2, "" );

	m_vdi.SetSize(3); m_vdi.SetAtGrow(0,""); m_vdi.SetAtGrow(1,"");m_vdi.SetAtGrow( 2, "" );
	m_lencnt.SetSize(3); m_lencnt.SetAtGrow( 0, "" ); m_lencnt.SetAtGrow( 1, "" );m_lencnt.SetAtGrow( 2, "" );

	m_damdst.SetSize( 3 );
	m_damdst.SetAtGrow( 0, "" );
	m_damdst.SetAtGrow( 1, "" );
	m_damdst.SetAtGrow( 2, "" );

	m_crhdst.SetSize(3); m_crhdst.SetAtGrow( 0, "" ); m_crhdst.SetAtGrow( 1, "" );m_crhdst.SetAtGrow( 2, "" );
	m_ax1.SetSize(3); m_ax1.SetAtGrow( 0, "" ); m_ax1.SetAtGrow( 1, "" );m_ax1.SetAtGrow( 2, "" );
	m_ax2.SetSize(3); m_ax2.SetAtGrow( 0, "" ); m_ax2.SetAtGrow( 1, "" );m_ax2.SetAtGrow( 2, "" );
	m_ax3.SetSize(3); m_ax3.SetAtGrow( 0, "" ); m_ax3.SetAtGrow( 1, "" );m_ax3.SetAtGrow( 2, "" );
	m_ax4.SetSize(3); m_ax4.SetAtGrow( 0, "" ); m_ax4.SetAtGrow( 1, "" );m_ax4.SetAtGrow( 2, "" );
	m_ax5.SetSize(3); m_ax5.SetAtGrow( 0, "" ); m_ax5.SetAtGrow( 1, "" );m_ax5.SetAtGrow( 2, "" );
	m_ax6.SetSize(3); m_ax6.SetAtGrow( 0, "" ); m_ax6.SetAtGrow( 1, "" );m_ax6.SetAtGrow( 2, "" );
	m_ax7.SetSize(3); m_ax7.SetAtGrow( 0, "" ); m_ax7.SetAtGrow( 1, "" );m_ax7.SetAtGrow( 2, "" );
	m_ax8.SetSize(3); m_ax8.SetAtGrow( 0, "" ); m_ax8.SetAtGrow( 1, "" );m_ax8.SetAtGrow( 2, "" );
	m_ax9.SetSize(3); m_ax9.SetAtGrow( 0, "" ); m_ax9.SetAtGrow( 1, "" );m_ax9.SetAtGrow( 2, "" );
	m_ax10.SetSize(3); m_ax10.SetAtGrow( 0, "" ); m_ax10.SetAtGrow( 1, "" );m_ax10.SetAtGrow( 2, "" );
	m_ax11.SetSize(3); m_ax11.SetAtGrow( 0, "" ); m_ax11.SetAtGrow( 1, "" );m_ax11.SetAtGrow( 2, "" );
	m_ax12.SetSize(3); m_ax12.SetAtGrow( 0, "" ); m_ax12.SetAtGrow( 1, "" );m_ax12.SetAtGrow( 2, "" );
	m_ax13.SetSize(3); m_ax13.SetAtGrow( 0, "" ); m_ax13.SetAtGrow( 1, "" );m_ax13.SetAtGrow( 2, "" );
	m_ax14.SetSize(3); m_ax14.SetAtGrow( 0, "" ); m_ax14.SetAtGrow( 1, "" );m_ax14.SetAtGrow( 2, "" );
	m_ax15.SetSize(3); m_ax15.SetAtGrow( 0, "" ); m_ax15.SetAtGrow( 1, "" );m_ax15.SetAtGrow( 2, "" );
	m_ax16.SetSize(3); m_ax16.SetAtGrow( 0, "" ); m_ax16.SetAtGrow( 1, "" );m_ax16.SetAtGrow( 2, "" );
	m_ax17.SetSize(3); m_ax17.SetAtGrow( 0, "" ); m_ax17.SetAtGrow( 1, "" );m_ax17.SetAtGrow( 2, "" );
	m_ax18.SetSize(3); m_ax18.SetAtGrow( 0, "" ); m_ax18.SetAtGrow( 1, "" );m_ax18.SetAtGrow( 2, "" );
	m_ax19.SetSize(3); m_ax19.SetAtGrow( 0, "" ); m_ax19.SetAtGrow( 1, "" );m_ax19.SetAtGrow( 2, "" );
	m_ax20.SetSize(3); m_ax20.SetAtGrow( 0, "" ); m_ax20.SetAtGrow( 1, "" );m_ax20.SetAtGrow( 2, "" );
	m_ax21.SetSize(3); m_ax21.SetAtGrow( 0, "" ); m_ax21.SetAtGrow( 1, "" );m_ax21.SetAtGrow( 2, "" );
	m_carang.SetSize(3); m_carang.SetAtGrow( 0, "" ); m_carang.SetAtGrow( 1, "" );m_carang.SetAtGrow( 2, "" );
	m_vehor.SetSize(3); m_vehor.SetAtGrow( 0, "" ); m_vehor.SetAtGrow( 1, "" );m_vehor.SetAtGrow( 2, "" );
	m_vehcom.SetSize(3); m_vehcom.SetAtGrow( 0, "" ); m_vehcom.SetAtGrow( 1, "" );m_vehcom.SetAtGrow( 2, "" );

	// CVehBarPage -- BEGIN
	m_cstrbarrig = _T("");
	m_cstrbarshp = _T("");
	m_cstrbarang = _T("");
	m_cstrbardia = _T("");
	m_cstrbarcom = _T("");
	// CVehBarPage -- END

	// CVehOccPage -- BEGIN
	m_occsets = 0;
	m_Occ_vehno.SetAtGrow( 0, "" );
	m_Occ_vehno.SetAtGrow( 1, "" ); 
	m_occloc.SetAtGrow( 0, "" );
	m_occloc.SetAtGrow( 1, "" );
	m_occtyp.SetAtGrow( 0, "" );
	m_occtyp.SetAtGrow( 1, "" );
	m_occage.SetAtGrow( 0, "" );
	m_occage.SetAtGrow( 1, "" );
	m_occsex.SetAtGrow(0,""); m_occsex.SetAtGrow(1,"");
	m_occht.SetAtGrow(0,""); m_occht.SetAtGrow(1,"");
	m_occwt.SetAtGrow(0,""); m_occwt.SetAtGrow(1,"");
	m_mthcal.SetAtGrow(0,""); m_mthcal.SetAtGrow(1,"");
	m_dumsiz.SetAtGrow(0,""); m_dumsiz.SetAtGrow(1,"");
	m_dumman.SetAtGrow(0,""); m_dumman.SetAtGrow(1,"");
	m_dummod.SetAtGrow(0,""); m_dummod.SetAtGrow(1,"");
	m_dumdsc.SetAtGrow(0,""); m_dumdsc.SetAtGrow(1,"");
	m_hh.SetAtGrow( 0, "" ); m_hh.SetAtGrow( 1, "" );
	m_hw.SetAtGrow( 0, "" ); m_hw.SetAtGrow( 1, "" );
	m_hr.SetAtGrow( 0, "" ); m_hr.SetAtGrow( 1, "" );
	m_hs.SetAtGrow( 0, "" ); m_hs.SetAtGrow( 1, "" );
	m_cd.SetAtGrow( 0, "" ); m_cd.SetAtGrow( 1, "" );
	m_cs.SetAtGrow( 0, "" ); m_cs.SetAtGrow( 1, "" );
	m_ad.SetAtGrow( 0, "" ); m_ad.SetAtGrow( 1, "" );
	m_hd.SetAtGrow( 0, "" ); m_hd.SetAtGrow( 1, "" );
	m_kd.SetAtGrow( 0, "" ); m_kd.SetAtGrow( 1, "" );
	m_hb.SetAtGrow( 0, "" ); m_hb.SetAtGrow( 1, "" );
	m_nb.SetAtGrow( 0, "" ); m_nb.SetAtGrow( 1, "" );
	m_cb.SetAtGrow( 0, "" ); m_cb.SetAtGrow( 1, "" );
	m_kb.SetAtGrow( 0, "" ); m_kb.SetAtGrow( 1, "" );
	m_seposn.SetAtGrow(0,""); m_seposn.SetAtGrow(1,"");
	m_cntrh1.SetAtGrow(0,""); m_cntrh1.SetAtGrow(1,"");
	m_cntrh2.SetAtGrow(0,""); m_cntrh2.SetAtGrow(1,"");
	m_cntrc1.SetAtGrow(0,""); m_cntrc1.SetAtGrow(1,"");
	m_cntrc2.SetAtGrow(0,""); m_cntrc2.SetAtGrow(1,"");
	m_cntrl1.SetAtGrow(0,""); m_cntrl1.SetAtGrow(1,"");
	m_cntrl2.SetAtGrow(0,""); m_cntrl2.SetAtGrow(1,"");
	m_hic.SetAtGrow( 0, "" ); m_hic.SetAtGrow ( 1, "" );
	m_t1.SetAtGrow( 0, "" );
	m_t1.SetAtGrow( 1, "" );
	m_t2.SetAtGrow( 0, "" );
	m_t2.SetAtGrow( 1, "" );
	m_clip3m.SetAtGrow( 0, "" );
	m_clip3m.SetAtGrow( 1, "" );
	m_lfem.SetAtGrow( 0, "" );
	m_lfem.SetAtGrow( 1, "" );
	m_rfem.SetAtGrow( 0, "" );
	m_rfem.SetAtGrow( 1, "" );
	m_csi.SetAtGrow( 0, "" );
	m_csi.SetAtGrow( 1, "" );
	m_lbelt.SetAtGrow( 0, "" );
	m_lbelt.SetAtGrow( 1, "" );
	m_sbelt.SetAtGrow( 0, "" );
	m_sbelt.SetAtGrow( 1, "" );
	m_tti.SetAtGrow( 0, "" );
	m_tti.SetAtGrow( 1, "" );
	m_pelvg.SetAtGrow( 0, "" );
	m_pelvg.SetAtGrow( 1, "" );
	m_occcom.SetAtGrow( 0, "" );
	m_occcom.SetAtGrow( 1, "" );
	// CVehOccPage -- END


    //Occupant Restraints Info *******************************************
	m_restsets = 0;
	m_Rest_vehno.SetAtGrow( 0, "1" );
	m_Rest_vehno.SetAtGrow( 1, "1" );
	m_Rest_occloc.SetAtGrow( 0,"" );
	m_Rest_occloc.SetAtGrow( 1,"" );
	m_rstno.SetAtGrow( 0, "1" );
	m_rstno.SetAtGrow( 1, "1" );
	m_rsttyp.SetAtGrow(	0, "" );
	m_rsttyp.SetAtGrow( 1, "" );
	m_rstmnt.SetAtGrow(	0, "" );
	m_rstmnt.SetAtGrow( 1, "" );
	m_deploy.SetAtGrow(	0, "" );
	m_deploy.SetAtGrow( 1, "" );
	m_rstcom.SetAtGrow(	0, "" );
	m_rstcom.SetAtGrow( 1, "" );

	// Instrumentation Info ***********************************************
	m_Inst_vehno.SetAtGrow( 0, "1" );
	m_Inst_vehno.SetAtGrow( 1, "1" );
	m_curno = 0;	// Nnumber of curves, also used as array index.
	m_senloc.SetAtGrow( 0, "" );
	m_senloc.SetAtGrow( 1, "" );
	m_sentyp.SetAtGrow( 0, "" );
	m_sentyp.SetAtGrow( 1, "" );
	m_senatt.SetAtGrow( 0, "" );
	m_senatt.SetAtGrow( 1, "" );
	m_axis.SetAtGrow( 0, "" );
	m_axis.SetAtGrow( 1, "" ); 
	m_xunits.SetAtGrow( 0, "SEC" );
	m_xunits.SetAtGrow( 1, "SEC" );
	m_yunits.SetAtGrow( 0, "" );
	m_yunits.SetAtGrow( 1, "" );
	m_prefil.SetAtGrow( 0, "" );
	m_prefil.SetAtGrow( 1, "" );
	m_insman.SetAtGrow( 0, "" );
	m_insman.SetAtGrow( 1, "" );
	m_caldat.SetAtGrow( 0, "" );
	m_caldat.SetAtGrow( 1, "" );
	m_insrat.SetAtGrow( 0, "" );
	m_insrat.SetAtGrow( 1, "" );
	m_chlmax.SetAtGrow( 0, "" );
	m_chlmax.SetAtGrow( 1, "" );
	m_inivel.SetAtGrow( 0, "" );
	m_inivel.SetAtGrow( 1, "" );
	m_nfp.SetAtGrow( 0, "" );
	m_nfp.SetAtGrow( 1, "" );
	m_nlp.SetAtGrow( 0,"" );
	m_nlp.SetAtGrow( 1, "" );
	m_delt.SetAtGrow( 0, "" );
	m_delt.SetAtGrow( 1, "" );
	m_dastat.SetAtGrow( 0, "" );
	m_dastat.SetAtGrow( 1, "" );
	m_chstat.SetAtGrow( 0, "");
	m_chstat.SetAtGrow( 1, "" );
	m_inscom.SetAtGrow( 0, "");
	m_inscom.SetAtGrow( 1, "" );

/*	// Intrusion page
	m_nrt_no.SetAtGrow( 0, "");			m_nrt_no.SetAtGrow( 1, "1");
	m_nrt_vehno.SetAtGrow( 0, "");		m_nrt_vehno.SetAtGrow( 1, "");
//	m_nrt_point.SetAtGrow( 0, "");		m_nrt_point.SetAtGrow( 1, "");
	m_nrt_pointno.SetAtGrow( 0, "");	m_nrt_pointno.SetAtGrow( 1, "");
	m_nrt_pointloc.SetAtGrow( 0, "");	m_nrt_pointloc.SetAtGrow( 1, "");
	m_nrt_bix.SetAtGrow( 0, "");		m_nrt_bix.SetAtGrow( 1, "");
	m_nrt_biy.SetAtGrow( 0, "");		m_nrt_biy.SetAtGrow( 1, "");
	m_nrt_biz.SetAtGrow( 0, "");		m_nrt_biz.SetAtGrow( 1, "");
	m_nrt_aix.SetAtGrow( 0, "");		m_nrt_aix.SetAtGrow( 1, "");
	m_nrt_aiy.SetAtGrow( 0, "");		m_nrt_aiy.SetAtGrow( 1, "");
	m_nrt_aiz.SetAtGrow( 0, "");		m_nrt_aiz.SetAtGrow( 1, "");
	// Intrusion page end
*/
	m_IntrusionData.SetTestRef(m_tstref);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
CVehData::~CVehData()
{

}

//******************
// ExportEV5 
// This function creates a .ev5 file and writes the data in VehData out to it. 
// *****************
/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehData::ExportEV5(CString & strfile_out)
{
	CStdioFile myFile;
	CFileException fileException;

	myFile.Open(	strfile_out,
					CFile::modeCreate | CFile::modeReadWrite | CFile::typeText,
					&fileException );

	if( !myFile.m_pStream )  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_out, fileException.m_cause );
		MessageBox(NULL,msg,"Error",MB_OK);
		return FALSE;
	}
	
	CTime now = CTime::GetCurrentTime ();
	myFile.WriteString ("# Source: Entree for Windows v5\n");
	CString strToday;
	strToday.Format("# Date: <%d/%d/%d>\n", now.GetMonth(), now.GetDay(), now.GetYear() );
	myFile.WriteString (strToday);
	
	myFile.WriteString ("----- EV5 -----\n");

	WriteVehTest( myFile );
	WriteVehVeh( myFile );
	WriteVehBar( myFile );
	WriteVehOcc( myFile );
	WriteVehRest( myFile );
	WriteVehInst( myFile );

	myFile.WriteString ("----- END -----\n");

	myFile.Close ();

	return TRUE;
}

/******************************************************************************

	Name:		WriteVehTest 	

	Action:		Write Test info to EV5 in a standardized order

	Params:		CStdioFile& myFile

	Returns:	void

	Notes:		Last String in VehTest, dont use OutString to append |, 
				instead append \n.

	Dates:

******************************************************************************/
void CVehData::WriteVehTest( CStdioFile& myFile )
{	
	if( ValidateEmptyTest() == true )
	{
		return;
	}

	CString cstrValue("");

	myFile.WriteString ("----- TEST -----\n");
	
	myFile.WriteString( OutString( m_verno ) );
	myFile.WriteString( OutString( m_title ) );
	myFile.WriteString( OutString( m_tstobj ) );

	m_tstdat.MakeUpper();
	myFile.WriteString( OutString( m_tstdat ) );
	myFile.WriteString( OutString( m_tstprf ) );
	myFile.WriteString( OutString( m_conno ) );
	myFile.WriteString( OutString( m_tstref ) );
	myFile.WriteString( OutString( m_tsttyp ) );
	myFile.WriteString( OutString( m_tstcfn ) );
	myFile.WriteString( OutString( m_tksurf ) );
	myFile.WriteString( OutString( m_tkcond ) );
	myFile.WriteString( OutString( m_temp ) );
	myFile.WriteString( OutString( m_rectyp ) );
	myFile.WriteString( OutString( m_link ) );
	myFile.WriteString( OutString( m_clsspd ) );
	myFile.WriteString( OutString( m_impang ) );
	myFile.WriteString( OutString( m_offset ) );
	myFile.WriteString( OutString( m_imppnt ) );

	cstrValue.Format( "%d", m_totcrv );
	myFile.WriteString( OutString( cstrValue ) );
	myFile.WriteString( m_tstcom + '\n'); 
}

/******************************************************************************

	Name:		ValidateEmptyTest

	Action:		

	Params:		void

	Returns:	bool

	Notes:		

	Dates:		Created -- Al Wilhelm -- 03/17/2000

******************************************************************************/
bool CVehData::ValidateEmptyTest( void )
{
	if(		( m_title.IsEmpty() == TRUE )
		&&	( m_tstobj.IsEmpty() == TRUE )
		&&	( m_tstprf.IsEmpty() == TRUE )
		&&	( m_conno.IsEmpty() == TRUE )
		&&	( m_tstref.IsEmpty() == TRUE )
		&&	( m_tsttyp.IsEmpty() == TRUE )
		&&	( m_tksurf.IsEmpty() == TRUE )
		&&	( m_tkcond.IsEmpty() == TRUE )
		&&	( m_temp.IsEmpty() == TRUE )
		&&	( m_rectyp.IsEmpty() == TRUE )
		&&	( m_link.IsEmpty() == TRUE )
		&&	( m_clsspd.IsEmpty() == TRUE )
		&&	( m_impang.IsEmpty() == TRUE )
		&&	( m_offset.IsEmpty() == TRUE )
		&&	( m_imppnt.IsEmpty() == TRUE )
		&&	( m_tstcom.IsEmpty() == TRUE )
		&&	( m_totcrv <= 0 )	)
	{
		return true;
	}

	return false;
}

/******************************************************************************

	Name:		WriteVehVeh	

	Action:		

	Params:		CStdioFile& myFile

	Returns:	void

	Notes:		The last String in VehVeh, so don't use OutString to append |,
				instead append \n

	Dates:

******************************************************************************/
void CVehData::WriteVehVeh( CStdioFile& myFile )
{
	if( ValidateEmptyVeh() == true )
	{
		return;
	}

	CString	cstrValue("");

	myFile.WriteString( "----- VEHICLE -----\n" );

	for( int loop = 1; loop <= m_vehno; loop++ )
	{
		cstrValue.Format( "%d", loop );
		myFile.WriteString( OutString( cstrValue ) );
		myFile.WriteString( OutString(m_make[loop]));
		myFile.WriteString( OutString(m_model[loop]));
		myFile.WriteString( OutString(m_year[loop]));
		myFile.WriteString( OutString(m_nhtsano[loop]));
		myFile.WriteString( OutString(m_body[loop]));
		myFile.WriteString( OutString(m_vin[loop]));
		myFile.WriteString( OutString(m_engine[loop]));
		myFile.WriteString( OutString( m_engdsp[loop] ) );
		myFile.WriteString( OutString(m_transm[loop]) );
		myFile.WriteString( OutString(m_vehtwt[loop]) );
		myFile.WriteString( OutString(m_whlbas[loop]) );
		myFile.WriteString( OutString(m_vehlen[loop]) );
		myFile.WriteString( OutString(m_vehwid[loop]) );
		myFile.WriteString( OutString(m_vehcg[loop]) );
		myFile.WriteString( OutString(m_strsep[loop]) );
		myFile.WriteString( OutString(m_colmec[loop]) );
		myFile.WriteString( OutString(m_modind[loop]) );
		myFile.WriteString( OutString(m_moddsc[loop]) );
		myFile.WriteString( OutString(m_bx1[loop]));
		myFile.WriteString( OutString(m_bx2[loop]));
		myFile.WriteString( OutString(m_bx3[loop]));
		myFile.WriteString( OutString(m_bx4[loop]));
		myFile.WriteString( OutString(m_bx5[loop]));
		myFile.WriteString( OutString(m_bx6[loop]));
		myFile.WriteString( OutString(m_bx7[loop]));
		myFile.WriteString( OutString(m_bx8[loop]));
		myFile.WriteString( OutString(m_bx9[loop]));
		myFile.WriteString( OutString(m_bx10[loop]));
		myFile.WriteString( OutString(m_bx11[loop]));
		myFile.WriteString( OutString(m_bx12[loop]));
		myFile.WriteString( OutString(m_bx13[loop]));
		myFile.WriteString( OutString(m_bx14[loop]));
		myFile.WriteString( OutString(m_bx15[loop]));
		myFile.WriteString( OutString(m_bx16[loop]));
		myFile.WriteString( OutString(m_bx17[loop]));
		myFile.WriteString( OutString(m_bx18[loop]));
		myFile.WriteString( OutString(m_bx19[loop]));
		myFile.WriteString( OutString(m_bx20[loop]));
		myFile.WriteString( OutString(m_bx21[loop]));
		myFile.WriteString( OutString( m_vehspd[loop] ) );
		myFile.WriteString( OutString(m_crbang[loop]));
		myFile.WriteString( OutString(m_pdof[loop]));
		myFile.WriteString( OutString(m_bmpeng[loop]));
		myFile.WriteString( OutString(m_sileng[loop]));
		myFile.WriteString( OutString(m_apleng[loop]));
		myFile.WriteString( OutString(m_dpd1[loop]));
		myFile.WriteString( OutString(m_dpd2[loop]));
		myFile.WriteString( OutString(m_dpd3[loop]));
		myFile.WriteString( OutString(m_dpd4[loop]));
		myFile.WriteString( OutString(m_dpd5[loop]));
		myFile.WriteString( OutString(m_dpd6[loop]));
		myFile.WriteString( OutString(m_vdi[loop]));
		myFile.WriteString( OutString(m_lencnt[loop]));
		myFile.WriteString( OutString(m_damdst[loop]));
		myFile.WriteString( OutString(m_crhdst[loop]));
		myFile.WriteString( OutString(m_ax1[loop]));
		myFile.WriteString( OutString(m_ax2[loop]));
		myFile.WriteString( OutString(m_ax3[loop]));
		myFile.WriteString( OutString(m_ax4[loop]));
		myFile.WriteString( OutString(m_ax5[loop]));
		myFile.WriteString( OutString(m_ax6[loop]));
		myFile.WriteString( OutString(m_ax7[loop]));
		myFile.WriteString( OutString(m_ax8[loop]));
		myFile.WriteString( OutString(m_ax9[loop]));
		myFile.WriteString( OutString(m_ax10[loop]));
		myFile.WriteString( OutString(m_ax11[loop]));
		myFile.WriteString( OutString(m_ax12[loop]));
		myFile.WriteString( OutString(m_ax13[loop]));
		myFile.WriteString( OutString(m_ax14[loop]));
		myFile.WriteString( OutString(m_ax15[loop]));
		myFile.WriteString( OutString(m_ax16[loop]));
		myFile.WriteString( OutString(m_ax17[loop]));
		myFile.WriteString( OutString(m_ax18[loop]));
		myFile.WriteString( OutString(m_ax19[loop]));
		myFile.WriteString( OutString(m_ax20[loop]));
		myFile.WriteString( OutString(m_ax21[loop]));		
		myFile.WriteString( OutString(m_carang[loop]));
		myFile.WriteString( OutString(m_vehor[loop]));
		myFile.WriteString( m_vehcom[loop] + '\n');
	}
}

/******************************************************************************

	Name:		ValidateEmptyVeh

	Action:		

	Params:		void

	Returns:	bool

	Notes:		

	Dates:		Created -- Al Wilhelm -- 03/17/2000

******************************************************************************/
bool CVehData::ValidateEmptyVeh( void )
{
	if(		( m_make[ 1 ].IsEmpty() == TRUE )
		&&	( m_model[ 1 ].IsEmpty() == TRUE )
		&&	( m_nhtsano[ 1 ].IsEmpty() == TRUE )
		&&	( m_body[ 1 ].IsEmpty() == TRUE )
		&&	( m_vin[ 1 ].IsEmpty() == TRUE )
		&&	( m_engine[ 1 ].IsEmpty() == TRUE )
		&&	( m_engdsp[ 1 ].IsEmpty() == TRUE )
		&&	( m_transm[ 1 ].IsEmpty() == TRUE )
		&&	( m_vehtwt[ 1 ].IsEmpty() == TRUE )
		&&	( m_whlbas[ 1 ].IsEmpty() == TRUE )
		&&	( m_vehlen[ 1 ].IsEmpty() == TRUE )
		&&	( m_vehwid[ 1 ].IsEmpty() == TRUE )
		&&	( m_vehcg[ 1 ].IsEmpty() == TRUE )
		&&	( m_strsep[ 1 ].IsEmpty() == TRUE )
		&&	( m_colmec[ 1 ].IsEmpty() == TRUE )
		&&	( m_modind[ 1 ].IsEmpty() == TRUE )
		&&	( m_moddsc[ 1 ].IsEmpty() == TRUE )
		&&	( m_vehspd[ 1 ].IsEmpty() == TRUE )
		&&	( m_crbang[ 1 ].IsEmpty() == TRUE )
		&&	( m_pdof[ 1 ].IsEmpty() == TRUE )
		&&	( m_bmpeng[ 1 ].IsEmpty() == TRUE )
		&&	( m_sileng[ 1 ].IsEmpty() == TRUE )
		&&	( m_apleng[ 1 ].IsEmpty() == TRUE )
		&&	( m_vdi[ 1 ].IsEmpty() == TRUE )
		&&	( m_lencnt[ 1 ].IsEmpty() == TRUE )
		&&	( m_damdst[ 1 ].IsEmpty() == TRUE )
		&&	( m_crhdst[ 1 ].IsEmpty() == TRUE )
		&&	( m_carang[ 1 ].IsEmpty() == TRUE )
		&&	( m_vehor[ 1 ].IsEmpty() == TRUE )
		&&	( m_vehcom[ 1 ].IsEmpty() == TRUE ) )
	{
		return true;
	}

	return false;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:		Last String in Vehbar, don't use OutString to append |,instead
				append \n

	Dates:

******************************************************************************/
void CVehData::WriteVehBar(CStdioFile& myFile)
{
	if( ValidateEmptyBar() == true )
	{
		return;
	}

	myFile.WriteString ("----- BARRIER -----\n");

	myFile.WriteString( OutString( m_cstrbarrig ) );
	myFile.WriteString( OutString( m_cstrbarshp ) );
	myFile.WriteString( OutString( m_cstrbarang ) );
	myFile.WriteString( OutString( m_cstrbardia ) );
	myFile.WriteString( m_cstrbarcom + '\n' );
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:		If m_tstcfn = VTV,ITI,VTI,ITV there should be no BARRIER Info,
	
	Dates:		Created -- Al Wilhelm -- 03/17/2000

******************************************************************************/
bool CVehData::ValidateEmptyBar( void )
{
	if(		( m_tstcfn == "VTV" ) 
		||	( m_tstcfn == "ITI" )
		||	( m_tstcfn == "VTI" )
		||	( m_tstcfn == "ITV" ) )
	{
		return true;
	}

	if(		( m_cstrbarshp.IsEmpty() == TRUE )
		&&	( m_cstrbarang.IsEmpty() == TRUE )
		&&	( m_cstrbardia.IsEmpty() == TRUE )
		&&	( m_cstrbarcom.IsEmpty() == TRUE ) )
	{
		return true;
	}

	return false;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:		occcom is last string, so dont use OutString to append |, 
				instead append \n

	Dates:		Modified - Al Wilhelm - 03/08/2000

******************************************************************************/
void CVehData::WriteVehOcc(CStdioFile& myFile)
{
	if( m_occsets <= 0 )
	{
		return;
	}

	CString	cstrValue("");

	myFile.WriteString( "----- OCCUPANT -----\n" );

	for( int loop = 1; loop <= m_occsets; loop++ )  
	{
//		cstrValue.Format( "%d", m_Occ_vehno[loop] );
//		myFile.WriteString( OutString( cstrValue ) );
		myFile.WriteString( OutString(m_Occ_vehno[loop] ) );
		myFile.WriteString( OutString(m_occloc[loop] ) );
		myFile.WriteString( OutString(m_occtyp[loop]));
		myFile.WriteString( OutString(m_occage[loop]));
		myFile.WriteString( OutString(m_occsex[loop]));
		myFile.WriteString( OutString(m_occht[loop]));
		myFile.WriteString( OutString(m_occwt[loop]));
		myFile.WriteString( OutString(m_mthcal[loop]));
		myFile.WriteString( OutString(m_dumsiz[loop]));
		myFile.WriteString( OutString(m_dumman[loop]));
		myFile.WriteString( OutString(m_dummod[loop]));
		myFile.WriteString( OutString(m_dumdsc[loop]));
		myFile.WriteString( OutString(m_hh[loop]));
		myFile.WriteString( OutString(m_hw[loop]));
		myFile.WriteString( OutString(m_hr[loop]));
		myFile.WriteString( OutString(m_hs[loop]));
		myFile.WriteString( OutString(m_cd[loop]));
		myFile.WriteString( OutString(m_cs[loop]));
		myFile.WriteString( OutString(m_ad[loop]));
		myFile.WriteString( OutString(m_hd[loop]));
		myFile.WriteString( OutString(m_kd[loop]));
		myFile.WriteString( OutString(m_hb[loop]));
		myFile.WriteString( OutString(m_nb[loop]));
		myFile.WriteString( OutString(m_cb[loop]));
		myFile.WriteString( OutString(m_kb[loop]));
		myFile.WriteString( OutString(m_seposn[loop]));
		myFile.WriteString( OutString(m_cntrh1[loop]));
		myFile.WriteString( OutString(m_cntrh2[loop]));
		myFile.WriteString( OutString(m_cntrc1[loop]));
		myFile.WriteString( OutString(m_cntrc2[loop]));
		myFile.WriteString( OutString(m_cntrl1[loop]));
		myFile.WriteString( OutString(m_cntrl2[loop]));
		myFile.WriteString( OutString(m_hic[loop]));
		myFile.WriteString( OutString( m_t1[loop] ) );
		myFile.WriteString( OutString( m_t2[loop] ) );
		myFile.WriteString( OutString( m_clip3m[loop] ) );
		myFile.WriteString( OutString(m_lfem[loop]));
		myFile.WriteString( OutString(m_rfem[loop]));
		myFile.WriteString( OutString(m_csi[loop]));
		myFile.WriteString( OutString(m_lbelt[loop]));
		myFile.WriteString( OutString(m_sbelt[loop]));
		myFile.WriteString( OutString( m_tti[loop] ) );
		myFile.WriteString( OutString( m_pelvg[loop] ) );
		myFile.WriteString( m_occcom[loop] + '\n'); 
	}
}

//*****************************************************************************
//
//	Name:		WriteVehRest
//	Action:		
//	Params:		CSdioFile &
//	Returns:	void
//	Notes:		rstcom is last string, so dont use Outstring to append |,
//				instead append \n.
//	Dates:
//
//*****************************************************************************
void CVehData::WriteVehRest( CStdioFile& myFile )
{
	if( m_restsets <= 0 )
	{
		return;
	}

	myFile.WriteString ("----- RESTRAINT -----\n");

	for( int loop = 1; loop <= m_restsets; loop++ )
	{
		myFile.WriteString( OutString( m_Rest_vehno[loop] ) );
		myFile.WriteString( OutString( m_Rest_occloc[loop] ) );
		myFile.WriteString( OutString( m_rstno[loop] ) );
		myFile.WriteString( OutString( m_rsttyp[loop] ) );
		myFile.WriteString( OutString( m_rstmnt[loop] ) );
		myFile.WriteString( OutString( m_deploy[loop] ) );
		myFile.WriteString( m_rstcom[loop] +'\n' ); 
	}
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:		inscom is last string, so dont use OutString to append |,
				instead append '\n'

	Dates:

******************************************************************************/
void CVehData::WriteVehInst(CStdioFile& myFile)
{
	if( m_totcrv <= 0 )
	{
		return;
	}

	char temp [100];

	myFile.WriteString ("----- INSTRUMENTATION -----\n");

	for( int loop = 1; loop <= m_totcrv; loop++ )  
	{
		myFile.WriteString (OutString(m_Inst_vehno[loop]));

		itoa(loop,temp,10);
		myFile.WriteString (OutString(temp));
		myFile.WriteString (OutString(m_sentyp[loop]));
		myFile.WriteString (OutString(m_senloc[loop]));
		myFile.WriteString (OutString(m_senatt[loop]));
		myFile.WriteString (OutString(m_axis[loop]));
		myFile.WriteString (OutString(m_xunits[loop]));
		myFile.WriteString (OutString(m_yunits[loop]));
		myFile.WriteString (OutString(m_prefil[loop]));
		myFile.WriteString (OutString(m_insman[loop]));

		m_caldat[loop].MakeUpper();
		myFile.WriteString (OutString(m_caldat[loop]));
		myFile.WriteString (OutString(m_insrat[loop]));
		myFile.WriteString (OutString(m_chlmax[loop]));
		myFile.WriteString (OutString(m_inivel[loop]));
		myFile.WriteString (OutString(m_nfp[loop]));
		myFile.WriteString (OutString(m_nlp[loop]));
		myFile.WriteString (OutString(m_delt[loop]));
		myFile.WriteString (OutString(m_dastat[loop]));
		myFile.WriteString (OutString(m_chstat[loop]));
		myFile.WriteString (m_inscom[loop] + '\n'); 
	}
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
CString CVehData::OutString(CString str)
{
	if (str=="")
	{
		str=" |";
	}
	else
	{
		str+= "|";
	}
	
	return str;

}

// **********************
// Create a report (.evr) from the current vehdata
//
// **********************
/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehData::ExportEVR(CString & strfile_out)
{
	CStdioFile myFile;
	CFileException fileException;

	myFile.Open( strfile_out, CFile::modeCreate | CFile::modeReadWrite | CFile::typeText,
		&fileException );
	if (!myFile.m_pStream)  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_out, fileException.m_cause );
		MessageBox(NULL,msg,"Error",MB_OK);
		return FALSE;
	}
	
	CTime now = CTime::GetCurrentTime ();
	myFile.WriteString ("# Source: Entree for Windows v5\n");
	CString strToday;
	strToday.Format("# Date: <%d/%d/%d>\n", now.GetMonth(), now.GetDay(), now.GetYear() );
	myFile.WriteString (strToday);
	myFile.WriteString ("----- EV5 REPORT FILE -----\n");

	WriteVehTestReport(myFile);
	WriteVehVehReport (myFile);
	WriteVehBarReport (myFile);
	WriteVehOccReport (myFile);
	WriteVehRestReport(myFile);
	WriteVehInstReport(myFile);

	myFile.WriteString ("----- END -----\n");

	myFile.Close ();


	return TRUE;
}

/******************************************************************************

	Name:		WriteVehTestReport	

	Action:		Write the VehTest part of a Report (evr) file

	Params:		CStdioFile & myFile

	Returns:	void

	Notes:	

	Dates:		Modify - Al Wilhelm - 03/06/2000

******************************************************************************/
void CVehData::WriteVehTestReport(CStdioFile & myFile)
{
	if( ValidateEmptyTest() == true )
	{
		return;
	}

	CString	cstrValue("");

	myFile.WriteString( "----- TEST -----\n" );
	
	myFile.WriteString( "Version Number:	" + m_verno + "\n" );
	myFile.WriteString( "Test Title:	" + m_title + "\n" );	
	myFile.WriteString( "Test Objectives:	" + m_tstobj + "\n" );
	myFile.WriteString( "Test Date:	" + m_tstdat + "\n" );
	myFile.WriteString( "Test Performer:	" + m_tstprf + "\n" );	
	myFile.WriteString( "Contract Number:	" + m_conno + "\n" );	
	myFile.WriteString( "Test Reference Number:	" + m_tstref + "\n" );
	myFile.WriteString( "Test Type:	" + m_tsttyp + "\n" );
	myFile.WriteString( "Test Configuration:	" + m_tstcfn + "\n" );
	myFile.WriteString( "Test Track Surface:	" + m_tksurf + "\n" );
	myFile.WriteString( "Test Track Condition:	" + m_tkcond + "\n" );
	myFile.WriteString( "Ambient Temperature:	" + m_temp + "\n" );
	myFile.WriteString( "Recorder Type:	" + m_rectyp + "\n" );
	myFile.WriteString( "Data Link Type:	" + m_link + "\n" );
	myFile.WriteString( "Closing Speed:	" + m_clsspd + "\n" );
	myFile.WriteString( "Impact Angle:	" + m_impang + "\n" );
	myFile.WriteString( "Offset Distance:	" + m_offset + "\n" );
	myFile.WriteString( "Side Impact Point:	" + m_imppnt + "\n" );
	myFile.WriteString( "Test Comments:	" + m_tstcom + "\n" ); 

	cstrValue.Format( "%d", m_totcrv );
	myFile.WriteString( "Total Number of Curves:	" + cstrValue + "\n" );
}

/******************************************************************************

	Name:		WriteVehVehReport	

	Action:		Write the VehVeh part of a report (.evr)

	Params:		CStdioFile & myFile

	Returns:	void

	Notes:	

	Dates:

******************************************************************************/
void CVehData::WriteVehVehReport( CStdioFile & myFile )
{
	if( ValidateEmptyVeh() == true )
	{
		return;
	}

	CString	cstrValue("");

	myFile.WriteString ("----- VEHICLE -----\n");

	for( int loop = 1;loop <= m_vehno; loop++ )
	{
		cstrValue.Format( "%d", loop );
		myFile.WriteString( "----- VEHICLE NUMBER " + cstrValue + " -----\n" );
		myFile.WriteString( "Make:	"+m_make[loop]+"\n");
		myFile.WriteString( "Model:	"+m_model[loop]+"\n");
		myFile.WriteString( "Model Year:	"+m_year[loop]+"\n");
		myFile.WriteString( "NHTSA Number:	"+m_nhtsano[loop]+"\n");
		myFile.WriteString( "Body Type:	"+m_body[loop]+"\n");
		myFile.WriteString( "Manufacturer VIN:	"+m_vin[loop]+"\n");
		myFile.WriteString( "Engine Type:	"+m_engine[loop]+"\n");
		myFile.WriteString ("Engine Displacement:	" + m_engdsp[loop] + "\n" );
		myFile.WriteString ("Transmission Type:	"+m_transm[loop]+"\n");
		myFile.WriteString ("Vehicle Test Weight:	"+m_vehtwt[loop]+"\n");
		myFile.WriteString ("Wheelbase:	"+m_whlbas[loop]+"\n");
		myFile.WriteString ("Vehicle Length:	"+m_vehlen[loop]+"\n");
		myFile.WriteString("Vehicle Width:	"+m_vehwid[loop]+"\n");
		myFile.WriteString ("Center of Gravity Distance Behind Front Axle:	"+m_vehcg[loop]+"\n");
		myFile.WriteString ("Steering Column Shear Capsule Separation:	"+m_strsep[loop]+"\n");
		myFile.WriteString ("Steering Column Collapse Mechanism:	"+m_colmec[loop]+"\n");
		myFile.WriteString ("Vehicle Modification Indicator:	"+m_modind[loop]+"\n");
		myFile.WriteString ("Description of Vehicle Modification:	"+m_moddsc[loop]+"\n");
		myFile.WriteString ("BX1:	"+m_bx1[loop]+"\n");
		myFile.WriteString ("BX2:	"+m_bx2[loop]+"\n");
		myFile.WriteString ("BX3:	"+m_bx3[loop]+"\n");
		myFile.WriteString ("BX4:	"+m_bx4[loop]+"\n");
		myFile.WriteString ("BX5:	"+m_bx5[loop]+"\n");
		myFile.WriteString ("BX6:	"+m_bx6[loop]+"\n");
		myFile.WriteString ("BX7:	"+m_bx7[loop]+"\n");
		myFile.WriteString ("BX8:	"+m_bx8[loop]+"\n");
		myFile.WriteString ("BX9:	"+m_bx9[loop]+"\n");
		myFile.WriteString ("BX10:	"+m_bx10[loop]+"\n");
		myFile.WriteString ("BX11:	"+m_bx11[loop]+"\n");
		myFile.WriteString ("BX12:	"+m_bx12[loop]+"\n");
		myFile.WriteString ("BX13:	"+m_bx13[loop]+"\n");
		myFile.WriteString ("BX14:	"+m_bx14[loop]+"\n");
		myFile.WriteString ("BX15:	"+m_bx15[loop]+"\n");
		myFile.WriteString ("BX16:	"+m_bx16[loop]+"\n");
		myFile.WriteString ("BX17:	"+m_bx17[loop]+"\n");
		myFile.WriteString ("BX18:	"+m_bx18[loop]+"\n");
		myFile.WriteString ("BX19:	"+m_bx19[loop]+"\n");
		myFile.WriteString ("BX20:	"+m_bx20[loop]+"\n");
		myFile.WriteString ("BX21:	"+m_bx21[loop]+"\n");
		myFile.WriteString ("Vehicle Speed:	" + m_vehspd[loop] + "\n" );
		myFile.WriteString ("Crabbed Angle:	"+m_crbang[loop]+"\n");
		myFile.WriteString ("Principle Direction of Force:	"+m_pdof[loop]+"\n");
		myFile.WriteString ("Bumper Engagement:	"+m_bmpeng[loop]+"\n");
		myFile.WriteString ("Sill Engagement:	"+m_sileng[loop]+"\n");
		myFile.WriteString ("A-Pillar Engagement:	"+m_apleng[loop]+"\n");
		myFile.WriteString ("Damage Profile Distance 1:	"+m_dpd1[loop]+"\n");
		myFile.WriteString ("Damage Profile Distance 2:	"+m_dpd2[loop]+"\n");
		myFile.WriteString ("Damage Profile Distance 3:	"+m_dpd3[loop]+"\n");
		myFile.WriteString ("Damage Profile Distance 4:	"+m_dpd4[loop]+"\n");
		myFile.WriteString ("Damage Profile Distance 5:	"+m_dpd5[loop]+"\n");
		myFile.WriteString ("Damage Profile Distance 6:	"+m_dpd6[loop]+"\n");
		myFile.WriteString("Vehicle Damage Index:	"+m_vdi[loop]+"\n");
		myFile.WriteString ("Indentation Length:	"+m_lencnt[loop]+"\n");
		myFile.WriteString ("Damage Distance to Center of Gravity:	"+m_damdst[loop]+"\n");
		myFile.WriteString ("Maximum Crush Distance:	"+m_crhdst[loop]+"\n");
		myFile.WriteString ("AX1:	"+m_ax1[loop]+"\n");
		myFile.WriteString ("AX2:	"+m_ax2[loop]+"\n");
		myFile.WriteString ("AX3:	"+m_ax3[loop]+"\n");
		myFile.WriteString ("AX4:	"+m_ax4[loop]+"\n");
		myFile.WriteString ("AX5:	"+m_ax5[loop]+"\n");
		myFile.WriteString ("AX6:	"+m_ax6[loop]+"\n");
		myFile.WriteString ("AX7:	"+m_ax7[loop]+"\n");
		myFile.WriteString ("AX8:	"+m_ax8[loop]+"\n");
		myFile.WriteString ("AX9:	"+m_ax9[loop]+"\n");
		myFile.WriteString ("AX10:	"+m_ax10[loop]+"\n");
		myFile.WriteString ("AX11:	"+m_ax11[loop]+"\n");
		myFile.WriteString ("AX12:	"+m_ax12[loop]+"\n");
		myFile.WriteString ("AX13:	"+m_ax13[loop]+"\n");
		myFile.WriteString ("AX14:	"+m_ax14[loop]+"\n");
		myFile.WriteString ("AX15:	"+m_ax15[loop]+"\n");
		myFile.WriteString ("AX16:	"+m_ax16[loop]+"\n");
		myFile.WriteString ("AX17:	"+m_ax17[loop]+"\n");
		myFile.WriteString ("AX18:	"+m_ax18[loop]+"\n");
		myFile.WriteString ("AX19:	"+m_ax19[loop]+"\n");
		myFile.WriteString ("AX20:	"+m_ax20[loop]+"\n");
		myFile.WriteString ("AX21:	"+m_ax21[loop]+"\n");		
		myFile.WriteString ("Angle of Moving Test Cart:	"+m_carang[loop]+"\n");
		myFile.WriteString ("Vehicle Orientation on Moving Cart:	"+m_vehor[loop]+"\n");
		myFile.WriteString("Vehicle Comments:	"+m_vehcom[loop] +"\n");
	}
}

/******************************************************************************

	Name:		WriteVehBarReport	

	Action:		Write the VehBar part of a report (.evr)

	Params:		CStdioFile & myFile

	Returns:	void

	Notes:		If m_tstcfn = VTV,ITI,VTI,ITV there should be no BARRIER Info,
				so exit the method.

	Dates:		Modify - Al Wilhelm - 03/06/2000

******************************************************************************/
void CVehData::WriteVehBarReport( CStdioFile & myFile )
{
	if( ValidateEmptyBar() == true )
	{
		return;
	}

	myFile.WriteString ("----- BARRIER -----\n");
	
	// 
	if( (m_tstcfn =="VTV") || (m_tstcfn =="ITI") ||
		(m_tstcfn =="VTI") || (m_tstcfn =="ITV") )
	{
		return;
	}
	
	myFile.WriteString( "Barrier Rigidity:	" + m_cstrbarrig + "\n" );
	myFile.WriteString( "Barrier Shape:	" + m_cstrbarshp + "\n" );
	myFile.WriteString( "Contact Angle:	" + m_cstrbarang + "\n" );
	myFile.WriteString( "Pole Diameter:	" + m_cstrbardia + "\n" );
	myFile.WriteString( "Barrier Comments:	" + m_cstrbarcom + "\n");
}

/******************************************************************************

	Name:		WriteVehOccReport

	Action:		Write the VehOcc part of a report (.evr)

	Params:		CStdioFile & myFile

	Returns:	void

	Notes:	

	Dates:		Modified -- Al Wilhelm - 03/08/2000

******************************************************************************/
void CVehData::WriteVehOccReport( CStdioFile & myFile )
{
	if( m_occsets <= 0 )
	{
		return;
	}

	CString	strTemp("");

	myFile.WriteString( "----- OCCUPANT -----\n" );

	for( int loop = 1; loop <= m_occsets; loop++ )
	{
		strTemp.Format( "%d", loop );
		myFile.WriteString( "----- Occupant Number " + strTemp + " -----\n" );

		strTemp.Format( "%d", m_vehno );
		myFile.WriteString( "Vehicle Number:	" + strTemp + "\n" );
		myFile.WriteString ("Occupant Location:	"+m_occloc[loop]+"\n");
		myFile.WriteString ("Occupant Type:	"+m_occtyp[loop]+"\n");
		myFile.WriteString ("Occupant Age:	"+m_occage[loop]+"\n");
		myFile.WriteString ("Occupant Sex:	"+m_occsex[loop]+"\n");
		myFile.WriteString ("Occupant Height:	"+m_occht[loop]+"\n");
		myFile.WriteString ("Occupant Weight:	"+m_occwt[loop]+"\n");
		myFile.WriteString ("Method of Calibration:	"+m_mthcal[loop]+"\n");
		myFile.WriteString ("Dummy Size Percentile:	"+m_dumsiz[loop]+"\n");
		myFile.WriteString ("Dummy Manufacturer:	"+m_dumman[loop]+"\n");
		myFile.WriteString ("Dummy Modification:	"+m_dummod[loop]+"\n");
		myFile.WriteString ("Dummy Description:	"+m_dumdsc[loop]+"\n");
		myFile.WriteString ("Head to Windshield Header:	"+m_hh[loop]+"\n");
		myFile.WriteString ("Head to Windshield:	"+m_hw[loop]+"\n");
		myFile.WriteString ("Head to Side Header:	"+m_hr[loop]+"\n");
		myFile.WriteString ("Head to Side Window:	"+m_hs[loop]+"\n");
		myFile.WriteString ("Chest to Dash:	"+m_cd[loop]+"\n");
		myFile.WriteString ("Chest to Steering Wheel:	"+m_cs[loop]+"\n");
		myFile.WriteString ("Arm to Door:	"+m_ad[loop]+"\n");
		myFile.WriteString ("Hip to Door:	"+m_hd[loop]+"\n");
		myFile.WriteString ("Knees to Dash:	"+m_kd[loop]+"\n");
		myFile.WriteString ("Head to Seatback:	"+m_hb[loop]+"\n");
		myFile.WriteString ("Neck to Seatback:	"+m_nb[loop]+"\n");
		myFile.WriteString ("Chest to Seatback:	"+m_cb[loop]+"\n");
		myFile.WriteString ("Knee to Seatback:	"+m_kb[loop]+"\n");
		myFile.WriteString ("Seat Position:	"+m_seposn[loop]+"\n");
		myFile.WriteString ("First Contact Region for Head:	"+m_cntrh1[loop]+"\n");
		myFile.WriteString ("Second Contact Region for Head:	"+m_cntrh2[loop]+"\n");
		myFile.WriteString ("First Contact Region for Chest:	"+m_cntrc1[loop]+"\n");
		myFile.WriteString ("Second Contact Region for Chest:	"+m_cntrc2[loop]+"\n");
		myFile.WriteString ("First Contact Region for Legs:	"+m_cntrl1[loop]+"\n");
		myFile.WriteString ("Second Contact Region for Legs:	"+m_cntrl2[loop]+"\n");
		myFile.WriteString ("Head Injury Criterion:	"+m_hic[loop]+"\n");
		myFile.WriteString ("HIC Time Interval (lower boundary):	" + m_t1[loop] + "\n" );
		myFile.WriteString ("HIC Time Interval (upper boundary):	" + m_t2[loop] + "\n" );
		myFile.WriteString( "Peak Acceleration of Thorax Region:	" + m_clip3m[loop] + "\n" );
		myFile.WriteString ("Left Femur Peak Load:	"+m_lfem[loop]+"\n");
		myFile.WriteString ("Right Femur Peak Load:	"+m_rfem[loop]+"\n");
		myFile.WriteString ("Chest Severity Index:	"+m_csi[loop]+"\n");
		myFile.WriteString ("Lap Belt Peak Load:	"+m_lbelt[loop]+"\n");
		myFile.WriteString ("Shoulder Belt Peak Load:	"+m_sbelt[loop]+"\n");
		myFile.WriteString ("Thoracic Trauma Index:	"+ m_tti[loop] +"\n");
		myFile.WriteString ("Pelvic G's:	"+ m_pelvg[loop] +"\n");
		myFile.WriteString ("Occupant Comments:	"+m_occcom[loop] + "\n"); 
	}
}

/******************************************************************************

	Name:		

	Action:		Write the VehRest part of a report (.evr)

	Params:		

	Returns:	

	Notes:

	Dates:

******************************************************************************/
void CVehData::WriteVehRestReport(CStdioFile & myFile)
{
	if( m_restsets <= 0 )
	{
		return;
	}

	for( int loop = 1; loop <= m_restsets; loop++ )  
	{
		myFile.WriteString( "----- RESTRAINT -----\n" );
		myFile.WriteString( "Vehicle Number:	" +m_Rest_vehno[loop] + "\n" );
		myFile.WriteString( "Occupant Location:	" +m_Rest_occloc[loop] + "\n" );
		myFile.WriteString( "Restraint Number:	" +m_rstno[loop] + "\n" );
		myFile.WriteString( "Restraint Type:	" +m_rsttyp[loop] + "\n" );
		myFile.WriteString( "Restraint Mount:	" +m_rstmnt[loop] + "\n" );
		myFile.WriteString( "Inflator/Belt Pretensioner Deployment:	" + m_deploy[loop] + "\n" );
		myFile.WriteString( "Restraint Comments:	" + m_rstcom[loop] +"\n" ); 
	}
}

/******************************************************************************

	Name:		

	Action:		Write the VehInst part of a report (.evr)

	Params:		

	Returns:	

	Notes:		

	Dates:

******************************************************************************/
void CVehData::WriteVehInstReport(CStdioFile & myFile)
{
	if( m_totcrv <= 0 )
	{
		return;
	}

	CString	strTemp("");

	myFile.WriteString ("----- INSTRUMENTATION -----\n");

	for( int loop = 1; loop <= m_totcrv; loop++ )  
	{
		strTemp.Format( "%d", loop );
		myFile.WriteString ("----- CURVE NUMBER "+strTemp+" -----\n");
		myFile.WriteString ("Vehicle Number:	"+m_Inst_vehno[loop]+"\n");
		myFile.WriteString ("Sensor Type:	"+m_sentyp[loop]+"\n");
		myFile.WriteString ("Sensor Location:	"+m_senloc[loop]+"\n");
		myFile.WriteString ("Sensor Attachment:	"+m_senatt[loop]+"\n");
		myFile.WriteString ("Axis Direction of Sensor:	"+m_axis[loop]+"\n");
		myFile.WriteString ("Data Measurement XUnits:	"+m_xunits[loop]+"\n");
		myFile.WriteString ("Data Measurement YUnits:	"+m_yunits[loop]+"\n");
		myFile.WriteString ("Prefilter Frequency:	"+m_prefil[loop]+"\n");
		myFile.WriteString ("Instrument Manufacturer:	"+m_insman[loop]+"\n");
		myFile.WriteString ("Calibration Date:	"+m_caldat[loop]+"\n");
		myFile.WriteString ("Instrument Rating:	"+m_insrat[loop]+"\n");
		myFile.WriteString ("Channel Maximum Rating:	"+m_chlmax[loop]+"\n");
		myFile.WriteString ("Initial Velocity:	"+ m_inivel[loop] +"\n");
		myFile.WriteString ("Number of First Point:	"+m_nfp[loop]+"\n");
		myFile.WriteString ("Number of Last Point:	"+m_nlp[loop]+"\n");
		myFile.WriteString ("Time Increment:	"+m_delt[loop]+"\n");
		myFile.WriteString ("Data Status:	"+m_dastat[loop]+"\n");
		myFile.WriteString ("Channel Status:	"+m_chstat[loop]+"\n");
		myFile.WriteString ("Instrument Comments:	"+m_inscom[loop]+"\n");
	}
}

/******************************************************************************

	Name:		

	Action:		Open an EV5 file to read in the data.

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehData::ImportEV5(CString & strfile_in)
{
	CStdioFile myFile;
	CFileException fileException;

	myFile.Open( strfile_in, CFile::modeRead | CFile::typeText,
		&fileException );
	if (!myFile.m_pStream)  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_in, fileException.m_cause );
		MessageBox(NULL,msg,"Error",MB_OK);
		return FALSE;
	}

	return LoadVehEV5Data(myFile);
}

// Open an EV4 file to read in the data.
/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehData::ImportEV4(CString & strfile_in)
{
	CStdioFile myFile;
	CFileException fileException;

	myFile.Open( strfile_in, CFile::modeRead | CFile::typeText,
		&fileException );
	if (!myFile.m_pStream)  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_in, fileException.m_cause );
		MessageBox(NULL,msg,"Error",MB_OK);
		return FALSE;
	}



	ExtractTestData(myFile, EV4);   // test data section is omnipresent

	ExtractVehData (myFile, EV4); // finds vehicle section intelligently-
							 // same format in ev4 and ev5
	
	ExtractBarData(myFile,EV4);  // finds barrier section intelligently. 
							// same format in ev4 and ev5
	
	ExtractOccData(myFile,EV4);  // finds barrier section intelligently. 
							// same format in ev4 and ev5
	
	ExtractRestData(myFile,EV4);  // finds barrier section intelligently. 
							// same format in ev4 and ev5

	ExtractInstData (myFile, EV4);  // finds inst section intelligently. 
							// same format in ev4 and ev5
	
	return TRUE;
}

// put data from ev5 file in VehData data members
/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehData::LoadVehEV5Data(CStdioFile & myFile)
{
	CString strLine;

	myFile.SeekToBegin ();  // back to beginning
	myFile.ReadString (strLine);
	myFile.ReadString (strLine);
	myFile.ReadString (strLine);  //get to the 3rd line
	
	ExtractTestData(myFile, EV5); // test data section is omnipresent

	ExtractVehData (myFile, EV5); // finds vehicle section intelligently
	
	ExtractBarData(myFile, EV5);  // finds barrier section intelligently. 
	
	ExtractOccData(myFile, EV5);  // finds barrier section intelligently. 
	 
	ExtractRestData(myFile,EV5); // finds barrier section intelligently. 

	ExtractInstData (myFile, EV5); // finds inst section intelligently. 

	return TRUE;

}

/******************************************************************************

	Name:		ExtractTestData

	Action:		Looks for a TEST section in a VEH EV file.  If found, extracts
				the data and puts it into members of CVehData.

	Params:		CStdioFile & myFile, int nVersion

	Returns:	void

	Notes:	

	Dates:

******************************************************************************/
void CVehData::ExtractTestData( CStdioFile & myFile, int nVersion )
{

	CString strLine;
	myFile.SeekToBegin ();  // back to beginning

	// find ----- TEST -----
	int nRes = -1;
	while (myFile.ReadString (strLine))
	{
		nRes = strLine.Find("----- TEST -----");
		if (nRes != -1) break;
	}

	if (nRes == -1) return;  // TEST section not found
    // now read line after ----- TEST -----
	
	myFile.ReadString (strLine);	
	if ((strLine.GetLength ()) <1) return;  // don't process empty string

	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}

	int loc1 = strLine.Find ('|',0);

	if (loc1==-1)  return;  // | not found in line after ----- TEST -----,
					        // must be another section, so return.

	//19 pipes.EV5,  20 EV4 (pipes = fields-1)
	int nPipes = CHighSpeedVideoData::CountPipes(strLine);
	if (nVersion==EV4)
	{
		if (nPipes!=20)
		{
			char buf [10];
			itoa (nPipes,buf,10);
			CString strPipes = buf;
			CString strErr = "This EV4 file has "+strPipes +" | characters in the TEST section, should have 20.";
			MessageBox(NULL, strErr, "Error",MB_OK);
			return;
		}
	}
	else if (nVersion==EV5)
	{
		if (nPipes!=19)
		{
			char buf [10];
			itoa (nPipes,buf,10);
			CString strPipes = buf;
			CString strErr = "This EV5 file has "+strPipes +" | characters in the TEST section, should have 19.";
			MessageBox(NULL, strErr, "Error",MB_OK);
			return;
		}
	}

	if (nVersion==EV4)  //only skip one if EV4.  EV5 has no tstno.
	{
		//m_tstno = atoi(strLine.Mid(0, loc1 - 0)); // dont use tstno
		m_verno		= GetTextBetweenPipes( strLine, 1,2 );
		m_title		= GetTextBetweenPipes( strLine, 2,3 );
		m_tstobj	= GetTextBetweenPipes( strLine, 3,4 );
		m_tstdat	= GetTextBetweenPipes( strLine, 4,5 );
		m_tstprf	= GetTextBetweenPipes( strLine, 5,6 );
		m_conno		= GetTextBetweenPipes( strLine, 6,7 );
		m_tstref	= GetTextBetweenPipes( strLine, 7,8 );
		m_tsttyp	= GetTextBetweenPipes( strLine, 8,9 );
		m_tstcfn	= GetTextBetweenPipes( strLine, 9,10 );
		m_tksurf	= GetTextBetweenPipes( strLine, 10,11 );
		m_tkcond	= GetTextBetweenPipes( strLine, 11,12 );
		m_temp		= GetTextBetweenPipes( strLine, 12,13 );
		m_rectyp	= GetTextBetweenPipes( strLine, 13,14 );
		m_link		= GetTextBetweenPipes( strLine, 14,15 );
		m_clsspd	= GetTextBetweenPipes( strLine, 15,16 );
		m_impang	= GetTextBetweenPipes( strLine, 16,17 );
		m_offset	= GetTextBetweenPipes( strLine, 17,18 );
		m_imppnt	= GetTextBetweenPipes( strLine, 18,19 );
		m_totcrv	= atoi(GetTextBetweenPipes( strLine, 19,20 ));
		m_tstcom	= GetTextBetweenPipes( strLine, 20,21 );
	}
	else //EV5
	{
		m_verno		= GetTextBetweenPipes( strLine, 0,1 );
		m_title		= GetTextBetweenPipes( strLine, 1,2 );
		m_tstobj	= GetTextBetweenPipes( strLine, 2,3 );
		m_tstdat	= GetTextBetweenPipes( strLine, 3,4 );
		m_tstprf	= GetTextBetweenPipes( strLine, 4,5 );
		m_conno		= GetTextBetweenPipes( strLine, 5,6 );
		m_tstref	= GetTextBetweenPipes( strLine, 6,7 );
		m_tsttyp	= GetTextBetweenPipes( strLine, 7,8 );
		m_tstcfn	= GetTextBetweenPipes( strLine, 8,9 );
		m_tksurf	= GetTextBetweenPipes( strLine, 9,10 );
		m_tkcond	= GetTextBetweenPipes( strLine, 10,11 );
		m_temp		= GetTextBetweenPipes( strLine, 11,12 );
		m_rectyp	= GetTextBetweenPipes( strLine, 12,13 );
		m_link		= GetTextBetweenPipes( strLine, 13,14 );
		m_clsspd	= GetTextBetweenPipes( strLine, 14,15 );
		m_impang	= GetTextBetweenPipes( strLine, 15,16 );
		m_offset	= GetTextBetweenPipes( strLine, 16,17 );
		m_imppnt	= GetTextBetweenPipes( strLine, 17,18 );
		m_totcrv	= atoi(GetTextBetweenPipes( strLine, 18,19 ));
		m_tstcom	= GetTextBetweenPipes( strLine, 19,20 );
	}

	return;
}


// ******
// ExtractVehData
// This function finds and separates the Vehicle data in an .ev5 file if any,
// and fills in VehData with that info.
// ******
/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehData::ExtractVehData(CStdioFile & myFile, int nVersion)
{
	CString strLine;
	myFile.SeekToBegin ();  // back to beginning

	// find ----- VEHICLE -----
	int nRes=-1;
	while (myFile.ReadString (strLine))
	{
		nRes = strLine.Find("----- VEHICLE -----");
		if (nRes != -1) break;
	}
	if (nRes==-1) 
	{
		return; // VEHICLE not found.
	}

	// now read line after ----- VEHICLE -----
	myFile.ReadString (strLine);

	if ((strLine.GetLength ()) <1) 
	{
		return;  // don't process empty string
	}

	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}


	int loc1 = strLine.Find ('|',0);
	if (loc1==-1) 
	{
		return;      // | not found in line after ----- VEHICLE -----,
				     // must be another section, so return.
	}

	//79 pipes.EV5 and 80 EV4
	int nPipes = CHighSpeedVideoData::CountPipes(strLine);
	if (nVersion==EV4)
	{
		if (nPipes!= 80)
		{
			char buf [10];
			itoa (nPipes,buf,10);
			CString strPipes = buf;
			CString strErr = "This EV4 file has "+strPipes +" | characters in one line of the VEHICLE section, should have 80.";
			MessageBox(NULL, strErr, "Error",MB_OK);
			return;
		}
	}
	else if (nVersion==EV5)
	{
		if (nPipes!= 79)
		{
			char buf [10];
			itoa (nPipes,buf,10);
			CString strPipes = buf;
			CString strErr = "This EV5 file has "+strPipes +" | characters in one line of the VEHICLE section, should have 79.";
			MessageBox(NULL, strErr, "Error",MB_OK);
			return;
		}
	}
//	m_tstno = atoi(strLine.Mid(0, loc1 - 0)); // skip this one.

	if (nVersion == EV4) //skip tstno if ev4
	{
		m_vehno			= atoi(GetTextBetweenPipes(strLine, 1,2));
		m_make[1]		= GetTextBetweenPipes(strLine, 2,3);
		m_model[1]		= GetTextBetweenPipes(strLine, 3,4);
		m_year[1]		= GetTextBetweenPipes(strLine, 4,5);
		m_nhtsano[1]	= GetTextBetweenPipes(strLine, 5,6);
		m_body[1]		= GetTextBetweenPipes(strLine, 6,7);
		m_vin[1]		= GetTextBetweenPipes(strLine, 7,8);
		m_engine[1]		= GetTextBetweenPipes(strLine, 8,9);
		m_engdsp[1]		= GetTextBetweenPipes(strLine, 9,10);
		m_transm[1]		= GetTextBetweenPipes(strLine, 10,11);
		m_vehtwt[1]		= GetTextBetweenPipes(strLine, 11,12);
		m_whlbas[1]		= GetTextBetweenPipes(strLine, 12,13);
		m_vehlen[1]		= GetTextBetweenPipes(strLine, 13,14);
		m_vehwid[1]		= GetTextBetweenPipes(strLine, 14,15);
		m_vehcg[1]		= GetTextBetweenPipes(strLine, 15,16);
		m_strsep[1]		= GetTextBetweenPipes(strLine, 16,17);
		m_colmec[1]		= GetTextBetweenPipes(strLine, 17,18);
		m_modind[1]		= GetTextBetweenPipes(strLine, 18,19);
		m_moddsc[1]		= GetTextBetweenPipes(strLine, 19,20);
		m_bx1[1]		= GetTextBetweenPipes(strLine, 20,21);
		m_bx2[1]		= GetTextBetweenPipes(strLine, 21,22);
		m_bx3[1]		= GetTextBetweenPipes(strLine, 22,23);
		m_bx4[1]		= GetTextBetweenPipes(strLine, 23,24);
		m_bx5[1]		= GetTextBetweenPipes(strLine, 24,25);
		m_bx6[1]		= GetTextBetweenPipes(strLine, 25,26);
		m_bx7[1]		= GetTextBetweenPipes(strLine, 26,27);
		m_bx8[1]		= GetTextBetweenPipes(strLine, 27,28);
		m_bx9[1]		= GetTextBetweenPipes(strLine, 28,29);
		m_bx10[1]		= GetTextBetweenPipes(strLine, 29,30);
		m_bx11[1]		= GetTextBetweenPipes(strLine, 30,31);
		m_bx12[1]		= GetTextBetweenPipes(strLine, 31,32);
		m_bx13[1]		= GetTextBetweenPipes(strLine, 32,33);
		m_bx14[1]		= GetTextBetweenPipes(strLine, 33,34);
		m_bx15[1]		= GetTextBetweenPipes(strLine, 34,35);
		m_bx16[1]		= GetTextBetweenPipes(strLine, 35,36);
		m_bx17[1]		= GetTextBetweenPipes(strLine, 36,37);
		m_bx18[1]		= GetTextBetweenPipes(strLine, 37,38);
		m_bx19[1]		= GetTextBetweenPipes(strLine, 38,39);
		m_bx20[1]		= GetTextBetweenPipes(strLine, 39,40);
		m_bx21[1]		= GetTextBetweenPipes(strLine, 40,41);
		m_vehspd[1]		= GetTextBetweenPipes(strLine, 41,42);
		m_crbang[1]		= GetTextBetweenPipes(strLine, 42,43);
		m_pdof[1]		= GetTextBetweenPipes(strLine, 43,44);
		m_bmpeng[1]		= GetTextBetweenPipes(strLine, 44,45);
		m_sileng[1]		= GetTextBetweenPipes(strLine, 45,46);
		m_apleng[1]		= GetTextBetweenPipes(strLine, 46,47);
		m_dpd1[1]		= GetTextBetweenPipes(strLine, 47,48);
		m_dpd2[1]		= GetTextBetweenPipes(strLine, 48,49);
		m_dpd3[1]		= GetTextBetweenPipes(strLine, 49,50);
		m_dpd4[1]		= GetTextBetweenPipes(strLine, 50,51);
		m_dpd5[1]		= GetTextBetweenPipes(strLine, 51,52);
		m_dpd6[1]		= GetTextBetweenPipes(strLine, 52,53);
		m_vdi[1]		= GetTextBetweenPipes(strLine, 53,54);
		m_lencnt[1]		= GetTextBetweenPipes(strLine, 54,55);
		m_damdst[1]		= GetTextBetweenPipes(strLine, 55,56);
		m_crhdst[1]		= GetTextBetweenPipes(strLine, 56,57);
		m_ax1[1]		= GetTextBetweenPipes(strLine, 57,58);
		m_ax2[1]		= GetTextBetweenPipes(strLine, 58,59);
		m_ax3[1]		= GetTextBetweenPipes(strLine, 59,60);
		m_ax4[1]		= GetTextBetweenPipes(strLine, 60,61);
		m_ax5[1]		= GetTextBetweenPipes(strLine, 61,62);
		m_ax6[1]		= GetTextBetweenPipes(strLine, 62,63);
		m_ax7[1]		= GetTextBetweenPipes(strLine, 63,64);
		m_ax8[1]		= GetTextBetweenPipes(strLine, 64,65);
		m_ax9[1]		= GetTextBetweenPipes(strLine, 65,66);
		m_ax10[1]		= GetTextBetweenPipes(strLine, 66,67);
		m_ax11[1]		= GetTextBetweenPipes(strLine, 67,68);
		m_ax12[1]		= GetTextBetweenPipes(strLine, 68,69);
		m_ax13[1]		= GetTextBetweenPipes(strLine, 69,70);
		m_ax14[1]		= GetTextBetweenPipes(strLine, 70,71);
		m_ax15[1]		= GetTextBetweenPipes(strLine, 71,72);
		m_ax16[1]		= GetTextBetweenPipes(strLine, 72,73);
		m_ax17[1]		= GetTextBetweenPipes(strLine, 73,74);
		m_ax18[1]		= GetTextBetweenPipes(strLine, 74,75);
		m_ax19[1]		= GetTextBetweenPipes(strLine, 75,76);
		m_ax20[1]		= GetTextBetweenPipes(strLine, 76,77);
		m_ax21[1]		= GetTextBetweenPipes(strLine, 77,78);
		m_carang[1]		= GetTextBetweenPipes(strLine, 78,79);
		m_vehor[1]		= GetTextBetweenPipes(strLine, 79,80);
		m_vehcom[1]		= GetTextBetweenPipes(strLine, 80,81);
	}
	else  // no tstno to skip in ev5.
	{
		m_vehno			= atoi(GetTextBetweenPipes(strLine, 0,1));
		m_make[1]		= GetTextBetweenPipes(strLine, 1,2);
		m_model[1]		= GetTextBetweenPipes(strLine, 2,3);
		m_year[1]		= GetTextBetweenPipes(strLine, 3,4);
		m_nhtsano[1]	= GetTextBetweenPipes(strLine, 4,5);
		m_body[1]		= GetTextBetweenPipes(strLine, 5,6);
		m_vin[1]		= GetTextBetweenPipes(strLine, 6,7);
		m_engine[1]		= GetTextBetweenPipes(strLine, 7,8);
		m_engdsp[1]		= GetTextBetweenPipes(strLine, 8,9);
		m_transm[1]		= GetTextBetweenPipes(strLine, 9,10);
		m_vehtwt[1]		= GetTextBetweenPipes(strLine, 10,11);
		m_whlbas[1]		= GetTextBetweenPipes(strLine, 11,12);
		m_vehlen[1]		= GetTextBetweenPipes(strLine, 12,13);
		m_vehwid[1]		= GetTextBetweenPipes(strLine, 13,14);
		m_vehcg[1]		= GetTextBetweenPipes(strLine, 14,15);
		m_strsep[1]		= GetTextBetweenPipes(strLine, 15,16);
		m_colmec[1]		= GetTextBetweenPipes(strLine, 16,17);
		m_modind[1]		= GetTextBetweenPipes(strLine, 17,18);
		m_moddsc[1]		= GetTextBetweenPipes(strLine, 18,19);
		m_bx1[1]		= GetTextBetweenPipes(strLine, 19,20);
		m_bx2[1]		= GetTextBetweenPipes(strLine, 20,21);
		m_bx3[1]		= GetTextBetweenPipes(strLine, 21,22);
		m_bx4[1]		= GetTextBetweenPipes(strLine, 22,23);
		m_bx5[1]		= GetTextBetweenPipes(strLine, 23,24);
		m_bx6[1]		= GetTextBetweenPipes(strLine, 24,25);
		m_bx7[1]		= GetTextBetweenPipes(strLine, 25,26);
		m_bx8[1]		= GetTextBetweenPipes(strLine, 26,27);
		m_bx9[1]		= GetTextBetweenPipes(strLine, 27,28);
		m_bx10[1]		= GetTextBetweenPipes(strLine, 28,29);
		m_bx11[1]		= GetTextBetweenPipes(strLine, 29,30);
		m_bx12[1]		= GetTextBetweenPipes(strLine, 30,31);
		m_bx13[1]		= GetTextBetweenPipes(strLine, 31,32);
		m_bx14[1]		= GetTextBetweenPipes(strLine, 32,33);
		m_bx15[1]		= GetTextBetweenPipes(strLine, 33,34);
		m_bx16[1]		= GetTextBetweenPipes(strLine, 34,35);
		m_bx17[1]		= GetTextBetweenPipes(strLine, 35,36);
		m_bx18[1]		= GetTextBetweenPipes(strLine, 36,37);
		m_bx19[1]		= GetTextBetweenPipes(strLine, 37,38);
		m_bx20[1]		= GetTextBetweenPipes(strLine, 38,39);
		m_bx21[1]		= GetTextBetweenPipes(strLine, 39,40);
		m_vehspd[1]		= GetTextBetweenPipes(strLine, 40,41);
		m_crbang[1]		= GetTextBetweenPipes(strLine, 41,42);
		m_pdof[1]		= GetTextBetweenPipes(strLine, 42,43);
		m_bmpeng[1]		= GetTextBetweenPipes(strLine, 43,44);
		m_sileng[1]		= GetTextBetweenPipes(strLine, 44,45);
		m_apleng[1]		= GetTextBetweenPipes(strLine, 45,46);
		m_dpd1[1]		= GetTextBetweenPipes(strLine, 46,47);
		m_dpd2[1]		= GetTextBetweenPipes(strLine, 47,48);
		m_dpd3[1]		= GetTextBetweenPipes(strLine, 48,49);
		m_dpd4[1]		= GetTextBetweenPipes(strLine, 49,50);
		m_dpd5[1]		= GetTextBetweenPipes(strLine, 50,51);
		m_dpd6[1]		= GetTextBetweenPipes(strLine, 51,52);
		m_vdi[1]		= GetTextBetweenPipes(strLine, 52,53);
		m_lencnt[1]		= GetTextBetweenPipes(strLine, 53,54);
		m_damdst[1]		= GetTextBetweenPipes(strLine, 54,55);
		m_crhdst[1]		= GetTextBetweenPipes(strLine, 55,56);
		m_ax1[1]		= GetTextBetweenPipes(strLine, 56,57);
		m_ax2[1]		= GetTextBetweenPipes(strLine, 57,58);
		m_ax3[1]		= GetTextBetweenPipes(strLine, 58,59);
		m_ax4[1]		= GetTextBetweenPipes(strLine, 59,60);
		m_ax5[1]		= GetTextBetweenPipes(strLine, 60,61);
		m_ax6[1]		= GetTextBetweenPipes(strLine, 61,62);
		m_ax7[1]		= GetTextBetweenPipes(strLine, 62,63);
		m_ax8[1]		= GetTextBetweenPipes(strLine, 63,64);
		m_ax9[1]		= GetTextBetweenPipes(strLine, 64,65);
		m_ax10[1]		= GetTextBetweenPipes(strLine, 65,66);
		m_ax11[1]		= GetTextBetweenPipes(strLine, 66,67);
		m_ax12[1]		= GetTextBetweenPipes(strLine, 67,68);
		m_ax13[1]		= GetTextBetweenPipes(strLine, 68,69);
		m_ax14[1]		= GetTextBetweenPipes(strLine, 69,70);
		m_ax15[1]		= GetTextBetweenPipes(strLine, 70,71);
		m_ax16[1]		= GetTextBetweenPipes(strLine, 71,72);
		m_ax17[1]		= GetTextBetweenPipes(strLine, 72,73);
		m_ax18[1]		= GetTextBetweenPipes(strLine, 73,74);
		m_ax19[1]		= GetTextBetweenPipes(strLine, 74,75);
		m_ax20[1]		= GetTextBetweenPipes(strLine, 75,76);
		m_ax21[1]		= GetTextBetweenPipes(strLine, 76,77);
		m_carang[1]		= GetTextBetweenPipes(strLine, 77,78);
		m_vehor[1]		= GetTextBetweenPipes(strLine, 78,79);
		m_vehcom[1]		= GetTextBetweenPipes(strLine, 79,80);
	}
	
	// read second vehicle (if present)
	myFile.ReadString (strLine);  // next vehicle should be next line
	if ((strLine.GetLength ()) <1) 
	{
		return;  // don't process empty string
	}

	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}

	loc1 = strLine.Find ('|',0);
	if (loc1==-1) 
	{
		return;      // | not found in line after ----- VEHICLE -----,
				     // must be another section, so return.
	}

	//79 pipes.EV5 and 80 EV4
	nPipes = CountPipes(strLine);
	if (nVersion==EV4)
	{
		if (nPipes!= 80)
		{
			char buf [10];
			itoa (nPipes,buf,10);
			CString strPipes = buf;
			CString strErr = "This EV4 file has "+strPipes +" | characters in one line of the VEHICLE section, should have 80.";
			MessageBox(NULL, strErr, "Error",MB_OK);
			return;
		}
	}
	else if (nVersion==EV5)
	{
		if (nPipes!= 79)
		{
			char buf [10];
			itoa (nPipes,buf,10);
			CString strPipes = buf;
			CString strErr = "This EV5 file has "+strPipes +" | characters in one line of the VEHICLE section, should have 79.";
			MessageBox(NULL, strErr, "Error",MB_OK);
			return;
		}
	}

	if (nVersion == EV4) //skip tstno if ev4
	{
		m_vehno			= atoi(GetTextBetweenPipes(strLine, 1,2));
		m_make[2]		= GetTextBetweenPipes(strLine, 2,3);
		m_model[2]		= GetTextBetweenPipes(strLine, 3,4);
		m_year[2]		= GetTextBetweenPipes(strLine, 4,5);
		m_nhtsano[2]	= GetTextBetweenPipes(strLine, 5,6);
		m_body[2]		= GetTextBetweenPipes(strLine, 6,7);
		m_vin[2]		= GetTextBetweenPipes(strLine, 7,8);
		m_engine[2]		= GetTextBetweenPipes(strLine, 8,9);
		m_engdsp[2]		= GetTextBetweenPipes(strLine, 9,10);
		m_transm[2]		= GetTextBetweenPipes(strLine, 10,11);
		m_vehtwt[2]		= GetTextBetweenPipes(strLine, 11,12);
		m_whlbas[2]		= GetTextBetweenPipes(strLine, 12,13);
		m_vehlen[2]		= GetTextBetweenPipes(strLine, 13,14);
		m_vehwid[2]		= GetTextBetweenPipes(strLine, 14,15);
		m_vehcg[2]		= GetTextBetweenPipes(strLine, 15,16);
		m_strsep[2]		= GetTextBetweenPipes(strLine, 16,17);
		m_colmec[2]		= GetTextBetweenPipes(strLine, 17,18);
		m_modind[2]		= GetTextBetweenPipes(strLine, 18,19);
		m_moddsc[2]		= GetTextBetweenPipes(strLine, 19,20);
		m_bx1[2]		= GetTextBetweenPipes(strLine, 20,21);
		m_bx2[2]		= GetTextBetweenPipes(strLine, 21,22);
		m_bx3[2]		= GetTextBetweenPipes(strLine, 22,23);
		m_bx4[2]		= GetTextBetweenPipes(strLine, 23,24);
		m_bx5[2]		= GetTextBetweenPipes(strLine, 24,25);
		m_bx6[2]		= GetTextBetweenPipes(strLine, 25,26);
		m_bx7[2]		= GetTextBetweenPipes(strLine, 26,27);
		m_bx8[2]		= GetTextBetweenPipes(strLine, 27,28);
		m_bx9[2]		= GetTextBetweenPipes(strLine, 28,29);
		m_bx10[2]		= GetTextBetweenPipes(strLine, 29,30);
		m_bx11[2]		= GetTextBetweenPipes(strLine, 30,31);
		m_bx12[2]		= GetTextBetweenPipes(strLine, 31,32);
		m_bx13[2]		= GetTextBetweenPipes(strLine, 32,33);
		m_bx14[2]		= GetTextBetweenPipes(strLine, 33,34);
		m_bx15[2]		= GetTextBetweenPipes(strLine, 34,35);
		m_bx16[2]		= GetTextBetweenPipes(strLine, 35,36);
		m_bx17[2]		= GetTextBetweenPipes(strLine, 36,37);
		m_bx18[2]		= GetTextBetweenPipes(strLine, 37,38);
		m_bx19[2]		= GetTextBetweenPipes(strLine, 38,39);
		m_bx20[2]		= GetTextBetweenPipes(strLine, 39,40);
		m_bx21[2]		= GetTextBetweenPipes(strLine, 40,41);
		m_vehspd[2]		= GetTextBetweenPipes(strLine, 41,42);
		m_crbang[2]		= GetTextBetweenPipes(strLine, 42,43);
		m_pdof[2]		= GetTextBetweenPipes(strLine, 43,44);
		m_bmpeng[2]		= GetTextBetweenPipes(strLine, 44,45);
		m_sileng[2]		= GetTextBetweenPipes(strLine, 45,46);
		m_apleng[2]		= GetTextBetweenPipes(strLine, 46,47);
		m_dpd1[2]		= GetTextBetweenPipes(strLine, 47,48);
		m_dpd2[2]		= GetTextBetweenPipes(strLine, 48,49);
		m_dpd3[2]		= GetTextBetweenPipes(strLine, 49,50);
		m_dpd4[2]		= GetTextBetweenPipes(strLine, 50,51);
		m_dpd5[2]		= GetTextBetweenPipes(strLine, 51,52);
		m_dpd6[2]		= GetTextBetweenPipes(strLine, 52,53);
		m_vdi[2]		= GetTextBetweenPipes(strLine, 53,54);
		m_lencnt[2]		= GetTextBetweenPipes(strLine, 54,55);
		m_damdst[2]		= GetTextBetweenPipes(strLine, 55,56);
		m_crhdst[2]		= GetTextBetweenPipes(strLine, 56,57);
		m_ax1[2]		= GetTextBetweenPipes(strLine, 57,58);
		m_ax2[2]		= GetTextBetweenPipes(strLine, 58,59);
		m_ax3[2]		= GetTextBetweenPipes(strLine, 59,60);
		m_ax4[2]		= GetTextBetweenPipes(strLine, 60,61);
		m_ax5[2]		= GetTextBetweenPipes(strLine, 61,62);
		m_ax6[2]		= GetTextBetweenPipes(strLine, 62,63);
		m_ax7[2]		= GetTextBetweenPipes(strLine, 63,64);
		m_ax8[2]		= GetTextBetweenPipes(strLine, 64,65);
		m_ax9[2]		= GetTextBetweenPipes(strLine, 65,66);
		m_ax10[2]		= GetTextBetweenPipes(strLine, 66,67);
		m_ax11[2]		= GetTextBetweenPipes(strLine, 67,68);
		m_ax12[2]		= GetTextBetweenPipes(strLine, 68,69);
		m_ax13[2]		= GetTextBetweenPipes(strLine, 69,70);
		m_ax14[2]		= GetTextBetweenPipes(strLine, 70,71);
		m_ax15[2]		= GetTextBetweenPipes(strLine, 71,72);
		m_ax16[2]		= GetTextBetweenPipes(strLine, 72,73);
		m_ax17[2]		= GetTextBetweenPipes(strLine, 73,74);
		m_ax18[2]		= GetTextBetweenPipes(strLine, 74,75);
		m_ax19[2]		= GetTextBetweenPipes(strLine, 75,76);
		m_ax20[2]		= GetTextBetweenPipes(strLine, 76,77);
		m_ax21[2]		= GetTextBetweenPipes(strLine, 77,78);
		m_carang[2]		= GetTextBetweenPipes(strLine, 78,79);
		m_vehor[2]		= GetTextBetweenPipes(strLine, 79,80);
		m_vehcom[2]		= GetTextBetweenPipes(strLine, 80,81);
	}
	else  // no tstno to skip in ev5.
	{
		m_vehno			= atoi(GetTextBetweenPipes(strLine, 0,1));
		m_make[2]		= GetTextBetweenPipes(strLine, 1,2);
		m_model[2]		= GetTextBetweenPipes(strLine, 2,3);
		m_year[2]		= GetTextBetweenPipes(strLine, 3,4);
		m_nhtsano[2]	= GetTextBetweenPipes(strLine, 4,5);
		m_body[2]		= GetTextBetweenPipes(strLine, 5,6);
		m_vin[2]		= GetTextBetweenPipes(strLine, 6,7);
		m_engine[2]		= GetTextBetweenPipes(strLine, 7,8);
		m_engdsp[2]		= GetTextBetweenPipes(strLine, 8,9);
		m_transm[2]		= GetTextBetweenPipes(strLine, 9,10);
		m_vehtwt[2]		= GetTextBetweenPipes(strLine, 10,11);
		m_whlbas[2]		= GetTextBetweenPipes(strLine, 11,12);
		m_vehlen[2]		= GetTextBetweenPipes(strLine, 12,13);
		m_vehwid[2]		= GetTextBetweenPipes(strLine, 13,14);
		m_vehcg[2]		= GetTextBetweenPipes(strLine, 14,15);
		m_strsep[2]		= GetTextBetweenPipes(strLine, 15,16);
		m_colmec[2]		= GetTextBetweenPipes(strLine, 16,17);
		m_modind[2]		= GetTextBetweenPipes(strLine, 17,18);
		m_moddsc[2]		= GetTextBetweenPipes(strLine, 18,19);
		m_bx1[2]		= GetTextBetweenPipes(strLine, 19,20);
		m_bx2[2]		= GetTextBetweenPipes(strLine, 20,21);
		m_bx3[2]		= GetTextBetweenPipes(strLine, 21,22);
		m_bx4[2]		= GetTextBetweenPipes(strLine, 22,23);
		m_bx5[2]		= GetTextBetweenPipes(strLine, 23,24);
		m_bx6[2]		= GetTextBetweenPipes(strLine, 24,25);
		m_bx7[2]		= GetTextBetweenPipes(strLine, 25,26);
		m_bx8[2]		= GetTextBetweenPipes(strLine, 26,27);
		m_bx9[2]		= GetTextBetweenPipes(strLine, 27,28);
		m_bx10[2]		= GetTextBetweenPipes(strLine, 28,29);
		m_bx11[2]		= GetTextBetweenPipes(strLine, 29,30);
		m_bx12[2]		= GetTextBetweenPipes(strLine, 30,31);
		m_bx13[2]		= GetTextBetweenPipes(strLine, 31,32);
		m_bx14[2]		= GetTextBetweenPipes(strLine, 32,33);
		m_bx15[2]		= GetTextBetweenPipes(strLine, 33,34);
		m_bx16[2]		= GetTextBetweenPipes(strLine, 34,35);
		m_bx17[2]		= GetTextBetweenPipes(strLine, 35,36);
		m_bx18[2]		= GetTextBetweenPipes(strLine, 36,37);
		m_bx19[2]		= GetTextBetweenPipes(strLine, 37,38);
		m_bx20[2]		= GetTextBetweenPipes(strLine, 38,39);
		m_bx21[2]		= GetTextBetweenPipes(strLine, 39,40);
		m_vehspd[2]		= GetTextBetweenPipes(strLine, 40,41);
		m_crbang[2]		= GetTextBetweenPipes(strLine, 41,42);
		m_pdof[2]		= GetTextBetweenPipes(strLine, 42,43);
		m_bmpeng[2]		= GetTextBetweenPipes(strLine, 43,44);
		m_sileng[2]		= GetTextBetweenPipes(strLine, 44,45);
		m_apleng[2]		= GetTextBetweenPipes(strLine, 45,46);
		m_dpd1[2]		= GetTextBetweenPipes(strLine, 46,47);
		m_dpd2[2]		= GetTextBetweenPipes(strLine, 47,48);
		m_dpd3[2]		= GetTextBetweenPipes(strLine, 48,49);
		m_dpd4[2]		= GetTextBetweenPipes(strLine, 49,50);
		m_dpd5[2]		= GetTextBetweenPipes(strLine, 50,51);
		m_dpd6[2]		= GetTextBetweenPipes(strLine, 51,52);
		m_vdi[2]		= GetTextBetweenPipes(strLine, 52,53);
		m_lencnt[2]		= GetTextBetweenPipes(strLine, 53,54);
		m_damdst[2]		= GetTextBetweenPipes(strLine, 54,55);
		m_crhdst[2]		= GetTextBetweenPipes(strLine, 55,56);
		m_ax1[2]		= GetTextBetweenPipes(strLine, 56,57);
		m_ax2[2]		= GetTextBetweenPipes(strLine, 57,58);
		m_ax3[2]		= GetTextBetweenPipes(strLine, 58,59);
		m_ax4[2]		= GetTextBetweenPipes(strLine, 59,60);
		m_ax5[2]		= GetTextBetweenPipes(strLine, 60,61);
		m_ax6[2]		= GetTextBetweenPipes(strLine, 61,62);
		m_ax7[2]		= GetTextBetweenPipes(strLine, 62,63);
		m_ax8[2]		= GetTextBetweenPipes(strLine, 63,64);
		m_ax9[2]		= GetTextBetweenPipes(strLine, 64,65);
		m_ax10[2]		= GetTextBetweenPipes(strLine, 65,66);
		m_ax11[2]		= GetTextBetweenPipes(strLine, 66,67);
		m_ax12[2]		= GetTextBetweenPipes(strLine, 67,68);
		m_ax13[2]		= GetTextBetweenPipes(strLine, 68,69);
		m_ax14[2]		= GetTextBetweenPipes(strLine, 69,70);
		m_ax15[2]		= GetTextBetweenPipes(strLine, 70,71);
		m_ax16[2]		= GetTextBetweenPipes(strLine, 71,72);
		m_ax17[2]		= GetTextBetweenPipes(strLine, 72,73);
		m_ax18[2]		= GetTextBetweenPipes(strLine, 73,74);
		m_ax19[2]		= GetTextBetweenPipes(strLine, 74,75);
		m_ax20[2]		= GetTextBetweenPipes(strLine, 75,76);
		m_ax21[2]		= GetTextBetweenPipes(strLine, 76,77);
		m_carang[2]		= GetTextBetweenPipes(strLine, 77,78);
		m_vehor[2]		= GetTextBetweenPipes(strLine, 78,79);
		m_vehcom[2]		= GetTextBetweenPipes(strLine, 79,80);
	}

	return;
}

// ******
// ExtractBarData
// This function finds and separates the Barrier data in an .ev5 file if any,
// and fills in VehData with that info.
// ******
/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehData::ExtractBarData(CStdioFile & myFile, int nVersion)
{
	CString strLine;
	myFile.SeekToBegin ();  // back to beginning

	// find ----- BARRIER -----
	int nRes =-1;
	while (myFile.ReadString (strLine))
	{
		nRes = strLine.Find("----- BARRIER -----");
		if (nRes != -1) break;
	}

	if (nRes==-1) 
	{
		return; // BARRIER not found.
	}

	// now read line after ----- BARRIER -----
	myFile.ReadString (strLine);

	if ((strLine.GetLength ()) <1) 
	{
		return;  // don't process empty string
	}

	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}

	int loc1 = strLine.Find ('|',0);
	if (loc1==-1) 
	{
		return;      // | not found in line after ----- BARRIER -----,
				     // must be another section, so return.
	}

	//4 pipes.EV5 and 5 EV4
	int nPipes = CountPipes(strLine);
	if (nVersion==EV4)
	{
		if (nPipes!= 5)
		{
			char buf [10];
			itoa (nPipes,buf,10);
			CString strPipes = buf;
			CString strErr = "This EV4 file has "+strPipes +" | characters in the BARRIER section, should have 5.";
			MessageBox(NULL, strErr, "Error",MB_OK);
			return;
		}
	}
	else if (nVersion==EV5)
	{
		if (nPipes!= 4)
		{
			char buf [10];
			itoa (nPipes,buf,10);
			CString strPipes = buf;
			CString strErr = "This EV5 file has "+strPipes +" | characters in the BARRIER section, should have 4.";
			MessageBox(NULL, strErr, "Error",MB_OK);
			return;
		}
	}

//	m_tstno = atoi(strLine.Mid(0, loc1 - 0)); // skip this one.

	int loc2 = strLine.Find ('|',loc1+1);

	if (nVersion == EV4) //skip tstno if EV4
	{
		m_cstrbarrig = GetTextBetweenPipes(strLine, 1,2);
		m_cstrbarshp = GetTextBetweenPipes(strLine, 2,3);
		m_cstrbarang = GetTextBetweenPipes(strLine, 3,4);
		m_cstrbardia = GetTextBetweenPipes(strLine, 4,5);
		m_cstrbarcom = GetTextBetweenPipes(strLine, 5,6);

	}
	else  //no tstno to skip if EV5
	{
		m_cstrbarrig = GetTextBetweenPipes(strLine, 0,1);
		m_cstrbarshp = GetTextBetweenPipes(strLine, 1,2);
		m_cstrbarang = GetTextBetweenPipes(strLine, 2,3);
		m_cstrbardia = GetTextBetweenPipes(strLine, 3,4);
		m_cstrbarcom = GetTextBetweenPipes(strLine, 4,5);
	}
}

// ******
// ExtractOccData
// This function finds and separates the Occupant data in an .ev5 file if any,
// and fills in VehData with that info.
// ******
/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehData::ExtractOccData(CStdioFile & myFile, int nVersion)
{
	CString strLine;
	myFile.SeekToBegin ();  // back to beginning

	// find ----- OCCUPANT -----
	int nRes=-1;
	while (myFile.ReadString (strLine))
	{
		nRes = strLine.Find("----- OCCUPANT -----");
		if (nRes != -1) break;
	}

	if (nRes==-1) 
	{
		m_occsets=0;
		return; // OCCUPANT not found.
	}

    // now read line after ----- OCCUPANT -----
	myFile.ReadString (strLine);	

	if ((strLine.GetLength ()) <1) 
	{
		m_occsets=0;
		return;  // don't process empty string
	}

	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}

	int loc1 = strLine.Find ('|',0);
	if (loc1==-1) 
	{
		m_occsets=0;
		return;      // | not found in line after ----- OCCUPANT -----,
				     // must be another section, so return.
	}

	int loop =1;
	while ((strLine.Find("----- "))== -1)  // not at restraint line.
	{
		//43 pipes.EV5 and 44 EV4
		int nPipes = CountPipes(strLine);
		if (nVersion==EV4)
		{
			if (nPipes!= 44)
			{
				char buf [10];
				itoa (nPipes,buf,10);
				CString strPipes = buf;
				CString strErr = "This EV4 file has "+strPipes +" | characters in one line of the OCCUPANT section, should have 44.";
				MessageBox(NULL, strErr, "Error",MB_OK);
				m_occsets=0;
				return;  // makes sure all entries are correct.
			}
		}
		else if (nVersion==EV5)
		{
			if (nPipes!= 43)
			{
				char buf [10];
				itoa (nPipes,buf,10);
				CString strPipes = buf;
				CString strErr = "This EV5 file has "+strPipes +" | characters in one line of the OCCUPANT section, should have 43.";
				MessageBox(NULL, strErr, "Error",MB_OK);
				m_occsets=0;
				return;  // makes sure all entries are correct.
			}
		}

		if (nVersion==EV4) //skip tstno if ev4
		{
			m_Occ_vehno.SetAtGrow( loop, GetTextBetweenPipes( strLine, 1, 2 ) );
			m_occloc.SetAtGrow( loop, GetTextBetweenPipes( strLine, 2, 3 ) );
			m_occtyp.SetAtGrow( loop, GetTextBetweenPipes( strLine, 3, 4 ) );
			m_occage.SetAtGrow( loop, GetTextBetweenPipes( strLine, 4, 5 ) );
			m_occsex.SetAtGrow(loop, GetTextBetweenPipes( strLine, 5,6 ) );
			m_occht.SetAtGrow( loop, GetTextBetweenPipes( strLine, 6,7 ) );
			m_occwt.SetAtGrow( loop, GetTextBetweenPipes( strLine, 7, 8 ) );
			m_mthcal.SetAtGrow(loop, GetTextBetweenPipes(strLine, 8,9));
			m_dumsiz.SetAtGrow(loop, GetTextBetweenPipes(strLine, 9,10));
			m_dumman.SetAtGrow(loop, GetTextBetweenPipes(strLine, 10,11));
			m_dummod.SetAtGrow(loop, GetTextBetweenPipes(strLine, 11,12));
			m_dumdsc.SetAtGrow(loop, GetTextBetweenPipes(strLine, 12,13));
			m_hh.SetAtGrow( loop, GetTextBetweenPipes( strLine, 13,14));
			m_hw.SetAtGrow( loop, GetTextBetweenPipes( strLine, 14,15));
			m_hr.SetAtGrow( loop, GetTextBetweenPipes( strLine, 15,16));
			m_hs.SetAtGrow( loop, GetTextBetweenPipes( strLine, 16,17));
			m_cd.SetAtGrow( loop, GetTextBetweenPipes( strLine, 17,18));
			m_cs.SetAtGrow( loop, GetTextBetweenPipes( strLine, 18,19));
			m_ad.SetAtGrow( loop, GetTextBetweenPipes( strLine, 19,20));
			m_hd.SetAtGrow( loop, GetTextBetweenPipes( strLine, 20,21));
			m_kd.SetAtGrow( loop, GetTextBetweenPipes( strLine, 21,22));
			m_hb.SetAtGrow( loop, GetTextBetweenPipes( strLine, 22,23));
			m_nb.SetAtGrow( loop, GetTextBetweenPipes( strLine, 23,24));
			m_cb.SetAtGrow( loop, GetTextBetweenPipes( strLine, 24,25));
			m_kb.SetAtGrow( loop, GetTextBetweenPipes( strLine, 25,26));
			m_seposn.SetAtGrow(loop,GetTextBetweenPipes(strLine, 26,27));
			m_cntrh1.SetAtGrow(loop,GetTextBetweenPipes(strLine, 27,28));
			m_cntrh2.SetAtGrow(loop,GetTextBetweenPipes(strLine, 28,29));
			m_cntrc1.SetAtGrow(loop,GetTextBetweenPipes(strLine, 29,30));
			m_cntrc2.SetAtGrow(loop,GetTextBetweenPipes(strLine, 30,31));
			m_cntrl1.SetAtGrow(loop,GetTextBetweenPipes(strLine, 31,32));
			m_cntrl2.SetAtGrow(loop,GetTextBetweenPipes(strLine, 32,33));
			m_hic.SetAtGrow( loop, GetTextBetweenPipes( strLine, 33, 34 ) );
			m_t1.SetAtGrow( loop, GetTextBetweenPipes( strLine, 34, 35 ) );
			m_t2.SetAtGrow( loop, GetTextBetweenPipes( strLine, 35, 36 ) );
			m_clip3m.SetAtGrow( loop, GetTextBetweenPipes( strLine, 36, 37 ) );
			m_lfem.SetAtGrow( loop, GetTextBetweenPipes( strLine, 37, 38 ) );
			m_rfem.SetAtGrow( loop, GetTextBetweenPipes( strLine, 38, 39 ) );
			m_csi.SetAtGrow( loop, GetTextBetweenPipes( strLine, 39, 40 ) );
			m_lbelt.SetAtGrow( loop, GetTextBetweenPipes( strLine, 40, 41 ) );
			m_sbelt.SetAtGrow( loop, GetTextBetweenPipes( strLine, 41, 42 ) );
			m_tti.SetAtGrow( loop, GetTextBetweenPipes( strLine, 42, 43 ) );
			m_pelvg.SetAtGrow( loop, GetTextBetweenPipes( strLine, 43, 44 ) );
			m_occcom.SetAtGrow (loop, GetTextBetweenPipes(strLine, 44,45)) ;   
		}
		else   //skip nothing in ev5
		{
			m_Occ_vehno.SetAtGrow( loop, GetTextBetweenPipes( strLine, 0,1 ) );
			m_occloc.SetAtGrow(loop, GetTextBetweenPipes(strLine, 1,2));
			m_occtyp.SetAtGrow(loop, GetTextBetweenPipes(strLine, 2,3));
			m_occage.SetAtGrow(loop, GetTextBetweenPipes(strLine, 3,4));
			m_occsex.SetAtGrow(loop, GetTextBetweenPipes(strLine, 4,5));
			m_occht.SetAtGrow(loop, GetTextBetweenPipes(strLine, 5,6));
			m_occwt.SetAtGrow(loop, GetTextBetweenPipes(strLine, 6,7));
			m_mthcal.SetAtGrow(loop, GetTextBetweenPipes(strLine, 7,8));
			m_dumsiz.SetAtGrow(loop, GetTextBetweenPipes(strLine, 8,9));
			m_dumman.SetAtGrow(loop, GetTextBetweenPipes(strLine, 9,10));
			m_dummod.SetAtGrow(loop, GetTextBetweenPipes(strLine, 10,11));
			m_dumdsc.SetAtGrow(loop, GetTextBetweenPipes(strLine, 11,12));
			m_hh.SetAtGrow(loop,GetTextBetweenPipes(strLine, 12,13));
			m_hw.SetAtGrow(loop,GetTextBetweenPipes(strLine, 13,14));
			m_hr.SetAtGrow(loop,GetTextBetweenPipes(strLine, 14,15));
			m_hs.SetAtGrow(loop,GetTextBetweenPipes(strLine, 15,16));
			m_cd.SetAtGrow(loop,GetTextBetweenPipes(strLine, 16,17));
			m_cs.SetAtGrow(loop,GetTextBetweenPipes(strLine, 17,18));
			m_ad.SetAtGrow(loop,GetTextBetweenPipes(strLine, 18,19));
			m_hd.SetAtGrow(loop,GetTextBetweenPipes(strLine, 19,20));
			m_kd.SetAtGrow(loop,GetTextBetweenPipes(strLine, 20,21));
			m_hb.SetAtGrow(loop,GetTextBetweenPipes(strLine, 21,22));
			m_nb.SetAtGrow(loop,GetTextBetweenPipes(strLine, 22,23));
			m_cb.SetAtGrow(loop,GetTextBetweenPipes(strLine, 23,24));
			m_kb.SetAtGrow(loop,GetTextBetweenPipes(strLine, 24,25));
			m_seposn.SetAtGrow(loop,GetTextBetweenPipes(strLine, 25,26));
			m_cntrh1.SetAtGrow(loop,GetTextBetweenPipes(strLine, 26,27));
			m_cntrh2.SetAtGrow(loop,GetTextBetweenPipes(strLine, 27,28));
			m_cntrc1.SetAtGrow(loop,GetTextBetweenPipes(strLine, 28,29));
			m_cntrc2.SetAtGrow(loop,GetTextBetweenPipes(strLine, 29,30));
			m_cntrl1.SetAtGrow(loop,GetTextBetweenPipes(strLine, 30,31));
			m_cntrl2.SetAtGrow(loop,GetTextBetweenPipes(strLine, 31,32));
			m_hic.SetAtGrow(loop, GetTextBetweenPipes(strLine, 32,33));
			m_t1.SetAtGrow(loop, GetTextBetweenPipes(strLine, 33,34));
			m_t2.SetAtGrow(loop, GetTextBetweenPipes(strLine, 34,35));
			m_clip3m.SetAtGrow(loop, GetTextBetweenPipes(strLine, 35,36));
			m_lfem.SetAtGrow(loop, GetTextBetweenPipes(strLine, 36,37));
			m_rfem.SetAtGrow(loop, GetTextBetweenPipes(strLine, 37,38));
			m_csi.SetAtGrow(loop, GetTextBetweenPipes(strLine, 38,39));
			m_lbelt.SetAtGrow(loop, GetTextBetweenPipes(strLine, 39,40));
			m_sbelt.SetAtGrow(loop, GetTextBetweenPipes(strLine, 40,41));
			m_tti.SetAtGrow(loop, GetTextBetweenPipes(strLine, 41,42));
			m_pelvg.SetAtGrow(loop, GetTextBetweenPipes(strLine, 42,43));
			m_occcom.SetAtGrow (loop, GetTextBetweenPipes(strLine, 43,44)) ;   
		}

		// now increment loop and read next string.
		loop++;
		myFile.ReadString (strLine);	
	
		while (strLine[0]=='#')  //comment line, so read another.
		{
			myFile.ReadString (strLine);	
		}

	}
	m_occsets=loop-1;
}

// ******
// ExtractRestData
// This function finds and separates the Restraint data in an .ev5 file if any,
// and fills in VehData with that info.
// ******
/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehData::ExtractRestData(CStdioFile & myFile, int nVersion)
{
	CString strLine;
	myFile.SeekToBegin ();  // back to beginning

	// find ----- RESTRAINT -----
	int nRes=-1;
	while (myFile.ReadString (strLine))
	{
		nRes = strLine.Find("----- RESTRAINT -----");
		if (nRes != -1) break;
	}
	
	if (nRes==-1) 
	{
		m_restsets=0;
		return; // RESTRAINT not found.
	}

    // now read line after ----- RESTRAINT -----
	myFile.ReadString (strLine);	

	if ((strLine.GetLength ()) <1) 
	{
		m_restsets=0;
		return;  // don't process empty string
	}

	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}

	int loc1 = strLine.Find ('|',0);
	if (loc1==-1) 
	{
		m_restsets=0;
		return;      // | not found in line after ----- RESTRAINT -----,
				     // must be another section, so return.
	}

	int loop =1;
	while ((strLine.Find("----- "))== -1)  // not at inst line.
	{

		//6 pipes.EV5 and 7 EV4
		int nPipes = CountPipes(strLine);
		if (nVersion==EV4)
		{
			if (nPipes!= 7)
			{
				char buf [10];
				itoa (nPipes,buf,10);
				CString strPipes = buf;
				CString strErr = "This EV4 file has "+strPipes +" | characters in one line of the RESTRAINT section, should have 7.";
				MessageBox(NULL, strErr, "Error",MB_OK);
				m_restsets=0;
				return;  // makes sure all entries are correct.
			}
		}
		else if(nVersion==EV5)
		{
			if (nPipes!= 6)
			{
				char buf [10];
				itoa (nPipes,buf,10);
				CString strPipes = buf;
				CString strErr = "This EV5 file has "+strPipes +" | characters in one line of the RESTRAINT section, should have 6.";
				MessageBox(NULL, strErr, "Error",MB_OK);
				m_restsets=0;
				return;  // makes sure all entries are correct.
			}
		}
  
		if (nVersion==EV4) //if EV4, skip tstno
		{
			m_Rest_vehno.SetAtGrow( loop, GetTextBetweenPipes( strLine, 1,2 ) );
			m_Rest_occloc.SetAtGrow( loop, GetTextBetweenPipes( strLine, 2,3 ) );
			m_rstno.SetAtGrow( loop, GetTextBetweenPipes(strLine, 3,4 ) );
			m_rsttyp.SetAtGrow( loop, GetTextBetweenPipes(strLine, 4,5 ) );
			m_rstmnt.SetAtGrow( loop, GetTextBetweenPipes(strLine, 5,6 ) );
			m_deploy.SetAtGrow( loop, GetTextBetweenPipes(strLine, 6,7 ) );
			m_rstcom.SetAtGrow( loop, GetTextBetweenPipes(strLine, 7,8 ) ); 
			
		}
		else  // ev5, skip nothing.
		{
			m_Rest_vehno.SetAtGrow( loop, GetTextBetweenPipes(strLine, 0,1 ) );
			m_Rest_occloc.SetAtGrow( loop, GetTextBetweenPipes(strLine, 1,2 ) );
			m_rstno.SetAtGrow( loop, GetTextBetweenPipes(strLine, 2,3 ) );
			m_rsttyp.SetAtGrow( loop, GetTextBetweenPipes(strLine, 3,4 ) );
			m_rstmnt.SetAtGrow( loop, GetTextBetweenPipes(strLine, 4,5 ) );
			m_deploy.SetAtGrow( loop, GetTextBetweenPipes(strLine, 5,6 ) );
			m_rstcom.SetAtGrow( loop, GetTextBetweenPipes(strLine, 6,7 ) ); 
		}
 
		// now increment loop and read next string.
		loop++;
		myFile.ReadString (strLine);	

		while (strLine[0]=='#')  //comment line, so read another.
		{
			myFile.ReadString (strLine);	
		}

	}
	
	m_restsets=loop-1;

}

/******************************************************************************
	Name:		ExtractInstData
	Action:		This function finds and separates the Curve data in an .ev5 
				file if any, and fills in VehData with that info.
	Params:		CStdioFile, int
	Returns:	void
	Notes:	
	Dates:
******************************************************************************/
void CVehData::ExtractInstData(CStdioFile & myFile, int nVersion)
{
	CString strLine;
	myFile.SeekToBegin ();  // back to beginning

	// find ----- INSTRUMENTATION -----
	int nRes = -1;
	while (myFile.ReadString (strLine))
	{
		nRes = strLine.Find("----- INSTRUMENTATION -----");
		if (nRes != -1) break;
	}
	if (nRes==-1) 
	{
		m_totcrv = 0;
		return; // INSTRUMENTATION not found.
	}

    // now read line after ----- INSTRUMENTATION -----
	myFile.ReadString (strLine);	

	if ((strLine.GetLength ()) <1) 
	{
		m_totcrv = 0;
		return;  // don't process empty string
	}

	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}


	int loc1 = strLine.Find ('|',0);
	if (loc1==-1) 
	{
		m_totcrv = 0;
		return;      // | not found in line after ----- INSTRUMENTATION -----,
				     // must be another section, so return.
	}

	int loop = 1;
	while ((strLine.Find("----- END -----"))== -1)  // not at end line.
	{
		//19 pipes EV5 and 19 EV4
		int nPipes = CountPipes(strLine);
		if (nVersion == EV5)
		{
			if (nPipes!= 19)
			{
				char buf [10];
				itoa (nPipes,buf,10);
				CString strPipes = buf;
				CString strErr = "This EV5 file has "+strPipes +" | characters in one line of the INSTRUMENTATION section, should have 19.";
				MessageBox(NULL, strErr, "Error",MB_OK);
				m_totcrv = 0;
				return;  // makes sure all entries are correct.
			}
		}
		else if (nVersion==EV4)
		{
			if (nPipes!= 19)
			{
				char buf [10];
				itoa (nPipes,buf,10);
				CString strPipes = buf;
				CString strErr = "This EV4 file has "+strPipes +" | characters in one line of the INSTRUMENTATION section, should have 19.";
				MessageBox(NULL, strErr, "Error",MB_OK);
				m_totcrv = 0;
				return;  // makes sure all entries are correct.
			}
		}
		
		if (nVersion==EV4) // if EV4, skip tstno
		{
			m_Inst_vehno.SetAtGrow(loop, GetTextBetweenPipes(strLine, 1,2));
			m_curno = atoi(GetTextBetweenPipes(strLine, 2,3));  
			m_sentyp.SetAtGrow(loop, GetTextBetweenPipes(strLine, 3,4));
			m_senloc.SetAtGrow(loop, GetTextBetweenPipes(strLine, 4,5));
			m_senatt.SetAtGrow(loop, GetTextBetweenPipes(strLine, 5,6));
			m_axis.SetAtGrow(loop, GetTextBetweenPipes(strLine, 6,7));
//			m_xunits.SetAtGrow(loop, GetTextBetweenPipes(strLine, 7,8));
			m_xunits.SetAtGrow(loop, _T("SEC"));
			//EV4 has one field for x and y units so dont advance.
			m_yunits.SetAtGrow(loop, GetTextBetweenPipes(strLine, 7,8));
			m_prefil.SetAtGrow(loop, GetTextBetweenPipes(strLine, 8,9));
			m_insman.SetAtGrow(loop, GetTextBetweenPipes(strLine, 9,10));
			m_caldat.SetAtGrow(loop, GetTextBetweenPipes(strLine, 10,11));
			m_insrat.SetAtGrow(loop, GetTextBetweenPipes(strLine, 11,12));
			m_chlmax.SetAtGrow(loop, GetTextBetweenPipes(strLine, 12,13));
			m_inivel.SetAtGrow(loop, GetTextBetweenPipes(strLine, 13,14));
			m_nfp.SetAtGrow(loop, GetTextBetweenPipes(strLine, 14,15));
			m_nlp.SetAtGrow(loop, GetTextBetweenPipes(strLine, 15,16));
			m_delt.SetAtGrow(loop, GetTextBetweenPipes(strLine, 16,17));
			m_dastat.SetAtGrow(loop, GetTextBetweenPipes(strLine, 17,18));
			m_chstat.SetAtGrow(loop, GetTextBetweenPipes(strLine, 18,19));
			m_inscom.SetAtGrow (loop, GetTextBetweenPipes(strLine, 19,20));

		}
		else  // if ev5 skip nothing.
		{
			m_Inst_vehno.SetAtGrow(loop, GetTextBetweenPipes(strLine, 0,1));
			m_curno = atoi(GetTextBetweenPipes(strLine, 1,2));  
			m_sentyp.SetAtGrow(loop, GetTextBetweenPipes(strLine, 2,3));
			m_senloc.SetAtGrow(loop, GetTextBetweenPipes(strLine, 3,4));
			m_senatt.SetAtGrow(loop, GetTextBetweenPipes(strLine, 4,5));
			m_axis.SetAtGrow(loop, GetTextBetweenPipes(strLine, 5,6));
			m_xunits.SetAtGrow(loop, GetTextBetweenPipes(strLine, 6,7));
			m_yunits.SetAtGrow(loop, GetTextBetweenPipes(strLine, 7,8));
			m_prefil.SetAtGrow(loop, GetTextBetweenPipes(strLine, 8,9));
			m_insman.SetAtGrow(loop, GetTextBetweenPipes(strLine, 9,10));
			m_caldat.SetAtGrow(loop, GetTextBetweenPipes(strLine, 10,11));
			m_insrat.SetAtGrow(loop, GetTextBetweenPipes(strLine, 11,12));
			m_chlmax.SetAtGrow(loop, GetTextBetweenPipes(strLine, 12,13));
			m_inivel.SetAtGrow(loop, GetTextBetweenPipes(strLine, 13,14));
			m_nfp.SetAtGrow(loop, GetTextBetweenPipes(strLine, 14,15));
			m_nlp.SetAtGrow(loop, GetTextBetweenPipes(strLine, 15,16));
			m_delt.SetAtGrow(loop, GetTextBetweenPipes(strLine, 16,17));
			m_dastat.SetAtGrow(loop, GetTextBetweenPipes(strLine, 17,18));
			m_chstat.SetAtGrow(loop, GetTextBetweenPipes(strLine, 18,19));
			m_inscom.SetAtGrow (loop, GetTextBetweenPipes(strLine, 19,20));
		}
		// now increment loop and read next string.
		loop++;
		myFile.ReadString (strLine);

		while (strLine[0]=='#')  //comment line, so read another.
		{
			myFile.ReadString (strLine);	
		}

	}
	m_totcrv=loop -1;  // total curve infos read from file.
}

// ------------------------------------
// BOOL ImportGR1(CString&)
// Description:  Opens GR1 file. Sets VehData member vars with
//               Data found there, using the offsets defined in
//               VehGR1.h
// ------------------------------------
/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehData::ImportGR1(CString & strfile_in)
{
	CStdioFile myFile;
	CFileException fileException;

	myFile.Open( strfile_in, CFile::modeRead | CFile::typeText,
		&fileException );
	if (!myFile.m_pStream)  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_in, fileException.m_cause );
		MessageBox(NULL,msg,"Error",MB_OK);
		return FALSE;
	}

	CString strLine;
	myFile.ReadString (strLine);

	if ((strLine.GetLength ()) <1) return FALSE;  // don't process empty string

	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}

	int nLen = strLine.GetLength ();
	if (nLen != m_GR1.m_totallen)
	{
		MessageBox(NULL,strfile_in+" is not in proper GR1 format.","ERROR", MB_OK);
		return FALSE;
	}
	// load member variables
	
	m_title		= strLine.Mid(m_GR1.m_titleoff ,m_GR1.m_titlelen );
	m_tstobj	= strLine.Mid(m_GR1.m_tstobjoff ,m_GR1.m_tstobjlen );
	m_tstdat	= strLine.Mid(m_GR1.m_tstdatoff ,m_GR1.m_tstdatlen );
	m_tstprf	= strLine.Mid(m_GR1.m_tstprfoff ,m_GR1.m_tstprflen );
	m_conno		= strLine.Mid(m_GR1.m_connooff ,m_GR1.m_connolen );
	m_tstref	= strLine.Mid(m_GR1.m_tstrefoff ,m_GR1.m_tstreflen );
	m_tsttyp	= strLine.Mid(m_GR1.m_tsttypoff ,m_GR1.m_tsttyplen );
	m_tstcfn	= strLine.Mid(m_GR1.m_tstcfnoff ,m_GR1.m_tstcfnlen );
	m_tksurf	= strLine.Mid(m_GR1.m_tksurfoff ,m_GR1.m_tksurflen );
	m_tkcond	= strLine.Mid(m_GR1.m_tkcondoff ,m_GR1.m_tkcondlen );
	m_temp		= strLine.Mid(m_GR1.m_tempoff ,m_GR1.m_templen );
	m_rectyp	= strLine.Mid(m_GR1.m_rectypoff ,m_GR1.m_rectyplen );
	m_link		= strLine.Mid(m_GR1.m_linkoff ,m_GR1.m_linklen );
	m_clsspd	= strLine.Mid(m_GR1.m_clsspdoff ,m_GR1.m_clsspdlen );
	m_impang	= strLine.Mid(m_GR1.m_impangoff ,m_GR1.m_impanglen );
	m_offset	= strLine.Mid(m_GR1.m_offsetoff ,m_GR1.m_offsetlen );
	m_imppnt	= strLine.Mid(m_GR1.m_imppntoff ,m_GR1.m_imppntlen );
//	m_totcrv	= strLine.Mid(m_GR1.m_totcrvoff ,m_GR1.m_totcrvlen );  GR5 controlled.
	m_tstcom	= strLine.Mid(m_GR1.m_tstcomoff ,m_GR1.m_tstcomlen );

	return TRUE;
}

// ------------------------------------
// BOOL ImportGR2(CString&)
// Description:  Opens GR2 file. Sets VehData member vars with
//               Data found there, using the offsets defined in
//               VehGR2.h
// ------------------------------------
/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehData::ImportGR2(CString & strfile_in)
{
	CStdioFile myFile;
	CFileException fileException;
	
	myFile.Open( strfile_in, CFile::modeRead | CFile::typeText,
		&fileException );
	if (!myFile.m_pStream)  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_in, fileException.m_cause );
		MessageBox(NULL,msg,"Error",MB_OK);
		return FALSE;
	}

	CString strLine;

	while(myFile.ReadString (strLine))
	{
		if ((strLine.GetLength ()) <1) return FALSE;  // don't process empty string

		while (strLine[0]=='#')  //comment line, so read another.
		{
			myFile.ReadString (strLine);	
		}

		int nLen = strLine.GetLength ();
		if (nLen != m_GR2.m_totallen)
		{
			MessageBox(NULL,strfile_in+" is not in proper GR2 format.","ERROR", MB_OK);
			return FALSE;
		}
	
		// load member variables
 		m_vehno = atoi(strLine.Mid(m_GR2.m_vehnooff ,m_GR2.m_vehnolen ));
		// verify vehno validity
		if ((m_vehno !=1) && (m_vehno!=2))
		{
			  MessageBox(NULL,"Invalid Vehicle Number","ERROR",MB_OK);
			m_vehno = 1;
			return FALSE;
		}
	  
		m_make[m_vehno]	= strLine.Mid(m_GR2.m_makeoff ,m_GR2.m_makelen );
		m_model[m_vehno]	= strLine.Mid(m_GR2.m_modeloff ,m_GR2.m_modellen );
		m_year[m_vehno]	= strLine.Mid(m_GR2.m_yearoff ,m_GR2.m_yearlen );
		m_body[m_vehno]	= strLine.Mid(m_GR2.m_bodyoff ,m_GR2.m_bodylen );
		m_vin[m_vehno]	= strLine.Mid(m_GR2.m_vinoff ,m_GR2.m_vinlen );
		m_engine[m_vehno]	= strLine.Mid(m_GR2.m_engineoff ,m_GR2.m_enginelen );
		m_engdsp[m_vehno]	= strLine.Mid(m_GR2.m_engdspoff ,m_GR2.m_engdsplen );
		m_transm[m_vehno]	= strLine.Mid(m_GR2.m_transmoff ,m_GR2.m_transmlen );
		m_vehtwt[m_vehno]	= strLine.Mid(m_GR2.m_vehtwtoff ,m_GR2.m_vehtwtlen );
		m_whlbas[m_vehno]	= strLine.Mid(m_GR2.m_whlbasoff ,m_GR2.m_whlbaslen );
		m_vehlen[m_vehno]	= strLine.Mid(m_GR2.m_vehlenoff ,m_GR2.m_vehlenlen );
		m_vehwid[m_vehno]	= strLine.Mid(m_GR2.m_vehwidoff ,m_GR2.m_vehwidlen );
		m_vehcg[m_vehno]	= strLine.Mid(m_GR2.m_vehcgoff ,m_GR2.m_vehcglen );
		m_strsep[m_vehno]	= strLine.Mid(m_GR2.m_strsepoff ,m_GR2.m_strseplen );
		m_colmec[m_vehno]	= strLine.Mid(m_GR2.m_colmecoff ,m_GR2.m_colmeclen );
		m_modind[m_vehno]	= strLine.Mid(m_GR2.m_modindoff ,m_GR2.m_modindlen );
		m_moddsc[m_vehno]	= strLine.Mid(m_GR2.m_moddscoff ,m_GR2.m_moddsclen );
		m_bx1[m_vehno]	= strLine.Mid(m_GR2.m_bx1off ,m_GR2.m_bx1len );
		m_bx2[m_vehno]	= strLine.Mid(m_GR2.m_bx2off ,m_GR2.m_bx2len );
		m_bx3[m_vehno]	= strLine.Mid(m_GR2.m_bx3off ,m_GR2.m_bx3len );
		m_bx4[m_vehno]	= strLine.Mid(m_GR2.m_bx4off ,m_GR2.m_bx4len );
		m_bx5[m_vehno]	= strLine.Mid(m_GR2.m_bx5off ,m_GR2.m_bx5len );
		m_bx6[m_vehno]	= strLine.Mid(m_GR2.m_bx6off ,m_GR2.m_bx6len );
		m_bx7[m_vehno]	= strLine.Mid(m_GR2.m_bx7off ,m_GR2.m_bx7len );
		m_bx8[m_vehno]	= strLine.Mid(m_GR2.m_bx8off ,m_GR2.m_bx8len );
		m_bx9[m_vehno]	= strLine.Mid(m_GR2.m_bx9off ,m_GR2.m_bx9len );
		m_bx10[m_vehno]	= strLine.Mid(m_GR2.m_bx10off ,m_GR2.m_bx10len );
		m_bx11[m_vehno]	= strLine.Mid(m_GR2.m_bx11off ,m_GR2.m_bx11len );
		m_bx12[m_vehno]	= strLine.Mid(m_GR2.m_bx12off ,m_GR2.m_bx12len );
		m_bx13[m_vehno]	= strLine.Mid(m_GR2.m_bx13off ,m_GR2.m_bx13len );
		m_bx14[m_vehno]	= strLine.Mid(m_GR2.m_bx14off ,m_GR2.m_bx14len );
		m_bx15[m_vehno]	= strLine.Mid(m_GR2.m_bx15off ,m_GR2.m_bx15len );
		m_bx16[m_vehno]	= strLine.Mid(m_GR2.m_bx16off ,m_GR2.m_bx16len );
		m_bx17[m_vehno]	= strLine.Mid(m_GR2.m_bx17off ,m_GR2.m_bx17len );
		m_bx18[m_vehno]	= strLine.Mid(m_GR2.m_bx18off ,m_GR2.m_bx18len );
		m_bx19[m_vehno]	= strLine.Mid(m_GR2.m_bx19off ,m_GR2.m_bx19len );
		m_bx20[m_vehno]	= strLine.Mid(m_GR2.m_bx20off ,m_GR2.m_bx20len );
		m_bx21[m_vehno]	= strLine.Mid(m_GR2.m_bx21off ,m_GR2.m_bx21len );
		m_vehspd[m_vehno]	= strLine.Mid(m_GR2.m_vehspdoff ,m_GR2.m_vehspdlen );
		m_crbang[m_vehno]	= strLine.Mid(m_GR2.m_crbangoff ,m_GR2.m_crbanglen );
		m_pdof[m_vehno]	= strLine.Mid(m_GR2.m_pdofoff ,m_GR2.m_pdoflen );
		m_bmpeng[m_vehno]	= strLine.Mid(m_GR2.m_bmpengoff ,m_GR2.m_bmpenglen );
		m_sileng[m_vehno]	= strLine.Mid(m_GR2.m_silengoff ,m_GR2.m_silenglen );
		m_apleng[m_vehno]	= strLine.Mid(m_GR2.m_aplengoff ,m_GR2.m_aplenglen );
		m_dpd1[m_vehno]	= strLine.Mid(m_GR2.m_dpd1off ,m_GR2.m_dpd1len );
		m_dpd2[m_vehno]	= strLine.Mid(m_GR2.m_dpd2off ,m_GR2.m_dpd2len );
		m_dpd3[m_vehno]	= strLine.Mid(m_GR2.m_dpd3off ,m_GR2.m_dpd3len );
		m_dpd4[m_vehno]	= strLine.Mid(m_GR2.m_dpd4off ,m_GR2.m_dpd4len );
		m_dpd5[m_vehno]	= strLine.Mid(m_GR2.m_dpd5off ,m_GR2.m_dpd5len );
		m_dpd6[m_vehno]	= strLine.Mid(m_GR2.m_dpd6off ,m_GR2.m_dpd6len );
		m_vdi[m_vehno]	= strLine.Mid(m_GR2.m_vdioff ,m_GR2.m_vdilen );
		m_lencnt[m_vehno]	= strLine.Mid(m_GR2.m_lencntoff ,m_GR2.m_lencntlen );
		m_damdst[m_vehno]	= strLine.Mid(m_GR2.m_damdstoff ,m_GR2.m_damdstlen );
		m_crhdst[m_vehno]	= strLine.Mid(m_GR2.m_crhdstoff ,m_GR2.m_crhdstlen );
		m_ax1[m_vehno]	= strLine.Mid(m_GR2.m_ax1off ,m_GR2.m_ax1len );
		m_ax2[m_vehno]	= strLine.Mid(m_GR2.m_ax2off ,m_GR2.m_ax2len );
		m_ax3[m_vehno]	= strLine.Mid(m_GR2.m_ax3off ,m_GR2.m_ax3len );
		m_ax4[m_vehno]	= strLine.Mid(m_GR2.m_ax4off ,m_GR2.m_ax4len );
		m_ax5[m_vehno]	= strLine.Mid(m_GR2.m_ax5off ,m_GR2.m_ax5len );
		m_ax6[m_vehno]	= strLine.Mid(m_GR2.m_ax6off ,m_GR2.m_ax6len );
		m_ax7[m_vehno]	= strLine.Mid(m_GR2.m_ax7off ,m_GR2.m_ax7len );
		m_ax8[m_vehno]	= strLine.Mid(m_GR2.m_ax8off ,m_GR2.m_ax8len );
		m_ax9[m_vehno]	= strLine.Mid(m_GR2.m_ax9off ,m_GR2.m_ax9len );
		m_ax10[m_vehno]	= strLine.Mid(m_GR2.m_ax10off ,m_GR2.m_ax10len );
		m_ax11[m_vehno]	= strLine.Mid(m_GR2.m_ax11off ,m_GR2.m_ax11len );
		m_ax12[m_vehno]	= strLine.Mid(m_GR2.m_ax12off ,m_GR2.m_ax12len );
		m_ax13[m_vehno]	= strLine.Mid(m_GR2.m_ax13off ,m_GR2.m_ax13len );
		m_ax14[m_vehno]	= strLine.Mid(m_GR2.m_ax14off ,m_GR2.m_ax14len );
		m_ax15[m_vehno]	= strLine.Mid(m_GR2.m_ax15off ,m_GR2.m_ax15len );
		m_ax16[m_vehno]	= strLine.Mid(m_GR2.m_ax16off ,m_GR2.m_ax16len );
		m_ax17[m_vehno]	= strLine.Mid(m_GR2.m_ax17off ,m_GR2.m_ax17len );
		m_ax18[m_vehno]	= strLine.Mid(m_GR2.m_ax18off ,m_GR2.m_ax18len );
		m_ax19[m_vehno]	= strLine.Mid(m_GR2.m_ax19off ,m_GR2.m_ax19len );
		m_ax20[m_vehno]	= strLine.Mid(m_GR2.m_ax20off ,m_GR2.m_ax20len );
		m_ax21[m_vehno]	= strLine.Mid(m_GR2.m_ax21off ,m_GR2.m_ax21len );
		m_carang[m_vehno]	= strLine.Mid(m_GR2.m_carangoff ,m_GR2.m_caranglen );
		m_vehor[m_vehno]	= strLine.Mid(m_GR2.m_vehoroff ,m_GR2.m_vehorlen );
		m_vehcom[m_vehno]	= strLine.Mid(m_GR2.m_vehcomoff ,m_GR2.m_vehcomlen );
	}
	  
	return TRUE;
}

// ------------------------------------
// BOOL ImportGR3(CString&)
// Description:  Opens GR3 file. Sets VehData member vars with
//               Data found there, using the offsets defined in
//               VehGR3.h
// ------------------------------------
/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehData::ImportGR3(CString & strfile_in)
{
	CStdioFile myFile;
	CFileException fileException;
	
	myFile.Open( strfile_in, CFile::modeRead | CFile::typeText,
		&fileException );
	if (!myFile.m_pStream)  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_in, fileException.m_cause );
		MessageBox(NULL,msg,"Error",MB_OK);
		return FALSE;
	}

	CString strLine;
	myFile.ReadString (strLine);

	if ((strLine.GetLength ()) <1) return FALSE;  // don't process empty string

	while (strLine[0]=='#')  //comment line, so read another.
	{
		myFile.ReadString (strLine);	
	}

	int nLen = strLine.GetLength ();
	if (nLen != m_GR3.m_totallen)
	{
		MessageBox(NULL,strfile_in+" is not in proper GR3 format.","ERROR", MB_OK);
		return FALSE;
	}
	
	// load member variables
	m_cstrbarrig = strLine.Mid( m_GR3.m_barrigoff ,m_GR3.m_barriglen );
	m_cstrbarshp = strLine.Mid( m_GR3.m_barshpoff ,m_GR3.m_barshplen );
	m_cstrbarang = strLine.Mid( m_GR3.m_barangoff ,m_GR3.m_baranglen );
	m_cstrbardia = strLine.Mid( m_GR3.m_bardiaoff ,m_GR3.m_bardialen );
	m_cstrbarcom = strLine.Mid( m_GR3.m_barcomoff ,m_GR3.m_barcomlen );

	return TRUE;

}

// ------------------------------------
// short ImportGR4(CString&, int)
// Description:  Opens GR4 file. Sets VehData member vars with
//               Data found there, using the offsets defined in
//               VehGR4.h
// ------------------------------------
/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
short CVehData::ImportGR4(CString & strfile_in)
{
	CStdioFile myFile;
	CFileException fileException;
	
	myFile.Open( strfile_in, CFile::modeRead | CFile::typeText,
		&fileException );
	if (!myFile.m_pStream)  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_in, fileException.m_cause );
		MessageBox(NULL,msg,"Error",MB_OK);
		return FALSE;
	}

	CString strLine;
	short loop = 1;

	while(myFile.ReadString (strLine))
	{
		if ((strLine.GetLength ()) <1) return 0;  // don't process empty string

		while (strLine[0]=='#')  //comment line, so read another.
		{
			myFile.ReadString (strLine);	
		}

		int nLen = strLine.GetLength ();
		if (nLen != m_GR4.m_totallen)
		{
			MessageBox(NULL,strfile_in+" is not in proper GR4 format.","ERROR", MB_OK);
			return 0;
		}
		
		// load member variables  
		
		m_Occ_vehno.SetAtGrow (loop, strLine.Mid(m_GR4.m_vehnooff ,m_GR4.m_vehnolen));
		m_occloc.SetAtGrow (loop,strLine.Mid(m_GR4.m_occlocoff ,m_GR4.m_occloclen));
		m_occtyp.SetAtGrow (loop,strLine.Mid(m_GR4.m_occtypoff ,m_GR4.m_occtyplen));
		m_occage.SetAtGrow (loop, strLine.Mid(m_GR4.m_occageoff ,m_GR4.m_occagelen));
		m_occsex.SetAtGrow (loop,strLine.Mid(m_GR4.m_occsexoff ,m_GR4.m_occsexlen));
		m_occht.SetAtGrow (loop, strLine.Mid(m_GR4.m_occhtoff ,m_GR4.m_occhtlen));
		m_occwt.SetAtGrow (loop, strLine.Mid(m_GR4.m_occwtoff ,m_GR4.m_occwtlen));
		m_mthcal.SetAtGrow (loop,strLine.Mid(m_GR4.m_mthcaloff ,m_GR4.m_mthcallen));
		m_dumsiz.SetAtGrow (loop,strLine.Mid(m_GR4.m_dumsizoff ,m_GR4.m_dumsizlen));
		m_dumman.SetAtGrow (loop,strLine.Mid(m_GR4.m_dummanoff ,m_GR4.m_dummanlen));
		m_dummod.SetAtGrow (loop,strLine.Mid(m_GR4.m_dummodoff ,m_GR4.m_dummodlen));
		m_dumdsc.SetAtGrow (loop,strLine.Mid(m_GR4.m_dumdscoff ,m_GR4.m_dumdsclen));
		m_hh.SetAtGrow (loop,strLine.Mid(m_GR4.m_hhoff ,m_GR4.m_hhlen));
		m_hw.SetAtGrow (loop,strLine.Mid(m_GR4.m_hwoff ,m_GR4.m_hwlen));
		m_hr.SetAtGrow (loop,strLine.Mid(m_GR4.m_hroff ,m_GR4.m_hrlen));
		m_hs.SetAtGrow (loop,strLine.Mid(m_GR4.m_hsoff ,m_GR4.m_hslen));
		m_cd.SetAtGrow (loop,strLine.Mid(m_GR4.m_cdoff ,m_GR4.m_cdlen));
		m_cs.SetAtGrow (loop,strLine.Mid(m_GR4.m_csoff ,m_GR4.m_cslen));
		m_ad.SetAtGrow (loop,strLine.Mid(m_GR4.m_adoff ,m_GR4.m_adlen));
		m_hd.SetAtGrow (loop,strLine.Mid(m_GR4.m_hdoff ,m_GR4.m_hdlen));
		m_kd.SetAtGrow (loop,strLine.Mid(m_GR4.m_kdoff ,m_GR4.m_kdlen));
		m_hb.SetAtGrow (loop,strLine.Mid(m_GR4.m_hboff ,m_GR4.m_hblen));
		m_nb.SetAtGrow (loop,strLine.Mid(m_GR4.m_nboff ,m_GR4.m_nblen));
		m_cb.SetAtGrow (loop,strLine.Mid(m_GR4.m_cboff ,m_GR4.m_cblen));
		m_kb.SetAtGrow (loop,strLine.Mid(m_GR4.m_kboff ,m_GR4.m_kblen));
		m_seposn.SetAtGrow (loop,strLine.Mid(m_GR4.m_seposnoff ,m_GR4.m_seposnlen));
		m_cntrh1.SetAtGrow (loop,strLine.Mid(m_GR4.m_cntrh1off ,m_GR4.m_cntrh1len));
		m_cntrh2.SetAtGrow (loop,strLine.Mid(m_GR4.m_cntrh2off ,m_GR4.m_cntrh2len));
		m_cntrc1.SetAtGrow (loop,strLine.Mid(m_GR4.m_cntrc1off ,m_GR4.m_cntrc1len));
		m_cntrc2.SetAtGrow (loop,strLine.Mid(m_GR4.m_cntrc2off ,m_GR4.m_cntrc2len));
		m_cntrl1.SetAtGrow (loop,strLine.Mid(m_GR4.m_cntrl1off ,m_GR4.m_cntrl1len));
		m_cntrl2.SetAtGrow (loop,strLine.Mid(m_GR4.m_cntrl2off ,m_GR4.m_cntrl2len));
		m_hic.SetAtGrow (loop,strLine.Mid(m_GR4.m_hicoff ,m_GR4.m_hiclen));
		m_t1.SetAtGrow (loop, strLine.Mid(m_GR4.m_t1off ,m_GR4.m_t1len));
		m_t2.SetAtGrow (loop, strLine.Mid(m_GR4.m_t2off ,m_GR4.m_t2len));
		m_clip3m.SetAtGrow (loop, strLine.Mid(m_GR4.m_clip3moff ,m_GR4.m_clip3mlen));
		m_lfem.SetAtGrow (loop, strLine.Mid(m_GR4.m_lfemoff ,m_GR4.m_lfemlen));
		m_rfem.SetAtGrow (loop, strLine.Mid(m_GR4.m_rfemoff ,m_GR4.m_rfemlen));
		m_csi.SetAtGrow (loop, strLine.Mid(m_GR4.m_csioff ,m_GR4.m_csilen));
		m_lbelt.SetAtGrow (loop, strLine.Mid(m_GR4.m_lbeltoff ,m_GR4.m_lbeltlen));
		m_sbelt.SetAtGrow (loop, strLine.Mid(m_GR4.m_sbeltoff ,m_GR4.m_sbeltlen));
		m_occcom.SetAtGrow (loop, strLine.Mid(m_GR4.m_occcomoff ,m_GR4.m_occcomlen));
		//These arent in GR4 so give defaults to avoid access violation.
		m_tti.SetAtGrow(loop, "" );
		m_pelvg.SetAtGrow(loop, "" );
		
		loop++;
	}

	return --loop;

}

/******************************************************************************
	Name:		ImportGR5
	Action:		Opens GR5 file.
	Params:		CString & strfile_in
	Returns:	BOOL
	Notes:		Sets VehData member vars with Data found there, using the 
				offsets defined in VehGR5.h.
	Dates:
******************************************************************************/
BOOL CVehData::ImportGR5(CString & strfile_in)
{
	CStdioFile myFile;
	CFileException fileException;
	
	myFile.Open( strfile_in, CFile::modeRead | CFile::typeText,
		&fileException );
	if (!myFile.m_pStream)  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_in, fileException.m_cause );
		MessageBox(NULL,msg,"Error",MB_OK);
		return FALSE;
	}

	CString strLine;
	
	while(myFile.ReadString (strLine))
	{
		if ((strLine.GetLength ()) <1) return FALSE;  // don't process empty string
		
		while (strLine[0]=='#')  //comment line, so read another.
		{
			myFile.ReadString (strLine);	
		}

		int nLen = strLine.GetLength ();
		if (nLen != m_GR5.m_totallen)
		{
			MessageBox(NULL,strfile_in+" is not in proper GR5 format.","ERROR", MB_OK);
			return FALSE;
		}
		
		// load member variables  
		
		m_curno = atoi(strLine.Mid(m_GR5.m_curnooff ,m_GR5.m_curnolen ));
				
		m_Inst_vehno.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_vehnooff, m_GR5.m_vehnolen));
		
		m_sentyp.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_sentypoff ,m_GR5.m_sentyplen ));
				
		m_senloc.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_senlocoff ,m_GR5.m_senloclen ));
				
		m_senatt.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_senattoff ,m_GR5.m_senattlen ));
				
		m_axis.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_axisoff ,m_GR5.m_axislen ));

		//	XUNITS should be set to "SEC".
		m_xunits.SetAtGrow( m_curno, _T("SEC") );

		//	YUNITS should be set to UNITS.
		m_yunits.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_unitsoff ,m_GR5.m_unitslen ));
		
		m_prefil.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_prefiloff ,m_GR5.m_prefillen ));
				
		m_insman.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_insmanoff ,m_GR5.m_insmanlen ));
				
		m_caldat.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_caldatoff ,m_GR5.m_caldatlen ));
				
		m_insrat.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_insratoff ,m_GR5.m_insratlen ));
				
		m_chlmax.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_chlmaxoff ,m_GR5.m_chlmaxlen ));
				
		m_inivel.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_iniveloff ,m_GR5.m_inivellen ));
		
		m_nfp.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_nfpoff ,m_GR5.m_nfplen ));
				
		m_nlp.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_nlpoff ,m_GR5.m_nlplen ));
				
		m_delt.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_deltoff ,m_GR5.m_deltlen ));
				
		m_dastat.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_dastatoff ,m_GR5.m_dastatlen ));

		m_chstat.SetAtGrow (m_curno, _T("")); //chstat isn't in GR5, so fill in data to avoid access violations
				
		m_inscom.SetAtGrow (m_curno, strLine.Mid(m_GR5.m_inscomoff ,m_GR5.m_inscomlen ));
		
	}
	m_totcrv = m_curno;
	return TRUE;
}

//// for High speed video
