// VehData.h: interface for the CVehData class.
//
//////////////////////////////////////////////////////////////////////

#include "VehGR1.h"
#include "VehGR2.h"
#include "VehGR3.h"
#include "VehGR4.h"
#include "VehGR5.h"
#include "HighSpeedVideoData.h"
#include "IntrusionData.h"

#if !defined(AFX_VEHDATA_H__A10DACD7_64F7_11D2_9493_0008C7AA9033__INCLUDED_)
#define AFX_VEHDATA_H__A10DACD7_64F7_11D2_9493_0008C7AA9033__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CVehData : public CHighSpeedVideoData//, public CIntrusionData
{
public:
	//Constructors/Destructors
	CVehData();
	virtual ~CVehData();

	// member functions
	BOOL ImportGR5(CString &);
	short ImportGR4(CString &);
	BOOL ImportGR3(CString &);
	BOOL ImportGR2(CString &);
	BOOL ImportGR1(CString &);
	
	void ExtractInstData (CStdioFile &, int);
	void ExtractRestData (CStdioFile &, int);
	void ExtractOccData(CStdioFile &,int);
	void ExtractBarData(CStdioFile &, int);
	void ExtractVehData (CStdioFile &, int);
	void ExtractTestData(CStdioFile &, int);
	
	BOOL LoadVehEV5Data (CStdioFile &);
	
	BOOL ImportEV4(CString &);
	BOOL ImportEV5(CString &);
	
	void WriteVehInstReport (CStdioFile &);
	void WriteVehRestReport (CStdioFile &);
	void WriteVehOccReport(CStdioFile &);
	void WriteVehBarReport(CStdioFile &);
	void WriteVehVehReport(CStdioFile &);
	void WriteVehTestReport (CStdioFile &);
	
	BOOL ExportEVR(CString &);
	CString OutString(CString);
	void WriteVehInst(CStdioFile &);
	void WriteVehRest(CStdioFile &);
	void WriteVehOcc(CStdioFile &);
	void WriteVehBar (CStdioFile &);
	void WriteVehVeh(CStdioFile &);
	void WriteVehTest(CStdioFile &);
	BOOL ExportEV5(CString& );

	bool ValidateEmptyBar( void );
	bool ValidateEmptyTest( void );
	bool ValidateEmptyVeh( void );

//data members
public:
	CVehGR1 m_GR1;
	CVehGR2 m_GR2;
	CVehGR3 m_GR3;
	CVehGR4 m_GR4;
	CVehGR5 m_GR5;
	CIntrusionData m_IntrusionData;

	int m_restsets;
	int m_occsets;
	
	//	CVehTestPage -- BEGIN
	CString m_verno;
	CString m_title;
	CString m_tstobj;
	CString m_tstdat;
	CString m_tstprf;
	CString m_conno;
	CString m_tsttyp;
//	CString m_tstref;	/ defined in CHighSpeedVideo
	CString m_tstcfn;
	CString m_tksurf;
	CString m_tkcond;
	CString	m_temp;
	CString m_rectyp;
	CString m_link;
	CString	m_clsspd;
	CString	m_impang;
	CString	m_offset;
	CString	m_imppnt;
	int		m_totcrv;
	CString m_tstcom;
	//	CVehTestPage -- END

	// CVehVehPage -- BEGIN
	// Vehicle Info Data - arrays for multiple vehicles- currently only 2 allowed. 
	int				m_vehno;	// Number of vehicles, also used as array index
	CStringArray	m_make;
	CStringArray	m_model;
	CStringArray	m_year;
	CStringArray	m_nhtsano;
	CStringArray	m_body;
	CStringArray	m_vin;
	CStringArray	m_engine;
	CStringArray	m_engdsp;
	CStringArray	m_transm;
	CStringArray	m_vehtwt;
	CStringArray	m_whlbas;
	CStringArray	m_vehlen;
	CStringArray	m_vehwid;
	CStringArray	m_vehcg;
	CStringArray	m_strsep;
	CStringArray	m_colmec;
	CStringArray	m_modind;
	CStringArray	m_moddsc;
	CStringArray	m_bx1;
	CStringArray	m_bx2;
	CStringArray	m_bx3;
	CStringArray	m_bx4;
	CStringArray	m_bx5;
	CStringArray	m_bx6;
	CStringArray	m_bx7;
	CStringArray	m_bx8;
	CStringArray	m_bx9;
	CStringArray	m_bx10;
	CStringArray	m_bx11;
	CStringArray	m_bx12;
	CStringArray	m_bx13;
	CStringArray	m_bx14;
	CStringArray	m_bx15;
	CStringArray	m_bx16;
	CStringArray	m_bx17;
	CStringArray	m_bx18;
	CStringArray	m_bx19;
	CStringArray	m_bx20;
	CStringArray	m_bx21;
	CStringArray	m_vehspd;
	CStringArray	m_crbang;
	CStringArray	m_pdof;
	CStringArray	m_bmpeng;
	CStringArray	m_sileng;
	CStringArray	m_apleng;
	CStringArray	m_dpd1;
	CStringArray	m_dpd2;
	CStringArray	m_dpd3;
	CStringArray	m_dpd4;
	CStringArray	m_dpd5;
	CStringArray	m_dpd6;
	CStringArray	m_vdi;
	CStringArray	m_lencnt;
	CStringArray	m_damdst;
	CStringArray	m_crhdst;
	CStringArray	m_ax1;
	CStringArray	m_ax2;
	CStringArray	m_ax3;
	CStringArray	m_ax4;
	CStringArray	m_ax5;
	CStringArray	m_ax6;
	CStringArray	m_ax7;
	CStringArray	m_ax8;
	CStringArray	m_ax9;
	CStringArray	m_ax10;
	CStringArray	m_ax11;
	CStringArray	m_ax12;
	CStringArray	m_ax13;
	CStringArray	m_ax14;
	CStringArray	m_ax15;
	CStringArray	m_ax16;
	CStringArray	m_ax17;
	CStringArray	m_ax18;
	CStringArray	m_ax19;
	CStringArray	m_ax20;
	CStringArray	m_ax21;
	CStringArray	m_carang;
	CStringArray	m_vehor;
	CStringArray	m_vehcom;
	// CVehVehPage -- END

	// CVehBarPage -- BEGIN
	CString	m_cstrbarrig;
	CString	m_cstrbarshp;
	CString	m_cstrbarang;
	CString	m_cstrbardia;
	CString m_cstrbarcom;
	// CVehBarPage -- END

	// CVehOccPage -- BEGIN
	CStringArray	m_Occ_vehno;
	CStringArray	m_occloc;
	CStringArray	m_occtyp;
	CStringArray	m_occage;
	CStringArray	m_occsex;
	CStringArray	m_occht;
	CStringArray	m_occwt;
	CStringArray	m_mthcal;
	CStringArray	m_dumsiz;
	CStringArray	m_dumman;
	CStringArray	m_dummod;
	CStringArray	m_dumdsc;
	CStringArray	m_hh;
	CStringArray	m_hw;
	CStringArray	m_hr;
	CStringArray	m_hs;
	CStringArray	m_cd;
	CStringArray	m_cs;
	CStringArray	m_ad;
	CStringArray	m_hd;
	CStringArray	m_kd;
	CStringArray	m_hb;
	CStringArray	m_nb;
	CStringArray	m_cb;
	CStringArray	m_kb;
	CStringArray	m_seposn;
	CStringArray	m_cntrh1;
	CStringArray	m_cntrh2;
	CStringArray	m_cntrc1;
	CStringArray	m_cntrc2;
	CStringArray	m_cntrl1;
	CStringArray	m_cntrl2;
	CStringArray	m_hic;
	CStringArray	m_t1;
	CStringArray	m_t2;
	CStringArray	m_clip3m;
	CStringArray	m_lfem;
	CStringArray	m_rfem;
	CStringArray	m_csi;
	CStringArray	m_lbelt;
	CStringArray	m_sbelt;
	CStringArray	m_tti;
	CStringArray	m_pelvg;
	CStringArray	m_occcom;
	// CVehOccPage -- END

	// CVehRestPage -- BEGIN
	CStringArray	m_Rest_vehno;
	CStringArray	m_Rest_occloc;
	CStringArray	m_rstno;
	CStringArray	m_rsttyp;
	CStringArray	m_rstmnt;
	CStringArray	m_deploy;
	CStringArray	m_rstcom;
	// CVehRestPage -- END

	// CVehInstPage -- BEGIN
	CStringArray	m_Inst_vehno;
	int				m_curno;   //number of curves, also used as array index.
	CStringArray	m_senloc;
	CStringArray	m_sentyp;
	CStringArray	m_senatt;
	CStringArray	m_axis;
	CStringArray	m_xunits;
	CStringArray	m_yunits;
	CStringArray	m_prefil;
	CStringArray	m_insman;
	CStringArray	m_caldat;
	CStringArray	m_insrat;
	CStringArray	m_chlmax;
	CStringArray	m_inivel;
	CStringArray	m_nfp;
	CStringArray	m_nlp;
	CStringArray	m_delt;
	CStringArray	m_dastat;
	CStringArray	m_chstat;
	CStringArray	m_inscom;
	// CVehInstPage -- End

};

#endif // !defined(AFX_VEHDATA_H__A10DACD7_64F7_11D2_9493_0008C7AA9033__INCLUDED_)
