// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: VehGR1.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description: CVehGR1 constructor.  All this class does is
//              hold the offsets and lengths used for parsing data out of
//              a GR1 file.
// -----------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "VehGR1.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
CVehGR1::CVehGR1()
{
	m_vernooff = 0;
	m_vernolen = 2;

	m_tstnooff = 2;
	m_tstnolen = 1;

	m_titleoff = 3;
	m_titlelen = 70;

	m_tstobjoff = 73;
	m_tstobjlen = 70;

	m_tstdatoff = 143;
	m_tstdatlen = 9;

	m_tstprfoff = 152;
	m_tstprflen = 3;

	m_connooff = 155;
	m_connolen = 17;

	m_tstrefoff = 172;
	m_tstreflen = 10;

	m_tsttypoff = 182;
	m_tsttyplen = 3;

	m_tstcfnoff = 185;
	m_tstcfnlen = 3;

	m_tksurfoff = 188;
	m_tksurflen = 3;

	m_tkcondoff = 191;
	m_tkcondlen = 3;

	m_tempoff = 194;
	m_templen = 3;

	m_rectypoff = 197;
	m_rectyplen = 3;

	m_linkoff = 200;
	m_linklen = 3;

	m_clsspdoff = 203;
	m_clsspdlen = 5;

	m_impangoff = 208;
	m_impanglen = 3;

	m_offsetoff = 211;
	m_offsetlen = 6;

	m_imppntoff = 217;
	m_imppntlen = 6;

	m_dimsysoff = 223;
	m_dimsyslen = 3;

	m_totcrvoff = 226;
	m_totcrvlen = 3;

	m_tstcomoff = 229;
	m_tstcomlen = 70;

	m_totallen = 299;

}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
CVehGR1::~CVehGR1()
{

}
