// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: VehGR2.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description: CVehGR2 constructor.  All this class does is
//              hold the offsets and lengths used for parsing data out of
//              a GR2 file.
// -----------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "VehGR2.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
CVehGR2::CVehGR2()
{
	
	  m_vehnooff = 1;
	  m_vehnolen = 1;

	  m_makeoff = 2;
	  m_makelen = 2;

	  m_modeloff = 4;
	  m_modellen = 2;

	  m_yearoff = 6;
	  m_yearlen = 2;

	  m_bodyoff = 8;
	  m_bodylen = 2;

	  m_vinoff = 10;
	  m_vinlen = 20;

	  m_engineoff = 30;
	  m_enginelen = 4;

	  m_engdspoff = 34;
	  m_engdsplen = 12;

	  m_transmoff = 46;
	  m_transmlen = 2;

	  m_vehtwtoff = 48;
	  m_vehtwtlen = 5;

	  m_whlbasoff = 53;
	  m_whlbaslen = 6;

	  m_vehlenoff = 59;
	  m_vehlenlen = 6;

	  m_vehwidoff = 65;
	  m_vehwidlen = 5;

	  m_vehcgoff = 70;
	  m_vehcglen = 5;

	  m_strsepoff = 75;
	  m_strseplen = 2;

	  m_colmecoff = 77;
	  m_colmeclen = 3;

	  m_modindoff = 80;
	  m_modindlen = 1;

	  m_moddscoff = 81;
	  m_moddsclen = 70;

	  m_bx1off = 151;
	  m_bx1len = 6;

	  m_bx2off = 157;
	  m_bx2len = 6;

	  m_bx3off = 163;
	  m_bx3len = 6;

	  m_bx4off = 169;
	  m_bx4len = 6;

	  m_bx5off = 175;
	  m_bx5len = 6;

	  m_bx6off = 181;
	  m_bx6len = 6;

	  m_bx7off = 187;
	  m_bx7len = 6;

	  m_bx8off = 193;
	  m_bx8len = 6;

	  m_bx9off = 199;
	  m_bx9len = 6;

	  m_bx10off = 205;
	  m_bx10len = 6;

	  m_bx11off = 211;
	  m_bx11len = 6;

	  m_bx12off = 217;
	  m_bx12len = 6;

	  m_bx13off = 223;
	  m_bx13len = 6;

	  m_bx14off = 229;
	  m_bx14len = 6;

	  m_bx15off = 235;
	  m_bx15len = 6;

	  m_bx16off = 241;
	  m_bx16len = 6;

	  m_bx17off = 247;
	  m_bx17len = 6;

	  m_bx18off = 253;
	  m_bx18len = 6;

	  m_bx19off = 259;
	  m_bx19len = 6;

	  m_bx20off = 265;
	  m_bx20len = 6;

	  m_bx21off = 271;
	  m_bx21len = 6;

	  m_vehspdoff = 277;
	  m_vehspdlen = 5;

	  m_crbangoff = 282;
	  m_crbanglen = 3;

	  m_pdofoff = 285;
	  m_pdoflen = 3;

	  m_bmpengoff = 288;
	  m_bmpenglen = 2;

	  m_silengoff = 290;
	  m_silenglen = 2;

	  m_aplengoff = 292;
	  m_aplenglen = 2;

	  m_dpd1off = 294;
	  m_dpd1len = 5;

	  m_dpd2off = 299;
	  m_dpd2len = 5;

	  m_dpd3off = 304;
	  m_dpd3len = 5;

	  m_dpd4off = 309;
	  m_dpd4len = 5;

	  m_dpd5off = 314;
	  m_dpd5len = 5;

	  m_dpd6off = 319;
	  m_dpd6len = 5;

	  m_vdioff = 324;
	  m_vdilen = 7;

	  m_lencntoff = 331;
	  m_lencntlen = 6;

	  m_damdstoff = 337;
	  m_damdstlen = 5;

	  m_crhdstoff = 342;
	  m_crhdstlen = 5;

	  m_ax1off = 347;
	  m_ax1len = 6;

	  m_ax2off = 353;
	  m_ax2len = 6;

	  m_ax3off = 359;
	  m_ax3len = 6;

	  m_ax4off = 365;
	  m_ax4len = 6;

	  m_ax5off = 371;
	  m_ax5len = 6;

	  m_ax6off = 377;
	  m_ax6len = 6;

	  m_ax7off = 383;
	  m_ax7len = 6;

	  m_ax8off = 389;
	  m_ax8len = 6;

	  m_ax9off = 395;
	  m_ax9len = 6;

	  m_ax10off = 401;
	  m_ax10len = 6;

	  m_ax11off = 407;
	  m_ax11len = 6;

	  m_ax12off = 413;
	  m_ax12len = 6;

	  m_ax13off = 419;
	  m_ax13len = 6;

	  m_ax14off = 425;
	  m_ax14len = 6;

	  m_ax15off = 431;
	  m_ax15len = 6;

	  m_ax16off = 437;
	  m_ax16len = 6;

	  m_ax17off = 443;
	  m_ax17len = 6;

	  m_ax18off = 449;
	  m_ax18len = 6;

	  m_ax19off = 455;
	  m_ax19len = 6;

	  m_ax20off = 461;
	  m_ax20len = 6;

	  m_ax21off = 467;
	  m_ax21len = 6;

	  m_carangoff = 473;
	  m_caranglen = 3;

	  m_vehoroff = 476;
	  m_vehorlen = 3;

	  m_vehcomoff = 479;
	  m_vehcomlen = 70;
	
	  m_totallen = 549;  
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
CVehGR2::~CVehGR2()
{
} 
