// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: VehGR4.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description: CVehGR4 constructor.  All this class does is
//              hold the offsets and lengths used for parsing data out of
//              a GR4 file.
// -----------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "VehGR4.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
CVehGR4::CVehGR4()
{
	m_vehnooff = 1;
	m_vehnolen = 1;

	m_occlocoff = 2;
	m_occloclen = 2;

	m_occtypoff = 4;
	m_occtyplen = 2;

	m_occageoff = 6;
	m_occagelen = 2;

	m_occsexoff = 8; 
	m_occsexlen = 1;

	m_occhtoff = 9;
	m_occhtlen = 3;

	m_occwtoff = 12;
	m_occwtlen = 3;

	m_mthcaloff = 15;
	m_mthcallen = 2;

	m_dumsizoff = 17;
	m_dumsizlen = 2;

	m_dummanoff = 19;
	m_dummanlen = 70;

	m_dummodoff = 89;
	m_dummodlen = 70;

	m_dumdscoff = 159;
	m_dumdsclen = 70;

	m_hhoff = 229;
	m_hhlen = 5;

	m_hwoff = 234;
	m_hwlen = 5;

	m_hroff = 239;
	m_hrlen = 5;

	m_hsoff = 244;
	m_hslen = 5;

	m_cdoff = 249;
	m_cdlen = 5;

	m_csoff = 254;
	m_cslen = 5;

	m_adoff = 259;
	m_adlen = 5;

	m_hdoff = 264;
	m_hdlen = 5;

	m_kdoff = 269;
	m_kdlen = 5;

	m_hboff = 274;
	m_hblen = 5;

	m_nboff = 279;
	m_nblen = 5;

	m_cboff = 284;
	m_cblen = 5;

	m_kboff = 289;
	m_kblen = 5;

	m_restr1off = 294;
	m_restr1len = 3;

	m_restr2off = 297;
	m_restr2len = 3;

	m_restxtoff = 300;
	m_restxtlen = 70;

	m_seposnoff = 370;
	m_seposnlen = 2;

	m_airdepoff = 372;
	m_airdeplen = 2;

	m_cntrh1off = 374;
	m_cntrh1len = 2;

	m_cntrh2off = 376;
	m_cntrh2len = 2;

	m_cntrc1off = 378;
	m_cntrc1len = 2;

	m_cntrc2off = 380;
	m_cntrc2len = 2;

	m_cntrl1off = 382;
	m_cntrl1len = 2;

	m_cntrl2off = 384;
	m_cntrl2len = 2;

	m_hicoff = 386;
	m_hiclen = 5;

	m_t1off = 391;
	m_t1len = 7;

	m_t2off = 398;
	m_t2len = 7;

	m_clip3moff = 405;
	m_clip3mlen = 5;

	m_lfemoff = 410;
	m_lfemlen = 5;

	m_rfemoff = 415;
	m_rfemlen = 5;

	m_csioff = 420;
	m_csilen = 5;

	m_lbeltoff = 425;
	m_lbeltlen = 5;

	m_sbeltoff = 430;
	m_sbeltlen = 5;

	m_occcomoff = 435;
	m_occcomlen = 70;

	m_totallen = 505;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
CVehGR4::~CVehGR4()
{

}
