// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: VehiclePropertySheet.cpp
//
// Author: Dan Robbins
//
// Date Created: October 1998
//
// Description:  CVehiclePropertySheet is the container for all
//               the Veh...Pages.  The member functions here
//               process menu selections.
// -----------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "entreeV5dlg.h"
#include "VehiclePropertySheet.h"

#include <winspool.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVehiclePropertySheet

IMPLEMENT_DYNAMIC(CVehiclePropertySheet, CPropertySheet)

/******************************************************************************
	Name:		
	Action:		
	Params:		
	Returns:	
	Notes:	
	Dates:
******************************************************************************/
CVehiclePropertySheet::CVehiclePropertySheet(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(nIDCaption, pParentWnd, iSelectPage),
	_bClearAll( false )
{
	m_VehTestPage.m_pVehData=&m_VehData;  // the data is available inside Test info dlg
	m_VehBarPage.m_pVehData=&m_VehData;   // the data is available inside Barrier info dlg
	m_VehOccPage.m_pVehData=&m_VehData;   // the data is available inside Occupant info dlg
	m_VehRestPage.m_pVehData=&m_VehData;  // the data is available inside Restraint info dlg
	m_VehVehPage.m_pVehData=&m_VehData;   // the data is available inside Vehicle info dlg
	m_VehInstPage.m_pVehData=&m_VehData;  // the data is available inside Inst info dlg
	m_HsvdPage.m_pVehHsvdData=&m_VehData;
	m_VehIntrPage.m_pVehData = &m_VehData;
	m_HsvdPage.m_cVersion = 'V';

	AddPage(&m_VehTestPage);
	AddPage(&m_VehVehPage);
	AddPage(&m_VehOccPage);
	AddPage(&m_VehRestPage);
	AddPage(&m_VehBarPage);
	AddPage(&m_VehInstPage);
	AddPage(&m_HsvdPage);
	AddPage(&m_VehIntrPage);	

	m_pParent = (CChooseDB *) pParentWnd;

	m_bValidate = false;
}

/******************************************************************************
	Name:		
	Action:		
	Params:		
	Returns:	
	Notes:	
	Dates:
******************************************************************************/
CVehiclePropertySheet::CVehiclePropertySheet(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage),
	_bClearAll( false )
{
	m_VehTestPage.m_pVehData=&m_VehData;  // the data is available inside Test info dlg
	m_VehBarPage.m_pVehData=&m_VehData;   // the data is available inside Barrier info dlg
	m_VehOccPage.m_pVehData=&m_VehData;   // the data is available inside Occupant info dlg
	m_VehRestPage.m_pVehData=&m_VehData;  // the data is available inside Restraint info dlg
	m_VehVehPage.m_pVehData=&m_VehData;   // the data is available inside Vehicle info dlg
	m_VehInstPage.m_pVehData=&m_VehData;  // the data is available inside Inst info dlg
	m_HsvdPage.m_pVehHsvdData=&m_VehData;
	m_VehIntrPage.m_pVehData = &m_VehData;
	m_HsvdPage.m_cVersion = 'V';

    AddPage(&m_VehTestPage);
	AddPage(&m_VehVehPage);
	AddPage(&m_VehOccPage);
	AddPage(&m_VehRestPage);
	AddPage(&m_VehBarPage);
	AddPage(&m_VehInstPage);
	AddPage(&m_HsvdPage);
	AddPage(&m_VehIntrPage);

	m_pParent = (CChooseDB *) pParentWnd;

	m_bValidate = false;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
CVehiclePropertySheet::~CVehiclePropertySheet()
{
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BEGIN_MESSAGE_MAP(CVehiclePropertySheet, CPropertySheet)
	//{{AFX_MSG_MAP(CVehiclePropertySheet)
	ON_COMMAND(ID_BIOMECHDB, OnBiomechdb)
	ON_COMMAND(ID_COMPONENTDB, OnComponentdb)
	ON_COMMAND(ID_SWGDB, OnSwgdb)
	ON_COMMAND(ID_CLEARALL, OnClearall)
	ON_COMMAND(ID_IMPORT_TEST, OnImportTest)
	ON_COMMAND(ID_FILE_LOAD_HSVD, OnImportHsvdData)
	ON_COMMAND(ID_FILE_SAVE_HSVD, OnExportHsvdData)
	ON_COMMAND(ID_FILE_SAVE_HSVD_REPORT, OnExportHsvdReport)
	ON_COMMAND(ID_FILE_LOAD_INTRUSION, OnImportIntrusionData)
	ON_COMMAND(ID_FILE_SAVE_INTRUSION, OnExportIntrusionData)
	ON_COMMAND(ID_FILE_SAVE_INTRUSION_REPORT, OnExportIntrusionReport)
	ON_COMMAND(ID_FILE_PRINT, OnFilePrint)
	ON_COMMAND(ID_EXIT, OnExit)
	ON_COMMAND(ID_EXPORT_REPORT, OnExportReport)
	ON_WM_CLOSE()
	ON_COMMAND(ID_HELP_ABOUT, OnHelpAbout)
	ON_COMMAND(ID_HELP_INDEX, OnHelpIndex)
	ON_COMMAND(ID_EXPORT_TEST, OnExportTest)
	ON_WM_INITMENUPOPUP()
	ON_WM_SYSCOMMAND()
	ON_COMMAND(ID_HELP, OnHelpFinder)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVehiclePropertySheet message handlers

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehiclePropertySheet::OnInitDialog() 
{
	m_bValidPage = false;

	BOOL bResult = CPropertySheet::OnInitDialog();

	
	
	// modify propertysheet appearance.
	//Load Menu
	CMenu MyMenu; 
	CMenu* pMenu=&MyMenu; 
	pMenu->LoadMenu(IDR_PROPSHEET_MENU);
	// resize, buttons get cut off if you dont, because of menu.
    CRect rect; 
	GetWindowRect(&rect);
    
	SetMenu(pMenu);

    MyMenu.CheckMenuItem (ID_VEHICLEDB, MF_CHECKED);
	MyMenu.Detach ();  // MyMenu wont be deleted after this function.

	SetWindowPos(&wndTop, rect.left,rect.top, rect.Width() +15, rect.Height()+75, SWP_NOZORDER);
	
	HICON hICN = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	SetIcon(hICN,FALSE);
	
	CenterWindow();

	m_bValidPage = true;

	return bResult;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehiclePropertySheet::OnBiomechdb() 
{
	if (MessageBox("Exit Vehicle Data Screens?",NULL,MB_YESNO)==IDYES)
	{
		CPropertySheet::OnClose();
		m_pParent->OnBiomechButton ();	
	}
	
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehiclePropertySheet::OnComponentdb() 
{
	if (MessageBox("Exit Vehicle Data Screens?",NULL,MB_YESNO)==IDYES)
	{
		CPropertySheet::OnClose();
		m_pParent->OnComponentButton ();	
	}
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehiclePropertySheet::OnSwgdb() 
{
	if (MessageBox("Exit Vehicle Data Screens?",NULL,MB_YESNO)==IDYES)
	{
		CPropertySheet::OnClose();
		m_pParent->OnSwgButton ();	
	}
}

/******************************************************************************

	Name:		OnClearall

	Action:		This function is long.  Clear all edit boxes.  Clear all data
				from all arrays in m_VehData.  Then, reinitialize both with
				defaults.

	Params:		void

	Returns:	BOOL

	Notes:	

	Dates:		Modify -- Al Wilhelm -- 03/09/2000

******************************************************************************/
void CVehiclePropertySheet::OnClearall( void ) 
{
	if( AfxMessageBox( "Really clear all entries?", MB_YESNO ) == IDNO )
	{
		this->_bClearAll = false;
		return;	// was returning FALSE;
	}
		
	m_VehData.m_title	= _T("");
	m_VehData.m_tstobj	= _T("");
	m_VehData.m_tstdat	= _T("");
	m_VehData.m_tstprf	= _T("");
	m_VehData.m_conno	= _T("");
	m_VehData.m_tsttyp	= _T("");
	m_VehData.m_tstref	= _T("");
	m_VehData.m_tstcfn	= _T("VTB");
	m_VehData.m_tksurf	= _T("");
	m_VehData.m_tkcond	= _T("");
	m_VehData.m_temp	= _T("");
	m_VehData.m_rectyp	= _T("");
	m_VehData.m_link	= _T("");
	m_VehData.m_clsspd	= _T("");
    m_VehData.m_impang	= _T("");
	m_VehData.m_offset	= _T("");
	m_VehData.m_imppnt	= _T("");
	m_VehData.m_totcrv	= 0;
	m_VehData.m_tstcom	= _T("");

	m_VehData.m_vehno	= 1;

	m_VehData.m_make.RemoveAll();
	m_VehData.m_model.RemoveAll();
	m_VehData.m_year.RemoveAll();
	m_VehData.m_nhtsano.RemoveAll();
	m_VehData.m_body.RemoveAll();
	m_VehData.m_vin.RemoveAll();
	m_VehData.m_engine.RemoveAll();
	m_VehData.m_engdsp.RemoveAll();
	m_VehData.m_transm.RemoveAll();
	m_VehData.m_vehtwt.RemoveAll();
	m_VehData.m_whlbas.RemoveAll();
	m_VehData.m_vehlen.RemoveAll();
	m_VehData.m_vehwid.RemoveAll();
	m_VehData.m_vehcg.RemoveAll();
	m_VehData.m_strsep.RemoveAll();
	m_VehData.m_colmec.RemoveAll();
	m_VehData.m_modind.RemoveAll();
	m_VehData.m_moddsc.RemoveAll();
	m_VehData.m_bx1.RemoveAll();
	m_VehData.m_bx2.RemoveAll();
	m_VehData.m_bx3.RemoveAll();
	m_VehData.m_bx4.RemoveAll();
	m_VehData.m_bx5.RemoveAll();
	m_VehData.m_bx6.RemoveAll();
	m_VehData.m_bx7.RemoveAll();
	m_VehData.m_bx8.RemoveAll();
	m_VehData.m_bx9.RemoveAll();
	m_VehData.m_bx10.RemoveAll();
	m_VehData.m_bx11.RemoveAll();
	m_VehData.m_bx12.RemoveAll();
	m_VehData.m_bx13.RemoveAll();
	m_VehData.m_bx14.RemoveAll();
	m_VehData.m_bx15.RemoveAll();
	m_VehData.m_bx16.RemoveAll();
	m_VehData.m_bx17.RemoveAll();
	m_VehData.m_bx18.RemoveAll();
	m_VehData.m_bx19.RemoveAll();
	m_VehData.m_bx20.RemoveAll();
	m_VehData.m_bx21.RemoveAll();
	m_VehData.m_vehspd.RemoveAll();
	m_VehData.m_crbang.RemoveAll();
	m_VehData.m_pdof.RemoveAll();
	m_VehData.m_bmpeng.RemoveAll();
	m_VehData.m_sileng.RemoveAll();
	m_VehData.m_apleng.RemoveAll();
	m_VehData.m_dpd1.RemoveAll();
	m_VehData.m_dpd2.RemoveAll();
	m_VehData.m_dpd3.RemoveAll();
	m_VehData.m_dpd4.RemoveAll();
	m_VehData.m_dpd5.RemoveAll();
	m_VehData.m_dpd6.RemoveAll();
	m_VehData.m_vdi.RemoveAll();
	m_VehData.m_lencnt.RemoveAll();
	m_VehData.m_damdst.RemoveAll();
	m_VehData.m_crhdst.RemoveAll();
	m_VehData.m_ax1.RemoveAll();
	m_VehData.m_ax2.RemoveAll();
	m_VehData.m_ax3.RemoveAll();
	m_VehData.m_ax4.RemoveAll();
	m_VehData.m_ax5.RemoveAll();
	m_VehData.m_ax6.RemoveAll();
	m_VehData.m_ax7.RemoveAll();
	m_VehData.m_ax8.RemoveAll();
	m_VehData.m_ax9.RemoveAll();
	m_VehData.m_ax10.RemoveAll();
	m_VehData.m_ax11.RemoveAll();
	m_VehData.m_ax12.RemoveAll();
	m_VehData.m_ax13.RemoveAll();
	m_VehData.m_ax14.RemoveAll();
	m_VehData.m_ax15.RemoveAll();
	m_VehData.m_ax16.RemoveAll();
	m_VehData.m_ax17.RemoveAll();
	m_VehData.m_ax18.RemoveAll();
	m_VehData.m_ax19.RemoveAll();
	m_VehData.m_ax20.RemoveAll();
	m_VehData.m_ax21.RemoveAll();
	m_VehData.m_carang.RemoveAll();
	m_VehData.m_vehor.RemoveAll();
	m_VehData.m_vehcom.RemoveAll();


	// CVehBarPage -- BEGIN
	m_VehData.m_cstrbarrig = _T("");
	m_VehData.m_cstrbarshp = _T("");
	m_VehData.m_cstrbarang = _T("");
	m_VehData.m_cstrbardia = _T("");
	m_VehData.m_cstrbarcom = _T("");
	// CVehBarPage -- END


	m_VehData.m_occsets = 0;
	m_VehData.m_Occ_vehno.RemoveAll();
	m_VehData.m_occloc.RemoveAll();
	m_VehData.m_occtyp.RemoveAll();
	m_VehData.m_occage.RemoveAll();
	m_VehData.m_occsex.RemoveAll();
	m_VehData.m_occht.RemoveAll();
	m_VehData.m_occwt.RemoveAll();
	m_VehData.m_mthcal.RemoveAll();
	m_VehData.m_dumsiz.RemoveAll();
	m_VehData.m_dumman.RemoveAll();
	m_VehData.m_dummod.RemoveAll();
	m_VehData.m_dumdsc.RemoveAll();
	m_VehData.m_hh.RemoveAll();
	m_VehData.m_hw.RemoveAll();
	m_VehData.m_hr.RemoveAll();
	m_VehData.m_hs.RemoveAll();
	m_VehData.m_cd.RemoveAll();
	m_VehData.m_cs.RemoveAll();
	m_VehData.m_ad.RemoveAll();
	m_VehData.m_hd.RemoveAll();
	m_VehData.m_kd.RemoveAll();
	m_VehData.m_hb.RemoveAll();
	m_VehData.m_nb.RemoveAll();
	m_VehData.m_cb.RemoveAll();
	m_VehData.m_kb.RemoveAll();
	m_VehData.m_seposn.RemoveAll();
	m_VehData.m_cntrh1.RemoveAll();
	m_VehData.m_cntrh2.RemoveAll();
	m_VehData.m_cntrc1.RemoveAll();
	m_VehData.m_cntrc2.RemoveAll();
	m_VehData.m_cntrl1.RemoveAll();
	m_VehData.m_cntrl2.RemoveAll();
	m_VehData.m_hic.RemoveAll();
	m_VehData.m_t1.RemoveAll();
	m_VehData.m_t2.RemoveAll();
	m_VehData.m_clip3m.RemoveAll();
	m_VehData.m_lfem.RemoveAll();
	m_VehData.m_rfem.RemoveAll();
	m_VehData.m_csi.RemoveAll();
	m_VehData.m_lbelt.RemoveAll();
	m_VehData.m_sbelt.RemoveAll();
	m_VehData.m_tti.RemoveAll();
	m_VehData.m_pelvg.RemoveAll();
	m_VehData.m_occcom.RemoveAll();
	m_VehData.m_restsets = 0;
	m_VehData.m_Rest_vehno.RemoveAll();
	m_VehData.m_Rest_occloc.RemoveAll();
	m_VehData.m_rstno.RemoveAll();
	m_VehData.m_rsttyp.RemoveAll();
	m_VehData.m_rstmnt.RemoveAll();
	m_VehData.m_deploy.RemoveAll();
	m_VehData.m_rstcom.RemoveAll();
	m_VehData.m_Inst_vehno.RemoveAll();
	m_VehData.m_curno=0;   
	m_VehData.m_senloc.RemoveAll();
	m_VehData.m_sentyp.RemoveAll();
	m_VehData.m_senatt.RemoveAll();
	m_VehData.m_axis.RemoveAll();
	m_VehData.m_xunits.RemoveAll();
	m_VehData.m_yunits.RemoveAll();
	m_VehData.m_prefil.RemoveAll();
	m_VehData.m_insman.RemoveAll();
	m_VehData.m_caldat.RemoveAll();
	m_VehData.m_insrat.RemoveAll();
	m_VehData.m_chlmax.RemoveAll();
	m_VehData.m_inivel.RemoveAll();
	m_VehData.m_nfp.RemoveAll();
	m_VehData.m_nlp.RemoveAll();
	m_VehData.m_delt.RemoveAll();
	m_VehData.m_dastat.RemoveAll();
	m_VehData.m_chstat.RemoveAll();
	m_VehData.m_inscom.RemoveAll();
	// Reinitialize VehData Arrays**********************************
	m_VehData.m_make.SetAtGrow(0,"");m_VehData.m_make.SetAtGrow(1,"");m_VehData.m_make.SetAtGrow(2,"");
	m_VehData.m_model.SetAtGrow(0,"");m_VehData.m_model.SetAtGrow(1,"");m_VehData.m_model.SetAtGrow(2,"");

	m_VehData.m_year.SetAtGrow( 0, "1999" );
	m_VehData.m_year.SetAtGrow( 1, "1999" );
	m_VehData.m_year.SetAtGrow( 2, "1999" );

	m_VehData.m_nhtsano.SetAtGrow(0,"");m_VehData.m_nhtsano.SetAtGrow(1,"");m_VehData.m_nhtsano.SetAtGrow(2,"");
	m_VehData.m_body.SetAtGrow(0,"");m_VehData.m_body.SetAtGrow(1,"");m_VehData.m_body.SetAtGrow(2,"");
	m_VehData.m_vin.SetAtGrow(0,"");m_VehData.m_vin.SetAtGrow(1,"");m_VehData.m_vin.SetAtGrow(2,"");
	m_VehData.m_engine.SetAtGrow(0,"");m_VehData.m_engine.SetAtGrow(1,"");m_VehData.m_engine.SetAtGrow(2,"");

	m_VehData.m_engdsp.SetAtGrow( 0, "" );
	m_VehData.m_engdsp.SetAtGrow( 1, "" );
	m_VehData.m_engdsp.SetAtGrow( 2, "" );

	m_VehData.m_transm.SetAtGrow(0,"");m_VehData.m_transm.SetAtGrow(1,"");m_VehData.m_transm.SetAtGrow(2,"");
	m_VehData.m_vehtwt.SetAtGrow( 0, "" );m_VehData.m_vehtwt.SetAtGrow( 1, "" );m_VehData.m_vehtwt.SetAtGrow( 2, "" );
	m_VehData.m_whlbas.SetAtGrow( 0, "" );m_VehData.m_whlbas.SetAtGrow( 1, "" );m_VehData.m_whlbas.SetAtGrow( 2, "" );
	m_VehData.m_vehlen.SetAtGrow( 0, "" );m_VehData.m_vehlen.SetAtGrow( 1, "" );m_VehData.m_vehlen.SetAtGrow( 2, "" );
	m_VehData.m_vehwid.SetAtGrow( 0, "" );m_VehData.m_vehwid.SetAtGrow( 1, "" );m_VehData.m_vehwid.SetAtGrow( 2, "" );
	m_VehData.m_vehcg.SetAtGrow( 0, "" );m_VehData.m_vehcg.SetAtGrow( 1, "" );m_VehData.m_vehcg.SetAtGrow( 2, "" );
	m_VehData.m_strsep.SetAtGrow(0,"");m_VehData.m_strsep.SetAtGrow(1,"");m_VehData.m_strsep.SetAtGrow(2,"");
	m_VehData.m_colmec.SetAtGrow(0,"");m_VehData.m_colmec.SetAtGrow(1,"");m_VehData.m_colmec.SetAtGrow(2,"");
	m_VehData.m_modind.SetAtGrow(0,"");m_VehData.m_modind.SetAtGrow(1,"");m_VehData.m_modind.SetAtGrow(2,"");
	m_VehData.m_moddsc.SetAtGrow(0,"");m_VehData.m_moddsc.SetAtGrow(1,"");m_VehData.m_moddsc.SetAtGrow(2,"");
	m_VehData.m_bx1.SetAtGrow( 0, "" );m_VehData.m_bx1.SetAtGrow( 1, "" );m_VehData.m_bx1.SetAtGrow( 2, "" );
	m_VehData.m_bx2.SetAtGrow( 0, "" );m_VehData.m_bx2.SetAtGrow( 1, "" );m_VehData.m_bx2.SetAtGrow( 2, "" );
	m_VehData.m_bx3.SetAtGrow( 0, "" );m_VehData.m_bx3.SetAtGrow( 1, "" );m_VehData.m_bx3.SetAtGrow( 2, "" );
	m_VehData.m_bx4.SetAtGrow( 0, "" );m_VehData.m_bx4.SetAtGrow( 1, "" );m_VehData.m_bx4.SetAtGrow( 2, "" );
	m_VehData.m_bx5.SetAtGrow( 0, "" );m_VehData.m_bx5.SetAtGrow( 1, "" );m_VehData.m_bx5.SetAtGrow( 2, "" );
	m_VehData.m_bx6.SetAtGrow( 0, "" );m_VehData.m_bx6.SetAtGrow( 1, "" );m_VehData.m_bx6.SetAtGrow( 2, "" );
	m_VehData.m_bx7.SetAtGrow( 0, "" );m_VehData.m_bx7.SetAtGrow( 1, "" );m_VehData.m_bx7.SetAtGrow( 2, "" );
	m_VehData.m_bx8.SetAtGrow( 0, "" );m_VehData.m_bx8.SetAtGrow( 1, "" );m_VehData.m_bx8.SetAtGrow( 2, "" );
	m_VehData.m_bx9.SetAtGrow( 0, "" );m_VehData.m_bx9.SetAtGrow( 1, "" );m_VehData.m_bx9.SetAtGrow( 2, "" );
	m_VehData.m_bx10.SetAtGrow( 0, "" );m_VehData.m_bx10.SetAtGrow( 1, "" );m_VehData.m_bx10.SetAtGrow( 2, "" );
	m_VehData.m_bx11.SetAtGrow( 0, "" );m_VehData.m_bx11.SetAtGrow( 1, "" );m_VehData.m_bx11.SetAtGrow( 2, "" );
	m_VehData.m_bx12.SetAtGrow( 0, "" );m_VehData.m_bx12.SetAtGrow( 1, "" );m_VehData.m_bx12.SetAtGrow( 2, "" );
	m_VehData.m_bx13.SetAtGrow( 0, "" );m_VehData.m_bx13.SetAtGrow( 1, "" );m_VehData.m_bx13.SetAtGrow( 2, "" );
	m_VehData.m_bx14.SetAtGrow( 0, "" );m_VehData.m_bx14.SetAtGrow( 1, "" );m_VehData.m_bx14.SetAtGrow( 2, "" );
	m_VehData.m_bx15.SetAtGrow( 0, "" );m_VehData.m_bx15.SetAtGrow( 1, "" );m_VehData.m_bx15.SetAtGrow( 2, "" );
	m_VehData.m_bx16.SetAtGrow( 0, "" );m_VehData.m_bx16.SetAtGrow( 1, "" );m_VehData.m_bx16.SetAtGrow( 2, "" );
	m_VehData.m_bx17.SetAtGrow( 0, "" );m_VehData.m_bx17.SetAtGrow( 1, "" );m_VehData.m_bx17.SetAtGrow( 2, "" );
	m_VehData.m_bx18.SetAtGrow( 0, "" );m_VehData.m_bx18.SetAtGrow( 1, "" );m_VehData.m_bx18.SetAtGrow( 2, "" );
	m_VehData.m_bx19.SetAtGrow( 0, "" );m_VehData.m_bx19.SetAtGrow( 1, "" );m_VehData.m_bx19.SetAtGrow( 2, "" );
	m_VehData.m_bx20.SetAtGrow( 0, "" );m_VehData.m_bx20.SetAtGrow( 1, "" );m_VehData.m_bx20.SetAtGrow( 2, "" );
	m_VehData.m_bx21.SetAtGrow( 0, "" );m_VehData.m_bx21.SetAtGrow( 1, "" );m_VehData.m_bx21.SetAtGrow( 2, "" );

	m_VehData.m_vehspd.SetAtGrow( 0, "" );
	m_VehData.m_vehspd.SetAtGrow( 1, "" );
	m_VehData.m_vehspd.SetAtGrow( 2, "" );

	m_VehData.m_crbang.SetAtGrow( 0, "" );m_VehData.m_crbang.SetAtGrow( 1, "" );m_VehData.m_crbang.SetAtGrow( 2, "" );
	m_VehData.m_pdof.SetAtGrow( 0, "" );m_VehData.m_pdof.SetAtGrow( 1, "" );m_VehData.m_pdof.SetAtGrow( 2, "" );
	m_VehData.m_bmpeng.SetAtGrow(0,"");m_VehData.m_bmpeng.SetAtGrow(1,"");m_VehData.m_bmpeng.SetAtGrow(2,"");
	m_VehData.m_sileng.SetAtGrow(0,"");m_VehData.m_sileng.SetAtGrow(1,"");m_VehData.m_sileng.SetAtGrow(2,"");
	m_VehData.m_apleng.SetAtGrow(0,"");m_VehData.m_apleng.SetAtGrow(1,"");m_VehData.m_apleng.SetAtGrow(2,"");

	m_VehData.m_dpd1.SetAtGrow( 0, "" );
	m_VehData.m_dpd1.SetAtGrow( 1, "" );
	m_VehData.m_dpd1.SetAtGrow( 2, "" );

	m_VehData.m_dpd2.SetAtGrow( 0, "" );
	m_VehData.m_dpd2.SetAtGrow( 1, "" );
	m_VehData.m_dpd2.SetAtGrow( 2, "" );

	m_VehData.m_dpd3.SetAtGrow( 0, "" );
	m_VehData.m_dpd3.SetAtGrow( 1, "" );
	m_VehData.m_dpd3.SetAtGrow( 2, "" );

	m_VehData.m_dpd4.SetAtGrow( 0, "" );
	m_VehData.m_dpd4.SetAtGrow( 1, "" );
	m_VehData.m_dpd4.SetAtGrow( 2, "" );

	m_VehData.m_dpd5.SetAtGrow( 0, "" );
	m_VehData.m_dpd5.SetAtGrow( 1, "" );
	m_VehData.m_dpd5.SetAtGrow( 2, "" );

	m_VehData.m_dpd6.SetAtGrow( 0, "" );
	m_VehData.m_dpd6.SetAtGrow( 1, "" );
	m_VehData.m_dpd6.SetAtGrow( 2, "" );

	m_VehData.m_vdi.SetAtGrow(0,"");m_VehData.m_vdi.SetAtGrow(1,"");m_VehData.m_vdi.SetAtGrow(2,"");
	m_VehData.m_lencnt.SetAtGrow( 0, "" );m_VehData.m_lencnt.SetAtGrow( 1, "" );m_VehData.m_lencnt.SetAtGrow( 2, "" );

	m_VehData.m_damdst.SetAtGrow( 0, "" );
	m_VehData.m_damdst.SetAtGrow( 1, "" );
	m_VehData.m_damdst.SetAtGrow( 2, "" );

	m_VehData.m_crhdst.SetAtGrow( 0, "" );m_VehData.m_crhdst.SetAtGrow( 1, "" );m_VehData.m_crhdst.SetAtGrow( 2, "" );
	m_VehData.m_ax1.SetAtGrow( 0, "" );m_VehData.m_ax1.SetAtGrow( 1, "" );m_VehData.m_ax1.SetAtGrow( 2, "" );
	m_VehData.m_ax2.SetAtGrow( 0, "" );m_VehData.m_ax2.SetAtGrow( 1, "" );m_VehData.m_ax2.SetAtGrow( 2, "" );
	m_VehData.m_ax3.SetAtGrow( 0, "" );m_VehData.m_ax3.SetAtGrow( 1, "" );m_VehData.m_ax3.SetAtGrow( 2, "" );
	m_VehData.m_ax4.SetAtGrow( 0, "" );m_VehData.m_ax4.SetAtGrow( 1, "" );m_VehData.m_ax4.SetAtGrow( 2, "" );
	m_VehData.m_ax5.SetAtGrow( 0, "" );m_VehData.m_ax5.SetAtGrow( 1, "" );m_VehData.m_ax5.SetAtGrow( 2, "" );
	m_VehData.m_ax6.SetAtGrow( 0, "" );m_VehData.m_ax6.SetAtGrow( 1, "" );m_VehData.m_ax6.SetAtGrow( 2, "" );
	m_VehData.m_ax7.SetAtGrow( 0, "" );m_VehData.m_ax7.SetAtGrow( 1, "" );m_VehData.m_ax7.SetAtGrow( 2, "" );
	m_VehData.m_ax8.SetAtGrow( 0, "" );m_VehData.m_ax8.SetAtGrow( 1, "" );m_VehData.m_ax8.SetAtGrow( 2, "" );
	m_VehData.m_ax9.SetAtGrow( 0, "" );m_VehData.m_ax9.SetAtGrow( 1, "" );m_VehData.m_ax9.SetAtGrow( 2, "" );
	m_VehData.m_ax10.SetAtGrow( 0, "" );m_VehData.m_ax10.SetAtGrow( 1, "" );m_VehData.m_ax10.SetAtGrow( 2, "" );
	m_VehData.m_ax11.SetAtGrow( 0, "" );m_VehData.m_ax11.SetAtGrow( 1, "" );m_VehData.m_ax11.SetAtGrow( 2, "" );
	m_VehData.m_ax12.SetAtGrow( 0, "" );m_VehData.m_ax12.SetAtGrow( 1, "" );m_VehData.m_ax12.SetAtGrow( 2, "" );
	m_VehData.m_ax13.SetAtGrow( 0, "" );m_VehData.m_ax13.SetAtGrow( 1, "" );m_VehData.m_ax13.SetAtGrow( 2, "" );
	m_VehData.m_ax14.SetAtGrow( 0, "" );m_VehData.m_ax14.SetAtGrow( 1, "" );m_VehData.m_ax14.SetAtGrow( 2, "" );
	m_VehData.m_ax15.SetAtGrow( 0, "" );m_VehData.m_ax15.SetAtGrow( 1, "" );m_VehData.m_ax15.SetAtGrow( 2, "" );
	m_VehData.m_ax16.SetAtGrow( 0, "" );m_VehData.m_ax16.SetAtGrow( 1, "" );m_VehData.m_ax16.SetAtGrow( 2, "" );
	m_VehData.m_ax17.SetAtGrow( 0, "" );m_VehData.m_ax17.SetAtGrow( 1, "" );m_VehData.m_ax17.SetAtGrow( 2, "" );
	m_VehData.m_ax18.SetAtGrow( 0, "" );m_VehData.m_ax18.SetAtGrow( 1, "" );m_VehData.m_ax18.SetAtGrow( 2, "" );
	m_VehData.m_ax19.SetAtGrow( 0, "" );m_VehData.m_ax19.SetAtGrow( 1, "" );m_VehData.m_ax19.SetAtGrow( 2, "" );
	m_VehData.m_ax20.SetAtGrow( 0, "" );m_VehData.m_ax20.SetAtGrow( 1, "" );m_VehData.m_ax20.SetAtGrow( 2, "" );
	m_VehData.m_ax21.SetAtGrow( 0, "" );m_VehData.m_ax21.SetAtGrow( 1, "" );m_VehData.m_ax21.SetAtGrow( 2, "" );
	m_VehData.m_carang.SetAtGrow( 0, "" );m_VehData.m_carang.SetAtGrow( 1, "" );m_VehData.m_carang.SetAtGrow( 2, "" );
	m_VehData.m_vehor.SetAtGrow( 0, "" );m_VehData.m_vehor.SetAtGrow( 1, "" );m_VehData.m_vehor.SetAtGrow( 2, "" );
	m_VehData.m_vehcom.SetAtGrow(0,"");m_VehData.m_vehcom.SetAtGrow(1,"");m_VehData.m_vehcom.SetAtGrow(2,"");
	m_VehData.m_Occ_vehno.SetAtGrow( 0, "1" );
	m_VehData.m_Occ_vehno.SetAtGrow( 1, "1" );
	m_VehData.m_occloc.SetAtGrow(0,"");m_VehData.m_occloc.SetAtGrow(1,"");
	m_VehData.m_occtyp.SetAtGrow(0,"");m_VehData.m_occtyp.SetAtGrow(1,"");

	m_VehData.m_occage.SetAtGrow( 0, "" );
	m_VehData.m_occage.SetAtGrow( 1, "" );

	m_VehData.m_occsex.SetAtGrow(0,"");m_VehData.m_occsex.SetAtGrow(1,"");
	m_VehData.m_occht.SetAtGrow( 0, "" );m_VehData.m_occht.SetAtGrow( 1, "" );
	m_VehData.m_occwt.SetAtGrow( 0, "" );m_VehData.m_occwt.SetAtGrow( 1, "" );
	m_VehData.m_mthcal.SetAtGrow(0,"");m_VehData.m_mthcal.SetAtGrow(1,"");
	m_VehData.m_dumsiz.SetAtGrow(0,"");m_VehData.m_dumsiz.SetAtGrow(1,"");
	m_VehData.m_dumman.SetAtGrow(0,"");m_VehData.m_dumman.SetAtGrow(1,"");
	m_VehData.m_dummod.SetAtGrow(0,"");m_VehData.m_dummod.SetAtGrow(1,"");
	m_VehData.m_dumdsc.SetAtGrow(0,"");m_VehData.m_dumdsc.SetAtGrow(1,"");
	m_VehData.m_hh.SetAtGrow( 0, "" );m_VehData.m_hh.SetAtGrow( 1, "" );
	m_VehData.m_hw.SetAtGrow( 0, "" );m_VehData.m_hw.SetAtGrow( 1, "" );
	m_VehData.m_hr.SetAtGrow( 0, "" );m_VehData.m_hr.SetAtGrow( 1, "" );
	m_VehData.m_hs.SetAtGrow( 0, "" );m_VehData.m_hs.SetAtGrow( 1, "" );
	m_VehData.m_cd.SetAtGrow( 0, "" );m_VehData.m_cd.SetAtGrow( 1, "" );
	m_VehData.m_cs.SetAtGrow( 0, "" );m_VehData.m_cs.SetAtGrow( 1, "" );
	m_VehData.m_ad.SetAtGrow( 0, "" );m_VehData.m_ad.SetAtGrow( 1, "" );
	m_VehData.m_hd.SetAtGrow( 0, "" );m_VehData.m_hd.SetAtGrow( 1, "" );
	m_VehData.m_kd.SetAtGrow( 0, "" );m_VehData.m_kd.SetAtGrow( 1, "" );
	m_VehData.m_hb.SetAtGrow( 0, "" );m_VehData.m_hb.SetAtGrow( 1, "" );
	m_VehData.m_nb.SetAtGrow( 0, "" );m_VehData.m_nb.SetAtGrow( 1, "" );
	m_VehData.m_cb.SetAtGrow( 0, "" );m_VehData.m_cb.SetAtGrow( 1, "" );
	m_VehData.m_kb.SetAtGrow( 0, "" );m_VehData.m_kb.SetAtGrow( 1, "" );
	m_VehData.m_seposn.SetAtGrow(0,"");m_VehData.m_seposn.SetAtGrow(1,"");
	m_VehData.m_cntrh1.SetAtGrow(0,"");m_VehData.m_cntrh1.SetAtGrow(1,"");
	m_VehData.m_cntrh2.SetAtGrow(0,"");m_VehData.m_cntrh2.SetAtGrow(1,"");
	m_VehData.m_cntrc1.SetAtGrow(0,"");m_VehData.m_cntrc1.SetAtGrow(1,"");
	m_VehData.m_cntrc2.SetAtGrow(0,"");m_VehData.m_cntrc2.SetAtGrow(1,"");
	m_VehData.m_cntrl1.SetAtGrow(0,"");m_VehData.m_cntrl1.SetAtGrow(1,"");
	m_VehData.m_cntrl2.SetAtGrow(0,"");m_VehData.m_cntrl2.SetAtGrow(1,"");
	m_VehData.m_hic.SetAtGrow( 0, "" );m_VehData.m_hic.SetAtGrow( 1, "" );

	m_VehData.m_t1.SetAtGrow( 0, "" );
	m_VehData.m_t1.SetAtGrow( 1, "" );

	m_VehData.m_t2.SetAtGrow( 0, "" );
	m_VehData.m_t2.SetAtGrow( 1, "" );

	m_VehData.m_clip3m.SetAtGrow( 0, "" );
	m_VehData.m_clip3m.SetAtGrow( 1, "" );

	m_VehData.m_lfem.SetAtGrow( 0, "" );
	m_VehData.m_lfem.SetAtGrow( 1, "" );

	m_VehData.m_rfem.SetAtGrow( 0, "" );
	m_VehData.m_rfem.SetAtGrow( 1, "" );

	m_VehData.m_csi.SetAtGrow( 0, "" );m_VehData.m_csi.SetAtGrow( 1, "" );
	m_VehData.m_lbelt.SetAtGrow( 0, "" );m_VehData.m_lbelt.SetAtGrow( 1, "" );
	m_VehData.m_sbelt.SetAtGrow( 0, "" );m_VehData.m_sbelt.SetAtGrow( 1, "" );

	m_VehData.m_tti.SetAtGrow( 0, "" );
	m_VehData.m_tti.SetAtGrow( 1, "" );

	m_VehData.m_pelvg.SetAtGrow( 0, "" );
	m_VehData.m_pelvg.SetAtGrow( 1, "" );

	m_VehData.m_occcom.SetAtGrow(0,"");
	m_VehData.m_occcom.SetAtGrow(1,"");

	m_VehData.m_Rest_vehno.SetAtGrow(0,"1" );
	m_VehData.m_Rest_vehno.SetAtGrow( 1, "1" );

	m_VehData.m_Rest_occloc.SetAtGrow(0,"");m_VehData.m_Rest_occloc.SetAtGrow(1,"");
	m_VehData.m_rstno.SetAtGrow( 0, "" );m_VehData.m_rstno.SetAtGrow( 1, "" );
	m_VehData.m_rsttyp.SetAtGrow(0,"");m_VehData.m_rsttyp.SetAtGrow(1,"");
	m_VehData.m_rstmnt.SetAtGrow(0,"");m_VehData.m_rstmnt.SetAtGrow(1,"");
	m_VehData.m_deploy.SetAtGrow(0,"");m_VehData.m_deploy.SetAtGrow(1,"");
	m_VehData.m_rstcom.SetAtGrow(0,"");m_VehData.m_rstcom.SetAtGrow(1,"");
	m_VehData.m_Inst_vehno.SetAtGrow( 0, "1" );m_VehData.m_Inst_vehno.SetAtGrow( 1,"1" );
	m_VehData.m_senloc.SetAtGrow(0,"");m_VehData.m_senloc.SetAtGrow(1,"");
	m_VehData.m_sentyp.SetAtGrow(0,"");m_VehData.m_sentyp.SetAtGrow(1,"");
	m_VehData.m_senatt.SetAtGrow(0,"");m_VehData.m_senatt.SetAtGrow(1,"");
	m_VehData.m_axis.SetAtGrow(0,"");m_VehData.m_axis.SetAtGrow(1,"");
	m_VehData.m_xunits.SetAtGrow(0,"SEC");m_VehData.m_xunits.SetAtGrow(1,"SEC");
	m_VehData.m_yunits.SetAtGrow(0,"");m_VehData.m_yunits.SetAtGrow(1,"");
	m_VehData.m_prefil.SetAtGrow( 0, "" );m_VehData.m_prefil.SetAtGrow( 1, "" );
	m_VehData.m_insman.SetAtGrow(0,"");m_VehData.m_insman.SetAtGrow(1,"");
	m_VehData.m_caldat.SetAtGrow(0,"");m_VehData.m_caldat.SetAtGrow(1,"");
	m_VehData.m_insrat.SetAtGrow( 0, "" );m_VehData.m_insrat.SetAtGrow( 1, "" );
	m_VehData.m_chlmax.SetAtGrow( 0, "" );m_VehData.m_chlmax.SetAtGrow( 1, "" );
	m_VehData.m_inivel.SetAtGrow(0,"");m_VehData.m_inivel.SetAtGrow(1,"");
	m_VehData.m_nfp.SetAtGrow( 0, "" );m_VehData.m_nfp.SetAtGrow( 1, "" );
	m_VehData.m_nlp.SetAtGrow( 0, "" );m_VehData.m_nlp.SetAtGrow( 1, "" );
	m_VehData.m_delt.SetAtGrow( 0, "" );m_VehData.m_delt.SetAtGrow( 1, "" );
	m_VehData.m_dastat.SetAtGrow(0,"");m_VehData.m_dastat.SetAtGrow(1,"");
	m_VehData.m_chstat.SetAtGrow(0,"");m_VehData.m_chstat.SetAtGrow(1,"");
	m_VehData.m_inscom.SetAtGrow(0,"");m_VehData.m_inscom.SetAtGrow(1,"");

	// CVehTestPage -- BEGIN
	m_VehTestPage.m_editclsspd	= _T("");
	m_VehTestPage.m_editconno	= _T("");
	m_VehTestPage.m_editimpang	= _T("");
	m_VehTestPage.m_editimppnt	= _T("");
	m_VehTestPage.m_link		= _T("");
	m_VehTestPage.m_editoffset	= _T("");
	m_VehTestPage.m_rectyp		= _T("");
	m_VehTestPage.m_edittemp	= _T("");
	m_VehTestPage.m_edittitle	= _T("");
	m_VehTestPage.m_tkcond		= _T("");
	m_VehTestPage.m_tksurf		= _T("");
	m_VehTestPage.m_totcrv		= _T("");
	m_VehTestPage.m_tstcfn		= _T("VTB");
	m_VehTestPage.m_edittstcom	= _T("");
	m_VehTestPage.m_edittstobj	= _T("");
	m_VehTestPage.m_tstprf		= _T("");
	m_VehTestPage.m_edittstref	= _T("");
	m_VehTestPage.m_tsttyp		= _T("");
	m_VehTestPage.m_editverno	= _T("V5");	
	// CVehTestPage -- END

	// CVehVehPage -- BEGIN
	m_VehVehPage.m_apleng	= _T("");
	m_VehVehPage.m_bmpeng	= _T("");
	m_VehVehPage.m_body		= _T("");
	m_VehVehPage.m_carang	= _T("");
	m_VehVehPage.m_colmec	= _T("");
	m_VehVehPage.m_crbang	= _T("");
	m_VehVehPage.m_crhdst	= _T("");
	m_VehVehPage.m_damdst	= _T("");
	m_VehVehPage.m_engdsp	= _T("");
	m_VehVehPage.m_engine	= _T("");
	m_VehVehPage.m_lencnt	= _T("");
	m_VehVehPage.m_make		= _T("");
	m_VehVehPage.m_moddsc	= _T("");
	m_VehVehPage.m_model	= _T("");
	m_VehVehPage.m_modind	= _T("");
	m_VehVehPage.m_nhtsano	= _T("");
	m_VehVehPage.m_pdof		= _T("");
	m_VehVehPage.m_sileng	= _T("");
	m_VehVehPage.m_strsep	= _T("");
	m_VehVehPage.m_transm	= _T("");
	m_VehVehPage.m_vdi		= _T("");
	m_VehVehPage.m_vehcg	= _T("");
	m_VehVehPage.m_vehcom	= _T("");
	m_VehVehPage.m_vehlen	= _T("");
	m_VehVehPage.m_vehno	= _T("1");
	m_VehVehPage.m_vehor	= _T("");
	m_VehVehPage.m_vehspd	= _T("");
	m_VehVehPage.m_vehtwt	= _T("");
	m_VehVehPage.m_vehwid	= _T("");
	m_VehVehPage.m_vin		= _T("");
	m_VehVehPage.m_whlbas	= _T("");
	m_VehVehPage.m_year		= _T("1999");
	// CVehVehPage -- END

	//RestPage *****************************************************
	m_VehRestPage.m_deploy					= _T("");
	m_VehRestPage.m_occloc					= _T("");
	m_VehRestPage.m_rstcom					= _T("");
	m_VehRestPage.m_rstmnt					= _T("");
	m_VehRestPage.m_rstno					= _T("1");
	m_VehRestPage.m_rsttyp					= _T("");
	m_VehRestPage.m_editRestVehicleNumber	= _T("1");
	m_VehRestPage.m_currest					= 0;
//	m_VehRestPage.m_totalrestsets			= 0;
	
	//OccPage ******************************************************

	m_VehOccPage.m_cntrc1		= _T("");
	m_VehOccPage.m_cntrc2		= _T("");
	m_VehOccPage.m_cntrh1		= _T("");
	m_VehOccPage.m_cntrh2		= _T("");
	m_VehOccPage.m_cntrl1		= _T("");
	m_VehOccPage.m_cntrl2		= _T("");
	m_VehOccPage.m_dumdsc		= _T("");
	m_VehOccPage.m_dumman		= _T("");
	m_VehOccPage.m_dummod		= _T("");
	m_VehOccPage.m_dumsiz		= _T("");
	m_VehOccPage.m_mthcal		= _T("");
	m_VehOccPage.m_occage		= _T("");
	m_VehOccPage.m_occcom		= _T("");
	m_VehOccPage.m_occht		= _T("");
	m_VehOccPage.m_occloc		= _T("");
	m_VehOccPage.m_occsex		= _T("");
	m_VehOccPage.m_occtyp		= _T("");
	m_VehOccPage.m_occwt		= _T("");
	m_VehOccPage.m_seposn		= _T("");
	m_VehOccPage.m_vehno		= _T("1");
//	m_VehOccPage.m_totaloccsets	= 0;
	m_VehOccPage.m_curocc		= 0;
	
	//InstPage  ***************************************************
	m_VehInstPage.m_axis		= _T("");
	m_VehInstPage.m_chlmax		= _T("");
	m_VehInstPage.m_chstat		= _T("");
	m_VehInstPage.m_curno		= _T("0");
	m_VehInstPage.m_dastat		= _T("");
	m_VehInstPage.m_delt		= _T("");
	m_VehInstPage.m_inivel		= _T("");
	m_VehInstPage.m_inscom		= _T("");
	m_VehInstPage.m_insman		= _T("");
	m_VehInstPage.m_insrat		= _T("");
	m_VehInstPage.m_nfp			= _T("");
	m_VehInstPage.m_nlp			= _T("");
	m_VehInstPage.m_prefil		= _T("");
	m_VehInstPage.m_senatt		= _T("");
	m_VehInstPage.m_senloc		= _T("");
	m_VehInstPage.m_sentyp		= _T("");
	m_VehInstPage.m_vehno		= _T("1");
	m_VehInstPage.m_xunits		= _T("SEC");
	m_VehInstPage.m_yunits		= _T("");
	m_VehInstPage.m_totalcurves	= 0;
	m_VehInstPage.m_icurno		= 0;
	
	// CVehBarPage -- BEGIN
	m_VehBarPage.m_editbarshp = _T("");
	m_VehBarPage.m_editbardia = _T("");
	m_VehBarPage.m_editbarcom = _T("");
	m_VehBarPage.m_editbarang = _T("");
	// CVehBarPage -- END

	if (m_VehTestPage.m_hWnd!=NULL) m_VehTestPage.UpdateData(FALSE);
	
	if( m_VehVehPage.m_hWnd != NULL )
	{
		m_VehVehPage.PretestButton();
		m_VehVehPage.PosttestButton();
		m_VehVehPage.DamageprofButton();
		m_VehVehPage.UpdateData (FALSE);
	}

	if (m_VehRestPage.m_hWnd!=NULL) 
	{
		m_VehRestPage.m_restlist.ResetContent();
		m_VehRestPage.UpdateData(FALSE);
	}
	
	if (m_VehOccPage.m_hWnd!=NULL)
	{
		m_VehOccPage.Clearancedist();
		m_VehOccPage.Injmeas();
		m_VehOccPage.Peakloads();
		m_VehOccPage.EnableButtons( FALSE );
		m_VehOccPage.m_occlist.ResetContent();
		m_VehOccPage.UpdateData(FALSE);

	}
	if (m_VehBarPage.m_hWnd!=NULL) m_VehBarPage.UpdateData (FALSE);

	if (m_VehInstPage.m_hWnd!=NULL) 
	{
		m_VehInstPage.m_curvelist.ResetContent();
		m_VehInstPage.UpdateData (FALSE);
	}
		
	// for high speed video
	m_VehData.ClearHsvddata();
	if (m_HsvdPage.m_hWnd!=NULL) { m_HsvdPage.ClearAll(); }
	
	// for intrusion
	m_VehData.m_IntrusionData.ClearIntrusionData();
	if (m_VehIntrPage.m_hWnd!=NULL) { m_VehIntrPage.ClearAll(); }

	this->_bClearAll = true;

	return;	//	was returning TRUE;
	
}

/******************************************************************************

	Name:		OnExportTest

	Action:		Load data from all pages into VehData.  If success, let the
				user export an EV5 file containing this data.

	Params:		void

	Returns:	void

	Notes:	

	Dates:

******************************************************************************/
void CVehiclePropertySheet::OnExportTest( void ) 
{
	// Get latest data from pages - if already loaded, no big deal.
	if( !m_VehTestPage.LoadVehTestData() ) { return; }
	if( !m_VehVehPage.LoadVehVehData() ) { return; }
	if( !m_VehRestPage.LoadVehRestData() ) { return; }
	if( !m_VehOccPage.LoadVehOccData() ) { return; }
	if( !m_VehBarPage.LoadVehBarData() ) { return; }
	if( !m_VehInstPage.LoadVehInstData() ) { return; }

	//File Export Dialog Common Control
	CFileDialog export(FALSE);
	export.m_ofn.lpstrTitle ="Export File";
	export.m_ofn.lpstrFilter = "EV5 File (*.ev5)\0*.ev5\0";

	if( export.DoModal() == IDOK )
	{		
		//export here
		CString strfile_out = export.GetPathName();
		if( export.GetFileExt() != "ev5" )
		{
			strfile_out += ".ev5";
		}

		m_VehData.ExportEV5( strfile_out );

		// export high-speed video report
		if( m_VehData.m_camno.GetSize()>1 )
		{
			if ( !m_HsvdPage.ValidateThisPage() ) //??? ALl page?
			{ 
				AfxMessageBox("Illegal data found. No high-speed video file output.");
				return;
			}
		}

		strfile_out.TrimRight();
		CString sTitle = strfile_out.Left(strfile_out.GetLength()-4);
		CString HsvdFile = sTitle + ".hs5";
		m_VehData.ExportHsvd( HsvdFile );

		if( m_VehData.m_IntrusionData.m_nrt_no.GetSize()>1 )
		{
			if ( !m_VehIntrPage.ValidateThisPage() )
			{ 
				AfxMessageBox("Illegal data found. No intrusion file output.");
				return;
			}
		}
		CString IntrFile = sTitle + ".ip5";
		m_VehData.m_IntrusionData.ExportIntrusion( IntrFile );
	}
}	// OnExportTest

/******************************************************************************

	Name:		

	Action:		Let the user choose a file to import, and then try to load it.

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehiclePropertySheet::OnImportTest() 
{
	CFileDialog import(TRUE);
	import.m_ofn.lpstrTitle ="Open Test";
	import.m_ofn.lpstrFilter =
	 "EV5 Tests (*.ev5)\0*.ev5\0EV4 Tests (*.ev4)\0*.ev4\0EV3 Test Data (*.gr1)\0*.gr1\0EV3 Vehicle Data (*.gr2)\0*.gr2\0EV3 Barrier Data (*.gr3)\0*.gr3\0EV3 Occupant Data (*.gr4)\0*.gr4\0EV3 Instrumentation Data (*.gr5)\0*.gr5\0";
	 
	if (import.DoModal ()==IDOK)
	{
			//import here
		CString strfile_in = import.GetPathName () ;
		CString strext = import.GetFileExt ();
		strext.MakeLower ();

		if( strext == "ev5" ) 
		{	
			OnClearall();
			if( this->_bClearAll == false )
			{
				//	exit if user doesn't want to 
				//	replace current data with imported data.
				return;
			}

			BOOL success = m_VehData.ImportEV5(strfile_in);
			if( success ) 
			{
				m_VehTestPage.OnSetActive ();  //m_hWnd always exists
				if (m_VehBarPage.m_hWnd) m_VehBarPage.OnSetActive();
				
				m_VehOccPage.m_curocc = m_VehData.m_occsets;  //goto last set.
				if (m_VehOccPage.m_hWnd) m_VehOccPage.OnSetActive();
				
				m_VehRestPage.m_currest = m_VehData.m_restsets;  //goto last set.
				if (m_VehRestPage.m_hWnd) m_VehRestPage.OnSetActive();
				
				if (m_VehVehPage.m_hWnd) m_VehVehPage.OnSetActive();

				m_VehInstPage.m_icurno = m_VehData.m_totcrv;  //goto last curve.
				if (m_VehInstPage.m_hWnd) m_VehInstPage.OnSetActive();
				
			}
			// import High Speed Video data
			strfile_in.TrimRight();
			CString HsvdFile = strfile_in.Left(strfile_in.GetLength()-4) + ".hs5";
			ImportHsvdData(HsvdFile, false);
			// import Intrusion data
			CString IntrFile = strfile_in.Left(strfile_in.GetLength()-4) + ".ip5";
			ImportIntrusionData(IntrFile, false);
		}
		else
		if( strext == "ev4" )
		{
			OnClearall();
			if( this->_bClearAll == false )
			{
				//	exit if user doesn't want to 
				//	replace current data with imported data.
				return;
			}

			BOOL success = m_VehData.ImportEV4(strfile_in);
			if( success ) 
			{
				m_VehTestPage.OnSetActive ();  //m_hWnd always exists

				if (m_VehBarPage.m_hWnd) 
				{
					m_VehBarPage.OnSetActive();
				}
				
				m_VehOccPage.m_curocc = m_VehData.m_occsets;  //goto last set.
				if (m_VehOccPage.m_hWnd) m_VehOccPage.OnSetActive();
				
				m_VehRestPage.m_currest = m_VehData.m_restsets;  //goto last set.
				if (m_VehRestPage.m_hWnd) m_VehRestPage.OnSetActive();
				
				if (m_VehVehPage.m_hWnd) m_VehVehPage.OnSetActive();

				m_VehInstPage.m_icurno = m_VehData.m_totcrv;  //goto last curve.
				if (m_VehInstPage.m_hWnd) m_VehInstPage.OnSetActive();
				
			}
			
		}
		else
		if( strext == "gr1" )
		{
			BOOL success = m_VehData.ImportGR1(strfile_in);
			if( success )
			{
				m_VehTestPage.OnSetActive ();  //m_hWnd always exists
				if (m_VehBarPage.m_hWnd) m_VehBarPage.OnSetActive();
				if (m_VehOccPage.m_hWnd) m_VehOccPage.OnSetActive();
				if (m_VehRestPage.m_hWnd) m_VehRestPage.OnSetActive();
				if (m_VehVehPage.m_hWnd) m_VehVehPage.OnSetActive();
				if (m_VehInstPage.m_hWnd) m_VehInstPage.OnSetActive();
			}
			
		}
		else
		if( strext == "gr2" )
		{
			BOOL success = m_VehData.ImportGR2(strfile_in);
			if( success ) 
			{
				m_VehTestPage.OnSetActive ();  //m_hWnd always exists
				if (m_VehBarPage.m_hWnd) m_VehBarPage.OnSetActive();
				if (m_VehOccPage.m_hWnd) m_VehOccPage.OnSetActive();
				if (m_VehRestPage.m_hWnd) m_VehRestPage.OnSetActive();
				if (m_VehVehPage.m_hWnd) m_VehVehPage.OnSetActive();
				if (m_VehInstPage.m_hWnd) m_VehInstPage.OnSetActive();
			}
			
		}
		else
		if( strext == "gr3" )
		{
			BOOL success = m_VehData.ImportGR3(strfile_in);
			if( success )
			{
				m_VehTestPage.OnSetActive ();  //m_hWnd always exists
				if (m_VehBarPage.m_hWnd) m_VehBarPage.OnSetActive();
				if (m_VehOccPage.m_hWnd) m_VehOccPage.OnSetActive();
				if (m_VehRestPage.m_hWnd) m_VehRestPage.OnSetActive();
				if (m_VehVehPage.m_hWnd) m_VehVehPage.OnSetActive();
				if (m_VehInstPage.m_hWnd) m_VehInstPage.OnSetActive();
			}
			
		}
		else
		if( strext == "gr4" )
		{
			short nSets = m_VehData.ImportGR4(strfile_in);

			if( nSets )
			{
				m_VehData.m_occsets=nSets;
				
				m_VehTestPage.OnSetActive ();  //m_hWnd always exists

				m_VehOccPage.m_curocc = m_VehData.m_occsets;  //goto last set.

				if (m_VehBarPage.m_hWnd) m_VehBarPage.OnSetActive();
				if (m_VehOccPage.m_hWnd) m_VehOccPage.OnSetActive();
				if (m_VehRestPage.m_hWnd) m_VehRestPage.OnSetActive();
				if (m_VehVehPage.m_hWnd) m_VehVehPage.OnSetActive();
				if (m_VehInstPage.m_hWnd) m_VehInstPage.OnSetActive();
			}
		}
		else
		if( strext == "gr5" )
		{
			BOOL success = m_VehData.ImportGR5(strfile_in);

			if( success ) 
			{
				m_VehInstPage.m_icurno = m_VehData.m_totcrv;  //goto last curve.

				m_VehTestPage.OnSetActive ();  //m_hWnd always exists
				if (m_VehBarPage.m_hWnd) m_VehBarPage.OnSetActive();
				if (m_VehOccPage.m_hWnd) m_VehOccPage.OnSetActive();
				if (m_VehRestPage.m_hWnd) m_VehRestPage.OnSetActive();
				if (m_VehVehPage.m_hWnd) m_VehVehPage.OnSetActive();
				if (m_VehInstPage.m_hWnd) m_VehInstPage.OnSetActive();
			}
		}
	}
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehiclePropertySheet::OnExit() 
{
	OnClose();
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:		Ask user which file to print.  Then ask which printer to
				print with.  Then do an annoying line by line print loop.
				There must be a better way to do this.  See ch15 from
				Programming Windows 95 by Petzold.

	Dates:

******************************************************************************/
void CVehiclePropertySheet::OnFilePrint() 
{

	CString strfile_out= GetPrintFileName();
	if (strfile_out=="") return;  // no file chosen, cancel.

	CString device = GetPrinterDeviceName();
	if (device == "") return; // no printer chosen, cancel.

	CStdioFile myFile;
	CFileException fileException;

	myFile.Open( strfile_out, CFile::shareDenyNone | CFile::modeRead | CFile::typeText,
		&fileException );
	if (!myFile.m_pStream)  // not opened, will be NULL.
	{
		CString msg;
		msg.Format ("Can't open file %s, error = %u\n", strfile_out, fileException.m_cause );
		MessageBox(msg);
		return ;
	}
	
	static DOCINFO di={sizeof(DOCINFO), strfile_out,NULL};

	HDC hdcPrn = CreateDC("WINSPOOL", device, NULL, NULL);

	// size of page and chars and lines per page.
	TEXTMETRIC tm;
	GetTextMetrics(hdcPrn, &tm);
	int yChar, nline = 0;
	yChar = tm.tmHeight +tm.tmExternalLeading;
	int iCharsPerLine = GetDeviceCaps(hdcPrn, HORZRES) /tm.tmAveCharWidth ;
	int iLinesPerPage = GetDeviceCaps(hdcPrn, VERTRES) / yChar;
	
	StartDoc (hdcPrn, &di);
	StartPage (hdcPrn);
	
	CString strbuf;
	char* pBuf = new char[iCharsPerLine + 1];
	// readstrings from file.  
	while (myFile.ReadString(pBuf, iCharsPerLine)) //reads max of iCharsPerLine chars.
	{
		if (nline == iLinesPerPage)  //new page
		{
			nline = 0;
			EndPage(hdcPrn);
			StartPage(hdcPrn);
		}
		// WARNING! TextOut doesn't handle Tabs well, so there are no tabs in .ev5 or .evr.
		strbuf = pBuf;
		TextOut(hdcPrn,0,yChar*nline, strbuf, strbuf.GetLength ());
		nline++;
		
	}

	EndPage(hdcPrn);
	EndDoc(hdcPrn);
	DeleteDC(hdcPrn);
	delete [] pBuf;
	myFile.Close ();
	return;

}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
CString CVehiclePropertySheet::GetPrintFileName()
{
	// Get Print File Name  **********
	CFileDialog printfile(TRUE);
	CString strfile_out;
	printfile.m_ofn.lpstrTitle ="Choose File To Print";
	printfile.m_ofn.lpstrFilter = "EV5 File (*.ev5)\0*.ev5\0EV5 Report File (*.evr)\0*.evr\0";

	if (printfile.DoModal()==IDOK)
	{
		strfile_out = printfile.GetPathName ();
	}
	else
	{
		strfile_out = "";
	}
	return strfile_out;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
CString CVehiclePropertySheet::GetPrinterDeviceName()
{
	CString device;
	// Choose Printer to use ************
	CPrintDialog printmachine(FALSE);
	
	if (printmachine.DoModal ()==IDOK)
	{
		device = printmachine.GetDeviceName();
		GlobalFree(printmachine.m_pd.hDevMode );
		GlobalFree(printmachine.m_pd.hDevNames );
	}
	else
	{
		GlobalFree(printmachine.m_pd.hDevMode );
		GlobalFree(printmachine.m_pd.hDevNames );
		device = "";
	}
	return device;

}

// Try to load all data into m_VehData.  If success,
// let the user export this data into a report (EVR) file.
/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehiclePropertySheet::OnExportReport() 
{
	// Get latest data from pages - if already loaded, no big deal.
	if (!m_VehTestPage.LoadVehTestData ()) return;
	if (!m_VehVehPage.LoadVehVehData ()) return;
	if (!m_VehRestPage.LoadVehRestData ()) return;
	if (!m_VehOccPage.LoadVehOccData ()) return;
	if (!m_VehBarPage.LoadVehBarData ()) return;
	if (!m_VehInstPage.LoadVehInstData ()) return;

	// File export dialog common control
	CFileDialog export(FALSE);
	export.m_ofn.lpstrTitle ="Export Report";
	export.m_ofn.lpstrFilter = "EV5 Report (*.evr)\0*.evr\0";

	if (export.DoModal()==IDOK)
	{
		//export here
//		CString strfile_out = export.GetPathName () + ".evr";
//		m_VehData.ExportEVR (strfile_out);
		CString strfile_out = export.GetPathName ();
		if (export.GetFileExt ()!="evr")
		{
			strfile_out +=".evr";
		}
		m_VehData.ExportEVR (strfile_out);

		// Export high speed video report
		if( m_VehData.m_camno.GetSize()>1 )
		{
			if ( !m_HsvdPage.ValidateThisPage() ) 
			{ 
				AfxMessageBox("Illegal data found. No file output.");
				return; 
			}
		}
		strfile_out.TrimRight();
		CString sTitle = strfile_out.Left(strfile_out.GetLength()-4);
		CString HsvdFile = sTitle + ".hsr";
		m_VehData.ExportHsvdReport( HsvdFile );

		// Export intrusion report
		if( m_VehData.m_IntrusionData.m_nrt_no.GetSize()>1 )
		{
			if ( !m_VehIntrPage.ValidateThisPage() )
			{ 
				AfxMessageBox("Illegal data found. No intrusion file output.");
				return;
			}
		}
		CString IntrFile = sTitle + ".ipr";
		m_VehData.m_IntrusionData.ExportIntrusionReport( IntrFile );
	}	
}	// OnExportReport

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehiclePropertySheet::OnClose() 
{
	if (MessageBox("Really exit Entree?", "Warning", MB_YESNO)==IDYES)
	{
		m_pParent->DoneChoose();	

	}

}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehiclePropertySheet::OnHelpAbout() 
{
	CAboutDlg about;
	about.DoModal ();
	
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehiclePropertySheet::OnHelpIndex() 
{
	OnHelpFinder();		
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehiclePropertySheet::OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu) 
{
	CPropertySheet::OnInitMenuPopup(pPopupMenu, nIndex, bSysMenu);

	if( nIndex != 0 )
	{
		return;
	}

	if( m_bValidate == true )
	{
		pPopupMenu->EnableMenuItem( ID_EXPORT_TEST, MF_ENABLED );		
	}
	else
	{
		pPopupMenu->EnableMenuItem( ID_EXPORT_TEST, MF_GRAYED );
	}

	// for intrusion point
	pPopupMenu->EnableMenuItem( ID_FILE_LOAD_INTRUSION, MF_ENABLED );
	pPopupMenu->EnableMenuItem( ID_FILE_SAVE_INTRUSION, MF_ENABLED );
	pPopupMenu->EnableMenuItem( ID_FILE_SAVE_INTRUSION_REPORT, MF_ENABLED );
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehiclePropertySheet::OnSysCommand(UINT nID, LPARAM lParam) 
{

	// TODO: Add your message handler code here and/or call default

	// Page Number
	// Test = 0
	// Veh = 1
	// Occ = 2
	// Rest = 3
	// Bar = 4
	// Inst = 5

	LockWindowUpdate();

	int iActivePage = 0;
	iActivePage = GetActiveIndex();


	if(		( m_VehTestPage.ValidatePage() == true ) 
		&&	( m_VehVehPage.ValidatePage() == true )
		&&	( m_VehRestPage.ValidatePage() == true )
		&&	( m_VehOccPage.ValidatePage() == true )
		&&	( m_VehBarPage.ValidatePage() == true )
		&&	( m_VehInstPage.ValidatePage() == true ) )
	{
		m_bValidate = true;

		SetActivePage( 1 );

		if( m_VehVehPage.m_hWnd )
		{
			// FALSE, More then one page.
			if ( m_VehVehPage.EnableControls() == FALSE )
			{
				if( m_VehVehPage.ValidateSpinControl() == false )
				{
					m_bValidate = false;

					UnlockWindowUpdate();

					CPropertySheet::OnSysCommand(nID, lParam);

					return;
				}
			}
		}

		if(		( m_VehVehPage.bPretest == true )
			&&	( m_VehVehPage.bPosttest == true )
			&&	( m_VehVehPage.bDamamge == true ) )
		{
			m_bValidate = true;

			SetActivePage( 2 );

			if(		( m_VehOccPage.bClearancedist == true )
				&&	( m_VehOccPage.bPeakloads == true )
				&&	( m_VehOccPage.bInjmeas == true ) )
			{
				m_bValidate = true;

				SetActivePage( iActivePage );
			}
			else
			{
				m_bValidate = false;
			}
		}
		else
		{
			m_bValidate = false;
		}
	}
	else
	{
		m_bValidate = false;
	}

	UnlockWindowUpdate();

	CPropertySheet::OnSysCommand(nID, lParam);
}

////////////// for high-speed video files only
void CVehiclePropertySheet::OnImportHsvdData()
{
	CFileDialog import(TRUE);
	import.m_ofn.lpstrTitle ="Open High-Speed Video File";
	import.m_ofn.lpstrFilter = "EV5 HSVD (*.hs5)\0*.hs5\0All Files\0*.*\0";
//	 "EV5 Tests (*.ev5)\0*.ev5\0EV4 Tests (*.ev4)\0*.ev4\0EV3 Test Data (*.gr1)\0*.gr1\0EV3 Vehicle Data (*.gr2)\0*.gr2\0EV3 Barrier Data (*.gr3)\0*.gr3\0EV3 Occupant Data (*.gr4)\0*.gr4\0EV3 Instrumentation Data (*.gr5)\0*.gr5\0";
	 
	if (import.DoModal ()==IDCANCEL) { return; }
	CString strfile_in = import.GetPathName () ;
	ImportHsvdData(strfile_in);
}	// OnImportHsvdData

void CVehiclePropertySheet::OnExportHsvdData()
{
	ExportHsvdData();
}	// OnExportHsvdData

void CVehiclePropertySheet::ImportHsvdData(CString& strfile_in, bool bErrMsgResponse) // = true
{
	if( !m_VehData.ImportHsvd(strfile_in, bErrMsgResponse) ) { return; }
	m_HsvdPage.m_nCurCamNo = m_HsvdPage.m_nTotalCamNo = m_VehData.m_camno.GetSize() - 1;	// the 0th item is empty.
	m_VehTestPage.OnSetActive ();  //m_hWnd always exists
	if (m_HsvdPage.m_hWnd) m_HsvdPage.OnSetActive();
	
}	// ImportHsvdData

void CVehiclePropertySheet::ExportHsvdData()
{
	if( m_VehData.m_camno.GetSize()<2 ) { return; }

	if ( !m_HsvdPage.ValidateThisPage() ) 
	{ 
		AfxMessageBox("Illegal data found. No file output.");
		return; 
	}

	//File Export Dialog Common Control
	CFileDialog export(FALSE);
	export.m_ofn.lpstrTitle ="Export File";
	export.m_ofn.lpstrFilter = "EV5 HSVD (*.hs5)\0*.hs5\0";

	if( export.DoModal() == IDCANCEL ) { return; }
	
	//export here
	CString strfile_out = export.GetPathName();
	if( export.GetFileExt() != "hs5" )
	{
		strfile_out += ".hs5";
	}

	m_VehData.ExportHsvd( strfile_out );

}	// ExportHsvdData

void CVehiclePropertySheet::OnExportHsvdReport()
{
	ExportHsvdReport();
}	// OnExportHsvdReport


void CVehiclePropertySheet::ExportHsvdReport()
{
	if( m_VehData.m_camno.GetSize()<2 ) { return; }

	if ( !m_HsvdPage.ValidateThisPage() ) 
	{ 
		AfxMessageBox("Illegal data found. No file output.");
		return; 
	}

	//File Export Dialog Common Control
	CFileDialog export(FALSE);
	export.m_ofn.lpstrTitle ="Report File";
	export.m_ofn.lpstrFilter = "EV5 HSVD (*.hsr)\0*.hsr\0";

	if( export.DoModal() == IDCANCEL ) { return; }
	
	//export here
	CString strfile_out = export.GetPathName();
	if( export.GetFileExt() != "hsr" )
	{
		strfile_out += ".hsr";
	}

	m_VehData.ExportHsvdReport( strfile_out );

}	// ExportHsvdReport

void CVehiclePropertySheet::ImportIntrusionData(CString& strfile_in, bool bErrMsgResponse) // = true)
{
	if( !m_VehData.m_IntrusionData.ImportIntrusion(strfile_in, bErrMsgResponse) ) { return; }
	if (m_VehData.m_tstref=="") { m_VehData.m_tstref = m_VehData.m_IntrusionData.m_tstref; }
	m_VehIntrPage.m_nCurNo = m_VehIntrPage.m_nTotalNo = m_VehData.m_IntrusionData.m_nrt_no.GetSize() - 1;	// the 0th item is empty.
	m_VehTestPage.OnSetActive ();  //m_hWnd always exists
	if (m_VehIntrPage.m_hWnd) m_VehIntrPage.OnSetActive();
}	// ImportIntrusionData

// for intrusion data
void CVehiclePropertySheet::OnImportIntrusionData()
{
	CFileDialog import(TRUE);
	import.m_ofn.lpstrTitle ="Open High-Speed Video File";
	import.m_ofn.lpstrFilter = "EV5 Intrusion (*.ip5)\0*.ip5\0All Files\0*.*\0";
	 
	if (import.DoModal ()==IDCANCEL) { return; }
	CString strfile_in = import.GetPathName () ;
	ImportIntrusionData(strfile_in);

}	// OnImportIntrusionData

void CVehiclePropertySheet::OnExportIntrusionData()
{
	if( m_VehData.m_IntrusionData.m_nrt_no.GetSize()<2 ) { return; }

	if ( !m_VehIntrPage.ValidateThisPage() ) 
	{ 
		AfxMessageBox("Illegal data found. No file output.");
		return; 
	}

	//File Export Dialog Common Control
	CFileDialog export(FALSE);
	export.m_ofn.lpstrTitle ="Export File";
	export.m_ofn.lpstrFilter = "EV5 Intrusion (*.ip5)\0*.ip5\0";

	if( export.DoModal() == IDCANCEL ) { return; }
	
	//export here
	CString strfile_out = export.GetPathName();
	if( export.GetFileExt() != "ip5" )
	{
		strfile_out += ".ip5";
	}

	m_VehData.m_IntrusionData.ExportIntrusion( strfile_out );
}	// OnExportIntrusionData

void CVehiclePropertySheet::OnExportIntrusionReport()
{
	if( m_VehData.m_IntrusionData.m_nrt_no.GetSize()<2 ) { return; }

	if ( !m_HsvdPage.ValidateThisPage() ) 
	{ 
		AfxMessageBox("Illegal data found. No file output.");
		return; 
	}

	//File Export Dialog Common Control
	CFileDialog export(FALSE);
	export.m_ofn.lpstrTitle ="Report File";
	export.m_ofn.lpstrFilter = "EV5 Intrusion (*.ipr)\0*.ipr\0";

	if( export.DoModal() == IDCANCEL ) { return; }
	
	//export here
	CString strfile_out = export.GetPathName();
	if( export.GetFileExt() != "ipr" )
	{
		strfile_out += ".ipr";
	}

	m_VehData.m_IntrusionData.ExportIntrusionReport( strfile_out );

}	// OnExportIntrusionReport