#if !defined(AFX_VEHICLEPROPERTYSHEET_H__96CE047E_5893_11D2_9493_0008C7AA9033__INCLUDED_)
#define AFX_VEHICLEPROPERTYSHEET_H__96CE047E_5893_11D2_9493_0008C7AA9033__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ChooseDB.h"
#include "VehTestPage.h"
#include "VehVehPage.h"
#include "VehRestPage.h"
#include "VehOccPage.h"
#include "VehBarPage.h"
#include "VehInstPage.h"
#include "VehData.h"	// Added by ClassView
#include "HsvdPage.h"
#include "VehIntrPage.h"

// VehiclePropertySheet.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CVehiclePropertySheet

class CVehiclePropertySheet : public CPropertySheet
{
	DECLARE_DYNAMIC(CVehiclePropertySheet)

// Construction
public:
	CVehiclePropertySheet(UINT nIDCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);
	CVehiclePropertySheet(LPCTSTR pszCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);

// Attributes
public:

	CVehTestPage m_VehTestPage;
	CVehVehPage  m_VehVehPage;
	CVehRestPage m_VehRestPage;
	CVehOccPage  m_VehOccPage;
	CVehBarPage  m_VehBarPage;
	CVehInstPage m_VehInstPage;
	CHsvdPage	 m_HsvdPage;
	CVehIntrPage m_VehIntrPage;

	CChooseDB*	m_pParent;
	CVehData	m_VehData;
	bool		m_bValidPage;
	bool		m_bValidate;


// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVehiclePropertySheet)
	public:
	virtual BOOL OnInitDialog();
	//}}AFX_VIRTUAL

// Implementation
public:
	
	CString GetPrinterDeviceName();
	CString GetPrintFileName();
	virtual ~CVehiclePropertySheet();

	// Generated message map functions
protected:
	//{{AFX_MSG(CVehiclePropertySheet)
	afx_msg void OnBiomechdb();
	afx_msg void OnComponentdb();
	afx_msg void OnSwgdb();
	afx_msg void OnClearall();
	afx_msg void OnImportTest();
	afx_msg void OnImportHsvdData();
	afx_msg void OnExportHsvdData();
	afx_msg void OnExportHsvdReport();
	afx_msg void OnImportIntrusionData();
	afx_msg void OnExportIntrusionData();
	afx_msg void OnExportIntrusionReport();
	afx_msg void OnFilePrint();
	afx_msg void OnExit();
	afx_msg void OnExportReport();
	afx_msg void OnClose();
	afx_msg void OnHelpAbout();
	afx_msg void OnHelpIndex();
	afx_msg void OnExportTest();
	afx_msg void OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu);
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	bool	_bClearAll;
	void	ImportHsvdData(CString& strfile_in, bool bErrMsgResponse = true);
	void	ImportIntrusionData(CString& strfile_in, bool bErrMsgResponse = true);
	void	ExportHsvdData();
	void	ExportHsvdReport();
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VEHICLEPROPERTYSHEET_H__96CE047E_5893_11D2_9493_0008C7AA9033__INCLUDED_)
