// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: VehInstPage.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description:  Member functions of CVehInstPage.
//               They relate to the loading and display of 
//               data on this page.
//
//  Modification History:
//  Date		Who			Description
//  03/03/00	Yeun Wong	add info data insertion and correct info data indexing
// -----------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "VehInstPage.h"
#include "search.h"
#include "CodeValidation.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CString search_code;

/////////////////////////////////////////////////////////////////////////////
// CVehInstPage property page

IMPLEMENT_DYNCREATE(CVehInstPage, CPropertyPage)

/******************************************************************************

	Name:		CVehInstPage	

	Action:		Default Constructor

	Params:		void

	Returns:	None

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000
				Modify - Al Wilhelm - 9/14/2000

******************************************************************************/
CVehInstPage::CVehInstPage( void ) : CPropertyPage( CVehInstPage::IDD ), 
	m_icurno( 0 )	// Default to first curve.
{
	//{{AFX_DATA_INIT(CVehInstPage)
	m_retaindata	= FALSE;
	m_axis			= _T("");
	m_chstat		= _T("");
	m_dastat		= _T("");
	m_inscom		= _T("");
	m_insman		= _T("");
	m_senatt		= _T("");
	m_senloc		= _T("");
	m_sentyp		= _T("");
	m_xunits		= _T("");
	m_yunits		= _T("");
	m_vehno			= _T("");
	m_prefil		= _T("");
	m_insrat		= _T("");
	m_chlmax		= _T("");
	m_nfp			= _T("");
	m_nlp			= _T("");
	m_delt			= _T("");
	m_inivel		= _T("");
	//}}AFX_DATA_INIT
}

/******************************************************************************

	Name:		~CVehInstPage	

	Action:		Default Deconstrutor

	Params:		void

	Returns:	None

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
CVehInstPage::~CVehInstPage( void )
{
}

/******************************************************************************

	Name:		DoDataExchange

	Action:		

	Params:		CDataExchange *

	Returns:	void

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
void CVehInstPage::DoDataExchange( CDataExchange* pDX )
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVehInstPage)
	DDX_Control(pDX, IDC_VEHINSTDAT, m_editinstdate);
	DDX_Control(pDX, IDC_CURVELIST, m_curvelist);
	DDX_Control(pDX, IDC_NEXTRECORD, m_nextrecordbutton);
	DDX_Control(pDX, IDC_DELETECURVE, m_deletecurvebutton);
	DDX_Control(pDX, IDC_VEHINST_CALDAT, m_caldatctrl);
	DDX_Check(pDX, IDC_RETAINDATA, m_retaindata);
	DDX_Control(pDX, IDC_VEHINST_AXIS, m_axis);
	DDX_Control(pDX, IDC_VEHINST_CHSTAT, m_chstat);
	DDX_Control(pDX, IDC_VEHINST_DASTAT, m_dastat);
	DDX_Control(pDX, IDC_VEHINST_INSCOM, m_inscom);
	DDX_Control(pDX, IDC_VEHINST_INSMAN, m_insman);
	DDX_Control(pDX, IDC_VEHINST_SENATT, m_senatt);
	DDX_Control(pDX, IDC_VEHINST_SENLOC, m_senloc);
	DDX_Control(pDX, IDC_VEHINST_SENTYP, m_sentyp);
	DDX_Control(pDX, IDC_VEHINST_XUNITS, m_xunits);
	DDX_Control(pDX, IDC_VEHINST_YUNITS, m_yunits);
	DDX_Control(pDX, IDC_VEHINST_VEHNO, m_vehno);
	DDX_Control(pDX, IDC_VEHINST_PREFIL, m_prefil);
	DDX_Control(pDX, IDC_VEHINST_INSRAT, m_insrat);
	DDX_Control(pDX, IDC_VEHINST_CHLMAX, m_chlmax);
	DDX_Control(pDX, IDC_VEHINST_NFP, m_nfp);
	DDX_Control(pDX, IDC_VEHINST_NLP, m_nlp);
	DDX_Control(pDX, IDC_VEHINST_DELT, m_delt);
	DDX_Control(pDX, IDC_VEHINST_INIVEL, m_inivel);
	//}}AFX_DATA_MAP
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
BEGIN_MESSAGE_MAP( CVehInstPage, CPropertyPage )
	//{{AFX_MSG_MAP(CVehInstPage)
	ON_BN_CLICKED(IDC_NEXTRECORD, OnNextrecord)
	ON_BN_CLICKED(IDC_DELETECURVE, OnDeletecurve)
	ON_BN_CLICKED(IDC_SENTYPSEARCH, OnSentypsearch)
	ON_BN_CLICKED(IDC_SENLOCSEARCH, OnSenlocsearch)
	ON_BN_CLICKED(IDC_SENATTSEARCH, OnSenattsearch)
	ON_BN_CLICKED(IDC_AXISSEARCH, OnAxissearch)
	ON_BN_CLICKED(IDC_XUNITSSEARCH, OnXunitssearch)
	ON_BN_CLICKED(IDC_YUNITSSEARCH, OnYunitssearch)
	ON_BN_CLICKED(IDC_DASTATSEARCH, OnDastatsearch)
	ON_BN_CLICKED(IDC_CHSTATSEARCH, OnChstatsearch)
	ON_LBN_SELCHANGE(IDC_CURVELIST, OnSelchangeCurvelist)
	ON_WM_HELPINFO()
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTW, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTA, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY(DTN_DATETIMECHANGE, IDC_VEHINST_CALDAT, OnDatetimechangeVehinstCaldat)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVehInstPage message handlers

/******************************************************************************

	Name:		OnToolTipNotify

	Action:		

	Params:		UINT, NMHDR *, LRESULT *

	Returns:	BOOL

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
BOOL CVehInstPage::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
	TOOLTIPTEXTA* pTTTA = (TOOLTIPTEXTA*)pNMHDR;
	TOOLTIPTEXTW* pTTTW = (TOOLTIPTEXTW*)pNMHDR;
	CString strTipText = "";
	UINT nID = pNMHDR->idFrom;
	if (pNMHDR->code == TTN_NEEDTEXTA && (pTTTA->uFlags & TTF_IDISHWND) ||
		pNMHDR->code == TTN_NEEDTEXTW && (pTTTW->uFlags & TTF_IDISHWND))
	{
		// idFrom is actually the HWND of the tool
		nID = ::GetDlgCtrlID((HWND)nID);
	}

	if (nID != 0) // will be zero on a separator
	{
		strTipText.Format("Control ID = %d", nID);
		switch (nID)
		{
		case IDC_NEXTRECORD:
			strTipText = "Go to (or add) the next curve";
			break;
		case IDC_VEHINST_DELT:
			strTipText = "Microseconds (0->999999)";
			break;
		case IDC_VEHINST_CHLMAX:
			strTipText = "% Integer (0->999)";
			break;
		case IDC_VEHINST_INIVEL:
			strTipText = "km/hr (-200.00->200.00)";
			break;
		case IDC_VEHINST_PREFIL:
			strTipText = "Hz (0->99999)";
			break;
		case IDC_VEHINST_INSRAT:
			strTipText = "Hz (-999999->999999)";
			break;
		case IDC_VEHINST_NFP:
			strTipText = "-10000->0";
			break;
		case IDC_VEHINST_NLP:
			strTipText = "0->99999";
			break;
		case IDC_VEHINST_VEHNO:
			strTipText = "0, 1 or 2";
			break;
		case IDC_DELETECURVE:
			strTipText = "Delete curve";
			break;
		case IDC_VEHINSTDAT:
			strTipText = "Date (dd/MMM/yyyy)";
			break;
		default:
			strTipText = "";
		}
	}

	if (pNMHDR->code == TTN_NEEDTEXTA)
		lstrcpyn(pTTTA->szText, strTipText, sizeof(pTTTA->szText));
	else
		::MultiByteToWideChar( CP_ACP , 0, strTipText, -1, pTTTW->szText, sizeof(pTTTW->szText) );
	*pResult = 0;

	return TRUE;    // message was handled
}

/******************************************************************************

	Name:		OnNextrecord

	Action:		

	Params:		void

	Returns:	void

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
void CVehInstPage::OnNextrecord( void ) 
{
	if( ::GetKeyState( VK_RETURN ) < 0 ) { return; }

//	m_totalcurves = m_pVehData->m_totcrv;

	// If at end, increase # of curves
	if( m_icurno == m_totalcurves ) 
	{
		if( m_icurno != 0 )
		{
			LoadVehInstData();
		}

		m_totalcurves++; 
		m_icurno++;
		InitializeNextCurve();

//		m_pVehData->m_totcrv = m_totalcurves;
	} 
	else if( m_icurno != 0 ) 
	{
		if( !LoadVehInstData() )
		{
			MessageBox( "Error: see CVehInstPage::OnNextcurveButton()" );
			return;
		}

		m_icurno++;
	}

	DisplayVehInstData();
//	ValidatePage();		// ?
	SetBusinessRules();	// ?
}

/******************************************************************************

	Name:		OnDeletecurve	

	Action:		

	Params:		

	Returns:	void

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
void CVehInstPage::OnDeletecurve() 
{
	if( ::GetKeyState( VK_RETURN ) < 0 ) { return; }

	if( m_icurno == 0 ) { return; }  // Can not delete zeroth curve.

	m_totalcurves--;

//	m_pVehData->m_totcrv = m_totalcurves;
	
	m_pVehData->m_Inst_vehno.RemoveAt(m_icurno);
	m_pVehData->m_senloc.RemoveAt(m_icurno);
	m_pVehData->m_sentyp.RemoveAt(m_icurno);
	m_pVehData->m_senatt.RemoveAt(m_icurno);
	m_pVehData->m_axis.RemoveAt(m_icurno); 
	m_pVehData->m_xunits.RemoveAt(m_icurno);
	m_pVehData->m_yunits.RemoveAt(m_icurno);
	m_pVehData->m_prefil.RemoveAt(m_icurno); 
	m_pVehData->m_insman.RemoveAt(m_icurno);
	m_pVehData->m_caldat.RemoveAt(m_icurno);
	m_pVehData->m_insrat.RemoveAt(m_icurno); 
	m_pVehData->m_chlmax.RemoveAt(m_icurno);
	m_pVehData->m_inivel.RemoveAt(m_icurno);
	m_pVehData->m_nfp.RemoveAt(m_icurno); 
	m_pVehData->m_nlp.RemoveAt(m_icurno); 
	m_pVehData->m_delt.RemoveAt(m_icurno);
	m_pVehData->m_dastat.RemoveAt(m_icurno); 
	m_pVehData->m_chstat.RemoveAt(m_icurno); 
	m_pVehData->m_inscom.RemoveAt(m_icurno); 

	m_icurno--;	// Goto previous curve 

	// If m_icurno == 0 now, and there are remaining curves,
	// set curve 1 as active ( m_icurno = 1 )
	if(	( m_icurno == 0 ) && ( m_totalcurves > 0 ) )
	{
		m_icurno = 1;
	}
		
	DisplayVehInstData();  // display previous set, if existing
}

/******************************************************************************

	Name:		OnSentypsearch	

	Action:		

	Params:		

	Returns:	void

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
void CVehInstPage::OnSentypsearch() 
{
	if( ::GetKeyState( VK_RETURN ) < 0 ) { return; }

	UpdateData( TRUE );  //First save data

	CSearch search( NULL, "SENTYP", "VEHDB" );
	if( search.DoModal() == IDOK )
	{
		m_sentyp = search_code;
		m_sentyp.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		OnSenlocsearch	

	Action:		

	Params:		

	Returns:	void	

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
void CVehInstPage::OnSenlocsearch() 
{
	if( ::GetKeyState( VK_RETURN ) < 0 ) { return; }

	UpdateData( TRUE );  //First save data

	CSearch search( NULL, "SENLOC", "VEHDB" );
	if( search.DoModal() == IDOK )
	{
		m_senloc = search_code;
		m_senloc.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		OnSenattsearch	

	Action:		

	Params:		

	Returns:	void

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
void CVehInstPage::OnSenattsearch() 
{
	if( ::GetKeyState( VK_RETURN ) < 0 ) { return; }

	UpdateData( TRUE );  //First save data

	CSearch search( NULL, "SENATT", "VEHDB" );
	if( search.DoModal() == IDOK )
	{
		m_senatt = search_code;
		m_senatt.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		OnAxissearch	

	Action:		

	Params:		

	Returns:	void

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
void CVehInstPage::OnAxissearch() 
{
	if( ::GetKeyState( VK_RETURN ) < 0 ) { return; }

	UpdateData( TRUE );  //First save data

	CSearch search( NULL, "AXIS", "VEHDB" );
	if( search.DoModal() == IDOK )
	{
		m_axis = search_code;
		m_axis.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		OnXunitssearch	

	Action:		

	Params:		

	Returns:	void

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
void CVehInstPage::OnXunitssearch() 
{
	if( ::GetKeyState( VK_RETURN ) < 0 ) { return; }

	UpdateData( TRUE );  //First save data

	CSearch search( NULL, "UNITS", "VEHDB" );
	if( search.DoModal() == IDOK )
	{
		m_xunits = search_code;
		m_xunits.SetValidateColor();

		// for the rule xunits!="SEC"
		COLORREF colorGreyBack = RGB( 192, 192, 192 );		
		COLORREF colorBlackText = RGB( 0, 0, 0 );
		if (search_code!="SEC") 
		{ 
			m_delt = "0";
			m_delt.SetColor(colorBlackText, colorGreyBack);
			m_delt.EnableWindow(false);
		}
		else 
		{ 
			m_delt.EnableWindow();
			COLORREF colorYellowBack = RGB( 255, 255, 0 );
			COLORREF colorWhiteBack = RGB( 255, 255, 255 );
			m_delt = m_pVehData->m_delt[m_icurno];			
			if (m_delt.GetValidate()) { m_delt.SetColor(colorBlackText, colorWhiteBack); }
			else { m_delt.SetColor(colorBlackText, colorYellowBack); }
		}
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		OnYunitssearch

	Action:		

	Params:		

	Returns:	void

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
void CVehInstPage::OnYunitssearch() 
{
	if( ::GetKeyState( VK_RETURN ) < 0 ) { return; }

	UpdateData( TRUE );  //First save data

	CSearch search(NULL,"UNITS","VEHDB");
	if( search.DoModal() == IDOK )
	{
		m_yunits = search_code;
		m_yunits.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		OnDastatsearch	

	Action:		

	Params:		

	Returns:	void

	Notes:	

	Dates:

******************************************************************************/
void CVehInstPage::OnDastatsearch() 
{
	if( ::GetKeyState( VK_RETURN ) < 0 ) { return; }

	UpdateData( TRUE );  //First save data

	CSearch search( NULL, "DASTAT", "VEHDB" );
	if( search.DoModal() == IDOK )
	{
		m_dastat = search_code;
		m_dastat.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		OnChstatsearch	

	Action:		

	Params:		

	Returns:	void

	Notes:	

	Dates:

******************************************************************************/
void CVehInstPage::OnChstatsearch() 
{
	if( ::GetKeyState( VK_RETURN ) < 0 ) { return; }

	UpdateData( TRUE );  //First save data

	CSearch search( NULL, "CHSTAT", "VEHDB" );
	if( search.DoModal() == IDOK )
	{
		m_chstat = search_code;
		m_chstat.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		LoadVehInstData	

	Action:		put data into m_pVehData

	Params:		void

	Returns:	BOOL

	Notes:	

	Dates:		This function gets the data from the entry fields and puts
				it into m_pVehData.  It is called in OnKillActive,
				ExportData, record changed.

******************************************************************************/
BOOL CVehInstPage::LoadVehInstData( void )
{
	if( m_hWnd == NULL ) { return TRUE; }	//only return FALSE if data invalid

	if( !UpdateData( TRUE ) ) 
	{
		return FALSE;
	}

	m_pVehData->m_Inst_vehno[m_icurno]	= m_vehno.GetTextAsString();
	m_pVehData->m_senloc[m_icurno]		= m_senloc.GetTextAsString();
	m_pVehData->m_sentyp[m_icurno]		= m_sentyp.GetTextAsString();
	m_pVehData->m_senatt[m_icurno]		= m_senatt.GetTextAsString();
	m_pVehData->m_axis[m_icurno]		= m_axis.GetTextAsString();
	m_pVehData->m_xunits[m_icurno]		= m_xunits.GetTextAsString();
	m_pVehData->m_yunits[m_icurno]		= m_yunits.GetTextAsString();
	m_pVehData->m_prefil[m_icurno]		= m_prefil.GetTextAsString();
	m_pVehData->m_insman[m_icurno]		= m_insman.GetTextAsString();

	CString caldate;
	GetDlgItemText( IDC_VEHINSTDAT, caldate );
	m_pVehData->m_caldat[m_icurno]	= caldate;

	m_pVehData->m_caldat[m_icurno]	= caldate;
	m_pVehData->m_insrat[m_icurno]	= m_insrat.GetTextAsString();
	m_pVehData->m_chlmax[m_icurno]	= m_chlmax.GetTextAsString();
	m_pVehData->m_inivel[m_icurno]	= m_inivel.GetTextAsString();
	m_pVehData->m_nfp[m_icurno]		= m_nfp.GetTextAsString();
	m_pVehData->m_nlp[m_icurno]		= m_nlp.GetTextAsString();
	m_pVehData->m_delt[m_icurno]	= m_delt.GetTextAsString();
	m_pVehData->m_dastat[m_icurno]	= m_dastat.GetTextAsString();
	m_pVehData->m_chstat[m_icurno]	= m_chstat.GetTextAsString();
	m_pVehData->m_inscom[m_icurno]	= m_inscom.GetTextAsString();

	m_pVehData->m_totcrv	= m_totalcurves;

	return TRUE;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:	Modify -- Wong on 03/03/2000

******************************************************************************/
bool CVehInstPage::InsertVehInstData( void )
{
	if( m_hWnd == NULL )
	{
		return TRUE;
	}  // Return FALSE if data invalid
	
	UpdateData();
 
	m_pVehData->m_Inst_vehno.InsertAt( m_icurno, m_vehno.GetTextAsString() );
	m_pVehData->m_senloc.InsertAt( m_icurno, m_senloc.GetTextAsString() );
	m_pVehData->m_sentyp.InsertAt( m_icurno, m_sentyp.GetTextAsString() );
	m_pVehData->m_senatt.InsertAt( m_icurno, m_senatt.GetTextAsString() );
	m_pVehData->m_axis.InsertAt( m_icurno, m_axis.GetTextAsString() );
	m_pVehData->m_xunits.InsertAt( m_icurno, m_xunits.GetTextAsString() );
	m_pVehData->m_yunits.InsertAt( m_icurno, m_yunits.GetTextAsString() );
	m_pVehData->m_prefil.InsertAt( m_icurno, m_prefil.GetTextAsString() );
	m_pVehData->m_insman.InsertAt( m_icurno, m_insman.GetTextAsString() );

	CString caldate;
	GetDlgItemText(IDC_VEHINST_CALDAT,caldate);
	m_pVehData->m_caldat.InsertAt( m_icurno, caldate );

	m_pVehData->m_insrat.InsertAt( m_icurno, m_insrat.GetTextAsString() );
	m_pVehData->m_chlmax.InsertAt( m_icurno, m_chlmax.GetTextAsString() );
	m_pVehData->m_inivel.InsertAt( m_icurno, m_inivel.GetTextAsString() );
	m_pVehData->m_nfp.InsertAt( m_icurno, m_nfp.GetTextAsString() );
	m_pVehData->m_nlp.InsertAt( m_icurno, m_nlp.GetTextAsString() );
	m_pVehData->m_delt.InsertAt( m_icurno, m_delt.GetTextAsString() );
	m_pVehData->m_dastat.InsertAt( m_icurno, m_dastat.GetTextAsString() );
	m_pVehData->m_chstat.InsertAt( m_icurno, m_chstat.GetTextAsString() );
	m_pVehData->m_inscom.InsertAt( m_icurno, m_inscom.GetTextAsString() );

	m_pVehData->m_totcrv = m_totalcurves;

	UpdateData( false );

	return true;
}

/******************************************************************************

	Name:		DisplayVehInstData

	Action:		Get data from m_pVehData and display it.	

	Params:		void

	Returns:	void

	Notes:	

	Dates:

******************************************************************************/
void CVehInstPage::DisplayVehInstData( void )
{
	if( m_hWnd == NULL ) { return; }

	UpdateCurveListbox();
	
	UpdateData();

	m_axis		= m_pVehData->m_axis [m_icurno];
	m_chlmax	= m_pVehData->m_chlmax[m_icurno];
	m_chstat	= m_pVehData->m_chstat[m_icurno];
	m_dastat	= m_pVehData->m_dastat[m_icurno];
	m_delt		= m_pVehData->m_delt[m_icurno];
	m_inivel	= m_pVehData->m_inivel [m_icurno];
	m_inscom	= m_pVehData->m_inscom[m_icurno];
	m_insman	= m_pVehData->m_insman[m_icurno];
	m_insrat	= m_pVehData->m_insrat[m_icurno];
	m_nfp		= m_pVehData->m_nfp[m_icurno];
	m_nlp		= m_pVehData->m_nlp[m_icurno];
	m_prefil	= m_pVehData->m_prefil[m_icurno];
	m_senatt	= m_pVehData->m_senatt[m_icurno];
	m_senloc	= m_pVehData->m_senloc[m_icurno];
	m_sentyp	= m_pVehData->m_sentyp[m_icurno];
	m_vehno		= m_pVehData->m_Inst_vehno[m_icurno];
	m_xunits	= m_pVehData->m_xunits [m_icurno];
	m_yunits	= m_pVehData->m_yunits [m_icurno];

	m_caldatctrl.SetTime( &( StringToTime( m_pVehData->m_caldat[m_icurno] ) ) );
	m_pVehData->m_caldat[m_icurno].MakeUpper();
	m_editinstdate	= m_pVehData->m_caldat[m_icurno];

	if (m_delt.GetValidate()) { m_delt.SetColor(RGB( 0, 0, 0 ), RGB( 255, 255, 255 )); }
	CCodeValidation( m_sentyp, "SENTYP","VEHDB" );
	CCodeValidation( m_senloc, "SENLOC","VEHDB" );
	CCodeValidation( m_senatt, "SENATT","VEHDB" );
	CCodeValidation( m_axis, "AXIS","VEHDB" );
	CCodeValidation( m_xunits, "UNITS","VEHDB" );
	CCodeValidation( m_yunits, "UNITS","VEHDB" );
	CCodeValidation( m_dastat, "DASTAT","VEHDB" );
	CCodeValidation( m_chstat, "CHSTAT","VEHDB" );

	UpdateData( FALSE );

	if (m_pVehData->m_xunits[m_icurno]=="SEC") { m_delt.EnableWindow(); }
	else 
	{ 
		m_delt.SetColor(RGB( 0, 0, 0 ), RGB( 192, 192, 192 ));
		m_delt.EnableWindow(false); 
	}
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehInstPage::OnSetActive() 
{
	//initialize total curves.
	m_totalcurves = max( m_pVehData->m_totcrv , 0 );

	SetBusinessRules();

	DisplayVehInstData();

	ValidatePage();
	
	return CPropertyPage::OnSetActive();
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehInstPage::OnKillActive() 
{
	if( ValidatePage() == true )
	{
		LoadVehInstData();

		int nOldCurIndx = m_icurno;

		for( m_icurno = 1; m_icurno < m_totalcurves + 1; m_icurno++ )
		{
			DisplayVehInstData();

			if( !ValidatePage() ) 
			{
				return false;
			}
		}

		m_icurno = nOldCurIndx;

		DisplayVehInstData();

		return CPropertyPage::OnKillActive();
	}
	else
	{
		// Error are found on AnthPage.
		return FALSE;
	}
}

/******************************************************************************

	Name:		OnInitDialog	

	Action:		

	Params:		void

	Returns:	BOOL

	Notes:		Return TRUE unless you set the focus to a control
				EXCEPTION: OCX Property Pages should return FALSE

	Dates:

******************************************************************************/
BOOL CVehInstPage::OnInitDialog( void ) 
{
	CPropertyPage::OnInitDialog();
	
	EnableToolTips();

	m_caldatctrl.SetFormat("dd'/'MMM'/'yyy");
	
	return TRUE;  
}

/******************************************************************************

	Name:		InitializeNextCurve

	Action:		new curve, expand arrays in m_pVehData to hold new info

	Params:		void

	Returns:	void

	Notes:		These temp variables are used because the reference that
				[] returns is invalid when SetAtGrow happens, because 
				SetAtGrow (sometimes) moves the array to a different location
				in memory. If you try to use that reference directly, you will
				get an access violation.

			For Example:
			m_pVehData->m_inscom.SetAtGrow( m_icurno,
											m_pVehData->inscom[m_icurno-1]);

	Dates:

******************************************************************************/
void CVehInstPage::InitializeNextCurve( void )
{
	if( m_retaindata )
	{
		CString temp = m_pVehData->m_Inst_vehno[m_icurno -1];
		m_pVehData->m_Inst_vehno.SetAtGrow(m_icurno, temp);
		temp = m_pVehData->m_senloc[m_icurno -1];
		m_pVehData->m_senloc.SetAtGrow(m_icurno, temp);
		temp = m_pVehData->m_sentyp[m_icurno -1];
		m_pVehData->m_sentyp.SetAtGrow(m_icurno, temp);
		temp = m_pVehData->m_senatt[m_icurno -1];
		m_pVehData->m_senatt.SetAtGrow(m_icurno, temp);
		temp = m_pVehData->m_axis[m_icurno -1];
		m_pVehData->m_axis.SetAtGrow(m_icurno, temp); 
		temp = m_pVehData->m_xunits[m_icurno -1];
		m_pVehData->m_xunits.SetAtGrow(m_icurno, temp);
		temp = m_pVehData->m_yunits[m_icurno -1];
		m_pVehData->m_yunits.SetAtGrow(m_icurno, temp);
		temp = m_pVehData->m_prefil [m_icurno - 1];
		m_pVehData->m_prefil.SetAtGrow(m_icurno, temp); 
		temp = m_pVehData->m_insman [m_icurno -1];
		m_pVehData->m_insman.SetAtGrow(m_icurno, temp);
		temp = m_pVehData->m_caldat [m_icurno -1];
		m_pVehData->m_caldat.SetAtGrow(m_icurno, temp);
		temp = m_pVehData->m_insrat [m_icurno-1];
		m_pVehData->m_insrat.SetAtGrow(m_icurno, temp);
		temp = m_pVehData->m_chlmax [m_icurno -1];
		m_pVehData->m_chlmax.SetAtGrow(m_icurno, temp);
		temp = m_pVehData->m_inivel[m_icurno -1];
		m_pVehData->m_inivel.SetAtGrow(m_icurno, temp);
		temp =  m_pVehData->m_nfp [m_icurno -1];
		m_pVehData->m_nfp.SetAtGrow(m_icurno, temp); 
		temp = m_pVehData->m_nlp [m_icurno -1];
		m_pVehData->m_nlp.SetAtGrow(m_icurno, temp); 
		temp = m_pVehData->m_delt [m_icurno -1];
		m_pVehData->m_delt.SetAtGrow(m_icurno, temp);
		temp = m_pVehData->m_dastat[m_icurno -1];
		m_pVehData->m_dastat.SetAtGrow(m_icurno, temp);
		temp =  m_pVehData->m_chstat[m_icurno -1];
		m_pVehData->m_chstat.SetAtGrow(m_icurno, temp); 
		temp = m_pVehData->m_inscom [m_icurno -1];
		m_pVehData->m_inscom.SetAtGrow(m_icurno, temp); 
	}
	else
	{
		m_pVehData->m_Inst_vehno.SetAtGrow(m_icurno, "1" );
		m_pVehData->m_senloc.SetAtGrow(m_icurno,"" );
		m_pVehData->m_sentyp.SetAtGrow(m_icurno,"" );
		m_pVehData->m_senatt.SetAtGrow(m_icurno,"" );
		m_pVehData->m_axis.SetAtGrow(m_icurno,"" ); 
		m_pVehData->m_xunits.SetAtGrow(m_icurno,"SEC");
		m_pVehData->m_yunits.SetAtGrow(m_icurno,"" );
		m_pVehData->m_prefil.SetAtGrow(m_icurno, "" ); 
		m_pVehData->m_insman.SetAtGrow(m_icurno,"" );
		m_pVehData->m_caldat.SetAtGrow(m_icurno,"" );
		m_pVehData->m_insrat.SetAtGrow(m_icurno, "" ); 
		m_pVehData->m_chlmax.SetAtGrow(m_icurno, "" );
		m_pVehData->m_inivel.SetAtGrow(m_icurno, "" );
		m_pVehData->m_nfp.SetAtGrow(m_icurno, "" );
		m_pVehData->m_nlp.SetAtGrow(m_icurno, "" ); 
		m_pVehData->m_delt.SetAtGrow(m_icurno, "" );
		m_pVehData->m_dastat.SetAtGrow(m_icurno,"" ); 
		m_pVehData->m_chstat.SetAtGrow(m_icurno,"" ); 
		m_pVehData->m_inscom.SetAtGrow(m_icurno,"" ); 

		// Here, just set the control to today.
		CTime now;
		now= CTime::GetCurrentTime ();
		m_caldatctrl.SetTime(&now);
	}
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehInstPage::UpdateCurveListbox()
{
	if( m_curvelist.GetCount() != m_totalcurves )
	{
		m_curvelist.ResetContent();
		char crvbuf [10];
		for( int loop = 1; loop <= m_totalcurves; loop++ )
		{
			// If buffer is not there already.
			itoa( loop, crvbuf, 10 );
			if( m_curvelist.FindString( -1, crvbuf ) == LB_ERR )  
			{
				m_curvelist.AddString( crvbuf );
			}
		}
	}

	// select current curve, zero based.
	m_curvelist.SetCurSel( max( 0, m_icurno - 1 ) );  
}

/******************************************************************************

	Name:		OnSelchangeCurvelist

	Action:		

	Params:		

	Returns:	void

	Notes:		user clicked the curves listbox, so change to that curve

	Dates:

******************************************************************************/
void CVehInstPage::OnSelchangeCurvelist() 
{
	SelchangeCurvelist();
}

void CVehInstPage::SelchangeCurvelist( void )
{
	int nCurve = m_curvelist.GetCurSel();  // Zero based

	if( m_icurno != 0 ) 
	{
		// Load current info (not zeroth curve)
		// Data not valid, dont change curves.
		if( !LoadVehInstData() )
		{
			// Select current curve, zero based.
			m_curvelist.SetCurSel( max( 0, m_icurno - 1 ) );  
			return;
		}
	}

	m_icurno = nCurve + 1;	// Goto current curve 

	DisplayVehInstData();	// Display next set, if existing
	


//	ValidatePage();			// ?
//	SetBusinessRules();		// ?
}

/******************************************************************************

	Name:		OnHelpInfo	

	Action:		

	Params:		HELPINFO *	

	Returns:	BOOL

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehInstPage::OnHelpInfo( HELPINFO * pHelpInfo ) 
{
	WinHelp( Instrumentation );
	
	return TRUE;
}

/******************************************************************************

	Name:		ValidatePage	

	Action:		

	Params:		void

	Returns:	bool

	Notes:		0 = Number
				1 = String
				2 = Float

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
bool CVehInstPage::ValidatePage( void )
{
	const int nTotal = 19;
	bool bRetArray[nTotal];

	bRetArray[0] = m_inscom.GetValidate();
	bRetArray[1] = m_insman.GetValidate();
	bRetArray[2] = m_vehno.GetValidate();
	bRetArray[3] = m_prefil.GetValidate();
	bRetArray[4] = m_insrat.GetValidate();
	bRetArray[5] = m_chlmax.GetValidate();
	bRetArray[6] = m_nfp.GetValidate();
	bRetArray[7] = m_nlp.GetValidate();
	bRetArray[8] = m_delt.GetValidate();
	bRetArray[9] = m_inivel.GetValidate();
	bRetArray[10] = m_editinstdate.GetValidate();

	bRetArray[11]	= m_sentyp.GetValidate();
	bRetArray[12]	= m_senloc.GetValidate();
	bRetArray[13]	= m_senatt.GetValidate();
	bRetArray[14]	= m_axis.GetValidate();
	bRetArray[15]	= m_xunits.GetValidate();
	bRetArray[16]	= m_yunits.GetValidate();
	bRetArray[17]	= m_dastat.GetValidate();
	bRetArray[18]	= m_chstat.GetValidate();

	for( int i = 0; i < nTotal; i++ )
	{
		if( !bRetArray[i] )
		{
			return false;
		}
	}

	return true;
}

/******************************************************************************

	Name:		SetBusinessRules

	Action:		

	Params:		void

	Returns:	void

	Notes:		0 = Number
				1 = String

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
void CVehInstPage::SetBusinessRules( void )
{
	m_inscom.SetString( 0, 70, true );
	m_insman.SetString( 0, 70, true );
	m_vehno.SetDouble( 0, 2, true );
	m_prefil.SetDouble( 0.0, 99999.0, true );
	m_insrat.SetDouble( -999999.0, 999999.0, true );
	m_chlmax.SetDouble( 0, 999, true );
	m_nfp.SetDouble( -10000.0, 0.0, true );
	m_nlp.SetDouble( 0.0, 99999.0, true );
	m_delt.SetDouble( 0.0, 999999.0, true );
	m_inivel.SetDouble( -200.0, 200.0, true );
	m_editinstdate.SetDate();
}

/******************************************************************************

	Name:		OnDatetimechangeVehinstCaldat	

	Action:		

	Params:		NMHDR *, LRESULT *

	Returns:	void

	Notes:		

	Dates:		

******************************************************************************/
void CVehInstPage::OnDatetimechangeVehinstCaldat( NMHDR * pNMHDR, LRESULT * pResult )  
{
	CString sDate;
    GetDlgItemText( IDC_VEHINST_CALDAT, sDate );

	sDate.MakeUpper();
	m_editinstdate = m_pVehData->m_caldat[m_icurno] = sDate;
	
	*pResult = 0;
}
