#if !defined(AFX_VEHINSTPAGE_H__0278173A_6367_11D2_9493_0008C7AA9033__INCLUDED_)
#define AFX_VEHINSTPAGE_H__0278173A_6367_11D2_9493_0008C7AA9033__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "VehData.h"
#include "EditEx.h"
// VehInstPage.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CVehInstPage dialog

class CVehInstPage : public CPropertyPage
{
	DECLARE_DYNCREATE(CVehInstPage)

// Construction
public:
	CVehInstPage();
	~CVehInstPage();

	void	UpdateCurveListbox();
	void	InitializeNextCurve();
	
	void	DisplayVehInstData();
	BOOL	LoadVehInstData();
	bool	InsertVehInstData();

	bool ValidatePage( void );
	void SetBusinessRules( void );

	int			m_totalcurves;
	int			m_icurno;
	CVehData *	m_pVehData;


// Dialog Data
	//{{AFX_DATA(CVehInstPage)
	enum { IDD = IDD_VEH_INST_PAGE };
	CNEdit	m_editinstdate;
	CListBox	m_curvelist;
	CButton	m_previousrecordbutton;
	CButton	m_nextrecordbutton;
	CButton	m_lastrecordbutton;
	CButton	m_firstrecordbutton;
	CButton	m_deletecurvebutton;
	CDateTimeCtrl	m_caldatctrl;
	BOOL	m_retaindata;
	CNEdit	m_axis;
	CNEdit	m_chstat;
	CNEdit	m_curno;
	CNEdit	m_dastat;
	CNEdit	m_inscom;
	CNEdit	m_insman;
	CNEdit	m_senatt;
	CNEdit	m_senloc;
	CNEdit	m_sentyp;
	CNEdit	m_xunits;
	CNEdit	m_yunits;
	CNEdit	m_vehno;
	CNEdit	m_prefil;
	CNEdit	m_insrat;
	CNEdit	m_chlmax;
	CNEdit	m_nfp;
	CNEdit	m_nlp;
	CNEdit	m_delt;
	CNEdit	m_inivel;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CVehInstPage)
	public:
	virtual BOOL OnSetActive();
	virtual BOOL OnKillActive();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CVehInstPage)
	afx_msg void OnNextrecord();
	afx_msg void OnDeletecurve();
	afx_msg void OnSentypsearch();
	afx_msg void OnSenlocsearch();
	afx_msg void OnSenattsearch();
	afx_msg void OnAxissearch();
	afx_msg void OnXunitssearch();
	afx_msg void OnYunitssearch();
	afx_msg void OnDastatsearch();
	afx_msg void OnChstatsearch();
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeCurvelist();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	afx_msg BOOL OnToolTipNotify(UINT, NMHDR *, LRESULT *);
	afx_msg void OnDatetimechangeVehinstCaldat(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()


public:
	void SelchangeCurvelist( void );

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VEHINSTPAGE_H__0278173A_6367_11D2_9493_0008C7AA9033__INCLUDED_)
