// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: VehOccPage.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description:  Member functions of CVehOccPage.
//               They relate to the loading and display of 
//               data on this page.
//
//  Modification History:
//  Date		Who			Description
//  03/03/00	Yeun Wong	add info data insertion and correct info data indexing
// -----------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "VehOccPage.h"
#include "search.h"
#include "CodeValidation.h"

#include "ClearanceDist.h"
#include "Peakload.h"
#include "Injmeas.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern CString search_code;

/////////////////////////////////////////////////////////////////////////////
// CVehOccPage property page

IMPLEMENT_DYNCREATE(CVehOccPage, CPropertyPage)

//*****************************************************************************
//
//	Name:		
//	Action:		
//	Params:		
//	Returns:	
//	Notes:	
//	Dates:
//
//*****************************************************************************
CVehOccPage::CVehOccPage() : CPropertyPage(CVehOccPage::IDD)
{
	//{{AFX_DATA_INIT(CVehOccPage)
	m_cntrc1		= _T("");
	m_cntrc2		= _T("");
	m_cntrh1		= _T("");
	m_cntrh2		= _T("");
	m_cntrl1		= _T("");
	m_cntrl2		= _T("");
	m_dumdsc		= _T("");
	m_dumman		= _T("");
	m_dummod		= _T("");
	m_dumsiz		= _T("");
	m_mthcal		= _T("");
	m_occcom		= _T("");
	m_occloc		= _T("");
	m_occsex		= _T("");
	m_occtyp		= _T("");
	m_seposn		= _T("");
	m_retaindata	= FALSE;
	m_vehno			= _T("");
	m_occage		= _T("");
	m_occwt			= _T("");
	m_occht			= _T("");
	//}}AFX_DATA_INIT

	m_curocc = 0;
	bClearancedist = false;
	bPeakloads = false;
	bInjmeas = false;
}

//*****************************************************************************
//
//	Name:		
//	Action:		
//	Params:		
//	Returns:	
//	Notes:	
//	Dates:
//
//*****************************************************************************
CVehOccPage::~CVehOccPage()
{
}

//*****************************************************************************
//
//	Name:		
//	Action:		
//	Params:		
//	Returns:	
//	Notes:	
//	Dates:
//
//*****************************************************************************
void CVehOccPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVehOccPage)
	DDX_Control(pDX, IDC_EDIT_PEAK, m_editPeak);
	DDX_Control(pDX, IDC_EDIT_INJURY, m_editInjury);
	DDX_Control(pDX, IDC_EDIT_CLEARANCE, m_editClearance);
	DDX_Control(pDX, IDC_OCCLIST, m_occlist);
	DDX_Control(pDX, IDC_INJMEAS, m_injmeas);
	DDX_Control(pDX, IDC_CLEARANCEDIST, m_clearancedist);
	DDX_Control(pDX, IDC_PEAKLOADS, m_peakloads);
	DDX_Control(pDX, IDC_NEXTSET_BUTTON, m_nextsetbutton);
	DDX_Control(pDX, IDC_DELETE_BUTTON, m_deletebutton);
	DDX_Control(pDX, IDC_VEHOCC_CNTRC1, m_cntrc1);
	DDX_Control(pDX, IDC_VEHOCC_CNTRC2, m_cntrc2);
	DDX_Control(pDX, IDC_VEHOCC_CNTRH1, m_cntrh1);
	DDX_Control(pDX, IDC_VEHOCC_CNTRH2, m_cntrh2);
	DDX_Control(pDX, IDC_VEHOCC_CNTRL1, m_cntrl1);
	DDX_Control(pDX, IDC_VEHOCC_CNTRL2, m_cntrl2);
	DDX_Control(pDX, IDC_VEHOCC_DUMDSC, m_dumdsc);
	DDX_Control(pDX, IDC_VEHOCC_DUMMAN, m_dumman);
	DDX_Control(pDX, IDC_VEHOCC_DUMMOD, m_dummod);
	DDX_Control(pDX, IDC_VEHOCC_DUMSIZ, m_dumsiz);
	DDX_Control(pDX, IDC_VEHOCC_MTHCAL, m_mthcal);
	DDX_Control(pDX, IDC_VEHOCC_OCCCOM, m_occcom);
	DDX_Control(pDX, IDC_VEHOCC_OCCLOC, m_occloc);
	DDX_Control(pDX, IDC_VEHOCC_OCCSEX, m_occsex);
	DDX_Control(pDX, IDC_VEHOCC_OCCTYP, m_occtyp);
	DDX_Control(pDX, IDC_VEHOCC_SEPOSN, m_seposn);
	DDX_Check(pDX, IDC_RETAINDATA, m_retaindata);
	DDX_Control(pDX, IDC_VEHOCC_VEHNO, m_vehno);
	DDX_Control(pDX, IDC_VEHOCC_OCCAGE, m_occage);
	DDX_Control(pDX, IDC_VEHOCC_OCCWT, m_occwt);
	DDX_Control(pDX, IDC_VEHOCC_OCCHT, m_occht);
	//}}AFX_DATA_MAP
}

//*****************************************************************************
//
//	Name:		
//	Action:		
//	Params:		
//	Returns:	
//	Notes:	
//	Dates:
//
//*****************************************************************************
BEGIN_MESSAGE_MAP(CVehOccPage, CPropertyPage)
	//{{AFX_MSG_MAP(CVehOccPage)
	ON_BN_CLICKED(IDC_CLEARANCEDIST, OnClearancedist)
	ON_BN_CLICKED(IDC_OCCLOCSEARCH, OnOcclocsearch)
	ON_BN_CLICKED(IDC_OCCTYPSEARCH, OnOcctypsearch)
	ON_BN_CLICKED(IDC_OCCSEXSEARCH, OnOccsexsearch)
	ON_BN_CLICKED(IDC_MTHCALSEARCH, OnMthcalsearch)
	ON_BN_CLICKED(IDC_DUMSIZSEARCH, OnDumsizsearch)
	ON_BN_CLICKED(IDC_SEPOSNSEARCH, OnSeposnsearch)
	ON_BN_CLICKED(IDC_CNTRH1SEARCH, OnCntrh1search)
	ON_BN_CLICKED(IDC_CNTRH2SEARCH, OnCntrh2search)
	ON_BN_CLICKED(IDC_CNTRC1SEARCH, OnCntrc1search)
	ON_BN_CLICKED(IDC_CNTRC2SEARCH, OnCntrc2search)
	ON_BN_CLICKED(IDC_CNTRL1SEARCH, OnCntrl1search)
	ON_BN_CLICKED(IDC_CNTRL2SEARCH, OnCntrl2search)
	ON_BN_CLICKED(IDC_NEXTSET_BUTTON, OnNextsetButton)
	ON_BN_CLICKED(IDC_DELETE_BUTTON, OnDeleteButton)
	ON_BN_CLICKED(IDC_PEAKLOADS, OnPeakloads)
	ON_BN_CLICKED(IDC_INJMEAS, OnInjmeas)
	ON_LBN_SELCHANGE(IDC_OCCLIST, OnSelchangeOcclist)
	ON_WM_HELPINFO()
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTW, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTA, 0, 0xFFFF, OnToolTipNotify )
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVehOccPage message handlers

//*****************************************************************************
//
//	Name:		
//	Action:		
//	Params:		
//	Returns:	
//	Notes:	
//	Dates:
//
//*****************************************************************************
BOOL CVehOccPage::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
	TOOLTIPTEXTA* pTTTA = (TOOLTIPTEXTA*)pNMHDR;
	TOOLTIPTEXTW* pTTTW = (TOOLTIPTEXTW*)pNMHDR;
	CString strTipText = "";
	UINT nID = pNMHDR->idFrom;
	if (pNMHDR->code == TTN_NEEDTEXTA && (pTTTA->uFlags & TTF_IDISHWND) ||
		pNMHDR->code == TTN_NEEDTEXTW && (pTTTW->uFlags & TTF_IDISHWND))
	{
		// idFrom is actually the HWND of the tool
		nID = ::GetDlgCtrlID((HWND)nID);
	}

	if (nID != 0) // will be zero on a separator
	{
		strTipText.Format("Control ID = %d", nID);
		switch (nID)
		{
		case IDC_CLEARANCEDIST:
			strTipText = "Set Clearance Distance Values";
			break;
		case IDC_VEHOCC_OCCHT:
			strTipText = "mm (0->9999)";
			break;
		case IDC_VEHOCC_VEHNO:
			strTipText = "1->2";
			break;
		case IDC_VEHOCC_OCCAGE:
			strTipText = "0->99";
			break;
		case IDC_VEHOCC_HIC:
			strTipText = "0->9999";
			break;
		case IDC_VEHOCC_CSI:
			strTipText = "0->9999";
			break;
		case IDC_VEHOCC_CLIP3M:
			strTipText = "Acceleration (g, 00000.00->99999.99)";
			break;
		case IDC_VEHOCC_OCCWT:
			strTipText = "kg (0->999)";
			break;
		case IDC_VEHOCC_LFEM:
			strTipText = "newtons (-99999->0)";
			break;
		case IDC_VEHOCC_RFEM:
			strTipText = "newtons (-99999->0)";
			break;
		case IDC_VEHOCC_LBELT:
			strTipText = "newtons (0->99999)";
			break;
		case IDC_VEHOCC_SBELT:
			strTipText = "newtons (0->99999)";
			break;
		case IDC_VEHOCC_T1:
			strTipText = "ms (000000.00->999999.99)";
			break;
		case IDC_VEHOCC_T2:
			strTipText = "ms (000000.00->999999.99)";
			break;
		case IDC_VEHOCC_PELVG:
			strTipText = "00000.00->99999.99";
			break;
		case IDC_VEHOCC_TTI:
			strTipText = "Acceleration (g, 00000.00->99999.99)";
			break;
		case IDC_NEXTSET_BUTTON:
			strTipText = "Advance to Next Occupant Info Set";
			break;
		case IDC_DELETE_BUTTON:
			strTipText = "Delete Set";
			break;
		default:
			strTipText = "";
		}
	}

	if (pNMHDR->code == TTN_NEEDTEXTA)
		lstrcpyn(pTTTA->szText, strTipText, sizeof(pTTTA->szText));
	else
		::MultiByteToWideChar( CP_ACP , 0, strTipText, -1, pTTTW->szText, sizeof(pTTTW->szText) );
	*pResult = 0;

	return TRUE;    // message was handled
}

//Display Clearance dist dlg to collect that info.
//*****************************************************************************
//
//	Name:		
//	Action:		
//	Params:		
//	Returns:	
//	Notes:	
//	Dates:
//
//*****************************************************************************
void CVehOccPage::OnClearancedist() 
{
	CClearanceDist clearance(m_pVehData, m_curocc);

	if(clearance.DoModal() == IDOK )
	{
		m_pVehData->m_ad[m_curocc]	= clearance.m_ad.GetTextAsString();
		m_pVehData->m_cb[m_curocc]	= clearance.m_cb.GetTextAsString();
		m_pVehData->m_cd[m_curocc]	= clearance.m_cd.GetTextAsString();
		m_pVehData->m_cs[m_curocc]	= clearance.m_cs.GetTextAsString();
		m_pVehData->m_hb[m_curocc]	= clearance.m_hb.GetTextAsString();
		m_pVehData->m_hd[m_curocc]	= clearance.m_hd.GetTextAsString();
		m_pVehData->m_hh[m_curocc]	= clearance.m_hh.GetTextAsString();
		m_pVehData->m_hr[m_curocc]	= clearance.m_hr.GetTextAsString();
		m_pVehData->m_hs[m_curocc]	= clearance.m_hs.GetTextAsString();
		m_pVehData->m_hw[m_curocc]	= clearance.m_hw.GetTextAsString();
		m_pVehData->m_kb[m_curocc]	= clearance.m_kb.GetTextAsString();
		m_pVehData->m_kd[m_curocc]	= clearance.m_kd.GetTextAsString();
		m_pVehData->m_nb[m_curocc]	= clearance.m_nb.GetTextAsString();
	}

	if( clearance.m_bValidate == false )
	{
		COLORREF	clText	= RGB( 0, 0, 0 );
		COLORREF	clBkg	= RGB( 255, 0, 0 );

		m_editClearance = "ERROR";

		m_editClearance.SetColor( clText, clBkg );

		m_editClearance.ShowWindow( SW_SHOW );

		bClearancedist = false;
	}
	else
	{
		COLORREF	clText	= RGB( 0, 0, 0 );
		COLORREF	clBkg	= RGB( 255, 255, 255 );

		m_editClearance = "";

		m_editClearance.SetColor( clText, clBkg );

		m_editClearance.ShowWindow( SW_HIDE );

		bClearancedist = true;
	}	
}

//*****************************************************************************
//
//	Name:		
//	Action:		
//	Params:		
//	Returns:	
//	Notes:	
//	Dates:
//
//*****************************************************************************
bool CVehOccPage::Clearancedist( void )
{
	CClearanceDist clearance(m_pVehData, m_curocc);

	clearance.m_bDisplay = false;
	clearance.DoModal();

	if( clearance.m_bValidate == false )
	{
		COLORREF	clText	= RGB( 0, 0, 0 );
		COLORREF	clBkg	= RGB( 255, 0, 0 );

		m_editClearance = "ERROR";

		m_editClearance.SetColor( clText, clBkg );

		m_editClearance.ShowWindow( SW_SHOW );

		bClearancedist = false;

		return false;
	}
	else
	{
		COLORREF	clText	= RGB( 0, 0, 0 );
		COLORREF	clBkg	= RGB( 255, 255, 255 );

		m_editClearance = "";

		m_editClearance.SetColor( clText, clBkg );

		m_editClearance.ShowWindow( SW_HIDE );

		bClearancedist = true;

		return true;
	}
}

//*****************************************************************************
//
//	Name:		
//	Action:		
//	Params:		
//	Returns:	
//	Notes:	
//	Dates:
//
//*****************************************************************************
void CVehOccPage::OnOcclocsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"OCCLOC","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_occloc = search_code;
		m_occloc.SetValidateColor();
	}
	UpdateData(FALSE);
}

//*****************************************************************************
//
//	Name:		
//	Action:		
//	Params:		
//	Returns:	
//	Notes:	
//	Dates:
//
//*****************************************************************************
void CVehOccPage::OnOcctypsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"OCCTYP","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_occtyp = search_code;
		m_occtyp.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehOccPage::OnOccsexsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"OCCSEX","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_occsex = search_code;
		m_occsex.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehOccPage::OnMthcalsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"MTHCAL","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_mthcal = search_code;
		m_mthcal.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehOccPage::OnDumsizsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"DUMSIZ","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_dumsiz = search_code;
		m_dumsiz.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehOccPage::OnSeposnsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"SEPOSN","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_seposn = search_code;
		m_seposn.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehOccPage::OnCntrh1search() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"CNTRH1","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_cntrh1 = search_code;
		m_cntrh1.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehOccPage::OnCntrh2search() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"CNTRH2","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_cntrh2 = search_code;
		m_cntrh2.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehOccPage::OnCntrc1search() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"CNTRC1","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_cntrc1 = search_code;
		m_cntrc1.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehOccPage::OnCntrc2search() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"CNTRC2","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_cntrc2 = search_code;
		m_cntrc2.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehOccPage::OnCntrl1search() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"CNTRL1","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_cntrl1 = search_code;
		m_cntrl1.SetValidateColor();
	}
	UpdateData(FALSE);
}

//*****************************************************************************
//
//	Name:		
//	Action:		
//	Params:		
//	Returns:	
//	Notes:	
//	Dates:
//
//*****************************************************************************/
void CVehOccPage::OnCntrl2search() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"CNTRL2","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_cntrl2 = search_code;
		m_cntrl2.SetValidateColor();
	}
	UpdateData(FALSE);
}

//*****************************************************************************
//
//	Name:		LoadVehOccData
//	Action:		
//	Params:		void
//	Returns:	BOOL
//	Notes:		This function gets the data from the entry fields and 
//				puts it into m_pVehData.  It is called in 
//				OnKillActive, ExportData, record changed.
//	Dates:
//
//*****************************************************************************
BOOL CVehOccPage::LoadVehOccData( void )
{
	//put data into m_pVehData

	if (m_hWnd==NULL) return TRUE;  // only return FALSE if data invalid
	if (!UpdateData(TRUE))  return FALSE;

	m_pVehData->m_Occ_vehno[m_curocc]	= m_vehno.GetTextAsString();
	m_pVehData->m_occloc[m_curocc]		= m_occloc.GetTextAsString();
	m_pVehData->m_occtyp[m_curocc]		= m_occtyp.GetTextAsString();
	m_pVehData->m_occage[m_curocc]		= m_occage.GetTextAsString();
	m_pVehData->m_occsex[m_curocc]		= m_occsex.GetTextAsString();
	m_pVehData->m_occht[m_curocc]		= m_occht.GetTextAsString();
	m_pVehData->m_occwt[m_curocc]		= m_occwt.GetTextAsString();
	m_pVehData->m_mthcal[m_curocc]		= m_mthcal.GetTextAsString();
	m_pVehData->m_dumsiz[m_curocc]		= m_dumsiz.GetTextAsString();
	m_pVehData->m_dumman[m_curocc]		= m_dumman.GetTextAsString();
	m_pVehData->m_dummod[m_curocc]		= m_dummod.GetTextAsString();
	m_pVehData->m_dumdsc[m_curocc]		= m_dumdsc.GetTextAsString();
	m_pVehData->m_seposn[m_curocc]		= m_seposn.GetTextAsString();
	m_pVehData->m_cntrh1[m_curocc]		= m_cntrh1.GetTextAsString();
	m_pVehData->m_cntrh2[m_curocc]		= m_cntrh2.GetTextAsString();
	m_pVehData->m_cntrc1[m_curocc]		= m_cntrc1.GetTextAsString();
	m_pVehData->m_cntrc2[m_curocc]		= m_cntrc2.GetTextAsString();
	m_pVehData->m_cntrl1[m_curocc]		= m_cntrl1.GetTextAsString();
	m_pVehData->m_cntrl2[m_curocc]		= m_cntrl2.GetTextAsString();
	m_pVehData->m_occcom[m_curocc]		= m_occcom.GetTextAsString();

	m_pVehData->m_occsets = m_totaloccsets;

	return TRUE;
}

//*****************************************************************************
//
//	Name:		
//	Action:		
//	Params:		
//	Returns:	
//	Notes:	
//	Dates:		wong code in 03/03/2000
//
//*****************************************************************************
bool CVehOccPage::InsertVehOccData()
{
	if (m_hWnd==NULL) return TRUE;  // only return FALSE if data invalid
	
	UpdateData();
 
	m_pVehData->m_Occ_vehno.InsertAt( m_curocc, m_vehno.GetTextAsString() );
	m_pVehData->m_occloc.InsertAt( m_curocc, m_occloc.GetTextAsString() );
	m_pVehData->m_occtyp.InsertAt( m_curocc, m_occtyp.GetTextAsString() );
	m_pVehData->m_occage.InsertAt( m_curocc, m_occage.GetTextAsString() );
	m_pVehData->m_occsex.InsertAt( m_curocc, m_occsex.GetTextAsString() );
	m_pVehData->m_occht.InsertAt( m_curocc, m_occht.GetTextAsString() );
	m_pVehData->m_occwt.InsertAt( m_curocc, m_occwt.GetTextAsString() );
	m_pVehData->m_mthcal.InsertAt( m_curocc, m_mthcal.GetTextAsString() );
	m_pVehData->m_dumsiz.InsertAt( m_curocc, m_dumsiz.GetTextAsString() );
	m_pVehData->m_dumman.InsertAt( m_curocc, m_dumman.GetTextAsString() );
	m_pVehData->m_dummod.InsertAt( m_curocc, m_dummod.GetTextAsString() );
	m_pVehData->m_dumdsc.InsertAt( m_curocc, m_dumdsc.GetTextAsString() );
	m_pVehData->m_seposn.InsertAt( m_curocc, m_seposn.GetTextAsString() );
	m_pVehData->m_cntrh1.InsertAt( m_curocc, m_cntrh1.GetTextAsString() );
	m_pVehData->m_cntrh2.InsertAt( m_curocc, m_cntrh2.GetTextAsString() );
	m_pVehData->m_cntrc1.InsertAt( m_curocc, m_cntrc1.GetTextAsString() );
	m_pVehData->m_cntrc2.InsertAt( m_curocc, m_cntrc2.GetTextAsString() );
	m_pVehData->m_cntrl1.InsertAt( m_curocc, m_cntrl1.GetTextAsString() );
	m_pVehData->m_cntrl2.InsertAt( m_curocc, m_cntrl2.GetTextAsString() );
	m_pVehData->m_occcom.InsertAt( m_curocc, m_occcom.GetTextAsString() );

	m_pVehData->m_occsets = m_totaloccsets;

	UpdateData(false);

	return true;
}	// InsertVehOccData

//Get data from m_pVehData and display it.
//*****************************************************************************
//
//	Name:		
//	Action:		
//	Params:		
//	Returns:	
//	Notes:	
//	Dates:
//
//*****************************************************************************
void CVehOccPage::DisplayVehOccData()
{
	if (m_hWnd==NULL) return;

	UpdateCurveListbox();

	UpdateData();

	m_vehno		= m_pVehData->m_Occ_vehno[m_curocc];
	m_occloc	= m_pVehData->m_occloc[m_curocc];
	m_occtyp	= m_pVehData->m_occtyp[m_curocc];
	m_occage	= m_pVehData->m_occage[m_curocc];
	m_occsex	= m_pVehData->m_occsex[m_curocc];
	m_occht		= m_pVehData->m_occht[m_curocc];
	m_occwt		= m_pVehData->m_occwt[m_curocc];
	m_mthcal	= m_pVehData->m_mthcal[m_curocc];
	m_dumsiz	= m_pVehData->m_dumsiz[m_curocc];
	m_dumman	= m_pVehData->m_dumman[m_curocc];
	m_dummod	= m_pVehData->m_dummod[m_curocc];
	m_dumdsc	= m_pVehData->m_dumdsc[m_curocc];
	m_seposn	= m_pVehData->m_seposn[m_curocc];
	m_cntrh1	= m_pVehData->m_cntrh1[m_curocc];
	m_cntrh2	= m_pVehData->m_cntrh2[m_curocc];
	m_cntrc1	= m_pVehData->m_cntrc1[m_curocc];
	m_cntrc2	= m_pVehData->m_cntrc2[m_curocc];
	m_cntrl1	= m_pVehData->m_cntrl1[m_curocc];
	m_cntrl2	= m_pVehData->m_cntrl2[m_curocc];
	m_occcom	= m_pVehData->m_occcom[m_curocc];

	CCodeValidation( m_occloc, "OCCLOC","VEHDB" );
	CCodeValidation( m_occtyp, "OCCTYP","VEHDB" );
	CCodeValidation( m_occsex, "OCCSEX","VEHDB" );
	CCodeValidation( m_mthcal, "MTHCAL","VEHDB" );
	CCodeValidation( m_dumsiz, "DUMSIZ","VEHDB" );

	CCodeValidation( m_seposn, "SEPOSN","VEHDB" );
	CCodeValidation( m_cntrh1, "CNTRH1","VEHDB" );
	CCodeValidation( m_cntrh2, "CNTRH2","VEHDB" );
	CCodeValidation( m_cntrc1, "CNTRC1","VEHDB" );
	CCodeValidation( m_cntrc2, "CNTRC2","VEHDB" );

	CCodeValidation( m_cntrl1, "CNTRL1","VEHDB" );
	CCodeValidation( m_cntrl2, "CNTRL2","VEHDB" );

	UpdateData(FALSE);
}

//*****************************************************************************
//
//	Name:		
//	Action:		
//	Params:		
//	Returns:	
//	Notes:	
//	Dates:
//
//*****************************************************************************
BOOL CVehOccPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	EnableToolTips();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

//*****************************************************************************
//
//	Name:		OnKillActive
//	Action:		
//	Params:		void
//	Returns:	BOOL
//	Notes:		
//	Dates:		
//
//*****************************************************************************
BOOL CVehOccPage::OnKillActive( void ) 
{
	if(	   ( Clearancedist() == false )
		|| ( Peakloads() == false )
		|| ( Injmeas() == false ) )
	{
		return FALSE;
	}

	if( ValidatePage() == true )
	{
		LoadVehOccData();

		int nOldCurIndx = m_curocc;
		for( m_curocc = 1; m_curocc < m_totaloccsets + 1; m_curocc++ )
		{
			DisplayVehOccData();
			if( !ValidatePage() )
			{
				return FALSE;
			}
		}

		m_curocc = nOldCurIndx;

		DisplayVehOccData();

		return CPropertyPage::OnKillActive();
	}
	else
	{
		// Error are found on AnthPage.
		return FALSE;
	}
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehOccPage::OnSetActive() 
{
	SetBusinessRules();

	Clearancedist();
	Peakloads();
	Injmeas();

	// Initialize total curves.
	m_totaloccsets = max( m_pVehData->m_occsets, 0 );

	DisplayVehOccData();

	// Check for 0th set
	if( m_totaloccsets == 0 )
	{
		EnableButtons(FALSE);
	}
	else
	{
		EnableButtons(TRUE);
	}

	ValidatePage();
	
	return CPropertyPage::OnSetActive();
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehOccPage::OnNextsetButton() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }


	if( m_curocc == m_totaloccsets ) //if at end, increase # of curves
	{
		if( m_curocc != 0 ) { LoadVehOccData(); }
		m_totaloccsets++; 
		m_curocc++;
		InitializeNextSet();

		// Check for 0th set
		if( m_totaloccsets == 0 )
		{
			EnableButtons(FALSE);
		}
		else
		{
			EnableButtons(TRUE);
		}
	} 
	else if (m_curocc != 0) 
	{
		if(!LoadVehOccData())
		{
			MessageBox("Error: see CVehOccPage::OnNextcurveButton()");
			return;
		}
		m_curocc++;
	}

	DisplayVehOccData();
	ValidatePage();

	Clearancedist();
	Peakloads();
	Injmeas();
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehOccPage::OnDeleteButton() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	if( m_curocc == 0 ) return;  //Cant delete zeroth curve.

	m_totaloccsets--;

	// Remove the data from all of the arrays.
	m_pVehData->m_Occ_vehno.RemoveAt(m_curocc);
	m_pVehData->m_occloc.RemoveAt(m_curocc);
	m_pVehData->m_occtyp.RemoveAt(m_curocc);
	m_pVehData->m_occage.RemoveAt(m_curocc);
	m_pVehData->m_occsex.RemoveAt(m_curocc);
	m_pVehData->m_occht.RemoveAt(m_curocc);
	m_pVehData->m_occwt.RemoveAt(m_curocc);
	m_pVehData->m_mthcal.RemoveAt(m_curocc);
	m_pVehData->m_dumsiz.RemoveAt(m_curocc);
	m_pVehData->m_dumman.RemoveAt(m_curocc);
	m_pVehData->m_dummod.RemoveAt(m_curocc);
	m_pVehData->m_dumdsc.RemoveAt(m_curocc);
	m_pVehData->m_seposn.RemoveAt(m_curocc);
	m_pVehData->m_cntrh1.RemoveAt(m_curocc);
	m_pVehData->m_cntrh2.RemoveAt(m_curocc);
	m_pVehData->m_cntrc1.RemoveAt(m_curocc);
	m_pVehData->m_cntrc2.RemoveAt(m_curocc);
	m_pVehData->m_cntrl1.RemoveAt(m_curocc);
	m_pVehData->m_cntrl2.RemoveAt(m_curocc);
	m_pVehData->m_hic.RemoveAt(m_curocc);
	m_pVehData->m_t1.RemoveAt(m_curocc);
	m_pVehData->m_t2.RemoveAt(m_curocc);
	m_pVehData->m_clip3m.RemoveAt(m_curocc);
	m_pVehData->m_lfem.RemoveAt(m_curocc);
	m_pVehData->m_rfem.RemoveAt(m_curocc);
	m_pVehData->m_csi.RemoveAt(m_curocc);
	m_pVehData->m_lbelt.RemoveAt(m_curocc);
	m_pVehData->m_sbelt.RemoveAt(m_curocc);
	m_pVehData->m_tti.RemoveAt(m_curocc);
	m_pVehData->m_pelvg.RemoveAt(m_curocc);
	m_pVehData->m_occcom.RemoveAt(m_curocc);
	// dont forget the arrays in the Clearance Dist Screen
	m_pVehData->m_ad.RemoveAt(m_curocc);
	m_pVehData->m_cb.RemoveAt(m_curocc);
	m_pVehData->m_cd.RemoveAt(m_curocc);
	m_pVehData->m_cs.RemoveAt(m_curocc);
	m_pVehData->m_hb.RemoveAt(m_curocc);
	m_pVehData->m_hd.RemoveAt(m_curocc);
	m_pVehData->m_hh.RemoveAt(m_curocc);
	m_pVehData->m_hr.RemoveAt(m_curocc);
	m_pVehData->m_hs.RemoveAt(m_curocc);
	m_pVehData->m_hw.RemoveAt(m_curocc);
	m_pVehData->m_kb.RemoveAt(m_curocc);
	m_pVehData->m_kd.RemoveAt(m_curocc);
	m_pVehData->m_nb.RemoveAt(m_curocc);
	
	m_curocc--;             //goto previous set 
	
	//if m_curocc == 0 now, and there are remaining curves, set curve 1 as active (m_curocc=1)
	if( m_curocc == 0 && m_totaloccsets > 0 )
	{
		m_curocc = 1;
	}

	DisplayVehOccData();  //display previous set, if existing

	// Check for 0th set
	if( m_totaloccsets == 0 )
	{
		EnableButtons(FALSE);
	}
	else
	{
		EnableButtons(TRUE);
	}

	
}


//new set, expand VehData arrays to hold new info
/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:		These temp variables are used because the reference that [] 
				returns is invalid when SetAtGrow happens, because SetAtGrow
				(sometimes) moves the array to a different location in memory.
				If you try to use that reference directly, you will get an
				access violation.  
	For Example:  This is very BAD!!!!
	m_pVehData->m_inscom.SetAtGrow(m_icurno,m_pVehData->inscom[m_icurno-1]); 

	Dates:

******************************************************************************/
void CVehOccPage::InitializeNextSet()
{
	CString strtemp(""); 

	if (m_retaindata)
	{
		// Remove the data from all of the arrays.
		strtemp = m_pVehData->m_deploy[m_curocc -1];
		m_pVehData->m_deploy.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_Occ_vehno[m_curocc -1];
		m_pVehData->m_Occ_vehno.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_occloc[m_curocc -1];
		m_pVehData->m_occloc.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_occtyp[m_curocc -1];
		m_pVehData->m_occtyp.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_occage[m_curocc -1];
		m_pVehData->m_occage.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_occsex[m_curocc -1];
		m_pVehData->m_occsex.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_occht[m_curocc -1];
		m_pVehData->m_occht.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_occwt[m_curocc -1];
		m_pVehData->m_occwt.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_mthcal[m_curocc -1];
		m_pVehData->m_mthcal.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_dumsiz[m_curocc -1];
		m_pVehData->m_dumsiz.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_dumman[m_curocc -1];
		m_pVehData->m_dumman.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_dummod[m_curocc -1];
		m_pVehData->m_dummod.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_dumdsc[m_curocc -1];
		m_pVehData->m_dumdsc.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_seposn[m_curocc -1];
		m_pVehData->m_seposn.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_cntrh1[m_curocc -1];
		m_pVehData->m_cntrh1.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_cntrh2[m_curocc -1];
		m_pVehData->m_cntrh2.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_cntrc1[m_curocc -1];
		m_pVehData->m_cntrc1.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_cntrc2[m_curocc -1];
		m_pVehData->m_cntrc2.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_cntrl1[m_curocc -1];
		m_pVehData->m_cntrl1.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_cntrl2[m_curocc -1];
		m_pVehData->m_cntrl2.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_hic[m_curocc -1];
		m_pVehData->m_hic.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_t1[m_curocc -1];
		m_pVehData->m_t1.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_t2[m_curocc -1];
		m_pVehData->m_t2.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_clip3m[m_curocc -1];
		m_pVehData->m_clip3m.SetAtGrow(m_curocc, strtemp);
		
		strtemp = m_pVehData->m_lfem[m_curocc -1];
		m_pVehData->m_lfem.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_rfem[m_curocc -1];
		m_pVehData->m_rfem.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_csi[m_curocc -1];
		m_pVehData->m_csi.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_lbelt[m_curocc -1];
		m_pVehData->m_lbelt.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_sbelt[m_curocc -1];
		m_pVehData->m_sbelt.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_tti[m_curocc -1];
		m_pVehData->m_tti.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_pelvg[m_curocc -1];
		m_pVehData->m_pelvg.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_occcom[m_curocc -1];
		m_pVehData->m_occcom.SetAtGrow(m_curocc, strtemp);
		// dont forget the arrays in the Clearance Dist Screen
		strtemp = m_pVehData->m_ad[m_curocc -1];
		m_pVehData->m_ad.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_cb[m_curocc -1];
		m_pVehData->m_cb.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_cd[m_curocc -1];
		m_pVehData->m_cd.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_cs[m_curocc -1];
		m_pVehData->m_cs.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_hb[m_curocc -1];
		m_pVehData->m_hb.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_hd[m_curocc -1];
		m_pVehData->m_hd.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_hh[m_curocc -1];
		m_pVehData->m_hh.SetAtGrow(m_curocc, strtemp);
		
		strtemp = m_pVehData->m_hr[m_curocc -1];
		m_pVehData->m_hr.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_hs[m_curocc -1];
		m_pVehData->m_hs.SetAtGrow(m_curocc, strtemp);
		
		strtemp = m_pVehData->m_hw[m_curocc -1];
		m_pVehData->m_hw.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_kb[m_curocc -1];
		m_pVehData->m_kb.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_kd[m_curocc -1];
		m_pVehData->m_kd.SetAtGrow(m_curocc, strtemp);

		strtemp = m_pVehData->m_nb[m_curocc -1];
		m_pVehData->m_nb.SetAtGrow(m_curocc, strtemp);

	}
	else
	{
		// Remove the data and expand all of the arrays.
		m_pVehData->m_deploy.SetAtGrow(m_curocc, "" );
		m_pVehData->m_Occ_vehno.SetAtGrow(m_curocc, "1");
		m_pVehData->m_occloc.SetAtGrow(m_curocc, "" );
		m_pVehData->m_occtyp.SetAtGrow(m_curocc, "" );
		m_pVehData->m_occage.SetAtGrow(m_curocc, "" );
		m_pVehData->m_occsex.SetAtGrow(m_curocc, "" );
		m_pVehData->m_occht.SetAtGrow(m_curocc, "" );
		m_pVehData->m_occwt.SetAtGrow(m_curocc, "" );
		m_pVehData->m_mthcal.SetAtGrow(m_curocc, "");
		m_pVehData->m_dumsiz.SetAtGrow(m_curocc, "");
		m_pVehData->m_dumman.SetAtGrow(m_curocc, "");
		m_pVehData->m_dummod.SetAtGrow(m_curocc, "");
		m_pVehData->m_dumdsc.SetAtGrow(m_curocc, "");
		m_pVehData->m_seposn.SetAtGrow(m_curocc, "");
		m_pVehData->m_cntrh1.SetAtGrow(m_curocc, "");
		m_pVehData->m_cntrh2.SetAtGrow(m_curocc, "");
		m_pVehData->m_cntrc1.SetAtGrow(m_curocc, "");
		m_pVehData->m_cntrc2.SetAtGrow(m_curocc, "");
		m_pVehData->m_cntrl1.SetAtGrow(m_curocc, "");
		m_pVehData->m_cntrl2.SetAtGrow(m_curocc, "");
		m_pVehData->m_hic.SetAtGrow(m_curocc, "" );
		m_pVehData->m_t1.SetAtGrow(m_curocc, "" );
		m_pVehData->m_t2.SetAtGrow(m_curocc, "" );
		m_pVehData->m_clip3m.SetAtGrow(m_curocc, "" );
		m_pVehData->m_lfem.SetAtGrow(m_curocc, "" );
		m_pVehData->m_rfem.SetAtGrow(m_curocc, "" );
		m_pVehData->m_csi.SetAtGrow(m_curocc, "" );
		m_pVehData->m_lbelt.SetAtGrow(m_curocc, "" );
		m_pVehData->m_sbelt.SetAtGrow(m_curocc, "" );
		m_pVehData->m_tti.SetAtGrow(m_curocc, "" );
		m_pVehData->m_pelvg.SetAtGrow(m_curocc, "" );
		m_pVehData->m_occcom.SetAtGrow(m_curocc, "");
		// dont forget the arrays in the Clearance Dist Screen
		m_pVehData->m_ad.SetAtGrow(m_curocc, "" );
		m_pVehData->m_cb.SetAtGrow(m_curocc, "" );
		m_pVehData->m_cd.SetAtGrow(m_curocc, "" );
		m_pVehData->m_cs.SetAtGrow(m_curocc, "" );
		m_pVehData->m_hb.SetAtGrow(m_curocc, "" );
		m_pVehData->m_hd.SetAtGrow(m_curocc, "" );
		m_pVehData->m_hh.SetAtGrow(m_curocc, "" );
		m_pVehData->m_hr.SetAtGrow(m_curocc, "" );
		m_pVehData->m_hs.SetAtGrow(m_curocc, "" );
		m_pVehData->m_hw.SetAtGrow(m_curocc, "" );
		m_pVehData->m_kb.SetAtGrow(m_curocc, "" );
		m_pVehData->m_kd.SetAtGrow(m_curocc, "" );
		m_pVehData->m_nb.SetAtGrow(m_curocc, "" );
	}
}

// Display PeakLoads Dlg to collect that info
/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehOccPage::OnPeakloads() 
{
	CPeakload peak(m_pVehData, m_curocc);
	if(peak.DoModal ()==IDOK)
	{
		m_pVehData->m_lbelt[m_curocc]	= peak.m_lbelt.GetTextAsString();
		m_pVehData->m_sbelt[m_curocc]	= peak.m_sbelt.GetTextAsString();
		m_pVehData->m_lfem[m_curocc]	= peak.m_lfem.GetTextAsString();
		m_pVehData->m_rfem[m_curocc]	= peak.m_rfem.GetTextAsString();
		
	}
	if( peak.m_bValidate == false )
	{
		COLORREF	clText	= RGB( 0, 0, 0 );
		COLORREF	clBkg	= RGB( 255, 0, 0 );

		m_editPeak = "ERROR";

		m_editPeak.SetColor( clText, clBkg );

		m_editPeak.ShowWindow( SW_SHOW );

		bPeakloads = false;
	}
	else
	{
		COLORREF	clText	= RGB( 0, 0, 0 );
		COLORREF	clBkg	= RGB( 255, 255, 255 );

		m_editPeak = "";

		m_editPeak.SetColor( clText, clBkg );

		m_editPeak.ShowWindow( SW_HIDE );

		bPeakloads = true;
	}
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
bool CVehOccPage::Peakloads( void ) 
{
	CPeakload peak(m_pVehData, m_curocc);

	peak.m_bDisplay = false;
	peak.DoModal();

	if( peak.m_bValidate == false )
	{
		COLORREF	clText	= RGB( 0, 0, 0 );
		COLORREF	clBkg	= RGB( 255, 0, 0 );

		m_editPeak = "ERROR";

		m_editPeak.SetColor( clText, clBkg );

		m_editPeak.ShowWindow( SW_SHOW );

		bPeakloads = false;

		return false;
	}
	else
	{
		COLORREF	clText	= RGB( 0, 0, 0 );
		COLORREF	clBkg	= RGB( 255, 255, 255 );

		m_editPeak = "";

		m_editPeak.SetColor( clText, clBkg );

		m_editPeak.ShowWindow( SW_HIDE );

		bPeakloads = true;

		return true;
	}
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	Display Injmeas Dlg to collect that info

	Dates:

******************************************************************************/
void CVehOccPage::OnInjmeas() 
{
	CInjmeas injmeas(m_pVehData, m_curocc);
	if(injmeas.DoModal ()==IDOK)
	{
		m_pVehData->m_hic[m_curocc] =injmeas.m_hic.GetTextAsString();
		m_pVehData->m_t1[m_curocc] =injmeas.m_t1.GetTextAsString();
		m_pVehData->m_t2[m_curocc] =injmeas.m_t2.GetTextAsString();
		m_pVehData->m_clip3m[m_curocc] =injmeas.m_clip3m.GetTextAsString();
		m_pVehData->m_csi[m_curocc] =injmeas.m_csi.GetTextAsString();
		m_pVehData->m_tti[m_curocc] =injmeas.m_tti.GetTextAsString();
		m_pVehData->m_pelvg[m_curocc] =injmeas.m_pelvg.GetTextAsString();
	}

	if( injmeas.m_bValidate == false )
	{
		COLORREF	clText	= RGB( 0, 0, 0 );
		COLORREF	clBkg	= RGB( 255, 0, 0 );

		m_editInjury = "ERROR";

		m_editInjury.SetColor( clText, clBkg );

		m_editInjury.ShowWindow( SW_SHOW );

		bInjmeas = false;
	}
	else
	{
		COLORREF	clText	= RGB( 0, 0, 0 );
		COLORREF	clBkg	= RGB( 255, 255, 255 );

		m_editInjury = "";

		m_editInjury.SetColor( clText, clBkg );

		m_editInjury.ShowWindow( SW_HIDE );

		bInjmeas = true;
	}	
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
bool CVehOccPage::Injmeas( void )
{
	CInjmeas injmeas(m_pVehData, m_curocc);

	injmeas.m_bDisplay = false;
	injmeas.DoModal();

	if( injmeas.m_bValidate == false )
	{
		COLORREF	clText	= RGB( 0, 0, 0 );
		COLORREF	clBkg	= RGB( 255, 0, 0 );

		m_editInjury = "ERROR";

		m_editInjury.SetColor( clText, clBkg );

		m_editInjury.ShowWindow( SW_SHOW );

		bInjmeas = false;

		return false;
	}
	else
	{
		COLORREF	clText	= RGB( 0, 0, 0 );
		COLORREF	clBkg	= RGB( 255, 255, 255 );

		m_editInjury = "";

		m_editInjury.SetColor( clText, clBkg );

		m_editInjury.ShowWindow( SW_HIDE );

		bInjmeas = true;

		return true;
	}	
}

//Enable or disable pushbuttons on screen
/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehOccPage::EnableButtons(BOOL bEnable)
{
	m_peakloads.EnableWindow (bEnable);
	m_clearancedist.EnableWindow (bEnable);
	m_injmeas.EnableWindow(bEnable);

}

// associate the listbox with m_totalcurves
/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehOccPage::UpdateCurveListbox()
{
	if( m_occlist.GetCount() != m_totaloccsets )
	{
		m_occlist.ResetContent();
		char crvbuf [10];
		for( int loop = 1; loop <= m_totaloccsets; loop++ )
		{
			itoa(loop,crvbuf,10);
			if (m_occlist.FindString (-1,crvbuf)==LB_ERR)  //if buf isnt there already.
			{
				m_occlist.AddString(crvbuf);
			}
		}
	}

	m_occlist.SetCurSel (max(0,m_curocc-1));  // select current curve, zero based.
	
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehOccPage::OnSelchangeOcclist() 
{
	int nCurve = m_occlist.GetCurSel ();  //zero based

	if (m_curocc != 0) 
	{
		BOOL success = LoadVehOccData();     //load current info (not zeroth occ)
		if (!success) //Data not valid, dont change occ.
		{
			m_occlist.SetCurSel (max(0,m_curocc-1));  // select current occ, zero based.
			return;
		}
	}

	m_curocc= nCurve+1;             //goto current curve 

	DisplayVehOccData();  //display next set, if existing

	ValidatePage();

	Clearancedist();
	Peakloads();
	Injmeas();
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehOccPage::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	WinHelp(Occupant_Information);
	
	return TRUE;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:		

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
bool CVehOccPage::ValidatePage( void )
{
	const int nTotal = 20;
	bool bRetArray[nTotal];
	
	bRetArray[0] = m_dumdsc.GetValidate();
	bRetArray[1] = m_dumman.GetValidate();
	bRetArray[2] = m_dummod.GetValidate();
	bRetArray[3] = m_occcom.GetValidate();
	bRetArray[4] = m_vehno.GetValidate();
	bRetArray[5] = m_occage.GetValidate();
	bRetArray[6] = m_occwt.GetValidate();
	bRetArray[7] = m_occht.GetValidate();

	bRetArray[8]	= m_occloc.GetValidate();
	bRetArray[9]	= m_occtyp.GetValidate();
	bRetArray[10]	= m_occsex.GetValidate();
	bRetArray[11]	= m_mthcal.GetValidate();
	bRetArray[12]	= m_dumsiz.GetValidate();

	bRetArray[13]	= m_seposn.GetValidate();
	bRetArray[14]	= m_cntrh1.GetValidate();
	bRetArray[15]	= m_cntrh2.GetValidate();
	bRetArray[16]	= m_cntrc1.GetValidate();
	bRetArray[17]	= m_cntrc2.GetValidate();

	bRetArray[18]	= m_cntrl1.GetValidate();
	bRetArray[19]	= m_cntrl2.GetValidate();

	for( int i = 0; i < nTotal; i++ )
	{
		if( !bRetArray[i] )
		{
			return false;
		}
	}

	return true;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:		
	
	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
void CVehOccPage::SetBusinessRules( void )
{
	m_dumdsc.SetString( 0, 70, true );
	m_dumman.SetString( 0, 70, true );
	m_dummod.SetString( 0, 70, true );
	m_occcom.SetString( 0, 70, true );
	m_vehno.SetDouble( 1, 2, true );
	m_occage.SetDouble( 0, 99, true );
	m_occwt.SetDouble( 0, 999, true );
	m_occht.SetDouble( 0, 9999, true );
}