#if !defined(AFX_VEHOCCPAGE_H__02781738_6367_11D2_9493_0008C7AA9033__INCLUDED_)
#define AFX_VEHOCCPAGE_H__02781738_6367_11D2_9493_0008C7AA9033__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "VehData.h"
#include "EditEx.h"
// VehOccPage.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CVehOccPage dialog

class CVehOccPage : public CPropertyPage
{
	DECLARE_DYNCREATE(CVehOccPage)

// Construction
public:
	CVehOccPage();
	~CVehOccPage();

	void	UpdateCurveListbox();
	void	EnableButtons(BOOL);
	void	InitializeNextSet();
	
	void	DisplayVehOccData();
	BOOL	LoadVehOccData();
	bool	InsertVehOccData();

	bool ValidatePage( void );
	void SetBusinessRules( void );

	bool	Clearancedist( void );
	bool	Peakloads( void );
	bool	Injmeas( void );

	bool	bClearancedist;
	bool	bPeakloads;
	bool	bInjmeas;

	int			m_totaloccsets;
	int			m_curocc;
	CVehData *	m_pVehData;


// Dialog Data
	//{{AFX_DATA(CVehOccPage)
	enum { IDD = IDD_VEH_OCC_PAGE };
	CNEdit		m_editPeak;
	CNEdit		m_editInjury;
	CNEdit		m_editClearance;
	CListBox	m_occlist;
	CButton		m_injmeas;
	CButton		m_clearancedist;
	CButton		m_peakloads;
	CNEdit		m_curoccedit;
	CNEdit		m_totoccedit;
	CButton		m_previoussetbutton;
	CButton		m_nextsetbutton;
	CButton		m_lastsetbutton;
	CButton		m_firstsetbutton;
	CButton		m_deletebutton;
	CNEdit		m_cntrc1;
	CNEdit		m_cntrc2;
	CNEdit		m_cntrh1;
	CNEdit		m_cntrh2;
	CNEdit		m_cntrl1;
	CNEdit		m_cntrl2;
	CNEdit		m_dumdsc;
	CNEdit		m_dumman;
	CNEdit		m_dummod;
	CNEdit		m_dumsiz;
	CNEdit		m_mthcal;
	CNEdit		m_occcom;
	CNEdit		m_occloc;
	CNEdit		m_occsex;
	CNEdit		m_occtyp;
	CNEdit		m_seposn;
	BOOL		m_retaindata;
	CNEdit		m_vehno;
	CNEdit		m_occage;
	CNEdit		m_occwt;
	CNEdit		m_occht;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CVehOccPage)
	public:
	virtual BOOL OnKillActive();
	virtual BOOL OnSetActive();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CVehOccPage)
	afx_msg void OnClearancedist();
	afx_msg void OnOcclocsearch();
	afx_msg void OnOcctypsearch();
	afx_msg void OnOccsexsearch();
	afx_msg void OnMthcalsearch();
	afx_msg void OnDumsizsearch();
	afx_msg void OnSeposnsearch();
	afx_msg void OnCntrh1search();
	afx_msg void OnCntrh2search();
	afx_msg void OnCntrc1search();
	afx_msg void OnCntrc2search();
	afx_msg void OnCntrl1search();
	afx_msg void OnCntrl2search();
	virtual BOOL OnInitDialog();
	afx_msg void OnNextsetButton();
	afx_msg void OnDeleteButton();
	afx_msg void OnPeakloads();
	afx_msg void OnInjmeas();
	afx_msg void OnSelchangeOcclist();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	afx_msg BOOL OnToolTipNotify(UINT, NMHDR *, LRESULT *);
	afx_msg void OnKillfocusVehoccVehno();
	afx_msg void OnKillfocusVehoccOccage();
	afx_msg void OnKillfocusVehoccOccht();
	afx_msg void OnKillfocusVehoccOccwt();
	afx_msg void OnKillfocusVehoccOcccom();
	afx_msg void OnKillfocusVehoccDumman();
	afx_msg void OnKillfocusVehoccDummod();
	afx_msg void OnKillfocusVehoccDumdsc();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VEHOCCPAGE_H__02781738_6367_11D2_9493_0008C7AA9033__INCLUDED_)
