// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: VehPostTest.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description:  Member functions of CVehPostTest.
//               They relate to the loading and display of 
//               data on this page.
// -----------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "VehPostTest.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVehPostTest dialog

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
CVehPostTest::CVehPostTest(CVehData* pdata, int vehno, CWnd* pParent /*=NULL*/)
	: CDialog(CVehPostTest::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVehPostTest)

	//}}AFX_DATA_INIT
	m_pVehData = pdata;
	m_vehno = vehno;

	m_bDisplay = true;
	m_bValidate = true;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehPostTest::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVehPostTest)
	DDX_Control(pDX, IDC_AX1, m_ax1);
	DDX_Control(pDX, IDC_AX10, m_ax10);
	DDX_Control(pDX, IDC_AX11, m_ax11);
	DDX_Control(pDX, IDC_AX12, m_ax12);
	DDX_Control(pDX, IDC_AX13, m_ax13);
	DDX_Control(pDX, IDC_AX14, m_ax14);
	DDX_Control(pDX, IDC_AX15, m_ax15);
	DDX_Control(pDX, IDC_AX16, m_ax16);
	DDX_Control(pDX, IDC_AX17, m_ax17);
	DDX_Control(pDX, IDC_AX18, m_ax18);
	DDX_Control(pDX, IDC_AX19, m_ax19);
	DDX_Control(pDX, IDC_AX2, m_ax2);
	DDX_Control(pDX, IDC_AX20, m_ax20);
	DDX_Control(pDX, IDC_AX21, m_ax21);
	DDX_Control(pDX, IDC_AX3, m_ax3);
	DDX_Control(pDX, IDC_AX4, m_ax4);
	DDX_Control(pDX, IDC_AX5, m_ax5);
	DDX_Control(pDX, IDC_AX6, m_ax6);
	DDX_Control(pDX, IDC_AX7, m_ax7);
	DDX_Control(pDX, IDC_AX8, m_ax8);
	DDX_Control(pDX, IDC_AX9, m_ax9);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CVehPostTest, CDialog)
	//{{AFX_MSG_MAP(CVehPostTest)
	ON_NOTIFY_EX( TTN_NEEDTEXT, 0, OnToolTipNotify )
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVehPostTest message handlers

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehPostTest::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
    TOOLTIPTEXT *pTTT = (TOOLTIPTEXT *)pNMHDR;
    int nID =pNMHDR->idFrom;
    if (pTTT->uFlags & TTF_IDISHWND)    
	{
        // idFrom is actually the HWND of the tool
        nID = ::GetDlgCtrlID((HWND)nID);    
		if(nID)        
		{
           pTTT->lpszText = "0->99999";
		   return TRUE;
		}   
	}  
	return FALSE;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehPostTest::OnInitDialog() 
{
	CDialog::OnInitDialog();

	SetBusinessRules();
	
	m_ax1= m_pVehData->m_ax1[m_vehno];
	m_ax2= m_pVehData->m_ax2[m_vehno];
	m_ax3= m_pVehData->m_ax3[m_vehno];
	m_ax4= m_pVehData->m_ax4[m_vehno];
	m_ax5= m_pVehData->m_ax5[m_vehno];
	m_ax6= m_pVehData->m_ax6[m_vehno];
	m_ax7= m_pVehData->m_ax7[m_vehno];
	m_ax8= m_pVehData->m_ax8[m_vehno];
	m_ax9= m_pVehData->m_ax9[m_vehno];
	m_ax10= m_pVehData->m_ax10[m_vehno];
	m_ax11= m_pVehData->m_ax11[m_vehno];
	m_ax12= m_pVehData->m_ax12[m_vehno];
	m_ax13= m_pVehData->m_ax13[m_vehno];
	m_ax14= m_pVehData->m_ax14[m_vehno];
	m_ax15= m_pVehData->m_ax15[m_vehno];
	m_ax16= m_pVehData->m_ax16[m_vehno];
	m_ax17= m_pVehData->m_ax17[m_vehno];
	m_ax18= m_pVehData->m_ax18[m_vehno];
	m_ax19= m_pVehData->m_ax19[m_vehno];
	m_ax20= m_pVehData->m_ax20[m_vehno];
	m_ax21= m_pVehData->m_ax21[m_vehno];

	if( m_bDisplay == false )
	{
		if( ValidatePage() == false )
		{
			m_bValidate = false;
		}

		CDialog::OnOK();
	}
	else
	{
		ValidatePage();
	}

	UpdateData(FALSE);

	EnableToolTips();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Created -- Al Wilhelm -- 03/09/2000

******************************************************************************/
void CVehPostTest::OnOK()
{
	if( ValidatePage() == false )
	{
		return;
	}
	
	CDialog::OnOK();
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Created -- Al Wilhelm -- 03/10/2000

******************************************************************************/
void CVehPostTest::OnCancel() 
{
	if( ValidatePage() == false )
	{
		m_bValidate = false;
	}
	else
	{
		m_bValidate = true;
	}
	
	CDialog::OnCancel();
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
bool CVehPostTest::ValidatePage( void )
{
	bool bRetArray[21];
	
	bRetArray[0]	= m_ax1.GetValidate();
	bRetArray[1]	= m_ax10.GetValidate();
	bRetArray[2]	= m_ax11.GetValidate();
	bRetArray[3]	= m_ax12.GetValidate();
	bRetArray[4]	= m_ax13.GetValidate();
	bRetArray[5]	= m_ax14.GetValidate();
	bRetArray[6]	= m_ax15.GetValidate();
	bRetArray[7]	= m_ax16.GetValidate();
	bRetArray[8]	= m_ax17.GetValidate();
	bRetArray[9]	= m_ax18.GetValidate();
	bRetArray[10]	= m_ax19.GetValidate();
	bRetArray[11]	= m_ax2.GetValidate();
	bRetArray[12]	= m_ax20.GetValidate();
	bRetArray[13]	= m_ax21.GetValidate();
	bRetArray[14]	= m_ax3.GetValidate();
	bRetArray[15]	= m_ax4.GetValidate();
	bRetArray[16]	= m_ax5.GetValidate();
	bRetArray[17]	= m_ax6.GetValidate();
	bRetArray[18]	= m_ax7.GetValidate();
	bRetArray[19]	= m_ax8.GetValidate();
	bRetArray[20]	= m_ax9.GetValidate();

	for( int i = 0; i < 21; i++ )
	{
		if( !bRetArray[i] )
		{
			return false;
		}
	}

	return true;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
void CVehPostTest::SetBusinessRules( void )
{
	m_ax1.SetDouble( 0.0, 99999.0, true );
	m_ax10.SetDouble( 0.0, 99999.0, true );
	m_ax11.SetDouble( 0.0, 99999.0, true );
	m_ax12.SetDouble( 0.0, 99999.0, true );
	m_ax13.SetDouble( 0.0, 99999.0, true );
	m_ax14.SetDouble( 0.0, 99999.0, true );
	m_ax15.SetDouble( 0.0, 99999.0, true );
	m_ax16.SetDouble( 0.0, 99999.0, true );
	m_ax17.SetDouble( 0.0, 99999.0, true );
	m_ax18.SetDouble( 0.0, 99999.0, true );
	m_ax19.SetDouble( 0.0, 99999.0, true );
	m_ax2.SetDouble( 0.0, 99999.0, true );
	m_ax20.SetDouble( 0.0, 99999.0, true );
	m_ax21.SetDouble( 0.0, 99999.0, true );
	m_ax3.SetDouble( 0.0, 99999.0, true );
	m_ax4.SetDouble( 0.0, 99999.0, true );
	m_ax5.SetDouble( 0.0, 99999.0, true );
	m_ax6.SetDouble( 0.0, 99999.0, true );
	m_ax7.SetDouble( 0.0, 99999.0, true );
	m_ax8.SetDouble( 0.0, 99999.0, true );
	m_ax9.SetDouble( 0.0, 99999.0, true );
}
