// -----------------------------------------
// Copyright 1998, Data Center.GetDouble( NRD of DOT
// File: VehPreTest.cpp
//
// Author: Dan Robbins
//
// Date Created: October.GetDouble( 1998
//
// Description:  Member functions of CVehPreTest.
//               They relate to the loading and display of 
//               data on this page.
// -----------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "VehPreTest.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVehPreTest dialog

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
CVehPreTest::CVehPreTest(CVehData* pvehdata, int vehno, CWnd* pParent /*=NULL*/)
	: CDialog(CVehPreTest::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVehPreTest)

	//}}AFX_DATA_INIT
	m_pVehData = pvehdata;
	m_vehno = vehno;

	m_bDisplay = true;
	m_bValidate = true;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehPreTest::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVehPreTest)
	DDX_Control(pDX, IDC_BX1, m_bx1);
	DDX_Control(pDX, IDC_BX10, m_bx10);
	DDX_Control(pDX, IDC_BX11, m_bx11);
	DDX_Control(pDX, IDC_BX12, m_bx12);
	DDX_Control(pDX, IDC_BX13, m_bx13);
	DDX_Control(pDX, IDC_BX14, m_bx14);
	DDX_Control(pDX, IDC_BX15, m_bx15);
	DDX_Control(pDX, IDC_BX16, m_bx16);
	DDX_Control(pDX, IDC_BX17, m_bx17);
	DDX_Control(pDX, IDC_BX18, m_bx18);
	DDX_Control(pDX, IDC_BX2, m_bx2);
	DDX_Control(pDX, IDC_BX3, m_bx3);
	DDX_Control(pDX, IDC_BX4, m_bx4);
	DDX_Control(pDX, IDC_BX5, m_bx5);
	DDX_Control(pDX, IDC_BX6, m_bx6);
	DDX_Control(pDX, IDC_BX7, m_bx7);
	DDX_Control(pDX, IDC_BX8, m_bx8);
	DDX_Control(pDX, IDC_BX9, m_bx9);
	DDX_Control(pDX, IDC_BX19, m_bx19);
	DDX_Control(pDX, IDC_BX20, m_bx20);
	DDX_Control(pDX, IDC_BX21, m_bx21);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CVehPreTest, CDialog)
	//{{AFX_MSG_MAP(CVehPreTest)
	ON_NOTIFY_EX( TTN_NEEDTEXT, 0, OnToolTipNotify )
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVehPreTest message handlers

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehPreTest::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
    TOOLTIPTEXT *pTTT = (TOOLTIPTEXT *)pNMHDR;
    int nID =pNMHDR->idFrom;
    if (pTTT->uFlags & TTF_IDISHWND)    
	{
        // idFrom is actually the HWND of the tool
        nID = ::GetDlgCtrlID((HWND)nID);    
		if(nID)        
		{
           pTTT->lpszText = "0->9999";
		   return TRUE;
		}   
	}  
	return FALSE;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehPreTest::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	SetBusinessRules();

	m_bx1= m_pVehData->m_bx1[m_vehno];
	m_bx2= m_pVehData->m_bx2[m_vehno];
	m_bx3= m_pVehData->m_bx3[m_vehno];
	m_bx4= m_pVehData->m_bx4[m_vehno];
	m_bx5= m_pVehData->m_bx5[m_vehno];
	m_bx6= m_pVehData->m_bx6[m_vehno];
	m_bx7= m_pVehData->m_bx7[m_vehno];
	m_bx8= m_pVehData->m_bx8[m_vehno];
	m_bx9= m_pVehData->m_bx9[m_vehno];
	m_bx10= m_pVehData->m_bx10[m_vehno];
	m_bx11= m_pVehData->m_bx11[m_vehno];
	m_bx12= m_pVehData->m_bx12[m_vehno];
	m_bx13= m_pVehData->m_bx13[m_vehno];
	m_bx14= m_pVehData->m_bx14[m_vehno];
	m_bx15= m_pVehData->m_bx15[m_vehno];
	m_bx16= m_pVehData->m_bx16[m_vehno];
	m_bx17= m_pVehData->m_bx17[m_vehno];
	m_bx18= m_pVehData->m_bx18[m_vehno];
	m_bx19= m_pVehData->m_bx19[m_vehno];
	m_bx20= m_pVehData->m_bx20[m_vehno];
	m_bx21= m_pVehData->m_bx21[m_vehno];

	if( m_bDisplay == false )
	{
		if( ValidatePage() == false )
		{
			m_bValidate = false;
		}

		CDialog::OnOK();
	}
	else
	{
		ValidatePage();
	}

	EnableToolTips();

	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Created -- Al Wilhelm -- 03/09/2000

******************************************************************************/
void CVehPreTest::OnOK() 
{
	if( ValidatePage() == false )
	{
		return;
	}
	
	CDialog::OnOK();
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Created -- Al Wilhelm -- 03/10/2000

******************************************************************************/
void CVehPreTest::OnCancel() 
{
	if( ValidatePage() == false )
	{
		m_bValidate = false;
	}
	else
	{
		m_bValidate = true;
	}
	
	CDialog::OnCancel();
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
bool CVehPreTest::ValidatePage( void )
{
	bool bRetArray[21];
	
	bRetArray[0]	= m_bx1.GetValidate();
	bRetArray[1]	= m_bx10.GetValidate();
	bRetArray[2]	= m_bx11.GetValidate();
	bRetArray[3]	= m_bx12.GetValidate();
	bRetArray[4]	= m_bx13.GetValidate();
	bRetArray[5]	= m_bx14.GetValidate();
	bRetArray[6]	= m_bx15.GetValidate();
	bRetArray[7]	= m_bx16.GetValidate();
	bRetArray[8]	= m_bx17.GetValidate();
	bRetArray[9]	= m_bx18.GetValidate();
	bRetArray[10]	= m_bx2.GetValidate();
	bRetArray[11]	= m_bx3.GetValidate();
	bRetArray[12]	= m_bx4.GetValidate();
	bRetArray[13]	= m_bx5.GetValidate();
	bRetArray[14]	= m_bx6.GetValidate();
	bRetArray[15]	= m_bx7.GetValidate();
	bRetArray[16]	= m_bx8.GetValidate();
	bRetArray[17]	= m_bx9.GetValidate();
	bRetArray[18]	= m_bx19.GetValidate();
	bRetArray[19]	= m_bx20.GetValidate();
	bRetArray[20]	= m_bx21.GetValidate();

	for( int i = 0; i < 21; i++ )
	{
		if( !bRetArray[i] )
		{
			return false;
		}
	}

	return true;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
void CVehPreTest::SetBusinessRules( void )
{
	m_bx1.SetDouble( 0, 9999, true );
	m_bx10.SetDouble( 0, 9999, true );
	m_bx11.SetDouble( 0, 9999, true );
	m_bx12.SetDouble( 0, 9999, true );
	m_bx13.SetDouble( 0, 9999, true );
	m_bx14.SetDouble( 0, 9999, true );
	m_bx15.SetDouble( 0, 9999, true );
	m_bx16.SetDouble( 0, 9999, true );
	m_bx17.SetDouble( 0, 9999, true );
	m_bx18.SetDouble( 0, 9999, true );
	m_bx2.SetDouble( 0, 9999, true );
	m_bx3.SetDouble( 0, 9999, true );
	m_bx4.SetDouble( 0, 9999, true );
	m_bx5.SetDouble( 0, 9999, true );
	m_bx6.SetDouble( 0, 9999, true );
	m_bx7.SetDouble( 0, 9999, true );
	m_bx8.SetDouble( 0, 9999, true );
	m_bx9.SetDouble( 0, 9999, true );
	m_bx19.SetDouble( 0, 9999, true );
	m_bx20.SetDouble( 0, 9999, true );
	m_bx21.SetDouble( 0, 9999, true );
}