// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: VehRestPage.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description:  Member functions of CVehRestPage.
//               They relate to the loading and display of 
//               data on this page.
//
//  Modification History:
//  Date		Who			Description
//  03/03/00	Yeun Wong	add info data insertion and correct info data indexing
// -----------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "VehRestPage.h"
#include "search.h"
#include "CodeValidation.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CString search_code;

/////////////////////////////////////////////////////////////////////////////
// CVehRestPage property page

IMPLEMENT_DYNCREATE(CVehRestPage, CPropertyPage)

//*****************************************************************************
//
//	Name:		
//	Action:		
//	Params:		
//	Returns:	
//	Notes:	
//	Dates:
//
//*****************************************************************************
CVehRestPage::CVehRestPage() : CPropertyPage(CVehRestPage::IDD)
{
	//{{AFX_DATA_INIT(CVehRestPage)
	m_deploy		= _T("");
	m_occloc		= _T("");
	m_rstcom		= _T("");
	m_rstmnt		= _T("");
	m_rsttyp		= _T("");
	m_retaindata	= FALSE;
	m_rstno			= _T("1");
	//}}AFX_DATA_INIT

	m_currest= 0;
}

//*****************************************************************************
//
//	Name:		
//	Action:		
//	Params:		
//	Returns:	
//	Notes:	
//	Dates:
//
//*****************************************************************************
CVehRestPage::~CVehRestPage()
{
}

//*****************************************************************************
//
//	Name:		
//	Action:		
//	Params:		
//	Returns:	
//	Notes:	
//	Dates:
//
//*****************************************************************************
void CVehRestPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVehRestPage)
	DDX_Control(pDX, IDC_VEHNO, m_editRestVehicleNumber);
	DDX_Control(pDX, IDC_RESTLIST, m_restlist);
	DDX_Control(pDX, IDC_NEXTSET_BUTTON, m_nextsetbutton);
	DDX_Control(pDX, IDC_DELETEBUTTON, m_deletebutton);
	DDX_Control(pDX, IDC_DEPLOY, m_deploy);
	DDX_Control(pDX, IDC_OCCLOC, m_occloc);
	DDX_Control(pDX, IDC_RSTCOM, m_rstcom);
	DDX_Control(pDX, IDC_RSTMNT, m_rstmnt);
	DDX_Control(pDX, IDC_RSTTYP, m_rsttyp);
	DDX_Check(pDX, IDC_RETAINDATA, m_retaindata);
	DDX_Control(pDX, IDC_RSTNO, m_rstno);
	//}}AFX_DATA_MAP
}

//*****************************************************************************
//
//	Name:		
//	Action:		
//	Params:		
//	Returns:	
//	Notes:	
//	Dates:
//
//*****************************************************************************
BEGIN_MESSAGE_MAP(CVehRestPage, CPropertyPage)
	//{{AFX_MSG_MAP(CVehRestPage)
	ON_BN_CLICKED(IDC_OCCLOC_SEARCH, OnOcclocSearch)
	ON_BN_CLICKED(IDC_RSTTYP_SEARCH, OnRsttypSearch)
	ON_BN_CLICKED(IDC_RSTMNT_SEARCH, OnRstmntSearch)
	ON_BN_CLICKED(IDC_DEPLOY_SEARCH, OnDeploySearch)
	ON_BN_CLICKED(IDC_NEXTSET_BUTTON, OnNextsetButton)
	ON_BN_CLICKED(IDC_DELETEBUTTON, OnDeletebutton)
	ON_LBN_SELCHANGE(IDC_RESTLIST, OnSelchangeRestlist)
	ON_WM_HELPINFO()
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTW, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTA, 0, 0xFFFF, OnToolTipNotify )
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVehRestPage message handlers

//*****************************************************************************
//
//	Name:		
//	Action:		
//	Params:		
//	Returns:	
//	Notes:	
//	Dates:
//
//*****************************************************************************
BOOL CVehRestPage::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
	TOOLTIPTEXTA* pTTTA = (TOOLTIPTEXTA*)pNMHDR;
	TOOLTIPTEXTW* pTTTW = (TOOLTIPTEXTW*)pNMHDR;
	CString strTipText = "";
	UINT nID = pNMHDR->idFrom;
	if (pNMHDR->code == TTN_NEEDTEXTA && (pTTTA->uFlags & TTF_IDISHWND) ||
		pNMHDR->code == TTN_NEEDTEXTW && (pTTTW->uFlags & TTF_IDISHWND))
	{
		// idFrom is actually the HWND of the tool
		nID = ::GetDlgCtrlID((HWND)nID);
	}

	if (nID != 0) // will be zero on a separator
	{
		strTipText.Format("Control ID = %d", nID);
		switch (nID)
		{
		case IDC_NEXTSET_BUTTON:
			strTipText = "Go to (or add) the next restraint info set";
			break;
		case IDC_DELETEBUTTON:
			strTipText = "Delete this restraint info set";
			break;
		case IDC_RSTNO:
			strTipText = "1->9";
			break;
		case IDC_VEHNO:
			strTipText = "1->2";
			break;
		default: strTipText = "";
		}
	}

	if (pNMHDR->code == TTN_NEEDTEXTA)
		lstrcpyn(pTTTA->szText, strTipText, sizeof(pTTTA->szText));
	else
		::MultiByteToWideChar( CP_ACP , 0, strTipText, -1, pTTTW->szText, sizeof(pTTTW->szText) );
	*pResult = 0;

	return TRUE;    // message was handled
}

//*****************************************************************************
//
//	Name:		
//	Action:		
//	Params:		
//	Returns:	
//	Notes:	
//	Dates:
//
//*****************************************************************************
void CVehRestPage::OnOcclocSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"OCCLOC","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_occloc = search_code;
		m_occloc.SetValidateColor();
	}
	UpdateData(FALSE);
}

//*****************************************************************************
//
//	Name:		
//	Action:		
//	Params:		
//	Returns:	
//	Notes:	
//	Dates:
//
//*****************************************************************************
void CVehRestPage::OnRsttypSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"RSTTYP","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_rsttyp = search_code;
		m_rsttyp.SetValidateColor();
	}
	UpdateData(FALSE);
}

//*****************************************************************************
//
//	Name:		
//	Action:		
//	Params:		
//	Returns:	
//	Notes:	
//	Dates:
//
//*****************************************************************************
void CVehRestPage::OnRstmntSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"RSTMNT","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_rstmnt = search_code;
		m_rstmnt.SetValidateColor();
	}
	UpdateData(FALSE);
}

//*****************************************************************************
//
//	Name:		OnDeploySearch
//	Action:		
//	Params:		void
//	Returns:	void
//	Notes:	
//	Dates:
//
//*****************************************************************************
void CVehRestPage::OnDeploySearch( void ) 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"DEPLOY","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_deploy = search_code;
		UpdateData(FALSE);
	}
	
}

//*****************************************************************************
//
//	Name:		LoadVehRestData
//	Action:		
//	Params:		void
//	Returns:	BOOL
//	Notes:		This function gets the data from the entry fields and puts
//				it into m_pVehData.  It is called in OnKillActive, 
//				ExportData, record changed.
//
//	Dates:
//
//*****************************************************************************
BOOL CVehRestPage::LoadVehRestData( void )
{
	if (m_hWnd==NULL) return TRUE;  //only return FALSE if data not valid.
	if (!UpdateData(TRUE)) return FALSE;

	m_pVehData->m_Rest_vehno[m_currest] = m_editRestVehicleNumber.GetTextAsString();
	m_pVehData->m_Rest_occloc[m_currest] = m_occloc.GetTextAsString();
	m_pVehData->m_rstno[m_currest] = m_rstno.GetTextAsString();
	m_pVehData->m_rsttyp[m_currest] = m_rsttyp.GetTextAsString();
	m_pVehData->m_rstmnt[m_currest] = m_rstmnt.GetTextAsString();
	m_pVehData->m_rstcom[m_currest] = m_rstcom.GetTextAsString();
	m_pVehData->m_deploy[m_currest] = m_deploy.GetTextAsString();

	m_pVehData->m_restsets = m_totalrestsets;
			
	return TRUE;

}

//*****************************************************************************
//
//	Name:		
//	Action:		
//	Params:		
//	Returns:	
//	Notes:	
//	Dates:		wong code in 03/03/2000
//
//*****************************************************************************
bool CVehRestPage::InsertVehRestData( void )
{
	if (m_hWnd==NULL) return TRUE;  // only return FALSE if data invalid
	
	UpdateData();
 
	m_pVehData->m_Rest_vehno.InsertAt( m_currest, m_editRestVehicleNumber.GetTextAsString() );
	m_pVehData->m_Rest_occloc.InsertAt( m_currest, m_occloc.GetTextAsString() );
	m_pVehData->m_rstno.InsertAt( m_currest, m_rstno.GetTextAsString() );
	m_pVehData->m_rsttyp.InsertAt( m_currest, m_rsttyp.GetTextAsString() );
	m_pVehData->m_rstmnt.InsertAt( m_currest, m_rstmnt.GetTextAsString() );
	m_pVehData->m_rstcom.InsertAt( m_currest, m_rstcom.GetTextAsString() );
	m_pVehData->m_deploy.InsertAt( m_currest, m_deploy.GetTextAsString() );

	m_pVehData->m_restsets = m_totalrestsets;

	UpdateData(false);

	return true;
}

//*****************************************************************************
//
//	Name:		
//	Action:		Get Data from m_pVehData and Display it.
//	Params:		
//	Returns:	
//	Notes:	
//	Dates:
//
//*****************************************************************************
void CVehRestPage::DisplayVehRestData()
{
	if (m_hWnd==NULL) return;

	UpdateCurveListbox();

	UpdateData();
	m_editRestVehicleNumber = m_pVehData->m_Rest_vehno[m_currest];
	m_occloc = m_pVehData->m_Rest_occloc[m_currest];
	m_rstno = m_pVehData->m_rstno[m_currest];
	m_rsttyp = m_pVehData->m_rsttyp[m_currest];
	m_rstmnt = m_pVehData->m_rstmnt[m_currest];
	m_rstcom = m_pVehData->m_rstcom[m_currest];
	m_deploy = m_pVehData->m_deploy[m_currest];

	CCodeValidation( m_occloc, "OCCLOC","VEHDB" );
	CCodeValidation( m_rsttyp, "RSTTYP","VEHDB" );
	CCodeValidation( m_rstmnt, "RSTMNT","VEHDB" );
	UpdateData(FALSE);

}

//*****************************************************************************
//
//	Name:		
//	Action:		
//	Params:		
//	Returns:	
//	Notes:	
//	Dates:
//
//*****************************************************************************/
BOOL CVehRestPage::OnKillActive() 
{
	if( ValidatePage() == true )
	{
		LoadVehRestData();

		int nOldCurIndx = m_currest;
		for( m_currest = 1; m_currest < m_totalrestsets + 1; m_currest++ )
		{
			DisplayVehRestData();
			if (!ValidatePage()) { return false; }
		}

		m_currest = nOldCurIndx;

		DisplayVehRestData();

		return CPropertyPage::OnKillActive();
	}
	else
	{
		// Error are found on AnthPage.
		return FALSE;
	}
}

//*****************************************************************************
//
//	Name:		
//	Action:		
//	Params:		
//	Returns:	
//	Notes:	
//	Dates:
//
//*****************************************************************************
BOOL CVehRestPage::OnSetActive() 
{
	SetBusinessRules();

	// Initialize total curves.
	m_totalrestsets = max( m_pVehData->m_restsets , 0 );

	DisplayVehRestData();

	ValidatePage();

	return CPropertyPage::OnSetActive();
}

//*****************************************************************************
//
//	Name:		
//	Action:		
//	Params:		
//	Returns:	
//	Notes:	
//	Dates:
//
//*****************************************************************************
BOOL CVehRestPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();

	EnableToolTips();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

//*****************************************************************************
//
//	Name:		
//	Action:		
//	Params:		
//	Returns:	
//	Notes:	
//	Dates:
//
//*****************************************************************************
void CVehRestPage::OnNextsetButton() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	if( m_currest == m_totalrestsets ) //if at end, increase # of curves
	{
		if (m_currest!=0) { LoadVehRestData(); }
		m_totalrestsets++; 
		m_currest++;
		InitializeNextSet();
	} 
	else if( m_currest != 0 ) 
	{
		if( !LoadVehRestData() )
		{
			MessageBox("Error: see CVehRestPage::OnNextcurveButton()");
			return;
		}

		m_currest++;
	}

	DisplayVehRestData();
	ValidatePage();

/***
	bool newset=false;

//	if (m_currest==m_totalrestsets)
	{
//		m_totalrestsets++;  // wong corrected
		newset=true;
	}   

	if (m_currest != 0)
	{
//		BOOL success=LoadVehRestData(); //load current info into m_pVehData(not zeroth set)
		if(!InsertVehRestData()) //Data not valid
		{
//			if (newset) m_totalrestsets--;
			return;
		}
	}

	m_currest++;             //goto next set
//	m_totalrestsets++;	// wong added

	if( newset )
	{
		InitializeNextSet();
	}

	DisplayVehRestData();  //display next set, if existing
	ValidatePage();
**/
}

//*****************************************************************************
//
//	Name:		
//	Action:		
//	Params:		
//	Returns:	
//	Notes:	
//	Dates:
//
//*****************************************************************************
void CVehRestPage::OnDeletebutton() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	if( m_currest == 0 ) { return;  }

	m_totalrestsets--;

	m_pVehData->m_Rest_vehno.RemoveAt(m_currest);
	m_pVehData->m_Rest_occloc.RemoveAt(m_currest);
	m_pVehData->m_rstno.RemoveAt(m_currest);
	m_pVehData->m_rsttyp.RemoveAt(m_currest);
	m_pVehData->m_rstmnt.RemoveAt(m_currest); 
	m_pVehData->m_rstcom.RemoveAt(m_currest);
	m_pVehData->m_deploy.RemoveAt(m_currest);
	
	m_currest--;             //goto previous set

	//if m_currest == 0 now, and there are remaining rests, set rest 1 as active (m_currest=1)
	if( m_currest == 0 && m_totalrestsets > 0 )
	{
		m_currest = 1;
	}

	DisplayVehRestData();  //display previous set, if existing
}

/******************************************************************************
	Name:		
	Action:		New set, expand VehData arrays for new info.
	Params:		
	Returns:	
	Notes:		These temp variables are used because the reference that 
				[] returns is invalid when SetAtGrow happens, because 
				SetAtGrow (sometimes) moves the array to a different 
				location in memory.   If you try to use that reference
				directly, you will get an access violation.
	For Example:  Very Bad!!!
	m_pVehData->m_inscom.SetAtGrow (m_icurno,m_pVehData->inscom[m_icurno-1]);

	Dates:

******************************************************************************/
void CVehRestPage::InitializeNextSet()
{
	if (m_retaindata)
	{
		CString temp = m_pVehData->m_Rest_vehno[m_currest-1];
		m_pVehData->m_Rest_vehno.SetAtGrow (m_currest, temp);
		temp = m_pVehData->m_rstno[m_currest-1];
		m_pVehData->m_rstno.SetAtGrow (m_currest, temp); 
		temp = m_pVehData->m_rsttyp[m_currest-1];
		m_pVehData->m_rsttyp.SetAtGrow (m_currest, temp); 
		temp = m_pVehData->m_rstmnt[m_currest-1];
		m_pVehData->m_rstmnt.SetAtGrow (m_currest, temp); 
		temp = m_pVehData->m_rstcom[m_currest-1];
		m_pVehData->m_rstcom.SetAtGrow (m_currest, temp); 
		temp = m_pVehData->m_deploy[m_currest-1];
		m_pVehData->m_deploy.SetAtGrow (m_currest, temp); 
		temp = m_pVehData->m_Rest_occloc[m_currest-1];
		m_pVehData->m_Rest_occloc.SetAtGrow (m_currest, temp); 
	}
	else
	{
		m_pVehData->m_Rest_vehno.SetAtGrow( m_currest, "1" ); 
		m_pVehData->m_rstno.SetAtGrow( m_currest, "1" ); 
		m_pVehData->m_Rest_occloc.SetAtGrow( m_currest, "" ); 
		m_pVehData->m_rsttyp.SetAtGrow( m_currest, "" ); 
		m_pVehData->m_rstmnt.SetAtGrow( m_currest, "" ); 
		m_pVehData->m_rstcom.SetAtGrow( m_currest, "" ); 
		m_pVehData->m_deploy.SetAtGrow( m_currest, "" ); 
	}
}

//*****************************************************************************
//
//	Name:		
//	Action:		
//	Params:		
//	Returns:	
//	Notes:		User clicked the curves listbox, so change to that rest.
//	Dates:
//
//*****************************************************************************
void CVehRestPage::OnSelchangeRestlist() 
{
	int nCurve = m_restlist.GetCurSel ();  //zero based

	if (m_currest != 0) 
	{
		BOOL success = LoadVehRestData();     //load current info (not zeroth rest)
		if (!success) //Data not valid, dont change curves.
		{
			// select current curve, zero based.
			m_restlist.SetCurSel( max( 0, m_currest - 1 ) );
			return;
		}
	}

	// goto current curve 
	m_currest = nCurve + 1;

	DisplayVehRestData();  //display next set, if existing

	ValidatePage();
}

//*****************************************************************************
//
//	Name:		UpdateCurveListbox
//	Action:		
//	Params:		void
//	Returns:	void
//	Notes:	
//	Dates:
//
//*****************************************************************************
void CVehRestPage::UpdateCurveListbox( void )
{
	if( m_restlist.GetCount() != m_totalrestsets )
	{
		m_restlist.ResetContent();
		char crvbuf [10];
		for( int loop = 1; loop <= m_totalrestsets; loop++ )
		{
			itoa(loop,crvbuf,10);
			if (m_restlist.FindString (-1,crvbuf)==LB_ERR)  //if buf isnt there already.
			{
				m_restlist.AddString(crvbuf);
			}
		}
	}

	m_restlist.SetCurSel (max(0,m_currest-1));  // select current curve, zero based.
}

//*****************************************************************************
//
//	Name:		OnHelpInfo
//	Action:		To call WinHelp
//	Params:		HELPINFO *
//	Returns:	BOOL
//	Notes:		To take the user to Restraint section in the help file.
//	Dates:
//
//*****************************************************************************
BOOL CVehRestPage::OnHelpInfo( HELPINFO * pHelpInfo ) 
{
	WinHelp(Restraint);
	
	return TRUE;
}

//*****************************************************************************
//
//	Name:		ValidatePage
//	Action:		To validate page.
//	Params:		void
//	Returns:	void
//	Notes:	
//	Dates:		Created - Al Wilhelm - 03/06/2000
//
//*****************************************************************************
bool CVehRestPage::ValidatePage( void )
{
	const int nTotal = 6;
	bool bRetArray[nTotal];
	
	bRetArray[0] = m_rstcom.GetValidate();
	bRetArray[1] = m_editRestVehicleNumber.GetValidate();
	bRetArray[2] = m_rstno.GetValidate();

	bRetArray[3] = m_occloc.GetValidate();
	bRetArray[4] = m_rsttyp.GetValidate();
	bRetArray[5] = m_rstmnt.GetValidate();

	for( int i = 0; i < nTotal; i++ )
	{
		if( !bRetArray[i] )
		{
			return false;
		}
	}

	return true;
}

//*****************************************************************************
//
//	Name:		SetBusinessRules
//	Action:		Set business rules.
//	Params:		void
//	Returns:	void
//	Notes:	
//	Dates:		Created - Al Wilhelm - 03/06/2000
//
//*****************************************************************************
void CVehRestPage::SetBusinessRules( void )
{
	m_rstcom.SetString( 0, 70, true );
	m_editRestVehicleNumber.SetDouble( 1, 2, true );
	m_rstno.SetDouble( 1, 9, true );
}
