#if !defined(AFX_VEHRESTPAGE_H__02781739_6367_11D2_9493_0008C7AA9033__INCLUDED_)
#define AFX_VEHRESTPAGE_H__02781739_6367_11D2_9493_0008C7AA9033__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "VehData.h"
#include "EditEx.h"
// VehRestPage.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CVehRestPage dialog

class CVehRestPage : public CPropertyPage
{
	DECLARE_DYNCREATE(CVehRestPage)

// Construction
public:
	CVehRestPage();
	~CVehRestPage();

	void UpdateCurveListbox();	
	void InitializeNextSet();
	void DisplayVehRestData();
	BOOL LoadVehRestData();
	bool InsertVehRestData();

	bool ValidatePage( void );
	void SetBusinessRules( void );

	int m_currest;        // restraint info set currently being displayed.
	int m_totalrestsets;  // total number of restraint info sets for this screen.
	CVehData * m_pVehData;


// Dialog Data
	//{{AFX_DATA(CVehRestPage)
	enum { IDD = IDD_VEH_REST_PAGE };
	CNEdit	m_editRestVehicleNumber;
	CListBox	m_restlist;
	CButton	m_nextsetbutton;
	CButton	m_deletebutton;
	CNEdit	m_deploy;
	CNEdit	m_occloc;
	CNEdit	m_rstcom;
	CNEdit	m_rstmnt;
	CNEdit	m_rsttyp;
	BOOL	m_retaindata;
	CNEdit	m_rstno;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CVehRestPage)
	public:
	virtual BOOL OnKillActive();
	virtual BOOL OnSetActive();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CVehRestPage)
	afx_msg void OnOcclocSearch();
	afx_msg void OnRsttypSearch();
	afx_msg void OnRstmntSearch();
	afx_msg void OnDeploySearch();
	virtual BOOL OnInitDialog();
	afx_msg void OnNextsetButton();
	afx_msg void OnDeletebutton();
	afx_msg void OnSelchangeRestlist();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	afx_msg BOOL OnToolTipNotify(UINT, NMHDR *, LRESULT *);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VEHRESTPAGE_H__02781739_6367_11D2_9493_0008C7AA9033__INCLUDED_)
