// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: VehTestPage.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description:  Member functions of CVehTestPage.
//               They relate to the loading and display of 
//               data on this page.
// -----------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "VehTestPage.h"
#include "search.h"
#include "CodeValidation.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CString search_code;

/////////////////////////////////////////////////////////////////////////////
// CVehTestPage property page

IMPLEMENT_DYNCREATE(CVehTestPage, CPropertyPage)

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
CVehTestPage::CVehTestPage() : CPropertyPage(CVehTestPage::IDD)
{
	//{{AFX_DATA_INIT(CVehTestPage)
	m_edittestdate	= _T("");
	m_editconno		= _T("");
	m_link			= _T("");
	m_rectyp		= _T("");
	m_edittitle		= _T("");
	m_tkcond		= _T("");
	m_tksurf		= _T("");
	m_totcrv		= _T("");
	m_tstcfn		= _T("");
	m_edittstcom	= _T("");
	m_edittstobj	= _T("");
	m_tstprf		= _T("");
	m_edittstref	= _T("");
	m_tsttyp		= _T("");
	m_editverno		= _T("");
	m_editclsspd	= _T("");	// Was a float
	m_editimpang	= _T("");
	m_edittemp		= _T("");
	m_editoffset	= _T("");
	m_editimppnt	= _T("");
	//}}AFX_DATA_INIT
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
CVehTestPage::~CVehTestPage()
{
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehTestPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVehTestPage)
	DDX_Control(pDX, IDC_VEHTESTDAT, m_edittestdate);
	DDX_Control(pDX, IDC_VEHTEST_TSTDAT, m_tstdatctrl);
	DDX_Control(pDX, IDC_VEHTEST_CONNO, m_editconno);
	DDX_Control(pDX, IDC_VEHTEST_LINK, m_link);
	DDX_Control(pDX, IDC_VEHTEST_RECTYP, m_rectyp);
	DDX_Control(pDX, IDC_VEHTEST_TITLE, m_edittitle);
	DDX_Control(pDX, IDC_VEHTEST_TKCOND, m_tkcond);
	DDX_Control(pDX, IDC_VEHTEST_TKSURF, m_tksurf);
	DDX_Control(pDX, IDC_VEHTEST_TOTCRV, m_totcrv);
	DDX_Control(pDX, IDC_VEHTEST_TSTCFN, m_tstcfn);
	DDX_Control(pDX, IDC_VEHTEST_TSTCOM, m_edittstcom);
	DDX_Control(pDX, IDC_VEHTEST_TSTOBJ, m_edittstobj);
	DDX_Control(pDX, IDC_VEHTEST_TSTPRF, m_tstprf);
	DDX_Control(pDX, IDC_VEHTEST_TSTREF, m_edittstref);
	DDX_Control(pDX, IDC_VEHTEST_TSTTYP, m_tsttyp);
	DDX_Control(pDX, IDC_VEHTEST_VERNO, m_editverno);
	DDX_Control(pDX, IDC_VEHTEST_CLSSPD, m_editclsspd);
	DDX_Control(pDX, IDC_VEHTEST_IMPANG, m_editimpang);
	DDX_Control(pDX, IDC_VEHTEST_TEMP, m_edittemp);
	DDX_Control(pDX, IDC_VEHTEST_OFFSET, m_editoffset);
	DDX_Control(pDX, IDC_VEHTEST_IMPPNT, m_editimppnt);
	//}}AFX_DATA_MAP
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BEGIN_MESSAGE_MAP(CVehTestPage, CPropertyPage)
	//{{AFX_MSG_MAP(CVehTestPage)
	ON_BN_CLICKED(IDC_VEHTESTTSTTYP_SEARCH, OnVehtesttsttypSearch)
	ON_BN_CLICKED(IDC_VEHTESTTSTCFN_SEARCH, OnVehtesttstcfnSearch)
	ON_BN_CLICKED(IDC_VEHTESTRECTYP_SEARCH, OnVehtestrectypSearch)
	ON_BN_CLICKED(IDC_VEHTESTTSTPRF_SEARCH, OnVehtesttstprfSearch)
	ON_BN_CLICKED(IDC_VEHTESTLINK_SEARCH, OnVehtestlinkSearch)
	ON_BN_CLICKED(IDC_VEHTESTTKSURF_SEARCH, OnVehtesttksurfSearch)
	ON_BN_CLICKED(IDC_VEHTESTTKCOND_SEARCH, OnVehtesttkcondSearch)
	ON_WM_HELPINFO()
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTW, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTA, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY(DTN_DATETIMECHANGE, IDC_VEHTEST_TSTDAT, OnDatetimechangeVehtestTstdat)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVehTestPage message handlers

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehTestPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	m_tstdatctrl.SetFormat("dd'/'MMM'/'yyy");
	CancelToClose();
	EnableToolTips();	

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehTestPage::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
	TOOLTIPTEXTA* pTTTA = (TOOLTIPTEXTA*)pNMHDR;
	TOOLTIPTEXTW* pTTTW = (TOOLTIPTEXTW*)pNMHDR;
	CString strTipText = "";
	UINT nID = pNMHDR->idFrom;
	if (pNMHDR->code == TTN_NEEDTEXTA && (pTTTA->uFlags & TTF_IDISHWND) ||
		pNMHDR->code == TTN_NEEDTEXTW && (pTTTW->uFlags & TTF_IDISHWND))
	{
		// idFrom is actually the HWND of the tool
		nID = ::GetDlgCtrlID((HWND)nID);
	}

	if (nID != 0) // will be zero on a separator
	{
		strTipText.Format("Control ID = %d", nID);
		switch (nID)
		{
			case IDC_VEHTEST_CLSSPD:
				strTipText = "km/hr (000.00->200.00)";
				return TRUE;
			case IDC_VEHTEST_IMPANG:
				strTipText = "degrees (Integer)";
				return TRUE;
			case IDC_VEHTEST_TEMP:
				strTipText = "degrees Celsius (-99->99)";
				return TRUE;
			case IDC_VEHTEST_OFFSET:
				strTipText = "mm (-9999->9999)";
				return TRUE;
			case IDC_VEHTEST_IMPPNT:
				strTipText = "mm (-9999->9999)";
				return TRUE;
			case IDC_VEHTESTDAT:
				strTipText = "Date (dd/MMM/yyyy)";
				break;
		default:
			strTipText = "";
		}
	}

	if (pNMHDR->code == TTN_NEEDTEXTA)
		lstrcpyn(pTTTA->szText, strTipText, sizeof(pTTTA->szText));
	else
		::MultiByteToWideChar( CP_ACP , 0, strTipText, -1, pTTTW->szText, sizeof(pTTTW->szText) );
	*pResult = 0;

	return TRUE;    // message was handled
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehTestPage::OnVehtesttsttypSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"TSTTYP","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_tsttyp = search_code;
		m_tsttyp.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehTestPage::OnVehtesttstcfnSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"TSTCFN","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_tstcfn = search_code;
		m_tstcfn.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehTestPage::OnVehtestrectypSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"RECTYP","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_rectyp = search_code;
		m_rectyp.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehTestPage::OnVehtesttstprfSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"TSTPRF","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_tstprf = search_code;
		m_tstprf.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehTestPage::OnVehtestlinkSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"LINK","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_link = search_code;
		m_link.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehTestPage::OnVehtesttksurfSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"TKSURF","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_tksurf = search_code;
		m_tksurf.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehTestPage::OnVehtesttkcondSearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"TKCOND","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_tkcond = search_code;
		m_tkcond.SetValidateColor();
	}
	UpdateData(FALSE);
}

// UpdateData(TRUE), then put data into m_pVehData from members of VehTestPage
/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehTestPage::LoadVehTestData()
{	
	// put data into m_pVehData
	if (!UpdateData(TRUE))
	{
		return FALSE;
	}

	m_pVehData->m_verno		= m_editverno.GetTextAsString();
	m_pVehData->m_title		= m_edittitle.GetTextAsString();
	m_pVehData->m_tstobj	= m_edittstobj.GetTextAsString();
	m_pVehData->m_tstprf	= m_tstprf.GetTextAsString();
	m_pVehData->m_conno		= m_editconno.GetTextAsString();
	m_pVehData->m_tsttyp	= m_tsttyp.GetTextAsString();
	m_pVehData->m_tstref	= m_edittstref.GetTextAsString();
	m_pVehData->m_tstcfn	= m_tstcfn.GetTextAsString();
	m_pVehData->m_tksurf	= m_tksurf.GetTextAsString();
	m_pVehData->m_tkcond	= m_tkcond.GetTextAsString();
	m_pVehData->m_temp		= m_edittemp.GetTextAsString();
	m_pVehData->m_rectyp	= m_rectyp.GetTextAsString();
	m_pVehData->m_link		= m_link.GetTextAsString();
	m_pVehData->m_clsspd	= m_editclsspd.GetTextAsString();
	m_pVehData->m_impang	= m_editimpang.GetTextAsString();;
	m_pVehData->m_offset	= m_editoffset.GetTextAsString();
	m_pVehData->m_imppnt	= m_editimppnt.GetTextAsString();
	m_pVehData->m_totcrv	= atoi(m_totcrv.GetTextAsString());
	m_pVehData->m_tstcom	= m_edittstcom.GetTextAsString();;

	CString testdate;
    GetDlgItemText(IDC_VEHTESTDAT, testdate);
	m_pVehData->m_tstdat=testdate;

	return TRUE;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehTestPage::OnKillActive() 
{
	if( ValidatePage() == true )
	{
		LoadVehTestData();

		return CPropertyPage::OnKillActive();
	}
	else
	{
		// Error are found on AnthPage.
		return FALSE;
	}
}

/******************************************************************************

	Name:		DisplayVehTestData

	Action:		Get Data out of m_pVehData, and put it into members of
				VehTestPage, and then UpdateData(FALSE).

	Params:		void

	Returns:	void

	Notes:	

	Dates:		Modify - Al Wilhelm - 03/06/2000

******************************************************************************/
void CVehTestPage::DisplayVehTestData( void )
{
	m_editverno		= m_pVehData->m_verno;
	m_edittitle		= m_pVehData->m_title;
	m_edittstobj	= m_pVehData->m_tstobj;
	m_tstprf		= m_pVehData->m_tstprf;
	m_editconno		= m_pVehData->m_conno;
	m_tsttyp		= m_pVehData->m_tsttyp;
	m_edittstref	= m_pVehData->m_tstref;
	m_tstcfn		= m_pVehData->m_tstcfn;
	m_tksurf		= m_pVehData->m_tksurf;
	m_tkcond		= m_pVehData->m_tkcond;
	m_edittemp		= m_pVehData->m_temp;
	m_rectyp		= m_pVehData->m_rectyp;
	m_link			= m_pVehData->m_link;
	m_editclsspd	= m_pVehData->m_clsspd;
	m_editimpang	= m_pVehData->m_impang;
	m_editoffset	= m_pVehData->m_offset;
	m_editimppnt	= m_pVehData->m_imppnt;
	m_totcrv		= m_pVehData->m_totcrv;
	m_edittstcom	= m_pVehData->m_tstcom;

	m_tstdatctrl.SetTime(&(StringToTime(m_pVehData->m_tstdat)));
	m_pVehData->m_tstdat.MakeUpper();
	m_edittestdate = m_pVehData->m_tstdat;

	CCodeValidation( m_tsttyp, "TSTTYP","VEHDB" );
	CCodeValidation( m_tstcfn, "TSTCFN","VEHDB" );
	CCodeValidation( m_rectyp, "RECTYP","VEHDB" );
	CCodeValidation( m_tstprf, "TSTPRF","VEHDB" );
	CCodeValidation( m_link, "LINK","VEHDB" );

	CCodeValidation( m_tksurf, "TKSURF","VEHDB" );
	CCodeValidation( m_tkcond, "TKCOND","VEHDB" );

	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehTestPage::OnSetActive() 
{
	SetBusinessRules();

	DisplayVehTestData();

	ValidatePage();
	
	return CPropertyPage::OnSetActive();
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehTestPage::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	WinHelp(General_Test_Information);
	
	return TRUE;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:		

	Dates:		Created -- Al Wilhelm -- 03/06/2000

******************************************************************************/
bool CVehTestPage::ValidatePage( void )
{
	const int nTotal = 19;
	bool bRetArray[nTotal];

	bRetArray[0]	= m_editconno.GetValidate();
	bRetArray[1]	= m_edittitle.GetValidate();
	bRetArray[2]	= m_edittstcom.GetValidate();
	bRetArray[3]	= m_edittstobj.GetValidate();
	bRetArray[4]	= m_edittstref.GetValidate();
	bRetArray[5]	= m_editverno.GetValidate();
	bRetArray[6]	= m_editclsspd.GetValidate();
	bRetArray[7]	= m_editimpang.GetValidate();
	bRetArray[8]	= m_edittemp.GetValidate();
	bRetArray[9]	= m_editoffset.GetValidate();
	bRetArray[10]	= m_editimppnt.GetValidate();
	bRetArray[11]	= m_edittestdate.GetValidate();

	bRetArray[12]	= m_tsttyp.GetValidate();
	bRetArray[13]	= m_tstcfn.GetValidate();
	bRetArray[14]	= m_rectyp.GetValidate();
	bRetArray[15]	= m_tstprf.GetValidate();
	bRetArray[16]	= m_link.GetValidate();

	bRetArray[17]	= m_tksurf.GetValidate();
	bRetArray[18]	= m_tkcond.GetValidate();

	for( int i = 0; i < nTotal; i++ )
	{
		if( !bRetArray[i] )
		{
			return false;
		}
	}

	return true;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:		

	Dates:		Created -- Al Wilhelm -- 03/06/2000

******************************************************************************/
void CVehTestPage::SetBusinessRules( void )
{
	m_editconno.SetString( 0, 17, true );
	m_edittitle.SetString( 0, 70, true );
	m_edittstcom.SetString( 0, 70, true );
	m_edittstobj.SetString( 0, 70, true );
	m_edittstref.SetString( 0, 10, true );
	m_editverno.SetString( 0, 2, true );
	m_editclsspd.SetDouble( 0.0, 200.0, true );
	m_editimpang.SetDouble( 0, 359, true );
	m_edittemp.SetDouble( -99, 99, true );
	m_editoffset.SetDouble( -9999, 9999, true );
	m_editimppnt.SetDouble( -9999, 9999, true );
	m_edittestdate.SetDate();
}

void CVehTestPage::OnDatetimechangeVehtestTstdat(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CString sDate;
    GetDlgItemText(IDC_VEHTEST_TSTDAT, sDate);

	sDate.MakeUpper();
	m_edittestdate =  m_pVehData->m_tstdat = sDate;
	
	*pResult = 0;
}
