// -----------------------------------------
// Copyright 1998, Data Center, NRD of DOT
// File: VehVehPage.cpp
//
// Author: Dan Robbins
//
// Date Created: October, 1998
//
// Description:  Member functions of CVehVehPage.
//               They relate to the loading and display of 
//               data on this page.
// -----------------------------------------

#include "stdafx.h"
#include "entreeV5.h"
#include "VehVehPage.h"
#include "search.h"
#include "CodeValidation.h"

#include "VehPreTest.h"
#include "VehPostTest.h"
#include "VehDamage.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CString search_code;

/////////////////////////////////////////////////////////////////////////////
// CVehVehPage property page

IMPLEMENT_DYNCREATE(CVehVehPage, CPropertyPage)

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
CVehVehPage::CVehVehPage() : CPropertyPage(CVehVehPage::IDD)
{
	//{{AFX_DATA_INIT(CVehVehPage)
	m_apleng	= _T("");
	m_bmpeng	= _T("");
	m_body		= _T("");
	m_colmec	= _T("");
	m_engine	= _T("");
	m_make		= _T("");
	m_moddsc	= _T("");
	m_model		= _T("");
	m_modind	= _T("");
	m_nhtsano	= _T("");
	m_sileng	= _T("");
	m_strsep	= _T("");
	m_transm	= _T("");
	m_vdi		= _T("");
	m_vehcom	= _T("");
	m_vehno		= _T("");
	m_vin		= _T("");
	m_engdsp	= _T("");
	m_vehtwt	= _T("");
	m_whlbas	= _T("");
	m_vehlen	= _T("");
	m_vehwid	= _T("");
	m_vehcg		= _T("");
	m_damdst	= _T("");
	m_crhdst	= _T("");
	m_year		= _T("1999");
	m_vehspd	= _T("");
	m_crbang	= _T("");
	m_pdof		= _T("");
	m_carang	= _T("");
	m_vehor		= _T("");
	m_lencnt	= _T("");
	//}}AFX_DATA_INIT

	bPretest = false;
	bPosttest = false;
	bDamamge = false;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
CVehVehPage::~CVehVehPage()
{
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehVehPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVehVehPage)
	DDX_Control(pDX, IDC_DAMAGEPROF_BUTTON, m_btnDamageProf);
	DDX_Control(pDX, IDC_POSTTEST_BUTTON, m_btnPostTest);
	DDX_Control(pDX, IDC_PRETEST_BUTTON, m_btnPreTest);
	DDX_Control(pDX, IDC_EDIT_PROTEST, m_editProTest);
	DDX_Control(pDX, IDC_EDIT_PRETEST, m_editPreTest);
	DDX_Control(pDX, IDC_EDIT_DAMAGE, m_editDamage);
	DDX_Control(pDX, IDC_VEHNOSPIN, m_vehnospin);
	DDX_Control(pDX, IDC_VEHVEH_APLENG, m_apleng);
	DDX_Control(pDX, IDC_VEHVEH_BMPENG, m_bmpeng);
	DDX_Control(pDX, IDC_VEHVEH_BODY, m_body);
	DDX_Control(pDX, IDC_VEHVEH_COLMEC, m_colmec);
	DDX_Control(pDX, IDC_VEHVEH_ENGINE, m_engine);
	DDX_Control(pDX, IDC_VEHVEH_MAKE, m_make);
	DDX_Control(pDX, IDC_VEHVEH_MODDSC, m_moddsc);
	DDX_Control(pDX, IDC_VEHVEH_MODEL, m_model);
	DDX_Control(pDX, IDC_VEHVEH_MODIND, m_modind);
	DDX_Control(pDX, IDC_VEHVEH_NHTSANO, m_nhtsano);
	DDX_Control(pDX, IDC_VEHVEH_SILENG, m_sileng);
	DDX_Control(pDX, IDC_VEHVEH_STRSEP, m_strsep);
	DDX_Control(pDX, IDC_VEHVEH_TRANSM, m_transm);
	DDX_Control(pDX, IDC_VEHVEH_VDI, m_vdi);
	DDX_Control(pDX, IDC_VEHVEH_VEHCOM, m_vehcom);
	DDX_Control(pDX, IDC_VEHVEH_VEHNO, m_vehno);
	DDX_Control(pDX, IDC_VEHVEH_VIN, m_vin);
	DDX_Control(pDX, IDC_VEHVEH_ENGDSP, m_engdsp);
	DDX_Control(pDX, IDC_VEHVEH_VEHTWT, m_vehtwt);
	DDX_Control(pDX, IDC_VEHVEH_WHLBAS, m_whlbas);
	DDX_Control(pDX, IDC_VEHVEH_VEHLEN, m_vehlen);
	DDX_Control(pDX, IDC_VEHVEH_VEHWID, m_vehwid);
	DDX_Control(pDX, IDC_VEHVEH_VEHCG, m_vehcg);
	DDX_Control(pDX, IDC_VEHVEH_DAMDST, m_damdst);
	DDX_Control(pDX, IDC_VEHVEH_CRHDST, m_crhdst);
	DDX_Control(pDX, IDC_VEHVEH_YEAR, m_year);
	DDX_Control(pDX, IDC_VEHVEH_VEHSPD, m_vehspd);
	DDX_Control(pDX, IDC_VEHVEH_CRBANG, m_crbang);
	DDX_Control(pDX, IDC_VEHVEH_PDOF, m_pdof);
	DDX_Control(pDX, IDC_VEHVEH_CARANG, m_carang);
	DDX_Control(pDX, IDC_VEHVEH_VEHOR, m_vehor);
	DDX_Control(pDX, IDC_VEHVEH_LENCNT, m_lencnt);
	//}}AFX_DATA_MAP
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BEGIN_MESSAGE_MAP(CVehVehPage, CPropertyPage)
	//{{AFX_MSG_MAP(CVehVehPage)
	ON_BN_CLICKED(IDC_MAKESEARCH, OnMakesearch)
	ON_BN_CLICKED(IDC_MODELSEARCH, OnModelsearch)
	ON_BN_CLICKED(IDC_BODYSEARCH, OnBodysearch)
	ON_BN_CLICKED(IDC_ENGINESEARCH, OnEnginesearch)
	ON_BN_CLICKED(IDC_TRANSMSEARCH, OnTransmsearch)
	ON_BN_CLICKED(IDC_COLMECSEARCH, OnColmecsearch)
	ON_BN_CLICKED(IDC_MODINDSEARCH, OnModindsearch)
	ON_BN_CLICKED(IDC_SILENGSEARCH, OnSilengsearch)
	ON_BN_CLICKED(IDC_APLENGSEARCH, OnAplengsearch)
	ON_BN_CLICKED(IDC_BMPENGSEARCH, OnBmpengsearch)
	ON_BN_CLICKED(IDC_PRETEST_BUTTON, OnPretestButton)
	ON_BN_CLICKED(IDC_POSTTEST_BUTTON, OnPosttestButton)
	ON_BN_CLICKED(IDC_DAMAGEPROF_BUTTON, OnDamageprofButton)
	ON_BN_CLICKED(IDC_STRSEPSEARCH, OnStrsepsearch)
	ON_NOTIFY(UDN_DELTAPOS, IDC_VEHNOSPIN, OnDeltaposVehnospin)
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTW, 0, 0xFFFF, OnToolTipNotify )
	ON_NOTIFY_EX_RANGE( TTN_NEEDTEXTA, 0, 0xFFFF, OnToolTipNotify )
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVehVehPage message handlers

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehVehPage::OnMakesearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search( NULL, "MAKE", "VEHDB" );
	if( search.DoModal() == IDOK )
	{
		if( search_code != m_make.GetTextAsString() )  // if you change the make, reset the model.
		{
			m_model = "";
		}
		m_make = search_code;
		m_make.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehVehPage::OnModelsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	if ( m_make.GetTextAsString()==("") )
	{
		MessageBox("Please enter 'Vehicle Make' prior to searching 'Vehicle Model'.");
		return;	
	}

	UpdateData(TRUE);  //First save data

	// Pass the whole SQL Select line because choices are narrowed based on MAKE.
	CSearch search(	NULL, "MODEL","",
					"SELECT MODEL,MODELD,MODEL_COMMENT FROM NHTSADB_MODEL WHERE MAKE LIKE '"
						+ m_make.GetTextAsString()
						+ "%' AND REFERENCE LIKE '%VEHDB%' ORDER BY MODEL" );
	
	if (search.DoModal ()==IDOK)
	{
		m_model = search_code.Right (2);
		m_model.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehVehPage::OnBodysearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"BODY","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_body = search_code;
		m_body.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehVehPage::OnEnginesearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"ENGINE","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_engine = search_code;
		m_engine.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehVehPage::OnTransmsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"TRANSM","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_transm = search_code;
		m_transm.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehVehPage::OnColmecsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"COLMEC","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_colmec = search_code;
		m_colmec.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehVehPage::OnModindsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"MODIND","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_modind = search_code;
		m_modind.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehVehPage::OnSilengsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"SILENG","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_sileng = search_code;
		m_sileng.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehVehPage::OnAplengsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"APLENG","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_apleng = search_code;
		m_apleng.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehVehPage::OnBmpengsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"BMPENG","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_bmpeng = search_code;
		m_bmpeng.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehVehPage::OnStrsepsearch() 
{
	if (::GetKeyState(VK_RETURN)<0) { return; }

	UpdateData(TRUE);  //First save data

	CSearch search(NULL,"STRSEP","VEHDB");
	if (search.DoModal ()==IDOK)
	{
		m_strsep = search_code;
		m_strsep.SetValidateColor();
	}
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehVehPage::OnPretestButton() 
{
	CVehPreTest pretest( m_pVehData, m_vehno.GetTextAsNumber() );

	if( pretest.DoModal() == IDOK )
	{
		m_pVehData->m_bx1[m_vehno.GetTextAsNumber()]	= pretest.m_bx1.GetTextAsString();
		m_pVehData->m_bx2[m_vehno.GetTextAsNumber()]	= pretest.m_bx2.GetTextAsString();
		m_pVehData->m_bx3[m_vehno.GetTextAsNumber()]	= pretest.m_bx3.GetTextAsString();
		m_pVehData->m_bx4[m_vehno.GetTextAsNumber()]	= pretest.m_bx4.GetTextAsString();
		m_pVehData->m_bx5[m_vehno.GetTextAsNumber()]	= pretest.m_bx5.GetTextAsString();
		m_pVehData->m_bx6[m_vehno.GetTextAsNumber()]	= pretest.m_bx6.GetTextAsString();
		m_pVehData->m_bx7[m_vehno.GetTextAsNumber()]	= pretest.m_bx7.GetTextAsString();
		m_pVehData->m_bx8[m_vehno.GetTextAsNumber()]	= pretest.m_bx8.GetTextAsString();
		m_pVehData->m_bx9[m_vehno.GetTextAsNumber()]	= pretest.m_bx9.GetTextAsString();
		m_pVehData->m_bx10[m_vehno.GetTextAsNumber()]	= pretest.m_bx10.GetTextAsString();
		m_pVehData->m_bx11[m_vehno.GetTextAsNumber()]	= pretest.m_bx11.GetTextAsString();
		m_pVehData->m_bx12[m_vehno.GetTextAsNumber()]	= pretest.m_bx12.GetTextAsString();
		m_pVehData->m_bx13[m_vehno.GetTextAsNumber()]	= pretest.m_bx13.GetTextAsString();
		m_pVehData->m_bx14[m_vehno.GetTextAsNumber()]	= pretest.m_bx14.GetTextAsString();
		m_pVehData->m_bx15[m_vehno.GetTextAsNumber()]	= pretest.m_bx15.GetTextAsString();
		m_pVehData->m_bx16[m_vehno.GetTextAsNumber()]	= pretest.m_bx16.GetTextAsString();
		m_pVehData->m_bx17[m_vehno.GetTextAsNumber()]	= pretest.m_bx17.GetTextAsString();
		m_pVehData->m_bx18[m_vehno.GetTextAsNumber()]	= pretest.m_bx18.GetTextAsString();
		m_pVehData->m_bx19[m_vehno.GetTextAsNumber()]	= pretest.m_bx19.GetTextAsString();
		m_pVehData->m_bx20[m_vehno.GetTextAsNumber()]	= pretest.m_bx20.GetTextAsString();
		m_pVehData->m_bx21[m_vehno.GetTextAsNumber()]	= pretest.m_bx21.GetTextAsString();
	}

	if( pretest.m_bValidate == false )
	{
		COLORREF	clText	= RGB( 0, 0, 0 );
		COLORREF	clBkg	= RGB( 255, 0, 0 );

		m_editPreTest = "ERROR";

		m_editPreTest.SetColor( clText, clBkg );

		m_editPreTest.ShowWindow( SW_SHOW );
		
		bPretest = false;
	}
	else
	{
		COLORREF	clText	= RGB( 0, 0, 0 );
		COLORREF	clBkg	= RGB( 255, 255, 255 );

		m_editPreTest = "";

		m_editPreTest.SetColor( clText, clBkg );

		m_editPreTest.ShowWindow( SW_HIDE );

		bPretest = true;
	}
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
bool CVehVehPage::PretestButton() 
{
	CVehPreTest pretest( m_pVehData, m_vehno.GetTextAsNumber() );

	pretest.m_bDisplay = false;
	pretest.DoModal();

	if( pretest.m_bValidate == false )
	{
		COLORREF	clText	= RGB( 0, 0, 0 );
		COLORREF	clBkg	= RGB( 255, 0, 0 );

		m_editPreTest = "ERROR";

		m_editPreTest.SetColor( clText, clBkg );

		m_editPreTest.ShowWindow( SW_SHOW );

		bPretest = false;

		return false;
	}
	else
	{
		COLORREF	clText	= RGB( 0, 0, 0 );
		COLORREF	clBkg	= RGB( 255, 255, 255 );

		m_editPreTest = "";

		m_editPreTest.SetColor( clText, clBkg );

		m_editPreTest.ShowWindow( SW_HIDE );

		bPretest = true;

		return true;
	}
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehVehPage::OnPosttestButton() 
{
	CVehPostTest posttest(m_pVehData, m_vehno.GetTextAsNumber());
	if( posttest.DoModal() == IDOK )
	{
		m_pVehData->m_ax1[m_vehno.GetTextAsNumber()]	= posttest.m_ax1.GetTextAsString();
		m_pVehData->m_ax2[m_vehno.GetTextAsNumber()]	= posttest.m_ax2.GetTextAsString();
		m_pVehData->m_ax3[m_vehno.GetTextAsNumber()]	= posttest.m_ax3.GetTextAsString();
		m_pVehData->m_ax4[m_vehno.GetTextAsNumber()]	= posttest.m_ax4.GetTextAsString();
		m_pVehData->m_ax5[m_vehno.GetTextAsNumber()]	= posttest.m_ax5.GetTextAsString();
		m_pVehData->m_ax6[m_vehno.GetTextAsNumber()]	= posttest.m_ax6.GetTextAsString();
		m_pVehData->m_ax7[m_vehno.GetTextAsNumber()]	= posttest.m_ax7.GetTextAsString();
		m_pVehData->m_ax8[m_vehno.GetTextAsNumber()]	= posttest.m_ax8.GetTextAsString();
		m_pVehData->m_ax9[m_vehno.GetTextAsNumber()]	= posttest.m_ax9.GetTextAsString();
		m_pVehData->m_ax10[m_vehno.GetTextAsNumber()]	= posttest.m_ax10.GetTextAsString();
		m_pVehData->m_ax11[m_vehno.GetTextAsNumber()]	= posttest.m_ax11.GetTextAsString();
		m_pVehData->m_ax12[m_vehno.GetTextAsNumber()]	= posttest.m_ax12.GetTextAsString();
		m_pVehData->m_ax13[m_vehno.GetTextAsNumber()]	= posttest.m_ax13.GetTextAsString();
		m_pVehData->m_ax14[m_vehno.GetTextAsNumber()]	= posttest.m_ax14.GetTextAsString();
		m_pVehData->m_ax15[m_vehno.GetTextAsNumber()]	= posttest.m_ax15.GetTextAsString();
		m_pVehData->m_ax16[m_vehno.GetTextAsNumber()]	= posttest.m_ax16.GetTextAsString();
		m_pVehData->m_ax17[m_vehno.GetTextAsNumber()]	= posttest.m_ax17.GetTextAsString();
		m_pVehData->m_ax18[m_vehno.GetTextAsNumber()]	= posttest.m_ax18.GetTextAsString();
		m_pVehData->m_ax19[m_vehno.GetTextAsNumber()]	= posttest.m_ax19.GetTextAsString();
		m_pVehData->m_ax20[m_vehno.GetTextAsNumber()]	= posttest.m_ax20.GetTextAsString();
		m_pVehData->m_ax21[m_vehno.GetTextAsNumber()]	= posttest.m_ax21.GetTextAsString();
	}

	if( posttest.m_bValidate == false )
	{
		COLORREF	clText	= RGB( 0, 0, 0 );
		COLORREF	clBkg	= RGB( 255, 0, 0 );

		m_editProTest = "ERROR";

		m_editProTest.SetColor( clText, clBkg );

		m_editProTest.ShowWindow( SW_SHOW );

		bPosttest = false;
	}
	else
	{
		COLORREF	clText	= RGB( 0, 0, 0 );
		COLORREF	clBkg	= RGB( 255, 255, 255 );

		m_editProTest = "";

		m_editProTest.SetColor( clText, clBkg );

		m_editProTest.ShowWindow( SW_HIDE );

		bPosttest = true;
	}
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
bool CVehVehPage::PosttestButton() 
{
	CVehPostTest posttest(m_pVehData, m_vehno.GetTextAsNumber());

	posttest.m_bDisplay = false;
	posttest.DoModal();

	if( posttest.m_bValidate == false )
	{
		COLORREF	clText	= RGB( 0, 0, 0 );
		COLORREF	clBkg	= RGB( 255, 0, 0 );

		m_editProTest = "ERROR";

		m_editProTest.SetColor( clText, clBkg );

		m_editProTest.ShowWindow( SW_SHOW );

		bPosttest = false;

		return false;
	}
	else
	{
		COLORREF	clText	= RGB( 0, 0, 0 );
		COLORREF	clBkg	= RGB( 255, 255, 255 );

		m_editProTest = "";

		m_editProTest.SetColor( clText, clBkg );

		m_editProTest.ShowWindow( SW_HIDE );

		bPosttest = true;

		return true;
	}
}


/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehVehPage::OnDamageprofButton() 
{
	CVehDamage damage(m_pVehData, m_vehno.GetTextAsNumber());
	if( damage.DoModal() == IDOK )
	{
		m_pVehData->m_dpd1[m_vehno.GetTextAsNumber()] = damage.m_editdpd1.GetTextAsString();
		m_pVehData->m_dpd2[m_vehno.GetTextAsNumber()] = damage.m_editdpd2.GetTextAsString();
		m_pVehData->m_dpd3[m_vehno.GetTextAsNumber()] = damage.m_editdpd3.GetTextAsString();
		m_pVehData->m_dpd4[m_vehno.GetTextAsNumber()] = damage.m_editdpd4.GetTextAsString();
		m_pVehData->m_dpd5[m_vehno.GetTextAsNumber()] = damage.m_editdpd5.GetTextAsString();
		m_pVehData->m_dpd6[m_vehno.GetTextAsNumber()] = damage.m_editdpd6.GetTextAsString();
	}

	if( damage.m_bValidate == false )
	{
		COLORREF	clText	= RGB( 0, 0, 0 );
		COLORREF	clBkg	= RGB( 255, 0, 0 );

		m_editDamage = "ERROR";

		m_editDamage.SetColor( clText, clBkg );

		m_editDamage.ShowWindow( SW_SHOW );

		bDamamge = false;
	}
	else
	{
		COLORREF	clText	= RGB( 0, 0, 0 );
		COLORREF	clBkg	= RGB( 255, 255, 255 );

		m_editDamage = "";

		m_editDamage.SetColor( clText, clBkg );

		m_editDamage.ShowWindow( SW_HIDE );

		bDamamge = true;
	}
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
bool CVehVehPage::DamageprofButton() 
{
	CVehDamage damage(m_pVehData, m_vehno.GetTextAsNumber());

	damage.m_bDisplay = false;
	damage.DoModal();

	if( damage.m_bValidate == false )
	{
		COLORREF	clText	= RGB( 0, 0, 0 );
		COLORREF	clBkg	= RGB( 255, 0, 0 );

		m_editDamage = "ERROR";

		m_editDamage.SetColor( clText, clBkg );

		m_editDamage.ShowWindow( SW_SHOW );

		bDamamge = false;

		return false;
	}
	else
	{
		COLORREF	clText	= RGB( 0, 0, 0 );
		COLORREF	clBkg	= RGB( 255, 255, 255 );

		m_editDamage = "";

		m_editDamage.SetColor( clText, clBkg );

		m_editDamage.ShowWindow( SW_HIDE );

		bDamamge = true;

		return true;
	}
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehVehPage::EnableButtons( BOOL bEnable )
{
	m_btnDamageProf.EnableWindow(bEnable);
	m_btnPostTest.EnableWindow(bEnable);
	m_btnPreTest.EnableWindow(bEnable);
}

/******************************************************************************

	Name:		LoadVehVehData

	Action:		This function gets the data from the entry fields and puts it
				into m_pVehData.  It is called in OnKillActive, ExportData,
				record changed.

	Params:		void

	Returns:	BOOL

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehVehPage::LoadVehVehData( void )
{
	//put data into m_pVehData

	if (m_hWnd==NULL) return TRUE;  // Only return FALSE if DATA not valid
	BOOL success = UpdateData(TRUE);
	if (!success) return FALSE;

//	if (m_vehno.GetTextAsNumber() > m_pVehData->m_vehno)
//	{
//		m_pVehData->m_vehno= m_vehno.GetTextAsNumber();
//	}

//	if( EnableControls() == FALSE ) 
//	if ((m_pVehData->m_tstcfn == "VTB") || (m_pVehData->m_tstcfn == "ITB"))
	if( CheckTestConfiguration() == 2 )
	{
		m_pVehData->m_vehno = 2;
	}
	else
	{
		m_pVehData->m_vehno = 1;
	}

	m_pVehData->m_apleng[m_vehno.GetTextAsNumber()] = m_apleng.GetTextAsString();
	m_pVehData->m_bmpeng[m_vehno.GetTextAsNumber()] = m_bmpeng.GetTextAsString();
	m_pVehData->m_body[m_vehno.GetTextAsNumber()] = m_body.GetTextAsString();
	m_pVehData->m_carang[m_vehno.GetTextAsNumber()] = m_carang.GetTextAsString();
	m_pVehData->m_colmec[m_vehno.GetTextAsNumber()] = m_colmec.GetTextAsString();
	m_pVehData->m_crbang[m_vehno.GetTextAsNumber()] = m_crbang.GetTextAsString();
	m_pVehData->m_crhdst[m_vehno.GetTextAsNumber()] = m_crhdst.GetTextAsString();
	m_pVehData->m_damdst[m_vehno.GetTextAsNumber()] = m_damdst.GetTextAsString();
	m_pVehData->m_engdsp[m_vehno.GetTextAsNumber()] = m_engdsp.GetTextAsString();
	m_pVehData->m_engine[m_vehno.GetTextAsNumber()] = m_engine.GetTextAsString();
	m_pVehData->m_lencnt[m_vehno.GetTextAsNumber()] = m_lencnt.GetTextAsString();
	m_pVehData->m_make[m_vehno.GetTextAsNumber()] = m_make.GetTextAsString();
	m_pVehData->m_moddsc[m_vehno.GetTextAsNumber()] = m_moddsc.GetTextAsString();
	m_pVehData->m_model[m_vehno.GetTextAsNumber()] = m_model.GetTextAsString();
	m_pVehData->m_modind[m_vehno.GetTextAsNumber()] = m_modind.GetTextAsString();
	m_pVehData->m_nhtsano[m_vehno.GetTextAsNumber()] = m_nhtsano.GetTextAsString();
	m_pVehData->m_pdof[m_vehno.GetTextAsNumber()] = m_pdof.GetTextAsString();
	m_pVehData->m_sileng[m_vehno.GetTextAsNumber()] = m_sileng.GetTextAsString();
	m_pVehData->m_strsep[m_vehno.GetTextAsNumber()] = m_strsep.GetTextAsString();
	m_pVehData->m_transm[m_vehno.GetTextAsNumber()] = m_transm.GetTextAsString();
	m_pVehData->m_vdi[m_vehno.GetTextAsNumber()] = m_vdi.GetTextAsString();
	m_pVehData->m_vehcg[m_vehno.GetTextAsNumber()] = m_vehcg.GetTextAsString();
	m_pVehData->m_vehcom[m_vehno.GetTextAsNumber()] = m_vehcom.GetTextAsString();
	m_pVehData->m_vehlen[m_vehno.GetTextAsNumber()] = m_vehlen.GetTextAsString();
	m_pVehData->m_vehor[m_vehno.GetTextAsNumber()] = m_vehor.GetTextAsString();
	m_pVehData->m_vehspd[m_vehno.GetTextAsNumber()] = m_vehspd.GetTextAsString();
	m_pVehData->m_vehtwt[m_vehno.GetTextAsNumber()] = m_vehtwt.GetTextAsString();
	m_pVehData->m_vehwid[m_vehno.GetTextAsNumber()] = m_vehwid.GetTextAsString();
	m_pVehData->m_vin[m_vehno.GetTextAsNumber()] = m_vin.GetTextAsString();
	m_pVehData->m_whlbas[m_vehno.GetTextAsNumber()] = m_whlbas.GetTextAsString();
	m_pVehData->m_year[m_vehno.GetTextAsNumber()] = m_year.GetTextAsString();

	return TRUE;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:		Get data from m_pVehData and display it.	

	Dates:

******************************************************************************/
void CVehVehPage::DisplayVehVehData()
{
	m_apleng = m_pVehData->m_apleng[m_vehno.GetTextAsNumber()];
	m_bmpeng = m_pVehData->m_bmpeng[m_vehno.GetTextAsNumber()];
	m_body = m_pVehData->m_body[m_vehno.GetTextAsNumber()];
	m_carang = m_pVehData->m_carang[m_vehno.GetTextAsNumber()];
	m_colmec = m_pVehData->m_colmec[m_vehno.GetTextAsNumber()];
	m_crbang = m_pVehData->m_crbang[m_vehno.GetTextAsNumber()];
	m_crhdst = m_pVehData->m_crhdst[m_vehno.GetTextAsNumber()];
	m_damdst = m_pVehData->m_damdst[m_vehno.GetTextAsNumber()];
	m_engdsp = m_pVehData->m_engdsp[m_vehno.GetTextAsNumber()];
	m_engine = m_pVehData->m_engine[m_vehno.GetTextAsNumber()] ;
	m_lencnt = m_pVehData->m_lencnt[m_vehno.GetTextAsNumber()];
	m_make = m_pVehData->m_make[m_vehno.GetTextAsNumber()];
	m_moddsc = m_pVehData->m_moddsc[m_vehno.GetTextAsNumber()];
	m_model = m_pVehData->m_model[m_vehno.GetTextAsNumber()] ;
	m_modind = m_pVehData->m_modind[m_vehno.GetTextAsNumber()];
	m_nhtsano = m_pVehData->m_nhtsano[m_vehno.GetTextAsNumber()];
	m_pdof = m_pVehData->m_pdof[m_vehno.GetTextAsNumber()];
	m_sileng = m_pVehData->m_sileng[m_vehno.GetTextAsNumber()];
	m_strsep = m_pVehData->m_strsep[m_vehno.GetTextAsNumber()];
	m_transm = m_pVehData->m_transm[m_vehno.GetTextAsNumber()];
	m_vdi = m_pVehData->m_vdi[m_vehno.GetTextAsNumber()];
	m_vehcg = m_pVehData->m_vehcg[m_vehno.GetTextAsNumber()];
	m_vehcom = m_pVehData->m_vehcom[m_vehno.GetTextAsNumber()];
	m_vehlen = m_pVehData->m_vehlen[m_vehno.GetTextAsNumber()];
	m_vehor =m_pVehData->m_vehor[m_vehno.GetTextAsNumber()];
	m_vehspd = m_pVehData->m_vehspd [m_vehno.GetTextAsNumber()];
	m_vehtwt = m_pVehData->m_vehtwt[m_vehno.GetTextAsNumber()];
	m_vehwid = m_pVehData->m_vehwid[m_vehno.GetTextAsNumber()];
	m_vin = m_pVehData->m_vin[m_vehno.GetTextAsNumber()];
	m_whlbas = m_pVehData->m_whlbas[m_vehno.GetTextAsNumber()];
	m_year = m_pVehData->m_year[m_vehno.GetTextAsNumber()];

	CCodeValidation( m_make, "MAKE","VEHDB" );
	CCodeValidation( m_model, "MODEL","VEHDB" );
	CCodeValidation( m_body, "BODY","VEHDB" );
	CCodeValidation( m_engine, "ENGINE","VEHDB" );
	CCodeValidation( m_transm, "TRANSM","VEHDB" );
	CCodeValidation( m_colmec, "COLMEC","VEHDB" );
	CCodeValidation( m_modind, "MODIND","VEHDB" );
	CCodeValidation( m_sileng, "SILENG","VEHDB" );
	CCodeValidation( m_apleng, "APLENG","VEHDB" );
	CCodeValidation( m_bmpeng, "BMPENG","VEHDB" );
	CCodeValidation( m_strsep, "STRSEP","VEHDB" );
	
	UpdateData(FALSE);
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehVehPage::OnKillActive() 
{
	if( ValidateSpinControl() == false )
	{
		return FALSE;
	}

	if(		( PretestButton() == false )
		||	( PosttestButton() == false )
		||	( DamageprofButton() == false ) )
	{
		return FALSE;
	}


	if( ValidatePage() == true )
	{
		LoadVehVehData();

		return CPropertyPage::OnKillActive();
	}
	else
	{
		// Error are found on AnthPage.
		return FALSE;
	}
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehVehPage::OnSetActive() 
{
	SetBusinessRules();

	PretestButton();
	PosttestButton();
	DamageprofButton();

	DisplayVehVehData();

	StartEnableControls();

	ValidatePage();

	return CPropertyPage::OnSetActive();
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehVehPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	EnableToolTips();

	m_vehno = _T("1");

	m_vehnospin.SetRange (1,2);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehVehPage::OnToolTipNotify( UINT id, NMHDR * pNMHDR, LRESULT * pResult )
{
	TOOLTIPTEXTA* pTTTA = (TOOLTIPTEXTA*)pNMHDR;
	TOOLTIPTEXTW* pTTTW = (TOOLTIPTEXTW*)pNMHDR;
	CString strTipText = "";
	UINT nID = pNMHDR->idFrom;
	if (pNMHDR->code == TTN_NEEDTEXTA && (pTTTA->uFlags & TTF_IDISHWND) ||
		pNMHDR->code == TTN_NEEDTEXTW && (pTTTW->uFlags & TTF_IDISHWND))
	{
		// idFrom is actually the HWND of the tool
		nID = ::GetDlgCtrlID((HWND)nID);
	}

	if (nID != 0) // will be zero on a separator
	{
		strTipText.Format("Control ID = %d", nID);
		switch (nID)
		{
			case IDC_PRETEST_BUTTON:
				strTipText = "Set Pretest Measurement Values";
				break;
			case IDC_POSTTEST_BUTTON:
				strTipText = "Set Posttest Measurement Values";
				break;
			case IDC_DAMAGEPROF_BUTTON:
				strTipText = "Set Damage Profile Distance Values";
				break;
			case IDC_VEHVEH_ENGDSP:
				strTipText = "liters (00.0->99.9)";
				break;
			case IDC_VEHVEH_VEHSPD:
				strTipText = "km/hr (000.00->999.99)";
				break;
			case IDC_VEHVEH_CRBANG:
				strTipText = "degrees (0->359)";
				break;
			case IDC_VEHVEH_PDOF:
				strTipText = "degrees (0->359)";
				break;
			case IDC_VEHVEH_VEHTWT:
				strTipText = "kg (0->99999)";
				break;
			case IDC_VEHVEH_WHLBAS:
				strTipText = "mm (0->99999)";
				break;
			case IDC_VEHVEH_VEHLEN:
				strTipText = "mm (0->99999)";
				break;
			case IDC_VEHVEH_VEHWID:
				strTipText = "mm (0->9999)";
				break;
			case IDC_VEHVEH_VEHCG:
				strTipText = "mm (0->9999)";
				break;
			case IDC_VEHVEH_CARANG:
				strTipText = "degrees (0->359)";
				break;
			case IDC_VEHVEH_VEHOR:
				strTipText = "degrees (0-90)";
				break;
			case IDC_VEHVEH_LENCNT:
				strTipText = "mm (0->99999)";
				break;
			case IDC_VEHVEH_DAMDST:
				strTipText = "mm (-9999->99999)";
				break;
			case IDC_VEHVEH_CRHDST:
				strTipText = "mm (0->9999)";
				break;
			case IDC_VEHVEH_YEAR:
				strTipText = "1900 to 9999";
				break;
		default:
			strTipText = "";
		}
	}

	if (pNMHDR->code == TTN_NEEDTEXTA)
		lstrcpyn(pTTTA->szText, strTipText, sizeof(pTTTA->szText));
	else
		::MultiByteToWideChar( CP_ACP , 0, strTipText, -1, pTTTW->szText, sizeof(pTTTW->szText) );
	*pResult = 0;

	return TRUE;    // message was handled
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
void CVehVehPage::OnDeltaposVehnospin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;

			pNMUpDown->hdr;

	int pos = pNMUpDown->iPos;   //current position, before the change
	int delt = pNMUpDown->iDelta;//change direction, +1 or -1

	if (pos==2 && delt==-1)
	{
		//going down, m_vehno currently equals 2
		BOOL success = LoadVehVehData();
		if (!success) return;  //data not valid

		m_vehno = _T("1");   //Needs to be changed here before call to DisplayVehVehData.
						 //It would happen automatically later.
		DisplayVehVehData();

	
	}
	else if (pos==1 && delt==1)
	{
		// going up, m_vehno currently equals 1   
		BOOL success = LoadVehVehData();
		if (!success) return;  //data not valid

		m_vehno = _T("2");    //Needs to be changed here before call to DisplayVehVehData.
						 //It would happen automatically later.
		DisplayVehVehData();
	
	}

	*pResult = 0;
}

// ***********
// CVehVehPage::EnableControls()
// If m_pVehData->m_tstcfn is VTB or ITB, only one Vehicle allowed.
// ***********
/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehVehPage::EnableControls()
{
	BOOL bVTB_or_ITB = FALSE;

//	if ((m_pVehData->m_tstcfn == "VTB") || (m_pVehData->m_tstcfn == "ITB"))
	if( CheckTestConfiguration() == 1 )
	{
		bVTB_or_ITB = TRUE;

		LoadVehVehData();

		CSpinButtonCtrl * pSpin = NULL;

		pSpin = (CSpinButtonCtrl *)GetDlgItem( IDC_VEHNOSPIN );
		pSpin->SetRange( 1, 2 );

		//Needs to be changed here before call to DisplayVehVehData.
		SetDlgItemText( IDC_VEHVEH_VEHNO, _T("1") );
		 //It would happen automatically later.
		DisplayVehVehData();

		pSpin->SetPos( 1 );
	}

	m_vehnospin.EnableWindow (!bVTB_or_ITB);

	return bVTB_or_ITB;
}

// ***********
// CVehVehPage::EnableControls()
// If m_pVehData->m_tstcfn is VTB or ITB, only one Vehicle allowed.
// ***********
/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehVehPage::StartEnableControls()
{
	BOOL bVTB_or_ITB = FALSE;

//	if ((m_pVehData->m_tstcfn == "VTB") || (m_pVehData->m_tstcfn == "ITB"))
	if( CheckTestConfiguration() == 1 )
	{
		bVTB_or_ITB = TRUE;

		CSpinButtonCtrl * pSpin = NULL;

		pSpin = (CSpinButtonCtrl *)GetDlgItem( IDC_VEHNOSPIN );
		pSpin->SetRange( 1, 2 );

		//Needs to be changed here before call to DisplayVehVehData.
		SetDlgItemText( IDC_VEHVEH_VEHNO, _T("1") );
		 //It would happen automatically later.
		DisplayVehVehData();

		pSpin->SetPos( 1 );
	}

	m_vehnospin.EnableWindow (!bVTB_or_ITB);

	return bVTB_or_ITB;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:	

	Dates:

******************************************************************************/
BOOL CVehVehPage::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	WinHelp(Vehicle_Information);
	
	return TRUE;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:		

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
bool CVehVehPage::ValidatePage( void )
{
	const int nTotal = 31;
	bool bRetArray[nTotal];
	
	bRetArray[0]	= m_moddsc.GetValidate();
	bRetArray[1]	= m_nhtsano.GetValidate();
	bRetArray[2]	= m_vdi.GetValidate();
	bRetArray[3]	= m_vehcom.GetValidate();
	bRetArray[4]	= m_vin.GetValidate();
	bRetArray[5]	= m_engdsp.GetValidate();
	bRetArray[6]	= m_vehtwt.GetValidate();
	bRetArray[7]	= m_whlbas.GetValidate();
	bRetArray[8]	= m_vehlen.GetValidate();
	bRetArray[9]	= m_vehwid.GetValidate();
	bRetArray[10]	= m_vehcg.GetValidate();
	bRetArray[11]	= m_damdst.GetValidate();
	bRetArray[12]	= m_crhdst.GetValidate();
	bRetArray[13]	= m_year.GetValidate();
	bRetArray[14]	= m_vehspd.GetValidate();
	bRetArray[15]	= m_crbang.GetValidate();
	bRetArray[16]	= m_pdof.GetValidate();
	bRetArray[17]	= m_carang.GetValidate();
	bRetArray[18]	= m_vehor.GetValidate();
	bRetArray[19]	= m_lencnt.GetValidate();

	bRetArray[20]	= m_make.GetValidate();
	bRetArray[21]	= m_model.GetValidate();
	bRetArray[22]	= m_body.GetValidate();
	bRetArray[23]	= m_engine.GetValidate();
	bRetArray[24]	= m_transm.GetValidate();
	bRetArray[25]	= m_colmec.GetValidate();
	bRetArray[26]	= m_modind.GetValidate();
	bRetArray[27]	= m_sileng.GetValidate();
	bRetArray[28]	= m_apleng.GetValidate();
	bRetArray[29]	= m_bmpeng.GetValidate();
	bRetArray[30]	= m_strsep.GetValidate();

	for( int i = 0; i < nTotal; i++ )
	{
		if( !bRetArray[i] )
		{
			return false;
		}
	}

	return true;
}

/******************************************************************************

	Name:		

	Action:		

	Params:		

	Returns:	

	Notes:		

	Dates:		Modify - Al Wilhelm - 3/6/2000

******************************************************************************/
void CVehVehPage::SetBusinessRules( void )
{
	m_moddsc.SetString( 0, 70, true );
	m_nhtsano.SetString( 0, 6, true );
	m_vdi.SetString( 0, 7, true );
	m_vehcom.SetString( 0, 70, true );
	m_vin.SetString( 0, 20, true );
	m_engdsp.SetDouble( 0.0, 99.9, true );
	m_vehtwt.SetDouble( 0.0, 99999.0, true);
	m_whlbas.SetDouble( 0.0, 99999.0, true );
	m_vehlen.SetDouble( 0.0, 99999.0, true );
	m_vehwid.SetDouble( 0, 9999, true );
	m_vehcg.SetDouble( 0, 9999, true );
	m_damdst.SetDouble( -9999.0, 99999.0, true );
	m_crhdst.SetDouble( 0, 9999, true );
	m_year.SetDouble( 1900, 9999, true );	// Has a default value.
	m_vehspd.SetDouble( 0.0, 999.99, true );
	m_crbang.SetDouble( 0, 359, true );
	m_pdof.SetDouble( 0, 359, true );
	m_carang.SetDouble( 0, 359, true );
	m_vehor.SetDouble( 0, 90, true );
	m_lencnt.SetDouble( 0.0, 99999.0, true );
}

bool CVehVehPage::ValidateSpinControl( void )
{
	if( ValidatePage() == false  )
	{
		return false;
	}

	if( EnableControls() == TRUE )
	{
		return true;
	}

	CString cstrValue("");

	CSpinButtonCtrl * pSpin = NULL;

	GetDlgItemText( IDC_VEHVEH_VEHNO, cstrValue );

	pSpin = (CSpinButtonCtrl *)GetDlgItem( IDC_VEHNOSPIN );
	pSpin->SetRange( 1, 2 );

	if( cstrValue == "1" )
	{
		//going down, m_vehno currently equals 2
		BOOL success = LoadVehVehData();
		if( !success )
		{
			return false;  //data not valid
		}

		//Needs to be changed here before call to DisplayVehVehData.
		SetDlgItemText( IDC_VEHVEH_VEHNO, _T("2") );
		 //It would happen automatically later.
		DisplayVehVehData();

		pSpin->SetPos( 2 );

		if( ValidatePage() == false  )
		{
			return false;
		}
	}
	
	if( cstrValue == "2" )
	{
		//going down, m_vehno currently equals 2
		BOOL success = LoadVehVehData();
		if( !success )
		{
			return false;  //data not valid
		}

		//Needs to be changed here before call to DisplayVehVehData.
		SetDlgItemText( IDC_VEHVEH_VEHNO, _T("1") );
		 //It would happen automatically later.
		DisplayVehVehData();

		pSpin->SetPos( 1 );

		if( ValidatePage() == false  )
		{
			return false;
		}
	}

	return true;
}

int CVehVehPage::CheckTestConfiguration( void )
{
	if( (m_pVehData->m_tstcfn == "ITB") ||
		(m_pVehData->m_tstcfn == "ROL") ||
		(m_pVehData->m_tstcfn == "SLB") ||
		(m_pVehData->m_tstcfn == "SLN") ||
		(m_pVehData->m_tstcfn == "VTB") ||
		(m_pVehData->m_tstcfn == "VTI") ||
		(m_pVehData->m_tstcfn == "SAF") ||
		(m_pVehData->m_tstcfn == "SAS") ||
		(m_pVehData->m_tstcfn == "CAN") ||
		(m_pVehData->m_tstcfn == "DRP") ||
		(m_pVehData->m_tstcfn == "OTH") ||
		(m_pVehData->m_tstcfn == "PED") ||
		(m_pVehData->m_tstcfn == "PEN") ) {

		return 1;
	}

	if( (m_pVehData->m_tstcfn == "ITI") ||
		(m_pVehData->m_tstcfn == "ITV") ||
		(m_pVehData->m_tstcfn == "VTV") ) {

		return 2;
	}

	return 1;
}
